C $$-parf.for  -  obecna sekce pro FEMINU (s vyjimkou PARTICLE)      
      SUBROUTINE PARGEN1(IPT1,IPT2,IPT3)
      INCLUDE '$FEMEQ'
C Generuj PARTICLES v bodech PT
C NPART - pocet elementu typu castice
C NPARN - pocet uzlu typu castice
      IF(IPT1.GT.0.AND.IPT2.GE.IPT1.AND.IPT2+NPART.LE.MAXND)THEN
         DO IPOINT=IPT1,IPT2,IPT3
            NPARN=NPARN+1
            IND=ND+NPARN
            XX(IND)=PTX(IPOINT)
            YY(IND)=PTY(IPOINT)
            ZZ(IND)=PTZ(IPOINT)
            NPART=NPART+1
            IPART=NE+NPART
            L0=LUE(IPART)
            LUE(IPART+1)=LUE(IPART)+1
            MUE(IPART)=1
            MINT(IPART)=0
            IUE(L0+1)=IND
            IGROUP(IPART)=KGROUP
            IRCONS(IPART)=KRCONS
            IMPROP(IPART)=KMPROP
         ENDDO
      ENDIF
      END

      SUBROUTINE PARDEL(IPT)
      INCLUDE '$FEMEQ'
C Zrus castici s poradovym cislem IPT (vyrazeni ze seznamu elementu)
      IF(IPT.GT.0.AND.IPT.LE.NPART)THEN
         NPART=NPART-1
         DO I=NE+IPT,NE+NPART
            LUE(I)=LUE(I+1)
            MUE(I)=MUE(I+1)
            MINT(I)=MINT(I+1)
            IGROUP(I)=IGROUP(I+1)
            IRCONS(I)=IRCONS(I+1)
            IMPROP(I)=IMPROP(I+1)
            DO J=1,MAXEPAR
              EPAR(I,J)=EPAR(I+1,J)
            ENDDO
         ENDDO
         LUE(NE+1)=LUE(NE+2)
      ENDIF
      END

      SUBROUTINE PARTMOD2(X,Y,VISC,RHO,CP,RK,RKAPPA)
      INCLUDE '$FEMEQ'
C Modifikace parametru, pokud lezi bod X,Y uvnitr nejake castice
      IF(NPART.GT.0)THEN
        DO I=1,NPART
          IE=NE+I
          LEGRP=MAX0(1,IGROUP(IE))
          LRCON=MAX0(1,IRCONS(IE))
          NAMELE=JGROUP(LEGRP,$ENAME)
          SELECT CASE(NAMELE)
          CASE($CYLINDER)
            L0=LUE(IE)
            IND=IABS(IUE(L0+1))
            XC=XX(IND)
            YC=YY(IND)
            R=RRCONS(LRCON,$D)/2.
            IF((X-XC)**2+(Y-YC)**2.LE.R**2)THEN
C X,Y lezi v castici   
               LPROP=MAX0(1,IMPROP(IE))
               RHO=RMPROP(LPROP,$RHO)
               VISC=RMPROP(LPROP,$VISC)
               CP=RMPROP(LPROP,$CP)
               RK=RMPROP(LPROP,$KX)
               RKAPPA=RMPROP(LPROP,$KAPPA)
               RETURN
            ENDIF
          ENDSELECT
        ENDDO  
      ENDIF
      END

      SUBROUTINE PARTMOD3(X,Y,Z,VISC,RHO,CP,RK,RKAPPA)
      INCLUDE '$FEMEQ'
C Modifikace parametru, pokud lezi bod X,Y,Z uvnitr nejake castice
      IF(NPART.GT.0)THEN
        DO I=1,NPART
          IE=NE+I
          LEGRP=MAX0(1,IGROUP(IE))
          LRCON=MAX0(1,IRCONS(IE))
          NAMELE=JGROUP(LEGRP,$ENAME)
          SELECT CASE(NAMELE)
          CASE($SPHERE)
            L0=LUE(IE)
            IND=IABS(IUE(L0+1))
            XC=XX(IND)
            YC=YY(IND)
            ZC=ZZ(IND)
            R=RRCONS(LRCON,$D)/2.
            IF((X-XC)**2+(Y-YC)**2+(Z-ZC)**2.LE.R**2)THEN
C X,Y,Z lezi v kulove castici   
               LPROP=MAX0(1,IMPROP(IE))
               RHO=RMPROP(LPROP,$RHO)
               VISC=RMPROP(LPROP,$VISC)
               CP=RMPROP(LPROP,$CP)
               RK=RMPROP(LPROP,$KX)
               RKAPPA=RMPROP(LPROP,$KAPPA)
               RETURN
            ENDIF
          ENDSELECT
        ENDDO  
      ENDIF
      END
