      SUBROUTINE MENSET
C Preruseni GETCHARQQ volanim callback procedury z menu
C Pri volani z menu je treba vsechny polozky IP,RP,TP vytvorit procedurou DIAP
C TP(1),...,TP(MAXPAR) je treba vyprazdnit, protoze sestavovana prikazova radka je 
C vymezena posledni prazdnou textovou polozkou TP(i) 
      INCLUDE '$MENU'
	CALL FEMENU(-1)
	MENU=.TRUE.
	TP=' '
	LAST=0
	ISEMI=0
	II=FOCUSQQ(10)
      II=SETTEXTCOLOR(int2(13))
      WRITE(10,'('' > MENU interrupt'')')
      II=SETTEXTCOLOR(int2(15))
	END

	SUBROUTINE MENEND
	INCLUDE '$MENU'
C Po skonceni callback procedury z menu - navrat z preruseni
      IF(NOTHREAD)THEN
         WRITE(10,'('' Press Enter to resume command line''\)')
	ELSE
	   BREAK=.TRUE.
	ENDIF
	CALL FEMENU(-2)
	END

C =========================================================

	SUBROUTINE RRGFCR(IDUMMY)
C Vykresleni prubehu UDF podel krivky CR
	LOGICAL IDUMMY
	CALL MENSET
	CALL RGFCR(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RGFCR(IDUMMY)
C XY-graf prubehu definovane FUNKCE na specifikovane krivce
C GCR Cr,Cislo funkce,FONT
C kreslene hodnoty jsou presouvany do pracovnich vektoru XGR a VGR
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'GFCR',IEND)
           IC=IP(1)            
           IDF=IP(2)
           IF(IEND.EQ.0.AND.IC.GT.0.AND.IC.LE.NCR.AND.
     /        (IDF.GE.-10.AND.IDF.LE.60.OR.
     /         IABS(IDF).GE.101.AND.IABS(IDF).LE.105))THEN
              IPIXH=IP(3)
              IF(IPIXH.LE.8)THEN
                 IPIXH=12
                 IFONT=5
              ELSE
                 IFONT=3
              ENDIF
              DO I=1,MCR(IC)
                X8(I)=PTX(ICR(I,IC))
                Y8(I)=PTY(ICR(I,IC))
                Z8(I)=PTZ(ICR(I,IC))
              ENDDO
              IF(MCR(IC).EQ.2)THEN
                 X8(3)=(X8(1)+X8(2))*.5
                 Y8(3)=(Y8(1)+Y8(2))*.5
                 Z8(3)=(Z8(1)+Z8(2))*.5
              ENDIF
              AX=4*X8(3)-X8(2)-3*X8(1)
              BX=2*(X8(1)+X8(2))-4*X8(3)
              AY=4*Y8(3)-Y8(2)-3*Y8(1)
              BY=2*(Y8(1)+Y8(2))-4*Y8(3)
              AZ=4*Z8(3)-Z8(2)-3*Z8(1)
              BZ=2*(Z8(1)+Z8(2))-4*Z8(3)
              N=100
              DT=1./(N-1)
              YMINI=1E10
              YMAXI=-1E10
              DO I=1,N
                 T=(I-1)*DT
                 AUX(2)=X8(1)+AX*T+BX*T**2
                 AUX(3)=Y8(1)+AY*T+BY*T**2
                 AUX(4)=Z8(1)+AZ*T+BZ*T**2
                 XGR(I)=T
                 VGR(I)=CURFUN(IDF)
                 YMINI=AMIN1(YMINI,VGR(I))
                 YMAXI=AMAX1(YMAXI,VGR(I))
              ENDDO
              IF(YMINI.GE.YMAXI)THEN
                 YMINI=YMAXI-1
                 YMAXI=YMINI+1
              ENDIF
              II=FOCUSQQ(21)
              WRITE(LABEL,'(''Funct.'',I3)')IDF 
              CALL GMFSTW(2,1,$IVIEW,IFONT,IPIXH,
     /'t (rel.dist.)',LABEL,
     /0.,1.,0.,1.,0.,1.,YMINI,YMAXI)
              CALL GMFAXE(2,3,15)
              CALL GMFPL(N,XGR,VGR,12)
              CALL GMFSW(1)
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRGRAFUN(IDUMMY)
C Vykresleni prubehu funkce UDF 
	LOGICAL IDUMMY
	CALL MENSET
	CALL RGRAFUN(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RGRAFUN(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'GRAFUN',IEND)
           IF(IEND.EQ.0)THEN
             IFUN=IP(1)
             X1=RP(2)
             X2=RP(3)
             IPIXH=IP(4)
             IF(IPIXH.LE.8)THEN
                 IPIXH=12
                 IFONT=5
             ELSE
                 IFONT=3
             ENDIF
             YMINI=1E10
             YMAXI=-1E10
             N=100
             DX=(X2-X1)/N
             X0=X1
             DO I=1,N
                DO J=1,34
                  AUX(J)=X0
                ENDDO
                VGR(I)=CURFUN(IFUN)
                YMINI=AMIN1(YMINI,VGR(I))
                YMAXI=AMAX1(YMAXI,VGR(I))
                X0=X0+DX
             ENDDO
             IF(YMINI.GE.YMAXI)THEN
                YMINI=YMINI-1
                YMAXI=YMAXI+1
             ENDIF
             WRITE(LABEL,'(''Funct.'',I3)')IFUN
             II=FOCUSQQ(21)
             CALL GMFSTW(2,1,21,IFONT,IPIXH,'X',LABEL,0.,1.,0.,1.,
     /                    X1,X2,YMINI,YMAXI)
             CALL GMFAXE(2,3,15)
             CALL GMFPLD(X1,DX,N,VGR,12)
             IAUX(10)=0
             CALL GMFSW(1)
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRPTPLOT(IDUMMY)
C Vykresleni bodu PT
	LOGICAL IDUMMY
	CALL MENSET
	CALL RPTPLOT(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RPTPLOT(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Plot keypoints'')')
           CALL DIAP(NPT,'FLI',IEND)
           IF(IEND.EQ.0.AND.IP(1).GT.0.AND.IP(1).LE.NPT.AND.
     /        IP(3).LE.NPT)THEN
              II=SETACTIVEQQ(20)
              CALL GMFSWC(1,1,XMI,XMA,YMI,YMA)
              DO J=IP(1),IP(2),IP(3)
                CALL ROT(PTX(J),PTY(J),PTZ(J),PTXJ,PTYJ,DUMMY)
                CALL GMFMRKL(PTXJ,PTYJ,27+10*(NPT/20),J,KPT)
              ENDDO
              PT$=1
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRPTPG(IDUMMY)
C Vykresleni bodu PT
	LOGICAL IDUMMY
	CALL MENSET
	CALL RPTPG(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RPTPG(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Plot keypoints'')')
           CALL DIAP(NPT,'FLI',IEND)
           IF(IEND.EQ.0.AND.IP(1).GT.0.AND.IP(1).LE.NPT.AND.
     /        IP(3).LE.NPT)THEN
              II=SETACTIVEQQ(21)
              CALL GMFSW(2)
              DO J=IP(1),IP(2),IP(3)
                CALL ROT(PTX(J),PTY(J),PTZ(J),PTXJ,PTYJ,DUMMY)
                CALL GMFMRKL(PTXJ,PTYJ,27+10*(NPT/20),J,KPT)
              ENDDO
              PT$=1
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRNDPLOT(IDUMMY)
C Vykresleni uzlu ND
	LOGICAL IDUMMY
	CALL MENSET
	CALL RNDPLOT(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RNDPLOT(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Plot nodes'')')
           CALL DIAP(ND,'FLI',IEND)
           IF(IEND.EQ.0.AND.IP(1).GT.0)THEN
           II=SETACTIVEQQ(20)
           CALL GMFSWC(1,1,XMI,XMA,YMI,YMA)
           DO J=IP(1),IP(2),IP(3)
             CALL ROT(XX(J),YY(J),ZZ(J),XXJ,YYJ,DUMMY)
             IF(IP(2)-IP(1).LE.100)THEN
                CALL GMFMRKL(XXJ,YYJ,30,J,KND)
             ELSE
                CALL GMFMRKLS(XXJ,YYJ,30,J,KND)
             ENDIF
           ENDDO
           ND$=1
           ENDIF
	END

	SUBROUTINE RRSFPLOT(IDUMMY)
C Vykresleni ploch
	LOGICAL IDUMMY
	CALL MENSET
	CALL RSFPLOT(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RSFPLOT(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Plot surfaces'')')
           CALL DIAP(NSF,'FLI',IEND)
           IF(IEND.EQ.0.AND.IP(1).GT.0)THEN
           II=SETACTIVEQQ(20)
           CALL GMFSWC(1,1,XMI,XMA,YMI,YMA)
           DO K=IP(1),IP(2),IP(3)
             CALL PLOTSF(K,1,KSF)
           ENDDO
           ENDIF
	END


C-----------------------------------------------
	SUBROUTINE RRVIEW(IDUMMY)
C Nastaveni parametru 3D pohledu (axonometrie/souradnice oka)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RVIEW(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RVIEW(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
	     CALL DIAP(0,'VIEW',IEND)
           IF(IEND.EQ.0)THEN
             IPROJ=IP(1)
             SELECT CASE(IPROJ)
             CASE(0)
               GFIX=RP(2)
               GFIY=RP(3)
               GFIZ=RP(4)
             CASE DEFAULT
               XEYE=RP(2)
               YEYE=RP(3)
               ZEYE=RP(4)
             ENDSELECT
             CALL GMFSW(1)
             CALL SET3D
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRWINDOW(IDUMMY)
C Vyber okna, kde se budou kreslit vrstevnice (default 21-VIEW, je mozno prenest do 20-MODEL)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RWINDOW(IDUMMY)
	CALL MENEND
	END


      SUBROUTINE RWINDOW(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
	     CALL DIAP(21,'WINDOW',IEND)
           IF(IEND.EQ.0.AND.IP(1).EQ.20.OR.IP(1).EQ.21.OR.IP(1).EQ.40)
     /        $IVIEW=IP(1)
	END

C-----------------------------------------------
	SUBROUTINE RRGFSF(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RGFSF(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RGFSF(IDUMMY)
C 3D grafika - vykresleni vrstevnic FUNKCE na plose (3D rezu)
C GFSF SF FUNKCE VMIN VMAX
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'GFSF',IEND)
           IS=IP(1)
           IDF=IP(2)
           WMIN=RP(3)
           WMAX=RP(4)
           DW=(WMAX-WMIN)/11.
           DO I=1,10
              V8(I)=WMIN+I*DW
           ENDDO
           IF(IEND.EQ.0.AND.IS.GT.0.AND.IS.LE.NSF.AND.
     /        (IDF.GE.-10.AND.IDF.LE.60.OR.
     /         IABS(IDF).GE.101.AND.IABS(IDF).LE.105))THEN
              MSFIS=MSF(IS)
              DO I=1,MSFIS
                X8(I)=PTX(ISF(I,IS))
                Y8(I)=PTY(ISF(I,IS))
                Z8(I)=PTZ(ISF(I,IS))
              ENDDO
              II=FOCUSQQ(20)
              WMI=1E10
              WMA=-1E10
              DO IETA=1,31
                RETA=(IETA-16)/15.
                DO IKSI=1,31
                   RKSI=(IKSI-16)/15.
                   CALL FDQ(MSFIS,RKSI,RETA,FF,DFK,DFE)
                   X=0.
                   Y=0.
                   Z=0.
                   DO I=1,MSFIS
                     X=X+FF(I)*X8(I)
                     Y=Y+FF(I)*Y8(I)
                     Z=Z+FF(I)*Z8(I)
                   ENDDO
                   AUX(2)=X
                   AUX(3)=Y
                   AUX(4)=Z
                   WVNEW(IKSI)=CURFUN(IDF)
                   CALL ROT(X,Y,Z,WXNEW(IKSI),WYNEW(IKSI),DUMMY)
                   WMI=AMIN1(WMI,WVNEW(IKSI))
                   WMA=AMAX1(WMA,WVNEW(IKSI))
                ENDDO
                IF(IETA.GT.1)THEN
                   DO I=1,30
                      XGR(1)=WXNEW(I)
                      XGR(2)=WXOLD(I+1)
                      XGR(3)=WXOLD(I)
                      XGR(4)=WYNEW(I)
                      XGR(5)=WYOLD(I+1)
                      XGR(6)=WYOLD(I)
                      VGR(1)=WVNEW(I)
                      VGR(2)=WVOLD(I+1)
                      VGR(3)=WVOLD(I)
C      SUBROUTINE GMFCTR(V3,X3,Y3,VMIN,VMAX,IVMIN,IVMAX)
                      CALL GMFCTR(VGR,XGR,XGR(4),WMIN,WMAX,0,800)
                      CALL GMFCTI(VGR,XGR,XGR(4),V8,10,0)
                      XGR(3)=WXNEW(I+1)
                      XGR(6)=WYNEW(I+1)
                      VGR(3)=WVNEW(I+1) 
                      CALL GMFCTR(VGR,XGR,XGR(4),WMIN,WMAX,0,800)
                      CALL GMFCTI(VGR,XGR,XGR(4),V8,10,0)
                   ENDDO
                ENDIF
                WXOLD=WXNEW
                WYOLD=WYNEW
                WVOLD=WVNEW
              ENDDO
              WRITE(9,'('' FUNCTION('',I3,'') MIN'',E9.2,'' MAX'',E9.2)'
     /)IDF,WMI,WMA
           ENDIF
      END

C-----------------------------------------------
	SUBROUTINE RRGCR(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RGCR(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RGCR(IDUMMY)
C XY-graf prubehu vybraneho DOF na specifikovane krivce
C GCR Cr,Dof,Zone
C kreslene hodnoty presouvany do vektoru XGR a VGR
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'GCR',IEND)
           IC=IP(1)            
           IDF=IP(2)
           IZON=IP(3)
           IF(IEND.EQ.0.AND.IC.GT.0.AND.IC.LE.NCR.AND.
     /        IDF.GT.0.AND.IZON.GT.0.AND.IZON.LE.4)THEN
              IPIXH=IP(4)
              IF(IPIXH.LE.8)THEN
                 IPIXH=12
                 IFONT=5
              ELSE
                 IFONT=3
              ENDIF
              DO I=1,MCR(IC)
                X8(I)=PTX(ICR(I,IC))
                Y8(I)=PTY(ICR(I,IC))
                Z8(I)=PTZ(ICR(I,IC))
              ENDDO
              N=0
              YMINI=1E10
              YMAXI=-1E10
              DO I=1,ND
                 CALL FTN3CR(X8,Y8,Z8,MCR(IC),XX(I),YY(I),ZZ(I),$RTOL,T)
                 IF(T.GT.-.5)THEN
C Uzel I lezi na krivce. Vyber uzloveho parametru IDF ze zony IZON
                     N=MIN0(MAXNTS,N+1)
                     VGR(N)=VAL(LPU(IDF)+I,IZON)
                     XGR(N)=T
                     YMINI=AMIN1(YMINI,VGR(N))
                     YMAXI=AMAX1(YMAXI,VGR(N))
                 ENDIF
              ENDDO
              IF(YMINI.GE.YMAXI)THEN
                 YMINI=YMAXI-1
                 YMAXI=YMINI+1
              ENDIF
              II=FOCUSQQ(21)
             CALL GMFSTW(2,1,$IVIEW,IFONT,IPIXH,
     /'t (rel.dist.)',TDOF(IDF),
     /0.,1.,0.,1.,0.,1.,YMINI,YMAXI)
              CALL GMFAXE(2,3,15)
              CALL FSORT(N,XGR,VGR)
              CALL GMFPL(N,XGR,VGR,12)
              CALL GMFSW(1)
           ENDIF
      END

C-----------------------------------------------
	SUBROUTINE RRGE2(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RGE2(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RGE2(IDUMMY)
C Vrstevnice parametru elementu 2D
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'GE',IEND)
           IF(IEND.EQ.0)THEN
C Kresleni vrstevnic vybraneho sloupce EPAR(*,ICPE). IP(1)-kod parametru elementu.
C Zjisteni rozsahu XMI,XMA,.. z data typu FEM     
               XMI=RP(2)
               XMA=RP(3)
               YMI=RP(4)
               YMA=RP(5)
C GRANGE stanovi rozsah XMI,XMA,..., prvni parametr 1 (FEM), 2,2 (zvetseni o 2%)     
               IF(XMI.GE.XMA.OR.YMI.GE.YMA)
     /              CALL GRANGE(1,5,5,XMI,XMA,YMI,YMA)
               VMI=1E10
               VMA=-1E10
               XGR=0.
               VGR=0
               IP1=MAX0(1,MIN0(21,IP(1)))
               DO J=1,NE
                 NAMELE=JGROUP(IGROUP(J),$ENAME)
                 ICPE=MAX0(1,LEPAR(NAMELE,IP1))
C VEL hodnota parametru v elementu. Pricteni k prvkum uzlu elementu.
C     uzlove hodnoty VGR(ND) budou prumery sousednich elementu.
                 VEL=EPAR(J,ICPE)
                 L0=LUE(J)
                 DO I=1,IABS(MUE(J))
                   INDU=MAX0(1,IABS(IUE(L0+I)))
                   XGR(INDU)=XGR(INDU)+1
                   VGR(INDU)=VGR(INDU)+VEL
                 ENDDO
               ENDDO
               DO J=1,ND
                 IF(XGR(J).GT.0.)THEN
                    VGR(J)=VGR(J)/XGR(J)
                    IF(XX(J).GE.XMI.AND.XX(J).LE.XMA.AND.
     /                 YY(J).GE.YMI.AND.YY(J).LE.YMA)THEN
                       VMI=AMIN1(VMI,VGR(J))
                       VMA=AMAX1(VMA,VGR(J))
                    ENDIF
                 ENDIF
               ENDDO
              CALL GMFSTW(2,0,$IVIEW,5,12,'X (or axis)','Y (or radius)',
     /0.,1.,0.,1.,XMI,XMA,YMI,YMA)
               WRITE(LINE,'('' max='',E9.2,'' time='',E9.2)')VMA,TIME
             CALL GMFECTR(.TRUE.,2,' EPAR: '//TEPAR(IP1)//LINE(1:29),44,
     /                   XX,YY,VGR,IUE,LUE,MUE,MINT,NE,
     /                   XMI,XMA,YMI,YMA,VMI,VMA,1,800,0)
               CALL GMFSW(1)
           WRITE(9,'(1X,A8,'' range:'',2e9.2)')TEPAR(IP1),VMI,VMA
           ENDIF
      END

C-----------------------------------------------
	SUBROUTINE RRGE1(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RGE1(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RGE1(IDUMMY)
C Vrstevnice parametru elementu 1D
C EPAR 1D (napr. SHELLAX) - JEPA je index hlavicky parametru EPAR
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
           IDUMLOC=IDUMMY
           CALL DIAP(1,'GE',IEND)
           IF(IEND.EQ.0.AND.IP(1).GT.0)THEN
             IP1=MAX0(1,MIN0(21,IP(1)))
             FMAX=1E-15
             IMAX=1
             DO IE=1,NE
                NAMELE=JGROUP(IGROUP(IE),$ENAME)
                IFORCE=LEPAR(NAMELE,IP1)
                IF(IFORCE.GT.0)THEN
                  AFORCE=ABS(EPAR(IE,IFORCE))
                  IF(AFORCE.GT.FMAX)THEN
                    FMAX=AFORCE
                    IMAX=IE
                  ENDIF
                ENDIF
             ENDDO
C zjisteni rozsahu XMI,XMA,... pro FEM (a zvetseni o 10%)
             CALL GRANGE(1,10,10,XMI,XMA,YMI,YMA)
             II=FOCUSQQ(21)
             CALL GMFSTW(2,1,$IVIEW,5,12,'X (or axis)','Y (or radius)',
     /0.,1.,0.,1.,XMI,XMA,YMI,YMA)
             CALL GMFAXE(2,7,15)
             CALL GMFTEXT(XMI+(XMA-XMI)*.03,YMA-(YMA-YMI)*.01,1,8,
     /                      TEPAR(IP1))
             DO IE=1,NE
                IRG=MAX0(1,IRCONS(IE))
                T=RRCONS(IRG,$H)
                L0=LUE(IE)
                DO I=1,2
                   IND=IABS(IUE(L0+I))
                   X8(I)=XX(IND)
                   Y8(I)=YY(IND)
                ENDDO
                NAMELE=JGROUP(IGROUP(IE),$ENAME)
                IFORCE=LEPAR(NAMELE,IP1)
                IF(IFORCE.GT.0)THEN
                  FORC=EPAR(IE,IFORCE)/FMAX*.15
C    Kresleni usecky (2 body X8,Y8) se zadanymi hodnotami (FORC1,FORC2)
C    v koncovych bodech. Hodnoty FORC musi byt normalizovane v rozsahu (-1,1).
C    Usecka se kresli jako obdelnik o tloustce T*0.007 barvou 1. Barvou 4
C    se vykresluje obrys lichobezniku (prubeh FORC), ktery se vyplni barvou 12.
C    Parametry XC,YC jsou vystupni: teziste lichobeznika (napr. pro popis).
                  CALL GMFECR(X8,Y8,FORC,FORC,T*.007,1,4,12,XC,YC)
                  IF(IE.EQ.IMAX)THEN
                     XCMAX=XC
                     YCMAX=YC
                     WRITE(LABEL,'(ES10.3)')EPAR(IE,IFORCE)
                  ENDIF
                ENDIF
             ENDDO
             CALL GMFMRK(XCMAX,YCMAX,40+IFORCE)
             CALL GMFTEXT(XCMAX,YCMAX,1,10,LABEL)
             CALL GMFSW(1)
           ENDIF
      END

C-----------------------------------------------
	SUBROUTINE RRGD1(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RGD1(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RGD1(IDUMMY)
C Vrstevnice DOF 1D
CGD1 DOF, 1D, tonovani (potrubni site apod), IPIXELS(4), LABELX(5), LABELY(6)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(IP1,'GPIPE',IEND)
C          GD1    DOF,ZONE,THICKNESS
           IF(IEND.EQ.0.AND.IP(1).GT.0)THEN
               IPIXH=IP(4)
               IF(IPIXH.LE.8)THEN
                 IPIXH=12
                 IFONT=5
               ELSE
                 IFONT=3
               ENDIF
C nastaveni rozsahu XMI,XMA,... dle dat FEM (prvni parametr 1)
               CALL GRANGE(1,5,10,XMI,XMA,YMI,YMA)
               II=FOCUSQQ(21)
               CALL GMFSTW(2,1,$IVIEW,IFONT,IPIXH,
     /TRIM(TP(5)),TRIM(TP(6)),0.,1.,0.,1.,XMI,XMA,YMI,YMA)
               CALL GMFAXE(2,7,15)
               IP1=MAX0(1,MIN0(20,IP(1)))
               IP2=MAX0(1,MIN0(4,IP(2)))
               IP1=IP(1)
               CALL RANGE(IP2)
               DOFMI=DOFMIN(IP1)
               DOFMA=DOFMAX(IP1)
               DO IE=1,NE
                  CALL GPIPE(IE,IP(3),0,IP1,IP2,DOFMI,DOFMA,0,800)
               ENDDO
C               Legenda skaly barev
               DGX=(XMA-XMI)*.25
               DGY=(YMA-YMI)*.015
               X8(1:3)=(/XMA-DGX,XMI+DGX,XMI+DGX/)
               Y8(1:3)=(/YMA,YMA-DGY,YMA/)
               V8(1:3)=(/DOFMA,DOFMI,DOFMI/)
               CALL GMFCTR(V8,X8,Y8,DOFMI,DOFMA,0,800)
               X8(3)=XMA-DGX
               Y8(3)=YMA-DGY
               V8(3)=DOFMA
               CALL GMFCTR(V8,X8,Y8,DOFMI,DOFMA,0,800)
               WRITE(LABEL,'(ES9.2)')DOFMA
               CALL GMFTEXT(XMA-DGX,YMA-DGY,1,9,LABEL)
               WRITE(LABEL,'(ES9.2)')DOFMI
               CALL GMFTEXT(XMI,YMA-DGY,1,14,TDOF(IP1)//' '//LABEL)
               CALL GMFSW(1)
            ENDIF
      END

C-----------------------------------------------
	SUBROUTINE RRGVEL(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RGVEL(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RGVEL(IDUMMY)
C 2D rychlosti vykreslene sipkami
CGVEL  IZONE, XMI,XMA,YMI,YMA (VX,VY ARROW), IMESH, ISTEP
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(IP1,'GVEL',IEND)
           IP1=MAX0(1,MIN0(4,IP(1)))
           IF(IEND.EQ.0)THEN
               XMI=RP(2)
               XMA=RP(3)
               YMI=RP(4)
               YMA=RP(5)
               IMESH=IP(6)
               ISTEP=MAX0(1,IP(7))
               IPIXH=IP(8)
               IF(IPIXH.LE.8)THEN
                 IPIXH=12
                 IFONT=5
               ELSE
                 IFONT=3
               ENDIF
C GRANGE stanovi rozsah XMI,XMA,..., prvni parametr 1 (FEM), 2,2 (zvetseni o 2%)     
               IF(XMI.GE.XMA.OR.YMI.GE.YMA)
     /            CALL GRANGE(1,2,2,XMI,XMA,YMI,YMA)
C Kresleni vrstevnic absolutnich hodnot rychlosti zony IP1
               VMI=1E10
               VMA=-1E10
               DO J=1,ND
                 XGR(J)=VAL(LPU($VX)+J,IP1)
                 VGR(J)=VAL(LPU($VY)+J,IP1)
                 VABS=SQRT(XGR(J)**2+VGR(J)**2)
                 IF(XX(J).GE.XMI.AND.XX(J).LE.XMA.AND.
     /              YY(J).GE.YMI.AND.YY(J).LE.YMA)THEN
                    VMI=AMIN1(VMI,VABS)
                    VMA=AMAX1(VMA,VABS)
                 ENDIF
               ENDDO
              CALL GMFSTW(2,0,$IVIEW,IFONT,IPIXH,
     /TRIM(TP(9)),TRIM(TP(10)),0.,1.,0.,1.,XMI,XMA,YMI,YMA)
               WRITE(LINE,'('' min='',E10.3,'' max='',E10.3,'' time='',E
     /9.2)')VMI,VMA,TIME
               CALL GMFVELO(.TRUE.,2,'Vx,Vy '//LINE(1:45),51,
     /                   XX,YY,XGR,VGR,ND,IUE,LUE,MUE,MINT,NE,
     /                   XMI,XMA,YMI,YMA,VMI,VMA,300,800,0,ISTEP)
               IF(IMESH.GT.0)THEN
                  DO IE=1,NE
                     CALL PLOTEL(IE,0,0)
                  ENDDO
               ENDIF
               CALL GMFSW(1)
           ENDIF
      END

C-----------------------------------------------
	SUBROUTINE RRGD2(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RGD2(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RGD2(IDUMMY)
C menu GD2- vykreslovani vrstevnic
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(IP1,'GRAPH',IEND)
C          DOF,Zone
           IP1=MAX0(1,MIN0(24,IP(1)))
           LP1=LPU(IP1)
           IP2=MAX0(1,MIN0(4,IP(2)))
           IF(IEND.EQ.0.AND.LP1.GE.0)THEN
              XMI=RP(3)
              XMA=RP(4)
              YMI=RP(5)
              YMA=RP(6)
              IMESH=IP(7)
              VMI=RP(8)
              VMA=RP(9)
              IPIXH=IP(10)
              IF(IPIXH.LE.8)THEN
                 IPIXH=12
                 IFONT=5
              ELSE
                 IFONT=3
              ENDIF
C GRANGE stanovi rozsah XMI,XMA,..., prvni parametr 1 (FEM), 2,2 (zvetseni o 2%)     
          IF(XMI.GE.XMA.OR.YMI.GE.YMA)CALL GRANGE(1,2,2,XMI,XMA,YMI,YMA)
C Kresleni vrstevnic veliciny IP1 (viz TDOF) na zaklade hodnot VAL(*,IP2)
              DO J=1,ND
                VGR(J)=VAL(LP1+J,IP2)
              ENDDO
              IF(VMI.GE.VMA)THEN
                VMI=1E10
                VMA=-1E10
                DO J=1,ND
                  IF(XX(J).GE.XMI.AND.XX(J).LE.XMA.AND.
     /              YY(J).GE.YMI.AND.YY(J).LE.YMA)THEN
                   VMI=AMIN1(VMI,VGR(J))
                   VMA=AMAX1(VMA,VGR(J))
                  ENDIF
                ENDDO
              ENDIF
              CALL GMFSTW(2,0,$IVIEW,IFONT,IPIXH,
     /TRIM(TP(11)),TRIM(TP(12)),0.,1.,0.,1.,XMI,XMA,YMI,YMA)
              WRITE(LINE,'('' min='',E10.3,'' max='',E10.3,'' time='',E
     /9.2)')VMI,VMA,TIME
              CALL GMFECTR(.TRUE.,2,' DOF: '//TDOF(IP1)//LINE(1:45),55,
     /                   XX,YY,VGR,IUE,LUE,MUE,MINT,NE,
     /                   XMI,XMA,YMI,YMA,VMI,VMA,1,800,0)
              IF(IMESH.GT.0)THEN
                  DO IE=1,NE
                     CALL PLOTEL(IE,0,0)
                  ENDDO
              ENDIF
	        ii=focusqq(21)
              CALL GMFSW(1)
           ENDIF
      END


C-----------------------------------------------
	SUBROUTINE RRGTC(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RGTC(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RGTC(IDUMMY)
C GTC - casove prubehy MOP
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(-1,'GTC',IEND)
           IF(IEND.EQ.0)THEN
             NGRAF=IP(1)
C Zjisteni rozsahu XMITC,... dle dat typu TC (prvni parametr 2)
             IF(NGRAF.EQ.MAXSEL)THEN
                CALL GRANGE(2,1,5,XMITC,XMATC,YMITC,YMATC)
             ELSE
                XMITC=YGR(1,1)
                XMATC=YGR(MAX0(1,NGR),1)
                YMITC=1E10
                YMATC=-1E10
                DO IG=1,NGRAF
                   IGR=IP(IG+1)
                   IF(IGR.GT.1.AND.IGR.LE.MAXSEL)THEN
                      DO I=1,NGR
                         YMITC=AMIN1(YMITC,YGR(I,IGR))
                         YMATC=AMAX1(YMATC,YGR(I,IGR))
                      ENDDO
                   ENDIF
                ENDDO
             ENDIF
             CALL GRAPUT(2,XMITC,XMATC,YMITC,YMATC)
             IF(XMATC.GT.XMITC.AND.YMITC.LT.YMATC)THEN
                CALL GMFSTW(1,1,20,1,16,'time','Y',0.,1.,0.,1.,
     /                    XMITC,XMATC,YMITC,YMATC)
                CALL GMFAXE(1,3,15)
                CALL CLEARPLOT
                DO IG=1,NGRAF
                   IGR=IP(IG+1)
                   IF(IGR.GT.1.AND.IGR.LE.MAXSEL)THEN
                      CALL GMFPL(NGR,YGR(1,1),YGR(1,IGR),IGR)
                      ITCPLOT(IGR)=1
                   ENDIF
                ENDDO
             ENDIF
             CALL GMFSW(1)
             TC$=1
             ISTATUS=3
             IST20=2
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRVLPLOT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RVLPLOT(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RVLPLOT(IDUMMY)
C Vykresleni objemu (brick)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Plot volumes'')')
           CALL DIAP(NVL,'FLI',IEND)
           IF(IEND.EQ.0.AND.IP(1).GT.0)THEN
           II=SETACTIVEQQ(20)
           CALL GMFSWC(1,1,XMI,XMA,YMI,YMA)
           DO K=IP(1),IP(2),IP(3)
             CALL PLOTVL(K,1,KVL)
           ENDDO
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRCRPLOT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RCRPLOT(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RCRPLOT(IDUMMY)
C Vykresleni krivek
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Plot curves'')')
           CALL DIAP(NCR,'FLI',IEND)
           IF(IEND.EQ.0.AND.IP(1).GT.0)THEN
              II=SETACTIVEQQ(20)
              CALL GMFSWC(1,1,XMI,XMA,YMI,YMA)
              DO K=IP(1),IP(2),IP(3)
                CALL PLOTCR(K,2,KCR)
              ENDDO
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRCRPG(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RCRPG(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RCRPG(IDUMMY)
C Vykresleni krivek ale v okne VIEW
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Plot curves'')')
           CALL DIAP(NCR,'FLI',IEND)
           IF(IEND.EQ.0.AND.IP(1).GT.0)THEN
              II=SETACTIVEQQ(21)
              CALL GMFSW(2)
              DO K=IP(1),IP(2),IP(3)
                CALL PLOTCR(K,2,KCR)
              ENDDO
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRCTPLOT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RCTPLOT(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RCTPLOT(IDUMMY)
C Vykresleni obrysu (contours)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Plot contours'')')
           CALL DIAP(NCONTOUR,'FLI',IEND)
           IF(IEND.EQ.0.AND.IP(1).GT.0.AND.IP(2).LE.MAXCT)THEN
             II=SETACTIVEQQ(20)
             CALL GMFSWC(1,1,XMI,XMA,YMI,YMA)
             DO K=IP(1),IP(2),IP(3)
               DO I=1,MCONTOUR(K)
                 INDCR=ICONTOUR(I,K)
                 CALL PLOTCR(INDCR,11+K,KCR)
               ENDDO
             ENDDO
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRDETPLOT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RDETPLOT(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RDETPLOT(IDUMMY)
C Vykresleni detektoru
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'DETPLO',IEND)
           IF(IEND.EQ.0.AND.IP(1).GT.0)THEN
           II=SETACTIVEQQ(20)
           CALL GMFSWC(1,1,XMI,XMA,YMI,YMA)
           DO K=IP(1),IP(2),IP(3)
             CALL DETPLO(K,2)
           ENDDO
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RREPLOT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL REPLOT(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE REPLOT(IDUMMY)
C Vykresleni elementu
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
C EPLOT I1,I2,ISTEP, ERM-FILL, IGROUP-SELECTED
           CALL DIAP(NE,'EPLOT',IEND)
           IF(IEND.EQ.0.AND.IP(1).GT.0)THEN
           II=SETACTIVEQQ(20)
           CALL GMFSWC(1,1,XMI,XMA,YMI,YMA)
           CALL RANGE(2)
           IERM=IP(4)
           NGRP=IP(5)
           DO IE=IP(1),IP(2),IP(3)
             IF(NGRP.EQ.0.OR.IERM.EQ.0)THEN
                CALL PLOTEL(IE,0,IERM)
             ELSE
                SELECT CASE(IERM)
                CASE(1)
                   NUM=IGROUP(IE)
                CASE(2)
                   NUM=IRCONS(IE)
                CASE(3)
                   NUM=IMPROP(IE)
                CASE DEFAULT
                   NUM=0
                ENDSELECT
                IF(NUM.EQ.NGRP)CALL PLOTEL(IE,0,0)
             ENDIF
           ENDDO
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRDEFPLOT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RDEFPLOT(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RDEFPLOT(IDUMMY)
C 
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
C Deformovany tvar
           II=SETACTIVEQQ(20)
           CALL GMFSWC(1,1,XMI,XMA,YMI,YMA)
           CALL DEFPLOT(2,3,12)
	END

C-----------------------------------------------
	SUBROUTINE RRNFPLOT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RNFPLOT(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RNFPLOT(IDUMMY)
C Silne okrajove podminky v uzlech
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
C IP1,IP2,IP3 - rozsah uzlovych bodu
C IP4         - typ parametru (viz. TFOF: 1-T,2-Ux,...)
C U kazdeho uzlu je treba vyhledat, zda parametr IP4 existuje 
C a zda jeho status odpovida okrajove podmince, tj. IPU<0.
           WRITE(10,'('' Plot nodes with fixed/loaded DOFs.'')')
           CALL DIAP(ND,'NFPLOT',IEND)
           IF(IEND.EQ.0.AND.IP(4).GT.0.AND.IP(1).GT.0)THEN
             II=SETACTIVEQQ(20)
             CALL GMFSWC(1,1,XMI,XMA,YMI,YMA)
             DO J=IP(1),IP(2),IP(3)
                IF(IPU(LPU(IP(4))+J).NE.0)THEN
                  CALL ROT(XX(J),YY(J),ZZ(J),XXJ,YYJ,DUMMY)
                  CALL GMFMRK(XXJ,YYJ,IMARK(IP(4))+20)
                ENDIF
             ENDDO
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRPFPLOT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RPFPLOT(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RPFPLOT(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
C IP1         - ZONA 1-BC,2-WESULTS,3-IC
C IP2         - typ parametru (viz. TFOF: 1-T,2-Ux,...)
C IP3         - velikost 
           CALL DIAP(IZONE,'PFPLOT',IEND)
           IZONE=IP(1)
           ID=IP(2)
           IF(IEND.EQ.0.AND.ID.GT.0.AND.
     /             IZONE.GT.0.AND.IZONE.LE.4)THEN
             CALL RANGE(IZONE)
             IF(DOFMAX(ID).GT.DOFMIN(ID))THEN
               II=SETACTIVEQQ(20)
               CALL GMFSWC(1,1,XMI,XMA,YMI,YMA)
               DO IND=1,NPT
                 J=NEARND(IND)
                 IF(J.GT.0.AND.J.LE.ND)THEN
                    VALUE=(VAL(LPU(ID)+J,IZONE)-DOFMIN(ID))/
     /                        (DOFMAX(ID)-DOFMIN(ID))
                    CALL ROT(XX(J),YY(J),ZZ(J),XXJ,YYJ,DUMMY)
                    CALL GFND(XXJ,YYJ,VALUE,IP(3))
                 ENDIF
               ENDDO
             ENDIF
           ENDIF
	END


C-----------------------------------------------
	SUBROUTINE RRDIST(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RDIST(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RDIST(IDUMMY)
C Vzdalenost dvou bodu
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           KBD=1
           WRITE(10,'('' Distance between two points (L-click, R-click t
     /erminates)'')')
           CALL GMFSWC(1,1,XMI,XMA,YMI,YMA)
           II=SETACTIVEQQ(20)
           II=FOCUSQQ(20)
           CALL GMFLCC(PXO,PYO,KBD)	     
	     CALL GMFMRKS(PXO,PYO,47)
           DO WHILE(KBD.EQ.1)
             II=SETACTIVEQQ(20)
             II=FOCUSQQ(20)
             CALL GMFLCC(PX,PY,KBD)
	       IF(KBD.EQ.1)THEN
               CALL GMFMRKS(PX,PY,47)
	         CALL GMFLINE(PXO,PYO,PX,PY,12)
	         DIST=SQRT((PX-PXO)**2+(PY-PYO)**2)
	         PXO=PX
	         PYO=PY
               WRITE(11,'('' Distance='',es12.4)')DIST
	       ENDIF
           ENDDO
	END

C-----------------------------------------------
	SUBROUTINE RRPID(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RPID(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RPID(IDUMMY)
C Identifikace bodu PT lokatorem
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           KBD=1
         CALL HELPC(4,'PoinT identification by Left_Click. Ctrl+Left_Cli
     /ck hidden point. Shift+Left_Click from keyboard.      Use Right_Cl
     /ick to quit.')
           WRITE(10,'('' Identify PT by mouse (R-click terminates)'')')
           PT$=1
           CALL GMFSWC(1,1,XMI,XMA,YMI,YMA)
           DO WHILE(KBD.EQ.1)
             CALL PIDENT(JMI,KBD)
             WRITE(11,'('' Point'',I4.3,'' X='',ES10.3,'' Y='',ES10.3,
     /'' Z='',ES10.3/'' nearest Node='',i6)')
     /       JMI,PTX(JMI),PTY(JMI),PTZ(JMI),NEARND(JMI)
           ENDDO
	END

C-----------------------------------------------
	SUBROUTINE RRNID(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RNID(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RNID(IDUMMY)
C Identifikace uzlu ND lokatorem
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(IZONE,'NID',IEND)
           IZONE=IP(1)
           ITYP=IP(2)
           IF(IEND.EQ.0.AND.IZONE.GT.0.AND.IZONE.LE.4.AND.
     /        ITYP.GT.0.AND.ITYP.LE.MAXTDOF)THEN
              CALL NIDINF(IZONE,ITYP)
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RREID(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL REID(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE REID(IDUMMY)
C Identifikace elementu lokatorem
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(ITYP,'EID',IEND)
           ITYP=IP(1)
CIDENT ITYP=1 EGROUP, =2 RRCONS, =3 MPROP, =4 EPAR, =5 GEOMETRY, 6-modify
           IF(IEND.EQ.0.AND.ITYP.GE.0.AND.ITYP.LE.6)THEN
              CALL EIDINF(ITYP)
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRCID(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RCID(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RCID(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           KBD=1
         CALL HELPC(4,'Curve identification by Left_Click. Ctrl+Left_Cli
     /ck hidden curve. Shift+Left_Click from keyboard.      Use Right_Cl
     /ick to quit.')
           WRITE(10,'('' Identify CURVE by mouse (R-click terminates)'')
     /')
           CR$=1
           CALL GMFSWC(1,1,XMI,XMA,YMI,YMA)
           DO WHILE(KBD.EQ.1)
             CALL CIDENT(JMI,KBD)
             WRITE(11,'('' Curve'',I3.2,'' N_mesh='',I3,'' Last/First=''
     /,E10.3/'' Points:'',3i6.2)')
     /       JMI,NXCR(JMI),FLAFI(JMI),(ICR(I,JMI),I=1,MCR(JMI))
           ENDDO
	END

C-----------------------------------------------
	SUBROUTINE RRTID(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RTID(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RTID(IDUMMY)
C Identifikace TC lokatorem
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           KBD=1
           WRITE(10,'('' Identify TIME CURVE by mouse (R-click terminate
     /s)'')')
           TC$=1
           CALL GMFSWC(1,2,XMI,XMA,YMI,YMA)
           DO WHILE(KBD.EQ.1)
             CALL TIDENT(IMI,JMI,KBD)
             CALL RNMOM(YGR(1,1),YGR(1,JMI),NGR,V8)
             WRITE(11,'('' Curve'',I3,'': points='',I4,
     /'' t-mean='',e10.3,'' var.='',e10.3,'' 3M=''E10.3/
     /'' Point'',i4,'': time='',e10.3,'' value='',e10.3)')
     /       JMI,NGR,V8(4),V8(5),V8(3),
     /       IMI,YGR(IMI,1),YGR(IMI,JMI)
           ENDDO
	END

C-----------------------------------------------
	SUBROUTINE RRCLS(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RCLS(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RCLS(IDUMMY)
C CLEAR SCREEN
      INCLUDE '$MENU'
c	COMMON /$FIRSTPAGE/FFIRST
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           II=SETACTIVEQQ(20)
           CALL GMFSW(1)
           CALL GMFAXE(1,7,15)
c          clearplot jen vynuluje zonu /$plot/nd$,...
           CALL CLEARPLOT
c	     FFIRST=.TRUE.
	END

C-----------------------------------------------
	SUBROUTINE RRSCALE(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RSCALE(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RSCALE(IDUMMY)
C SCALE
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(0,'SCALE',IEND)
           IF(IEND.EQ.0)CALL WRITEL('SCALE')
	END

C-----------------------------------------------
	SUBROUTINE RRLABEL(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RLABEL(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RLABEL(IDUMMY)
C LABEL graphic
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Text to be moved to the MODEL window (locate by
     / mouse - Left click)'')')
	     CALL DIAP(1,'LATEX',IEND)
	     IF(IEND.EQ.0)THEN
              II=SETACTIVEQQ(20)
              II=FOCUSQQ(20)
              CALL GMFSW(1)
              IF(IST20.GT.2)CALL GMFSWC(1,2,XMI,XMA,YMI,YMA)
              CALL GMFLCC(XMI1,YMI1,KBD)
              LLL=MIN0(60,LEN(TRIM(TP(1))))
C                IF(KBD.EQ.1.AND.LLL.GT.2)THEN
C                CALL TLWC(LLL-2,LINE(3:LLL),LINE(3:LLL))
              IF(KBD.EQ.1)CALL GMFTEXT(XMI1,YMI1,1,LLL,TP(1))
	     ENDIF
	END

C-----------------------------------------------
	
      SUBROUTINE RWINSET(IDUMMY)
C VIEW WINDOWS SETING
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL WINSET('Actual setting of window 20')
	END

C-----------------------------------------------
	SUBROUTINE RRZOOMI(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RZOOMI(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RZOOMI(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Use mouse to select ZOOM (Left click for lower 
     /left and upper right corner).'')')
           II=SETACTIVEQQ(20)
           II=FOCUSQQ(20)
           CALL GMFSW(1)
           IF(IST20.GT.2)CALL GMFSWC(1,2,XMI,XMA,YMI,YMA)
           CALL GMFLCC(XMI1,YMI1,KBD)
           CALL GMFMRK(XMI1,YMI1,20)
           X8(1)=XMI1
           Y8(1)=YMI1
           X8(2)=XMI1+(XMAF-XMIF)*.1
           Y8(2)=YMI1
           CALL GMFPL(2,X8,Y8,13)
           X8(2)=XMI1
           Y8(2)=YMI1+(YMAF-YMIF)*.1
           CALL GMFPL(2,X8,Y8,13)
           CALL GMFLCC(XMA1,YMA1,KBD)
           CALL GMFMRK(XMA1,YMA1,20)
           IF(KBD.EQ.1)THEN
C GRAPUT ulozi do zony /$PLOT/ nove rozsahy XMI1,...
              CALL GRAPUT(IST20,XMI1,XMA1,YMI1,YMA1)
              CALL GMFSTW(1,1,20,1,16,'X (or axis)','Y (or radius)',
     /0.,1.,0.,1.,XMI1,XMA1,YMI1,YMA1)
              CALL GMFAXE(1,7,15)
              CALL PLOTAL
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRZOOMOUT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RZOOMOUT(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RZOOMOUT(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           II=SETACTIVEQQ(20)
C GRANGE ist20(typ), %dx, %dy
           CALL GRANGE(IST20,10,10,XMI,XMA,YMI,YMA)
           CALL GRAPUT(IST20,XMI,XMA,YMI,YMA)
           CALL GMFSTW(1,1,20,1,16,'X (or axis)','Y (or radius)',
     /0.,1.,0.,1.,XMI,XMA,YMI,YMA)
           CALL GMFAXE(1,7,15)
           CALL PLOTAL
	END

C-----------------------------------------------
	SUBROUTINE RRMAGNIF(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RMAGNIF(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RMAGNIF(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(0,'MAGNIF',IEND)
           SMAG=RP(1)*.5
           IF(IEND.EQ.0.AND.SMAG.GT.0.01)THEN
C RP1- SCALE RP2-SHIFT X RP3-SHIFT Y
             II=SETACTIVEQQ(20)
C GRANGE ist20(typ), %dx, %dy
             IF(XMI.GE.XMA.OR.YMI.GE.YMA)
     /            CALL GRANGE(IST20,10,10,XMI,XMA,YMI,YMA)
             DDX=XMA-XMI
             DDY=YMA-YMI
             XMEAN=(XMI+XMA)/2.-RP(2)*DDX
             YMEAN=(YMI+YMA)/2.-RP(3)*DDY
             XMI=XMEAN-DDX*SMAG
             XMA=XMEAN+DDX*SMAG
             YMI=YMEAN-DDY*SMAG
             YMA=YMEAN+DDY*SMAG
             CALL GRAPUT(IST20,XMI,XMA,YMI,YMA)
             CALL GMFSTW(1,1,20,1,16,'X (or axis)','Y (or radius)',
     /0.,1.,0.,1.,XMI,XMA,YMI,YMA)
             CALL GMFAXE(1,7,15)
             CALL PLOTAL
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRGRIDON(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RGRIDON(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RGRIDON(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(0,'GRIDON',IEND)
C          GRIDON X0,Y0,DX,DY
           IF(IEND.EQ.0)THEN
              II=SETACTIVEQQ(20)
              CALL GMFSWC(1,1,XMI,XMA,YMI,YMA)
              GRIDON=.TRUE.
              GRIDX0=RP(1)
              GRIDY0=RP(2)
              GRIDX=RP(3)
              GRIDY=RP(4)
C Vykresleni mrizky
              DO G=GRIDX0,XMA,GRIDX
                X8(1)=G
                X8(2)=G
                Y8(1)=GRIDY0
                Y8(2)=YMA
                CALL GMFDASH(2,X8,Y8,7,XMA,YMA,40)
              ENDDO
              DO G=GRIDY0,YMA,GRIDY
                Y8(1)=G
                Y8(2)=G
                X8(1)=GRIDX0
                X8(2)=XMA
                CALL GMFDASH(2,X8,Y8,7,XMA,YMA,50)
              ENDDO
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRGRIDOF(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RGRIDOF(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RGRIDOF(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           GRIDON=.FALSE.
           WRITE(10,'('' Grid remains on screen, but is inactive'')')
	END

C-----------------------------------------------
	SUBROUTINE RRMPLIST(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RMPLIST(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RMPLIST(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
		 WRITE(10,'('' Write material properties of elements MPROP int
     /o DBG file.'')')
           CALL DIAP(MMPROP,'FLI',IEND)
           IF(IEND.EQ.0.AND.IP(2).LE.MMPROP.AND.IP(1).GE.1)THEN
             WRITE(9,'(/1X,30(''-''),''MPLIS''/'' MP Funct    VALUE'')')
             DO I=IP(1),IP(2),IP(3)
               DO J=1,MAXNMPROP
                 WRITE(9,'(I3,'':['',I2,'']'',ES10.3,1X,A27)')
     /                    I,JMPROP(I,J),RMPROP(I,J),TMPROP(J)
               ENDDO
             ENDDO
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRRCLIST(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RRCLIST(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RRCLIST(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
		 WRITE(10,'('' Write real parameters of elements RCONST into D
     /BG-file.'')')
           CALL DIAP(MRCONS,'FLI',IEND)
           IF(IEND.EQ.0.AND.IP(2).LE.MRCONS.AND.IP(1).GE.1)THEN
             WRITE(9,'(/1X,30(''-''),''RCLIST''/''  RC   VALUE'')')
             DO I=IP(1),IP(2),IP(3)
               DO J=1,MAXNRCONS
                  WRITE(9,'(I3,'':'',ES10.3,1X,A32)')
     /               I,RRCONS(I,J),TRCONS(J)
               ENDDO
             ENDDO
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RREGLIST(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL REGLIST(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE REGLIST(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
		 WRITE(10,'('' Write integer parameters of elements EGROUP int
     /o DBG-file.'')')
           CALL DIAP(MGROUP,'FLI',IEND)
           IF(IEND.EQ.0.AND.IP(2).LE.MGROUP.AND.IP(1).GE.1)THEN
           WRITE(9,'(/1X,30(''-''),''EGLIST''/'' EG S/T Gss x/r S/S Met 
     /f(p)  NAME'')')
           DO I=IP(1),IP(2),IP(3)
             WRITE(9,'(I3,'':'',I2,5(I4),3X,A)')
     /          I,(JGROUP(I,J),J=2,7),TELEM(MAX0(1,JGROUP(I,1)))
           ENDDO
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRELIST(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RELIST(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RELIST(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
		 WRITE(10,'('' Write element connectivity matrix (nodes of ele
     /ments)'')')
           CALL DIAP(NE,'FLI',IEND)
           IF(IEND.EQ.0.AND.IP(1).GT.0.AND.IP(2).LE.MAXEL)THEN
      WRITE(9,'(/1X,30(''-''),''ELIST''/'' EL   EG RC MP  ND1  ND2  ND3 
     / ND4  ND5  ND6  ND7  ND8  ND9 ND10 ND11 ND12 ND13 ND14 ND15 ND16 N
     /D17 ND18 ND19 ND20'')')
           DO IE=IP(1),IP(2),IP(3)
             NUE=IABS(MUE(IE))
             L0=LUE(IE)
             WRITE(9,'(I5,'':'',I2,2I3,20I5)')IE,IGROUP(IE),
     /            IRCONS(IE),IMPROP(IE),(IUE(L0+K),K=1,NUE)
           ENDDO
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RREPLIST(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL REPLIST(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE REPLIST(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(NE,'EPLIST',IEND)
           IF(IEND.EQ.0.AND.IP(4).GE.1.AND.IP(4).LE.MAXTEPAR)THEN
             WRITE(9,'(1X,30(''-''),''EPLIST''/'' EL'',5X,A8)')
     /            TEPAR(IP(4))
             DO IE=IP(1),IP(2),IP(3)
               NAMELE=JGROUP(IGROUP(IE),$ENAME)
               LPR=LEPAR(NAMELE,IP(4))
               IF(LPR.GT.0)THEN
                  WRITE(9,'(I6,'':'',ES10.3)')IE,EPAR(IE,LPR)
               ELSE
                  WRITE(10,*)' Parameter ',TEPAR(IP(4)),' is not defined
     / in element',IE
               ENDIF
             ENDDO
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRNDLIST(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RNDLIST(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RNDLIST(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
C Vypisuje se jen jeden uzlovy parametr 
C NDL first,last,increment,dof
           CALL DIAP(ND,'NFPLOT',IEND)
           IF(IEND.EQ.0)THEN
           JDDOF=MAX0(1,IP(4))
      WRITE(9,'(/1X,30(''-''),''NDLIST''/'' ND       X        Y'',5X,A4,
     /''1'',5X,A4,''2 STATUS'')')
     /              TDOF(JDDOF),TDOF(JDDOF)
           DO J=IP(1),IP(2),IP(3)
              IND=LPU(JDDOF)+J
              WRITE(9,'(I5,'':'',2ES9.2,2ES10.3,I3)')
     /        J,XX(J),YY(J),VAL(IND,1),VAL(IND,2),IPU(IND)
              DO K=1,ND
                 IF(XX(J).EQ.XX(K).AND.YY(J).EQ.YY(K).AND.ZZ(J).EQ.ZZ(K)
     /           .AND.J.NE.K)WRITE(9,'('' ND'',2I7,'' coincide'')')J,K
              ENDDO
           ENDDO
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRPTLIST(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RPTLIST(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RPTLIST(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
	     WRITE(10,'('' Write list of keypoints PT into DBG-file'')')
           CALL DIAP(NPT,'FLI',IEND)
           IF(IEND.EQ.0.AND.IP(1).GT.0)THEN
           WRITE(9,'(/1X,30(''-''),''PTLIST''/'' PT        X        Y    
     /   Z'')')
           DO J=IP(1),IP(2),IP(3)
              WRITE(9,'(I4,'':'',3ES9.2)')J,PTX(J),PTY(J),PTZ(J)
              DO K=1,NPT
                 IF(PTX(J).EQ.PTX(K).AND.PTY(J).EQ.PTY(K).AND.
     /              PTZ(J).EQ.PTZ(K).AND.J.NE.K)
     /              WRITE(9,'('' PT'',2I4,'' coincide'')')J,K
              ENDDO
           ENDDO
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRSFLIST(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RSFLIST(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RSFLIST(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
	     WRITE(10,'('' Write list of surfaces SF into DBG-file'')')
           CALL DIAP(NSF,'FLI',IEND)
           IF(IEND.EQ.0.AND.IP(1).GT.0)THEN
          WRITE(9,'(/1X,30(''-''),''SFLIST''/''  SF   PT1 PT2 PT3 PT4 pt
     /5 pt6 pt7 pt8'')')
           DO J=IP(1),IP(2),IP(3)
              WRITE(9,'(I4,'': '',8I4)')J,(ISF(K,J),K=1,MSF(J))
           ENDDO
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRVLLIST(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RVLLIST(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RVLLIST(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
	     WRITE(10,'('' Write list of volumes VL into DBG-file'')')
           CALL DIAP(NVL,'FLI',IEND)
           IF(IEND.EQ.0.AND.IP(1).GT.0)THEN
          WRITE(9,'(/1X,30(''-''),''VLLIST''/''  VL   pt1 pt2 pt3 pt4 pt
     /5 pt6 pt7 pt8'')')
           DO J=IP(1),IP(2),IP(3)
              WRITE(9,'(I4,'': '',20I4)')J,(IVL(K,J),K=1,MVL(J))
           ENDDO
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRCRLIST(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RCRLIST(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RCRLIST(IDUMMY)
C LIST CURVES
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
	     WRITE(10,'('' Write list of curves CR into DBG-file'')')
           CALL DIAP(NCR,'FLI',IEND)
           IF(IEND.EQ.0.AND.IP(1).GT.0)THEN
           WRITE(9,'(/1X,30(''-''),''CRLIS''/'' CR     L[m]     PT1  PT2
     /  pt3'')')
           RL=0.
           DO J=IP(1),IP(2),IP(3)
              CALL CURLEN(J,HL)
              WRITE(9,'(I4,ES10.3,'':'',3I5)')J,HL,(ICR(K,J),K=1,MCR(J))
              RL=RL+HL
           ENDDO
           WRITE(9,'('' Total length of curves='',E10.3,'' [m]'')')RL
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRCTLIST(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RCTLIST(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RCTLIST(IDUMMY)
C LIST CONTOURS
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(9,'(/1X,30(''-''),''CONTOURS''/'' CT   CR1  CR2...'')')
           DO J=1,NCONTOUR
             WRITE(9,'(I4,'':'',50I5)')J,(ICONTOUR(K,J),K=1,MCONTOUR(J))
           ENDDO
	END

C-----------------------------------------------
	SUBROUTINE RRNCT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RNCT(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RNCT(IDUMMY)
C NUMBER OF CONTOURS
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' No.of contours is'',i2,''. Define new number of
     / contours:'')')NCONTOUR
           READ(10,*,IOSTAT=IRETURN)NCONTOUR
	END

C-----------------------------------------------
	SUBROUTINE RRPTIN(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RPTIN(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RPTIN(IDUMMY)
C POINT INSIDE A REGION?
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Region defined by'',i2,'' contours. Specify POI
     /NT X,Y by mouse (R-click quit).'')')NCONTOUR
	  KBD=0
        DO WHILE(KBD.NE.2)
	     II=SETACTIVEQQ(20)
	     II=FOCUSQQ(20)
           CALL GMFLCC(X,Y,KBD)
           CALL PTCTIN(X,Y,PTX,PTY,NPT,ICR,MCR,NCR,
     /                  ICONTOUR,MCONTOUR,NCONTOUR,IN)
	     CALL GMFMRKS(X,Y,41+IN)
           WRITE(10,'('' POINT is '',I3,'' [1=INSIDE,0=OUTSIDE,-1=BOUNDA
     /RY] R-click quit.'')')IN
	  ENDDO
	END

C-----------------------------------------------
	SUBROUTINE RRNFLIST(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RNFLIST(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RNFLIST(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Fixed/loaded DOF (nodal parameter) list.'')')
           CALL DIAP(ND,'FLI',IEND)
           IF(IEND.EQ.0.AND.IP(1).GT.0)THEN
           WRITE(9,'(/1X,30(''-''),''NFLIST''/'' ND  PAR  FUN  VALUE(B.C
     /.)'')')
           DO J=IP(1),IP(2),IP(3)
             DO K=1,MDOF
               LOC=MAXND*(K-1)+J
               IF(IPU(LOC).NE.0)
     /            WRITE(9,'(I4,1X,A4,I5.2,'':'',ES10.3)')
     /               J,TDOF(JPU(K)),IPU(LOC),VAL(LOC,1)
             ENDDO
           ENDDO
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRDOFLIST(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RDOFLIST(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RDOFLIST(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(IZONE,'DOFLIS',IEND)
           IF(IEND.EQ.0.AND.IP(1).GT.0.AND.IP(1).LE.4)THEN
             IZONE=IP(1)
             CALL RANGE(IZONE)
             WRITE(9,'(/1X,30(''-''),''DOFLIST''/'' VARIABLE MIN MAX zon
     /e '',I2)')IZONE
             DO I=1,MAXTDOF
              IF(DOFMIN(I).LT.DOFMAX(I))WRITE(9,'(1X,A4,'':'',3ES10.3)')
     /             TDOF(I),DOFMIN(I),DOFMAX(I),DOFMEAN(I)
             ENDDO
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRCURLIST(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RCURLIST(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RCURLIST(IDUMMY)
C UDF DEFINED BY TABLE LIST
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(9,'(/1X,30(''-''),''CURLIS''/'' Index Typ NPT'')')
           DO J=MIFUN,MAFUN
              IF(INDFUN(J).LT.0)THEN
                 IFF=-INDFUN(J)
                 WRITE(9,'(3I6)')J,KTABLE(IFF),MTPT(IFF)
                 WRITE(9,'('' point       X        Y'')')
                 WRITE(9,'(I6,2ES10.3)')
     /                 (I,XTAB(I,IFF),YTAB(I,IFF),I=1,MTPT(IFF))
              ENDIF
           ENDDO
	END

C-----------------------------------------------
	SUBROUTINE RRFUNLIST(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RFUNLIST(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RFUNLIST(IDUMMY)
C UDF LIST
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(9,'(/1X,30(''-''),''FUNLIS''/'' Index  RPN  Function'')
     /')
           NUMF=0
           NUMT=0
           DO J=MIFUN,MAFUN
              IFF=INDFUN(J)
              IF(IFF.GT.0)THEN
                 WRITE(9,'(2I6,'' : '',A)')
     /                J,MRPN(IFF),FUNTXT(IFF)
                 NUMF=NUMF+1
              ELSEIF(IFF.LT.0)THEN
                 WRITE(9,'(2I6,''-points table'')')J,MTPT(-IFF)
                 NUMT=NUMT+1
              ENDIF
           ENDDO
           IF(NUMT+NUMF.EQ.0)
     /WRITE(10,'('' Functions or tables have not been defined'') ')
           IF(NUMF.GT.0)WRITE(10,'(I3,'' functions are defined by Revers
     /e Polish Notation (code length see table)'')')NUMF
           IF(NUMT.GT.0)WRITE(10,'(I3,'' functions are defined as tables
     / (number of points see table)'')')NUMT
	END

C-----------------------------------------------
	SUBROUTINE RRCHECK(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RCHECK(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RCHECK(IDUMMY)
C CL
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL CHECK(IERR,9,10,IOBR)
           CALL OBR(IOBR)
	END

C-----------------------------------------------
	SUBROUTINE RRVARLIST(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RVARLIST(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RVARLIST(IDUMMY)
C VARABLES LISTING
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
	INCLUDE '$TRANDAT'
      IDUMLOC=IDUMMY
           CALL DIAP(1,'VARL',IEND)
           IF(IEND.EQ.0.AND.IP(1).EQ.0)THEN
      WRITE(9,'(/1X,30(''-''),''VARLIS''/'' NAME[1-Real,2-Int,3-Real vec
     /,4-Int vec,5-Fun]''/)')    
              CALL SORTNUM(NVARSYS,NAME,NSORT)
      WRITE(9,'('' System variables='',i3/(5(1X,A5,''['',I1,'']'')))')
     /NVARSYS,(TRIM(NAME(NSORT(I))),IATTR(2,NSORT(I)),I=1,NVARSYS)
              IF(NVARTOT.GT.NVARSYS)
     /WRITE(9,'('' User variables='',i3/(4(1X,A6,''['',I1,'']'')))')
     /NVARTOT-NVARSYS,(TRIM(NAME(I)),IATTR(2,I),I=NVARSYS+1,NVARTOT)
      WRITE(9,'('' -----------use LOC variable for more details'')')
           ELSEIF(IEND.EQ.0)THEN
              WRITE(9,'(/'' Important items in /FEM/ '')')
              CALL SORTNUM(NVARSYS,NAME,NSORT)
              OPEN(88,FILE='$IDELIST')
              DO II=1,NVARSYS
                 CALL VARHELP(NSORT(II),TXTV,LOC)
                 WRITE(9,'('' Identifier'',2X,A8,'' is ''\)')TRIM(TXTV)
                 SELECT CASE(IATTR(2,NSORT(II)))
                 CASE(1)
                    WRITE(9,'(''simple variable REAL'')')
                    WRITE(88,'('' R  '',A8\)')TRIM(TXTV)
                 CASE(2)
                    WRITE(9,'(''simple variable INTEGER'')')
                    WRITE(88,'('' I  '',A8\)')TRIM(TXTV)
                 CASE(3)
                    WRITE(9,'(''vector REAL'')')
                    WRITE(88,'('' V  '',A8\)')TRIM(TXTV)
                 CASE(4)
                    WRITE(9,'(''vector INTEGER'')')
                    WRITE(88,'('' L  '',A8\)')TRIM(TXTV)
                 CASE(5)
                    WRITE(9,'(''function'')')
                    WRITE(88,'('' F  '',A8\)')TRIM(TXTV)
                 ENDSELECT
                 IF(LOC.GT.0)THEN
                    CALL FEMHELP(LOC,TXTV,IENDH)
                    IF(IENDH.EQ.1)THEN
                       WRITE(9,'('' :'',A)')TRIM(TXTV)
                       WRITE(88,'('':'',A\)')TRIM(TXTV)
                    ENDIF
                 ENDIF
                 WRITE(88,'(''   '')')
              ENDDO
              CLOSE(88)
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRDETDEF(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RDETDEF(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RDETDEF(IDUMMY)
C DETECTOR DEFINE
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'DETDEF',IEND)
           IF(IEND.EQ.0) CALL WRITEL('DETDEF')
	END

C-----------------------------------------------
	SUBROUTINE RRDETDOF(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RDETDOF(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RDETDOF(IDUMMY)
C DETECTOR RESPONSE INTERPOLATING DOF
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'DETDOF',IEND)
           IF(IEND.EQ.0) CALL WRITEL('DETDOF')
	END

C-----------------------------------------------
	SUBROUTINE RRDETFUN(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RDETFUN(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RDETFUN(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'DETFUN',IEND)
           IF(IEND.EQ.0) CALL WRITEL('DETFUN')
	END

C-----------------------------------------------
	SUBROUTINE RRNODE(IDUMMY)
C Generovani uzlu mysi
	LOGICAL IDUMMY
	CALL MENSET
	CALL RNODE(IDUMMY)
	CALL MENEND
	END
	
	
	SUBROUTINE RNODE(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'ND',IEND)
           IF(IEND.EQ.0)THEN
             IND=MIN0(ND+1,MAXND)
             II=SETACTIVEQQ(20)
             CALL GMFSW(1)
             IF(LAST.LT.1)THEN
                PX=XMI
                PY=YMI
                KBD=1
                DO WHILE(KBD.EQ.1.AND.IND.LE.MAXND)
                  II=FOCUSQQ(20)
                  CALL GMFLCC(PX,PY,KBD)
                  IF(KBD.EQ.1)THEN
                    IF(GRIDON)THEN
                      PX=GRIDX0+INT((PX-GRIDX0)/GRIDX+.5)*GRIDX
                      PY=GRIDY0+INT((PY-GRIDY0)/GRIDY+.5)*GRIDY
                    ENDIF
                    WRITE(TP(1),'(E10.3)')PX
                    WRITE(TP(2),'(E10.3)')PY
                    TP(3)=''
                    CALL WRITEL('ND')
                    IND=IND+1
                  ENDIF
                ENDDO
             ELSE
                CALL WRITEL('ND')
             ENDIF
             ND$=1
           ENDIF
      END

C-----------------------------------------------
	SUBROUTINE RRCRS(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RCRS(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RCRS(IDUMMY)
C Generovani lomene cary mysi (crspoly)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
	DIMENSION ICRC(50)
      IDUMLOC=IDUMMY
           CALL DIAP(NPT+1,'CRSPOL',IEND)
c crspoly pt1,cr1
           IND=IP(1)
           ICU=IP(2)-1
           ICONTO=IP(3)
	     NCONTO=0
           IF(IEND.EQ.0.AND.IND.GT.0.AND.ICU.GE.0)THEN
             II=SETACTIVEQQ(20)
             CALL GMFSW(1)
             PX=XMI
             PY=YMI
             DX=AMAX1(.01,ABS(XMA-XMI))
             DY=AMAX1(.01,ABS(YMA-YMI))
             KBD=1
             FIRST=.TRUE.
             DO WHILE((KBD.EQ.1.OR.KBD.EQ.5.OR.KBD.EQ.9).AND.
     /                (IND.LE.MAXPT.AND.ICU.LE.MAXCR))
               II=FOCUSQQ(20)
               CALL GMFLCC(PX,PY,KBD)
               IF(KBD.EQ.1.OR.KBD.EQ.5.OR.KBD.EQ.9)THEN
                 IF(GRIDON)THEN
                   PX=GRIDX0+INT((PX-GRIDX0)/GRIDX+.5)*GRIDX
                   PY=GRIDY0+INT((PY-GRIDY0)/GRIDY+.5)*GRIDY
                 ENDIF
                 TOL2=$RTOL**2
                 DO I=1,NPT
                   IF(((PX-PTX(I))/DX)**2+((PY-PTY(I))/DY)**2.LE.TOL2)
     /               THEN
                      PX=PTX(I)
                      PY=PTY(I)
                   ENDIF
                 ENDDO
                 WRITE(TP(1),'(I4)')IND
                 WRITE(TP(2),'(E10.3)')PX
                 WRITE(TP(3),'(E10.3)')PY
                 TP(4)=''
                 CALL WRITEL('PT')
                 IND=IND+1
               ENDIF
               IF(.NOT.FIRST.AND.KBD.EQ.1)THEN
                 ICU=MIN0(ICU+1,MAXCR)
                 NCR=MAX0(NCR,ICU)
                 WRITE(TP(1),'(I4)')ICU
	           IF(NCONTO.LT.50)THEN
	              NCONTO=NCONTO+1
	              ICRC(NCONTO)=ICU
	           ENDIF
                 IF(LASTKBD.EQ.1)THEN
C usecka
                    WRITE(TP(2),'(I4)')IND-2
                    WRITE(TP(3),'(I4)')IND-1
                    TP(4)=''
                    CALL WRITEL('CR2PT')
                 ELSE
C krivka
                    WRITE(TP(2),'(I4)')IND-3
                    WRITE(TP(3),'(I4)')IND-1
                    WRITE(TP(4),'(I4)')IND-2
                    TP(5)=''
                    CALL WRITEL('CR3PT')
                 ENDIF
               ENDIF
               LASTKBD=KBD
               FIRST=.FALSE.
             ENDDO
             PT$=1
	       IF(ICONTO.GT.0.AND.ICONTO.LE.MAXCT)THEN
	          WRITE(TP(1),'(I4)')ICONTO
	          WRITE(TP(2),'(I4)')NCONTO
	          DO I=1,NCONTO
	             WRITE(TP(I+2),'(I4)')ICRC(I)
	          ENDDO
	          CALL WRITEL('CTR')
	       ENDIF
           ENDIF
      END

C-----------------------------------------------
	SUBROUTINE RRPTXYZ(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RPTXYZ(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RPTXYZ(IDUMMY)
C menu PT - zadani vztazneho bodu X,Y,Z jen z klavesnice
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(NPT+1,'PTXYZ',IEND)
           IF(IEND.EQ.0) CALL WRITEL('PTXYZ')
      END


C-----------------------------------------------
	SUBROUTINE RRPT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RPT(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RPT(IDUMMY)
C menu PT - zadani vztazneho bodu (bud z radky nebo mysi)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(NPT+1,'PT',IEND)
           IF(IEND.EQ.0)THEN
           IND=IP(1)
           II=SETACTIVEQQ(20)
C           CALL GMFSW(1)
           CALL GMFSWC(1,1,XMI,XMA,YMI,YMA)
           IF(IND.GT.0)THEN
             IF(LAST.LT.2)THEN
                PX=XMI
                PY=YMI
                DX=AMAX1(0.01,ABS(XMA-XMI))
                DY=AMAX1(0.01,ABS(YMA-YMI))
                KBD=1
                DO WHILE(KBD.EQ.1.AND.IND.LE.MAXPT)
                  II=FOCUSQQ(20)
200               CALL GMFLCC(PX,PY,KBD)
                  IF(KBD.EQ.1)THEN
                    IF(GRIDON)THEN
                      PX=GRIDX0+INT((PX-GRIDX0)/GRIDX+.5)*GRIDX
                      PY=GRIDY0+INT((PY-GRIDY0)/GRIDY+.5)*GRIDY
                    ENDIF
                    TOL2=$RTOL**2
                    DO I=1,NPT
                      IF(((PX-PTX(I))/DX)**2+((PY-PTY(I))/DY)**2.LE.
     /                     TOL2)GOTO 200
                    ENDDO
                    WRITE(TP(1),'(I4)')IND
                    WRITE(TP(2),'(E10.3)')PX
                    WRITE(TP(3),'(E10.3)')PY
                    CALL WRITEL('PT')
                    IND=IND+1
                  ENDIF
                ENDDO
             ELSE
                CALL WRITEL('PT')
             ENDIF
             PT$=1
           ENDIF
           ENDIF
           II=FOCUSQQ(10)
      END

C-----------------------------------------------
	SUBROUTINE RRCR2PT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RCR2PT(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RCR2PT(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NPT.LE.1)CALL HELPC(4,'Define points first using PT')
           CALL DIAP(NCR+1,'CR2PT',IEND)
           IF(IEND.EQ.0) CALL WRITEL('CR2PT')
	END

C-----------------------------------------------
	SUBROUTINE RRCR3PT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RCR3PT(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RCR3PT(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NPT.LE.2)CALL HELPC(4,'Define points first using PT')
           CALL DIAP(NCR+1,'CR3PT',IEND)
           IF(IEND.EQ.0) CALL WRITEL('CR3PT')
	END

C-----------------------------------------------
	SUBROUTINE RRCRNPT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RCRNPT(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RCRNPT(IDUMMY)
C POLYLINE fro defined points PT
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NPT.LE.2)CALL HELPC(4,'Define points first using PT')
           CALL DIAP(NCR+1,'CRNPT',IEND)
           IF(IEND.EQ.0) CALL WRITEL('CRNPT')
	END

C-----------------------------------------------
	SUBROUTINE RRCIRCLE(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RCIRCLE(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RCIRCLE(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NPT.LE.1)CALL HELPC(4,'Define points first using PT')
           CALL DIAP(NCR+1,'CIRCLE',IEND)
           IF(IEND.EQ.0) CALL WRITEL('CIRCLE')
	END

C-----------------------------------------------
	SUBROUTINE RRARC(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RARC(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RARC(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NPT.LE.1)CALL HELPC(4,'Define points first using PT')
           CALL DIAP(NCR+1,'ARC',IEND)
           IF(IEND.EQ.0) CALL WRITEL('ARC')
	END

C-----------------------------------------------
	SUBROUTINE RRSF4PT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RSF4PT(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RSF4PT(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NPT.LE.3)CALL HELPC(4,'Define points first using PT')
           CALL DIAP(NSF+1,'SF4PT',IEND)
           IF(IEND.EQ.0) CALL WRITEL('SF4PT')
	END

C-----------------------------------------------
	SUBROUTINE RRSF8PT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RSF8PT(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RSF8PT(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NPT.LE.7)CALL HELPC(4,'Define points first using PT')
           CALL DIAP(NSF+1,'SF8PT',IEND)
           IF(IEND.EQ.0) CALL WRITEL('SF8PT')
	END

C-----------------------------------------------
	SUBROUTINE RRSF3PT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RSF3PT(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RSF3PT(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NPT.LE.2)CALL HELPC(4,'Define points first using PT')
           CALL DIAP(NSF+1,'SF3PT',IEND)
           IF(IEND.EQ.0) CALL WRITEL('SF3PT')
	END

C-----------------------------------------------
	SUBROUTINE RRSF6PT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RSF6PT(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RSF6PT(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NPT.LE.5)CALL HELPC(4,'Define points first using PT')
           CALL DIAP(NSF+1,'SF6PT',IEND)
           IF(IEND.EQ.0) CALL WRITEL('SF6PT')
	END

C-----------------------------------------------
	SUBROUTINE RRSFCR(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RSFCR(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RSFCR(IDUMMY)
C
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NCR.LE.3)CALL HELPC(4,'Define curves using C2P or C3P')
           CALL DIAP(NSF+1,'SFCR',IEND)
           IF(IEND.EQ.0) CALL WRITEL('SFCR')
	END

C-----------------------------------------------
	SUBROUTINE RRPTCR2(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RPTCR2(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RPTCR2(IDUMMY)
C Bod jako prusecik dvou krivek
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NCR.LE.1)CALL HELPC(4,'Define curves using C2P or C3P')
           CALL DIAP(NCR,'PTCR2',IEND)
           IF(IEND.EQ.0) CALL WRITEL('PTCR2')
	END

C-----------------------------------------------
	SUBROUTINE RRVL8PT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RVL8PT(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RVL8PT(IDUMMY)
C Volume by 8/20 points
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NPT.LE.7)CALL HELPC(4,'Define points first using PT')
           CALL DIAP(NVL+1,'VL8PT',IEND)
           IF(IEND.EQ.0) CALL WRITEL('VL8PT')
	END

C-----------------------------------------------
	SUBROUTINE RRSFEXTR(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RSFEXTR(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RSFEXTR(IDUMMY)
C Volume by extrusion of surface
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NSF.LE.0)CALL HELPC(4,'Define surface using SnP, SFCR')
           CALL DIAP(NVL+1,'SFEXTR',IEND)
           IF(IEND.EQ.0) CALL WRITEL('SFEXTR')
	END

C-----------------------------------------------
	SUBROUTINE RRVLSF(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RVLSF(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RVLSF(IDUMMY)
C Volume from 2 surfaces
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NSF.LT.2)CALL HELPC(4,'Define surfaces using SnP, SFCR')
           CALL DIAP(NVL+1,'VLSF',IEND)
           IF(IEND.EQ.0) CALL WRITEL('VLSF')
	END

C-----------------------------------------------
	SUBROUTINE RRCTR(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RCTR(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RCTR(IDUMMY)
C define contour
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
CTI     interactive definition of countour
           IF(NCR.LE.0)CALL HELPC(4,'Define curves using C2P or C3P')
           CALL DIAP(NCONTOUR+1,'CTR',IEND)
           IF(IEND.EQ.0.AND.IP(1).GT.0.AND.IP(1).LE.MAXCT)THEN
             IND=IP(1)
             IF(LAST.LT.2)THEN
               II=SETACTIVEQQ(20)
               CALL GMFSWC(1,1,XMI,XMA,YMI,YMA)
               N=0
               KBD=1
               DO WHILE(KBD.EQ.1.AND.N.LE.20)
                 II=FOCUSQQ(20)
                 CALL CIDENT(JMI,KBD)
                 IF(KBD.EQ.1.AND.JMI.GT.0.AND.JMI.LE.NCR)THEN
C Zkontroluj navaznost
                    IF(N.GE.1)THEN
	                 ICPREV=IP(N+2)
	                 ICNEW=JMI
	                 IPREV=ICR(2,ICPREV)
	                 INEW=ICR(1,ICNEW)
	                 INEW2=ICR(2,ICNEW)
	                 IF(IPREV.NE.INEW)THEN
C Zmena orientace NOVE krivky
                          IF(IPREV.EQ.INEW2)THEN
                             ICR(1,ICNEW)=INEW2
	                       ICR(2,ICNEW)=INEW
	                       WRITE(10,'('' Orientation of curve'',i3,'' 
     /had to be changed'')')ICNEW
	                    ELSE
	                       WRITE(10,'('' Continuation dissrupted.''/''
     /    Previous curve'',i3,'' (end point'',i3,'')''/''    New curve''
     /,I3,'' (starting point'',i3,'')''/''    Use Ctr+Lclick or Shift+Lc
     /lick to select hidden curve'')')ICPREV,IPREV,JMI,INEW
                             CYCLE
	                    ENDIF
	                 ENDIF
	              ENDIF
                    N=N+1
                    IP(N+2)=JMI
                    WRITE(TP(N+2),'(I4)')JMI
                    WRITE(10,'('' Curve'',i3,'' included.'')')JMI	     
                 ENDIF
               ENDDO
               WRITE(TP(1),'(I4)')IND
               WRITE(TP(2),'(I4)')N
             ENDIF
             CALL WRITEL('CTR')
           ENDIF      
	END

C-----------------------------------------------
	SUBROUTINE RRCRN(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RCRN(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RCRN(IDUMMY)
C Define division of curve
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NCR.LE.0)CALL HELPC(4,'Define curves using C2P or C3P')
           CALL DIAP(NCREDIT+1,'CRN',IEND)
           IF(IEND.EQ.0)THEN
              NCREDIT=IP(1)
              CALL WRITEL('CRN')
           ENDIF
	END

C-----------------------------------------------
	SUBROUTINE RRMP(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RMP(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RMP(IDUMMY)
C MPROP
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(MIN0(MAXMMPROP,MMPROP+1),'MPROP',IEND)
           IF(IEND.EQ.0) CALL WRITEL('MPROP')
	END

C-----------------------------------------------
	SUBROUTINE RREG(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL REG(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE REG(IDUMMY)
C EGroup
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(MIN0(MAXMGROUP,MGROUP+1),'EGROUP',IEND)
           IF(IEND.EQ.0) CALL WRITEL('EGROUP')
	END

C-----------------------------------------------
	SUBROUTINE RRRC(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RRC(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RRC(IDUMMY)
C RConst
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(MIN0(MAXMRCONS,MRCONS+1),'RCONST',IEND)
           IF(IEND.EQ.0) CALL WRITEL('RCONST')
	END

C-----------------------------------------------
	SUBROUTINE RRRCPUMP(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RRCPUMP(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RRCPUMP(IDUMMY)
C RC for a new pump from database
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'RCPUMP',IEND)
           IF(IEND.EQ.0) CALL WRITEL('RCPUMP')
	END

C-----------------------------------------------
	SUBROUTINE RRRCEPUM(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RRCEPUM(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RRCEPUM(IDUMMY)
C RC for existing pump from database (picking by mouse)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'RCEPUM',IEND)
           IF(IEND.EQ.0) CALL WRITEL('RCEPUM')
	END

C-----------------------------------------------
	SUBROUTINE RRRCHEX(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RRCHEX(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RRCHEX(IDUMMY)
C RC for a general heat exchanger
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(MIN0(MAXMRCONS,MRCONS+1),'RCHEX',IEND)
           IF(IEND.EQ.0) CALL WRITEL('RCHEX')
	END

C-----------------------------------------------
	SUBROUTINE RRRCHEV(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RRCHEV(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RRCHEV(IDUMMY)
C RC for a new chevron heat exchanger
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(NE,'RCHEV',IEND)
           IF(IEND.EQ.0) CALL WRITEL('RCHEV')
	END

C-----------------------------------------------
	SUBROUTINE RRRCEHEV(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RRCEHEV(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RRCEHEV(IDUMMY)
C RC for an existing chevron heat exchanger (selected by mouse)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(NE,'RCEHEV',IEND)
           IF(IEND.EQ.0) CALL WRITEL('RCEHEV')
	END

C-----------------------------------------------
	SUBROUTINE RRRCSTUB(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RRCSTUB(IDUMMY)
	CALL MENEND
	END
	
      SUBROUTINE RRCSTUB(IDUMMY)
C RC for a new shell and tube HE
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(NE,'RCSTUB',IEND)
           IF(IEND.EQ.0) CALL WRITEL('RCSTUB')
	END

C --------------------------------------------------------------
	SUBROUTINE RRRCESTU(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RRCESTU(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RRCESTU(IDUMMY)
C RC shell and tube HE for existing element
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(NE,'RCESTU',IEND)
           IF(IEND.EQ.0) CALL WRITEL('RCESTU')
	END

C --------------------------------------------------------------
	SUBROUTINE RRRCSTH(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RRCSTH(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RRCSTH(IDUMMY)
C RC new helical shell and tube
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(NE,'RCSTH ',IEND)
           IF(IEND.EQ.0) CALL WRITEL('RCSTH ')
	END

C --------------------------------------------------------------
	SUBROUTINE RRRCESTH(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RRCESTH(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RRCESTH(IDUMMY)
C RC existing helical shell and tube
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(NE,'RCESTH',IEND)
           IF(IEND.EQ.0) CALL WRITEL('RCESTH')
	END

C --------------------------------------------------------------
	SUBROUTINE RRRCROSS(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RRCROSS(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RRCROSS(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(MRCONS,'RCROSS',IEND)
           IF(IEND.EQ.0) CALL WRITEL('RCROSS')
	END

C --------------------------------------------------------------
	SUBROUTINE RRFUNDEF(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RFUNDEF(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RFUNDEF(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'FUNDEF',IEND)
           IF(IEND.EQ.0) CALL WRITEL('FUNDEF')
	END

C --------------------------------------------------------------
	SUBROUTINE RRCURDEF   (IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RCURDEF(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RCURDEF(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'CURDEF',IEND)
           IF(IEND.EQ.0) CALL WRITEL('CURDEF')
	END

C --------------------------------------------------------------
	SUBROUTINE RRINTGCR(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RINTGCR(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RINTGCR(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'INTGCR',IEND)
           IF(IEND.EQ.0) CALL WRITEL('INTGCR')
	END

C --------------------------------------------------------------
	SUBROUTINE RRINTGSF(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RINTGSF(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RINTGSF(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'INTGSF',IEND)
           IF(IEND.EQ.0) CALL WRITEL('INTGSF')
	END

C --------------------------------------------------------------
	SUBROUTINE RRINTGEL(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RINTGEL(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RINTGEL(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'INTEL',IEND)
           IF(IEND.EQ.0) CALL WRITEL('INTEL')
	END

C --------------------------------------------------------------
	SUBROUTINE RRELEMENT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RELEMENT(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RELEMENT(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
CMESH      E no.of nodes, n1,n2,..
           IF(ND.LE.0)CALL HELPC(4,'Create nodes using ND,MCR,...')
           CALL DIAP(4,'E',IEND)
           IF(IEND.EQ.0) CALL WRITEL('E')
	END

C --------------------------------------------------------------
	SUBROUTINE RRMVL(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RMVL(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RMVL(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NVL.LE.0)CALL HELPC(4,'Define volume using V8P or SFEXTR')
           CALL DIAP(MIN0(NVL,INDV+1),'MVL',IEND)
           INDV=IP(1)
           IF(IEND.EQ.0) CALL WRITEL('MVL')
	END

C --------------------------------------------------------------
	SUBROUTINE RRMSF(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RMSF(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RMSF(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NSF.LE.0)CALL HELPC(4,'Define surface using S4P or S8P')
           CALL DIAP(MIN0(NSF,INDS+1),'MSF',IEND)
           INDS=IP(1)
           IF(IEND.EQ.0) CALL WRITEL('MSF')
	END

C --------------------------------------------------------------
	SUBROUTINE RRMCT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RMCT(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RMCT(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NCONTOUR.LE.0)CALL HELPC(4,'Define CONTOUR')
           CALL DIAP(1,'MCT',IEND)
           IF(IEND.EQ.0) CALL WRITEL('MCT')
	END

C --------------------------------------------------------------
	SUBROUTINE RRMRG(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RMRG(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RMRG(IDUMMY)
C MESH REGION
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NCONTOUR.LE.0)CALL HELPC(4,'Define CONTOUR')
           CALL DIAP(1,'MRG',IEND)
           IF(IEND.EQ.0) CALL WRITEL('MRG')
	END

C --------------------------------------------------------------
	SUBROUTINE RRMPT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RMPT(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RMPT(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NPT.LE.2)CALL HELPC(4,'Define points using PT')
           CALL DIAP(1,'MPT',IEND)
           IF(IEND.EQ.0) CALL WRITEL('MPT')
	END

C --------------------------------------------------------------
	SUBROUTINE RRMND(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RMND(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RMND(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(ND.LE.2)CALL HELPC(4,'Define nodes using READ or N')
           CALL DIAP(1,'MND',IEND)
           IF(IEND.EQ.0) CALL WRITEL('MND')
	END

C --------------------------------------------------------------
	SUBROUTINE RRMCR(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RMCR(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RMCR(IDUMMY)
C MESH CURVE
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NCR.LE.0)CALL HELPC(4,'Define curve using C2P,C3P')
           CALL DIAP(MIN0(NCR,INDC+1),'MCR',IEND)
           INDC=IP(1)
           IF(IEND.EQ.0) CALL WRITEL('MCR')
	END

C --------------------------------------------------------------
	SUBROUTINE RRMCR24(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RMCR24(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RMCR24(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NCR.LE.0)CALL HELPC(4,'Define curve using C2P,C3P')
CMESH      ELEMENTY TYPU VYMENIK PIPE(2)+HEX(4)
CMESH      MCR2 IC1,IC2,NX,MP1,MP2,RC1,RC2,RCHEX,IGPIPE,IGHEXC
           CALL DIAP(MIN0(NCR,INDC+1),'MCR2',IEND)
           INDC=IP(1)
           IF(IEND.EQ.0) CALL WRITEL('MCR2')
	END

C --------------------------------------------------------------
	SUBROUTINE RRMCR4(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RMCR4(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RMCR4(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NE.LE.1)CALL HELPC(4,'Define elements using MCR')
CMESH      ELEMENTY TYPU VYMENIK PRO JIZ VYGENEROVANE ELEMENTY PIPE
CMESH      MCR4 IC1,IC2,RCHEX,IGHEX
           CALL DIAP(MIN0(NCR,INDC+1),'MCR4',IEND)
           INDC=IP(1)
           IF(IEND.EQ.0) CALL WRITEL('MCR4')
	END

C --------------------------------------------------------------
	SUBROUTINE RRPARTIC(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RPARTIC(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RPARTIC(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NPT.LE.0)CALL HELPC(4,'Define points using PT')
           CALL DIAP(NPART,'PPT',IEND)
           IF(IEND.EQ.0) CALL WRITEL('PPT')
	END

C --------------------------------------------------------------
	SUBROUTINE RRPARDEL(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RPARDEL(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RPARDEL(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(NPART,'PARDEL',IEND)
           IF(IEND.EQ.0) CALL WRITEL('PARDEL')
	END

C --------------------------------------------------------------
	SUBROUTINE RRATTACH(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RATTACH(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RATTACH(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(ND.LE.0)CALL HELPC(4,'Create mesh using MCR,MSF,MVL')
           CALL DIAP(NSF,'ATTACH',IEND)
           IF(IEND.EQ.0) CALL WRITEL('ATTACH')
	END


C --------------------------------------------------------------
	SUBROUTINE RRNMERGE(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RNMERGE(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RNMERGE(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(ND.LE.0)CALL HELPC(4,'Create mesh using MCR,MSF,MVL')
           CALL WRITEL('NMERGE')
	END

C --------------------------------------------------------------
	SUBROUTINE RRNMERGS(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RNMERGS(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RNMERGS(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(ND.LE.0)CALL HELPC(4,'Create mesh using MCR,MSF,MVL')
           CALL DIAP(1,'NMERGS',IEND)
           IF(IEND.EQ.0) CALL WRITEL('NMERGS')
	END

C --------------------------------------------------------------
	SUBROUTINE RRPMERGE(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RPMERGE(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RPMERGE(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL WRITEL('PMERGE')
	END

C --------------------------------------------------------------
	SUBROUTINE RRERMSF(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RERMSF(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RERMSF(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(MIN0(NSF,INDS),'ERMSF',IEND)
           INDS=IP(1)
           IF(IEND.EQ.0) CALL WRITEL('ERMSF')
	END

C --------------------------------------------------------------
	SUBROUTINE RRERMOD(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RERMOD(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RERMOD(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(0,'ERMOD',IEND)
           IF(IEND.EQ.0) CALL WRITEL('ERMOD')
	END

C --------------------------------------------------------------
	SUBROUTINE RRERMEL(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RERMEL(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RERMEL(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(0,'ERMEL',IEND)
           IF(IEND.EQ.0) CALL WRITEL('ERMEL')
	END

C --------------------------------------------------------------
	SUBROUTINE RRNFCR(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RNFCR(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RNFCR(IDUMMY)
C NODAL FORCE ON CURVE
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NCR.LE.0)CALL HELPC(4,'Define curve using C2P,C3P')
           IF(ND.LE.0)CALL HELPC(4,'Create mesh using MCR,...')
           CALL DIAP(MIN0(NCR,INDC),'NFCR',IEND)
           INDC=IP(1)
           IF(IEND.EQ.0) CALL WRITEL('NFCR')
	END


C --------------------------------------------------------------
	SUBROUTINE RRNFCT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RNFCT(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RNFCT(IDUMMY)
C NODAL FORCE ON CONTOUR
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NCONTOUR.LE.0)CALL HELPC(4,'Define contour using CT')
           IF(NCR.LE.0)CALL HELPC(4,'Define curve using C2P,C3P')
           IF(ND.LE.0)CALL HELPC(4,'Create mesh using MCR,...')
           CALL DIAP(MIN0(NCONTOUR,INDC),'NFCT',IEND)
           INDC=IP(1)
           IF(IEND.EQ.0) CALL WRITEL('NFCT')
	END

C --------------------------------------------------------------
	SUBROUTINE RRNFSF(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RNFSF(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RNFSF(IDUMMY)
C NODAL FORCE ON SURFACE
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NSF.LE.0)CALL HELPC(4,'Define surface using S4P,SFCR,...')
           IF(ND.LE.0)CALL HELPC(4,'Create mesh using MCR,...')
           CALL DIAP(MIN0(NSF,INDS),'NFSF',IEND)
           INDS=IP(1)
           IF(IEND.EQ.0) CALL WRITEL('NFSF')

	END

C --------------------------------------------------------------
	SUBROUTINE RRNF(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RNF(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RNF(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(ND.LE.0)CALL HELPC(4,'Create mesh using MCR,...')
           CALL DIAP(MIN0(ND,IND),'NF',IEND)
           IF(IEND.EQ.0) CALL WRITEL('NF')
	END

C --------------------------------------------------------------
	SUBROUTINE RRNFPT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RNFPT(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RNFPT(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(ND.LE.0)CALL HELPC(4,'Create mesh using MCR,...')
           CALL DIAP(MIN0(NPT,IND),'NFPT',IEND)
           IF(IEND.EQ.0) CALL WRITEL('NFPT')
	END

C --------------------------------------------------------------
	SUBROUTINE RRINLET(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RINLET(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RINLET(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NCR.LE.0)CALL HELPC(4,'Define curve using C2P,C3P')
           IF(ND.LE.0)CALL HELPC(4,'Create mesh using MCR,...')
           CALL DIAP(MIN0(NCR,INDC),'INLET',IEND)
           INDC=IP(1)
           IF(IEND.EQ.0) CALL WRITEL('INLET')
	END

C --------------------------------------------------------------
	SUBROUTINE RRWALL(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RWALL(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RWALL(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(NCR.LE.0)CALL HELPC(4,'Define curve using C2P,C3P')
           IF(ND.LE.0)CALL HELPC(4,'Create mesh using MCR,...')
           CALL DIAP(MIN0(NCR,INDC),'WALL',IEND)
           INDC=IP(1)
           IF(IEND.EQ.0) CALL WRITEL('WALL')
	END

C --------------------------------------------------------------
	SUBROUTINE RRINITIA(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RINITIA(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RINITIA(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(ND.LE.0)CALL HELPC(4,'Create mesh using MCR,...')
           CALL DIAP(ISET,'INITIA',IEND)
           ISET=IP(2)
           IF(IEND.EQ.0) CALL WRITEL('INITIA')
	END

C --------------------------------------------------------------
	SUBROUTINE RRMOFE(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RMOFE(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RMOFE(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'MOFE',IEND)
           IF(IEND.EQ.0) CALL WRITEL('MOFE')
	END

C --------------------------------------------------------------
C graf casoveho prubehu EPAR
	SUBROUTINE RRGRATE(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RGRATE(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RGRATE(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL GRATE(IP1)
	END

C --------------------------------------------------------------
C     prenos vybranych parametru elementu do MOP
	SUBROUTINE RRGRACTE(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RGRACTE(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RGRACTE(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'CTE',IEND)
           IF(IEND.EQ.0)CALL WRITEL('CTE')
	END

C --------------------------------------------------------------
C graf casoveho prubehu DOF
	SUBROUTINE RRGRATN(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RGRATN(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RGRATN(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL GRATN(IP1)
	END

C --------------------------------------------------------------
C     prenos vybranych DOF do MOP
	SUBROUTINE RRGRACTN(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RGRACTN(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RGRACTN(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'CTN',IEND)
           IF(IEND.EQ.0)CALL WRITEL('CTN')
	END


C --------------------------------------------------------------
	SUBROUTINE RRZDEF(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RZDEF(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RZDEF(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(0,'ZDEF',IEND)
           IF(IEND.EQ.0) CALL WRITEL('ZDEF')
	END


C --------------------------------------------------------------
C Contours GRID v urcitem case (metoda siti)
	SUBROUTINE RRTGRID(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RTGRID(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RTGRID(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL TGRID(IP1)
	END


C --------------------------------------------------------------
C Contours GRID animace (metoda siti)
	SUBROUTINE RRAGRID(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RAGRID(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RAGRID(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL AGRID(IP1)
	END

C --------------------------------------------------------------
C TRAJEKTORIE z bodu vybranych mysi
	SUBROUTINE RRSTREAM(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RSTREAM(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RSTREAM(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
	   CALL DIAP(0,'STREAM',IEND)
	   IF(IEND.EQ.0.AND.IP(2).GT.1.AND.RP(1).GT.0.)THEN
            DT=RP(1)
            VMIN=1E10
	      VMAX=-1E10
	      DO I=1,ND
	         IVX=LPU($VX)+I
	         IVY=LPU($VY)+I
	         V=VAL(IVX,3)**2+VAL(IVY,3)**2
               VMIN=AMIN1(VMIN,V)
	         VMAX=AMAX1(VMAX,V)
            ENDDO
	      VMIN=SQRT(VMIN)
	      VMAX=SQRT(VMAX)
	      IF(VMAX.GT.VMIN)THEN
       	      KBD=1
	          II=SETACTIVEQQ(20)
	          DO WHILE(KBD.EQ.1)
                  II=FOCUSQQ(20)
                  CALL GMFLCC(PX,PY,KBD)
	            N=IP(2)
	            CALL PSTREAM(PX,PY,N,DT,VMIN,VMAX,1,450,1)
                ENDDO
            ELSE
	          WRITE(10,'('' All velocities are zero'')')
            ENDIF
	      II=FOCUSQQ(10)
         ENDIF
	END

C --------------------------------------------------------------
C TRAJEKTORIE z uzlovych bodu
	SUBROUTINE RRSTREAMN(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RSTREAMN(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RSTREAMN(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
	   CALL DIAP(0,'STREAMN',IEND)
	   IF(IEND.EQ.0.AND.IP(2).GT.1.AND.RP(1).GT.0.)THEN
            DT=RP(1)
	      ND1=IP(3)
	      ND2=IP(4)
	      NDS=IP(5)
            VMIN=1E10
	      VMAX=-1E10
	      DO I=1,ND
	         IVX=LPU($VX)+I
	         IVY=LPU($VY)+I
	         V=VAL(IVX,3)**2+VAL(IVY,3)**2
               VMIN=AMIN1(VMIN,V)
	         VMAX=AMAX1(VMAX,V)
            ENDDO
	      VMIN=SQRT(VMIN)
	      VMAX=SQRT(VMAX)
	      IF(VMAX.GT.VMIN)THEN
	          II=SETACTIVEQQ(20)
	          DO I=ND1,ND2,NDS
	            N=IP(2)
	            CALL PSTREAM(XX(I),YY(I),N,DT,VMIN,VMAX,1,450,0)
                ENDDO
            ELSE
	          WRITE(10,'('' All velocities are zero'')')
            ENDIF
	      II=FOCUSQQ(10)
         ENDIF
	END
