C --------------------------------------------------------------

	SUBROUTINE RRREOMAT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RREOMAT(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RREOMAT(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
         CALL DREOMAT(IEND)
         IF(IEND.EQ.0)THEN
            CALL WRITEL('REOMAT')
C           WOBSER zobrazi matici bodu pozorovani (od zacatku)
            CALL WOBSER(1,0,0,IFORMAT)
         ENDIF
	END

C --------------------------------------------------------------

	SUBROUTINE RRREAD(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RREAD(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RREAD(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
         CALL DIAP(IDEFILE,'READ',IEND)
CREAD FILE, 1-Nod,2-Ele,3-Grp,4-Epa,5-Geo,6-Obser.points,7-C,8-TC,
C           9-COSMOS,10-Fluent nodes,11-Fluent concentrations
         IF(IEND.EQ.0)THEN
           IDEFILE=IP(1)
           FILEDAT=TP(2)
           CALL FOPEN(3,FILEDAT)
           CALL FINQUIRE(3,FILEDAT)
           TP(2)=TRIM(FILEDAT)
           CALL SHOWBEG(3)

           SELECT CASE(IP(1))
           CASE(7)
CREAD jeden sloupec matice bodu pozorovani
C IP(3)-prvni sloupec dat, IP(4)=prvni sloupec matice bodu pozorovani,
C IP(5)-pocet prenasenych sloupcu,
C IP(6)-radek hlavicky, IP(7)-prvni radek dat
             CALL DIAP(1,'READCO',IEND)
             IF(IEND.EQ.0)CALL WRITEL('READ')
           CASE(8)
CREAD interpolace t-C (sloupce dat) do vybraneho sloupce matice bodu pozorovani
C IP(3)=sloupec dat TIME, IP(4)=sloupec dat C, 
C IP(5)=sloupec matice bodu pozorovani, IP(6)-prvni radek dat
             CALL DIAP(1,'READTC',IEND)
             IF(IEND.EQ.0.AND.IP(3).GT.0.AND.IP(4).GT.0.AND.
     /          IP(5).GT.0.AND.IP(5).LE.MAXSEL)CALL WRITEL('READ')
           CASE(11)
CREAD column of concentrations from FLUENT
             CALL DIAP(1,'READOF',IEND)
             IF(IEND.EQ.0.AND.IP(3).GT.0)CALL WRITEL('READ')
           CASE DEFAULT
                CALL WRITEL('READ')
           ENDSELECT
778        IF(IP(1).GE.6.AND.IP(1).LE.8)CALL WOBSER(1,0,0,IFORMAT)
           WRITE(10,'('', file ['',a,''] is closed.'')')TRIM(FILEDAT)
           CLOSE(3)
         ENDIF
	END

C --------------------------------------------------------------

	SUBROUTINE RRREADTS(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RREADTS(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RREADTS(IDUMMY)
C READ response and interpolate to equidistant time step
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
         CALL DIAP(1,'READTS',IEND)
         IF(IEND.EQ.0)CALL WRITEL('READTS')
	END

C --------------------------------------------------------------

	SUBROUTINE RRREADBI(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RREADBI(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RREADBI(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Read database from a binary file.BIN'')')
           CALL DIAFIL1(IEND,'*.BIN',2)
C          CALL DIAP(1,'FILE',IEND)
           IF(IEND.EQ.0)THEN
              TP(1)=TP(2)(1:INDEX(TP(2),'.')-1)
              CALL WRITEL('READB')
           ENDIF
	END


C --------------------------------------------------------------

	SUBROUTINE RRWRITEB(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RWRITEB(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RWRITEB(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Writing database to a file.BIN'')')
           CALL DIAP(1,'FILEBIN',IEND)
           IF(IEND.EQ.0)CALL WRITEL('WRITEB')
	END

C --------------------------------------------------------------

	SUBROUTINE RRWRITE(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RWRITE(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RWRITE(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'WRITE',IEND)
CWRITE [ 1-Nod,2-Ele,...] PROBLEM
           IF(IEND.EQ.0) CALL WRITEL('WRITE')
	END

C --------------------------------------------------------------


      SUBROUTINE RSETWIN(IDUMMY)
C SETUP()
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
	INCLUDE '$WIN'
          IDUMLOC=IDUMMY
          CALL SETUP()
          CALL READWIN(7)
          DO I=1,7
            unita =unitas(i)
	      IF(UNITA.NE.10)THEN
C 10-console v tonmto okne je spustena procedura USERGETCHAR a tak se nesmi uzavrit
            CALL WOPENH(unita,labela(unita),ixpos(unita),iypos(unita),
     / ixpix(unita),iypix(unita),nrow(unita),ncol(unita),
     / ifontph(unita),ihfontph(unita),icursor(unita),
     / fontphattr(unita),
     / icfR(unita),icfG(unita),icfB(unita),
     / icbR(unita),icbG(unita),icbB(unita),ioldwopen)
	      ENDIF
            IF(unita.EQ.30)THEN 
              MAXTROWS=nrow(unita)
              NBCK=MAXTROWS
            ENDIF
            CALL CLEARSCREEN($GCLEARSCREEN)
          ENDDO
          CALL HELP
          II=SETACTIVEQQ(20)
          CALL GMFSW(1)
          CALL GMFAXE(1,7,15)
          WRITE(10,'('' Continue by a new command'')')
          KEYW=' '
	END

C --------------------------------------------------------------

	SUBROUTINE RRCMD(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RCMD(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RCMD(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
C -CMD FILE REREAD
          CALL DIAP(1,'CMD',IEND)
          IF(IEND.EQ.0)CALL CMD
	END

C --------------------------------------------------------------

	SUBROUTINE RRINIFEM(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RINIFEM(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RINIFEM(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Initialise FEM arrays (zeroing nodes and elemen
     /ts)'')')
           CALL WRITEL('INIFEM')
	END

C --------------------------------------------------------------

	SUBROUTINE RRTRANSE(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RTRANSE(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RTRANSE(IDUMMY)
C Information about last translated RPN code
      INCLUDE '$MENU'
	INCLUDE '$TRANDAT'
      INCLUDE '$RPN'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Information about the interpret of expressions 
     /and script commands.''/'' List of variables and the last translate
     /d expression to RPN (Reverse Polish Notation).''/'' The RPN code i
     /s a sequence of numbers defining operations and operands.''/ '' NV
     /ARSYS='',I4,'' NVARTOT='',I4,'' NCONST='',I4,'' NCRPN='',I3)')
     /NVARSYS,NVARTOT,NCONST,NRPN
           WRITE(9,*)' ATTRIBUTES'
           DO I=1,NVARTOT
              WRITE(9,'(I4,2X,A8,I12,I3)')I,NAME(I),
     /                                    IATTW(1,I),IATTW(2,I)
           ENDDO
           WRITE(9,*)' RPN'
           WRITE(9,'(4I11)')(ICRPN(I),I=1,NRPN)
	END

C --------------------------------------------------------------

	SUBROUTINE RRDISPC(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RDISPC(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RDISPC(IDUMMY)
C Display variable in COMMON /$FEM/
      INCLUDE '$MENU'
	INCLUDE '$FEM-LOC'
      DIMENSION INTERC(MAXEND),REALRC(MAXEND)
      EQUIVALENCE (INTERC,REALRC,IAUX)
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,*)' Index of variable in common FEM'
           READ(10,*)IND
           IF(IND.GT.0.AND.IND.LE.MAXEND)WRITE(10,*)REALRC(IND)
	END

C --------------------------------------------------------------

	SUBROUTINE RRFI(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RFI(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RFI(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Interpret session file as a batch (including #L
     /OOP, but graphic commands are suppressed).'')')
           CALL DIAFIL(IEND)
           IF(IEND.EQ.0)THEN
              FILENAM=TRIM(TP(1))
              IFISTEP=IP(2)
              CALL FOPEN(2,FILENAM)
C Interpretace prikazu na UNIT=2. Treti parametr (.TRUE.) znamena, ze se
C budou identifikovat navesti, soucasne kopirovat radky do souboru 1 (session file, druhy
C parametr) a pak teprve probehne zpracovani vsech prikazu
C (vcetne cyklu) ze souboru 2. Soubor zustava otevreny a je mozne ho doplnovat.
C
              CALL COMFIL(2,1,.TRUE.)
              CLOSE(2)
           ENDIF
	END

C --------------------------------------------------------------

	SUBROUTINE RRFILE(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RFILE(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RFILE(IDUMMY)
C Process batch file
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Interpret session file as a batch (including #L
     /OOP, but graphic commands are suppressed).'')')
           CALL DIAP(1,'FILESTEP',IEND)
           IF(IEND.EQ.0)THEN
              FILENAM=TRIM(TP(1))
              IFISTEP=IP(2)
              CALL FOPEN(2,FILENAM)
C Interpretace prikazu na UNIT=2. Treti parametr (.TRUE.) znamena, ze se
C budou identifikovat navesti, soucasne kopirovat radky do souboru 1 (druhy
C parametr) a pak teprve probehne zpracovani vsech prikazu
C (vcetne cyklu). Soubor zustava otevreny a je mozne ho doplnovat.
C
              CALL COMFIL(2,1,.TRUE.)
              CLOSE(2)
           ENDIF
	END

C --------------------------------------------------------------

	SUBROUTINE RROPEN(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL ROPEN(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE ROPEN(IDUMMY)
C OPEN batch file for model processing (MDF Model Definition File)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Open file (*.geo) on unit 7 as a model for opti
     /misation'')')
           CALL DIAFIL1(IEND,'*.GEO',1)
           IF(IEND.EQ.0)THEN
              CALL WRITEL('MOP')
              IAUX(10)=1
           ENDIF
	END

C --------------------------------------------------------------

	SUBROUTINE RRCLOSE(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RCLOSE(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RCLOSE(IDUMMY)
C CLOSE model definition file
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(4,'CLOSE',IEND)
           IF(IEND.EQ.0)CALL WRITEL('CLOSE')
	END

C --------------------------------------------------------------

	SUBROUTINE RRUNDO(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RUNDO(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RUNDO(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
	INCLUDE '$WIN'
           IDUMLOC=IDUMMY
           REWIND 1
           UNITA=39
           CALL WOPENH(unita,'UNDO',
     /  ixpos(unita),iypos(unita),
     /  ixpix(unita),iypix(unita),nrow(unita),ncol(unita),
     /  ifontph(unita),ihfontph(unita),icursor(unita),
     /  fontphattr(unita),
     /  icfR(unita),icfG(unita),icfB(unita),
     /  icbR(unita),icbG(unita),icbB(unita),ioldwopen)
           II=FOCUSQQ(39)
           II=SETBKCOLOR(3)
           CALL CLEARSCREEN($GCLEARSCREEN)
           ILINE=0
850        READ(1,'(A)',END=851)LINE        
           ILINE=ILINE+1
           II=SETTEXTCOLOR(int2(11))
           WRITE(39,'(I4,'':''\)')ILINE
           II=SETTEXTCOLOR(int2(15))
           WRITE(39,'(A35)')LINE
           GOTO 850
851        BACKSPACE 1
           CALL DIAP(ILINE,'UNDO  ',IEND)
C ILINE= CELKOVY POCET RADKU
C IP(1)= REDUKOVANY POCET RADKU  
           IF(IEND.EQ.0.AND.ILINE.GT.IP(1).AND.IP(1).GT.0)THEN
C UNDO se provadi tak, ze se vytvori novy session file UNIT=1 PROBLEM.SES
C z nehoz je odstraneno nekolik poslednich radku, a tento soubor se necha
C interpretovat, procedurou COMFIL az do konce (ale s vynechanim navesti).
              REWIND 1
              DO I=1,IP(1)
                 READ(1,'(A)',END=51)LINE        
              ENDDO
              ENDFILE 1
              REWIND 1
              CALL INIT
              CALL SET3D
C Protoze je treti parametr false, nekopiruji se radky do session filu,
C ani se neuvazuji prikazy cyklu apod (rezim READFI=.false.)
              CALL COMFIL(1,1,.FALSE.)
           ENDIF
51         CLOSE(39)
c           UNITA =40
c           CALL WOPENH(UNITA,'HELP',
c     /  ixpos(unita),iypos(unita),
c     /  ixpix(unita),iypix(unita),nrow(unita),ncol(unita),
c     /  ifontph(unita),ihfontph(unita),icursor(unita),
c     /  fontphattr(unita),
c     /  icfR(unita),icfG(unita),icfB(unita),
c     /  icbR(unita),icbG(unita),icbB(unita),ioldwopen)
	END

C --------------------------------------------------------------

	SUBROUTINE RRSAVE(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RSAVE(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RSAVE(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
	INCLUDE '$WIN'
           IDUMLOC=IDUMMY
           REWIND 1
           UNITA=39
           CALL WOPENH(unita,'SAVE session file',
     /  ixpos(unita),iypos(unita),
     /  ixpix(unita),iypix(unita),nrow(unita),ncol(unita),
     /  ifontph(unita),ihfontph(unita),icursor(unita),
     /  fontphattr(unita),
     /  icfR(unita),icfG(unita),icfB(unita),
     /  icbR(unita),icbG(unita),icbB(unita),ioldwopen)
           II=FOCUSQQ(39)
           II=SETBKCOLOR(3)
           CALL CLEARSCREEN($GCLEARSCREEN)
           ILINE=0
850        READ(1,'(A)',END=851)LINE        
           ILINE=ILINE+1
           II=SETTEXTCOLOR(int2(11))
           WRITE(39,'(I4,'':''\)')ILINE
           II=SETTEXTCOLOR(int2(15))
           WRITE(39,'(A35)')LINE
           GOTO 850
851        BACKSPACE 1
           WRITE(10,'('' Safe current session file as ...'')')
           CALL DIAP(1,'FILENAM',IEND)
           IF(IEND.EQ.0)THEN
              FILENAM=TRIM(TP(1))
              OPEN(8,FILE=FILENAM)
              REWIND 1
870           READ(1,'(A)',END=871,ERR=871)LINE
              WRITE(8,'(A)')TRIM(LINE)
              GOTO 870
871           BACKSPACE 1
              CLOSE(8)
           ENDIF         
           CLOSE(39)
c           UNITA =40
c           CALL WOPENH(UNITA,'HELP',
c     /  ixpos(unita),iypos(unita),
c     /  ixpix(unita),iypix(unita),nrow(unita),ncol(unita),
c     /  ifontph(unita),ihfontph(unita),icursor(unita),
c     /  fontphattr(unita),
c     /  icfR(unita),icfG(unita),icfB(unita),
c     /  icbR(unita),icbG(unita),icbB(unita),ioldwopen)
	END

C --------------------------------------------------------------

      SUBROUTINE RMACRO(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Interpret macro file. #LOOP and step by step pr
     /ocessing are disabled.''/'' This is the difference from FILE, howe
     /ver it is possible to use graphic commands.'')')
           CALL DIAP(1,'FILENAM',IEND)
           IF(IEND.EQ.0)THEN
              FILENAM=TRIM(TP(1))
              IFISTEP=IP(2)
              CALL FOPEN(4,FILENAM)
              CALL SHOWBEG(4)
              READMA=.TRUE.
           ENDIF
	END

C --------------------------------------------------------------

	SUBROUTINE RRMAC(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RMAC(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RMAC(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Interpret macro file. #LOOP and step by step pr
     /ocessing are disabled.''/'' This is the difference from FILE, howe
     /ver it is possible to use graphic commands.'')')
           CALL DIAFIL(IEND)
           IF(IEND.EQ.0)THEN
              FILENAM=TRIM(TP(1))
              IFISTEP=IP(2)
              CALL FOPEN(4,FILENAM)
              CALL SHOWBEG(4)
              READMA=.TRUE.
           ENDIF
	END

C --------------------------------------------------------------

	SUBROUTINE RRRECORD(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RRECORD(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RRECORD(IDUMMY)
C Start recording macro into a file
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Following commands will be saved into a file, u
     /ntil ENDREC'')')
           CALL DIAP(1,'FILENAM',IEND)
           IF(IEND.EQ.0)THEN
              CLOSE(8)
              FILENAM=TRIM(TP(1))
              CALL FOPEN(8,FILENAM)
              RECORW=.TRUE.
           ENDIF
	END

C --------------------------------------------------------------

	SUBROUTINE RRENDREC(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RENDREC(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RENDREC(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
	IF(RECORW)THEN
           CALL SHOWBEG(8)
           CLOSE(8)
           RECORW=.FALSE.
           IAUX(10)=1
	ELSE
	   WRITE(10,'('' There are no records'')')
	ENDIF
	END

C --------------------------------------------------------------

	SUBROUTINE RRSTATUS(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RSTATUS(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RSTATUS(IDUMMY)
C Status fem,rtd
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'STATUS',IEND)
           IF(IEND.EQ.0)ISTATUS=IP(1)
	END

C --------------------------------------------------------------

	SUBROUTINE RRFUNVAL(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RFUNVAL(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RFUNVAL(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
C FUNVAL variable,INDEX_FUNCTION
           CALL DIAP(0,'FUNVAL',IEND)
           IF(IEND.EQ.0)CALL WRITEL('FUNVAL')
	END

C --------------------------------------------------------------

	SUBROUTINE RRANALYS(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RANALYS(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RANALYS(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'ANALYS',IEND)
           CALL WRITEL('ANALYS')
           CALL INFO21(MAXTROWS)
	END

C --------------------------------------------------------------

	SUBROUTINE RRACTNUM(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RACTNUM(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RACTNUM(IDUMMY)
C Aktivace cislovani entit pri kresleni
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Activate numbering of selected entities in wind
     /ow MODEL'')')
           CALL DIAP(1,'ACTNUM',IEND)
           IF(IEND.EQ.0)THEN
             IF(IP(1).GE.1.AND.IP(1).LE.5)THEN
                IACT(IP(1)+3)=1
             ELSE
                DO I=4,8
                   IACT(I)=1
                ENDDO
             ENDIF
           ENDIF
	END

C --------------------------------------------------------------

	SUBROUTINE RRINACTNUM(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RINACTNUM(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RINACTNUM(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,'('' Suppress numbering of selected entities in wind
     /ow MODEL'')')
           CALL DIAP(1,'ACTNUM',IEND)
           IF(IEND.EQ.0)THEN
             IF(IP(1).GE.1.AND.IP(1).LE.5)THEN
                IACT(IP(1)+3)=0
             ELSE
                DO I=4,8
                   IACT(I)=0
                ENDDO
             ENDIF
           ENDIF
	END

C --------------------------------------------------------------

	SUBROUTINE RRACTSET(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RACTSET(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RACTSET(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'ACTSET',IEND)
           IF(IEND.EQ.0)CALL WRITEL('ACTSET')
	END


C --------------------------------------------------------------

	SUBROUTINE RRNDEL(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RNDEL(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RNDEL(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'NDEL',IEND)
           IF(IEND.EQ.0) CALL WRITEL('NDEL')
	END

C --------------------------------------------------------------

	SUBROUTINE RREDEL(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL REDEL(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE REDEL(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'EDEL',IEND)
           IF(IEND.EQ.0) CALL WRITEL('EDEL')
	END

C --------------------------------------------------------------

	SUBROUTINE RRCRDEL(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RCRDEL(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RCRDEL(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'CRDEL',IEND)
           IF(IEND.EQ.0) CALL WRITEL('CRDEL')
	END

C --------------------------------------------------------------

	SUBROUTINE RRSFDEL(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RSFDEL(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RSFDEL(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'SFDEL',IEND)
           IF(IEND.EQ.0) CALL WRITEL('SFDEL')
	END

C --------------------------------------------------------------

	SUBROUTINE RRPTDEL(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RPTDEL(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RPTDEL(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'PTDEL',IEND)
           IF(IEND.EQ.0) CALL WRITEL('PTDEL')
	END

C --------------------------------------------------------------

	SUBROUTINE RRFLUENF(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RFLUENF(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RFLUENF(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
         CALL DIAP(1,'FLUENF',IEND)
         IF(IEND.EQ.0)CALL WRITEL('FLUENF')
	END

C --------------------------------------------------------------

	SUBROUTINE RRFLUENT(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RFLUENT(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RFLUENT(IDUMMY)
C Generuje journal file pro fluent popisujici simulaci nastriku (jednotlive casove ktroky)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
         CALL DIAP(1,'FLUENT',IEND)
         IF(IEND.EQ.0)CALL WRITEL('FLUENT')
	END

C --------------------------------------------------------------

	SUBROUTINE RRUNIFIL(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RUNIFIL(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RUNIFIL(IDUMMY)
C Cte vusledkove soubory Fluentu nnnn.RES z jednotlivych casovych kroku
C a vytvari z nich jediny OUT soubor
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'UNIFIL',IEND)
           IF(IEND.EQ.0)CALL WRITEL('UNIFIL')
	END

C --------------------------------------------------------------

	SUBROUTINE RRLOADTN(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RLOADTN(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RLOADTN(IDUMMY)
C Cteni casoveho kroku z OUT souboru
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'LTN',IEND)
           IF(IEND.EQ.0)CALL WRITEL('LTN')
	END


C --------------------------------------------------------------

	SUBROUTINE RRLOADTE(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RLOADTE(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RLOADTE(IDUMMY)
C Cteni casoveho kroku z TEP souboru
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'LTE',IEND)
           IF(IEND.EQ.0)CALL WRITEL('LTE')
	END

C --------------------------------------------------------------

	SUBROUTINE RRNAME(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RNAME(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RNAME(IDUMMY)
C Name of program?
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'NAME',IEND)
           IF(IEND.EQ.0)CALL WRITEL('NAME')
	END

C --------------------------------------------------------------

	SUBROUTINE RRBOX(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RBOX(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RBOX(IDUMMY)
C BOXING run BOX
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(ND.LE.0)CALL HELPC(4,'Create mesh using MCR,...')
           CALL DIAP(1,'BOX',IEND)
           IF(IEND.EQ.0) CALL WRITEL('BOX')
	END

C --------------------------------------------------------------

	SUBROUTINE RRTRUSS(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RTRUSS(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RTRUSS(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           WRITE(10,*)'Structural analysis of a system of trusses by Mon
     /te Carlo method.'
           CALL DIAP(1000,'TRUSS ',IEND)
           IF(IEND.EQ.0) CALL WRITEL('TRUSS')
	END

C --------------------------------------------------------------

	SUBROUTINE RRSOLVED(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RSOLVED(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RSOLVED(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(ND.LE.0)CALL HELPC(4,'Create mesh using MCR,...')
           CALL DIAP(1,'SOLVE',IEND)
           IF(IEND.EQ.0) CALL WRITEL('DSOLVE')
	END

C --------------------------------------------------------------

	SUBROUTINE RRSOLVE(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RSOLVE(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RSOLVE(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(ND.LE.0)CALL HELPC(4,'Create mesh using MCR,...')
           CALL DIAP(1,'SOLVE',IEND)
           IF(IEND.EQ.0)CALL WRITEL('SOLVE')
	END

C --------------------------------------------------------------

	SUBROUTINE RRPSOLVE(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RPSOLVE(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RPSOLVE(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           IF(ND.LE.0.OR.NPART.LE.0)CALL HELPC(4,'Create mesh using MCR,
     /..., particles using PPT')
           CALL DIAP(1,'SOLVE',IEND)
           IF(IEND.EQ.0) CALL WRITEL('PSOLVE')
	END


C --------------------------------------------------------------

	SUBROUTINE RRACCURA(IDUMMY)
	LOGICAL IDUMMY
	CALL MENSET
	CALL RACCURA(IDUMMY)
	CALL MENEND
	END

      SUBROUTINE RACCURA(IDUMMY)
      INCLUDE '$MENU'
      LOGICAL IDUMMY,IDUMLOC
      IDUMLOC=IDUMMY
           CALL DIAP(1,'ACCURA',IEND)
           IF(IEND.EQ.0) CALL WRITEL('ACCURA')
	END

