C $run-det.for
C
      SUBROUTINE DETEL(IAL,IDOF,ATTENUAT,IATTENUAT,
     /                 IVIEW,NDET,IDET,ITIME,DET)
C Vyhodnoceni signalu ze vsech NDET detektoru pro hodnoty koncentraci 
C v zone VAL(3)
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEMLOC'
      DIMENSION XND(20),YND(20),ZND(20),VND(20),XD(2),YD(2),ZD(2),
     /          XIG(2000),YIG(2000),ZIG(2000),WIG(2000),VIG(2000),
     /          XAG(20),YAG(20),WAG(20),VAG(20),
     /          IDET(MAXDET),DET(MAXDET),
     /          G1(16),G2(16),G3(16),WT(16),F(8),FX(8),FY(8),FZ(8)
      DET=0.
      IF(IAL.EQ.1)THEN
C Integrace odezvy pres elementy
         DO IE=1,NE     
           NUE=IABS(MUE(IE))-IABS(MINT(IE))
           L0=LUE(IE)
           DO I=1,NUE
             IU=IABS(IUE(L0+I))
             XND(I)=XX(IU)
             YND(I)=YY(IU)
             ZND(I)=ZZ(IU)
             VND(I)=VAL(LPU(IDOF)+IU,3)
           ENDDO
           IG=MAX0(1,IGROUP(IE))
           LRCON=MAX0(1,IRCONS(IE))
           NAMEL=JGROUP(IG,$ENAME)
           JAXIS=JGROUP(IG,$AXIS)
C Stanoveni poctu a souradnic integracnich uzlu dle typu elementu
C NING - pocet integracnich uzlu
C VIG()- interpolovana uzlova hodnota
C WIG()- objem odpovidajici integracnimu uzlu (vaha)
C XIG(),YIG(),ZIG() - souradnice integracnich uzlu
           SELECT CASE(NAMEL)
           CASE($PIPE2D,$PIPE3D,$CSTR)
C TRUBKA
              H=SQRT((XND(1)-XND(2))**2+(YND(1)-YND(2))**2+
     /                  (ZND(1)-ZND(2))**2)
              SELECT CASE(JAXIS)
              CASE(0,1)
C KRUHOVY PRUREZ (funkce RADEL vyhodnoti polomer PIPE2D,CSTR)
                D=2*RADEL(NAMEL,H,LRCON)
                NING=0
                NKSI=10
                NDR=10
                NFI=20
                DKSI=H/NKSI
                DR=D/(2*NDR)
                DFI=2*PI/NFI
                DO IKSI=1,NKSI
                  RKSI=(IKSI-.5)*DKSI
                  VKSI=(VND(2)*RKSI+VND(1)*(H-RKSI))/H
                  DO IRAD=1,NDR
                     R=DR*(IRAD-.5)
                     DO IFI=1,NFI
                       FI=(IFI-.5)*DFI
                       RETA=R*COS(FI)
                       RZETA=R*SIN(FI)
                       NING=NING+1
                       CALL TKEZXYZ(1,XND,YND,ZND,RKSI,RETA,RZETA,
     /                                 XIG(NING),YIG(NING),ZIG(NING))
                       WIG(NING)=DKSI*DR*R*DFI
                       VIG(NING)=VKSI
                     ENDDO
                  ENDDO
                ENDDO
              CASE(2,3,4)
C OBDELNIKOVY PRUREZ
                NING=0
                D=RRCONS(LRCON,$D)
                AREA=RRCONS(LRCON,$AREA)
                CALL RECTAB(D,AREA,A,B)
                NKSI=10
                NETA=12
                NZETA=12
                DKSI=H/NKSI
                DETA=A/NETA
                DZETA=B/NZETA
                DO IKSI=1,NKSI
                  RKSI=(IKSI-.5)*DKSI
                  VKSI=(VND(2)*RKSI+VND(1)*(H-RKSI))/H
                  DO IETA=1,NETA
                     RETA=-A/2+DETA*(IETA-.5)
                     DO IZETA=1,NZETA
                       RZETA=-B/2+DZETA*(IZETA-.5)
                       NING=NING+1
                       CALL TKEZXYZ(1,XND,YND,ZND,RKSI,RETA,RZETA,
     /                                 XIG(NING),YIG(NING),ZIG(NING))
                       WIG(NING)=DKSI*DETA*DZETA
                       VIG(NING)=VKSI
                     ENDDO
                  ENDDO
                ENDDO
              ENDSELECT
           CASE($FLOW2D,$PLANE2D)
C 2D element
              IF(NUE.EQ.3.OR.NUE.EQ.6)THEN
                 CALL TGAUS(7,NIN,G1,G2,WT)
              ELSE
                 CALL QGAUS(2,NIN,G1,G2,WT)
              ENDIF
              DO KG=1,NIN
                 IF(NUE.EQ.3.OR.NUE.EQ.6)THEN
                   CALL FDFT(NUE,XND,YND,G1(KG),G2(KG),F,FX,FY,DETJ)
                 ELSE
                   CALL FDFQ(NUE,XND,YND,G1(KG),G2(KG),F,FX,FY,DETJ)
                 ENDIF
                 XAG(KG)=0.
                 YAG(KG)=0.
                 WAG(KG)=DETJ*WT(KG)
                 VAG(KG)=0.
                 DO IU=1,NUE
                   XAG(KG)=XAG(KG)+F(IU)*XND(IU)
                   YAG(KG)=YAG(KG)+F(IU)*YND(IU)
                   VAG(KG)=VAG(KG)+F(IU)*VND(IU)
                 ENDDO
              ENDDO
C NIN XAG,WAG,VAG se tyka jen 2D integrace. Tu je treba rozsirit na 3D
C v zavislosti na JAXIS
              IF(JAXIS.EQ.1)THEN
C Rotacni symetrie vzhledem k ose X. Delime prstenec (2Pi) na 20 segmentu.
                 NING=0
                 NFI=20
                 DFI=2.*PI/NFI
                 DO I=1,NFI
                    FI=DFI*I
                    DO KG=1,NIN
                       NING=NING+1
                       XIG(NING)=XAG(KG)
                       YIG(NING)=YAG(KG)*COS(FI)
                       ZIG(NING)=YAG(KG)*SIN(FI)
                       VIG(NING)=VAG(KG)
                       WIG(NING)=WAG(KG)*DFI*YAG(KG)
                    ENDDO
                 ENDDO
              ELSE
C Deska, jejiz tloustka je parametrem RCONS. Integrace Z od -H/2 do H/2
                 H=RRCONS(LRCON,$H)
                 NING=0
                 NZ=20
                 DZ=H/NZ
                 Z=-H/2+DZ/2
                 DO I=1,NZ
                    DO KG=1,NIN
                       NING=NING+1
                       XIG(NING)=XAG(KG)
                       YIG(NING)=YAG(KG)
                       ZIG(NING)=Z
                       VIG(NING)=VAG(KG)
                       WIG(NING)=WAG(KG)*DZ
                    ENDDO
                    Z=Z+DZ
                 ENDDO
              ENDIF   
           CASE($SOLID)
C 3D element
              IF(NUE.EQ.4.OR.NUE.EQ.8)THEN
C 4sten
                  NING=4
                  ALF=0.5854102
                  BET=0.1381966
                  G1(1:4)=(/ALF,BET,BET,BET/)
                  G2(1:4)=(/BET,ALF,BET,BET/)
                  G3(1:4)=(/BET,BET,ALF,BET/)
                  WT(1:4)=(/.25,.25,.25,.25/)
              ELSE
C 6sten
                  NING=8
                  ALF=0.57735
                  G1(1:8)=(/-ALF,-ALF,-ALF,-ALF,ALF, ALF, ALF, ALF/)
                  G2(1:8)=(/-ALF,-ALF, ALF, ALF,-ALF,-ALF, ALF, ALF/)
                  G3(1:8)=(/-ALF, ALF,-ALF, ALF,-ALF, ALF,-ALF, ALF/)
                  WT(1:8)=(/1.,1.,1.,1.,1.,1.,1.,1./)
              ENDIF
              DO KG=1,NING
                 IF(NUE.EQ.4.OR.NUE.EQ.8)THEN
                    CALL FDFP(NUE,XND,YND,ZND,G1(KG),G2(KG),G3(KG),
     /                         F,FX,FY,FZ,DETJ)
                 ELSE
                    CALL FDFVL(NUE,XND,YND,ZND,G1(KG),G2(KG),G3(KG),
     /                         F,FX,FY,FZ,DETJ)
                 ENDIF
                 XIG(KG)=0.
                 YIG(KG)=0.
                 ZIG(KG)=0.
                 WIG(KG)=DETJ
                 VIG(KG)=0.
                 DO IU=1,NUE
                   XIG(KG)=XIG(KG)+F(IU)*XND(IU)
                   YIG(KG)=YIG(KG)+F(IU)*YND(IU)
                   ZIG(KG)=ZIG(KG)+F(IU)*ZND(IU)
                   VIG(KG)=VIG(KG)+F(IU)*VND(IU)
                 ENDDO
              ENDDO
           ENDSELECT
C Prispevek elementu IE ke vsem detektorum
           DO ID=1,NDET
C Index zpracovavaneho detektoru je systemova promenna I
              IG=IDET(ID)
              IAUX(49)=IG
              DO I=1,2
                 XD(I)=DETECT(IG,3*I-2)
                 YD(I)=DETECT(IG,3*I-1)
                 ZD(I)=DETECT(IG,3*I)
              ENDDO
              ACOL=DETECT(IG,10)
              APERTURE=DETECT(IG,7)
              HS=SQRT((XD(1)-XD(2))**2+(YD(1)-YD(2))**2+
     /                   (ZD(1)-ZD(2))**2)
              DO IT=1,NING
C Vzdalenost 
                 CALL TXYZRZ(DETECT(IG,1),DETECT(IG,2),DETECT(IG,3),
     /                       DETECT(IG,4),DETECT(IG,5),DETECT(IG,6),
     /                       XIG(IT),YIG(IT),ZIG(IT),R,Z)
                 AUX(2)=XIG(IT)
                 AUX(3)=YIG(IT)
                 AUX(4)=ZIG(IT)
                 AMU=ATTENUAT*CURFUN(IATTENUAT)
                 C=COLUNI(IVIEW,Z,R,APERTURE,HS,AMU,ACOL,0.1)
                 DET(IG)=DET(IG)+C*VIG(IT)*WIG(IT)
              ENDDO
           ENDDO
           WRITE(*,*)' Time step',itime,' Processed element: ',IE
        ENDDO
      ELSE
C Integrace pres detektory
        DO ID=1,NDET
           IG=IDET(ID)
C Index detektoru do systemove promenne I (pro uzivatelskou funkci utlumu)
           IAUX(49)=IG
           DO I=1,2
              XD(I)=DETECT(IG,3*I-2)
              YD(I)=DETECT(IG,3*I-1)
              ZD(I)=DETECT(IG,3*I)
           ENDDO
           ACOL=DETECT(IG,10)
           APERTURE=DETECT(IG,7)
           HS=SQRT((XD(1)-XD(2))**2+(YD(1)-YD(2))**2+
     /                   (ZD(1)-ZD(2))**2)
           RANGE=DETECT(IG,9)
           ANGLE=DETECT(IG,8)*PI/180.
           NKSI=100
           NFI=60
           NDR=30
           DKSI=RANGE/NKSI
           DFI=2*PI/NFI
           DO IKSI=1,NKSI
              RKSI=DKSI*(IKSI-.5)
              RADIUS=RKSI*TAN(ANGLE)
              DR=RADIUS/NDR
              DO IR=1,NDR
                R=DR*(IR-.5)
                DO IFI=1,NFI
                   FI=DFI*IFI
                   CALL TRZFXYZ(XD,YD,ZD,R,RKSI,FI,X,Y,Z)
                   AUX(2)=X
                   AUX(3)=Y
                   AUX(4)=Z
                   AMU=ATTENUAT*CURFUN(IATTENUAT)
                   V=CURFUN(IDOF)
                   C=COLUNI(IVIEW,RKSI,R,APERTURE,HS,AMU,ACOL,0.1)
                   DV=DKSI*DR*R*DFI
                   DET(IG)=DET(IG)+C*V*DV
                ENDDO
              ENDDO
           ENDDO
           WRITE(*,*)' Time step',ITIME,' detector',ID
        ENDDO
      ENDIF
      END

