C $S0-DIAL
      SUBROUTINE DIAP(IDEF,ICOM,IEND)
C DIALOG - DOPLNENI PARAMETRU NEZADANYCH V PRIKAZOVEM RADKU
C Vstupni parametry
C IDEF >0 default hodnota nektereho vyznamneho parametru (dle typu prikazu)
C      <0 pozadavek na provedeni predbezne kontroly a ev.hlaseni chyby
C ICOM    klicove slovo prikazu
C Vystupni parametry
C IEND =0 O.K.
C
C Ze zony common/FEM/ se vyuzivaji nektere default hodnoty (treba materialove
C parametry) a v teto zone jsou i vystupni parametry zpracovavaneho radku
C IP()  celociselne hodnoty parametru
C RP()  tytez hodnoty ale ve formatu real
C TP()  texty parametru
C LAST  pocet parametru zadanych primo na prikazovem radku 
C ISEMI pozice stredniku
C     
C NCMAX - max.POCET PRIKAZU, NPMAX -max.POCET POLOZEK

C Pozn. sekce zpracovani zacina radkou C=======
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEMLOC'
      COMMON /$SHIFTS/VSHIFT
C PD -default par, PDD-for table definition
C PICK=1 ND, =2 PT, =3 CR, =4 EL, =5 TC, =6 TCpoint
C IDIGR(MAXPAR) - index obrazku, ktery ma byt vystaven v okne DIALOG
      DIMENSION PD(MAXPAR),PDD(MAXPAR),IPICK(MAXPAR),IDIGR(MAXPAR)
C NAME  true-jen text, false-ciselna hodnota nebo vyraz (ZADAVANA hodnota)
C NAMED true-jen text, false-ciselna hodnota nebo vyraz (DEFAULT hodnota)
      LOGICAL REA,NAME(MAXPAR),NAMED(MAXPAR)
      CHARACTER*1 CH
C Zmena kveten 2007 FILENAL puvodne 12
      CHARACTER*20 TTP(MAXPAR)
      CHARACTER*5 POSTFIX(11)
      CHARACTER TEXT(MAXPAR)*(LENDIAL),LINE*(LENITE),ICOM*(*)
      DATA PDD /-1.,0.,8.,43*0./
      DATA JDDOF,NUCR,NUSF,XLAFI,YLAFI,ICURVE,
     / IDESTIN,PMIX1,PMIX2,F,ALFA,TMEAN,AMPLIT,MREG,ICOLX,ICOLY,ICOLE,
     / ICOLSIG,ICOLYP,IMODEL,W1,SMOOTH,ITER,IRPIPE,IRHEX,MPIPE,IGHEX,
     / IGPIPE,IAPPEND,IFFT,IFUN,ICOLX2,IZONE,XDEFA,YDEFA,ZDEFA,ATTENUAT,
     / IATTENUAT,IVIEW,NODET,INSERT,
     / WEIGHT,NUTR,SIZE,CONEAR,MITER,ROTAX,ROTAY,ROTAZ,TOLERANCE,
     / MOP,INDPAR,PARMI,PARMA
     /     /1,2,4,1.,1.,2,
     /      3,2.,2.,0.5,1.,1.,0.1,0,2,3,4,3,4,1,
     /      1E-3,1.0,3,1,2,1,2,1,0,4,1,2,2,0.,0.,0.,0.,0,1,1,4,
     /      2.,3,1.,1.,50,0.,0.,0.,1E-3,
     /      7,1,0.1,1./

	DATA RR,RI,RO,RLZ,THETA,DELTA /0.00231,0.00206,0.00231,1.315,0.,1./
	DATA MODEL /3/
      DATA C1,C2,B1,B2,B3 /2500.,431.,5.366,3.559,-0.3172/
	DATA HC1,HK1,HK2,HSIN2 /2500.,1.,2.,0./
	DATA GC1,GMJU,GJF,GSIN2 /2500.,24410.,0.7498,0.4465/
	DATA GGC1,GGMJU,GGJM,GGJF,GGSIN2 /2500.,24410.,3.,0.7498,0.4465/

	DATA RLA,RLT,HHH,WA,WT/1.2,1.,0.002,0.05,0.01/
      DATA POSTFIX/'*.NOD','*.ELE','*.GRP','*.EPA','*.PCS','*.DAT',
     /             '*.TXT','*.TXT','*.MOD','*.NEU','*.RES'/
	DATA HPLATE,RMASS,OMGW,PSI,RKO,RB0,timax,t0,vexp
     /     /0.008,0.25,0.6,2E-7,0.1,2E-6,500.,30.,3./
	DATA ALPHA,RBF,EPSF,TC/1e-4,0.002,0.7,110./
      DATA TIII,DTIII,DTI,RK,RPSI,EM,EN
     /     /110.,200.,30.,1.1,1E-19,1.,2./
      TEXT=''
      NAME=.FALSE.
      NAMED=.FALSE.
C IPICK - aktivace mysi F1, IDIGR - preruseni zpracovane procedurou DIGR
      IPICK=0
      IDIGR=0
C ZAporna hodnota IDEF znamena provedeni testu 
C IDEF=-1  NGR>=1 
      IF(IDEF.EQ.-1)THEN
         IF(NGR.LT.1)THEN
      CALL HELPC(4,'Read/generate observation matrix. READ,ROM,T,TCF')
            RETURN
         ENDIF
      ENDIF

C ISELSTEP - poradi parametru, kdy dochazi k vetveni rozhodovani
      ISELSTEP=2

      SELECT CASE(ICOM)

CASES CONTROL--

C      INCLUDE '$S0-DIAL'
C DELETE
      CASE('NDEL')
         NPAR=2
         PD(1:2)=(/1,ND/)
         IPICK(1:2)=(/1,1/)
         TEXT(1:2)=(/'First node to delete','...up to node'/)
         WRITE(10,'('' Deleting nodes. Elements associated with these no
     /des will be erased too.'')')
      CASE('EDEL')
         NPAR=2
         PD(1:2)=(/1,NE/)
         IPICK(1:2)=(/4,4/)
         TEXT(1:2)=(/'First element to delete','...up to element'/)
      CASE('CRDEL')
         NPAR=2
         PD(1:2)=(/1,NCR/)
         IPICK(1:2)=(/3,3/)
         TEXT(1:2)=(/'First curve to delete','...up to the curve'/)
      CASE('SFDEL')
         NPAR=2
         PD(1:2)=(/1,NSF/)
         TEXT(1:2)=(/'First surface to delete','...up to the surface'/)
      CASE('PTDEL')
         NPAR=2
         PD(1:2)=(/1,NPT/)
         IPICK(1:2)=(/2,2/)
         TEXT(1:2)=(/'First point to delete','...up to the point'/)
         WRITE(10,'('' Deleting points. Curves and surfaces associated w
     /ith these points will be erased too!'')')
      CASE('WINDOW')
         NPAR=1
         PD(1)=IDEF
         TEXT(1)='Window for graphs (20,21,40)'
      CASE('VIEW')
         NPAR=4
	   PD(1)=IPROJ
         PD(2:4)=(/rotax,rotay,rotaz/)
         TEXT(1:4)=(/'Projection: 0-rotation,1-axonometry',
     /        'Rotation X (deg)','Rotation Y (deg)','Rotation Z (deg)'/)
         WRITE(10,'('' Select projection method for 3D graphics.''/'' Op
     /tion 0 - rotation of coord.system. What you see is X-Y plane in ro
     /tated coord.system''/'' Option 1 - axonometry. Observers eye coord
     /inates are specified.'')')
      CASE('FILE') 
C FILE
         NPAR=1
         TTP(1)=PROBLEM
         NAME(1)=.TRUE.
         TEXT(1)='File name (without extension, max.8 char.)'
      CASE('FILEBIN')
C FILE
         NPAR=2
         TTP(1)=PROBLEM
         NAME(1)=.TRUE.
         PD(2)=1
         TEXT(1)='File name (without extension, max. 8 char.)'
         TEXT(2)='0-shortened databaze, 1-full database'
      CASE('FILENAM')
C FILE
         NPAR=1
         TTP(1)=FILENAM
         NAME(1)=.TRUE.
         TEXT(1)='File name (max.12 characters)'
         CALL SHOWFILE(21,'*.geo')
      CASE('LATEX')
C LATEX
         NPAR=1
         TTP(1)='_'
         NAME(1)=.TRUE.
         TEXT(1)='Write text'
      CASE('FILESTEP')
C FILE STEP BY STEP
         NPAR=2
         TTP(1)=FILENAM
         NAME(1)=.TRUE.
         PD(2)=0
         TEXT(1:2)=(/'File name (max.12 characters)',
     /               'Step by step (1)'/)
         CALL SHOWFILE(21,'*.geo')
      CASE('OPEN')
C OPEN IUNIT, FILE
         NPAR=2
         PD(1)=MOP
         TTP(2)=FILENAM
         NAME(2)=.TRUE.
         TEXT(1:2)=(/'Unit number','File name (max.12 characters)'/)
         CALL SHOWUNIT(10)
         WRITE(10,'('' Connect FILE to a free UNIT (you should not use a
     /ny unit in the list above).'')')
      CASE('CLOSE')
C OPEN IUNIT, FILE
         NPAR=1
         PD(1)=MOP
         TEXT(1)='Unit number'
         CALL SHOWUNIT(10)
         WRITE(10,'('' Close one of files from the list above.'')')
      CASE('FLI')
C FIRST, LAST, INC
         NPAR=3
         PD(1:3)=(/1,IDEF,1/)
         TEXT(1:3)=(/'first','last','increment'/)
      CASE('EPLOT')
C FIRST, LAST, INC, FILL(EG,RC,MP), GROUP number
         NPAR=5
         PD(1:5)=(/1,IDEF,1,0,0/)
         TEXT(1:5)=(/'first','last','increment',
     /'Select 1-EGROUP,2-RCONST,3-MPROP','Plot group number [0-all]'/)
         WRITE(10,'('' Plot elements. Filling by color according to grou
     /ps assigned (Egroups,RConst,Mprop).''/'' It is possible to select 
     /only elements having specified group number.'')')
      CASE('LINE')
C LINE (UP/DOWN)
         NPAR=1
         PD(1)=IDEF
         TEXT(1)='No. of lines'
      CASE('UNDO')
C UNDO
         NPAR=1
         PD(1)=IDEF
         TEXT(1)='Repeat up to the STEP'
      CASE('ANALYS')
C ANALYSIS
         NPAR=1
         PD(1)=1
         TEXT(1)='1-PIPE,2-UVP,3-PSI,4-FLUENT'
         WRITE(10,'('' Activate DOF for meshing and dialogs.'')')
      CASE('ACTNUM')
C ACTNUM
         NPAR=1
         PD(1)=1
         TEXT(1)='0-all,1-nd,2-el,3-pt,4-cr,5-sf'
      CASE('ACTSET')
C ACTSET
         NPAR=2
         PD(1:2)=(/IDEF,1/)
         TEXT(1:2)=(/'1-egroup,2-mprop,3-rconst','group no.'/)
         WRITE(10,'('' Activate groups for following meshing'')')
      CASE('STATUS')
C ACTNUM
         NPAR=1
         PD(1)=1
         TEXT(1)='1-FEM,2-MODEL,3-CURVES'
         WRITE(10,'('' Set status window (displays either FEM parameters
     /, model, or information about time curves'')')

CASES GEOM--

      CASE('ZDEF')
C ZDEF
         NPAR=1
         PD(1)=AUX(MAXAUX-2)
         TEXT(1)='Z-coordinate for following definitions'
      CASE('PT')
C PT
         NPAR=1
         PD(1)=IDEF
         TEXT(1)='PT index'
         IF(LAST.LT.3)
     /   WRITE(10,'('' Define points using mouse (L-click create PT, R-c
     /lick quit) at plane Z='',e9.2)')AUX(MAXAUX-2)
      CASE('PTXYZ')
C PTXYZ
         NPAR=4
         PD(1)=IDEF
	   PD(2:4)=(/XDEFA,YDEFA,ZDEFA/)
         TEXT(1:4)=(/'PT index','X','Y','Z'/)
         WRITE(10,'('' Define coordinates X,Y,Z of points PT'')')
      CASE('PTCR2')
C PTCR2 ic1 ic2
         NPAR=2
         PD(1:2)=(/NCR-1,NCR/)
         TEXT(1:2)=(/'First curve','Second curve'/)
         IPICK(1:2)=(/3,3/)
         IF(LAST.LT.NPAR)THEN
         CALL DRAWE(2)
         WRITE(10,'('' Points as intersections of two curves.'')')
         ENDIF
      CASE('CRSPOL')
C CRSPOLY
         NPAR=3
         PD(1:3)=(/NPT+1,NCR+1,0/)
         TEXT(1:3)=(/'PT index (first point)','CR index (first curve)',
     /               'Contour number'/)
         WRITE(10,'('' Define points and curves using mouse (L-click cre
     /ate PT and CR, R-click quit)''/'' It is possible to define quadrat
     /ic curves specifying mid-point by Ctrl+[L-click].'')')
         CALL DIAGRA('$CRSPOL.BMP')
      CASE('CR2PT')
C CR2PT
         NPAR=3
         PD(1:3)=(/IDEF,1,2/)
         TEXT(1:3)=(/ 'CR index','PT1','PT2'/)
         IPICK(2:3)=(/2,2/)
         IF(LAST.LT.NPAR)THEN
         CALL DRAWE(1)
         WRITE(10,'('' Define CuRve (line) from 2 points'')')
         ENDIF
      CASE('CR3PT')
C CR3PT
         NPAR=4
         PD(1:4)=(/IDEF,1,2,3/)
         TEXT(1:4)=(/ 'CR index','PT1(left)','PT2(right)','PT3(mid)'/)
         IPICK(2:4)=(/2,2,2/)
         IF(LAST.LT.NPAR)THEN
         CALL DRAWE(1)
         WRITE(10,'('' Define quadratic CuRve from 3 points'')')
         ENDIF
      CASE('CRNPT')
C CRNPT
         NPAR=3
         PD(1:3)=(/IDEF,1,NPT/)
         TEXT(1:3)=(/ 'CR first','PT first','PT last'/)
         IPICK(2:3)=(/2,2/)
         IF(LAST.LT.NPAR)THEN
         CALL DRAWE(1)
         WRITE(10,'('' Define sequence of curves from N-points'')')
         ENDIF
      CASE('CIRCLE')
C CIRCLE
         NPAR=5
         PD(1:5)=(/IDEF,1,2,4,0/)
         TEXT(1:5)=(/'CR first','PT-center','PT-zero deg',
     /'No.of segments','Index of contour'/)
         IPICK(2:3)=(/2,2/)
         IF(LAST.LT.NPAR)THEN
         CALL DRAWE(1)
         WRITE(10,'('' Define Circle from 2 points (center and one point
     / at perimeter) in the XY plane'')')
         ENDIF
      CASE('ARC')
C ARC ICURVE,ICENTER,IZERO,ANGLE,NSEG
         NPAR=5
         PD(1:5)=(/IDEF,1,2,30,1/)
         TEXT(1:5)=(/'CR first curve to be created','PT-center',
     /'PT-zero deg','Angle (deg)','No.of segments'/)
         IPICK(2:3)=(/2,2/)
         IF(LAST.LT.NPAR)THEN
         CALL DRAWE(1)
         WRITE(10,'('' Define Arc from 2 points (center and one point at
     / perimeter), and angle'')')
         ENDIF
      CASE('SF4PT')
C SF4PT
         NPAR=5
         PD(1:5)=(/IDEF,1,2,3,4/)
         TEXT(1:5)=(/ 'SF index','PT1','PT2','PT3','PT4'/)
         IPICK(2:5)=(/2,2,2,2/)
         IF(LAST.LT.NPAR)THEN
         CALL DRAWE(1)
         WRITE(10,'('' Define Surface by 4 corner points'')')
         ENDIF
      CASE('SF8PT')
C SF8PT
         NPAR=9
         PD(1:9)=(/IDEF,1,2,3,4,5,6,7,8/)
         TEXT(1:9)=(/'SF index','PT1','PT2','PT3','PT4',
     /               'pt5','pt6','pt7','pt8'/)
         IPICK(2:9)=(/2,2,2,2,2,2,2,2/)
         IF(LAST.LT.NPAR)THEN
         CALL DRAWE(1)
         WRITE(10,'('' Define curved surface by 8 points'')')
         ENDIF
      CASE('SF3PT')
C SF3PT
         NPAR=4
         PD(1:4)=(/IDEF,1,2,3/)
         TEXT(1:4)=(/ 'SF index','PT1','PT2','PT3'/)
         IPICK(2:4)=(/2,2,2/)
         IF(LAST.LT.NPAR)THEN
         CALL DRAWE(1)
         WRITE(10,'('' Define triangular Surface by 3 points'')')
         ENDIF
      CASE('SF6PT')
C SF6PT
         NPAR=7
         PD(1:7)=(/IDEF,1,2,3,4,5,6/)
         TEXT(1:7)=(/ 'SF index','PT1','PT2','PT3','pt4','pt5','pt6'/)
         IPICK(2:7)=(/2,2,2,2,2,2/)
         IF(LAST.LT.NPAR)THEN
         CALL DRAWE(1)
         WRITE(10,'('' Define triangular Surface by 3 vertices and 3 mid 
     /-points '')')
         ENDIF
      CASE('SFCR')
C SFCR
         NPAR=3
         PD(1:3)=(/IDEF,1,2/)
         TEXT(1:3)=(/ 'SF index','CR1','CR2'/)
         IPICK(2:3)=(/3,3/)
         IF(LAST.LT.NPAR)THEN
         CALL DRAWE(2)
         WRITE(10,'('' Define new surface by selecting 2 existing sides 
     /(all 4 curves must exist)'')')
         ENDIF

      CASE('VL8PT')
C VL8PT
         NPAR=9
         PD(1:9)=(/IDEF,1,2,3,4,5,6,7,8/)
         TEXT(1:9)=(/'VL index',
     /         'PT1 first side','PT2 first side',
     /         'PT3 first side','PT4 first side',
     /         'PT5 second side','PT6 second side',
     /         'PT7 second side','PT8 second side'/)
         IPICK(2:9)=(/2,2,2,2,2,2,2,2/)
         IF(LAST.LT.NPAR)THEN
         CALL DRAWE(1)
         WRITE(10,'('' Define volume by 8 corner points'')')
         ENDIF
      CASE('SFEXTR')
C SFEXTR
         NPAR=5
         PD(1:5)=(/IDEF,NSF,0,0,0/)
         TEXT(1:5)=(/'VL index','Extruded surface SF',
     /         'shift X','shift Y','shift Z'/)
         WRITE(10,'('' Volume created by a surface extrusion'')')
      CASE('VLSF')
C SFEXTR
         NPAR=3
         PD(1:3)=(/IDEF,1,2/)
         TEXT(1:3)=(/'VL index','Surface SF1','Surface SF2'/)
         WRITE(10,'('' Volume created from two opposite surfaces'')')
      CASE('ND  ')
         NPAR=0
         WRITE(10,'('' Define new nodes starting from index'',i7)')ND+1

CASES GROUP--

      CASE('EGROUP')
C EGROUP
         NPAR=3
         KELEM=MAX0(1,MIN0(KELEM,MAXELEM))
         PD(1:2)=(/IDEF,KELEM/)
         NAMED(2)=.TRUE.
         TTP(2)=TELEM(KELEM)
         IDIGR(2)=56
         TEXT(1:2)=(/'Egroup no.','Element name or index'/)
         WRITE(10,'('' Specify ALGORITHMS for an element group (E-name, 
     /Static/Transient,...)'')')
C Zvlastni pripad LAST>1, tj. napr. EGROUP 1,PIPE2D,1; v tom pripade je treba priradit default parametry dle 
C IP(1)-group, IP(2)-typ ale az ctvrtym parameterem pocinaje.
         IF(LAST.GE.2)THEN
           IG=MAX0(1,IP(2))
           IGR=MIN0(MAX0(1,IP(1)),MAXMGROUP)
           NPAR=NGROUP(IG)+1
           DO J=LAST,NGROUP(IG)
C IG-typ elementu, LGR-sloupec matice EGROUP
             LGR=LGROUP(IG,J)
             IF(LGR.GE.1.AND.LGR.LE.MAXNGROUP)THEN
                J1=J+1
                TEXT(J1)=TGROUP(LGR)
                PD(J1)=JGROUP(IGR,LGR)
             ENDIF
           ENDDO
         ENDIF
      CASE('MPROP')
C MPROP
         NPAR=3
         KELEM=MAX0(1,MIN0(KELEM,MAXELEM))
         PD(1:2)=(/IDEF,KELEM/)
         NAMED(2)=.TRUE.
         TTP(2)=TELEM(KELEM)
         TEXT(1:2)=(/'MPROP group no.','Element name'/)
         IDIGR(2)=56
         WRITE(10,'('' Specify MATERIAL PROPERTIES of element group'')')
      CASE('RCONST')
C RCGROUP
         NPAR=3
         KELEM=MAX0(1,MIN0(KELEM,MAXELEM))
         PD(1:2)=(/IDEF,KELEM/)
         NAMED(2)=.TRUE.
         TTP(2)=TELEM(KELEM)
         TEXT(1:2)=(/'RCONST group no.','Element name'/)
         IDIGR(2)=56
         WRITE(10,'('' Specify Real CONSTants for an element group'')')
C Zvlastni pripad, LAST>1
         IF(LAST.GE.2)THEN
	     IG=MAX0(1,IP(2))
           IGR=MIN0(MAX0(1,IP(1)),MAXMRCONS)
           NPAR=NRCONS(IG)+2
           DO J=LAST-1,NRCONS(IG)
              LRC=LRCONS(IG,J)
              IF(LRC.GE.1.AND.LRC.LE.MAXNRCONS)THEN
                 J2=J+2
                 TEXT(J2)=TRCONS(LRC)
                 PD(J2)=RRCONS(IGR,LRC)
                 IF(LRC.EQ.$D)PD(J2)=AMAX1(PD(J2),0.001)
              ENDIF
           ENDDO
         ENDIF
C RCHEX
      CASE('RCHEX')
         NPAR=3
         PD(1)=IDEF
         TEXT(1:3)=(/'RC group for Heat exchanger',
     /               'Heat transfer area to unit length of pipe',
     /               'Heat transfer coefficient'/)
         WRITE(10,'('' Specify Real CONSTants for heat exchanger'')')
         CALL DIAGRA('$HEXC.BMP')
      CASE('RCHEV')
         NPAR=3
         ISELSTEP=3
         PD(1:2)=(/MIN0(MGROUP+1,MAXMGROUP),MIN0(MRCONS+1,MAXMRCONS)/)
         TEXT(1:2)=(/'EGROUP no.','RCONST group no.'/)
         WRITE(10,'('' Specify parameters for a new CHEVRON-type heat ex
     /changer'')')
         CALL DIAGRA('$CHEVRON.BMP')
      CASE('RCEHEV')
         NPAR=2
         PD(1)=IDEF
         IPICK(1)=4
         TEXT(1)='Element no.'
         WRITE(10,'('' Specify parameters for CHEVRON-type heat exchange
     /r selected by mouse'')')
         CALL DIAGRA('$CHEVRON.BMP')
      CASE('RCSTUB')
         NPAR=3
         ISELSTEP=3
         PD(1:2)=(/MIN0(MGROUP+1,MAXMGROUP),MIN0(MRCONS+1,MAXMRCONS)/)
         TEXT(1:2)=(/'EGROUP no.','RCONST group no.'/)
         WRITE(10,'('' Specify parameters for a new shell and tube heat
     /exchanger'')')
         CALL DIAGRA('$STUBE.BMP')
      CASE('RCSTH')
         NPAR=3
         ISELSTEP=3
         PD(1:2)=(/MIN0(MGROUP+1,MAXMGROUP),MIN0(MRCONS+1,MAXMRCONS)/)
         TEXT(1:2)=(/'EGROUP no.','RCONST group no.'/)
         PD(1:2)=(/MIN0(MGROUP+1,MAXMGROUP),MIN0(MRCONS+1,MAXMRCONS)/)
         TEXT(1:2)=(/'EGROUP no.','RCONST group no.'/)
         WRITE(10,'('' Specify parameters for a new shell and tube heat
     /exchanger with helical baffles'')')
         CALL DIAGRA('$STUBEH.BMP')
      CASE('RCESTU')
         NPAR=3
         ISELSTEP=2
         PD(1)=IDEF
         IPICK(1)=4
         TEXT(1)='Element no.'
         WRITE(10,'('' Update parameters of existing shell and tube heat
     / exchanger'')')
         CALL DIAGRA('$STUBE.BMP')
      CASE('RCESTH')
         NPAR=3
         ISELSTEP=2
         PD(1)=IDEF
         IPICK(1)=4
         TEXT(1)='Element no.'
         WRITE(10,'('' Update parameters of existing shell and tube heat
     / exchanger with helical baffles'')')
         CALL DIAGRA('$STUBEH.BMP')
      CASE('RCPUMP')
         NPAR=3
         ISELSTEP=3
         PD(1:2)=(/MAX0(1,KGROUP),MAX0(1,KRCONS)/)
         TEXT(1:2)=(/'EGROUP no.','RCONST group no.'/)
         WRITE(10,'('' Selection RC and EG parameters of a pump from SIG
     /MA catalogue. Kind of pump:''/'' 0-any, 1-milk, 2-water treatment, 
     /3-feeding, 4-water, 5-food SPB, 6-screw pump''/'' All specificatio
     /ns in basic SI units.'')')
         CALL DIAGRA('$PUMP.BMP')
      CASE('RCEPUM')
         NPAR=2
         PD(1)=IDEF
         IPICK(1)=4
         TEXT(1)='Element no.'
         WRITE(10,'('' Selection a pump from SIGMA catalogue for existin
     /g element.'')')
         CALL DIAGRA('$PUMP.BMP')
      CASE('RCROSS')
         NPAR=3
         PD(1)=IDEF
         ISELSTEP=2
         TEXT(1:3)=(/'RCONST group no.','A-width','B-height'/)
         WRITE(10,'('' Define hydraulic diameter and cross section of a 
     /pipe, specifying dimensions of''/'' rectangular cross-section A x 
     /B. If the pipe is defined in XY plane,''/'' dimension A is in the 
     /Z-direction and B is in the plane XY.''/'' Remark: calculated para
     /meter AREA can be negative-the sign of AREA is used for resolving'
     /'/'' ambiguity between B x A and A x B.'')')
      CASE('FUNDEF')
C FUNDEF
         NPAR=2
         PD(1:2)=(/IFUN,1/)
         TEXT(1:2)=(/'Index of Function (-10:50)',
     /               'f(TIME,TEMP,XX,YY,UX,UY)'/)
         WRITE(10,'('' Define function as an expression, e.g. 2*XX*TIME.
     / The function will be refered by INDEX.''/'' This index can be wit
     /hin the range -10:50, negative values are used for variable''/'' b
     /oundary conditions, while positive values usually define initial c
     /onditions,''/'' variable material properties, hydraulic characteri
     /stics, variable loads etc.'')')
         IDIGR(1:2)=(/75,73/)
      CASE('CURDEF')
C CURDEF
         NPAR=19
         ISELSTEP=4
         PD(1)=IFUN
         PD(2:19)=PDD(2:19)
         TEXT(1:19)=(/
     / 'Index of function (-10:50)','0-time,1-x,2-y,3-z,4-temp,5-ux',
     /    'No of points (max 8)',
     /    'x1','y1','x2','y2','x3','y3','x4','y4','x5','y5','x6','y6',
     /    'x7','y7','x8','y8'/)
         WRITE(10,'('' Define table specifying x,y points (max.8)'')')
         IDIGR(1:2)=(/75,74/)
      CASE('FUNVAL')
C FUNVAL VARIABLE, INDEX of FUNCT
         NPAR=2
         PD(2)=1
         NAMED(1)=.TRUE.
         TTP(1)='A'
         TEXT(1:2)=(/'Variable','Index of function'/)
         WRITE(10,'('' Assignment Variable:=user defined function.'')')

      CASE('CTR')
C CTR
         NPAR=1
         PD(1)=IDEF
         TEXT(1)='Index of CONTOUR'
         WRITE(10,'('' Define CONTOUR as a list of curves (max.50). Use 
     /mouse (left-click)'')')
      CASE('CRN')
CRN      
         NPAR=3
         PD(1:2)=(/IDEF,5/)
         IPICK(1)=3
         PD(3)=1.
         TEXT(1:3)=(/'Index of curve','Nx','Last/First (+-)'/)
         WRITE(10,'('' Predefine parameters for meshing on a curve'')')
      CASE('INTGCR')
         NPAR=2
         PD(1:2)=(/IDEF,IFUN/)
         TEXT(1:2)=(/'Curve number','Index of function'/)
         WRITE(10,'('' Integrate selected function along a curve. Result
     / will be in the variable INTEGRAL.'')')
      CASE('INTGSF')
         NPAR=2
         PD(1:2)=(/IDEF,IFUN/)
         TEXT(1:2)=(/'Surface number','Index of function'/)
         WRITE(10,'('' Integrate selected function on a surface. Result
     /will be in the variable INTEGRAL.'')')
      CASE('INTEL')
         NPAR=5
         PD(1:5)=(/JDDOF,IFUN,1,NE,1/)
         TEXT(1:5)=(/'DOF-variable','multiplied by function',
     /               'first element','last element','step'/)
         WRITE(10,'('' Integrate DOF*selected function in elements. Resu
     /lt will be in the variable INTEGRAL.'')')

CASES MESH--
      CASE('MVL')
C MVL
         NPAR=11
         PD(1:4)=(/IDEF,1,1,1/)
         PD(5:7)=(/1.,1.,1./)
         PD(8:11)=(/8,0,1,0/)
         TEXT(1:11)=(/'Volume no.','NX','NY','NZ',
     /   'Last/first X','Last/first Y','Last/first Z',
     /   'Nodes of element (8 or 20)','VL last','VL step','No of inner n
     /odes'/)
         WRITE(10,'('' Volume parametric meshing. 8 or 20 nodal elements
     / can be generated'')')
      CASE('MSF')
C MSF
         NPAR=2
         PD(1)=IDEF
         TEXT(1)='SF index'
         IF(LAST.LT.NPAR)THEN
         CALL DRAWE(3)
         WRITE(10,'('' Mesh selected surface (triagles or quadrilaterals
     /)'')')
         ENDIF
      CASE('MCT')
C MCTS
         NPAR=5
         PD(1:5)=(/1,30,30,NUTR,0/)
         TEXT(1:5)=(/'No.of contours','No.of x-grid intervals',
     /               'No.of y-grid intervals','No.of element nodes',
     /               'No.of internal nodes'/)
         WRITE(10,'('' Mesh interior of a region defined by contours-the
     / first is outer and''/'' following contours are inner. This method
     / generates uniform triangles.''/'' Only the triangles crossing bou
     /ndary of region are modified.'')')
         CALL DIAGRA('$MCT.BMP')
      CASE('MRG')
C MRG
         NPAR=8
         PD(1:6)=(/1,NUTR,0,NUCR,MITER,0/)
         PD(7:8)=(/WEIGHT,SIZE/)
         TEXT(1:8)=(/'Index of contour',
     /               'No.of element nodes',
     /               'No.of internal nodes',
     /               'Default number of nodes on a curve',
     /               'Smoothing interations',
     /               'Refine mesh (4 times)',
     /               'Attractivity of boundary points (1-5)',
     /               'Control (0.95-1.1 small/big triangles)'/)
         WRITE(10,'('' Meshing interior of a region defined by one conto
     /ur by triangles (3 or 6 nodes).'')')
         CALL DIAGRA('$MRG.BMP')
      CASE('MPT')
C MPT
         NPAR=6
         PD(1:5)=(/1,NPT,1,NUTR,0/)
         PD(6)=1.
         TEXT(1:6)=(/'Fist PT','Last PT','Step PT',
     /               'No.of element nodes',
     /               'No.of internal nodes','Control (0-2)'/)
         WRITE(10,'('' Triangular mesh from key points (nodes will be cr
     /eated from PT).''/'' Parameter CONTROL can be 0-2'')')
      CASE('MND')
C MND
         NPAR=6
         PD(1:5)=(/1,ND,1,NUTR,0/)
         PD(6)=1.
         TEXT(1:6)=(/'Fist ND','Last ND','Step ND',
     /               'No.of element nodes',
     /               'No.of internal nodes','Control (0-2)'/)
         WRITE(10,'('' Triangular mesh from defined nodes (usually read 
     /from a file by READ).''/'' Parameter CONTROL can be 0-2'')')
      CASE('MCR')
C MCR
         NPAR=7
         PD(1:2)=(/IDEF,MAX0(NX,1)/)
         PD(3)=XLAFI
         PD(4:7)=(/NUCR,0,0,1/)
         TEXT(1:7)=(/'CR index','Nx','Last/First(+ one side, - sym.)',
     /    'No.of Nodes (2,3)','RC-group','CR last','CR step'/)
         IPICK(1)=3
         IPICK(6)=3
         IF(LAST.LT.NPAR)THEN
         CALL DRAWE(2)
         WRITE(10,'('' Mesh curve by default 2-3 node elements (can be a
     /pplied for SHELLAX,TRUSS,PIPES,CSTR,...)'')')
         ENDIF
      CASE('MCR2')
C MCR2 vymenik tepla
         NPAR=10
         PD(1:10)=(/IDEF,IDEF+1,MAX0(NX,1),
     /             MPIPE,MPIPE,IRPIPE,IRPIPE,IRHEX,IGPIPE,IGHEX/)
        TEXT(1:10)=(/'CR1 index','CR2 index','No elements on one curve',
     /           'Mprop group-pipe1', 'Mprop group-pipe2',
     /           'RConst group-pipe1','RConst group-pipe2',
     /           'RC-heat exchanger','EGROUP-pipes','EGROUP-exchanger'/)
         IPICK(1:2)=(/3,3/)
         IF(LAST.LT.NPAR)THEN
         CALL DRAWE(2)
         WRITE(10,'('' Mesh pair of curves by HEAT-Exchanger elements (p
     /airs of PIPE elements''/'' as well as 4-nodal conectivity elements
     / will be created).'')')
         ENDIF
      CASE('MCR4')
C MCR4 vymenik tepla
         NPAR=4
         PD(1:4)=(/IDEF,IDEF+1,IRHEX,IGHEX/)
         TEXT(1:4)=(/'CR1 index','CR2 index',
     /               'RC-heat exchanger','EGROUP-exchanger'/)
         IPICK(1:2)=(/3,3/)
         IF(LAST.LT.NPAR)THEN
         CALL DRAWE(2)
         WRITE(10,'('' Connects PIPE elements on a pair of curves by 4-n
     /odal HEAT-Exchanger elements.'')')
         ENDIF
      CASE('E')
         NPAR=9
         PD(1)=IDEF
         TEXT(1)='Number of nodes'
         DO I=2,NPAR
            WRITE(TEXT(I),'(i2,''. node index'')')I-1
            PD(I)=I-1
            IPICK(I)=1
         ENDDO
         WRITE(10,'('' Define new element number ['',i6,''],from existin
     /g nodes.''/'' Parameters EGROUP='',I2,'' RC='',I2,'' MPROP='',I2,'
     /'. Analysis type='',I2,''.'')')NE+1,KGROUP,KRCONS,KMPROP,KANAL
         IF(KGROUP.GE.0.AND.JGROUP(KGROUP,$ENAME).GT.0)
     /   WRITE(10,'('' Egroup corresponds to the element type:'',A8)')
     /   TELEM(JGROUP(KGROUP,$ENAME))
      CASE('ERMSF')
C ERMSF SF, EGROUP, RCONST, MPROP
         NPAR=4
         PD(1:4)=(/IDEF,KGROUP,KRCONS,KMPROP/)
         TEXT(1:4)=(/'Surface no.','EGROUP','RCONST','MPROP'/)
         WRITE(10,'('' Change group numbers of elements inside a surface
     /'')')
      CASE('ERMOD')
C ERMOD circle/box, center, radius, EGROUP, RCONST, MPROP
         NPAR=6
         PD(1:6)=(/IDEF,1,1,KGROUP,KRCONS,KMPROP/)
         IPICK(2)=2
         TEXT(1:6)=(/'Sphere(0)/Box(1)','Center point','Radius [m]',
     /'EGROUP','RCONST','MPROP'/)
         WRITE(10,'('' Change group numbers of elements inside a SPHERE 
     /or a CUBE'')')
         CALL DIAGRA('$ERMOD.BMP')
      CASE('ERMEL')
C ERMEL element EGROUP,RCONST,MPROP
         NPAR=4
         PD(1:4)=(/IDEF,KGROUP,KRCONS,KMPROP/)
         IPICK(1)=4
         TEXT(1:4)=(/'Element no.','EGROUP','RCONST','MPROP'/)
         WRITE(10,'('' Change group numbers of selected element'')')
      CASE('NMERGS')
C NMERGS nodes in a box
         NPAR=6
         PD(1:6)=(/0.,0.,0.,0.,-1e6,1e6/)
         TEXT(1:6)=(/'Xmin','Xmax','Ymin','Ymax','Zmin','Zmax'/)
         WRITE(10,'('' Merge nodes inside a rectangular box.'')')
      CASE('ATTACH')
	   NPAR=2
	   PD(1)=IDEF
	   PD(2)=TOLERANCE
	   TEXT(1:2)=(/'Index of curve','maximum distance'/)
	   WRITE(10,'('' Move nodes, having distance from a selected curve 
     /less than the prescribed tolerance''/'' to the curve.'')')
CASES FORCES--

      CASE('NFCR')
C NFCR
         NPAR=6
         JDDOF=MIN0(MAXTDOF,MAX0(1,JDDOF))
         PD(1:3)=(/IDEF,JDDOF,-1/)
         NAMED(2)=.TRUE.
         TTP(2)=TDOF(JDDOF)
         PD(4:6)=(/P1,P2,P3/)    
         TEXT(1:6)=(/'CR index',
     /               'DOF:Temp,Ux,..,Rx,..,Vx,..,Pres,Ps,Psx,..',
     /               'status (<0-Boundary Condition,>0-load)',
     /               'P1(left)','P2(right)','P3(midpoint)'/)
         IPICK(1)=3
         IF(LAST.LT.NPAR)THEN
           CALL DIAGRA('$NFCR.BMP')
C          CALL DRAWE(2)
           WRITE(10,'('' Specify DOF or LOAD in nodes on a curve'')')
         ENDIF
      CASE('NFCT')
C NFCT
         NPAR=4
         JDDOF=MIN0(MAXTDOF,MAX0(1,JDDOF))
         PD(1:3)=(/IDEF,JDDOF,-1/)
         NAMED(2)=.TRUE.
         TTP(2)=TDOF(JDDOF)
         PD(4)=P1    
         TEXT(1:4)=(/'CT contour index',
     /               'DOF:Temp,Ux,..,Rx,..,Vx,..,Pres,Ps,Psx,..',
     /               'status (<0-Boundary Condition,>0-load)',
     /               'DOF value along contour'/)
         IF(LAST.LT.NPAR)THEN
C          CALL DRAWE(2)
           WRITE(10,'('' Specify DOF or LOAD in nodes on a curve'')')
         ENDIF
      CASE('NFSF')
C NFSF
         NPAR=11
         JDDOF=MIN0(MAXTDOF,MAX0(1,JDDOF))
         PD(1:3)=(/IDEF,JDDOF,-1/)
         NAMED(2)=.TRUE.
         TTP(2)=TDOF(JDDOF)
         PD(4:11)=(/P1,P2,P3,P4,P5,P6,P7,P8/)    
         TEXT(1:11)=(/'SF index',
     /               'DOF:Temp,Ux,..,Rx,..,Vx,..,Pres,Ps,Psx,..',
     /               'status (<0-Boundary Condition,>0-load)',
     /               'P1','P2','P3','P4','P5m','P6m','P7m','P8m'/)
         IF(LAST.LT.NPAR)THEN
         CALL DRAWE(3)
         WRITE(10,'('' Specify DOF or LOAD in nodes inside surface'')')
         ENDIF
      CASE('NF')
C NF
         NPAR=4
         JDDOF=MIN0(MAXTDOF,MAX0(1,JDDOF))
         PD(1:3)=(/IDEF,JDDOF,-1/)    
         NAMED(2)=.TRUE.
         TTP(2)=TDOF(JDDOF)
         PD(4)=P1
         TEXT(1:4)=(/ 'ND index',
     /     'DOF:Temp,Ux,..,Rx,..,Vx,..,Pres,Ps,Psx,..',
     /     'status (<0-Boundary Condition,>0-load)','Value'/)
         IPICK(1)=1
         IF(LAST.LT.NPAR)THEN
           WRITE(10,'('' Specify DOF or LOAD in a node'')')
           CALL DIAGRA('$NF.BMP')
         ENDIF
      CASE('NFPT')
C NFPT
         NPAR=4
         JDDOF=MIN0(MAXTDOF,MAX0(1,JDDOF))
         PD(1:3)=(/IDEF,JDDOF,-1/)    
         NAMED(2)=.TRUE.
         TTP(2)=TDOF(JDDOF)
         PD(4)=P1
         TEXT(1:4)=(/ 'PT index',
     /     'DOF:Temp,Ux,..,Rx,..,Vx,..,Pres,Ps,Psx,..',
     /     'status (<0-Boundary Condition,>0-load)','DOF value'/)
         IPICK(1)=2
         IF(LAST.LT.NPAR)THEN
           WRITE(10,'('' Specify DOF or LOAD in a point'')')
           CALL DIAGRA('$NFPT.BMP')
         ENDIF
      CASE('INLET')
C INLET
         NPAR=4
         PD(1:2)=(/IDEF,-1/)
         PD(3)=1.
         PD(4)=0
         TEXT(1:4)=(/'CR index',
     /               'status (<0-fixed values)',
     /               'u-mean [m/s]','type (0-slit,1-circ.,2,3-flat)'/)
         IPICK(1)=3
         IDIGR(4)=90
         IF(LAST.LT.NPAR)THEN
         CALL DRAWE(2)
         WRITE(10,'('' Specify velocity profile (VX,VY,PS,PSX,PSY,OMG) a 
     /t inlet nodes.''/'' Laminar or uniform velocity profile. Stream fu
     /nction begins at PSWALL='',E10.3)')$PSWALL
         ENDIF
      CASE('WALL')
C WALL
         NPAR=2
         PD(1:2)=(/IDEF,-1/)
         TEXT(1:2)=(/'CR index',
     /               'status (<0-fixed ZERO values)'/)
         IPICK(1)=3
         IF(LAST.LT.NPAR)THEN
         CALL DRAWE(2)
         WRITE(10,'('' Specify velocities and stream function at wall (z 
     /ero velocities).''/'' Stream function is system variable PSWALL=''
     /,e10.3)') $PSWALL
         ENDIF
      CASE('INITIA')
C INITIA
         NPAR=2
         JDDOF=MIN0(MAXTDOF,MAX0(1,JDDOF))
         PD(1:2)=(/JDDOF,IFUN/)
         NAMED(1)=.TRUE.
         TTP(1)=TDOF(JDDOF)
         TEXT(1:2)=(/ 
     /     'DOF:Temp,Ux,..,Rx,..,Vx,..,Pres,Ps,Psx,..',
     /     'Function (-10:50),(101:105),(-105:-101)'/)
         IF(LAST.LT.NPAR)
     /   WRITE(10,'('' Assignment of initial conditions using specified 
     /function.''/'' It is possible to use simple functions within the r
     /ange of indices -10:50 (DUNDEF,CURDEF)''/'' or more complicated fu
     /nctions, identified by indices 101:105, which are to be defined''/
     /'' as an active model (the command RM reads the model from a scrip
     /t file *.MDT).'')')
      CASE('MOFE')
         NPAR=2
         PD(1:2)=(/IDEF,1/)
         TEXT(1:2)=(/'DOF:TEMP,UX,UY,...',
     /               'Mean DOF transferred into EPAR(1:5)'/)
         WRITE(10,'('' Mean values of a selected DOF are calculated in e
     /ach element and transfered into''/'' selected column of EPAR (matr
     /ix of element parameters)'')')
CASES FEM--
      CASE('BOX')
         NPAR=1
         PD(1)=$RBOXRATIO
         TEXT(1)='Box size (0.01-1)'
         WRITE(10,'('' Cartesian boxing. File $RUNBOX.BIN will be create
     /d.''/'' This file assigns index of element to voxels dx,dy,dz and 
     /therefore enables to identify an element''/'' containing arbitrary
     / point x,y,z.'')')
         CALL DIAGRA('$BOX.BMP')
      CASE('BOXTES')
         NPAR=5
         PD(1:3)=(/XDEFA,YDEFA,ZDEFA/)
         PD(4:5)=(/JDDOF,IZONE/)
         TEXT(1:5)=(/'X','Y','Z','DOF','Zone [1-4]'/)
         WRITE(10,'('' Testing $RUNBOX.BIN. Range X('',2E12.5,'')  Y('',
     /2E12.5,'')'')')XBOXMI,XBOXMA,YBOXMI,YBOXMA
      CASE('OPTION')
C OPTION
         NPAR=27
         PD(1:3)=(/$RGX,$RGY,$RGZ/)
         PD(4)=$ISOURCE
         PD(5)=$RUPW
         PD(6)=$IFOUL
         PD(7)=$IHEPI
         PD(8)=IALGOR(7)
         PD(9)=$REPSPIV
         PD(10)=$RELFAKT
         PD(11)=$RPENFAKT
         PD(12)=$RTHETA
         PD(13)=$RTAUDISP
         PD(14)=$BL
         PD(15)=$IBUOY
         PD(16)=$IPHASE
         PD(17)=$IVOLU
         PD(18)=RALGOR(11)
         PD(19)=RALGOR(15)
         PD(20:26)=IALGOR(21:27)
         PD(27)=$IFUN
         TEXT(1:27)=(/'gx [m/s^2]',
     /                'gy [m/s^2]',
     /                'gz [m/s^2]',
     /                'Source, e.g.ohmic (0-supressed)',
     /                'Upwind factor (0-1)',
     /                'Fouling (1-Ebert,>1 user function)',
     /                'MWR (0), Enthalpy (1), Convect.(2)',
     /                'Elimination treshold 5-50',
     /                'Minimum pivot for elimination',
     /                'Underrelaxation factor (0-1)',
     /                'Lambda for penalty method',
     /                'Theta (1-implicit,0-explicit)',
     /                'Tau-time constant of dispersion',
     /                'Boundary layer reduction coeff.',
     /                'Buoyancy (0-no,1-dens.,2-Boussin.)',
     /                'Phase change (0-cp(T),1-enthalpy)',
     /                'Mass (0), volumetric (1) flowrates',
     /                'Residuals for temperature',
     /                'Residuals for velocities',
     /                'ELEC iter.voltage',
     /                'FLOW iter.flow',
     /                'THER iter.temperature',
     /                'CONC iter.concentration',
     /                'COND iter.concentration',
     /                'CONA iter.concentration',
     /                'STAT iter.stress',
     /                'Function called at time step'/)
         WRITE(10,'('' Specify parameters for SOLUTION. These parameters
     / are also in the dialog SOLUTION->OPTION.''/'' Most of parameters
     /are defined as simple variables, e.g. GY-gravity,''/'' and therefo
     /re you can change or check their values by GY=9.81 or DISP GY.''/'
     /' The names of variables will be shown in the window DIALOG.'')')
         IDIGR(4:18)=(/21,22,23,24,25,26,27,28,29,30,31,32,33,34,35/)
      CASE('ACCURA')
         NPAR=10
         DO I=1,NPAR
            PD(I)=RALGOR(I+10)
         ENDDO
         TEXT(1:10)=(/'EPS temperature','EPS displacement','EPS  rotatio
     /n','EPS voltage','EPS velocity','EPS pressure','EPS omega',
     /'EPS stream function','EPS stream f.derivative','EPS cn'/)
         WRITE(10,'('' Relative accuracy tested in iteration loops in ea
     /ch time step'')')
      CASE('SOLVE')
C THERMAL
         NPAR=11
         PD(1:3)=(/TIME,FLOAT(NTSTEP),DTIME/)
         PD(4)=IAPPEND
         PD(5:11)=IALGOR(21:27)
         TEXT(1:11)=(/'Initial Time','No. of time steps','dt [s]',
     /'Append (0-clear EPA,1-old EPA,2-continue)',
     /'Iter voltage','Iter flow','Iter thermal','Iter concentration CN',
     /'Iter concentration CD','Iter concentration CA','Iter stress'/)
         WRITE(10,'('' FEM solution in defined time steps (voltage,flow,
     /temperature,concentration,stress)''/
     /'' Option APPEND defines initial actions (concerns files '',A,''.O
     /UT '',A,''.TEP):''/
     /'' (0) Open new OUT-file (DOF), new TEP-file (EPARameters) and cle 
     /ar EPARameter matrix''/
     /'' (1) Open new OUT-file,new TEP-file but old EPARameters are pres
     /erved''/
     /'' (2) Continuation of old OUT-file and TEP-file.'')')
     /TRIM(PROBLEM),TRIM(PROBLEM)
      CASE('TRUSS ')
C MONTE CARLO FOR TRUSSES
         NPAR=2
         PD(1:2)=(/FLOAT(IDEF),DTIME/)
         TEXT(1:2)=(/'Number of random trials','Increment U'/)

CASES MODEL--

      CASE('TSTEP')
C TIME STEPS
         NPAR=2
         IF(NTSTEP.GT.0)THEN
            PD(1)=NTSTEP
         ELSEIF(NGR.GT.0)THEN
            PD(1)=NGR
         ELSE
            PD(1)=1
         ENDIF
         IF(DTIME.GT.0.)THEN
            PD(2)=DTIME
         ELSEIF(NGR.GT.1)THEN
            PD(2)=(YGR(NGR,1)-YGR(1,1))/(NGR-1)
         ELSE
            PD(2)=1.
         ENDIF
         TEXT(1:2)=(/'No. of time steps','Time step dt [s]'/)
	CASE('TMAX')
	   NPAR=1
	   IF(NGR.GT.0.AND.NGR.LE.MAXNTS)THEN
	      PD(1)=YGR(NGR,1)
	   ELSE
	      PD(1)=1
	   ENDIF
	   TEXT(1)='t-max'
	CASE('TCNT')
	   NPAR=1
	   PD(1)=(NGR+1)/2
         TEXT(1)='New number of points'
	   WRITE(10,'('' Recalculate columns C2,C3,...C10 to a new number 
     /of rows, with a constant time step.''/'' New time step will be cal
     /culated as the difference (tmax-tmin)/n. Current n='',i4)')NGR
	CASE('TCDT')
	   NPAR=1
	   PD(1)=DTIME
         TEXT(1)='New time step'
	   WRITE(10,'('' Recalculate columns C2,C3,...C10 to a new time st
     /ep.  Number of rows will be adjusted''/'' so that the time range w
     /ould be preserved. Current time step='',E10.3)')DTIME
      CASE('PARDEF')
         NPAR=MAX0(2,NUMODP+1)
         PD(1)=NUMODP
         TEXT(1)='Number of model parameters'
         WRITE(10,'('' Specify number and location of parameters which a
     /re to be optimised by OPTIMA or SOMA.''/'' Location is specified b
     /y name of system variables, e.g. A,B,...,-user variables,''/
     /'' XPT(2)-coord.of points, VISC(1)-material params, RP(1),IP(2)-pa
     /rameters of RTD models...''/'' Hint: You can see the list of syste
     /m variables by pressing [F2].'')')
      CASE('PARLIM')
C nastaveni MEZI parametru aktivniho modelu
         NPAR=2*NUMODP
         DO I=1,NUMODP
           PD(2*I-1)=ZMINP(I)
           PD(2*I)=ZMAXP(I)
           TEXT(2*I-1)=TRIM(VARTXT(I))//' MIN '//TRIM(MODPARTXT(I))
           TEXT(2*I)=TRIM(VARTXT(I))//' MAX '//TRIM(MODPARTXT(I))
         ENDDO
         WRITE(10,'('' Set lower and upper bound of parameters (number o
     /f parameters='',i2)')NUMODP
      CASE('PARFIT')
C nastaveni pozadavku na regresi aktivniho modelu a default hodnoty
         NPAR=3*NUMODP
         DO I=1,NUMODP
           PD(3*I-1)=KMODEL(I)
      TEXT(3*I-1)='0-fixed,1-linear,2-Marquardt,3-Golden sect,>3 steps'
           PD(3*I)=1
           TEXT(3*I)='Relaxation param.(0,1)'
           IF(LMODEL(I).GT.0)THEN
              TEXT(3*I-2)=TRIM(VARTXT(I))//' '//TRIM(MODPARTXT(I))
              IF(JMODEL(I).EQ.1)THEN
                 PD(3*I-2)=REALRC(LMODEL(I))
              ELSE
                 PD(3*I-2)=INTERC(LMODEL(I))
              ENDIF
           ENDIF
         ENDDO
         WRITE(10,'('' Set default values of model parameters and requir
     /ement for params.optimisation:''/'' 0-fixed parameter, 1-linear pa
     /rameter, 2-nonlinear, 3-line search (nonderivative).''/'' Relaxati
     /on parameter multiplies calculated parameter increment.'')')

	CASE('PARLAB')
C Popis parametru modelu (text)
         NPAR=NUMODP
	   DO I=1,NUMODP
            NAME(I)=.TRUE.
	      NAMED(I)=.TRUE.
            TTP(I)=MODPARTXT(I)
	      TEXT(I)=TRIM(VARTXT(I))
	   ENDDO
	   WRITE(10,'('' Describe previously defined model parameters as a 
     / text'')')

      CASE('PARSET')
C nastaveni default hodnot parametru modelu
         NPAR=NUMODP
         DO I=1,NUMODP
           IF(LMODEL(I).GT.0)THEN
              TEXT(I)=TRIM(VARTXT(I))//' '//TRIM(MODPARTXT(I))
              IF(JMODEL(I).EQ.1)THEN
                 PD(I)=REALRC(LMODEL(I))
              ELSE
                 PD(I)=INTERC(LMODEL(I))
              ENDIF
           ENDIF
         ENDDO
         WRITE(10,'('' Set default values of model parameters (starting 
     /values for OPTIMA or SOMA''/'' or new values for IMPULS, CONVOL, I
     /NTEGR)'')')
      CASE('METHOD')
         CALL DIAGRA('$RESPON.BMP')
         NPAR=4
         PD(1:3)=(/METHOD,NEQUAT,NTSTEP/)
         PD(4)=DTIME
         TEXT(1:4)=(/'M: 0-Euler,>0-RK fix.dt,<0-variab.step',
     /               'no.of equations',
     /               'no.of basic time steps','basic time step'/)
         WRITE(10,'('' Method of integration (dif.eqs.model), specified 
     /by parameter M: Euler for basic time''/'' step (M=0), Runge Kutta
     / with step DT/M (for M>0), or variable time step (eps=10**M).''/
     /'' Time step DT=0 preserves predefined times ti in the first colum
     /n of MOP (C1).'')')
      CASE('INPUT')
         NPAR=NINPUTS+1
         TEXT(1)='Number of stimulus functions X'
         PD(1)=NINPUTS
         DO I=1,MAXINPUTS
           PD(I+1)=MINPUTS(I)
           WRITE(CH,'(I1)')I
           TEXT(I+1)='Index of TC as input X'//CH
         ENDDO
         WRITE(10,'('' Select TC-curves as input functions X(i,t), i=1,.
     /..'',i2)') MAXINPUTS
         CALL SHOWTC(10)
      CASE('OUTPUT')
         NPAR=NOUTPUTS+1
         PD(1)=NOUTPUTS
         TEXT(1)='Number of response functions Y'
         DO I=1,MAXOUTPUTS
           PD(I+1)=MOUTPUTS(I)
           WRITE(CH,'(I1)')I
           TEXT(I+1)='Index of TC as response Y'//CH
         ENDDO
         WRITE(10,'('' Select TC functions as responses Y(i,t), i=1,...'
     /',i2)')MAXOUTPUTS
         CALL SHOWTC(10)
      CASE('LINREG')
C LINREG MREG COLUMN-X COLUMN-Y COLUMP-YP COLUMN-SIG         
         NPAR=5
         PD(1:5)=(/MREG,ICOLX,ICOLY,ICOLYP,ICOLSIG/)
         TEXT(1:5)=(/'Degree of polynomial','Column of X','Column of Y',
     /               'Column of prediction','Column of sigma (>0)'/)
         WRITE(10,'('' Linear polynomial regression (data from observati
     /on matrix)''/'' High sigma decreases weights of corresponding poin
     /ts.'')')
      CASE('LAGREG')
C LAGREG MREG COLUMN-X COLUMN-Y COLUMP-YP COLUMN-SIG         
         NPAR=5
         PD(1:5)=(/MREG,ICOLX,ICOLY,ICOLYP,ICOLSIG/)
         TEXT(1:5)=(/'Degree of polynomial','Column of X','Column of Y',
     /               'Column of prediction','Column of sigma (>0)'/)
         WRITE(10,'('' Laguerre function regression (data from observati
     /on matrix)''/'' High sigma decreases weights of corresponding poin
     /ts.'')')
      CASE('NELREG')
C NELREG MREG COLUMN-X COLUMN-Y COLUMP-YP COLUMN-SIG         
         NPAR=5
         PD(1:5)=(/MREG,ICOLX,ICOLY,ICOLYP,ICOLSIG/)
      TEXT(1:5)=(/'Model (0-unknown,1-exp,2-double exp,3-Gauss,4-...)',
     /               'Column of X','Column of Y',
     /               'Column of prediction','Column of sigma (>0)'/)
         WRITE(10,'('' Nonlinear regression (data from observation matri
     /x)''/'' MODEL=0 best model selection, =1 exponential, =2 two expon
     /entials, =3 Gauss''/'' =4 rational, =5 logistics, =6 series, =7 ax
     /ial dispersion I., =8 axial disp.II (t^3/2),''/'' =9 sin, =10 sin+
     /linear, =11 sin+sin, =12 power law, ...'')')
         CALL DIAGRA('$NELREG.BMP')
      CASE('NLR2')
C NLR2  COLUMN-X1 COLUMN-X2 COLUMN-Y COLUMP-YP COLUMN-SIG         
         NPAR=6
         PD(1:6)=(/MREG,ICOLX,ICOLX2,ICOLY,ICOLYP,ICOLSIG/)
         TEXT(1:6)=(/'Model (0-unknown,1-linear,2-expon,3-power,...)',
     /               'Column of X1','Column of X2','Column of Y',
     /               'Column of prediction','Column of weights (>0)'/)
         WRITE(10,'('' Nonlinear regression with two independent variabl
     /es,e.g. Y=a1+a2*x1^a3*x2^a4''/'' Data are in the observation matri
     /x (X1,X2,Y,Yprediction,Sigma)''/'' MODEL=0 best model selection, =
     /1 linear, =2 bilinear, =3 quadratic,''/'' =4 exponential, =5,6 pow
     /er law, =7 rational, =8,9 power-exp, =10,11 Gauss'')')
         CALL DIAGRA('$NLR2.BMP')
      CASE('OPTIMA')
C OPTIMA IMODEL, ITER
         NPAR=5
         PD(1:3)=(/MOP,ITER,IALGOR(17)/)
         PD(4:5)=(/RALGOR(36),RALGOR(37)/)
         TEXT(1:5)=(/'Model (=0,1,2 ODE, =3,... file)',
     /               'No of iterations','parameter scaling [1]',
     /               'lambda increase [>1]','lambda decrease [<1]'/)
         WRITE(10,'('' Minimisation sum of squares in'',i2,'' pairs of c
     /olumns of observation matrix ('',2I3,'').''/'' Optimised model can
     / be either system of ordinary differential equations (MOD-file)''/
     /'' or any sequence of FEM calculations described in a SESion-file.
     /''/'' Total number of model parameters is'',i2,'':'',10(A6,1x))')
     /NCOMPAR,ICOMPAR(1,1),ICOMPAR(2,1),NUMODP,(VARTXT(I),I=1,NUMODP)
          IDIGR(1:6)=(/82,81,84,83,0,80/)
          IF(NUMODP.LE.0)CALL HELPC(4,'Use PARDEF to define optimised pa
     /rameters')
          IF(NCOMPAR.LE.0.OR.ICOMPAR(2,1).LE.0)CALL HELPC(4,'Use COMPAR, 
     /CRITER to define compared columns')
      CASE('SOMA')
C SOMA IMODEL, ITER, NSPEC, PRT, STEP, MASS, weigt
         NPAR=7
         PD(1:3)=(/MOP,ITER,3/)
         PD(4:7)=(/.9,.3,2.5,0.8/)
         TEXT(1:7)=(/'Model (=0,1,2 ODE, =3,... file)',
     /             'No of iterations','Specimens (>2)','Perturb (0,1)',
     /             'Step (0.11 - .9)','MASS (1.1-3)','Weight of initial 
     /estimate (0,1)'/)
         WRITE(10,'('' SOMA migration algorithm for optimisation.'')')
         WRITE(10,'('' Minimisation sum of squares in'',i2,'' pairs of c
     /olumns of observation matrix ('',2I3,'').''/'' Optimised model can
     / be either system of ordinary differential equations (MOD-file)''/
     /'' or any sequence of FEM calculations described in a SESion-file.
     /''/'' Total number of model parameters is'',i2,'':'',10(A6,1x))')
     /NCOMPAR,ICOMPAR(1,1),ICOMPAR(2,1),NUMODP,(VARTXT(I),I=1,NUMODP)
         IDIGR(1:6)=(/82,85,0,86,87,88/)
         IF(NCOMPAR.LE.0.OR.ICOMPAR(2,1).LE.0)CALL HELPC(4,'Use COMPAR, 
     /CRITER to define compared columns')
      CASE('NELDER')
C SOMA IMODEL, ITER, ALFA,BETA,GAMA
         NPAR=6
         PD(1:3)=(/MOP,ITER,1/)
         PD(4:6)=(/1.8,.3,.3/)
         TEXT(1:6)=(/'Model (=0,1,2 ODE, =3,... file)',
     /         'No of iterations',
     /         'No of steps in 1D optimisation',
     /         'Expansion (>1)','Contraction (0,1)',
     /         'Simplex reduction (0-1)'/)
         WRITE(10,'('' NELDER MEAD algorithm for optimisation.'')')
         WRITE(10,'('' Minimisation sum of squares in'',i2,'' pairs of c
     /olumns of observation matrix ('',2I3,'').''/'' Optimised model can
     / be either system of ordinary differential equations (MOD-file)''/
     /'' or any sequence of FEM calculations described in a SESion-file.
     /''/'' Total number of model parameters is'',i2,'':'',10(A6,1x))')
     /NCOMPAR,ICOMPAR(1,1),ICOMPAR(2,1),NUMODP,(VARTXT(I),I=1,NUMODP)
         IDIGR(1:6)=(/82,0,0,91,92,93/)
         IF(NCOMPAR.LE.0.OR.ICOMPAR(2,1).LE.0)CALL HELPC(4,'Use COMPAR, 
     /CRITER to define compared columns')
      CASE('RANDOM')
C RANDOM IMODEL, ITER
         NPAR=2
         PD(1:2)=(/MOP,ITER/)
         TEXT(1:2)=(/'Model (=0,1,2 ODE, =3,... file)',
     /             'No of iterations'/)
         WRITE(10,'('' RANDOM search.'')')
         IF(NCOMPAR.LE.0.OR.ICOMPAR(2,1).LE.0)CALL HELPC(4,'Use COMPAR, 
     /CRITER to define compared columns')

      CASE('GMOD')
C GMODEL
         NPAR=7
         PD(1:2)=(/MOP,INDPAR/)
         PD(3:4)=(/PARMI,PARMA/)
	   PD(5:7)=(/5,ICOLYP,0/)
         TEXT(1:7)=(/'Model (=0,1,2 ODE, =3,... file)',
     /             'Index of changed parameter','Pmin','Pmax',
     /             'No of changes','Column of MOP','Colour'/) 
         WRITE(10,'('' Graph of model prediction. Select one of the foll
     /owing parameters which is to be changed:''/9(I2,1X,A4))')
     /(I,VARTXT(I),I=1,MIN0(9,NUMODP))
	   WRITE(10,'('' Sensitivity of prediction d(deltaY/Y)/d(deltaP/P)
     / to the parameter relative changes is calculated.'')')

	CASE('EPIPE')
	   NPAR=7
	   ISELSTEP=7
	   PD(1:5)=(/RR,RI,RO,RLZ,THETA/)
	   PD(6)=MODEL
         TEXT(1:NPAR)=(/'measured outer R [m]','initial inner ri [m]',
     /        'initial outer ro [m]','axial stretch [-]',
     /        'opening angle alpha [deg]',
     /        '1-Fung,2-Holz,3-Gent'/)
	   WRITE(10,'('' Calculation of internal pressure (transmural pres
     /sure) given measured outer radius of aorta.''/'' Initial dimension
     /s of unloaded aorta, as well as opening angle must be specified.''
     //'' Constitutive equation can be selected.''/
     /'' 1-Fung C1,C2,B1,B2,B3, 2-Holzapfel C1,k1,k2,(sin
     / beta)^2,''/'' 3-NeoHook+Gent C,Jm,Mju,beta'')')
         CALL DIAGRA('$EPIPE.BMP')

	CASE('EPIPER')
	   NPAR=9
	   ISELSTEP=9
	   PD(1:7)=(/RR,OMG,RI,RO,RLZ,DELTA,THETA/)
	   PD(8)=MODEL
         TEXT(1:NPAR)=(/'measured outer R [m]','twist [deg]',
     /        'initial inner ri [m]',
     /        'initial outer ro [m]',
     /        'axial stretch after load [-]',
     /        'axial stretch before load [-]',
     /        'opening angle alpha [deg]',
     /        '3-Gen1,4-Gent2,5-Holz'/)
	   WRITE(10,'('' Calculation of pressure, load and moment given me
     /asured outer radius of aorta and twist.''/    '' Initial dimension
     /s of unloaded aorta, as well as opening angle must be specified.''
     //'' Constitutive equation can be selected.''/
     /'' 3-Gent1, 4-Gent2, 5-Holzapfel2'')')
         CALL DIAGRA('$EPIPE.BMP')

	CASE('ELONEX')
	   NPAR=7
	   ISELSTEP=7
	   PD(1:5)=(/RLA,RLT,HHH,WA,WT/)
	   PD(6)=1
         TEXT(1:NPAR)=(/'Axial stretch [-]','Transversal stretch [-]',
     /        'H-initial thickness [m]','Width axial [m]',
     /        'Width transversal [m]',
     /        'Type (1-Fung bi,2-Fung uniax,3-...'/)
	   WRITE(10,'('' Calculation of axial and transversal forces at si
     /des of rectangular plate.''/
     //'' Constitutive equation and type of loading can be selected.''/
     /'' 1-Fung C1,C2,B1,B2,B3, 2-Uniaxial load, 3-Uniaxial 90degs''/
     /'' 4-Holz C1,k1,k2,(sin beta)^2, 5-uniaxial, 6-uniax. 90degs''/
     /'' 7-Gent 8-Uniaxial load, 9-Uniaxial 90degs'')')
         CALL DIAGRA('$ELONEX.BMP')

	CASE('FOAM')
	   NPAR=18
	   PD(1:NPAR-3)=(/DTIME,HPLATE,RMASS,OMGW,T0,
     /	   VEXP,ALPHA,PSI,RKO,RB0,TIMAX,1.,1.,1.,1./)
	   PD(16:18)=(/2,3,4/)
         TEXT(1:NPAR)=(/'Time step [s]','Thickness H [m]','Mass [kg]',
     /        'Omega water [-]','T0','Vexpansion','ALPHA crust',
     /        'PSI-permeability (0-constrained)',
     /        'Consistency preexp',
     /        'Bubble radius [m]','time max [s]',
     /        'Alfa correction (1.phase)',
     /        'Alfa correction (foam phase)',
     /        'Alfa correction (free water phase)',
     /        'Alfa correction (bound water phase)',
     /         'col T','col p','col eps'/)
     
	   WRITE(10,'('' Expansion of waffle (integral foam, Crust)'')')

	CASE('FOAMS')
	   NPAR=18
	   PD(1:NPAR-3)=(/DTIME,HPLATE,RMASS,OMGW,T0,
     /	   EPSF,RK,RPSI,EM,EN,TIMAX,1.,1.,1.,1./)
	   PD(16:18)=(/2,3,4/)
         TEXT(1:NPAR)=(/'Time step [s]','Thickness H [m]','Mass [kg]',
     /        'Omega water [-]','T0','EPS-final','K (eps=K.dpm)',
     /        'PSI-permeability (0-constrained)',
     /        'M-exponent eps',
     /        'N-exponent flowrate','time max [s]',
     /        'Alfa correction (1.phase)',
     /        'Alfa correction (foam phase)',
     /        'Alfa correction (free water phase)',
     /        'Alfa correction (bound water phase)',
     /         'col T','col p','col eps'/)
     
      WRITE(10,'('' Expansion of waffle (empirical power law model)'')')

      CASE('FOAMSE')
	   NPAR=10
	   PD(1:NPAR)=(/TIII,dtIII,dtI,HPLATE,RMASS,OMGW,T0,
     /	   EPSF,EM,EN/)
         TEXT(1:NPAR)=(/'T-evaporation [C]',
     /        'time-evaporation [s]','time to 100C',
     /  	    'Thickness H [m]','Mass [kg]',
     /        'Omega water [-]','T0','EPS-final',
     /        'M-exponent eps',
     /        'N-exponent flowrate'/)
	WRITE(10,'('' ESTIMATE PARAMETERS OF EXPONENTIAL MODEL'')')


	CASE('FOAMV')
	   NPAR=15
	   PD(1:NPAR)=(/DTIME,HPLATE,RMASS,OMGW,ALPHA,PSI,RKO,RB0,RBF,
     /                EPSF,TC,TIMAX,1.,1.,1./)
         TEXT(1:NPAR)=(/'Time step [s]','Thickness H [m]','Mass [kg]',
     /        'Omega water [-]','ALPHA<0 crust suppressed)',
     /        'PSI-permeability',
     /        'Consistency preexp',
     /        'Bubble radius initial [m]',
     /        'Bubble radius final [m]',
     /        'Porosity','Transition T [C]',
     /        'time max [s]',
     /        'Alfa correction (I.phase)',
     /        'Alfa correction (II.phase)',
     /        'Alfa correction (bound water phase)'/)
     
	   WRITE(10,'('' Expansion of waffle (smooth II+III transition)'')')

CASES LISTS--

      CASE('EPLIST')
C EPLIST
         NPAR=4
         PD(1:4)=(/1,IDEF,1,MAX0(1,JDEPAR)/)
         NAMED(4)=.TRUE.
         TTP(4)=TEPAR(MAX0(1,IFIX(PD(4))))
         TEXT(1:4)=(/'first element','last element','increment',
     /               'index/name of parameter'/)
         IPICK(1:2)=(/3,3/)
         WRITE(10,'('' Element parameter list (EQ-flowrate,ERE-Re,ETAU-s
     /tress,EII-invariant,EFOUL-fouling,EPOWER,''/'' ENA-alpha stress,EN
     /B-beta stress,EMA-alpha moment,EMISE-von Mises...)'')')
      CASE('DOFLIS')
C DOFlist
         NPAR=1
         PD(1)=2
         TEXT(1)='1-Bound.Cond.,2-result,3-Init.Cond.,4-temporary'
         WRITE(10,'('' Calculate and display min/max DOF-values'')')
      CASE('VARL')
C VARLIST
         NPAR=1
         PD(1)=IDEF
         TEXT(1)='Only list of variabs=0, with comments =1'

CASES GRAF--

      CASE('GCR')
C GCR - kresli XY graf prubehu DOF podel vybrane krivky
         NPAR=4
	   IDF=MAX0(1,IDEF)
         JDDOF=MIN0(MAXTDOF,MAX0(1,JDDOF))
         PD(1:4)=(/IDF,JDDOF,2,12/)
         NAMED(2)=.TRUE.
         TTP(2)=TDOF(JDDOF)
         TEXT(1:4)=(/'Curve','DOF:TEMP,PRES,...',
     /      '1-Bound.Cond.,2-Result,3-Init.Cond.','Font height (pix)'/)
         IF(LAST.LT.NPAR)THEN
         CALL DRAWE(2)
         WRITE(10,'('' Graph XY - selected DOF along selected CURVE'')')
         ENDIF
      CASE('GFCR')
C GFCR - kresli XY graf prubehu FUNKCE podel vybrane krivky
         NPAR=3
         PD(1:3)=(/IDEF,IFUN,12/)
         TEXT(1:3)=(/'Curve','Index of function','Font height (pix)'/)
         IF(LAST.LT.NPAR)THEN
         CALL DRAWE(2)
         WRITE(10,'('' Graph XY - user function along selected CURVE. Yo
     /u can use function''/'' DOF(name,zone,x,y,z) or EPA(name,x,y,z) in 
     / expression, if the BOX operation has been done.'')')
         ENDIF
      CASE('GFSF')
C GFSF - kresli vrstevnice prubehu FUNKCE na vybrane plose
         NPAR=4
         PD(1:4)=(/IDEF,IFUN,0,1/)
         TEXT(1:4)=(/'Surface','Index of function','Minimum','Maximum'/)
         IF(LAST.LT.NPAR)THEN
         CALL DRAWE(3)
         WRITE(10,'('' Isolines of user function on selected SURFACE. Yo
     /u can use function''/'' DOF(name,zone,x,y,z) or EPA(name,x,y,z) in 
     / expression, if the BOX operation has been done.'')')
         ENDIF
      CASE('GE')
C GE-parametry elementu
         NPAR=5
         PD(1)=MAX0(1,JDEPAR)
         NAMED(1)=.TRUE.
         TTP(1)=TEPAR(MAX0(1,IFIX(PD(1))))
         PD(2:5)=(/0.,0.,0.,0./)
         TEXT(1:5)=(/'Element parameter (name)',
     /               'Xmin','Xmax','Ymin','Ymax'/)
         WRITE(10,'('' Graph of element parameters:''\)')
         NEPR=0
         DO J=1,MAXELEM
           DO I=1,NEPAR(J)
             IF(KEPAR(J,I).GT.0)THEN
               NEPR=NEPR+1
               WRITE(10,'(1X,A4,1X\)')TEPAR(JEPAR(J,I))
             ENDIF
           ENDDO
         ENDDO
         IF(NEPR.EQ.0)THEN
            WRITE(10,'('' Sorry no paramater has been calculated.'')')
         ELSE
            WRITE(10,*)
         ENDIF
      CASE('GPIPE')
C GRAPH PIPE
         NPAR=6
	   IDF=MAX0(1,IDEF)
         PD(1:4)=(/IDF,IZONE,2,12/)
         NAMED(1)=.TRUE.
         TTP(1)=TDOF(MAX0(1,IDEF))
         NAME(5:6)=(/.TRUE.,.TRUE./)
         TTP(5:6)=(/'X [m]','Y [m]'/)
         TEXT(1:6)=(/ 
     /     'DOF:Temp,Pres,Cn,Ux,Uy,Rz,Volt',
     /     '1-Bound.Cond.,2-result,3-Init.Cond.','Thickness [1-4]',
     /     'Font height (pix)','Label X','Label Y'/)
         WRITE(10,'('' Graph 1D (Pipes,Heat exchangers,Shells)- selected
     / degree of freedom visualised in colours.'')')
         CALL DIAGRA('$GD1.BMP')
      CASE('GRAPH')
C GRAPH
         NPAR=12
	   IDF=MAX0(1,IDEF)
         PD(1:2)=(/IDF,IZONE/)
         PD(3:6)=(/0.,0.,0.,0./)
         PD(7:10)=(/0,0,0,0/)
         TTP(11:12)=(/'X-or axis','Y-or radius'/)
         NAMED(1)=.TRUE.
         NAME(11:12)=(/.TRUE.,.TRUE./)
         TTP(1)=TDOF(MAX0(1,IDEF))
         TEXT(1:12)=(/ 
     /     'DOF:Temp,Ux,..,Rx,..,Vx,..,Pres,Ps,Psx,..',
     /     '1-Bound.Cond.,2-result,3-Init.Cond.',
     /     'Xmin','Xmax','Ymin','Ymax','Plot Mesh (>0)',
     /     'Value-min','Value-max','Font height [pixels]','Label X',
     /     'Label Y'/)
         WRITE(10,'('' Graph 2D - contours of selected degree of freedom
     /'')')
         CALL DIAGRA('$GD2.BMP')
      CASE('GVEL')
C GVEL
         NPAR=10
         PD(1)=IZONE
         PD(2:5)=(/0.,0.,0.,0./)
         PD(6:8)=(/0,3,12/)
         NAME(9:10)=(/.TRUE.,.TRUE./)
         TTP(9:10)=(/'X-or axis','Y-or radius'/)
         TEXT(1:10)=(/ 
     /     '1-Bound.Cond.,2-result,3-Init.Cond.',
     /     'Xmin','Xmax','Ymin','Ymax','Plot Mesh (>0)','Step',
     /     'Font height (pixels)','Label X','Label Y'/)
         WRITE(10,'('' Velocities Vx,Vx - arrows'')')
      CASE('STREAM')
C STREAM PLOT selected by mouse
         NPAR=2
         PD(1)=DTIME/10
         PD(2)=NTSTEP*10
         TEXT(1:2)=(/'Time step','No of time steps'/)
         WRITE(10,'('' Plot streamlines starting from points specified b
     /y mouse (L-click, R-click ends).''/'' Do not forget the BOX comman
     /d, hich has had to be executed previously.'')')
      CASE('STREAMN')
C STREAM PLOT from nodes
         NPAR=5
         PD(1)=DTIME/10
         PD(2:5)=(/NTSTEP*10,1,ND,1/)
         TEXT(1:5)=(/'Time step','No of time steps','First node','Last n
     /ode','step node'/)
         WRITE(10,'('' Plot streamlines starting from selected nodes.''/
     /'' Do not forget the BOX command, hich has had to be executed prev
     /iously.'')')

      CASE('TGRID')
C CONTOURS ON GRID (FINITE DIFFERENCES)
         NPAR=1
         PD(1)=IDEF
         TEXT(1)='Index of time step'
         WRITE(10,'('' TGRID-Contours of results calculated on an auxill
     /iary rectangular grid''/'' Data from file $T000i.OUT.'')')
      CASE('AGRID')
C CONTOURS ON GRID (ANIMATE)
         NPAR=4
         PD(1:2)=(/1,1/)
         PD(3:4)=(/0.,300./)
         TEXT(1:4)=(/'Index of FIRST time step',
     /'Index of LAST time step',
     /'minimum value','maximum value'/)
         WRITE(10,'('' AGRID-animated results calculated by ADI method o
     /n an auxilliary rectangular grid''/'' Data from $Txxxx.OUT.'')')
     
      CASE('GRAFUN')
C GRAFUN
         NPAR=4
         PD(1:3)=(/-1.,0.,1./)
         PD(4)=12
         TEXT(1:4)=(/'Index of function (-10:50)','Range X from','to',
     /'Font height (pix)'/)
         WRITE(10,'('' Plot a function defined by FUNDEF or CURDEF in a
     /specified range of X. The variable X is''/'' simultaneously TIME,X
     /X,YY,ZZ,II,DP,RE,TEMP,UX,...RX,...VOLT,VX,...PRES,PS,OMG,...'')')
      CASE('GRATIM')
C GRAPH TIME COURSES AND ANIMATION
         NPAR=1
         PD(1)=IDEF
         NAMED(1)=.TRUE.
         TTP(1)=TDOF(MAX0(1,IDEF))
         TEXT(1)='Recorded parameter TEMP,UX,...'
         WRITE(10,'('' Time course of DOF in picked nodes (L-click selec
     /t, R-click end) from '',A,''.OUT'')')TRIM(PROBLEM)
      CASE('GRATEL')
C GRAPH TIME COURSES elements 
         NPAR=1
         PD(1)=IDEF
         NAMED(1)=.TRUE.
         TTP(1)=TEPAR(MAX0(1,IDEF))
         TEXT(1)='Recorded parameter ENA,ERE,...'
         WRITE(10,'('' Time course of EPAR in picked elements (L-click s
     /elect, R-click end) from '',A,''.TEP'')')TRIM(PROBLEM)

	CASE('CTN')
C Read OUT file and put DOF of specified nodes into  MOP
         NPAR=2*MAXSEL
         PD(1:2)=(/IDEF,1/)
         NAMED(1)=.TRUE.
         TTP(1)=TDOF(MAX0(1,IDEF))
         TEXT(1)='Recorded parameter TEMP,UX,...'
         TEXT(2)='Number of nodes'
         DO I=2,MAXSEL
	      I1=2*I-1
            WRITE(TEXT(I1),'(i2,''. node index (; quit)'')')I-1
            PD(I1)=I-1
            IPICK(I1)=1
	      I2=2*I
            WRITE(TEXT(I2),'(i2,''. node DOF into column'')')I-1
            PD(I2)=I
         ENDDO
         WRITE(10,'('' Time course of DOF of specified nodes transferred 
     / to specified columns of MOP.''/'' Data are read from '',A,''.OUT'
     /')')
     /TRIM(PROBLEM)

	CASE('CTTN')
C Read OUT file and put DOF of specified nodes into  MOP only for times, specified in 1st column
         NPAR=2*MAXSEL
         PD(1:2)=(/IDEF,1/)
         NAMED(1)=.TRUE.
         TTP(1)=TDOF(MAX0(1,IDEF))
         TEXT(1)='Recorded parameter TEMP,UX,...'
         TEXT(2)='Number of nodes'
         DO I=2,MAXSEL
	      I1=2*I-1
            WRITE(TEXT(I1),'(i2,''. node index (; quit)'')')I-1
            PD(I1)=I-1
            IPICK(I1)=1
	      I2=2*I
            WRITE(TEXT(I2),'(i2,''. node DOF into column'')')I-1
            PD(I2)=I
         ENDDO
         WRITE(10,'('' Time course of DOF of specified nodes transferred 
     / to specified columns of MOP.''/'' Data are read from '',A,''.OUT'
     /'/'' Only data at time t specified in the 1st columns of MOP are s
     /aved'')')
     /TRIM(PROBLEM)

	CASE('CTE')
C Read TEP file and put EPAR of specified elements into  MOP
         NPAR=2*MAXSEL
         PD(1:2)=(/IDEF,1/)
         NAMED(1)=.TRUE.
         TTP(1)=TDOF(MAX0(1,IDEF))
         TEXT(1)='Recorded parameter ETX,...'
         TEXT(2)='Number of elements'
         DO I=2,MAXSEL
	      I1=2*I-1
            WRITE(TEXT(I1),'(i2,''. element index'')')I-1
            PD(I1)=I-1
            IPICK(I1)=2
	      I2=2*I
            WRITE(TEXT(I2),'(i2,''. element EPAR to column'')')I
            PD(I2)=I
         ENDDO
         WRITE(10,'('' Time course of EPAR of specified elements transfe 
     /rred to columns of MOP.''/'' Data are read from '',A,''.TEP'')')
     /TRIM(PROBLEM)
	
      CASE('GTC')
C Graf nekolika t-C krivek
         NPAR=MAXSEL+1
         TEXT(1)='Number of curves for plotting'
         PD(1)=MAXSEL
         DO I=1,MAXSEL
           PD(I+1)=I
           WRITE(CH,'(I1)')I
           TEXT(I+1)='Index of curve '//CH
         ENDDO
         WRITE(10,'('' Time curves - automatic scale according to select
     /ed curves for plotting i=2,...'',i2)')MAXSEL
         CALL SHOWTC(10)
      CASE('NFPLOT')
C NFPLOT
         NPAR=4
         JDDOF=MIN0(MAXTDOF,MAX0(1,JDDOF))
         PD(1:4)=(/1,IDEF,1,JDDOF/)
         NAMED(4)=.TRUE.
         TTP(4)=TDOF(JDDOF)
         IPICK(1:2)=(/1,1/)
         TEXT(1:4)=(/'first node','last node','increment',
     /               'DOF:Temp,Ux,..,Rx,..,Vx,..,Pres,Ps,Psx,..'/)
      CASE('PFPLOT')
C PFPLOT
         NPAR=3
         JDDOF=MIN0(MAXTDOF,MAX0(1,JDDOF))
         PD(1:3)=(/IDEF,JDDOF,1/)
         NAMED(2)=.TRUE.
         TTP(2)=TDOF(JDDOF)
         TEXT(1:3)=(/'Zone 1-Bound.Cond.,2-Result,3-Init.Cond.',
     /     'DOF:Temp,Ux,..,Rx,..,Vx,..,Pres,Ps,Psx,..',
     /     'Size (0-3)'/)
         WRITE(10,'('' Calculates min/max values of selected DOF and dis
     /plays it graphically in points PT''/'' Analog devices are attached 
     / to points connected with nodes by operation NMERGE.'')')
         CALL DIAGRA('$METER.BMP')
      CASE('TCP')
C Plot TC krivka
         NPAR=3
         PD(1:3)=(/ICURVE,0,0/)
         IPICK(1)=5
         TEXT(1:3)=(/'Select curve (2,3,...,10)',
     /         '0-line, <10-points, >10-line+points','Color (0-black)'/)
         WRITE(10,'('' Plot a time curve (add into existing graph)'')')
         CALL SHOWTC(10)
	CASE('TCL')
C Plot lambda
         NPAR=1
	   PD(1)=ICURVE
	   IPICK(1)=5
	   TEXT(1)='Select curve (2,3,...,10)'
	   WRITE(10,'('' Plot intensity function Lambda(t)'')')
	   CALL SHOWTC(10)
	CASE('TCF')
C Plot integral distribution F(t)
         NPAR=1
	   PD(1)=ICURVE
	   IPICK(1)=5
	   TEXT(1)='Select curve (2,3,...,10)'
	   WRITE(10,'('' Plot integral distribution F(t)'')')
	   CALL SHOWTC(10)
      CASE('TCLEAR')
C Clear=delete columns of TC
         NPAR=2
         PD(1:2)=(/IDEF,10/)
         TEXT(1:2)=(/'First deleted column','Last deleted column'/)
         WRITE(10,'('' Delete selected columns of MOP'')')
      CASE('TCPXY')
C Plot TC krivka
         NPAR=3
         PD(1:3)=(/IDEF,IDEF+1,0/)
         TEXT(1:3)=(/'Column of time (1,2,...,10)',
     /               'Column of value (1,2,...,10)',
     /               '0-line, <10-points, >10-line+points'/)
         WRITE(10,'('' Plot XY curve. X,Y are arbitrary selected columns   
     /of observation points matrix. Use CLS to rescale.'')')
         CALL SHOWTC(10)
      CASE('TCPXYM')
C Plot TC krivka body se znackami urcenymi cislem ve sloupci
         NPAR=3
         PD(1:3)=(/IDEF,IDEF+1,1/)
         TEXT(1:3)=(/'Column of time (1,2,...,10)',
     /               'Column of value (1,2,...,10)',
     /               'Column of marks (1,2,...,10)'/)

CASES IDENT--

      CASE('EID')
C EIDENT
         NPAR=1
         PD(1)=IDEF
         TEXT(1)='1-Egroup,2-Rconst,3-Mprop,4-EPAR,5-geom,6-modify'
         WRITE(10,'('' Information on elements selected by mouse (R-clic
     /k terminates the operation)'')')
      CASE('NID')
C NIDENT
         NPAR=2
         JDDOF=MIN0(MAXTDOF,MAX0(1,JDDOF))
         PD(1:2)=(/IDEF,JDDOF/)
         NAMED(2)=.TRUE.
         TTP(2)=TDOF(JDDOF)
         TEXT(1:2)=(/'Zone 1-Bound.Cond.,2-Result,3-Init.Cond.',
     /     'DOF:Temp,Ux,..,Rx,..,Vx,..,Pres,Ps,Psx,..'/)
         WRITE(10,'('' Information on Nodes selected by mouse (R-click t
     /erminates the operation)'')')


CASES SCREEN--

      CASE('SCALE')
C SCALE
         NPAR=6
         CALL GRANGE(0,1,1,XMIN,XMAX,YMIN,YMAX)
         PD(1:4)=(/xmin,xmax,ymin,ymax/)
         NAME(5:6)=(/.TRUE.,.TRUE./)
         TTP(5:6)=(/'X','Y'/)
         TEXT(1:6)=(/'xmin','xmax','ymin','ymax','Label X','Label Y'/)
         WRITE(10,'('' Set range of X,Y in the window MODEL'')')
      CASE('MAGNIF')
C Mgnify and pan
         NPAR=3
         PD(1:3)=(/1.,0.,0./)
         TEXT(1:3)=(/'Scale (relative)',
     /               'move horizontal (relative)',
     /               'move vertical (relative)'/)
         WRITE(10,'('' Magnify and move range of X,Y in the window MODEL
     /''/'' SCALE>1 increases range of axis (model appears smaller)''/
     /'' MOVE>0 moves objects to the right or up'')')
      CASE('GRIDON')
C GRIDON
         NPAR=4
         PD(1:4)=(/0.,0.,0.1,0.1/)
         TEXT(1:4)=(/'Origin X','Origin Y',
     /      'Increment DX','Increment DY'/)
         WRITE(10,'('' Grid for PT/ND definition using mouse (GRIDOF end
     /s)'')')

      CASE('DETDEF')
         NPAR=2
         PD(1)=IDEF
         TEXT(1)='Detector no.'
         WRITE(10,'('' Specify parameters for a collimated detector'')')
         CALL DIAGRA('$DETECT.BMP')
      CASE('DETDOF')
C DETDOF 
         NPAR=6
         ISELSTEP=6
         JDDOF=MIN0(MAXTDOF,MAX0(1,JDDOF))
         PD(1)=JDDOF
         PD(2)=ATTENUAT
         PD(3:5)=(/IATTENUAT,IVIEW,NODET/)
         NAMED(1)=.TRUE.
         TTP(1)=TDOF(JDDOF)
         TEXT(1:5)=(/'Source TEMP,CN,CD,CA','Attenuation of media',
     /'Attenuation multiplied by function',
     /'Algorithm (1,2-VF,3,4-SR,5,6-TR)',
     /'No.of detectors'/)
         WRITE(10,'('' Calculate responses of collimated detectors (inte
     /gral of DOF across all elements).''/'' Attenuation is described as
     / a user function. Results are in MOP.''/'' Algorithms View Factor,
     / Single and Triple Ray can be selected''/'' (without and with the 
     /near source correction).'')')
         CALL DIAGRA('$DETREC.BMP')
      CASE('DETFUN')
C DETFUN
         NPAR=6
         ISELSTEP=6
         PD(1)=IFUN
         PD(2)=ATTENUAT
         PD(3:5)=(/IATTENUAT,IVIEW,NODET/)
         TEXT(1:5)=(/'Response to a FUNCT no.','Attenuation of media',
     /'Attenuation multiplied by function',
     /'Algorithm (1,2-VF,3,4-SR,5,6-TR)',
     /'No.of detectors'/)
         WRITE(10,'('' Calculate responses of collimated detectors (inte
     /gral of specified FUNCTION).''/'' Attenuation is described as a us
     /er function. Results are in MOP.''/'' Algorithms View Factor, Sing
     /le and Triple Ray can be selected.'')')
         CALL DIAGRA('$DETREC.BMP')
      CASE('DETPLO')
         NPAR=3
         PD(1:3)=(/IDEF,MAXDET,1/)
         TEXT(1:3)=(/'Detector no.','Last detector','step'/)
         WRITE(10,'('' Plot detectors'')')

C      INCLUDE '$S0a-DIA'
CASES RTD--

      CASE('COMPAR')
C N I1 I2 C1-C1-W1, C2-C2-W2  promenny pocet argumentu
         NPAR=3
         PD(1:3)=(/MAX0(1,NCOMPAR),MAX0(1,ICOMP1),MIN0(NGR,ICOMP2)/)
         TEXT(1:3)=(/'Number of TC pairs (max.5)',
     /               'First row of observation matrix',
     /               'Last row of observation matrix'/)
         DO I=1,MAXSEL/2
           PD(3*I+1)=MAX0(2,ICOMPAR(1,I))
           PD(3*I+2)=MAX0(2,ICOMPAR(2,I))
           PD(3*I+3)=ICOMPAR(3,I)
           WRITE(CH,'(I1)')I
           TEXT(3*I+1)=CH//'-pair. Model prediction (2,...10)'
           TEXT(3*I+2)=CH//'-pair. Experimental data(2,...10)'
           TEXT(3*I+3)=CH//'-pair. Weighting coeffs.(2,...10)'
         ENDDO
         WRITE(10,'('' Select TC curves for comparison (difference norm 
     /calculation) in a specified time range.''/'' Column of weights can
     / be associated to compared pairs (if zero, unit weights are assume
     /d).''/'' Maximum number of compared TC pairs is 5.'')')
      CASE('CRITER')
C KCOMPAR
         NPAR=1
         PD(1)=KCOMPAR
         TEXT(1)='Criterion for TC comparison'
         WRITE(10,'('' Select criterion for evaluation of distance betwe
     /en pair of TC curves.''/'' 0-absolute,1-relative,2-sum of squares,
     /3-sum of squares relative,4-integral abs,...'')')
      CASE('COPYTO')
C COPY TC FROM TO
         NPAR=2
         PD(1:2)=(/ICURVE,IDESTIN/)
         TEXT(1:2)=(/'Copy FROM (curve index 2,3...)',
     /               'TO (curve index 2,3,...)'/)
         WRITE(10,'('' Copy a time curve in the matrix of observation po
     /ints (rewrite old time curve).''/'' Current indices are:'')')
         CALL SHOWTC(10)
      CASE('TCJOIN')
C compose a curve from two TC
         NPAR=3
         PD(1:3)=(/ICURVE,IDESTIN,INSERT/)
         IPICK(1)=5
         IPICK(3)=5
         TEXT(1:3)=(/'Basic source curve','Resulting composed curve','In
     /serted curve'/)
         WRITE(10,'('' Create time curve as a composition of two curves.
     / A selected interval <t1,t2>''/'' of the basic curve is replaced b
     /y a corresponding part of the second curve.'')') 
      CASE('TCSUB')
C Subtract TC
         NPAR=3
         PD(1:3)=(/ICURVE,IDESTIN,INSERT/)
         IPICK(1)=5
         IPICK(3)=5
         TEXT(1:3)=(/'Basic source curve','Resulting curve','Subtracted 
     /curve'/)
         WRITE(10,'('' Create a time curve by subtracting a curve from t
     /he basic time curve.'')')
      CASE('MOMENT')
C Momenty TC krivky
         NPAR=1
         PD(1)=ICURVE
         TEXT(1)='Index of curve (=2,3,...)'
         WRITE(10,'('' Calculate moments (area, center, variance) of a t
     /ime curve (max.index'',i2,'')'')')MAXSEL
         CALL SHOWTC(10)
      CASE('FMOM')
C Momenty TC krivky se zrcadlenim chvostu (vhodne pro FFT)
         NPAR=2
         PD(1:2)=(/ICURVE,1/)
         TEXT(1:2)=(/'Index of curve (=2,3,...)','Point separating tail'
     //)
         IPICK(1:2)=(/5,6/)
         CALL DIAGRA('$FMOM.BMP')
         WRITE(10,'('' Calculate moments (area, center, variance) of a t
     /ime curve (max.index'',i2,'')''/'' This operation assumes, that th
     /e tail should be moved left (FFT periodicity).'')')MAXSEL
         CALL SHOWTC(10)
      CASE('NORM')
C Normalizace TC krivky (bud na plochu nebo i na prvni moment)
         NPAR=3
         PD(1:3)=(/ICURVE,IDESTIN,0/)
         IPICK(1:2)=(/5,5/)
         TEXT(1:3)=(/'Index of source curve (=2,3,...)',
     /               'Index of normalised curve (=2,3,...)',
     /               '0-unit area,1-unit mean time'/)
         WRITE(10,'('' Normalize a time curve to area or mean time (sour
     /ce & resulting curves may be identical).''/'' Be carefull when sel
     /ecting mean time normalisation (time vector C1 would be changed).
     /'')')
         CALL SHOWTC(10)
      CASE('TCINT')
C Integrace TC krivky (vypocet F-krivky)
         NPAR=2
         PD(1:2)=(/ICURVE,IDESTIN/)
         IPICK(1)=5
         TEXT(1:2)=(/'Index of source curve (=2,3,...)',
     /               'Index of integrated F-curve (=2,3,...)'/)
         WRITE(10,'('' Integrate a time curve (F-distribution) in the ma
     /trix of observation points.'')')
         CALL SHOWTC(10)
      CASE('IDMSER')
C Serie idealnich misicu IG, P-misicu, Tmean
         NPAR=3
         PD(1)=ICURVE
         PD(2:3)=(/PMIX1,TMEAN/)
         TEXT(1:3)=(/'Index of new curve (=2,3,...)',
     /               'No.of mixers (can be real!)',
     /               'Mean residence time'/)
         WRITE(10,'('' Impulse response of a series of mixers for time
     /step'',e9.2,'' and'',i4,'' points''/'' Calculated response will be
     / located in a specified column of MOP.'')')DTIME,NTSTEP
      CASE('PASERI')
C 2 Serie idealnich misicu IG, P1,P2-misicu, f-delici pomer, alfa-V1/V2, Tmean
         NPAR=6
         PD(1)=ICURVE
         PD(2:6)=(/PMIX1,PMIX2,F,ALFA,TMEAN/)
         TEXT(1:6)=(/'Index of new curve (=2,3,...)',
     /      'No.of mixers 1.serie',
     /      'No.of mixers 2.serie','f=Q1/Q flowrate ratio',
     /      'alfa=t2/t1 residence times ratio','Mean residence time'/)
         WRITE(10,'('' Impulse response of two parallel series of mixers
     / for time step'',e9.2,'' and'',i4,'' points''/'' Calculated respon
     /se will be located in a specified column of MOP.'')')DTIME,NTSTEP
      CASE('SMOOTH')
C Smoothing a Time Curve
         NPAR=3
         PD(1:3)=(/ICURVE,IDESTIN,1/)
         IPICK(1)=5
         TEXT(1:3)=(/'Index of source curve (=2,3,...)',
     /               'Smoothed curve index (=2,3,...)',
     /               'Method 0-linear,>0-quadratic,<0-median'/)
         WRITE(10,'('' Smoothing a part of time curve using linear/quadr
     /atic splines or median filter.''/'' Method of smoothing is selecte
     /d by a parameter: Positive value means quadratic''/'' regression s
     /pline, negative value median method.''/'' Absolute value of parame
     /ter is number of neighbouring points used in local regression.'')'
     /)
         CALL SHOWTC(10)
         CALL DIAGRA('$smooth.BMP')
      CASE('TCEDIT')
C Editing using mouse
         NPAR=2
         PD(1:2)=(/ICURVE,1/)
         IPICK(1)=5
         TEXT(1:2)=(/'Index of edited curve (=2,3,...)',
     /           'Editing mode (0-7)'/)
         WRITE(10,'('' Edit TC-points using mouse. Parameter MODE specif
     /ies selection of point:''/'' 0,1,4,5-nearest distance, 2,3,6,7-nea
     /rest time.''/'' for 0,2,4,6 both time and C-value, while for 1,3,5
     /,7 only C-values will be changed.'')')
         CALL SHOWTC(10)
      CASE('TCINP')
C Input Column from keyboard
         NPAR=2
         PD(1:2)=(/ICURVE,1/)
         TEXT(1:2)=(/'Index of column in observation matrix',
     /               'First row of data to be read from keyboard'/)
         WRITE(10,'('' Input values from keyboard into specified column 
     /of observation matrix.'')')
      CASE('TCLIST')
C Vypis tabulky bodu pozorovani
         NPAR=2
         PD(1:2)=(/1,1/)
         TEXT(1:2)=(/'First row to be displayed',
     /               'Format (1-G9.4, 2-E9.2)'/)
      CASE('WMODIF')
C Modify weights
         NPAR=2
         PD(1)=2
         PD(2)=1
         TEXT(1:2)=(/'Column index of weights','Multiply weigths by'/)
         WRITE(10,'('' Change weights in a specified range of points.'')
     /')
      CASE('TCFUN')
C Assign T1(i)=.... or C1(i)=....
         NPAR=1
         TTP(1)='C1=0'
         NAME(1)=.TRUE.
         TEXT(1)='Assign Ck=...'
         WRITE(10,'('' Loop over'',i4,'' data points. Loop variable i ca
     /n be used as index of C1(i),...,C10(i).'')')NGR
      CASE('TCFR')
C Assign T1(i)=.... or C1(i)=.... in a specified range of ROWS
         NPAR=3
         PD(1:2)=(/1,NGR/)
         TTP(3)='C1=0'
         NAME(3)=.TRUE.
         TEXT(1:3)=(/'First row','Last row','Assign Ck=...'/)
         WRITE(10,'('' Loop over specified data points. Loop variable i 
     / can be an index of C1(i),...,C10(i).'')')
      CASE('TCRND')
C Randomizing Time Curve
         NPAR=4
         PD(1:3)=(/ICURVE,IDESTIN,1/)
         IPICK(1)=5
         PD(4)=AMPLIT
         TEXT(1:4)=(/'Index of SOURCE curve','NOISED curve index',
     /               'Noise 0-absolute,1-relative',
     /               'Value of mean amplitude'/)
         WRITE(10,'('' Randomising time curve by superposition of noise 
     /(absolute/relative,Gauss distribution)'')')
         CALL SHOWTC(10)
      CASE('TCDEC')
C Time decay correction
         NPAR=3
         PD(1:2)=(/ICURVE,IDESTIN/)
	   PD(3)=0
         IPICK(1)=5
         TEXT(1:3)=(/'Index of SOURCE curve','Corrected curve',
     /               'T1/2 [hours]'/)
         WRITE(10,'('' Half time decay correction of a response.'')')
      CASE('TCSET')
C Specify type of TC curve
         NPAR=3
         PD(1:2)=(/ICURVE,1/)
         ISELSTEP=3
         NAME(3)=.TRUE.
         TEXT(1:3)=(/'Index of observ. matrix column (=2,3,...)',
     /               'Type (1-t,2-FEM,3-Exp,4-X,5-Y,6-R,7-V)',
     /               'Label (max.8 characters)'/)
         WRITE(10,'('' Specify type of Column.''/'' 1-time,2-nodal value
     /s,3-exper.,4-X,5-Y,6-regres.model,7-std.dev.,8-E(t),9-Rxy,10...19-
     /user''/'' (time is usually the first column of observation matrix)
     /. NDAT='',I4,'', list of columns used:'')')NGR
         CALL SHOWTC(10)
      CASE('TAIL')
C Exponential/convectional tail 
         NPAR=3
         PD(1:3)=(/ICURVE,IDESTIN,1/)
         IPICK(1)=5
         TEXT(1:3)=(/'Select source curve (=2,3,...)',
     /               'Corrected curve (=2,3,...)',
     /               'Tail: 1-exp(t), 2-t.exp(t), 3-A/t^3'/)
         WRITE(10,'('' Replace tail of a time curve by exponential or po
     /wer function.''/'' Parametr Tail -1,-2,-3 assumes that the backgro
     /und has been subtracted,''/'' while the parameter Tail=1,2,3 subtr
     /acts the background automatically.''/'' Range of points used for f
     /unction approximation is specified by mouse (R-click quits).'')')
         CALL SHOWTC(10)
         CALL DIAGRA('$tail.BMP')
      CASE('TCREG')
C Regression fit of a part of curve
         II=SETACTIVEQQ(20)
         CALL GMFAXE(1,7,15)
         CALL PLOTAL
         NPAR=3
         PD(1:3)=(/ICURVE,IDESTIN,0/)
         IPICK(1)=5
         TEXT(1:3)=(/'Select source curve (=2,3,...)',
     /               'Corrected curve (=2,3,...)',
     /               'Regr.funct.: 0-any, 1-exp, 2-doubl.exp'/)
         WRITE(10,'('' Nonlinear regression of a part of time curve. Reg
     /ression functions: 0-any,''/'' 1-exp,2-double exp,3-Gauss,4-ration
     /al,6-series,7-ADM(open-open),8-ADM(close-open).''/'' Range of poin
     /ts used for function approximation is specified by mouse (R-click 
     /quits).'')')
         CALL DIAGRA('$TCREG.BMP')
         CALL SHOWTC(10)
      CASE('TCLIP')
C Odriznuti zapornych hodnot
         NPAR=1
         PD(1)=ICURVE
         TEXT(1)='Index of curve (=2,3,...)'
         IPICK(1)=5
        WRITE(10,'('' Clipping a time curve to positive values only'')')
         CALL SHOWTC(10)
      CASE('TCZERI')
C Vynulovani zacatku krivky
         NPAR=2
         PD(1:2)=(/ICURVE,0/)
         IPICK(1)=5
         TEXT(1:2)=(/'Index of curve (=2,3,...)','Time of first nonzero 
     /value'/)
        WRITE(10,'('' Fill zero values into initial part of a time curve
     / up to a specified time.''/'' If you specify zero as an initial ti
     /me,mouse will be activated for the time specification.'')')
         CALL SHOWTC(10)
      CASE('TCBGR')
C Odriznuti zvedajiciho se pozadi
         NPAR=2
         PD(1:2)=(/ICURVE,IDESTIN/)
         IPICK(1)=5
         TEXT(1:2)=(/'Source curve (curve index 2,3,...)',
     /               'corrected curve (index 2,3,...)'/)
         WRITE(10,'('' Raising background subtraction. This correction f
     /inds the initial and ''/'' the final level automatically and calcu
     /lates undisturbed response by iterative solution''/'' of integral 
     /equation. Check convergency in the window LIST.'')')
         CALL SHOWTC(10)
         CALL DIAGRA('$tcbgr.BMP')
      CASE('TRCOR')
C RC-correction
         NPAR=5
         PD(1:2)=(/ICURVE,IDESTIN/)
	   PD(3)=0.
	   PD(4:5)=(/20,0/)
         IPICK(1)=5
         TEXT(1:5)=(/'Source curve (curve index 2,3,...)',
     /               'corrected curve (index 2,3,...)',
     /               'RC or volume of detector',
     /               'No.of Laguerre functions in serie',
     /               'noise filtering (1), without filter (0)'/)
         WRITE(10,'('' Correction to integration constant RC of integrat
     /or, or to a finite''/'' volume od detector. The correction makes u
     /se of Laguerre functions expansion''/'' which can be used for nois
     /e filtering too (optionally),'')')
         CALL SHOWTC(10)
         CALL DIAGRA('$trcor.BMP')
      CASE('TCYSHF')
C Posun ve vertikalnim smeru
         NPAR=3
         PD(1:3)=(/ICURVE,IDESTIN,0/)
         IPICK(1)=5
         TEXT(1:3)=(/'Index of source curve (2,3,...)',
     /    'Index of modified curve (2,3,...)',
     /    'Shift vertically by increment'/)
         IF(VSHIFT.NE.0.)THEN
         PD(3)=-VSHIFT
         WRITE(10,'('' Vertical shift of a time curve by a specified inc
     /rement.''/'' New zero level can be located by mouse, if the INCREM
     /ENT=0.''/'' Default increment has been calculated by GTD operation
     /.'',e11.3)')VSHIFT
         ELSE
         WRITE(10,'('' Vertical shift of a time curve by a specified inc
     /rement.''/'' New zero level can be located by mouse, if the INCREM
     /ENT=0 (default).'')')
         ENDIF
         CALL SHOWTC(10)
      CASE('TCXSHF')
C Posun v HORIZONTALNIM smeru 
         NPAR=3
         PD(1:3)=(/ICURVE,IDESTIN,0/)
         IPICK(1)=5
         TEXT(1:3)=(/'Index of source curve (2,3,...)',
     /    'Index of modified curve (2,3,...)',
     /    'Time Shift by increment'/)
         WRITE(10,'('' Time shift of a time curve by a specified increme
     /nt.''/'' New time origin can be located by mouse, if the INCREMENT
     /=0.'')')
         CALL SHOWTC(10)
      CASE('TCOSHF')
C Posun ve vertikalnim i horizontalnim smeru (novy pocatek)
         NPAR=4
         PD(1:4)=(/ICURVE,IDESTIN,0,0/)
         IPICK(1)=5
         TEXT(1:4)=(/'Index of source curve (2,3,...)',
     /    'Index of modified curve (2,3,...)',
     /    'Time shift','Vertical Shift'/)
         WRITE(10,'('' New origin of a time curve (vertical and horizont
     /al shifts).'')')
         CALL SHOWTC(10)
      CASE('TCEND')
C Pocatecni a Koncovy cas vsech krivek
         NPAR=2
         PD(1:2)=(/0.,0./)
         TEXT(1:2)=(/'Initial time for all curves',
     /               'Maximum time for all curves'/)
         WRITE(10,'('' New time range for observation matrix.''/'' If th
     /e initial and final times equals (e.g.zero), mouse is activated.''
     /)')
      CASE('TCFFT')
CFFT konvoluce 
         NPAR=7
         PD(1)=IFFT
         TEXT(1)='E=Y/X (1),Y=E*X (2),Rxy=x*y (3), Filter(4)'
         IPICK(2:4)=(/5,5,5/)
         WRITE(10,'('' FFT: Noise filtering,deconvolution (Y/X),convolut
     /ion (E*X) or cross-correlation (X*Y).''/
     /'' No.of Fourier coefficients is given by number of points ('',i4,
     /'') and will be rounded to''/
     /'' nearest power of two. Smoothing is ensured by erasing Fourier c
     /oefs of high frequencies.'')')NGR
         CALL SHOWTC(10)
CASES WRITE/READ--

      CASE('LTN')
C LOADTIME NODAL PARAMETERS
         NPAR=1
         PD(1)=TIME
         TEXT(1)='Results from time [s]'
         IF(LAST.LT.NPAR)
     /   WRITE(10,'('' Read data from '',A,''.OUT file (time history DOF
     /)'')')TRIM(PROBLEM)
      CASE('LTE')
C LOADTIME ELEMENT PARAMETERS
         NPAR=1
         PD(1)=TIME
         TEXT(1)='Results from time [s]'
         IF(LAST.LT.NPAR)
     /   WRITE(10,'('' Read data from '',A,''.TEP file (time history of 
     /element parameters)'')')TRIM(PROBLEM)
      CASE('NAME')
C Zmena nazvu PROBLEM
         NPAR=1
         NAME(1)=.TRUE.
         TTP(1)=PROBLEM
         TEXT(1)='Change problem name'
         WRITE(10,'('' Problem name change, concerns processing files PR
     /OBLEM.OUT,PROBLEM.TEP'')')
      CASE('UNIFIL')
         NPAR=4
         NAME(1:2)=(/.TRUE.,.TRUE./)
         PD(3)=NTSTEP
         PD(4)=DTIME
         TTP(1:2)=(/PROBLEM,'Z0000000.RES'/)
         TEXT(1:4)=(/'File.OUT (without postfix)','from Fluent files',
     /               'no.of steps (files)','time step'/)
         WRITE(10,'('' File problem.OUT having a format of results (noda
     /l parameters in all time steps)''/'' will be created from files in
     / FLUENT format.'')')
      CASE('WRITE')
C WRITE
         NPAR=2
         NAME(2)=.TRUE.
         TTP(2)=PROBLEM
         PD(1)=IDEF
         TEXT(2)='File name (without extension)'
         TEXT(1)='1-Nod,2-Ele,3-Grp,4-Epa,5-PCS,6-Dat,7-TC'
         WRITE(10,'('' Data in ASCII format written into a *.nod *.ele 
     /*.grp *.epa *.pcs *.dat *.tc file'')')
      CASE('READ')
C READ ASCII
         NPAR=2
         PD(1)=IDEF
         NAME(2)=.TRUE.
         TEXT(1)='Type of data: 1-Nod,2-Ele,...,9-COSMOS,10,11-FLUENT'
         TEXT(2)='File name (with extension, max.12 char)'
         WRITE(10,'('' ASCII file read. The files 1-Nod,2-Elem,3-Groups,
     /4-El.param,5-Points,6-Observ. points,''/'' had to be created by op
     /eration WRITE. Options 7-Column, 8-TimeConc read free format data 
     /''/'' into a column of the observation matrix. 9-imports COSMOS,10
     /,11-FLUENT.'')')    
         CALL DIAGRA('$READ.BMP')  
      CASE('READTC')
C READ TC-krivku
         NPAR=6
         LAST=2
         PD(3:6)=(/1,2,ICURVE,1/)
         TEXT(3:6)=(/'Index of column TIME in file',
     /               'Index of column VALUE in file',
     /               'Column of observation matrix (=1,2,...10)',
     /               'First row in file'/)
         WRITE(10,'('' Calculate column of observation matrix by interpo
     /lation of T-C values (4 points regres.)''/'' in specified columns 
     /of data file ['',A,''].'')')TRIM(FILEDAT)
      CASE('READCO')
C Read values into COLUMN of observation matrix
         NPAR=7
         LAST=2
         PD(3:7)=(/1,ICURVE,1,0,1/)
         TEXT(3:7)=(/'Index of first column (=1,2,...) in file',
     /               'Corresponding column of observation matrix',
     /               'Number of transported columns',
     /               'Row of headers (or zero)',
     /               'First data row in file'/)
         WRITE(10,'('' Transfer selected columns of data file ['',A,''] 
     /into columns of observation matrix.'')')TRIM(FILEDAT)
      CASE('READOF')
C Read vector from PATRAN RES-file into values of selected DOF
         NPAR=4
         LAST=2
         PD(3:4)=(/1,3/)
         TEXT(3:4)=(/'name of DOF','1-B.C.,2-results,3-initial cond.'/)
         WRITE(10,'('' Transfer nodal values from data file ['',A,''] 
     /into select zone (1,2,3).'')')TRIM(FILEDAT)
      CASE('READTS')
C Read vector from PATRAN RES-file with the file name formed from counter
         NPAR=4
         PD(1:4)=(/1,1,1,3/)
         NAME(1)=.TRUE.
         TTP(1)='CN______.RES'
         TEXT(1:4)=(/'Basic file name (12 char)','file number',
     /               'name of DOF','1-B.C.,2-results,3-initial cond.'/)
         WRITE(10,'('' Transfer nodal values from data file FFnnnnnn.RES
     / where nnnnnnn is number specified as parameter'')')
      CASE('FLUENF')
C 
         NPAR=3
         LAST=1
         PD(3)=1000
         NAME(2)=.TRUE.
         TTP(2)='problem'
         TEXT(2:3)=(/'case file (without postfix)','no.of iterations'/)
         WRITE(10,'('' Script file PROBLEM.SCF will be created based upo
     /n selected template $FLUENT?.SCF''/'' This script controls solution
     / of specified case file (PROBLEM.CAS).'')')
         CALL DIAFIL1(IEND,'$FLUENT?.SCF',1)
C         TP(1)=TRIM(TP(2))
      CASE('FLUENT')
         NPAR=8
         LAST=1
         PD(3)=1.
         PD(4:8)=(/500,5,10,5,40/)
         NAME(2)=.TRUE.
         TTP(2)='problem'
         TEXT(2:8)=(/'case file (without postfix)','time step [s]',
     /'no.of time steps',
     /'step of injection start','step of injection end',
     /'n-steps for save','no.of iteration in a time step'/)
         WRITE(10,'('' Script file PROBLEM.SCT will be created based upo
     /n selected template $FLUENT?.SCT''/'' This script controls transie
     /nt solution-tracer injection.'')')
         CALL DIAFIL1(IEND,'$FLUENT?.SCT',1)
C         TP(1)=TRIM(TP(2))
       CASE('CMD')
          NPAR=0
          WRITE(10,'('' This command reads the file $FEMINA.CMD, which c
     /ontains definitions of''/'' external programs or RTD models.'')')

       CASE('PPT')
          NPAR=3
          NAMELE=JGROUP(KGROUP,$ENAME)
          IF(NAMELE.NE.$SPHERE)THEN
             CALL HELPC(4,'Wrong element type (should be SPHERE)')
             IEND=-1
             RETURN
          ENDIF
          PD(1:3)=(/1,2,1/)
          TEXT(1:3)=(/ 'First point','Last point','Increment'/)
          IPICK(1:2)=(/2,2/)
          IF(LAST.LT.NPAR)THEN
          CALL DRAWE(1)
          WRITE(10,'('' Define particle SPHERE as elements from points''
     /)')
          ENDIF

      CASE DEFAULT
C Prohlizeni seznamu jmen vnejsich programu
         DO I=1,NEXCOM
           IF(ICOM.EQ.NEXKWD(I))THEN
              NPAR=NEXPAR(I)
              DO J=1,NPAR
                PD(J)=DEXPAR(J,I)
                TEXT(J)=NEXPARTXT(J,I)
              ENDDO
           ENDIF
         ENDDO
      END SELECT

C================================================================================

      II=FOCUSQQ(10)
      IF(ISEMI.EQ.0)THEN
         REA=.TRUE.
      ELSE
         REA=.FALSE.
      ENDIF

C     cyklus I-parametr nezadany na prikazovem radku. Pouziva se
C     while, aby bylo mozne v prubehu zadavani modifikovat pocet porametru.
      I=LAST+1
      DO WHILE(I.LE.NPAR)
        IEND=0

C IG je hodnota predchoziho parametru pred rozhodovacim krokem (zpravidla
C    je ISELSTEP=2, rozhodujici je pak prvni zadavany parametr).

        IG=FLOOR(PD(ISELSTEP-1)+.5)
C        IG=IP(ISELSTEP-1)

        IF(I.EQ.ISELSTEP.AND.IG.GE.1)THEN
C Nasledujici sekce se provadi jen jednou pri zpracovani druheho parametru,
C tj. az po zadani prvniho parametru, ktery urcil skupinu nebo index entity IG.
C Ve vyjmenovanych pripadech se pak bud nastavi default hodnoty
C nebo se zobrazi napoveda (napr. se zobrazi prislusna entita 
C s orientaci stran apod.)
          SELECT CASE(ICOM)
	    CASE('ELONEX')
	       SELECT CASE(IG)
C IG-cislo modelu 1-FUNG,2-BILIN,3-sym.Holzapfel
	       CASE(1,2,3)
C neohook+FUNG
 	         NPAR=12
          	 PD(7:11)=(/C1,C2,B1,B2,B3/)
	         PD(12)=100
               TEXT(7:NPAR)=(/'c1','c2','b1','b2','b3','n-integ'/)
	         WRITE(10,'('' FUNG 5-param.model c1,c2,b1,b2,b3.'')')
             CASE(4,5,6)
C Holzapfel symmetric C1,K1,K2,BETA
 	         NPAR=11
          	 PD(7:10)=(/C1,C2,B1,AMIN1(0.9,B2)/)
	         PD(11)=100
               TEXT(7:NPAR)=(/'C','k1','k2','(SIN beta)**2','n-integ'/)
	         WRITE(10,'('' Holzapfel 4-param.model C,k1,k2,beta.'')')
	       CASE(7,8,9)
C Gent (modifikace Horny) C1,mju,Jm,BETA
 	         NPAR=11
          	 PD(7:10)=(/C1,C2,B1,AMIN1(0.9,B2)/)
	         PD(11)=100
           TEXT(7:NPAR)=(/'c','mju','Jm (max.stretch)','(SIN beta)**2',
     /'ITER'/)
	         WRITE(10,'('' Gent 4-param.model C,mju,Jm,beta.'')')
             ENDSELECT

          CASE('EPIPE')
	       SELECT CASE(IG)
C IG-cislo modelu 1-FUNG,2-BILIN,3-sym.Holzapfel
	       CASE(1)
C neohook+FUNG
 	         NPAR=12
          	 PD(7:11)=(/C1,C2,B1,B2,B3/)
	         PD(12)=100
               TEXT(7:NPAR)=(/'c1','c2','b1','b2','b3','n-integ'/)
	         WRITE(10,'('' FUNG 5-param.model c1,c2,b1,b2,b3.'')')
             CASE(2)
C Holzapfel symmetric c,K1,K2,BETA
 	         NPAR=11
          	 PD(7:10)=(/HC1,HK1,HK2,amin1(0.9,HSIN2)/)
	         PD(11)=100
               TEXT(7:NPAR)=(/'C','k1','k2','(SIN beta)**2','n-integ'/)
	         WRITE(10,'('' Holzapfel 4-param.model C,k1,k2,beta.'')')
	       CASE(3)
C Gent+Hook (modifikace Horny) C,mju,Jm,BETA
 	         NPAR=11
          	 PD(7:10)=(/GC1,GMJU,GJF,amax1(0.,amin1(0.9,GSIN2))/)
	         PD(11)=100
               TEXT(7:NPAR)=(/'C (Hook)','mju','Jm (max.stretch)',
     #                        '(SIN beta)**2','NINTEG'/)
	   WRITE(10,'('' Gent+Hook-Horny 4-param.model C,mju,Jm,beta.'')')
             ENDSELECT

          CASE('EPIPER')
	       SELECT CASE(IG)
C IG-cislo modelu 4-gent2,5-Holzapfel2
	       CASE(3)
C Gent1+Hook (modifikace Horny) C,mju,Jm,BETA
 	         NPAR=13
         	     PD(9:12)=(/GC1,GMJU,GJF,
     /                    amax1(0.,amin1(0.9,GSIN2))/)
	         PD(13)=20
               TEXT(9:NPAR)=(/'C (Hook)','mju',
     /                        'Jf (anisotropic)',
     /                        '(SIN beta)**2','n-integ'/)
	         WRITE(10,'('' Gent+Hook 4-param C,mju,Jf,beta.'')')
	       CASE(4)
C Gent2+Hook (modifikace Horny) C,mju,Jm,BETA
 	         NPAR=14
         	     PD(9:13)=(/GGC1,GGMJU,GGJM,GGJF,
     /                    amax1(0.,amin1(0.9,GGSIN2))/)
	         PD(14)=20
               TEXT(9:NPAR)=(/'C (Hook)','mju','Jm (max.stretch iso)',
     /                        'Jf (anisotropic)',
     /                        '(SIN beta)**2','n-integ'/)
	         WRITE(10,'('' Gent+Hook 5-param C,mju,Jm,Jf,beta.'')')
             CASE(5)
C Holzapfel symmetric c,K1,K2,BETA
 	         NPAR=13
          	 PD(9:12)=(/HC1,HK1,HK2,amax1(0.,amin1(0.9,HSIN2))/)
	         PD(13)=20
               TEXT(9:NPAR)=(/'C','k1','k2','(SIN beta)**2','n-integ'/)
	         WRITE(10,'('' Holzapfel 4-param.model C,k1,k2,beta.'')')
             ENDSELECT


          CASE('VIEW')
             PD(2:4)=(/100.,100.,100./)
             TEXT(2:4)=(/'X-eye','Y-eye','Z-eye'/)
          CASE('DETDOF','DETFUN')
             IF(IG.LE.MAXDET)THEN
               NPAR=6+2*IG
               DO J=1,IG
                 WRITE(LINE(1:3),'(I3)')J
                 TEXT(2*J+4)=LINE(1:3)//'. detector no.'
                 TEXT(2*J+5)=LINE(1:3)//'. response in column'
                 PD(2*J+4)=J
                 PD(2*J+5)=J+1
               ENDDO
               TEXT(NPAR)='time step (row of MOP)'
               PD(NPAR)=0
             ENDIF
          CASE('DETDEF')
             IF(IG.LE.MAXDET)THEN
               NPAR=11
               PD(2:11)=(/DETECT(IG,1),DETECT(IG,2),DETECT(IG,3),
     /                    DETECT(IG,4),DETECT(IG,5),DETECT(IG,6),
     /       DETECT(IG,7),DETECT(IG,8),DETECT(IG,9),DETECT(IG,10)/)
               TEXT(2:11)=(/'Front X','Front Y','Front Z','Back X',
     /                      'Back Y','Back Z','Apperture [m]',
     /     'View angle [degree]','Range [m]','Attenuation [1/m]'/)
             ENDIF
          CASE('MSF')
C MSF- plocha je trojuhelnik nebo ctyruhelnik
             CALL PLDSF(IG)
             NVERT=MSF(IG)
             IF(NVERT.EQ.4.OR.NVERT.EQ.8)THEN
C ctyruhelnik
               NX=1
               NY=1
               XLAFI=1.
               YLAFI=1.
               CALL SFCRID(IG,IC1,IC2,IC3,IC4)
               ICA1=IABS(IC1)
               IF(ICA1.GT.0)THEN
                  IF(NXCR(ICA1).GT.0)THEN
                     NX=NXCR(ICA1)
                     XLAFI=FLAFI(ICA1)
                     IF(IC1.LT.0.AND.FLAFI(ICA1).GT.0.)
     /                  XLAFI=1./FLAFI(ICA1)
                  ENDIF
               ENDIF
               ICA3=IABS(IC3)
               IF(ICA3.GT.0)THEN
                  IF(NXCR(ICA3).GT.0)THEN
                     NX=NXCR(ICA3)
                     XLAFI=FLAFI(ICA3)
                     IF(IC3.GT.0.AND.FLAFI(ICA3).GT.0.)
     /                  XLAFI=1./FLAFI(ICA3)
                  ENDIF
               ENDIF
               ICA2=IABS(IC2)
               IF(ICA2.GT.0)THEN
                  IF(NXCR(ICA2).GT.0)THEN
                     NY=NXCR(ICA2)
                     YLAFI=FLAFI(ICA2)
                     IF(IC2.LT.0.AND.FLAFI(ICA2).GT.0.)
     /                  YLAFI=1./FLAFI(ICA2)
                  ENDIF
               ENDIF
               ICA4=IABS(IC4)
               IF(ICA4.GT.0)THEN
                  IF(NXCR(ICA4).GT.0)THEN
                     NY=NXCR(ICA4)
                     YLAFI=FLAFI(ICA4)
                     IF(IC4.GT.0.AND.FLAFI(ICA4).GT.0.)
     /                  YLAFI=1./FLAFI(ICA4)
                  ENDIF
               ENDIF
               NPAR=7
               PD(2:3)=(/MAX0(NX,1),MAX0(NY,1)/)
               PD(4:5)=(/XLAFI,YLAFI/)
               PD(6:7)=(/NUSF,0/)
               TEXT(2:7)=(/'Nx','Ny','Last_x/First_x(+/-)',
     /               'Last_y/First_y(+/-)',
     /               'No.of Nodes (3,4,5,6,7,8,9)',
     /               'No.of inner nodes'/)
             ELSEIF(NVERT.EQ.3.OR.NVERT.EQ.6)THEN
               NPAR=5
               PD(2)=MAX0(NX,1)
               PD(3)=XLAFI
               PD(4:5)=(/NUSF,0/)
               TEXT(2:5)=(/'Nx','Last_x/First_x(+/-)',
     /               'No.of Nodes (3,6,7)','No.of inner nodes'/)
             ENDIF
          CASE('RCHEV')
             IGR=FLOOR(PD(1)+.5)
             IRC=IG
             IF(IGR.GT.0.AND.IGR.LE.MAXMGROUP.AND.
     /          IRC.GT.0.AND.IRC.LE.MAXMRCONS)THEN
                  WRITE(10,'('' Rewriting parameters of EGROUP '',i2,'' 
     /and RCONST'',i2)')IGR,IRC
               NPAR=12
               PD(3)=JGROUP(IGR,$GAUSS)
               PD(4)=JGROUP(IGR,$AXIS)
               PD(5)=JGROUP(IGR,$FI)
               PD(6:12)=   (/RRCONS(IRC,$H),RRCONS(IRC,$D),
     /                       RRCONS(IRC,$P),RRCONS(IRC,$ALFA),
     /                       RRCONS(IRC,$AREA),RRCONS(IRC,$PERIM),
     /                       RRCONS(IRC,$VOL)/)
               TEXT(3:12)=(/'Stream 1 (material prop)',
     /                      'Stream 2 (material prop)',
     /                      'No.of parallel channels',
     /                      'Plate thickness [m]',
     /                      'Hydraulic diameter De [m]',
     /                      'Chevron angle (deg)',
     /                      'Thermal cond.of plate [W/m/K]',
     /                      'Heat transf.surface of plate',
     /                      'Plate width [m]',
     /                      'Plate height [m]'/)
             ELSE
               EXIT
             ENDIF
          CASE('RCEHEV')
             IF(IG.LE.NE)THEN
               IRC=IRCONS(IG)
               IGR=IGROUP(IG)
               IF(IGR.GT.0.AND.IGR.LE.MAXMGROUP.AND.
     /            IRC.GT.0.AND.IRC.LE.MAXMRCONS)THEN
                  WRITE(10,'('' Rewriting parameters of EGROUP '',i2,'' 
     /and RCONST'',i2)')IGR,IRC
                 NPAR=11
                 PD(2)=JGROUP(IGR,$GAUSS)
                 PD(3)=JGROUP(IGR,$AXIS)
                 PD(4)=JGROUP(IGR,$FI)
                 PD(5:11)=   (/RRCONS(IRC,$H),RRCONS(IRC,$D),
     /                         RRCONS(IRC,$P),RRCONS(IRC,$ALFA),
     /                         RRCONS(IRC,$AREA),RRCONS(IRC,$PERIM),
     /                         RRCONS(IRC,$VOL)/)
                 TEXT(2:11)=(/'Stream 1 (material prop)',
     /                        'Stream 2 (material prop)',
     /                        'No.of parallel channels',
     /                        'Plate thickness [m]',
     /                        'Hydraulic diameter De [m]',
     /                        'Chevron angle (deg)',
     /                        'Thermal cond.of plate [W/m/K]',
     /                        'Heat transf.surface of plate',
     /                        'Plate width [m]',
     /                        'Plate height [m]'/)
               ELSE
                 EXIT
               ENDIF
             ENDIF

	    CASE('RCESTU')
C Shell&tube for existing ELEMENT
             IF(IG.LE.NE)THEN
               IRC=IRCONS(IG)
               IGR=IGROUP(IG)
               IF(IGR.GT.0.AND.IGR.LE.MAXMGROUP.AND.
     /            IRC.GT.0.AND.IRC.LE.MAXMRCONS)THEN
                  WRITE(10,'('' Rewriting parameters of EGROUP '',i2,'' 
     /and RCONST'',i2)')IGR,IRC
                 NPAR=21
                 PD(3)=JGROUP(IGR,$GAUSS)
                 PD(4)=JGROUP(IGR,$AXIS)
                 PD(5)=JGROUP(IGR,$ST)
                 PD(6)=JGROUP(IGR,$STRESS)
                 PD(7)=JGROUP(IGR,$FI)
 		       PD(8:21)=   (/RRCONS(IRC,$D),RRCONS(IRC,$H),
     /                         RRCONS(IRC,$PERMEAB),RRCONS(IRC,$AREA),
     /                         RRCONS(IRC,$PERIM),RRCONS(IRC,$ZETA),
     /                         RRCONS(IRC,$KN),RRCONS(IRC,$CEN),
     /                         RRCONS(IRC,$DUDY),RRCONS(IRC,$JZ),
     /                         RRCONS(IRC,$P),RRCONS(IRC,$RA),
     /                         RRCONS(IRC,$TE),RRCONS(IRC,$ALFA)/)
                 TEXT(3:21)=(/'Stream shell (material prop)',
     /                        'Stream tubes (material prop)',
     /                        'No.of passes in tube section',
     /                        'No.of tubes',
     /                        'No.of baffles',
     /                        'Tube outer diameter d2 [m]',
     /                        'Tube thickness st [m]',
     /                        'Tube length ltc [m]',
     /                        'Tube bundle diameter Ds [m]',
     /                        'Shell inner diamater D1 [m]',
     /                        'Baffle distance tp [m]',
     /                        'Baffle thickness sp [m]',
     /                        'Baffle height hp [m]',
     /                     'Clearance between tube and baffle stp [m]',
     /                     'Clearance between shell and baffle sps[m]',
     /                        'Layout angle (30,45,60,90) [deg]',
     /                        'Tubes spacing tt [m]',
     /                        'Wall roughness (inner,tube) [m]',
     /                        'Thermal cond.of tube [W/m/K]'
     /                        /)
C                              5  6  7  8  9 10 11 12 13 14 15 16 
                 IDIGR(5:21)=(/9,10,11,12,13,14,15,16,17,18,19,0,
     /                         0, 7,20, 0, 8/)
C                             17 18 19 20 21
               ELSE
                 EXIT
               ENDIF
             ENDIF
	    CASE('RCESTH')
C Shell&tube helical baffles for existing ELEMENT
               IRC=IRCONS(IG)
               IGR=IGROUP(IG)
               IF(IGR.GT.0.AND.IGR.LE.MAXMGROUP.AND.
     /            IRC.GT.0.AND.IRC.LE.MAXMRCONS)THEN
                  WRITE(10,'('' Rewriting parameters of EGROUP '',i2,'' 
     /and RCONST'',i2)')IGR,IRC
                 NPAR=22
                 PD(2)=JGROUP(IGR,$GAUSS)
                 PD(3)=JGROUP(IGR,$AXIS)
                 PD(4)=JGROUP(IGR,$FI)
                 PD(5)=JGROUP(IGR,$ST)
                 PD(6)=JGROUP(IGR,$STRESS)
                 PD(7)=JGROUP(IGR,$HEAT)
 			   PD(8:22)=   (/RRCONS(IRC,$H),RRCONS(IRC,$D),
     /                         RRCONS(IRC,$P),RRCONS(IRC,$ALFA),
     /                         RRCONS(IRC,$AREA),RRCONS(IRC,$PERIM),
     /                         RRCONS(IRC,$VOL),RRCONS(IRC,$ZETA),
     /                         RRCONS(IRC,$KN),RRCONS(IRC,$CEN),
     /                         RRCONS(IRC,$PERMEAB),RRCONS(IRC,$RA),
     /                         RRCONS(IRC,$TE),RRCONS(IRC,$DUDY),
     /                         RRCONS(IRC,$JZ)/)
                 TEXT(2:22)=(/'Stream 1 (material prop)',
     /                        'Stream 2 (material prop)',
     /                        'No.of baffles',
     /                        'No.of passes in tube section',
     /                        'No.of tubes',
     /                        'No.of pairs of sealing bars',
     /                        'Tube thickness [m]',
     /                        'Tube outer diameter[m]',
     /                        'Layout angle (30,45,60,90) [deg]',
     /                        'Thermal cond.of tube [W/m/K]',
     /                        'Tube bundle diameter [m]',
     /                        'Shell inner diamater [m]',
     /                        'Tube length without baffle [m]',
     /                        'Middle tube diameter [m]',
     /                        'Baffle thicknes [m]',
     /                        'Lead of helix angel (0-45)[deg]',
     /                        'Tubes distance [m]',
     /                        'Tube length [m]',
     /                        'Wall roughness (inner,tube) [m]',
     /                        'Clearance between tube and baffle [m]',
     /                        'Clearance between shell and baffle [m]'
     /                        /)
                 IDIGR(5:19)=(/9,6,0,0,0,7,6,0,0,8,6,0,0,0,10/)
               ELSE
                 EXIT
               ENDIF
	    CASE('RCSTUB')
C Shell&tube, specified groups
               IRC=FLOOR(PD(1)+.5)
               IGR=IG
               IF(IGR.GT.0.AND.IGR.LE.MAXMGROUP.AND.
     /            IRC.GT.0.AND.IRC.LE.MAXMRCONS)THEN
                  WRITE(10,'('' Rewriting parameters of EGROUP '',i2,'' 
     /and RCONST'',i2)')IGR,IRC
                 NPAR=21
                 PD(3)=JGROUP(IGR,$GAUSS)
                 PD(4)=JGROUP(IGR,$AXIS)
                 PD(5)=JGROUP(IGR,$ST)
                 PD(6)=JGROUP(IGR,$STRESS)
                 PD(7)=JGROUP(IGR,$FI)
 		       PD(8:21)=   (/RRCONS(IRC,$D),RRCONS(IRC,$H),
     /                         RRCONS(IRC,$PERMEAB),RRCONS(IRC,$AREA),
     /                         RRCONS(IRC,$PERIM),RRCONS(IRC,$ZETA),
     /                         RRCONS(IRC,$KN),RRCONS(IRC,$CEN),
     /                         RRCONS(IRC,$DUDY),RRCONS(IRC,$JZ),
     /                         RRCONS(IRC,$P),RRCONS(IRC,$RA),
     /                         RRCONS(IRC,$TE),RRCONS(IRC,$ALFA)/)
                 TEXT(3:21)=(/'Stream shell (material prop)',
     /                        'Stream tubes (material prop)',
     /                        'No.of passes in tube section',
     /                        'No.of tubes',
     /                        'No.of baffles',
     /                        'Tube outer diameter d2 [m]',
     /                        'Tube thickness st [m]',
     /                        'Tube length ltc [m]',
     /                        'Tube bundle diameter Ds [m]',
     /                        'Shell inner diamater D1 [m]',
     /                        'Baffle distance tp [m]',
     /                        'Baffle thickness sp [m]',
     /                        'Baffle height hp [m]',
     /                     'Clearance between tube and baffle stp [m]',
     /                     'Clearance between shell and baffle sps[m]',
     /                        'Layout angle (30,45,60,90) [deg]',
     /                        'Tubes spacing tt [m]',
     /                        'Wall roughness (inner,tube) [m]',
     /                        'Thermal cond.of tube [W/m/K]'
     /                        /)
C                              5  6  7  8  9 10 11 12 13 14 15 16 
                 IDIGR(5:21)=(/9,10,11,12,13,14,15,16,17,18,19,0,
     /                         0, 7,20, 6, 8/)
C                             17 18 19 20 21
               ELSE
                 EXIT
               ENDIF
	    CASE('RCSTH')
C shell&tube helical baffle (specified groups)
               IRC=FLOOR(PD(1)+.5)
               IGR=IG
               IF(IGR.GT.0.AND.IGR.LE.MAXMGROUP.AND.
     /            IRC.GT.0.AND.IRC.LE.MAXMRCONS)THEN
                  WRITE(10,'('' Rewriting parameters of EGROUP '',i2,'' 
     /and RCONST'',i2)')IGR,IRC
                 NPAR=23
                 PD(3)=JGROUP(IGR,$GAUSS)
                 PD(4)=JGROUP(IGR,$AXIS)
                 PD(5)=JGROUP(IGR,$FI)
                 PD(6)=JGROUP(IGR,$ST)
                 PD(7)=JGROUP(IGR,$STRESS)
                 PD(8)=JGROUP(IGR,$HEAT)
 		 PD(9:23)=   (/RRCONS(IRC,$H),RRCONS(IRC,$D),
     /                         RRCONS(IRC,$P),RRCONS(IRC,$ALFA),
     /                         RRCONS(IRC,$AREA),RRCONS(IRC,$PERIM),
     /                         RRCONS(IRC,$VOL),RRCONS(IRC,$ZETA),
     /                         RRCONS(IRC,$KN),RRCONS(IRC,$CEN),
     /                         RRCONS(IRC,$PERMEAB),RRCONS(IRC,$RA),
     /                         RRCONS(IRC,$TE),RRCONS(IRC,$DUDY),
     /                         RRCONS(IRC,$JZ)/)
                 TEXT(3:23)=(/'Stream 1 (material prop)',
     /                        'Stream 2 (material prop)',
     /                        'No.of baffles',
     /                        'No.of paths in tube section',
     /                        'No.of tubes',
     /                        'No.of pairs of sealing bars',
     /                        'Tube thickness [m]',
     /                        'Tube outer diameter[m]',
     /                        'Layout angle (30,45,60,90) [deg]',
     /                        'Thermal cond.of tube [W/m/K]',
     /                        'Tube bundle diameter [m]',
     /                        'Shell inner diamater [m]',
     /                        'Tube length without baffle [m]',
     /                        'Middle tube diameter [m]',
     /                        'Baffle thicknes [m]',
     /                        'Lead of helix angle (0-45)[deg]',
     /                        'Tubes distance [m]',
     /                        'Tube length [m]',
     /                        'Wall roughness (inner,tube) [m]',
     /                        'Clearance between tube and baffle [m]',
     /                        'Clearance between shell and baffle [m]'
     /                        /)
                 IDIGR(5:19)=(/9,6,0,0,0,7,6,0,0,8,6,0,0,0,10/)
               ELSE
                 EXIT
               ENDIF

          CASE('RCPUMP')
             IGR=FLOOR(PD(1)+.5)
             IRC=IG
             IF(IGR.GT.0.AND.IGR.LE.MAXMGROUP.AND.
     /          IRC.GT.0.AND.IRC.LE.MAXMRCONS)THEN
                  WRITE(10,'('' Rewriting parameters of EGROUP '',i2,'' 
     /and RCONST'',i2)')IGR,IRC
               NPAR=6
               PD(3)=JGROUP(IGR,$AXIS)
               PD(4:6)=(/RRCONS(IRC,$D),RRCONS(IRC,$P),RRCONS(IRC,$H)/)
               TEXT(3:6)=(/'Pump 0-any,1-milk,2-waterworks,...',
     /                      'Nozzle diameter [m]',
     /                      'Estimated flowrate [m^3/s]',
     /                      'Estimated discharge height [m]'/)
             ELSE
               EXIT
             ENDIF
          CASE('RCEPUM')
             IF(IG.LE.NE)THEN
               IRC=IRCONS(IG)
               IGR=IGROUP(IG)
               IF(IGR.GT.0.AND.IGR.LE.MAXMGROUP.AND.
     /            IRC.GT.0.AND.IRC.LE.MAXMRCONS)THEN
                  WRITE(10,'('' Rewriting parameters of EGROUP '',i2,'' 
     /and RCONST'',i2)')IGR,IRC
                 NPAR=5
                 PD(2)=JGROUP(IGR,$AXIS)
                PD(3:5)=(/RRCONS(IRC,$D),RRCONS(IRC,$P),RRCONS(IRC,$H)/)
                 TEXT(2:5)=(/'Pump 1-milk,2-water,3-slurry,...',
     /                       'Nozzle diameter [m]',
     /                       'Estimated flowrate [m^3/s]',
     /                       'Estimated discharge height [m]'/)
               ELSE
                 EXIT
               ENDIF
             ENDIF
          CASE('RCROSS')
             IRC=IG
             IF(IRC.GT.0.AND.IRC.LE.MAXMRCONS)THEN
               WRITE(10,'('' Rewriting parameters of RCONST '',i2)')IRC
               CALL RECTAB(RRCONS(IRC,$D),RRCONS(IRC,$AREA),PD(2),PD(3))
             ENDIF

          CASE('TCSET')
             IF(IG.LT.10)THEN
                EXIT
             ELSEIF(IG.LT.20)THEN
                TTP(3)=TTC(IG)
             ENDIF
          CASE('CURDEF')
             NPAR=MAX0(7,MIN0(19,2*IG+3))
          CASE('MPROP')
             IF(I.EQ.2)THEN
C prvni rozhodovani  IG - je cislo skupiny MPROP. 
C Pokusime se zjistit, kteremu typu elementu to nalezi 
               ISELSTEP=3
               DO IE=1,NE
                 IF(IMPROP(IE).EQ.IG)THEN
                   IEG=IGROUP(IE)
                   IF(IEG.GE.1.AND.IEG.LE.MGROUP)THEN
                      NA=MAX0(1,MIN0(JGROUP(IEG,1),MAXELEM))
                      PD(2)=NA
                      TTP(2)=TELEM(NA)
                      EXIT
                   ENDIF
                 ENDIF
               ENDDO
             ELSE
C druhe rozhodovani dle vybraneho typu elementu IG
C DEFAULT MPROP. IG je typ elementu
               IGR=MAX0(1,FLOOR(PD(1)+.5))
               IF(IG.LE.MAXELEM.AND.IGR.LE.MAXMMPROP)THEN
                 NPAR=2*NMPROP(IG)+2
                 DO J=1,NMPROP(IG)
                   LMP=LMPROP(IG,J)
                   IF(LMP.GE.1.AND.LMP.LE.MAXNMPROP)THEN
                     J2=2*J+1
                     TEXT(J2)=TMPROP(LMP)
                     TEXT(J2+1)=TRIM(TMPROP(LMP))//'_function'
                     PD(J2)=RMPROP(IGR,LMP)
                     PD(J2+1)=JMPROP(IGR,LMP)
                     IF(LMP.EQ.$E)IDIGR(J2)=38
                     IF(LMP.EQ.$KAPPA)IDIGR(J2)=39
                     IF(LMP.EQ.$AN)IDIGR(J2)=40
                     IF(LMP.EQ.$DN)IDIGR(J2)=41
                     IF(LMP.EQ.$TM)IDIGR(J2)=42
                     IF(LMP.EQ.$HM)IDIGR(J2)=43
                     IF(LMP.EQ.$KAPPE)IDIGR(J2)=44
                     IF(LMP.EQ.$KXE)IDIGR(J2)=45
                     IF(LMP.EQ.$BETA)IDIGR(J2)=46
                     IF(LMP.EQ.$VISC)IDIGR(J2)=47
                     IF(LMP.EQ.$CP)IDIGR(J2)=48
                     IF(LMP.EQ.$KX)IDIGR(J2)=49
                     IF(LMP.EQ.$RHO)IDIGR(J2)=50
                   ENDIF
                 ENDDO
               ELSE
                 WRITE(10,'('' Error material properties group'')')
                 RETURN
               ENDIF
             ENDIF
          CASE('EGROUP')
             IF(ISELSTEP.EQ.2)THEN
C ELEMENT KIND ACCORDING TO CURRENT. IG -prvni parametr, cislo EGROUP
               IF(IG.LE.MGROUP)THEN
                 PD(2)=JGROUP(IG,$ENAME)
                 TTP(2)=TELEM(MAX0(1,JGROUP(IG,$ENAME)))
               ENDIF
               ISELSTEP=3
             ELSE
C DEFAULT EGROUP.IG -druhy parametr, typ elementu. NGROUP(IG)-pocet parametru 
               IGR=MIN0(MAX0(1,FLOOR(PD(1)+.5)),MAXMGROUP)
               NPAR=NGROUP(IG)+1
               DO J=2,NGROUP(IG)
                 LGR=LGROUP(IG,J)
                 IF(LGR.GE.1.AND.LGR.LE.MAXNGROUP)THEN
                   J1=J+1
                   TEXT(J1)=TGROUP(LGR)
                   PD(J1)=JGROUP(IGR,LGR)
C IG-typ elementu, LGR-sloupec matice EGROUP
                   IF(LGR.EQ.$METHOD)THEN
                      IF(IG.EQ.$FLOW2D)IDIGR(J1)=1
                      IF(IG.EQ.$HEXC)IDIGR(J1)=2
                      IF(IG.EQ.$PUMP)IDIGR(J1)=4
                   ENDIF
                   IF(LGR.EQ.$ST)IDIGR(J1)=57
                   IF(LGR.EQ.$STRESS)IDIGR(J1)=58
                   IF(LGR.EQ.$AXIS)IDIGR(J1)=59
                   IF(LGR.EQ.$FI)IDIGR(J1)=55
                   IF(LGR.EQ.$HEAT)IDIGR(J1)=51
                   IF(LGR.EQ.$HSINK)IDIGR(J1)=52
                   IF(LGR.EQ.$NSOURCE)IDIGR(J1)=53
                   IF(LGR.EQ.$NSINK)IDIGR(J1)=54
                   IF(LGR.EQ.3.AND.IG.GE.$PLANE2D)IDIGR(J1)=3
                   IDIGR(J1+1)=100
                 ENDIF
               ENDDO
             ENDIF
          CASE('RCONST')
C DEFAULT RC
             IF(I.EQ.2)THEN
C prvni rozhodovani  IG - je cislo skupiny realnych konstant. 
C Pokusime se zjistit, kteremu typu elementu to nalezi 
               ISELSTEP=3
               DO IE=1,NE
                 IF(IRCONS(IE).EQ.IG)THEN
                   IEG=IGROUP(IE)
                   IF(IEG.GE.1.AND.IEG.LE.MGROUP)THEN
                      NA=MAX0(1,MIN0(JGROUP(IEG,1),MAXELEM))
                      PD(2)=NA
                      TTP(2)=TELEM(NA)
                      EXIT
                   ENDIF
                 ENDIF
               ENDDO
             ELSE
C druhe rozhodovani dle vybraneho typu elementu IG
               IGR=MIN0(MAX0(1,FLOOR(PD(1)+.5)),MAXMRCONS)
               NPAR=NRCONS(IG)+2
               DO J=1,NRCONS(IG)
                 LRC=LRCONS(IG,J)
                 IF(LRC.GE.1.AND.LRC.LE.MAXNRCONS)THEN
                   J2=J+2
                   TEXT(J2)=TRCONS(LRC)
                   PD(J2)=RRCONS(IGR,LRC)
                   IF(IG.EQ.$PIPE2D)THEN
                     IF(LRC.EQ.$D)IDIGR(J2)=61
                     IF(LRC.EQ.$TE)IDIGR(J2)=62
                     IF(LRC.EQ.$AREA)IDIGR(J2)=63
                     IF(LRC.EQ.$PERIM)IDIGR(J2)=64
                     IF(LRC.EQ.$DUDY)IDIGR(J2)=65
                     IF(LRC.EQ.$ZETA)IDIGR(J2)=66
                     IF(LRC.EQ.$PERMEAB)IDIGR(J2)=67
                     IF(LRC.EQ.$KN)IDIGR(J2)=68
                     IF(LRC.EQ.$CEN)IDIGR(J2)=69
                     IDIGR(J2+1)=100
                   ELSEIF(IG.EQ.$FLOW2D.OR.IG.EQ.$PLANE2D)THEN
                     IF(LRC.EQ.$TE)IDIGR(J2)=70
                     IF(LRC.EQ.$DUDY)IDIGR(J2)=71
                     IF(LRC.EQ.$ALFA)IDIGR(J2)=72
                     IDIGR(J2+1)=100
                   ENDIF
                   IF(LRC.EQ.$D)PD(J2)=AMAX1(PD(J2),0.001)
                 ENDIF
               ENDDO
             ENDIF
          CASE('RCHEX')
             PD(2)=RRCONS(IG,6)
             PD(3)=RRCONS(IG,4)
          CASE('NFSF')
C Vykresleni vybrane plochy a nastaveni poctu parametru dle poctu PT
             CALL PLDSF(IG)
             IF(MSF(IG).EQ.4)NPAR=7
          CASE('MCR')
C Vykresleni vybrane krivky
             CALL PLDCR(IG)
          CASE('NFCR')
C Vykresleni vybrane krivky a nastaveni poctu parametru dle poctu PT
             CALL PLDCR(IG)
             IF(MCR(IG).EQ.2)NPAR=5
          CASE('INPUT','OUTPUT')
C Vzruchove a odezvove funkce (seznam)
             NPAR=IG+1
          CASE('E')
C  element vyctem uzlu
             NPAR=IG+1
             IF(KGROUP.GT.0.AND.JGROUP(KGROUP,$ENAME).EQ.$HEXC
     /                     .AND.IG.EQ.4)IDIGR(2)=5
          CASE('COMPAR')
C Comparison of pairs
             NPAR=3*IG+3
          CASE('PARDEF')
C Names of model params
             NPAR=IG+1
             DO KK=1,IG
               TTP(KK+1)=VARTXT(KK)
               NAME(KK+1)=.TRUE.
               WRITE(TEXT(KK+1),'(I2,''-parameter name'')')KK
             ENDDO
          CASE('GTC')
C Graf nekolika krivek. Pokud je zadano IG=MAXSEL kresli se vsechny
             NPAR=IG+1
             IF(IG.EQ.MAXSEL)REA=.FALSE.
          CASE('WRITE')
C Vypis souboru s pozadovanou priponou
             IF(IG.LE.8)CALL SHOWFILE(21,POSTFIX(IG))
             IF(IG.EQ.7)THEN
                NPAR=3
                PD(3)=2.
                TEXT(3)='Column of C-values (=2,3,...)'
             ENDIF
          CASE('READ')
C Vypis souboru s pozadovanou priponou a default jmeno souboru *.NOD,...
             IF(IG.LE.11) CALL DIAFIL1(IEND,POSTFIX(IG),2)
             RETURN
          CASE('TCFFT')
C Regularizace jen pri dekonvoluci IP(1)=1; vynechame cteni parametru MODEL a W1
             SELECT CASE(IG)
             CASE(1)
                PD(2:4)=(/ICOLX,ICOLY,ICOLE/)
                PD(5)=SMOOTH
                PD(6)=IMODEL
                PD(7)=W1
                TEXT(2:7)=(/
     /               'Stimulus function X (2,..,10)',
     /               'Response function Y (2,..,10)',
     /               'Resulting impulse response E=Y/X (2,..,10)',
     /               'High frequencies supression (0 - 1)',
     /               'Assumed impulse response (N-mix)',
     /               'Weight of assumed model (>0)'/)
             CASE(2)
                PD(2:4)=(/ICOLX,ICOLE,ICOLY/)
                PD(5)=SMOOTH
                TEXT(2:5)=(/
     /               'Stimulus function X (2,..,10)',
     /               'Impulse response  E (2,..,10)',
     /               'Resulting response Y=E*X (2,..,10)',
     /               'High frequencies supression (0 - 1)'/)
                NPAR=5
             CASE(3)
                PD(2:4)=(/ICOLX,ICOLY,ICOLE/)
                PD(5)=SMOOTH
                TEXT(2:5)=(/
     /               'Function X (2,3,...,10)',
     /               'Function Y (2,3,...,10)',
     /               'Cross-correlation Rxy=X*Y (2,..,10)',
     /               'High frequencies supression (0 - 1)'/)
                NPAR=5
             CASE DEFAULT
                PD(2:3)=(/ICOLX,ICOLE/)
                PD(4)=SMOOTH
                TEXT(2:4)=(/
     /               'Noised function X (2,3,...,10)',
     /               'Filtered function Y (2,3,...,10)',
     /               'Smoothing level (-1 Wiener,...,1)'/)
                WRITE(10,'('' Smoothing level <0 activate Wiener filter,
     / value 1 activates interactive PSD cutoff'')')
                NPAR=4
             END SELECT
          END SELECT
        ENDIF

C=========================pokracovani
      
	
        IF(REA)THEN
C prikaz nebyl ukoncen strednikem, proto dialog
666        IPD=FLOOR(PD(I)+.5)
           CALL DIGR(IDIGR(I),PD)
           II=FOCUSQQ(10)
           IF(IPICK(I).GT.0)THEN
              II=SETTEXTCOLOR(int2(12))
              WRITE(10,'('' [F1-mouse]''\)')
           ENDIF
           II=SETTEXTCOLOR(int2(11))
           IF(NAMED(I).OR.NAME(I))THEN
              WRITE(10,'(1X,A,'' ['',A,''] > '',9X,\)')
     /                                    TRIM(TEXT(I)),TRIM(TTP(I))
           ELSEIF(FLOAT(IPD).EQ.PD(I).AND.ABS(PD(I)).LT.1000.)THEN
              WRITE(10,'(1X,A,'' ['',I4,''] >''\)')
     /                                    TRIM(TEXT(I)),IPD
           ELSE
              WRITE(10,'(1X,A,'' ['',E10.3,''] >''\)')
     /                                    TRIM(TEXT(I)),PD(I)
           ENDIF
           II=SETTEXTCOLOR(int2(15))
           CALL GMFEDLC(10,LINE,IEND)
C IEND=F1,F2,... moznost aktivace lokatoru (256,257,...), IEND=-1 (ESC)
           IF(IEND.GE.256.AND.IPICK(I).GT.0)THEN
              WRITE(10,'('' Use mouse to pick the entity (new default va
     /lue)...'')')
              SELECT CASE(IPICK(I))
              CASE(1)
                 CALL NIDENT(JMI,KBD)
              CASE(2)
                 CALL PIDENT(JMI,KBD)
              CASE(3)
                 CALL CIDENT(JMI,KBD)
              CASE(4)
                 CALL EIDENT(JMI,KBD)
              CASE(5)
                 CALL TIDENT(IDUMMY,JMI,KBD)
              CASE(6)
                 CALL TIDENT(JMI,IDUMMY,KBD)
              ENDSELECT
              PD(I)=JMI
              GOTO 666
           ENDIF
           IF(IEND.EQ.-1)GOTO 99
           IF(INDEX(LINE,';').GT.0)REA=.FALSE.
           CALL PROITE(I,LINE,IEND)
C PROITE generuje IP(i),RP(i),TP(i)
C IEND<0 chyba
           IF(IEND.LT.0.AND.REA.AND..NOT.NAME(I))THEN
               WRITE(10,'(''  Error parameter, repeat...'')')
               GOTO 666
           ENDIF
        ENDIF
        IF(IEND.LE.0)THEN
C DEFAULT
C PROITE konci bud hodnotou 
C         IEND>0 spravny vyraz, IEND=0 zadny text, IEND<0 chyba
          RP(I)=PD(I)
          IPD=FLOOR(RP(I)+.5)
          IF(NAME(I).OR.NAMED(I))THEN
             IF(IEND.EQ.0)TP(I)=TRIM(TTP(I))
          ELSEIF(FLOAT(IPD).EQ.RP(I).AND.ABS(RP(I)).LT.10000.)THEN
             WRITE(TP(I),'(I5)')IPD
          ELSE
             WRITE(TP(I),'(E10.3)')RP(I)
          ENDIF
        ENDIF
        IP(I)=FLOOR(RP(I)+.5)
C Vyznam nasledujiciho prirazeni je v tom, ze nasledujici zadavani
C parametru I+1,..., se muze ridit predchozimi vysledky
        PD(I)=RP(I)
        I=I+1
      ENDDO
C ======================================================
C Nove default hodnoty
      SELECT CASE(ICOM)
	CASE('ATTACH')
	   TOLERANCE=RP(2)
	CASE('VIEW')
	   IF(IP(1).EQ.0)THEN
            ROTAX=RP(2)
            ROTAY=RP(3)
            ROTAZ=RP(4)
         ENDIF	      
      CASE('DETDOF')
         JDDOF=IP(1)
         ATTENUAT=RP(2)
         IATTENUAT=IP(3)
         IVIEW=IP(4)
         NODET=IP(5)
      CASE('DETFUN')
         IFUN=IP(1)
         ATTENUAT=RP(2)
         IATTENUAT=IP(3)
         IVIEW=IP(4)
         NODET=IP(5)
      CASE('OPEN','CLOSE')
         MOP=IP(1)
	CASE('GMOD')
	   MOP=IP(1)
	   INDPAR=IP(2)
         PARMI=RP(3)
	   PARMA=RP(4)
	   ICOLYP=IP(6)
      CASE('SOLVE')
         IAPPEND=IP(4)
      CASE('SCALE')
         XMIN=RP(1)
         XMAX=RP(2)
         YMIN=RP(3)
         YMAX=RP(4)
      CASE('NFPLOT')
         JDDOF=IP(4)
      CASE('GE')
         JDEPAR=IP(1)
      CASE('GPIPE','GRAPH')
         IZONE=IP(2)
      CASE('BOXTES')
         XDEFA=RP(1)
         YDEFA=RP(2)
         ZDEFA=RP(3)
         JDDOF=IP(4)
         IZONE=IP(5)
      CASE('PTXYZ')
	   XDEFA=RP(2)
	   YDEFA=RP(3)
	   ZDEFA=RP(4)
      CASE('MCR   ')
         NX=IP(2)
         XLAFI=RP(3)
         NUCR=IP(4)
         IRPIPE=IP(5)
      CASE('MRG')
         NUTR=IP(2)
         NUCR=IP(4)
         MITER=IP(5)
         WEIGHT=RP(7)
         SIZE=RP(8)
         CONEAR=RP(9)
      CASE('MCT')
         NUTR=IP(4)
         MITER=IP(6)
         WEIGHT=RP(8)
         SIZE=RP(9)
      CASE('MCR2')
         NX=IP(3)
         MPIPE=IP(4)
         IRPIPE=IP(6)
         IRHEX=IP(8)
         IGPIPE=IP(9)
         IGHEX=IP(10)
      CASE('MCR4')
         IRHEX=IP(3)
         IGHEX=IP(4)
      CASE('MSF')
         IF(NVERT.EQ.4.OR.NVERT.EQ.8)THEN
            NX=IP(2)
            NY=IP(3)
            XLAFI=RP(4)
            YLAFI=RP(5)
            NUSF=IP(6)
         ELSEIF(NVERT.EQ.3.OR.NVERT.EQ.6)THEN
            NX=IP(2)
            XLAFI=RP(3)
            NUSF=IP(4)
         ENDIF
      CASE('NFCR')
         JDDOF=IP(2)
         P1=RP(4)
         P2=RP(5)
         P3=RP(6)
      CASE('NFSF')
         JDDOF=IP(2)
         P1=RP(4)
         P2=RP(5)
         P3=RP(6)
         P4=RP(7)
         P5=RP(8)
         P6=RP(9)
         P7=RP(10)
         P8=RP(11)
      CASE('NF','NFPT')
         JDDOF=IP(2)
         P1=RP(4)
      CASE('NID','PFPLOT','GCR')
         JDDOF=IP(2)
      CASE('INITIA')
         JDDOF=IP(1)
         IFUN=IP(2)
      CASE('FUNDEF')
         IFUN=IP(1)
      CASE('CURDEF')
         IFUN=IP(1)
         PDD(1:19)=RP(1:19)
      CASE('MOMENT')
         ICURVE=IP(1)
      CASE('IDMSER')
         ICURVE=IP(1)
         PMIX1=RP(2)
         TMEAN=RP(3)
      CASE('PASERI')
         ICURVE=IP(1)
         PMIX1=RP(2)
         PMIX2=RP(3)
         F=RP(4)
         ALFA=RP(5)
         TMEAN=RP(6)
      CASE('TAIL','NORM','TCBGR','COPYTO','TCRND','SMOOTH','TCYSHF',
     /     'TCREG')
         ICURVE=IP(1)
         IDESTIN=IP(2)
	CASE('TCP','TFL')
	   ICURVE=IP(1)
      CASE('TCJOIN','TCSUB')
         ICURVE=IP(1)
         IDESTIN=IP(2)
         INSERT=IP(3)
      CASE('LINREG','NELREG','LAGREG')
         MREG=IP(1)
         ICOLX=IP(2)
         ICOLY=IP(3)
         ICOLYP=IP(4)
         ICOLSIG=IP(5)
      CASE('NLR2')
         MREG=IP(1)
         ICOLX=IP(2)
         ICOLX2=IP(3)
         ICOLY=IP(4)
         ICOLYP=IP(5)
         ICOLSIG=IP(6)
      CASE('OPTIMA','SOMA','NELDER')
         MOP=IP(1)
         ITER=IP(2)
      CASE('TCFFT')
         IFFT=IP(1)
         ICOLX=IP(2)
         SELECT CASE(IP(1))
         CASE(1)
            ICOLY=IP(3)
            ICOLE=IP(4)
            SMOOTH=RP(5)
            IMODEL=IP(6)
            W1=RP(7)
         CASE(2)
            ICOLE=IP(3)
            ICOLY=IP(4)
            SMOOTH=RP(5)
         CASE(3)
            ICOLY=IP(3)
            ICOLE=IP(4)
            SMOOTH=RP(5)
         CASE DEFAULT
            ICOLE=IP(3)
            SMOOTH=RP(4)
         END SELECT
      CASE('EPIPE')
	   RR=RP(1)
	   RI=RP(2)
	   RO=RP(3)
	   RLZ=RP(4)
	   THETA=RP(5)
	   MODEL=IP(6)
	   SELECT CASE(MODEL)
	   CASE(1)
           C1=RP(7)
	     C2=RP(8)
	     B1=RP(9)
	     B2=RP(10)
	     B3=RP(11)
	   CASE(2)
           HC1=RP(7)
	     HK1=RP(8)
	     HK2=RP(9)
	     HSIN2=RP(10)
	   CASE(3)
           GC1=RP(7)
	     GMJU=RP(8)
	     GJF=RP(9)
	     GSIN2=RP(10)
         ENDSELECT
      CASE('EPIPER')
	   RR=RP(1)
	   OMG=RP(2)
	   RI=RP(3)
	   RO=RP(4)
	   RLZ=RP(5)
	   DELTA=RP(6)
	   THETA=RP(7)
	   MODEL=IP(8)
	   SELECT CASE(MODEL)
	   CASE(3)
           GC1=RP(9)
	     GMJU=RP(10)
	     GJF=RP(11)
	     GSIN2=RP(12)
	   CASE(4)
           GGC1=RP(9)
	     GGMJU=RP(10)
	     GGJM=RP(11)
	     GGJF=RP(12)
	     GSIN2=RP(13)
	   CASE(5)
           HC1=RP(9)
	     HK1=RP(10)
	     HK2=RP(11)
	     HSIN2=RP(12)
         ENDSELECT
	CASE('ELONEX')
	   RLA=RP(1)
	   RLT=RP(2)
	   HHH=RP(3)
	   WA=RP(4)
	   WT=RP(5)

	CASE('FOAM')
	   DTIME=RP(1)
	   HPLATE=RP(2)
	   RMASS=RP(3)
	   OMGW=RP(4)
	   ALPHA=RP(5)
	   PSI=RP(6)
	   RKO=RP(7)
	   RB0=RP(8)
	   timax=rp(9)
	CASE('FOAMS')
	   DTIME=RP(1)
	   HPLATE=RP(2)
	   RMASS=RP(3)
	   OMGW=RP(4)
	   T0=RP(5)
	   EPSF=RP(6)
	   RK=RP(7)
	   RPSI=RP(8)
	   EM=RP(9)
	   EN=RP(10)
         TIMAX=RP(11)
	CASE('FOAMV')
	   DTIME=RP(1)
	   HPLATE=RP(2)
	   RMASS=RP(3)
	   OMGW=RP(4)
	   ALPHA=RP(5)
	   PSI=RP(6)
	   RKO=RP(7)
	   RB0=RP(8)
	   RBF=RP(9)
	   EPSF=RP(10)
         TC=RP(11)
	   timax=rp(12)

      ENDSELECT
      II=SETTEXTCOLOR(int2(15))
      IEND=0
99    END

      SUBROUTINE DIGR(I,PD)
C Zobrazeni dialogu, pokud je i>0
      DIMENSION PD(1)
      IF(I.LE.0)RETURN
      SELECT CASE(I)
      CASE(1)
C Egroup flow2d - metoda
          CALL DIAGRA('$METHOD.BMP')
      CASE(2)
C Egroup HEXC - metoda
          CALL DIAGRA('$EGHEXC.BMP')
      CASE(3)
C Gaussovy body 2D
          CALL DIAGRA('$GAUSP.BMP')
      CASE(4)
C Egroup cerpadla
          CALL DIAGRA('$EGPUMP.BMP')
      CASE(5)
C element - vymenik (jak cislovat uzly)
          CALL DIAGRA('$ELEHEX.BMP')
      CASE(6)
C shell $ tube - geometrie a koty
          CALL DIAGRA('$STUBE.BMP')
      CASE(7)
C usporadani trubek
          CALL DIAGRA('$STUBANG.BMP')
          IF(PD(18).LE.0.)PD(18)=60.
      CASE(8)
          IF(PD(21).LE.0.)PD(21)=50.
      CASE(9)
C pocet tahu v trubkach
          CALL DIAGRA('$STPASS.BMP')
          PD(5)=AMAX1(1.,AMIN1(4.,PD(5)))
      CASE(10)
C pocet trubek
          CALL DIAGRA('$STUBE.BMP')
          PD(6)=AMAX1(1.,AMIN1(10000.,PD(6)))
      CASE(11)
C pocet prepazek
          PD(7)=AMIN1(50.,PD(7))
      CASE(12)
C prumer trubky
          PD(8)=AMAX1(0.005,PD(8))
      CASE(13)
C tloustka steny trubky
          PD(9)=AMIN1(PD(8)*0.4,PD(9))
      CASE(14)
C delka trubek
          PD(10)=AMAX1(PD(8),PD(10))
      CASE(15)
C prumer svazku
          PD(11)=AMAX1(SQRT(PD(6))*PD(8)*1.2,PD(11))
      CASE(16)
C prumer plaste
          PD(12)=AMAX1(PD(11)*1.01,PD(12))
      CASE(17)
C roztec prepazek
          PD(13)=AMAX1(PD(10)/(PD(7)+1.),PD(13))
      CASE(18)
C tloustka prepazek
          PD(14)=AMAX1(0.001,PD(14))
      CASE(19)
C vyska prepazek
          PD(15)=AMAX1(PD(12)*.4,AMIN1(PD(12)*.95,PD(15)))
      CASE(20)
C Roztec trubek
          PD(19)=AMAX1(PD(8)*1.1,PD(19))
      CASE(21)
C OPTION SOURCE
          CALL DIAGRA('$OPSOURCE.BMP')
      CASE(22)
C OPTION UPW
          CALL DIAGRA('$OPUPW.BMP')
      CASE(23)
C OPTION FOULING
          CALL DIAGRA('$OPFOUL.BMP')
      CASE(24)
C OPTION MWR
          CALL DIAGRA('$OPMWR.BMP')
      CASE(25)
C OPTION TRESHOLD
          CALL DIAGRA('$OPTRESH.BMP')
      CASE(26)
C OPTION PIVOT
          CALL DIAGRA('$OPIVOT.BMP')
      CASE(27)
C OPTION RELAX FAKTOR
          CALL DIAGRA('$OPRELF.BMP')
      CASE(28)
C OPTION LAMBDA
          CALL DIAGRA('$OPLAMBDA.BMP')
      CASE(29)
C OPTION THETA
          CALL DIAGRA('$OPTHETA.BMP')
      CASE(30)
C OPTION TAUD
          CALL DIAGRA('$OPTAUD.BMP')
      CASE(31)
C OPTION BND
          CALL DIAGRA('$OPBND.BMP')
      CASE(32)
C OPTION BUOYANCY
          CALL DIAGRA('$OPBUOY.BMP')
      CASE(33)
C OPTION PHASE CHANGES
          CALL DIAGRA('$OPPHASE.BMP')
      CASE(34)
C OPTION MASS/VOLUMETRIC FLOW RATE
          CALL DIAGRA('$OPMASS.BMP')
      CASE(35)
C OPTION RESIDUALS
          CALL DIAGRA('$OPRESID.BMP')
      CASE(38)
C MPROP EX 
          CALL DIAGRA('$MPEX.BMP')
      CASE(39)
C MPROP KAPPA
          CALL DIAGRA('$MPKAPPA.BMP')
      CASE(40)
C MPROP AN
          CALL DIAGRA('$MPAN.BMP')
      CASE(41)
C MPROP DN
          CALL DIAGRA('$MPDN.BMP')
      CASE(42)
C MPROP TMELT
          CALL DIAGRA('$MPTM.BMP')
      CASE(43)
C MPROP HM
          CALL DIAGRA('$MPHM.BMP')
      CASE(44)
C MPROP KAPPE
          CALL DIAGRA('$MPKAPF.BMP')
      CASE(45)
C MPROP KXF
          CALL DIAGRA('$MPKF.BMP')
      CASE(46)
C MPROP BETA
          CALL DIAGRA('$MPBETA.BMP')
      CASE(47)
C MPROP BETA
          CALL DIAGRA('$MPVISC.BMP')
      CASE(48)
C MPROP BETA
          CALL DIAGRA('$MPCP.BMP')
      CASE(49)
C MPROP BETA
          CALL DIAGRA('$MPKX.BMP')
      CASE(50)
C MPROP BETA
          CALL DIAGRA('$MPDENS.BMP')
      CASE(51)
C EGROUP HEAT SOURCE
          CALL DIAGRA('$EGHEAT.BMP')
      CASE(52)
C EGROUP HEAT SINK
          CALL DIAGRA('$EGHSINK.BMP')
      CASE(53)
C EGROUP CN-SOURCE
          CALL DIAGRA('$EGNSOUR.BMP')
      CASE(54)
C EGROUP CN-SINK
          CALL DIAGRA('$EGNSINK.BMP')
      CASE(55)
C EGROUP FI-hydraulic characteristic
          CALL DIAGRA('$EGHYDR.BMP')
      CASE(56)
C EGROUP name of element
          CALL DIAGRA('$EGname.BMP')
      CASE(57)
C EGROUP transient/steady
          CALL DIAGRA('$EGtrans.BMP')
      CASE(58)
C EGROUP stress
          CALL DIAGRA('$EGstres.BMP')
      CASE(59)
C EGROUP axis
          CALL DIAGRA('$EGaxis.BMP')
      CASE(61)
C RCON PIPE DIAMETER
          CALL DIAGRA('$RCDIAM.BMP')
      CASE(62)
C RCON PIPE EXTERNAL TEMPERATURE
          CALL DIAGRA('$RCTE.BMP')
      CASE(63)
C RCON PIPE AREA
          CALL DIAGRA('$RCAREA.BMP')
      CASE(64)
C RCON PIPE PERIM
          CALL DIAGRA('$RCPERIM.BMP')
      CASE(65)
C RCON PIPE DUDY
          CALL DIAGRA('$RCDUDY.BMP')
      CASE(66)
C RCON PIPE ZETA
          CALL DIAGRA('$RCZETA.BMP')
      CASE(67)
C RCON PIPE PERMEAB
          CALL DIAGRA('$RCPERM.BMP')
      CASE(68)
C RCON PIPE KN
          CALL DIAGRA('$RCPKN.BMP')
      CASE(69)
C RCON PIPE CEN
          CALL DIAGRA('$RCPCEN.BMP')
      CASE(70)
C RCON FLOW TE
          CALL DIAGRA('$RCFTE.BMP')
      CASE(71)
C RCON PIPE DUDY
          CALL DIAGRA('$RCFDUDY.BMP')
      CASE(72)
C RCON PIPE ALFA
          CALL DIAGRA('$RCFALFA.BMP')
      CASE(73)
C FUNDEF
          CALL DIAGRA('$FUNDEF.BMP')
      CASE(74)
C CURDEF
          CALL DIAGRA('$CURDEF.BMP')
      CASE(75)
C INDEX-FUNC
          CALL DIAGRA('$IFUN.BMP')
      CASE(80)
C OPTIMA 
          CALL DIAGRA('$Optima.BMP')
      CASE(81)
C OPTIMA iter
          CALL DIAGRA('$OMAITER.BMP')
      CASE(82)
C OPTIMA model
          CALL DIAGRA('$OMAMOD.BMP')
      CASE(83)
C OPTIMA lambda
          CALL DIAGRA('$OMALAM.BMP')
      CASE(84)
C OPTIMA scale
          CALL DIAGRA('$OMAscal.BMP')
      CASE(85)
C SOMA
          CALL DIAGRA('$SOMA.BMP')
      CASE(86)
C SOMA pert
          CALL DIAGRA('$SOMAPER.BMP')
      CASE(87)
C SOMA step
          CALL DIAGRA('$SOMASTE.BMP')
      CASE(88)
C SOMA MASS
          CALL DIAGRA('$SOMAMAS.BMP')
      CASE(90)
C INLETY
          CALL DIAGRA('$INLET.BMP')
      CASE(91)
C NELDER EXPANSION
          CALL DIAGRA('$NELDER1.BMP')
      CASE(92)
C NELDER CONTRACTION
          CALL DIAGRA('$NELDER2.BMP')
      CASE(93)
C NELDER REDUCTION
          CALL DIAGRA('$NELDER3.BMP')
      CASE(100)
C default window 21
          CALL INFO21(20)
      END SELECT
      END
      
C      INCLUDE '$S0-HELP.FOR'
