      SUBROUTINE HELP
C
C Procedura jen zobrazi fixni text (souhrn prikazu) v okne 40.
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEM'
      II=SETACTIVEQQ(40)
      II=SETBKCOLOR(3)
      CALL CLEARSCREEN($GCLEARSCREEN)
      II=SETBKCOLOR(1)
      WRITE(40,30)
30    FORMAT(' AVAILABLE COMMANDS: ')
      II=SETBKCOLOR(3)
      WRITE(40,40)
40    FORMAT(
     /' NEW(clear database) F or M(interpret session file as a batch or 
     /macro) Q(quit program) UNDO(return back) RECORD(macro) ENDREC'/
     /' control: #LABEL xxxx, #GOTO xxxx, #LOOP xxxx N (repeat N-times u
     /p to label xxxx), #IF relation THEN, #ELSE, #ENDIF'/
     /' windows: SCALE(range of model window) CLS(clear model) ZOOMI(or 
     /ZI) ZOOMOUT(or ZO) U(up list window) D(down) PU(PgUp) PD(PgDn)'/
     /' export/import: WRITE,READ (or W,R text files) WRITEB,READBI (or 
     /WB,RB, database as a binary file), ROM (RTD data,time-concentr.)'/
     /' groups:    EGROUP(or EG, element group) MPROP (or MP,material pr
     /operties) RCONST (or RC, real constants)'/
     /' functions: CURDEF(or CD, table of points) FUNDEF(or FD, expressi
     /on) CURLIST FUNLIST (or CURL,FUNL, lists)'/
     /' geometry: ZDEF(default Z) PT(point by mouse) CR2PT(curve by 2 po
     /ints) CR3PT, SF4PT(surface) SF8PT'/
     /'           SFCR(surface by 2 curves), CIRCLE,ARC (center and poin
     /t), CRS (polyline), PMERGE (merge points and curves)'/
     /' listings (abbr.form PTL,CRL,...): PTLIST CRLIST SFLIST NDLIST(no
     /des and DOFs) NFLIST(forces and fixed DOF in nodes)'/
     /'           ELIST EPLIST(element parameters EPAR) MPLIST RCLIST EG
     /LIST CLIST(Control parameters) DOFLIS(DOF range)'/
     /' activation: ACTNUM(numbering) INACTNUM ACTSET(element groups for
     / meshing) GRIDON GRIDOF (grid for PT definition)'/
     /' plots (abbr.PTP,CRP,...): PTPLOT CRPLOT SFPLOT NDPLOT NFPLOT EPL
     /OT PFPLOT(or METER-displays analog dial)'/
     /' graphs: GD1(DOF in 1D models) GD2(DOF contours in 2D models) GE1
     /(element parameter) GE2(contours of element parameters)'/
     /'          GC(plot DOF along a curve) GRAFUN(plot function) GRATIM
     /(time courses of picked DOFs) LOADT(load results from time)'/
     /' picking (abbr.NID,PID,EID,CID): NIDENT(nodes and DOFs) PIDENT(po
     /ints) EIDENT(elements and parameters) CIDENT(curves) TCIDENT'/
     /' nodes: NMERGE(merge and compress nodes) ND(define node by mouse)
     / E (define element directly)'/
     /' meshing:   MCR(mesh curve) MCRC MCR2(Heat Exchanger), MSF(mesh s
     /urface), MVL (mesh volume)'/
     /' forces, boundary, initial conditions: NFCR(DOF on a curve)  NFSF
     /(on surface) NF(in node) NFPT(in point) INITIAL(condition)'/
     /' run: OPTION adjusts solution parameters, SOLVE start solution us
     /ing external program (ELEC,FLOW,THER,CONC,STAT)')
      IF(NEXCOM.GT.0)WRITE(40,90)(NEXKWD(I),I=1,NEXCOM)
90    FORMAT(' Externals:',10(1X,A))
      II=SETBKCOLOR(1)
      WRITE(40,50)
50    FORMAT(' SYSTEM VARIABLES (use VARL,or LOC Variable for details)')
      II=SETBKCOLOR(3)
      WRITE(40,60)
60    FORMAT(
     /  ' auxilliary variables: A,B,...,Z'/
     /  ' current nodal values:XX,YY,ZZ,II,TIME /coords, second invarian
     /t, time/'/
     /  ' indices DOF:TEMP,UX,UY,UZ/disp./,RX,RY,RZ/rot/,VOLT,VX,VY,VZ/v
     /el./,PRES,OMG/vorticity/,PS/stream/,PSX,PSX,CN,CD,CA,KT,EPS,FILM'/
     /  ' indices E-parameter:ENA,ENB,EMA,EMB,EQZ,EQ,ERE,ETAU,EFOUL,EDIS
     /S,ELAV,EII,ETX,ETY,ESXX,ESYY,ESXY,EMISE,EPOWER,ETMEAN,EVX,EVY'/
     /  ' indices E-type:PIPE2D,TRUSS2D,BEAM2D,CSTR,PUMP,VALVE,SHELLAX,H
     /EXC,PLANE2D,FLOW2D,PSI,PLINK,MASS'/
     /  ' indices Flow methods:UVP,UVPP,MIKE/veloc.+pres./,PENS,MIDE/vel
     /ocities/,PSIN,PSBL,CREE/stream f./,PSOM/stream f.+vorticity/'/
     /  ' number of entities: NPT,NCR,NSF,NVL /geometry/, NE,ND /element
     / and nodes/, NEG,NRC,NMP /groups: element,real const,mat.prop./'/
     /  ' number of iterations for individual operations: ELEC,FLOW,THER
     /,CONC,STAT /voltage,flow,thermal,concentration,stress analysis/'/
     /  ' switches,params: BUOY/buoyancy/,GX,GY/acceler./,LAMB/penalty/,
     /OHMI/sources/,PIVT/mininum pivot/,UPW,RUPW/upwind switch,correct/'
     //'     DT/time step/,STEP/no.of steps/, SCL/scale deformed/,TOL/di
     /stance/, HEPI/weight.resid.,enthalpy balance,charact./, RT/fouling
     //'/
     /  ' coordinates: XND(i),YND(i),ZND(i),XPT(i),YPT(i),ZPT(i)'/
     /  ' real constants: HH(i)-thickness,DD(i)-diam.,PE(i),ALPHA(i)-hea
     /t trans.,TE(i),AREA(i),PERIM(i)-perimeter,JZ(i)-inertia moment'/' 
     /    VOL(i)-volume,RA(i)-roughness,DUDY(i)-elec.field, ZETA(i)-loss
     / coef.,PERM(i)-permeability'/
     /  ' material: KX(i)-therm.cond.,CP(i),DENS(i),KAPPA(i)-el.cond.,EX
     /(i)-Young,VISC(i),BETA(i)-therm.exp.,DN(i)-diffus.,HN(i)-enthalpy'
     //'      AN(i),TM(i)-melting,HM(i)-latent heat.'/
     /  ' element group: ENAME(i),TRANS(i)-static/transient,GAUSS(i)-Gau
     /ss points,AXIS(i)-Cartesian/Cylindrical,STRESS(i)-stress/strain'/
     /  ' DEV(dof)-deviation,MEAN(dof)-mean abs.value of DOF,RNG(dof)-mi
     /n/max values of DOF.'/
     /  ' LPU(i)-location of DOF,IPU(i)-status,JPU(i)-dof type'/
     /  ' nodal parameters: V1(i)-boundary cond.,V2(i)-solution,V3(i)-in
     /itial cond., element parameters: E1(i),E2(i),...,E5(i)'/
     /  ' Models and time curves: T1(i),C1(i),...,NGR(i), CM(i),DCM(i)-v
     /ariab.,deriv., PM(i)-model parameters')
      II=SETBKCOLOR(1)
      WRITE(40,70)
70    FORMAT(' FUNCTIONS: ')
      II=SETBKCOLOR(3)
      WRITE(40,80)
80    FORMAT(' SIN(x),COS(x),EXP(x),LOG(x),LGT(x),ABS(x),MIN(x1,x2,...),
     /MAX(x1,x2,..),ATN(x),ERF(x),PLE(n,x),PLG(n,x),PTC(n,x),RND(0)'/
     /' DOF(dof,zone,x,y,z), EPA(param,x,y,z),  CVT(i,time), XVT(i,time)
     /, YVT(i,time)')
      II=SETACTIVEQQ(10)
      END

      SUBROUTINE SHOWBEG(IUNIT)
C
C Vypis prvnich MAXTROWS radku souboru na zarizeni IUNIT v okne 21
C Soubor je pote nastaven na zacatek
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      CHARACTER*45 LINE,ROWNUM*3
      INTEGER*2 C1,C2,IRP
      LOGICAL RES1
      TYPE(XYCOORD)POS
      TYPE(WINDOWCONFIG)WC
      CALL FINQUIRE(IUNIT,LINE)
      II=FOCUSQQ(22)
      RES1=GETWINDOWCONFIG(WC)
      CALL SETVIEWPORT(0,0,WC.NUMXPIXELS,WC.NUMYPIXELS)
      II=SETBKCOLOR(0)
      CALL CLEARSCREEN($GCLEARSCREEN)
      C1=SETTEXTCOLOR(INT2(11))
      WRITE(22,'('' This is beginning of ['',A,''] unit='',I2)')
     /      LINE(1:12),IUNIT
      REWIND(IUNIT,ERR=999,IOSTAT=IER)
      LC=0
      INDEX=SETFONT('t''Courier''h14f')
      DO IR=1,WC.NUMYPIXELS/12-2
         READ(IUNIT,'(A)',END=775)LINE
         LC=LC+1
         IRP=IR*12+6
         CALL MOVETO(0,IRP,POS)
         C2=SETCOLOR(INT2(11))
         WRITE(ROWNUM,'(I3)')IR
         C2=SETCOLOR(INT2(11))
         CALL OUTGTEXT(ROWNUM)
         CALL MOVETO(INT2(23),IRP,POS)
         C2=SETCOLOR(INT2(15))
         CALL OUTGTEXT(LINE)
      ENDDO
775   REWIND(IUNIT,ERR=999)
999   C2=SETTEXTCOLOR(C1)
      IF(LC.EQ.0)WRITE(21,'('' EMPTY FILE'')')
      END

      SUBROUTINE SHOWF(FILESPEC,LINE,MAXLIN,LLIN)
C
C Pomocna procedura pro SHOWFILE
C Do textoveho vektoru LINE*20 vybere LLIN jmen 
C vyhovujicim specifikaci FILESPEC
C
      CHARACTER*(*) FILESPEC
      CHARACTER*20 LINE(MAXLIN)
C Doplneni seznamu LINE indexem 0 pocinaje
      CALL GFILNAM(FILESPEC,LINE,MAXLIN,0,LLIN)
C Setrideni
      IF(LLIN.GT.0)CALL SFILNAM(LINE,MAXLIN,LLIN)
      END

      SUBROUTINE SHOWF2(FILESPEC1,FILESPEC2,LINE,MAXLIN,LLIN)
C
C Pomocna procedura pro cteni matice ROM
C Do textoveho vektoru LINE*20 vybere LLIN jmen 
C vyhovujicim specifikaci FILESPEC1 nebo FILESPEC2 a setridi je
C
      CHARACTER*(*) FILESPEC1,FILESPEC2
      CHARACTER*20 LINE(MAXLIN)
      CALL GFILNAM(FILESPEC1,LINE,MAXLIN,0,LLIN1)
      CALL GFILNAM(FILESPEC2,LINE,MAXLIN,LLIN1,LLIN)
      IF(LLIN.GT.0)CALL SFILNAM(LINE,MAXLIN,LLIN)
      END

      SUBROUTINE GFILNAM(FILESPEC,LINE,MAXLIN,LZER,LLIN)
C
C Pomocna procedura pro SHOWF,SHOWF2 vybira do vektoru jmena souboru
C indexem LZER+1 pocinaje a indexem LLIN konce.
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      CHARACTER*(*) FILESPEC
      CHARACTER*20 LINE(MAXLIN)
      TYPE(FILE$INFO) INFO
      LLIN=LZER
      IHANDLE=FILE$FIRST
      LEN=GETFILEINFOQQ(FILESPEC,INFO,IHANDLE)
      DO WHILE(LEN.GT.0.AND.LLIN.LT.MAXLIN)
        LLIN=LLIN+1
        IF(FILESPEC(1:2).EQ.'.\')THEN
          LINE(LLIN)='.\FILES\'//INFO.NAME
        ELSE
          LINE(LLIN)=INFO.NAME
        ENDIF
        CALL TLWC(20,LINE(LLIN),LINE(LLIN))
        LEN=GETFILEINFOQQ(FILESPEC,INFO,IHANDLE)
        IF(IHANDLE.EQ.FILE$LAST)EXIT
      ENDDO
      END

      SUBROUTINE SFILNAM(LINE,MAXLIN,LLIN)
C
C abecedni setrideni textoveho vektoru LINE*20
C
      CHARACTER*20 LINE(MAXLIN),LAUX
      LOGICAL SORTED
      SORTED=.FALSE.
      DO WHILE(.NOT.SORTED)
         SORTED=.TRUE.
         DO I=1,LLIN-1
            IF(LINE(I)(1:3).GT.LINE(I+1)(1:3))THEN
               SORTED=.FALSE.
               LAUX=LINE(I)
               LINE(I)=LINE(I+1)
               LINE(I+1)=LAUX
            ENDIF
         ENDDO
      ENDDO
      END

      SUBROUTINE SHOWFILE(IUN,FILESPEC)
C
C Zobrazeni jmen souboru vyhovujicich specifikaci FILESPEC (napr. *.txt)
C v okne cislo IUN.
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      CHARACTER*(*) FILESPEC
      CHARACTER*20 LINE
	COMMON /$AUXILINE/LINE(100)
      INTEGER*4 C1
      TYPE(XYCOORD)POS
      TYPE(WINDOWCONFIG)WC
      CALL SHOWF(FILESPEC,LINE,100,LLIN)
      IF(LLIN.GT.0)THEN
         II=SETACTIVEQQ(IUN)
         II=SETBKCOLOR(3)
         RES1=GETWINDOWCONFIG(WC)
         CALL SETVIEWPORT(0,0,WC.NUMXPIXELS,WC.NUMYPIXELS)
         CALL CLEARSCREEN($GCLEARSCREEN)
         C1=SETTEXTCOLOR(INT2(11))
         WRITE(IUN,'('' Existing '',A8,'' files'',\)')
     /            TRIM(FILESPEC)
         LC=5
         LR=0
         INDEX=SETFONT('t''Courier''h14f')
         GRSTAT=SETCOLOR(INT2(15))
         DO I=1,LLIN
           LR=LR+1
           IF(LR.GE.WC.NUMYPIXELS/14-2)THEN
              LR=1
              LC=LC+100
           ENDIF
           IRP=LR*12+6
           CALL MOVETO(LC,IRP,POS)
           CALL OUTGTEXT(LINE(I))
         ENDDO
      ENDIF
      END

      SUBROUTINE SHOWUNIT(IUN)
C
C Vypis cisel zarizeni UNIT
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      LOGICAL OPE
      CHARACTER*64 FILENAME
      INTEGER*2 C1,C2
      WRITE(IUN,'('' Opened:''\)')
      C2=SETTEXTCOLOR(INT2(11))
      DO I=1,50
         INQUIRE(UNIT=I,OPENED=OPE,NAME=FILENAME)
         L=LEN(FILENAME)
	   IND=INDEX(FILENAME,'\')
	   INDB=1
         DO WHILE(IND.GT.0.AND.INDB.LT.L-IND)
	      INDB=INDB+IND
	      IND=INDEX(FILENAME(INDB:L),'\')
	   ENDDO
         IF(L.GT.1)THEN
            CALL TUPC(1,FILENAME(INDB:INDB),FILENAME(INDB:INDB))
            CALL TLWC(L-INDB,FILENAME(INDB+1:L),FILENAME(INDB+1:L))
         ENDIF
         IF(OPE)WRITE(IUN,'(I3,''-'',A\)')I,TRIM(FILENAME(INDB:L))
      ENDDO
      WRITE(IUN,*)
      C1=SETTEXTCOLOR(C2)
      END

      SUBROUTINE SHOWTC(IUN)
C
C Informace o vsech TC funkcich, ktere jsou nenulove v okne cislo IUN
C
      INCLUDE '$FEM'
      INTEGER MEMPTY(MAXSEL)
      LOGICAL EXIST
C Zjisteni toho, kolik je definovanych TC (dle toho se pak voli bohatost
C vypisu
      NDEF=0
      DO IG=2,MAXSEL
         IF(IQGR(IG).NE.0)NDEF=NDEF+1
      ENDDO
      EXIST=.FALSE.
      NEMPTY=0
      N3=0
      DO IG=2,MAXSEL
C IQGR = 0 not def, =1 time, =2 FEM, =3 experimental data, =4 inlet..
C EXIST=.TRUE. jen pro experimentalni data a ne pro vysledky FEM (vykresleni ukazky).
        IF(IQGR(IG).EQ.3)THEN
          N3=N3+1
          IF(NDEF.LE.2)THEN
             WRITE(IUN,'(1X,I2,''['',A4,'']:'',A12\)')
     /    IG,TTC(MIN0(20,IQGR(IG)+1)),TRIM(FILEXPERI(IG))
          ELSEIF(NDEF.LE.4.OR.N3.EQ.1)THEN
             WRITE(IUN,'(I2,''['',A4,'']:'',A8\)')
     /    IG,TTC(MIN0(20,IQGR(IG)+1)),TRIM(FILEXPERI(IG))
          ELSE
             WRITE(IUN,'(I2,''['',A4,'']:'',\)')
     /    IG,TTC(MIN0(20,IQGR(IG)+1))
          ENDIF
          EXIST=.TRUE.
        ELSEIF(IQGR(IG).GE.1)THEN
          WRITE(IUN,'(1X,I2,''['',A4,'']'',\)')
     /    IG,TTC(MIN0(20,IQGR(IG)+1))
          EXIST=.TRUE.
        ELSE
          NEMPTY=NEMPTY+1
          MEMPTY(NEMPTY)=IG
        ENDIF
      ENDDO
      IF(EXIST)THEN
         WRITE(IUN,'('' Empty:'',10I3)')(MEMPTY(I),I=1,NEMPTY)
         IF(IUN.NE.11)THEN
            CALL GRAFTC(0,1)
            CALL GMFSW(1)
         ENDIF
      ENDIF
      END

      SUBROUTINE HELPC(ITYP,KEYW)
C
C ITYP=1
C Reakce na nerozpoznany prikaz zacinajici textem KEYW (promenne delky).
C Rozlisuje se bud prirazovaci prikaz (=) nebo se porovnava text KEYW s
C radky v souboru $COMMAND.TXT. Podobne prikazy s komentarem (zajistuje
C procedura WRITECOM a COMHELP) se vypisuji do okna cislo 40.
C ITYP=2
C Vypis souboru FEMINA.TXT radkem, ktery obsahuje text 'KEYW pocinaje.
C Ceka se na potvrzeni Enter z okna 10 (CONSOLE).
C ITYP=3
C Vypis souboru FEMINA.TXT radke, ktery obsahuje KEYW (bez apostrofu)
C pocinaje. Jinak identicke s variantou ITYP=2
C ITYP=4,5,6 (CERVENA,BILA,ZELENA)
C Vypis urgentni zpravy KEYW v grafickem modu okna 40.
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      TYPE(RCCOORD)POS
      TYPE(XYCOORD)XPOS
      CHARACTER*(*) KEYW
      CHARACTER*100 LINE,LINESUB
      CHARACTER*40 KEYC,TXTV*17,KEY*1
      INTEGER IREAD(300),C1,C2
      LOGICAL FIRST,FIRSTA
	INCLUDE '$WIN'
	INCLUDE '$NAVIG'
      II=FOCUSQQ(40)
      II=SETBKCOLOR(0)
      CALL CLEARSCREEN($GCLEARSCREEN)
      SELECT CASE(ITYP)
      CASE(1)
C
C Testovani prirazovaciho prikazu provadime jen v pripade, ze KEYW obsahuje rovnitko
C
      NAVIG=.FALSE.
      IEQ=INDEX(KEYW,'=')
      IF(IEQ.GT.1)THEN
         C2=SETTEXTCOLOR(INT2(11))
         WRITE(40,'(5x,A,''-unknown. Probably Assignment with a syntax  
     /error'')')TRIM(KEYW)
         C1=SETTEXTCOLOR(C2)
         IZAV=INDEX(KEYW,'(')
         IF(IZAV.GT.1)THEN
            LK=MIN0(3,IZAV-1)
         ELSE
            LK=MIN0(3,IEQ-1)
         ENDIF
         CALL TUPC(LK,KEYW,KEYW)
         DO I=1,250
            CALL VARHELP(I,TXTV,LOC)
            IND=INDEX(TXTV,KEYW(1:LK))
            IF(IND.GT.0)WRITE(40,'('' Variable '',A)')TXTV
         ENDDO
      ELSE
C
C Operace
C
         OPEN(2,FILE='.\FILES\$COMMAND.TXT',STATUS='OLD',ERR=888)
C Soubor $COMMAND.TXT je seznam klicovych slov s carkou pred (i v 1.sloupci).
C Testujeme jen pripady, kdy klicove slovo jsou alespon 2 znaky.
C
C Prvni faze hledani: zamena jedineho znaku, eventualne jeden nadbytecny
C znak (pokud je delka klicoveho slova 4,5,6), nebo naopak jeden chybejici
C znak. IC je pocitadlo vybranych nabidek, vektor IREAD() indikator jiz
C vybrane nabidky LMIN je delka testovaneho klicoveho slova.
         FIRST=.TRUE.
         FIRSTA=.TRUE.
         IC=0
         IREAD=0
         LMIN=4
         DO WHILE(LMIN.GE.3.AND.IC.LE.2)
           REWIND (2,ERR=999)
           LMIN=LMIN-1
           KEYC=','//KEYW
           LK=MIN0(7,LEN(TRIM(KEYC)))
           I=0
           IF(LK.GE.4)THEN
1             READ(2,'(A)',END=100)LINE
              I=MIN0(300,I+1)
C Priklad LINE:  ,ND,NODE,UZEL
C         KEYC:  ,NOD
C Procedura INDEXI kontroluje, zda se v textu LINE vyskytuje retezec KEYC(1:LK)
C s eventualni zamenou znaku na pozici 2,...,LK. 
C Parametr LMIN slouzi jen k tomu, aby byl aktivovan test chybejiciho nebo 
C naopak prebyvajiciho znaku: Kdyz je LK>LMIN+1 testuje se nadbytecny znak,
C a kdyz je LK>LMIN testuje se i chybejici znak.
              CALL INDEXI(LINE,KEYC,LMIN,2,LK,LOC)
              IF(LOC.GT.0.AND.IREAD(I).EQ.0)THEN
                IC=IC+1
                IF(FIRST)THEN
                  C2=SETTEXTCOLOR(INT2(11))
                  WRITE(40,'(5X,A,''-unknown. Try similar commands:'')')
     /                 KEYW
                  C1=SETTEXTCOLOR(C2)
                  FIRST=.FALSE.
                ENDIF
                CALL WRITECOM(TRIM(LINE))
                IREAD(I)=1
              ENDIF
              GOTO 1
           ENDIF
C Druha faze: prohledavani s postupne zkracovanym klicovym slovem od zacatku
C Alespon prvni dva znaky musi byt shodne
100        REWIND (2,ERR=999)
           LK=MIN0(6,LK)
           DO WHILE(IC.LE.20.AND.LK.GE.LMIN)
             I=0
2            READ(2,'(A)',END=200)LINE
             I=MIN0(300,I+1)
             LOC=INDEX(LINE,KEYC(1:LK))
             IF(LOC.GT.0.AND.IREAD(I).EQ.0)THEN
                IC=IC+1
                IF(FIRST)THEN
                  C2=SETTEXTCOLOR(INT2(11))
                  WRITE(40,'(5X,A,''-unknown. Try similar commands:'')')
     /                 KEYW
                  C1=SETTEXTCOLOR(C2)
                  FIRST=.FALSE.
                ENDIF
                CALL WRITECOM(TRIM(LINE))
                IREAD(I)=1
             ENDIF
             GOTO 2
200          REWIND (2,ERR=999)
             LK=LK-1
           ENDDO
C Treti faze: prohledavani se zkracovanim klicoveho slova, ne od zacatku
           IF(LEN(TRIM(KEYW)).GE.2.AND.IC.LE.23)THEN
             LK=MIN0(6,LEN(TRIM(KEYW)))
             DO WHILE(IC.LE.30.AND.LK.GE.LMIN)
               I=0
3              READ(2,'(A)',END=300)LINE
               I=MIN0(300,I+1)
               LOC=INDEX(LINE,KEYW(1:LK))
               IF(LOC.GT.0.AND.IREAD(I).EQ.0)THEN
                 IC=IC+1
                 IF(FIRSTA)THEN
                   C2=SETTEXTCOLOR(INT2(11))
                   WRITE(40,'(5X,''Trying not very probable alternatives
     / of ['',A,''] but who knows...'')')KEYW
                   C1=SETTEXTCOLOR(C2)
                   FIRSTA=.FALSE.
                 ENDIF
                 CALL WRITECOM(TRIM(LINE))
                 IREAD(I)=1
               ENDIF
               GOTO 3
300            REWIND (2,ERR=999)
               LK=LK-1
             ENDDO
           ENDIF
         ENDDO
         CLOSE(2)
         IF(IC.EQ.0)WRITE(40,'(5X,''Sorry, nothing similar has been foun
     /d'')')
      ENDIF
      CASE(2,3)
         OPEN(2,FILE='.\FILES\$FEMINA.TXT',STATUS='OLD',ERR=999)
         REWIND (2,ERR=999)
         IF(ITYP.EQ.2)THEN
            KEYC=''''//TRIM(KEYW)
         ELSE
            KEYC=TRIM(KEYW)
         ENDIF
         LK=LEN(TRIM(KEYC))
         IF(LK.LE.0)GOTO 501
         CALL TUPC(LK,KEYC,KEYC)
         unita =39
         CALL WOPENH(unita,'SEARCH keyword in source program',
     / ixpos(unita),iypos(unita),
     / ixpix(unita),iypix(unita),nrow(unita),ncol(unita),
     / ifontph(unita),ihfontph(unita),icursor(unita),
     / fontphattr(unita),
     / icfR(unita),icfG(unita),icfB(unita),
     / icbR(unita),icbG(unita),icbB(unita),ioldwopen)       
	   II=SETBKCOLOR(0)
         CALL CLEARSCREEN($GCLEARSCREEN)
         IC=0
         ICLOC=0
         ICLIM=50000
         FIRST=.FALSE.
         DO WHILE(IC.LE.50000)
           READ(2,'(A)',END=501,ERR=501)LINE
           IC=IC+1
           ICLOC=ICLOC+1
           LOC=INDEX(LINE,KEYC(1:LK))
           IF(LOC.GT.0.AND.ICLIM.GT.IC+55)THEN
              ICLIM=IC+55
              FIRST=.TRUE.
              II=FOCUSQQ(39)
              CALL CLEARSCREEN($GCLEARSCREEN)
              CALL SETTEXTPOSITION(INT2(1),INT2(1),POS)
              II=SETBKCOLOR(1)
              WRITE(39,'('' Word '',A,'' has been found in the source fi
     /le: '',A)')KEYC,LINESUB(7:18)
              II=SETBKCOLOR(0)
           ENDIF
           IF(FIRST)WRITE(39,'(I8,'':'',A)')ICLOC,TRIM(LINE)
           IF(IC.GE.ICLIM)THEN
              II=SETTEXTCOLOR(11)
              WRITE(39,'('' Press any key to continue or Esc...'')')
              II=SETTEXTCOLOR(15)
              CALL GC(KEY,IKEY)
C              CALL GC(KEY,IKEY)
              IF(IKEY.EQ.227)GOTO501
              ICLIM=50000
              FIRST=.FALSE.
           ENDIF
           IF(LINE(2:6).EQ.'FILE:')THEN
              LINESUB=LINE
              ICLOC=0
           ENDIF
         ENDDO
501      IF(ITYP.EQ.2)THEN
           WRITE(39,'('' END-HELP. Press any key to continue... (HINT: s
     /imilar command is SEARCH text)'')')
         ELSE
           WRITE(39,'('' END-SEARCH. Press any key to continue...'')')
         ENDIF
         II=FOCUSQQ(10)
         CALL GCU(KEY,IKEY)
         CLOSE(2)        
         RETURN         
      CASE(4,5,6)
C ERROR grafika
         SELECT CASE(ITYP)
           CASE(4)
C ZELENA
              C1=SETCOLORRGB(#0000FF00)
           CASE(5)
C BILA
              C1=SETCOLORRGB(#00FFFFFF)
           CASE(6)
C CERVENA
              C1=SETCOLORRGB(#000000FF)
         END SELECT
         LENMES=LEN(TRIM(KEYW))
         NUMFONTS=INITIALIZEFONTS()
         IF(LENMES.LE.20)THEN
            FONT=SETFONT('t''Arial''h48e')
            CALL MOVETO(INT2(5),INT2(20),XPOS)
            CALL OUTGTEXT(TRIM(KEYW))
         ELSEIF(LENMES.LE.55)THEN
            FONT=SETFONT('t''Arial''h36e')
            ISPAC=INDEX(KEYW(20:LENMES),' ')
            CALL MOVETO(INT2(5),INT2(8),XPOS)
            IF(ISPAC.EQ.0)THEN
               CALL OUTGTEXT(KEYW(1:LENMES))
            ELSE
               CALL OUTGTEXT(KEYW(1:19+ISPAC))
               CALL MOVETO(INT2(5),INT2(40),XPOS)
               CALL OUTGTEXT(KEYW(20+ISPAC:LENMES))
            ENDIF
         ELSEIF(LENMES.LE.100)THEN
            FONT=SETFONT('t''Arial''h24e')
            ISPAC1=INDEX(KEYW(30:LENMES),' ')
            ISPAC2=INDEX(KEYW(60:LENMES),' ')
            CALL MOVETO(INT2(5),INT2(8),XPOS)
            CALL OUTGTEXT(KEYW(1:29+ISPAC1))
            CALL MOVETO(INT2(5),INT2(33),XPOS)
	      IF(ISPAC2.EQ.0)THEN
               CALL OUTGTEXT(KEYW(30+ISPAC1:LENMES))
	      ELSE
               CALL OUTGTEXT(KEYW(30+ISPAC1:59+ISPAC2))
               CALL MOVETO(INT2(5),INT2(58),XPOS)
               CALL OUTGTEXT(KEYW(60+ISPAC2:LENMES))
	      ENDIF
	   ELSEIF(LENMES.LE.130)THEN
            FONT=SETFONT('t''Arial''h24e')
            ISPAC1=INDEX(KEYW(30:LENMES),' ')
            ISPAC2=INDEX(KEYW(60:LENMES),' ')
	      ISPAC3=INDEX(KEYW(90:LENMES),' ')
            CALL MOVETO(INT2(5),INT2(8),XPOS)
            CALL OUTGTEXT(KEYW(1:29+ISPAC1))
            CALL MOVETO(INT2(5),INT2(33),XPOS)
            CALL OUTGTEXT(KEYW(30+ISPAC1:59+ISPAC2))
            CALL MOVETO(INT2(5),INT2(58),XPOS)
	      IF(ISPAC3.LE.0)THEN
               CALL OUTGTEXT(KEYW(60+ISPAC2:LENMES))
	      ELSE
               CALL OUTGTEXT(KEYW(60+ISPAC2:89+ISPAC3))
               CALL MOVETO(INT2(5),INT2(83),XPOS)
               CALL OUTGTEXT(KEYW(90+ISPAC3:LENMES))
	      ENDIF
         ELSE
            FONT=SETFONT('t''Arial''h24e')
            ISPAC1=INDEX(KEYW(35:LENMES),' ')
            ISPAC2=INDEX(KEYW(70:LENMES),' ')
	      ISPAC3=INDEX(KEYW(105:LENMES),' ')
	      ISPAC4=INDEX(KEYW(140:LENMES),' ')
            CALL MOVETO(INT2(5),INT2(8),XPOS)
            CALL OUTGTEXT(KEYW(1:34+ISPAC1))
            CALL MOVETO(INT2(5),INT2(33),XPOS)
            CALL OUTGTEXT(KEYW(35+ISPAC1:69+ISPAC2))
            CALL MOVETO(INT2(5),INT2(58),XPOS)
            CALL OUTGTEXT(KEYW(70+ISPAC2:104+ISPAC3))
            CALL MOVETO(INT2(5),INT2(83),XPOS)
	      IF(ISPAC4.LE.0)THEN
               CALL OUTGTEXT(KEYW(105+ISPAC3:LENMES))
	      ELSE
               CALL OUTGTEXT(KEYW(105+ISPAC3:139+ISPAC4))
               CALL MOVETO(INT2(5),INT2(108),XPOS)
               CALL OUTGTEXT(KEYW(140+ISPAC4:LENMES))
	      ENDIF

         ENDIF
         C2=SETCOLORRGB(C1)
      END SELECT
      RETURN
888   WRITE(10,*)'No help, because the file \FILES\$COMMAND.TXT is not i
     /nstalled'
      RETURN
999   WRITE(10,*)'No help, because the file \FILES\$FEMINA.TXT is not in
     /stalled'
      END

      SUBROUTINE INDEXI(TEXT,KEYW,LMIN,L1,L2,LOC)
C 
C Pomocna procedura pro HELPC - zjisteni jedineho odlisneho znaku
C Priklad TEXT   ,CONVOL,CON
C Priklad KEYW   ,ONVOL - to, co zadal uzivatel (doplneno carkou zleva)
      PARAMETER (NCH=32)
      CHARACTER*(*) TEXT,KEYW
      CHARACTER*1 A(NCH)
      CHARACTER*7 KEYC
      DATA A/'A','B','C','D','E','F','G','H','I','J','K','L','M','N',
     /       'O','P','Q','R','S','T','U','V','W','X','Y','Z',
     /       '2','3','4','6','8','#'/
C Test zameny znaku na pozici L1,...,L2
      DO L=L1,L2
         KEYC=KEYW
         DO I=1,NCH
           KEYC(L:L)=A(I)
           LOC=INDEX(TEXT,KEYC(1:L2))
           IF(LOC.GT.0)RETURN
         ENDDO
      ENDDO
C Test nadbytecneho znaku L na pozici L1,...,L2
      IF(L2.GT.LMIN+1)THEN
        DO L=L1,L2-1
          IF(L.LT.L2-1)THEN
             KEYC=KEYW(1:L-1)//KEYW(L+1:L2)
          ELSE
             KEYC=KEYW(1:L)
          ENDIF
          LOC=INDEX(TEXT,KEYC(1:L2-1))
          IF(LOC.GT.0)RETURN
        ENDDO
      ENDIF
C Test chybejiciho znaku (S VYJIMKOU KONCOVEHO)
      IF(L2.GT.LMIN.AND.L2.LT.7)THEN
        DO L=L1,L2
          DO I=1,NCH
             KEYC(1:L2+1)=KEYW(1:L-1)//A(I)//KEYW(L:L2)
             LOC=INDEX(TEXT,KEYC(1:L2+1))
             IF(LOC.GT.0)RETURN
          ENDDO
        ENDDO
      ENDIF
      END

      SUBROUTINE WRITECOM(TXKEYW)
C
C Doplneni komentare ke klicovemu slovu TXKEYW a zobrazeni v okne cislo 40 (HELP)
C
      CHARACTER*(*) TXKEYW
      CHARACTER*35 TXCOM
      CALL COMHELP(TXKEYW,TXCOM,IEND)
      IF(IEND.EQ.0)THEN
        WRITE(40,'(1X,A)')TXKEYW
      ELSE
        WRITE(40,'(1X,A,'' :  '',A)')TXKEYW,TXCOM
      ENDIF
      END

      SUBROUTINE INFO21(MAXTROWS)
C
C Zobrazeni informaci o uzlovych parametrech a parametrech elementu
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEMB'
      TYPE(RCCOORD)CURPOS
      II=FOCUSQQ(21)
      II=SETACTIVEQQ(21)
      II=SETBKCOLOR(3)
      CALL CLEARSCREEN($GCLEARSCREEN)
      II=WRAPON($GWRAPOFF)
      II=SETTEXTCOLOR(int2(11))
      CALL SETTEXTPOSITION(INT2(1),INT2(2),CURPOS)
	IF(ISTATUS.EQ.1)THEN
      WRITE(21,'('' Max. Elem='',i8,'' Nodes='',i8,'' PTs='',i3)')
     /MAXEL,MAXND,MAXPT
      CALL SETTEXTPOSITION(INT2(2),INT2(2),CURPOS)
      SELECT CASE(KANAL)
      CASE(1)
        WRITE(21,'('' PIPE: Structure of DOF (1D, pipelines)'')')
        NAM=$PIPE2D
      CASE(2)
        WRITE(21,'('' UVP: Structure of DOF (2D, primitive variabs)'')')
        NAM=$PLANE2D
      CASE(3)
        WRITE(21,'('' PSI: Structure of DOF (2D, stream funct.)'')')
        NAM=$FLOW2D
      CASE(4)
        WRITE(21,'('' FLUENT: only one DOF (CN-concentration)'')')
        NAM=$SOLID
      ENDSELECT
      II=SETTEXTCOLOR(int2(15))
      DO I=1,MDOF
         I1=I-1
         CALL SETTEXTPOSITION(INT2(3+I1/5),INT2(MOD(I1,5)*9+1),CURPOS)
C         WRITE(21,'(I3,''-'',A)')I,TDOF(JPU(I))
         WRITE(21,'(A)')TDOF(JPU(I))
      ENDDO
      CALL SETTEXTPOSITION(INT2(7),INT2(2),CURPOS)
      II=SETTEXTCOLOR(int2(11))
      WRITE(21,'('' Element '',A,'' parameters:'')')TELEM(NAM)
      II=SETTEXTCOLOR(int2(15))
      DO I=1,MIN0(24,NEPAR(NAM))
         I1=I-1
         CALL SETTEXTPOSITION(INT2(8+I1/4),INT2(MOD(I1,4)*12+1),CURPOS)
C         WRITE(21,'(i3,''-'',A)')I,TEPAR(JEPAR(NAM,I))
         WRITE(21,'(A)')TEPAR(JEPAR(NAM,I))
      ENDDO
	MELIN=12
	ELSE
	WRITE(21,'('' Maximum rows of MOP (observation points)='',I5)')
     /MAXNTS
	MELIN=3
	ENDIF
      IF(MAXTROWS.GE.MELIN+3)THEN
        CALL SETTEXTPOSITION(INT2(MELIN),INT2(2),CURPOS)
        II=SETTEXTCOLOR(int2(11))
        WRITE(21,'(I5,'' RTD interpreted models available:'')')NMODELS
        II=SETTEXTCOLOR(int2(15))
C        DO I=1,MIN0(28,NMODELS)
        DO I=1,MIN0((MAXTROWS-MELIN+2)*8,NMODELS)
            I1=I-1
           CALL SETTEXTPOSITION(INT2(MELIN+1+I1/8),INT2(MOD(I1,8)*8+1),
     /                          CURPOS)
           CALL OUTTEXT(MODKWD(I))
        ENDDO
      ENDIF
      END

      SUBROUTINE INFO21C
C
C Vymazani okna 21
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      II=FOCUSQQ(21)
      II=SETACTIVEQQ(21)
      II=SETBKCOLOR(3)
      CALL CLEARSCREEN($GCLEARSCREEN)
      II=WRAPON($GWRAPOFF)
      II=SETTEXTCOLOR(int2(11))
      WRITE(21,1)
1     FORMAT(/)
      END

      SUBROUTINE FILEXIST(FILENAME,EXIST)
C
C Zjisteni zda soubor FILENAME existuje (EXIST=true)
C 
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      LOGICAL EXIST
      CHARACTER*(*) FILENAME
      TYPE(FILE$INFO) INFO
      IHANDLE=FILE$FIRST
      LEN=GETFILEINFOQQ(FILENAME,INFO,IHANDLE)
      IF(LEN.GT.0)THEN
         EXIST=.TRUE.
      ELSE
         EXIST=.FALSE.
      ENDIF
      END

      SUBROUTINE READWIN(IUNIT)
C
C Cteni dat ze souboru $FEMWIN.CFG
C
      LOGICAL WESULT
	CHARACTER*200 LINE
	INCLUDE '$WIN'
      CLOSE(IUNIT)
      IOLDWOPEN=1
      INQUIRE(FILE='$FEMWIN.CFG',EXIST=WESULT)
      IF(WESULT)THEN
         OPEN(IUNIT,FILE='$FEMWIN.CFG')
         WRITE(*,*)' Setup file $FEMWIN.CFG from the current directory'
      ELSE       
         INQUIRE(FILE='.\FILES\$FEMWIN.CFG',EXIST=WESULT)
         IF(WESULT)THEN
           OPEN(IUNIT,FILE='.\FILES\$FEMWIN.CFG')
           WRITE(*,*)' Setup file $FEMWIN.CFG from the directory FILES'
         ELSE
           WRITE(*,*)' Unable to find setup file $FEMWIN.CFG. Default se
     /ttings are used.'
           GOTO 2010
         ENDIF
      ENDIF
      
C Open $FEMWIN.CFG file     
      
2005  READ(IUNIT,'(A)',END=2010)LINE
      CALL TUPC(LENLIN,LINE,LINE)
      IF(LINE(1:1).NE.'#')THEN
       IF(LINE(1:10).EQ.'\\WINCOUNT')THEN
        READ(IUNIT,*,ERR=2010)NWINS,ioldwopen
        DO I=1,NWINS
         READ(IUNIT,'(I3,A120)',ERR=2010)UNITA,LABELA(UNITA)
         READ(IUNIT,*,ERR=2010)ixpos(unita),iypos(unita),ixpix(unita),
     /    iypix(unita),nrow(unita),ncol(unita)
         READ(IUNIT,*,ERR=2010)ifontph(unita),ihfontph(unita),
     /    icursor(unita)
         READ(IUNIT,'(A)',ERR=2010)fontphattr(unita)
         READ(IUNIT,*,ERR=2010)icfR(unita),icfG(unita),icfB(unita)
         READ(IUNIT,*,ERR=2010)icbR(unita),icbG(unita),icbB(unita)
        ENDDO
       ENDIF
      ENDIF
      GOTO 2005
2010  CLOSE(IUNIT)
      END

C      INCLUDE '$S0A-HEL.FOR'
