C $S10-AUX
      SUBROUTINE PMERGE(TOL)
C
C Merge points
C
      INCLUDE '$FEM'
      I=1
      DO WHILE (I.LT.NPT)
        J=I+1
        DO WHILE (J.LE.NPT)
           IF(ABS(PTX(I)-PTX(J)).LT.TOL.AND.
     /        ABS(PTY(I)-PTY(J)).LT.TOL.AND.
     /        ABS(PTZ(I)-PTZ(J)).LT.TOL)THEN
C
C nahrad uzel J uzlem I a sniz vsechny indexy J,J+1,... o jednicku
              NPT=NPT-1
              DO K=J,NPT
                PTX(K)=PTX(K+1)
                PTY(K)=PTY(K+1)
                PTZ(K)=PTZ(K+1)
                NEARND(K)=NEARND(K+1)
              ENDDO
              DO K=1,NCR
                 DO L=1,MCR(K)
                    ICRLK=ICR(L,K)
                    IF(ICRLK.EQ.J)THEN
                       ICR(L,K)=I
                    ELSEIF(ICRLK.GT.J)THEN
                       ICR(L,K)=ICRLK-1
                    ENDIF
                 ENDDO
              ENDDO
              DO K=1,NSF
                 DO L=1,MSF(K)
                    ISFLK=ISF(L,K)
                    IF(ISFLK.EQ.J)THEN
                       ISF(L,K)=I
                    ELSEIF(ISFLK.GT.J)THEN
                       ISF(L,K)=ISFLK-1
                    ENDIF
                 ENDDO
              ENDDO
              DO K=1,NVL
                 DO L=1,MVL(K)
                    IVLLK=IVL(L,K)
                    IF(IVLLK.EQ.J)THEN
                       IVL(L,K)=I
                    ELSEIF(IVLLK.GT.J)THEN
                       IVL(L,K)=IVLLK-1
                    ENDIF
                 ENDDO
              ENDDO
              J=J-1
           ENDIF
           J=J+1
        END DO
        I=I+1
      ENDDO
      CALL CRCOMP
      CALL SFCOMP
      END

      SUBROUTINE NCOMPRES
C
C Vyrazeni uzlu, ktere se nevyskytuji v matici konektivity
C
      INCLUDE '$FEM'
      IU=0
      NDLOOP:DO WHILE(IU.LT.ND)
         IU=IU+1
C Hledej vyskyt uzlu v matici konektivity
         DO IE=1,NE
            LOC=LUE(IE)
            MU=IABS(MUE(IE))
            DO J=1,MU
              IN=IABS(IUE(LOC+J))
              IF(IU.EQ.IN)CYCLE NDLOOP
            ENDDO
         ENDDO
C Uzel nenalezen - ZRUSIT
         CALL NDDEL(IU)
         IU=IU-1
      ENDDO NDLOOP
      END
 
      SUBROUTINE NDDEL(IND)
C
C Zruseni uzlu cislo IND
C
C 1) zkraceni vektoru (presun o 1 vlevo) LPU(),XX(),YY(),ZZ()
C 2) v matici konektivity zmensit o jednicku vsechny indexy >IND (uzel IND by
C    v matici konektivity vubec nemel byt,mela by predchazet procedura MERGE).
C    Pokud se IND v matici konektivity vyskytne, musi byt odpovidajici element
C    take vyrazen.
C
      INCLUDE '$FEM'
      IF(IND.GT.0.AND.IND.LE.ND)THEN
         ND=ND-1
         DO I=IND,ND
            XX(I)=XX(I+1)
            YY(I)=YY(I+1)
            ZZ(I)=ZZ(I+1)
         ENDDO
C Uprava matice konektivity
         IE=0
         DO WHILE(IE.LT.NE)
            IE=IE+1
            LOC=LUE(IE)
            MU=IABS(MUE(IE))
            DO J=1,MU
              IU=IABS(IUE(LOC+J))
              IF(IU.GT.IND)THEN
                 IUE(LOC+J)=IU-1
              ELSEIF(IU.EQ.IND)THEN
                 CALL EDEL(IE)
                 IE=IE-1
                 EXIT
              ENDIF
            ENDDO
         ENDDO
      ENDIF
      END

      SUBROUTINE EDEL(IEL)
C
C Zruseni elementu IEL cislo ND
C
C Zkraceni vektoru (presun o 1 vlevo) LUE(),MUE()
C Soucasne presouvame vektory 
C
      INCLUDE '$FEM'
      IF(IEL.GT.0.AND.IEL.LE.NE)THEN
         NE=NE-1
         DO I=IEL,NE
            LUE(I)=LUE(I+1)
            MUE(I)=MUE(I+1)
            IGROUP(I)=IGROUP(I+1)
            IRCONS(I)=IRCONS(I+1)
            IMPROP(I)=IMPROP(I+1)
            DO J=1,MAXEPAR
              EPAR(I,J)=EPAR(I+1,J)
            ENDDO
         ENDDO
         LUE(NE+1)=LUE(NE+2)
      ENDIF
      END

      SUBROUTINE NIDENT(JMI,KBD)
C
C IDENTIFIKACE UZLU LOKATOREM
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEM'
	CHARACTER*100 LINE
      II=SETACTIVEQQ(20)
      II=FOCUSQQ(20)
C operace GMFCOM je nejasna, ale bez ni to nefunguje
C     CALL GMFCOM(1)
      CALL GMFLCC(PX,PY,KBD)
	IF((MOUSE$KS_SHIFT.AND.KBD).EQ.MOUSE$KS_SHIFT)THEN
C Zadej z klavesnice
	   WRITE(10,'('' Specify INDEX of node from keyboard'')')
	   CALL GMFEDLC(10,LINE,IEND)
	   READ(LINE,*,IOSTAT=IRET)JMI
	   WRITE(10,'('' Continue by mouse (R-click ends, Ctrl+L-click hid
     /den node)'')')
         II=SETACTIVEQQ(20)
         II=FOCUSQQ(20)
	   KBD=1
	ELSEIF((MOUSE$KS_CONTROL.AND.KBD).EQ.MOUSE$KS_CONTROL)THEN
C Vyber nejblizsi s vyjimkou JMI
         DISMIN=1E10
	   JMI0=JMI
         JMI=1
         DO J=1,ND
	     IF(J.NE.JMI0)THEN
             CALL ROT(XX(J),YY(J),ZZ(J),XXJ,YYJ,DUMMY)
             DIST=(XXJ-PX)**2+(YYJ-PY)**2
             IF(DIST.LT.DISMIN)THEN
               DISMIN=DIST
               JMI=J
               XXJMI=XXJ
               YYJMI=YYJ
             ENDIF
	     ENDIF
         ENDDO
	   KBD=1
      ELSE
         DISMIN=1E10
         JMI=1
         DO J=1,ND
           CALL ROT(XX(J),YY(J),ZZ(J),XXJ,YYJ,DUMMY)
           DIST=(XXJ-PX)**2+(YYJ-PY)**2
           IF(DIST.LT.DISMIN)THEN
              DISMIN=DIST
              JMI=J
              XXJMI=XXJ
              YYJMI=YYJ
           ENDIF
         ENDDO
	ENDIF
      CALL GMFMRKL(XXJMI,YYJMI,20,JMI,1)
      END

      SUBROUTINE PIDENT(JMI,KBD)
C
C IDENTIFIKACE PT LOKATOREM
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEM'
	CHARACTER*100 LINE
      II=SETACTIVEQQ(20)
      II=FOCUSQQ(20)
C operace GMFCOM je nejasna, ale bez ni to nefunguje
C     CALL GMFCOM(1)
      CALL GMFLCC(PX,PY,KBD)
	IF((MOUSE$KS_SHIFT.AND.KBD).EQ.MOUSE$KS_SHIFT)THEN
C Zadej z klavesnice
	   WRITE(10,'('' Specify INDEX of POINT from keyboard'')')
	   CALL GMFEDLC(10,LINE,IEND)
	   READ(LINE,*,IOSTAT=IRET)JMI
	   WRITE(10,'('' Continue by mouse (R-click ends, Ctrl+L-click hid
     /den point)'')')
         II=SETACTIVEQQ(20)
         II=FOCUSQQ(20)
	   KBD=1
	ELSEIF((MOUSE$KS_CONTROL.AND.KBD).EQ.MOUSE$KS_CONTROL)THEN
C Vyber nejblizsi s vyjimkou JMI
         DISMIN=1E10
	   JMI0=JMI
         JMI=1
         DO J=1,NPT
	     IF(J.NE.JMI0)THEN
           CALL ROT(PTX(J),PTY(J),PTZ(J),PTXJ,PTYJ,DUMMY)
           DIST=(PTXJ-PX)**2+(PTYJ-PY)**2
           IF(DIST.LT.DISMIN)THEN
             DISMIN=DIST
             JMI=J
             PTXJMI=PTXJ
             PTYJMI=PTYJ
           ENDIF
	     ENDIF
         ENDDO
	   KBD=1
	ELSE
         DISMIN=1E10
         JMI=1
         DO J=1,NPT
           CALL ROT(PTX(J),PTY(J),PTZ(J),PTXJ,PTYJ,DUMMY)
           DIST=(PTXJ-PX)**2+(PTYJ-PY)**2
           IF(DIST.LT.DISMIN)THEN
             DISMIN=DIST
             JMI=J
             PTXJMI=PTXJ
             PTYJMI=PTYJ
          ENDIF
        ENDDO
	ENDIF
      CALL GMFMRK(PTXJMI,PTYJMI,37)
      END

      SUBROUTINE EIDENT(JMI,KBD)
C
C IDENTIFIKACE EL LOKATOREM
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEM'
      II=SETACTIVEQQ(20)
      II=FOCUSQQ(20)
      CALL GMFLCC(PX,PY,KBD)
      DISMIN=1E10
      XTE=0
      YTE=0
      JMI=1
      DO J=1,NE
C teziste elementu J
         CALL GRAVEL(J,XTC,YTC,ZTC)
         CALL ROT(XTC,YTC,ZTC,XT,YT,DUMMY)
         DIST=(XT-PX)**2+(YT-PY)**2
         IF(DIST.LT.DISMIN)THEN
            DISMIN=DIST
            XTE=XT
            YTE=YT
            JMI=J
         ENDIF
      ENDDO
      CALL GMFMRKL(XTE,YTE,20,JMI,1)
      END

      SUBROUTINE GRAVEL(IE,XTC,YTC,ZTC)
C Vypocet teziste elementu IE
      INCLUDE '$FEM'
      XT=0
      YT=0
      ZT=0
      L0=LUE(IE)
      NUE=MAX0(IABS(MUE(IE)),1)
      DO I=1,NUE
         IND=MAX0(IABS(IUE(L0+I)),1)
         XT=XT+XX(IND)
         YT=YT+YY(IND)
         ZT=ZT+ZZ(IND)
      ENDDO
      XTC=XT/NUE
      YTC=YT/NUE
      ZTC=ZT/NUE
      END

      SUBROUTINE CIDENT(JMI,KBD)
C
C IDENTIFIKACE CR LOKATOREM
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEM'
      DIMENSION X(3),Y(3),Z(3)
	CHARACTER*100 LINE
      II=SETACTIVEQQ(20)
      II=FOCUSQQ(20)
      CALL GMFLCC(PX,PY,KBD)
	IF((MOUSE$KS_SHIFT.AND.KBD).EQ.MOUSE$KS_SHIFT)THEN
C Zadej z klavesnice
	   WRITE(10,'('' Specify INDEX of curve from keyboard'')')
	   CALL GMFEDLC(10,LINE,IEND)
	   READ(LINE,*,IOSTAT=IRET)JMI
	   WRITE(10,'('' Continue by mouse (R-click ends, Ctrl+L-click hid
     /den curve)'')')
         II=SETACTIVEQQ(20)
         II=FOCUSQQ(20)
	   KBD=1
	ELSEIF((MOUSE$KS_CONTROL.AND.KBD).EQ.MOUSE$KS_CONTROL)THEN
C Vyber nejblizsi s vyjimkou JMI
         DISMIN=1E10
	   JMI0=JMI
         JMI=1
         DO J=1,NCR
	     IF(J.NE.JMI0)THEN
             DO I=1,MCR(J)
               IND=ICR(I,J)
               CALL ROT(PTX(IND),PTY(IND),PTZ(IND),X(I),Y(I),DUMMY)
               Z(I)=0.
             ENDDO
             CALL PTCRDIST(X,Y,Z,MCR(J),PX,PY,0.,DIST)
             IF(DIST.LT.DISMIN)THEN
               DISMIN=DIST
               JMI=J
             ENDIF
	     ENDIF
         ENDDO
	   KBD=1
  	ELSE    
         DISMIN=1E10
         JMI=1
         DO J=1,NCR
             DO I=1,MCR(J)
               IND=ICR(I,J)
               CALL ROT(PTX(IND),PTY(IND),PTZ(IND),X(I),Y(I),DUMMY)
               Z(I)=0.
             ENDDO
             CALL PTCRDIST(X,Y,Z,MCR(J),PX,PY,0.,DIST)
             IF(DIST.LT.DISMIN)THEN
               DISMIN=DIST
               JMI=J
             ENDIF
         ENDDO
	ENDIF
      CALL PLOTCR(JMI,11,1)
      END

      SUBROUTINE TIDENT(IMI,JMI,KBD)
C
C IDENTIFIKACE TC krivky LOKATOREM
C IMI -index bodu krivky JMI
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEM'
      INCLUDE '$PLT-COM'
      II=SETACTIVEQQ(20)
      II=FOCUSQQ(20)
C operace GMFCOM je nejasna, ale bez ni to nefunguje
c     CALL GMFCOM(1)
      CALL GMFLCC(PX,PY,KBD)
      DISMIN=1E10
      JMI=2
      IMI=1
C Normalizace vzdalenosti X a Y
      CALL GRAGET(2,XXMI,XXMA,YYMI,YYMA)
      DDX=AMAX1(XXMA-XXMI,1E-5)
      DDY=AMAX1(YYMA-YYMI,1E-5)
      DO J=2,MAXSEL
         IF(ITCPLOT(J).NE.0)THEN
         DO I=1,NGR
            DIST=((YGR(I,1)-PX)/DDX)**2+((YGR(I,J)-PY)/DDY)**2
            IF(DIST.LT.DISMIN)THEN
               DISMIN=DIST
               JMI=J
               IMI=I
            ENDIF
         ENDDO
         ENDIF
      ENDDO
      CALL GMFMRKL(YGR(IMI,1),YGR(IMI,JMI),20,JMI,1)
      END

      SUBROUTINE UIDENT(IMI,J,KBD)
C
C IDENTIFIKACE jednoho bodu TC krivky LOKATOREM
C J   - zadany index krivky (2,3,...,MAXSEL)
C IMI - index nejblizsiho bodu krivky JMI
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEM'
      II=SETACTIVEQQ(20)
      II=FOCUSQQ(20)
C operace GMFCOM je nejasna, ale bez ni to nefunguje
c     CALL GMFCOM(1)
      CALL GMFLCC(PX,PY,KBD)
C Uvazujeme bezrozmernou vzdalenost
      CALL GRAGET(2,XXMI,XXMA,YYMI,YYMA)
      DDX=AMAX1(XXMA-XXMI,1E-5)
      DDY=AMAX1(YYMA-YYMI,1E-5)
      DISMIN=1E10
      IMI=1
      DO I=1,NGR
         DIST=((YGR(I,1)-PX)/DDX)**2+((YGR(I,J)-PY)/DDY)**2
         IF(DIST.LT.DISMIN)THEN
            DISMIN=DIST
            IMI=I
         ENDIF
      ENDDO
      CALL GMFMRKL(YGR(IMI,1),YGR(IMI,J),20,IMI,1)
      END

      SUBROUTINE UEDIT(MODE,J)
C
C Editace TC bodu krivky cislo J (J=2,3,...,MAXSEL).
C MODE  0-3 editace na dvoji kliknuti (s potvrzovanim)
C       4-7 editace na jedno kliknuti (poloha lokatoru je soucasne pozici noveho bodu)
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEM'
	INCLUDE '$PLT-COM'
      II=SETACTIVEQQ(20)
      II=FOCUSQQ(20)
      IF(IST20.GT.2)CALL GMFSWC(1,2,XMI,XMA,YMI,YMA)
      DO I=1,NGR
        CALL GMFMRKS(YGR(I,1),YGR(I,J),50)
      ENDDO
      KBD=1
      DO WHILE(KBD.NE.2)
          IF(MODE.LE.3)THEN
             IF(MODE.EQ.0.OR.MODE.EQ.1.OR.MODE.EQ.4.OR.MODE.EQ.5)THEN
              WRITE(10,'('' Pick a point and L-click (R-click quit)'')')
             ELSE
              WRITE(10,'('' Pick a point having nearest time and L-click
     / (R-click quit)'')')
             ENDIF
          ELSE
             IF(MOD(MODE,2).EQ.0)THEN
             WRITE(10,'('' Shift a point to a new position (L-click conf
     /irms, R-click quit)'')')
             ELSE
             WRITE(10,'('' Change C-value of a selected point (L-click c
     /onfirms, R-click quit)'')')
             ENDIF
          ENDIF
          II=FOCUSQQ(20)
          CALL GMFLCC(PX,PY,KBD)
          IF(KBD.EQ.2)RETURN
          DISMIN=1E10
          IMI=1
          DO I=1,NGR
             IF(MODE.EQ.0.OR.MODE.EQ.1.OR.MODE.EQ.4.OR.MODE.EQ.5)THEN
                 DIST=(YGR(I,1)-PX)**2+(YGR(I,J)-PY)**2
             ELSE
                 DIST=ABS(YGR(I,1)-PX)
             ENDIF
             IF(DIST.LT.DISMIN)THEN
                DISMIN=DIST
                IMI=I
             ENDIF
          ENDDO
          CALL GMFMRK(YGR(IMI,1),YGR(IMI,J),37)
          IF(MODE.LE.3)THEN
             IF(MOD(MODE,2).EQ.0)THEN
                WRITE(10,'('' New TC position of selected point'',i5,'' 
     /(L-click confirm, R-click quit)'')')IMI
             ELSE
                WRITE(10,'('' New C value. Time '',e10.3,'' will not be 
     /changed. (L-click confirm, R-click quit)'')')YGR(IMI,1)
             ENDIF
             II=FOCUSQQ(20)
             CALL GMFLCC(PX,PY,KBD)
          ENDIF
          IF(KBD.EQ.1)THEN
             CALL GMFMRK(YGR(IMI,1),YGR(IMI,J),-37)
             YGR(IMI,J)=PY
             IF(MOD(MODE,2).EQ.0)YGR(IMI,1)=PX
             CALL GMFMRK(YGR(IMI,1),YGR(IMI,J),50)
          ENDIF
      ENDDO
      END

      SUBROUTINE FTMCR2(IC1,IC2,NX,
     /           IRC1,IRC2,IMAT1,IMAT2,IRHEXC,IGPIPE,IGHEX)
C
C ELEMENTY TYPU VYMENIK DEFINOVANE ZE DVOU KRIVEK IC1,IC2 
C (NX elementu na kazde krivce).
C GENERUJI SE SOUCASNE I ELEMENTY TYPU PIPE (RC skupiny IRC1,IRC2, 
C MPROP skupiny IMAT1,IMAT2, elementove skupiny IGPIPE,IGHEX)
C
      INCLUDE '$FEMB'
      DIMENSION I1(2),I2(2),IR(2),IM(2)
      IF(IRC1.LE.0.OR.IRC2.LE.0.OR.IMAT1.LE.0.OR.IMAT2.LE.0
     /    .OR.IGPIPE.LE.0.OR.IGHEX.LE.0)THEN
        WRITE(10,*)' Zero group number - quit element generation'
        RETURN
      ENDIF
C IR(K),IM(K) skupina RC resp MPROP krivky K
      IR(1)=IRC1
      IR(2)=IRC2
      IM(1)=IMAT1
      IM(2)=IMAT2
C I1(K)-PRVNI, I2(K)-DRUHY bod krivky K
      I1(1)=ICR(1,IC1)
      I2(1)=ICR(2,IC1)
      I1(2)=ICR(1,IC2)
      I2(2)=ICR(2,IC2)
C TEST SPRAVNE ORIENTACE BODU
      DX1=PTX(I2(1))-PTX(I1(1))
      DX2=PTX(I2(2))-PTX(I1(2))
      DY1=PTY(I2(1))-PTY(I1(1))
      DY2=PTY(I2(2))-PTY(I1(2))
      IF(DX1*DX2.LT.0..OR.DY1*DY2.LT.0.)THEN
C PREHOZENI INDEXU 1 A 2
         I=I1(1)
         I1(1)=I2(1)
         I2(1)=I
      ENDIF
      NDOLD=ND
      DO I=1,NX+1
         DO IC=1,2
            IP1=I1(IC)
            IP2=I2(IC)
            DX=(PTX(IP2)-PTX(IP1))/NX
            DY=(PTY(IP2)-PTY(IP1))/NX
C UZEL NA KRIVCE IX V POZICI I
            ND=ND+1
            XX(ND)=PTX(IP1)+DX*(I-1)
            YY(ND)=PTY(IP1)+DY*(I-1)
C ELEMENT PIPE NA KRIVCE IC
            IF(I.GT.1)THEN
               NE=NE+1
               LOC=LUE(NE)
               LUE(NE+1)=LOC+2
               MUE(NE)=2
               IUE(LOC+1)=ND-2
               IUE(LOC+2)=ND
               IGROUP(NE)=IGPIPE
               JGROUP(IGPIPE,$ENAME)=$PIPE2D
               IRCONS(NE)=IR(IC)
               IMPROP(NE)=IM(IC)
             ENDIF
         ENDDO                              
C GENEROVANI ELEMENTU 4-UZLOVEHO
         IF(I.GT.1)THEN
            NE=NE+1
            LOC=LUE(NE)
            LUE(NE+1)=LOC+4
            MUE(NE)=4
            IUE(LOC+1)=ND-3
            IUE(LOC+2)=ND-1
            IUE(LOC+3)=ND-2
            IUE(LOC+4)=ND
            IGROUP(NE)=IGHEX
            JGROUP(IGHEX,$ENAME)=$HEXC
            IRCONS(NE)=IRHEXC
C ODKAZY NA DVOJICI ELEMENTU PIPE DO ZONY IEPAR
            LE1=LEPAR($HEXC,$EE1)
            LE2=LEPAR($HEXC,$EE2)
            IEPAR(NE,LE1)=NE-2
            IEPAR(NE,LE2)=NE-1
         ENDIF
      ENDDO
      END

      SUBROUTINE FTMHEX(IC1,IC2,KGROUPS,IRHEXC)
C Generovani elementu 4-uzlovych HEXC na dvojici jiz vysitovanych krivek IC1,IC2.
      INCLUDE '$FEMLOC'
      LOGICAL NSORTED
      DIMENSION ICRV(2),N(2),X3(3),Y3(3),Z3(3),IELONC(100,2)
      IF(KGROUPS.LE.0.OR.IRHEXC.LE.0)THEN
        WRITE(10,*)' Zero group number - quit HEXC element generation'
        RETURN
      ENDIF
      ICRV(1)=IC1
      ICRV(2)=IC2
      DO ICV=1,2
         IC=ICRV(ICV)
         DO I=1,MCR(IC)
            X3(I)=PTX(ICR(I,IC))
            Y3(I)=PTY(ICR(I,IC))
            Z3(I)=PTZ(ICR(I,IC))
         ENDDO
C IDENTIFIKACE dvouuzlovych elementu (PIPE), ktere lezi na krivce IC
         N(ICV)=0
         DO IE=1,NE
            LOCE=LUE(IE)
            IF(MUE(IE).EQ.2)THEN
              I1=IABS(IUE(LOCE+1))
             CALL FTN3CR(X3,Y3,Z3,MCR(IC),XX(I1),YY(I1),ZZ(I1),$RTOL,T1)
              I2=IABS(IUE(LOCE+2))
             CALL FTN3CR(X3,Y3,Z3,MCR(IC),XX(I2),YY(I2),ZZ(I2),$RTOL,T2)
              IF(T1.GT.-.5.AND.T2.GT.-0.5)THEN
                 N(ICV)=N(ICV)+1
                 IELONC(N(ICV),ICV)=IE
              ENDIF
            ENDIF
         ENDDO
C Sestrideni elementu dle rostouci souradnice X nebo Y
         NSORTED=.TRUE.
         DO WHILE(NSORTED)
            NSORTED=.FALSE.
            DO I=1,N(ICV)-1
               CALL XYELE(IELONC(I,ICV),X1)
               CALL XYELE(IELONC(I+1,ICV),X2)
               IF(X1.GT.X2)THEN
                   NSORTED=.TRUE.
                   IDUMMY=IELONC(I,ICV)
                   IELONC(I,ICV)=IELONC(I+1,ICV)
                   IELONC(I+1,ICV)=IDUMMY
               ENDIF
            ENDDO
         ENDDO
      ENDDO
C TEST STEJNEHO POCTU ELEMENTU NA KRIVKACH IC1,IC2
      IF(N(1).NE.N(2))THEN
         WRITE(10,'('' Number of elements on curves'',2i3)')N
         RETURN
      ELSE
C Generovani N(1) novych 4-uzlovych elementu
         DO I=1,N(1)
            NE=NE+1
            LOC=LUE(NE)
            LUE(NE+1)=LOC+4
            MUE(NE)=4
            LOC1=LUE(IELONC(I,1))
            LOC2=LUE(IELONC(I,2))
            IUE(LOC+1)=IABS(IUE(LOC1+1))
            IUE(LOC+2)=IABS(IUE(LOC1+2))
            IUE(LOC+3)=IABS(IUE(LOC2+1))
            IUE(LOC+4)=IABS(IUE(LOC2+2))
            IGROUP(NE)=KGROUPS
            JGROUP(KGROUPS,$ENAME)=$HEXC
            IRCONS(NE)=IRHEXC
C ODKAZY NA DVOJICI ELEMENTU PIPE DO ZONY IEPAR
            LE1=LEPAR($HEXC,$EE1)
            LE2=LEPAR($HEXC,$EE2)
            IEPAR(NE,LE1)=IELONC(I,1)
            IEPAR(NE,LE2)=IELONC(I,2)
         ENDDO
      ENDIF
      END

      SUBROUTINE XYELE(IE,X)
C
C charakteristicka souradnice uzlu elementu
C
      INCLUDE '$FEM'
      LOC=LUE(IE)
      IU1=IABS(IUE(LOC+1))
      IU2=IABS(IUE(LOC+2))
      X1=XX(IU1)
      Y1=YY(IU1)
      X2=XX(IU2)
      Y2=YY(IU2)
      IF(ABS(X2-X1).GE.ABS(Y2-Y1))THEN
         X=AMIN1(X1,X2)
      ELSE
         X=AMIN1(Y1,Y2)
      ENDIF
      END

      SUBROUTINE RANGE(IZONE)
C
C Ukolem teto procedury je aktualizovat DOFMIN a DOFMAX dle aktualnich hodnot 
C zonach 1,2,3,4,5 pole VAL
C
      INCLUDE '$FEM'
      DOFMIN=1E10
      DOFMAX=-1E10
C Cyklus pres vsechny uzlove body
      DO I=1,ND
         DO J=1,MDOF
            K=JPU(J)
            V=VAL(I+(J-1)*MAXND,IZONE)
            IF(K.GT.0)THEN
               DOFMIN(K)=AMIN1(DOFMIN(K),V)
               DOFMAX(K)=AMAX1(DOFMAX(K),V)
            ENDIF
         ENDDO
      ENDDO
      END

      SUBROUTINE MOFE(IDOF,IPE)
C
C Vypocet stredni hodnoty uzloveho parametru IDOF ve vsech elementech
C a presun do sloupce IPE matice parametru elementu EPAR
C
      include '$FEM'
      IF(IDOF.LE.0)RETURN
      LOCP=LPU(IDOF)
      DO IE=1,NE
         S=0.
         LOC=LUE(IE)
         DO IU=1,MUE(IE)
            IND=IABS(IUE(LOC+IU))
            S=S+VAL(LOCP+IND,2)
         ENDDO
         EPAR(IE,IPE)=S/MUE(IE)
      ENDDO
      END

      LOGICAL FUNCTION P2ONC(IP1,IP2,IC)
C Lezi body IP1,IP2 na krivce IC?
      INCLUDE '$FEM'
      IPC1=ICR(1,IC)
      IPC2=ICR(2,IC)
      IF((IPC1.EQ.IP1.AND.IPC2.EQ.IP2).OR.
     /   (IPC1.EQ.IP2.AND.IPC2.EQ.IP1))THEN
         P2ONC=.TRUE.
      ELSE
         P2ONC=.FALSE.
      ENDIF
      END

      SUBROUTINE INTC2(IC1,IC2,IPT,IPT1,IPT2)
C Jsou dany dve krivky IC1,IC2 (se 2 nebo 3 body).
C Ukolem je zjistit, zda maji spolecny bod IPT, a pokud ano (IPT>0)
C urcit indexy koncovych bodu IPT1,IPT2 na krivkach IC1,IC2.
      INCLUDE '$FEM'
      IP1C1=ICR(1,IC1)
      IP2C1=ICR(2,IC1)
      IP1C2=ICR(1,IC2)
      IP2C2=ICR(2,IC2)
      IF(IP1C1.EQ.IP1C2)THEN
         IPT=IP1C1
         IPT1=IP2C1
         IPT2=IP2C2
      ELSEIF(IP1C1.EQ.IP2C2)THEN
         IPT=IP1C1
         IPT1=IP2C1
         IPT2=IP1C2
      ELSEIF(IP2C1.EQ.IP1C2)THEN
         IPT=IP2C1
         IPT1=IP1C1
         IPT2=IP2C2
      ELSEIF(IP2C1.EQ.IP2C2)THEN
         IPT=IP2C1
         IPT1=IP1C1
         IPT2=IP1C2
      ELSE
         IPT=0
      ENDIF
      END

      SUBROUTINE P2ONCS(IP1,IP2,IC)
C Nalezeni krivky IC na niz lezi dvojice bodu IP1,IP2
C Pokud je poradi obracene, je vysledny index zaporny.
      INCLUDE '$FEM'
      LOGICAL P2ONC
      IC=0
      DO I=1,NCR
         IF(P2ONC(IP1,IP2,I))THEN
            IF(IP1.NE.ICR(1,I))THEN
              IC=-I
            ELSE
              IC=I
            ENDIF
            RETURN
         ENDIF
      ENDDO
      END

      SUBROUTINE SF2CR(IND,IC1,IC2,IEND)
C
C Vytvoreni plochy IND (4 nebo 8 bodu) na zaklade dvou krivek IC1,IC2,
C ktere mohou byt dvojici prilehlych nebo protilehlych stran
C 
C IEND <>0  plochu nelze vytvorit
C
      INCLUDE '$FEM'
      IEND=0
      CALL INTC2(IC1,IC2,IPT,IPT1,IPT2)
      IF(IPT.GT.0)THEN
C IPT je prusecik IC1,IC2 (prilehle strany)
C Hledani ctvrteho vrcholu IPP.      
         DO IPP=1,NPT
            IF(IPP.NE.IPT)THEN
               CALL P2ONCS(IPT1,IPP,IC3)
               CALL P2ONCS(IPT2,IPP,IC4)
               IC3=IABS(IC3)
               IC4=IABS(IC4)
               IF(IC3.GT.0.AND.IC4.GT.0)THEN
                   ISF(1,IND)=IPT
                   ISF(2,IND)=IPT1
                   ISF(3,IND)=IPP
                   ISF(4,IND)=IPT2
                   MSF(IND)=4
                   IF(MCR(IC1).EQ.3.AND.MCR(IC2).EQ.3.AND.
     /                MCR(IC3).EQ.3.AND.MCR(IC4).EQ.3)THEN
                      MSF(IND)=8
                      ISF(5,IND)=ICR(3,IC1)
                      ISF(6,IND)=ICR(3,IC3)
                      ISF(7,IND)=ICR(3,IC4)
                      ISF(8,IND)=ICR(3,IC2)
                   ENDIF
      WRITE(9,'('' Surface'',i3,'' from intersecting CR'',4i3)')ind,
     /       ic1,ic2,ic3,ic4
                   RETURN
               ENDIF
            ENDIF
         ENDDO
         WRITE(9,'('' UNABLE TO CREATE SURFACE from two intersecting cur
     /ves:'',2i5)')IC1,IC2
         CALL HELPC(4,'Try: TOL=TOL*100 and PMERGE')
         IEND=-3
      ELSE
C Krivky IC1 IC2 nemaji spolecny bod - jsou to protilehle strany
         IPT1=ICR(1,IC1)
         IPT2=ICR(1,IC2)
         CALL P2ONCS(IPT1,IPT2,IC3)
         IC3=IABS(IC3)
         IF(IC3.GT.0)THEN
            IPT3=ICR(2,IC1)
            IPT4=ICR(2,IC2)
         ELSE
            IPT2=ICR(2,IC2)
            CALL P2ONCS(IPT1,IPT2,IC3)
            IC3=IABS(IC3)
            IF(IC3.GT.0)THEN
               IPT3=ICR(2,IC1)
               IPT4=ICR(1,IC2)
            ELSE
               WRITE(9,'('' UNABLE TO CREATE SURFACE from two parallel c
     /urves'',2i5)')IC1,IC2
               CALL HELPC(4,'Try: TOL=TOL*100 and PMERGE')
               IEND=-1
               RETURN
            ENDIF
         ENDIF
         CALL P2ONCS(IPT3,IPT4,IC4)
         IC4=IABS(IC4)
         IF(IC4.GT.0)THEN
             ISF(1,IND)=IPT1
             ISF(2,IND)=IPT3
             ISF(3,IND)=IPT4
             ISF(4,IND)=IPT2
             MSF(IND)=4
             IF(MCR(IC1).EQ.3.AND.MCR(IC2).EQ.3.AND.
     /          MCR(IC3).EQ.3.AND.MCR(IC4).EQ.3)THEN
                   MSF(IND)=8
                   ISF(5,IND)=ICR(3,IC1)
                   ISF(6,IND)=ICR(3,IC4)
                   ISF(7,IND)=ICR(3,IC2)
                   ISF(8,IND)=ICR(3,IC3)
             ENDIF
          ELSE          
             WRITE(9,'('' UNABLE TO CREATE SURFACE'',i5)')IND
             CALL HELPC(4,'Try: TOL=TOL*100 and PMERGE')
             IEND=-2
             RETURN
          ENDIF
      WRITE(9,'('' Surface'',i3,'' from PARALEL CR'',4i3)')ind,
     /       ic1,ic2,ic3,ic4
      ENDIF
      END

      SUBROUTINE PTC2(IC1,IC2,NEW)
C
C Pruseciky dvou krivek IC1 a IC2. 
C Vystupni parametr    NEW=0  neni zadny prusecik
C                         =1  jediny prusecik
C                         =2  dva pruseciky
C
      INCLUDE '$FEM'
      DIMENSION X1(3),Y1(3),Z1(3),X2(3),Y2(3),Z2(3)
C Rovnice kvadratickych krivek X=a + b.t + c.t^2
      NEW=0
      IF(IC1.GT.0.AND.IC1.LE.NCR.AND.IC2.GT.0.AND.IC2.LE.NCR)THEN
         N1=MCR(IC1)
         N2=MCR(IC2)
         DO I=1,N1
           X1(I)=PTX(ICR(I,IC1))
           Y1(I)=PTY(ICR(I,IC1))
           Z1(I)=PTZ(ICR(I,IC1))
         ENDDO
         DO I=1,N2
           X2(I)=PTX(ICR(I,IC2))
           Y2(I)=PTY(ICR(I,IC2))
           Z2(I)=PTZ(ICR(I,IC2))
         ENDDO
         NP1=NPT+1
         NP2=NP1+1
         CALL PTCR2(X1,Y1,Z1,N1,X2,Y2,Z2,N2,NEW,
     /     PTX(NP1),PTY(NP1),PTZ(NP1),PTX(NP2),PTY(NP2),PTZ(NP2),$RTOL)
         NPT=NPT+NEW
      ENDIF
      END

      SUBROUTINE CHECKRES
C Kontrola vysledku RUNFEM
      INCLUDE '$FEMB'
      DIMENSION X(2),Y(2),Z(2)
      QMI=1E10
      QMA=-1E10
      VOLPIPE=0
      DO IE=1,NE
        IG=IGROUP(IE)
        IR=IRCONS(IE)
        NAMELE=JGROUP(IG,$ENAME)
        IF(NAMELE.EQ.$PUMP)THEN
           METHOD=JGROUP(IG,$METHOD)
           VOLPIPE=VOLPIPE+RRCONS(IR,$VOL)
           IF(METHOD.GT.0)THEN
              INDQ=MAX0(1,LEPAR(NAMELE,$EQ))
              Q=EPAR(IE,INDQ)
              QMIN=RRCONS(IR,$RX8)
              QMAX=RRCONS(IR,$RX9)
              IF(Q.LT.QMIN)THEN
                WRITE(9,100)Q,QMIN
100             FORMAT(' Calculated flowrate',e9.3,' <',e9.3,' (Qmin)')
              ELSEIF(Q.GT.QMAX)THEN
                WRITE(9,101)Q,QMAX
101             FORMAT(' Calculated flowrate',e9.3,' >',e9.3,' (Qmax)')
              ENDIF
              CALL PLOTCHAR(IR,IG)
              IAUX(10)=1
           ENDIF
        ELSEIF(NAMELE.EQ.$CSTR)THEN
           VOLPIPE=VOLPIPE+RRCONS(IR,$VOL)
        ELSEIF(NAMELE.EQ.$PIPE2D)THEN
           INDQ=MAX0(1,LEPAR(NAMELE,$EQ))
           Q=EPAR(IE,INDQ)
           QMI=AMIN1(Q,QMI)
           QMA=AMAX1(Q,QMA)
        ENDIF
      ENDDO
C Vykresleni sipek rychlosti v potrubni siti
      IF(QMA.GT.QMI)THEN
        CALL GMFSWC(1,1,XMI,XMA,YMI,YMA)
        QA=AMAX1(ABS(QMA),ABS(QMI))
        DO IE=1,NE
          IG=IGROUP(IE)
          IR=IRCONS(IE)
          NAMELE=JGROUP(IG,$ENAME)
          IF(NAMELE.EQ.$PIPE2D)THEN
             INDQ=MAX0(1,LEPAR(NAMELE,$EQ))
             INDR=MAX0(1,LEPAR(NAMELE,$ERE))
             Q=EPAR(IE,INDQ)
             IF(ABS(EPAR(IE,INDR)).GT.2300.)THEN
                ITYPE=-1
             ELSE
                ITYPE=0
             ENDIF
             LOC=LUE(IE)
             DO I=1,2
               I1=IABS(IUE(LOC+I))
               CALL ROT(XX(I1),YY(I1),ZZ(I1),X(I),Y(I),DUMMY)
             ENDDO
             CALL GMFARROW(ITYPE,X,Y,0.9*Q/QA,0)
C Vypocet objemu
             DO I=1,2
               I1=IABS(IUE(LOC+I))
               X(I)=XX(I1)
               Y(I)=YY(I1)
               Z(I)=ZZ(I1)
             ENDDO
             H=SQRT((X(1)-X(2))**2+(Y(1)-Y(2))**2+(Z(1)-Z(2))**2)
             AREA=ABS(RRCONS(IR,$AREA))
             VOLPIPE=VOLPIPE+AREA*H
          ENDIF
        ENDDO
        WRITE(9,110)QA,VOLPIPE,VOLPIPE/QA
110     FORMAT(' Flowrate=',e10.3,' pipe/CSTR/PUMP vol=',e10.3/' tmean='
     /,e10.3)
      ENDIF
      END

      SUBROUTINE CRCOMP
C
C Vyrazeni duplicitnich krivek ze seznamu
C
      INCLUDE '$FEM'
      I=1
      DO WHILE(I.LT.NCR)
         J=I+1
         DO WHILE(J.LE.NCR)
C POROVNEJ KRIVKY I a J
            IF((MCR(I).EQ.MCR(J).AND.ICR(3,I).EQ.ICR(3,J)).AND.
     /         (ICR(1,I).EQ.ICR(1,J).AND.ICR(2,I).EQ.ICR(2,J).OR.
     /          ICR(2,I).EQ.ICR(1,J).AND.ICR(1,I).EQ.ICR(2,J)))THEN
C Krivky I a J jsou totozne: Vyrad krivku J a zmensi NCR
C MCR-pocet bodu krivky, NXCR,FLAFI-informace o meshovani
C Pokud byla krivka J jiz meshovana, prekopiruji se meshovaci informace do I
               IF(NXCR(J).GT.0)THEN
                 NXCR(I)=NXCR(J)
                 FLAFI(I)=FLAFI(J)
               ENDIF
C Vyrad krivku J a zmensi NCR
               CALL CRDEL(J)
            ELSE
               J=J+1
            ENDIF
         ENDDO
         I=I+1
      ENDDO
      END

      SUBROUTINE SFCOMP
C
C Vyrazeni duplicitnich PLOCH ze seznamu
C
      INCLUDE '$FEM'
      LOGICAL TOTOZ,TOIJ
      I=1
      DO WHILE(I.LT.NSF)
         J=I+1
         DO WHILE(J.LE.NSF)
C POROVNEJ PLOCHY I a J
            TOTOZ=.FALSE.
            IF(MSF(I).EQ.MSF(J))THEN
              TOTOZ=.TRUE.
              DO II=1,MSF(I)
                TOIJ=.FALSE.
                DO JJ=1,MSF(J)
                  IF(ISF(II,I).EQ.ISF(JJ,J))TOIJ=.TRUE.
                ENDDO
                IF(.NOT.TOIJ)TOTOZ=.FALSE.
              ENDDO
            ENDIF
            IF(TOTOZ)THEN
C Plochy I a J jsou totozne: Vyrad plochu J a zmensi NSF
              CALL SFDEL(J)
            ELSE
              J=J+1
            ENDIF
         ENDDO
         I=I+1
      ENDDO
      END

      SUBROUTINE CRDEL(J)
C Vyrad krivku J ze seznamu krivek a precisluj krivky s vyssim indexem
      INCLUDE '$FEM'
C Vyrazovana krivka
      JMCR=MCR(J)
	JP1=ICR(1,J)
	JP2=ICR(2,J)
	JP3=ICR(3,J)
      DO K=J,NCR-1
         MCR(K)=MCR(K+1)
         NXCR(K)=NXCR(K+1)
         FLAFI(K)=FLAFI(K+1)
         ICR(3,K)=0
         DO L=1,MCR(K)
           ICR(L,K)=ICR(L,K+1)
         ENDDO
      ENDDO
C Modifikace seznamu CT
C  ICONTOUR(50,MAXCT),MCONTOUR(MAXCT),
      DO I=1,NCONTOUR
	   DO L=1,MCONTOUR(I)
	      IC=ICONTOUR(L,I)
	      IF(IC.GT.J)THEN
		     ICONTOUR(L,I)=IC-1
	      ELSEIF(IC.EQ.J)THEN
C Hledame exisujici krivku v seznamu krivek 1,...,J-1
              DO M=1,J-1
                MMCR=MCR(M)
	          MP1=ICR(1,M)
	          MP2=ICR(2,M)
	          MP3=ICR(3,M)
	          IF(MMCR.EQ.JMCR.AND.
     /			  MP1.EQ.JP1.AND.
     /			  MP2.EQ.JP2.AND.
     /			  MP3.EQ.JP3)THEN
	             ICONTOUR(L,I)=M
	             EXIT
                ENDIF
	        ENDDO
	      ENDIF
	   ENDDO
	ENDDO
      NCR=NCR-1
      END

      SUBROUTINE SFDEL(J)
C Vyrad plochu J ze seznamu ploch a precisluj plochy s vyssim indexem
      INCLUDE '$FEM'
      DO K=J,NSF-1
         MSF(K)=MSF(K+1)
         DO L=5,8
           ISF(L,K)=0
         ENDDO
         DO L=1,MSF(K)
           ISF(L,K)=ISF(L,K+1)
         ENDDO
      ENDDO
      NSF=NSF-1
      END

      SUBROUTINE PTDEL(IND)
C
C Zruseni BODU cislo IND
C
C 1) zkraceni vektoru (presun o 1 vlevo) PTX(),PTY(),PTZ(),NEARND()
C 2) zrusi se vsechny krivky a plochy, v nichz se PT vyskytuje a u vsech 
C    ostatnich se precisluji indexy
C
      INCLUDE '$FEM'
      IF(IND.GT.0.AND.IND.LE.NPT)THEN
         NPT=NPT-1
         DO I=IND,NPT
            PTX(I)=PTX(I+1)
            PTY(I)=PTY(I+1)
            PTZ(I)=PTZ(I+1)
            NEARND(I)=NEARND(I+1)
         ENDDO
C Uprava matice KRIVEK
         IC=0
         DO WHILE(IC.LT.NCR)
            IC=IC+1
            MU=MCR(IC)
            DO J=1,MU
              IU=ICR(J,IC)
              IF(IU.GT.IND)THEN
                 ICR(J,IC)=IU-1
              ELSEIF(IU.EQ.IND)THEN
                 CALL CRDEL(IC)
                 IC=IC-1
                 EXIT
              ENDIF
            ENDDO
         ENDDO
C Uprava matice PLOCH
         IS=0
         DO WHILE(IS.LT.NSF)
            IS=IS+1
            MU=MSF(IS)
            DO J=1,MU
              IU=ISF(J,IS)
              IF(IU.GT.IND)THEN
                 ISF(J,IS)=IU-1
              ELSEIF(IU.EQ.IND)THEN
                 CALL SFDEL(IS)
                 IS=IS-1
                 EXIT
              ENDIF
            ENDDO
         ENDDO
      ENDIF
      END

      SUBROUTINE SORTNUM(N,NAME,NSORT)
C Setrideni seznamu NAME(1),...  vzestupne. Nove indexy jsou NSORT(1),...
C Slouzi k setrideni pole NAME(2,*)
      CHARACTER*8 NAME
      DIMENSION NAME(*),NSORT(*)
      LOGICAL SORTED
      DO I=1,N
         NSORT(I)=I
      ENDDO
      SORTED=.FALSE.
      DO WHILE(.NOT.SORTED)
         SORTED=.TRUE.
         DO I=1,N-1
           IF(NAME(NSORT(I)).GT.NAME(NSORT(I+1)))THEN
               SORTED=.FALSE.
               J=NSORT(I)
               NSORT(I)=NSORT(I+1)
               NSORT(I+1)=J
           ENDIF
         ENDDO
      ENDDO
      END

      SUBROUTINE SHMOUSE(IS)
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
C
C Zadani RP(3),RP(4) mysi
C
      INCLUDE '$FEM'
      INCLUDE '$PLT-COM'
      SELECT CASE(IS)
      CASE(1)
         WRITE(10,'('' Use mouse to locate a new zero level (L-click con
     /firms, R-click quit)'')')
      CASE(2)
         WRITE(10,'('' Use mouse to locate a time origin (L-click confir
     /ms, R-click quit)'')')
      CASE(3)
         WRITE(10,'('' Use mouse to locate a new origin (L-click confirm
     /s, R-click quit)'')')
      CASE(4)
         WRITE(10,'('' Use mouse to locate a INITIAL and FINAL TIME (L-c
     /lick confirms, R-click quit)'')')
      CASE(5)
         WRITE(10,'('' Use mouse to locate end-point of a ZERO initial p
     /art (L-click confirms, R-click quit)'')')
      END SELECT
      II=SETACTIVEQQ(20)
      II=FOCUSQQ(20)
      CALL GMFSW(1)
      CALL GMFLCC(PX,PY,KBD)
      IF(KBD.EQ.1)THEN
         SELECT CASE(IS)
         CASE(1)
            RP(3)=-PY
            WRITE(TP(3),'(E10.3)')RP(3)
            WRITE(9,'('' Y-shift using mouse='',e10.3)')PY
         CASE(2)
            RP(3)=-PX
            WRITE(TP(3),'(E10.3)')RP(3)
            WRITE(9,'('' X-shift using mouse='',e10.3)')PX
         CASE(3)
            RP(3)=-PX
            RP(4)=-PY
            WRITE(TP(3),'(E10.3)')RP(3)
            WRITE(TP(4),'(E10.3)')RP(4)
            WRITE(9,'('' X,Y-shifts using mouse='',2e10.3)')PX,PY
         CASE(4)
            RP(1)=PX
            CALL GMFHV(2,PX,13)
            CALL GMFLCC(PX,PY,KBD)
            CALL GMFHV(2,PX,13)
            RP(2)=PX
            WRITE(TP(1),'(E10.3)')RP(1)
            WRITE(TP(2),'(E10.3)')RP(2)
            WRITE(9,'('' New INITIAL/END time='',2e10.3)')RP(1),RP(2)
         CASE(5)
            RP(2)=PX
            WRITE(TP(2),'(E10.3)')PX
            WRITE(9,'('' Time ending zero part='',e10.3)')PX
         END SELECT
      ENDIF
      END

      SUBROUTINE GMFHV(IHV,PXY,ICOLOR)
      INCLUDE '$GMF'
      DIMENSION X(2),Y(2)
      IF(IHV.EQ.1)THEN
C Horizontalni cara
         X(1)=FXMI
         X(2)=FXMA
         Y=PXY
      ELSE
C Vertikalni cara
         Y(1)=FYMI
         Y(2)=FYMA
         X=PXY
      ENDIF
      CALL GMFPL(2,X,Y,ICOLOR)
      END

      SUBROUTINE WOBSER(IFIRST,IBRIGHT,JBRIGHT,IFORMAT)
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
C
C Zobrazeni matice bodu pozorovani v okne cislo 20 (model)     
C Prvek v radku IBRIGHT a sloupci JBRIGHT je zobrazen cervene
C IFORMAT=1  E9.2
C IFORMAT=2  G9.2
C IFORMAT=-1 E9.2 potlacuje se clearscreen
C IFORMAT=-2 G9.2 potlacuje se clearscreen
C
      INCLUDE '$FEM'
      INCLUDE '$PLT-COM'
      INTEGER*2 IRES
      LOGICAL RES1
      TYPE(RCCOORD)CURPOS
      TYPE(WINDOWCONFIG)WC
      IAFORMAT=IABS(IFORMAT)
      II=FOCUSQQ(20)
c      istat = SETFONT('n3')
      RES1=GETWINDOWCONFIG(WC)
      MAXTROWS=WC.NUMTEXTROWS-6
      II=SETBKCOLOR(15)
      IF(IFORMAT.GE.0)CALL CLEARSCREEN($GCLEARSCREEN)
c Hlavicka zelene (1-fialovemodra, 3-zelena)
      IRES=SETTEXTCOLOR(INT2(3))
      DO I=1,MAXSEL
         CALL SETTEXTPOSITION(INT2(1),INT2((I-1)*12+4),CURPOS)
         WRITE(20,'(I11)')I
         CALL SETTEXTPOSITION(INT2(2),INT2((I-1)*12+6),CURPOS)
         WRITE(20,'(3X,A8)')FILEXPERI(I)
         CALL SETTEXTPOSITION(INT2(3),INT2((I-1)*12+6),CURPOS)
         WRITE(20,'(3X,A8)')TTC(IQGR(I)+1)
      ENDDO
      DO I=IFIRST,IFIRST+MAXTROWS
       IF(I.GE.1.AND.I.LE.NGR)THEN
         CALL SETTEXTPOSITION(INT2(I-IFIRST+4),INT2(0),CURPOS)
         IRES=SETTEXTCOLOR(INT2(3))
         WRITE(20,'(I4)')I
         DO J=1,MAXSEL
           IF(I.EQ.IBRIGHT.AND.J.EQ.JBRIGHT)THEN
               II=SETBKCOLOR(0)
               IRES=SETTEXTCOLOR(INT2(14))
           ELSE
               II=SETBKCOLOR(15)
               IRES=SETTEXTCOLOR(INT2(0))
           ENDIF
          CALL SETTEXTPOSITION(INT2(I-IFIRST+4),INT2((J-1)*12+6),CURPOS)
           YIJ=YGR(I,J)
           IF(YIJ.EQ.0.)THEN
              WRITE(20,'(''    0           '')')
           ELSEIF(IAFORMAT.EQ.2)THEN
              WRITE(20,'(ES10.2)')YIJ
           ELSEIF(IAFORMAT.EQ.1)THEN
              AIJ=ABS(YIJ)
              IF(AIJ.GE.100..AND.AIJ.LE.99999.)THEN
                 WRITE(20,'(F9.1,''     '')')YIJ
	        ELSEIF(AIJ.GE.100000.AND.AIJ.LE.999999.)THEN
                 WRITE(20,'(F9.0,''     '')')YIJ
              ELSEIF(AIJ.GE.0.005.AND.AIJ.LE.99.)THEN
                 WRITE(20,'(F9.4,''     '')')YIJ
              ELSE
                 WRITE(20,'(ES10.2,''    '')')YGR(I,J)
              ENDIF
           ENDIF
         ENDDO
       ENDIF
      ENDDO
      CALL SETTEXTPOSITION(INT2(MAXTROWS+5),INT2(1),CURPOS)
      WRITE(20,'(''_____________observation matrix'',i6,''-rows'')')NGR
C STATUT OKNA 20 - ALFANUMERICKY
      IST20=3
      END

      SUBROUTINE GRAPUT(ITYPS,XMIN,XMAX,YMIN,YMAX)
C Vstupni parametr ITYPS, nastaveni hodnot v COMMON/$PLT-COM/
C ITYPS=0  nastaveni dle IST20
C ITYPS=1  nastaveni XMIF,...
C ITYPS=2  nastaveni XMIT,...
C
      INCLUDE '$PLT-COM'
      IF(ITYPS.LE.0)THEN
         ITYP=IST20
      ELSE
         ITYP=ITYPS
      ENDIF
      SELECT CASE(ITYP)
      CASE(1)
         XMIF=XMIN
         XMAF=XMAX
         YMIF=YMIN
         YMAF=YMAX
      CASE(2)
         XMIT=XMIN
         XMAT=XMAX
         YMIT=YMIN
         YMAT=YMAX
      END SELECT
      END

      SUBROUTINE GRAGET(ITYPS,XMIN,XMAX,YMIN,YMAX)
C Vstupni parametr ITYPS, zjisti se XMIN,...
C ITYPS=0  dle aktualni hodnoty IST20
C ITYPS=1  aktualni nastaveni XMIF,... (FEM)
C ITYPS=2  aktualni nastaveni XMIT,... (GRAPHS)
C
      INCLUDE '$PLT-COM'
      IF(ITYPS.LE.0)THEN
         ITYP=IST20
      ELSE
         ITYP=ITYPS
      ENDIF
      SELECT CASE(ITYP)
      CASE(1)
         XMIN=XMIF
         XMAX=XMAF
         YMIN=YMIF
         YMAX=YMAF
      CASE(2)
         XMIN=XMIT
         XMAX=XMAT
         YMIN=YMIT
         YMAX=YMAT
      END SELECT
      END

      SUBROUTINE GRANGE(ITYP,ISIZEX,ISIZEY,XMI,XMA,YMI,YMA)
C Zjisteni rozsahu min/max souradnic, resp. grafu
C ITYP - vstupni parametr
C   ITYP=1 fem
C   ITYP=2 TC
C kdyz je ITYP=0 nastavi se rozsahy dle aktualniho statutu IST20
C ISIZE =0 bez zvetseni
C ISIZE >0 zvetseni DX,DY procenta
      INCLUDE '$FEM'
      INCLUDE '$PLT-COM'
      XMI=1E10
      XMA=-1E10
      YMI=1E10
      YMA=-1E10
      IF(ITYP.LE.0)THEN
         ITYPS=IST20
         IF(IST20.EQ.3)ITYPS=2
      ELSE
         ITYPS=ITYP
      ENDIF
      IF(ITYPS.EQ.1)THEN
         DO I=1,ND
            CALL ROT(XX(I),YY(I),ZZ(I),XXI,YYI,DUMMY)
            XMI=AMIN1(XXI,XMI)
            XMA=AMAX1(XXI,XMA)
            YMI=AMIN1(YYI,YMI)
            YMA=AMAX1(YYI,YMA)
         ENDDO
         DO I=1,NPT
            CALL ROT(PTX(I),PTY(I),PTZ(I),PTXI,PTYI,DUMMY)
            XMI=AMIN1(PTXI,XMI)
            XMA=AMAX1(PTXI,XMA)
            YMI=AMIN1(PTYI,YMI)
            YMA=AMAX1(PTYI,YMA)
         ENDDO
      ELSE
         DO I=1,NGR
            XMI=AMIN1(YGR(I,1),XMI)
            XMA=AMAX1(YGR(I,1),XMA)
            DO J=2,MAXSEL
              YMI=AMIN1(YGR(I,J),YMI)
              YMA=AMAX1(YGR(I,J),YMA)
            ENDDO
         ENDDO
      ENDIF
      IF(XMI.GE.XMA)THEN
         XMI=0.
         XMA=1.
      ENDIF
      IF(YMI.GE.YMA)THEN
         YMI=0.
         YMA=1.
      ENDIF
      DX=(XMA-XMI)*.01*ISIZEX
      DY=(YMA-YMI)*.01*ISIZEY
      IF(ITYPS.EQ.1)THEN
        IF(DX.LE.1e-4*DY)DX=DY
        IF(DY.LE.1e-4*DX)DY=DX
      ENDIF
      XMA=XMA+DX
      IF(ITYPS.EQ.1)THEN
         XMI=XMI-DX/2.
         YMI=YMI-DY/2.
      ENDIF
      YMA=YMA+DY
      END

      SUBROUTINE GMFSWC(IW,IST,XMI,XMA,YMI,YMA)
C
C Prepnuti na transformaci c.IW a soucasne kontrola, zda souhlasi 
C status IST=1 nebo 2 (bud FEM nebo TC). Kdyz nesouhlasi, definuje
C se nova transformace a vykresli se elementy ci krivky.
C XMI,XMA,YMI,YMA jsou vystupni parametry - aktualni nastaveni
C
      INCLUDE '$PLT-COM'
      CALL GRAGET(IST20,XMI,XMA,YMI,YMA)
      IF(IST.NE.IST20)THEN
          CALL GRAGET(IST,XMI,XMA,YMI,YMA)
          CALL GMFSTW(IW,1,20,3,16,'X','Y',0.,1.,0.,1.,XMI,XMA,YMI,YMA)
          CALL GMFAXE(IW,7,15)
          IST20=IST
          CALL PLOTAL
      ENDIF
      CALL GMFSW(IW)
      END

      SUBROUTINE WINSET(TEXT)
      CHARACTER*(*) TEXT
C
C ND$,...   priznak toho, ze byla vykreslena (a mela by byt prekreslena)
C           urcita entita
C IST20     statut okna 20 (MODEL)
C           IST20 =1 FEM
C                 =2 TC
C                 =3 ALFANUMERICKY
C
C XMIF,... rozsah okna FEM (aktualni treba po operaci ZOOM)
C XMIT,... rozsah okna TC
C
      INCLUDE '$PLT-COM'
C
C MAXX,MAXY pocet pixelu X,Y
C WXT,WYT   delka textu, ale v uzivatelskych souradnicich
C NX,DNX,DX informace pro osy - pocet useku, meritko a tik
C IXMI,...  vnejsi okenko  [I]
C JXMI,...  vnitrni okenko [J]
C FXMI,...  vnejsi okenko v uzivatelskych souradnicich  [F]
C WXMI,...  vnitrni okenko v uzivatelskych souradnicich [W]
C QXMI,...  zaokrouhlene rozsahy uzivatelske souradnice
C
      INCLUDE '$GMF'

      WRITE(9,1)TEXT,IST20,
     /  XMIT,XMAT,YMIT,YMAT,
     /  XMIF,XMAF,YMIF,YMAF,
     /  IXMI,IXMA,IYMI,IYMA,
     /  JXMI,JXMA,JYMI,JYMA,
     /  WXMI,WXMA,WYMI,WYMA,
     /  FXMI,FXMA,FYMI,FYMA,
     /  QXMI,QXMA,QYMI,QYMA,
     /  ND$,EL$,TC$,PT$,CR$,SF$
1     FORMAT(/1X,A/' WINDOW MODEL STATUS=',I2,' (1-fem,2-tc,3_alfa)'/
     /' TC range:',4E10.3/' FE range:',4E10.3/
     /' I -outer:',4I10  /' J -inner:',4I10/
     /' W -outer:',4e10.3/' F -inner:',4e10.3/' Q -round:',4E10.3/
     /' ND',i1,' EL',i1,' TC',i1,' PT',I1,' CR',I1,' SF',I1)
      END

      SUBROUTINE GRESID(IT,ITMAX,SSQ,ALAM,IMO)
C
C Vykresleni log(souctu ctvercu), log(lambda), alfa - regrese.
C IT - iteracni krok, ITMAX-celkovy pocet iteraci
C IMO=0 Marquartd, =1 Soma, =2 Nelder Mead
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      PARAMETER (MAXT=200)
      DIMENSION TIT(MAXT),YSSQR(MAXT),YALAM(MAXT),Y(MAXT)
	CHARACTER*24 LA
      IF(IT.GT.MAXT)RETURN
      IF(SSQ.GT.0.)YSSQR(IT)=ALOG10(SSQ)
      IF(ALAM.GT.0.)YALAM(IT)=ALOG10(ALAM)
      YSMAX=-1E10
      YSMIN=1E10
      YLMAX=-1E10
      YLMIN=1E10
      DO I=1,IT
        TIT(I)=I
        YSMAX=AMAX1(YSMAX,YSSQR(I))
        YSMIN=AMIN1(YSMIN,YSSQR(I))
        YLMAX=AMAX1(YLMAX,YALAM(I))
        YLMIN=AMIN1(YLMIN,YALAM(I))
      ENDDO
      TMAX=ITMAX
      TEXT=TMAX*.8
      CALL GMFSTW(3,1,21,5,10,'iter','SSQ',0.,1.,0.,1.,
     /            1.,TMAX,-0.01,1.01)
      CALL GMFAXE(3,7,15)
      CALL GMFFONT(5,12)
      CALL GMFTEXT(TEXT,0.9,13,22,'log Stdev (normalised)')
	IF(IMO.EQ.0)THEN
        CALL GMFTEXT(TEXT,0.8,12,23,'Lambda (gradient/Gauss)')
	ELSE
        CALL GMFTEXT(TEXT,0.8,12,14,'1/Leader Index')
	ENDIF
      IF(YSMAX.GT.YSMIN)THEN
         DO I=1,IT
            Y(I)=(YSSQR(I)-YSMIN)/(YSMAX-YSMIN)
            CALL GMFMRKS(TIT(I),Y(I),40)
         ENDDO
         CALL GMFPL(IT,TIT,Y,13)
      ELSE
        CALL GMFFONT(2,16)
	  WRITE(LA,'(''Iter='',i3,'' SSQ='',e11.4)')IT,SSQ
        CALL GMFTEXT(TEXT*.5,0.5,12,24,LA)   
      ENDIF
      IF(YLMAX.GT.YLMIN)THEN
         DO I=1,IT
            Y(I)=(YALAM(I)-YLMIN)/(YLMAX-YLMIN)
            CALL GMFMRKS(TIT(I),Y(I),46)
         ENDDO
         CALL GMFPL(IT,TIT,Y,12)
      ENDIF
      II=FOCUSQQ(21)
      CALL GMFSW(1)
      END

      SUBROUTINE SFPT(NPPT,IND)
C Generovani plochy IND majici NPPT bodu
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEM'
      IF(IND.GT.0.AND.IND.LE.MAXSF.AND.NCR.LE.MAXCR-4)THEN
         II=SETACTIVEQQ(20)
         NSF=MAX0(NSF,IND)
         MSF(IND)=NPPT
         IF(NPPT.LE.4)THEN
           DO J=1,NPPT
             IU=MAX0(1,MIN0(IP(J+1),NPT))
             ISF(J,IND)=IU
             NCR=NCR+1
             ICR(1,NCR)=IU
             MCR(NCR)=2
             IF(J.GT.1)ICR(2,NCR-1)=IU
           ENDDO
           ICR(2,NCR)=ICR(1,NCR-NPPT+1)
         ELSE
           NP1=NPPT/2
           DO J=1,NPPT
             IU=MAX0(1,MIN0(IP(J+1),NPT))
             ISF(J,IND)=IU
           ENDDO
           DO J=1,NP1
             NCR=NCR+1
             MCR(NCR)=3
             ICR(1,NCR)=ISF(J,IND)
             ICR(3,NCR)=ISF(J+NP1,IND)
             IF(J.LT.NP1)THEN
                ICR(2,NCR)=ISF(J+1,IND)
             ELSE
                ICR(2,NCR)=ISF(1,IND)
             ENDIF
           ENDDO
         ENDIF
         CALL PLOTSF(IND,1,KSF)
         CALL CRCOMP
      ENDIF
      END

      SUBROUTINE VLPT(NPPT,IND)
C Generovani objemu IND z NPPT bodu, ktere jiz byly definovany
C IP(1)-vl, IP(2)-p1, IP(3)-p2, ...
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEM'
      IF(IND.GT.0.AND.IND.LE.MAXVL)THEN
         II=SETACTIVEQQ(20)
         NVL=MAX0(NVL,IND)
         MVL(IND)=NPPT
         DO J=1,NPPT
           IU=MAX0(1,MIN0(IP(J+1),NPT))
           IVL(J,IND)=IU
         ENDDO
         CALL PLOTVL(IND,1,KVL)
      ENDIF
      END

      SUBROUTINE SFEXTR(ISSF,DX,DY,DZ,IND)
C Generovani objemu IND translaci plochy ISSF
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEM'
      IF(IND.GT.0.AND.IND.LE.MAXVL.AND.ISSF.GT.0.AND.ISSF.LE.NSF)THEN
         II=SETACTIVEQQ(20)
         NVL=MAX0(NVL,IND)
         MSFI=MSF(ISSF)
         IF(MSFI.EQ.4)THEN
            MVL(IND)=8
            DO I=1,4
               IPP=ISF(I,ISSF)
               NPT=MIN0(MAXPT,NPT+1)
               IVL(I,IND)=IPP
               IVL(I+4,IND)=NPT
               PTX(NPT)=PTX(IPP)+DX
               PTY(NPT)=PTY(IPP)+DY
               PTZ(NPT)=PTZ(IPP)+DZ
            ENDDO
         ELSEIF(MSFI.EQ.8)THEN
            MVL(IND)=20
            DO I=1,4
               IPP=ISF(I,ISSF)
               NPT=MIN0(MAXPT,NPT+1)
               IVL(I,IND)=IPP
               IVL(I+4,IND)=NPT
               PTX(NPT)=PTX(IPP)+DX
               PTY(NPT)=PTY(IPP)+DY
               PTZ(NPT)=PTZ(IPP)+DZ
               NPT=MIN0(MAXPT,NPT+1)
               IVL(I+16,IND)=NPT
               PTX(NPT)=PTX(IPP)+DX/2
               PTY(NPT)=PTY(IPP)+DY/2
               PTZ(NPT)=PTZ(IPP)+DZ/2
               IPP=ISF(I+4,ISSF)
               NPT=MIN0(MAXPT,NPT+1)
               IVL(I+8,IND)=IPP
               IVL(I+12,IND)=NPT
               PTX(NPT)=PTX(IPP)+DX
               PTY(NPT)=PTY(IPP)+DY
               PTZ(NPT)=PTZ(IPP)+DZ
            ENDDO
         ENDIF
         CALL PLOTVL(IND,1,KVL)
         CALL GENSFVL(IND)
      ENDIF
      END

      SUBROUTINE VLSF(IS1,IS2,IND)
C Generovani objemu ze dvou protilehlych ploch
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEM'
      IF(IND.GT.0.AND.IND.LE.MAXVL.AND.IS1.GT.0.AND.IS1.LE.NSF.AND.
     /   IS2.GT.0.AND.IS2.LE.NSF)THEN
         II=SETACTIVEQQ(20)
         NVL=MAX0(NVL,IND)
         MSF1=MSF(IS1)
         MSF2=MSF(IS2)
         IF(MSF1.EQ.4.AND.MSF2.EQ.4)THEN
            MVL(IND)=8
            DO I=1,4
               IVL(I,IND)  =ISF(I,IS1)
               IVL(I+4,IND)=ISF(I,IS2)
            ENDDO
            CALL GENSFVL(IND)
         ELSEIF(MSF1.EQ.8.AND.MSF2.EQ.8)THEN
            MVL(IND)=20
            DO I=1,4
               IVL(I,IND)  =ISF(I,IS1)
               IVL(I+4,IND)=ISF(I,IS2)
               IVL(I+8,IND)=ISF(I+4,IS1)
               IVL(I+12,IND)=ISF(I+4,IS2)
            ENDDO
            DO I=1,4
               IP1=ISF(I,IS1)
               IP2=ISF(I,IS2)
               NPT=MIN0(NPT+1,MAXPT)
               IVL(I+16,IND)=NPT
               PTX(NPT)=(PTX(IP1)+PTX(IP2))/2.
               PTY(NPT)=(PTY(IP1)+PTY(IP2))/2.
               PTZ(NPT)=(PTZ(IP1)+PTZ(IP2))/2.
            ENDDO
            CALL GENSFVL(IND)
         ELSE
            CALL HELPC(4,'Incompatible surfaces')
         ENDIF
      ENDIF
      END

      SUBROUTINE GENSFVL(IND)
C Generovani 6-ti ploch z sestistenu a komprese vytvorenych ploch
      INCLUDE '$FEM'
      DIMENSION LSF4(4,6),LSF8(8,6)
      DATA LSF4/1,2,3,4,5,6,7,8,1,2,6,5,2,3,7,6,3,4,8,7,4,1,5,8/
      DATA LSF8/1,2,3,4,9,10,11,12,5,6,7,8,13,14,15,16,
     /          1,2,6,5,9,18,13,17,2,3,7,6,10,19,14,18,
     /          3,4,8,7,11,20,15,19,4,1,5,8,12,17,16,20/
      MVLIND=MVL(IND)
      DO IS=1,6
        NSF=MIN0(MAXSF,NSF+1)
        IF(MVLIND.EQ.8)THEN
          MSF(NSF)=4
          DO I=1,4
            ISF(I,NSF)=IVL(LSF4(I,IS),IND)
          ENDDO
        ELSE
          MSF(NSF)=8
          DO I=1,8
            ISF(I,NSF)=IVL(LSF8(I,IS),IND)
          ENDDO
        ENDIF
      ENDDO
      CALL SFCOMP
      END

      SUBROUTINE SFCRID(IS,IC1,IC2,IC3,IC4)
C Nalezeni krivek, ktere tvori strany plochy
      INCLUDE '$FEM'
      IC1=0
      IC2=0
      IC3=0
      IC4=0
      IF(IS.GT.0.AND.IS.LE.NSF)THEN
         CALL P2ONCS(ISF(1,IS),ISF(2,IS),IC1)
         CALL P2ONCS(ISF(2,IS),ISF(3,IS),IC2)
         NP=MSF(IS)
         IF(NP.EQ.4.OR.NP.EQ.8)THEN
           CALL P2ONCS(ISF(3,IS),ISF(4,IS),IC3)
           CALL P2ONCS(ISF(4,IS),ISF(1,IS),IC4)
         ELSE
           CALL P2ONCS(ISF(3,IS),ISF(1,IS),IC3)
         ENDIF
      ENDIF
      END

      SUBROUTINE FNCR(ICURVE,IN,XP,YP,ZP)
C
C Vypocet souradnic uzlu XP,YP,ZP cislo IN na krivce ICURVE 
C Parametry sitovani NX a FLAFI ze zony $FEM
C
      DIMENSION XA(200),RX(3)
      INCLUDE '$FEM' 
      DATA RX /-1.,1.,0./
      NPCURVE=MCR(ICURVE)
C Doplneni bodu krivky ICURVE dle NXCR a FLAFI
      NODES=MAX0(3,NXCR(ICURVE))
      AX=FLAFI(ICURVE)
      IF(AX.EQ.0.)AX=1.
      CALL FEMDIV(-1.,1.,XA,NODES-1,AX)
      XP=0
      YP=0
      ZP=0
      DO I=1,NPCURVE
         ZX=XA(IN)*RX(I)
         IF(NPCURVE.EQ.2)THEN
             BI=(1+ZX)/2.
         ELSEIF(I.LE.2)THEN
             BI=(1+ZX)*ZX/2.
         ELSE
             BI=1-XA(IN)**2
         ENDIF
         IND=ICR(I,ICURVE)
         XP=XP+PTX(IND)*BI
         YP=YP+PTY(IND)*BI
         ZP=ZP+PTZ(IND)*BI
      ENDDO
      END

