C $S11-MOD.FOR
      SUBROUTINE READMOD(IM)
C IM - index modelu, cteneho ze souboru MODFILE(im)
C --------------------------------priklad 
C Serie idealnich misicu.
C \\ini
C neq=n
C \\mod
C dcm(1)=xv(1)
C for i=2,neq do
C dcm(i)=rp(1)*(cm(i-1)-cm(i))
C yv(1)=cm(neq)
C \\par
C idenum=1234 method=1 inp=1 out=1 npar=1
C x1=3 y1=4
C prvni parametr: rp(1)  default=123 min=-12 max=500 relax=0.3
C ---------------------------------konec prikladu
      INCLUDE '$FEMLOC'
      CHARACTER *(MAXATR*8) NAMES
	INCLUDE '$TRANDAT'
	INCLUDE '$RPN'
      CHARACTER *(LENLIN)LINE,ITEM, CH3*3
      DIMENSION LSBEG(4),LSEND(4)
      EQUIVALENCE (NAME,NAMES)

      IF(IM.LE.0.OR.IM.GT.NMODELS)GOTO 999
      IMODELA=IM
      OPEN(3,FILE='.\FILES\'//MODFILE(IM))
      LOC=0
      NUMLINES=1
      LINESRPN(1)=0
      LSBEG(1)=0
C Sekce popis (ukoncena //INI), inicializace (ukoncena //MOD), 
C       vypocet (ukoncena //PAR), pak nasleduji parametry
      DO IS=1,3
 1      READ(3,'(A)',END=100)LINE
        LLIN=LEN(TRIM(LINE))
        CALL TUPC(LLIN,LINE,LINE)
        LEND=LOC+LLIN+1
        IF(LEND.GT.LENMODEL)THEN
           CALL HELPC(6,'Text of model is too long...')
           GOTO 1000
        ENDIF
        NUMLINES=NUMLINES+1
        LINESRPN(NUMLINES)=LEND
        MODTXT(LOC+1:LEND)=TRIM(LINE)//' '
        IF(LINE(1:2).NE.'\\')THEN
           LOC=LEND
           GOTO 1
        ENDIF
100     LSEND(IS)=LOC
        LSBEG(IS+1)=LEND
        LOC=LEND
      ENDDO
C Preklad inicializacni sekce, prekopirovani atributu do pomocne zony
      DO I=1,NVARSYS
         IATTW(1,I)=IATTR(1,I)
         IATTW(2,I)=IATTR(2,I)
      ENDDO
      CALL TRANSQ(MODTXT,LSEND(2),LSBEG(2),NAMES,IATTW,8,NVARSYS,
     /     LOCMODCON-1,MAXATR,LOCMVAL-1,MAXMRPN, 
     /     LASTVAR,LASTCON,MIRPN, IAUX,MODRPN,IEND)
      IF(IEND.LT.0.OR.IEND+1.NE.LSEND(2))THEN
           CALL HELPC(6,'Syntax error in INI section')
           WRITE(9 ,'('' INI section error. Code length='',i4,''. Correc
     /tly translated only'',i4,'' of'',i4,'' characters.''/'' Please loo
     /k at the text: Capitals denote correctly translated part.'')')
     /MIRPN,IEND-LSBEG(2),LSEND(2)-LSBEG(2)-1
      ELSE
           WRITE(9 ,'('' INI section translated. Code length='',i4,''. C
     /orrectly translated all'',i4,'' characters of text.'')')
     /MIRPN,IEND-LSBEG(2)
      ENDIF
C Preklad vykone sekce
      IF(LSEND(3).GT.LSBEG(3))THEN
        CALL TRANSQ(MODTXT,LSEND(3),LSBEG(3),NAMES,IATTW,8,LASTVAR,
     /     LASTCON,MAXATR,LOCMVAL-1,MAXMRPN-MIRPN, 
     /     NVARTOT,KLST,MMRPN, IAUX,MODRPN(MIRPN+1),IEND)
C          names   const lenRPN Vars   RPN
        IF(IEND.LT.0.OR.IEND+1.NE.LSEND(3))THEN
           CALL HELPC(6,'Syntax error in MOD section')
           WRITE(9 ,'('' MOD section error. Code length='',i4,''. Correc
     /tly translated only'',i4,'' of'',i4,'' characters.''/'' Please loo
     /k at the text: Capitals denote correctly translated part.'')')
     /MMRPN,IEND-LSBEG(3),LSEND(3)-LSBEG(3)-1
        ELSE
           WRITE(9 ,'('' MOD section translated. Code length='',i4,''. C
     /orrectly translated all'',i4,'' characters of text.'')')
     /MMRPN,IEND-LSBEG(3)
        ENDIF
      ELSE
           CALL HELPC(6,'Model section is missing')
           MMRPN=0
      ENDIF
C Cteni a dekodovani parametru
C Prvni radek dat: IDENUM=x METHOD=x NEQ=x NPAR=x INP=x OUT=x
      IDENUM=0
      METHOD=0
      NEQUAT=0
      NUMODP=0
      NINPUTS=0
      NOUTPUTS=0
      READ(3,'(A)',END=1000)LINE
      LLIN=LEN(TRIM(LINE))
      CALL TUPC(LLIN,LINE,LINE)
      CALL TAKISD(LINE,LLIN,INDEX(LINE,'IDENUM=')+6,IDENUM,K)
      CALL TAKISD(LINE,LLIN,INDEX(LINE,'METHOD=')+6,METHOD,K)
      CALL TAKISD(LINE,LLIN,INDEX(LINE,'NEQ=')+3,NEQUAT,K)
      CALL TAKISD(LINE,LLIN,INDEX(LINE,'NPAR=')+4,NUMODP,K)
      CALL TAKISD(LINE,LLIN,INDEX(LINE,'INP=')+3,NINPUTS,K)
      CALL TAKISD(LINE,LLIN,INDEX(LINE,'OUT=')+3,NOUTPUTS,K)
C Druhy radek dat parametru: X1=x X2=x ...     Y1=x Y2=x...
C pouze kdyz NINPUTS+NOUTPUTS>0
      IF(NINPUTS+NOUTPUTS.GT.0)THEN
         READ(3,'(A)',END=1000)LINE
         LLIN=LEN(TRIM(LINE))
         CALL TUPC(LLIN,LINE,LINE)
         DO I=1,NINPUTS
            WRITE(CH3,'(''X'',I1,''='')')I
            CALL TAKISD(LINE,LLIN,INDEX(LINE,CH3)+2,MINPUTS(I),K)
            IG=MINPUTS(I)
            IF(IG.GT.1.AND.IG.LE.MAXSEL)THEN
               IF(IQGR(IG).LE.0)IQGR(IG)=4
               IF(NGR.LE.0)NGR=NTSTEP
            ELSE
               WRITE(9 ,'('' Index of input'',i3,'' should be >1'')')IG
            ENDIF
         ENDDO
         DO I=1,NOUTPUTS
            WRITE(CH3,'(''Y'',I1,''='')')I
            CALL TAKISD(LINE,LLIN,INDEX(LINE,CH3)+2,MOUTPUTS(I),K)
            IG=MOUTPUTS(I)
            IF(IG.GT.1.AND.IG.LE.MAXSEL)THEN
               IF(IQGR(IG).LE.0)IQGR(IG)=5
               IF(NGR.LE.0)NGR=NTSTEP
            ELSE
               WRITE(9 ,'('' Index of output'',i3,'' should be >1'')')IG
            ENDIF
         ENDDO
      ENDIF
C popis parametru modelu
      DO I=1,NUMODP
         READ(3,'(A)',END=1000)LINE
         LTEXT=INDEX(LINE,':')
         IF(LTEXT.GT.1)MODPARTXT(I)=LINE(1:LTEXT-1)
         ITEM=LINE(LTEXT+1:LENLIN)
         LITM=LEN(TRIM(ITEM))
         CALL TUPC(LITM,ITEM,ITEM)
         LINE=' '
         CALL SELITE(ITEM,0,LINE,K)
         LLIN=LEN(TRIM(LINE))
         VARTXT(I)=TRIM(LINE)
         CALL TRAN(LINE,LLIN,0,ICRPN,MAXCRPN,NRPN,IEND)
         CALL LOVARI(ICRPN,NRPN,LMODEL(I),JMODEL(I))
         CALL TAKERD(ITEM,LITM,INDEX(ITEM,'MIN=')+3,ZMINP(I),K)
         CALL TAKERD(ITEM,LITM,INDEX(ITEM,'MAX=')+3,ZMAXP(I),K)
         CALL TAKERD(ITEM,LITM,INDEX(ITEM,'RELFAKT=')+7,RMODEL(I),K)
         CALL TAKISD(ITEM,LITM,INDEX(ITEM,'REGRES=')+6,KMODEL(I),K)
         IDEFAULT=INDEX(ITEM,'DEFAULT=')
         IF(IDEFAULT.GT.0.AND.JMODEL(I).EQ.1.AND.LMODEL(I).GT.0)THEN
            CALL TAKERD(ITEM,LITM,IDEFAULT+7,REALRC(LMODEL(I)),K)
         ELSEIF(IDEFAULT.GT.0.AND.JMODEL(I).EQ.2.AND.LMODEL(I).GT.0)THEN
            CALL TAKISD(ITEM,LITM,IDEFAULT+7,INTERC(LMODEL(I)),K)
         ENDIF
      ENDDO
1000  CLOSE(3)
      IF(NUMLINES.LE.1)CALL HELPC(6,'Empty model definition file')
      RETURN
999   CALL HELPC(6,'Model is not defined')
      END

      SUBROUTINE PALIST(IUN)
C Vypis tabulky parametru modelu na zarizeni c. IUN
      INCLUDE '$FEMLOC'
      CHARACTER*4 TYPEVAR(3)
      DATA TYPEVAR /'Und.','Real','Intg'/
      WRITE(IUN,*)
      WRITE(IUN,'('' No. Variable    Value       Min      Max  Regr Rela
     /x'')')
      DO I=1,NUMODP
         IF(JMODEL(I).EQ.1)THEN
            CISLO=REALRC(LMODEL(I))
         ELSEIF(JMODEL(I).EQ.2)THEN
            CISLO=INTERC(LMODEL(I))
         ENDIF
         WRITE(IUN,'(i3,1x,a,1x,a6,ES10.3,2ES9.2,i2,F5.2)')
     /            I,TYPEVAR(JMODEL(I)+1),VARTXT(I),CISLO,
     /            ZMINP(I),ZMAXP(I),KMODEL(I),RMODEL(I)
      ENDDO
      END

	SUBROUTINE DMODLIST(INDMODEL)
C Vypise text modelu na zarizeni 9
      LOGICAL OPE
	CHARACTER*60 LINE
	IF(INDMODEL.LE.2)THEN
	   CALL MODLIST
      ELSEIF(INDMODEL.EQ.7)THEN
         INQUIRE(UNIT=7,OPENED=OPE)
	   IF(OPE)THEN
	      REWIND 7
	      WRITE(9,'(/'' Listing of model opened on unit 7'')')
	      DO WHILE(.TRUE.)
	         READ(7,10,END=999)LINE
	         WRITE(9,11)LINE
10             FORMAT(A60)
11             FORMAT(3X,A60)
	      ENDDO
999         REWIND 7
         ENDIF
	ENDIF
	END

      SUBROUTINE MODLIST
C Vypis aktivniho modelu a zobrazeni schematu
      INCLUDE '$FEMLOC'
      IF(IMODELA.GT.0.AND.IMODELA.LE.NMODELS)THEN
      WRITE(9,'(/1X,30(''-''),''MODLIS''/'' Active model '',A,''('',I3,'
     /') IDEnumber='',i7)')MODKWD(IMODELA),IMODELA,IDENUM
      DO I=1,NUMLINES-1
         WRITE(9,'(1X,A)')MODTXT(LINESRPN(I)+1:LINESRPN(I+1))
      ENDDO
      IF(MODKWD(IMODELA)(3:4).EQ.'  ')THEN
	   WRITE(10,'('' Less than 3-letters keyword-list suppressed.'')')
	   RETURN
	ENDIF
      WRITE(9,'('' NPAR='',I2,'' NEQ='',I3,'' METHOD='',I2,'' INP='',I2,
     /'' OUT='',I2)')NUMODP,NEQUAT,METHOD,NINPUTS,NOUTPUTS
      WRITE(9,'('' INPUTS :'',5I10)')(MINPUTS(I),I=1,NINPUTS)
      WRITE(9,'('' OUTPUTS:'',5I10)')(MOUTPUTS(I),I=1,NOUTPUTS)
      WRITE(9,'('' Par.Name[   Min   ,  Value ,   Max  ] Regr,Rel.'')')
      DO I=1,NUMODP
        CALL GETPAR(I,VALDEF,IVALDEF,IR)
        IF(IR.EQ.1)THEN
          WRITE(9,'(I3,1X,A,''['',3E9.2,'']'',I3,F5.2)')
     /  I,TRIM(VARTXT(I)),ZMINP(I),VALDEF,ZMAXP(I),KMODEL(I),RMODEL(I)
        ELSEIF(IR.EQ.2)THEN
          WRITE(9,'(I3,1X,A,''['',E9.2,I9,E9.2,'']'',I3)')
     /  I,TRIM(VARTXT(I)),ZMINP(I),IVALDEF,ZMAXP(I),KMODEL(I)
        ENDIF
      ENDDO
C IDENUM ttaan2n1
C Rozkodovani
      IDECODE=MAX0(0,IDENUM)
      LN1=MOD(IDECODE,100)
      IDECODE=IDECODE/100
      LN2=MOD(IDECODE,100)
      IDECODE=IDECODE/100
      LAV=MOD(IDECODE,100)
      IDECODE=IDECODE/100
      ITYP=MOD(IDECODE,10)
      ITYPG=IDECODE/10
      IF(ITYPG.LE.9)THEN
         CALL GETPAR(LN1,RN1,N1,IR)
         CALL GETPAR(LN2,RN2,N2,IR)
         CALL GETPAR(LAV,VREL,IVREL,IR)
         CALL PLOTMOD(IDENUM,ITYP,ITYPG,N1,N2,VREL)
      ENDIF
      ELSE
         WRITE(10,'('' No RTD model has been activated'')')
      ENDIF
      END

      SUBROUTINE PUTPAR(I,RVALUE)
C Vezme hodnoty I-teho parametru modelu a ulozi ji tam,
C kam ukazuje LMODEL (lokator parametru modelu). RVALUE je
C vzdy typu real, pokud je misto urceni integer, provadi se
C zaokrouhledni a prevod
      INCLUDE '$FEMLOC'
      IF(I.GE.1.AND.I.LE.NUMODP)THEN
        LOC=LMODEL(I)
        IR=JMODEL(I)
        IF(IR.EQ.1)THEN
            REALRC(LOC)=RVALUE
        ELSE
            INTERC(LOC)=RVALUE+.5
        ENDIF
      ENDIF
      END

      SUBROUTINE GETPAR(I,RVALUE,IVALUE,IR)
C Stanoveni hodnoty I-teho parametru modelu (i=1,...,NUMODP)
C RVALUE - aktualni realna hodnota
C IVALUE - aktualni celociselna hodnota
C IR     - =1 real, =2 integer
      INCLUDE '$FEMLOC'
      IR=0
      IF(I.GE.1.AND.I.LE.NUMODP)THEN
        IR=JMODEL(I)
        IF(IR.EQ.1)THEN
          IF(LMODEL(I).GT.0)THEN
            RVALUE=REALRC(LMODEL(I))
          ELSE
            RVALUE=PMODEL(I)
          ENDIF
          IVALUE=RVALUE
        ELSEIF(IR.EQ.2)THEN
          IF(LMODEL(I).GT.0)THEN
            IVALUE=INTERC(LMODEL(I))
          ELSE
            IVALUE=IFIX(PMODEL(I)+.5)
          ENDIF
          RVALUE=IVALUE
        ENDIF
      ENDIF
      END

      SUBROUTINE TCDEV
C Vypocet odchylek TC Krivek dle zvoleneho kriteria 
      INCLUDE '$FEM'
      REAL*8 DSUMSQ
      DSUMSQ=0.
      IF(NCOMPAR.LE.0.OR.NCOMPAR.GT.MAXSEL/2.OR.ICOMP1.LE.0.OR.
     /   ICOMP2.LT.ICOMP1)RETURN
      DO IC=1,NCOMPAR
         DO I=ICOMP1,ICOMP2
            IC1=ICOMPAR(1,IC)
            IC2=ICOMPAR(2,IC)
            IF(IC1.LE.0.OR.IC2.LE.0)RETURN
            Y1=YGR(I,IC1)
            Y2=YGR(I,IC2)
            IF(ICOMPAR(3,IC).LE.0)THEN
               W=1
            ELSE
               W=YGR(I,ICOMPAR(3,IC))
            ENDIF
            IF(KCOMPAR.GT.3)THEN
               IF(I.LT.ICOMP2)THEN
                  W=W*(YGR(I+1,1)-YGR(I,1))
               ELSE
                  W=0
               ENDIF
            ENDIF
            SELECT CASE(KCOMPAR)
            CASE(0,4)
               DSUMSQ=DSUMSQ+ABS(Y1-Y2)*W
            CASE(1,5)
               DSUMSQ=DSUMSQ+ABS(Y1-Y2)/AMAX1(1E-10,ABS(Y1),ABS(Y2))*W
            CASE(2,6)
               DSUMSQ=DSUMSQ+(Y1-Y2)**2*W
            CASE(3,7)
               DSUMSQ=DSUMSQ+((Y1-Y2)/AMAX1(1E-10,ABS(Y1),ABS(Y2)))**2*W
            END SELECT
         ENDDO
      ENDDO
      NPOINTS=(ICOMP2-ICOMP1+1)*NCOMPAR
      SELECT CASE(KCOMPAR)
      CASE(0,1)
         SUMSQ=DSUMSQ/NPOINTS
      CASE(2,3)
         SUMSQ=DSQRT(DSUMSQ/NPOINTS)
      CASE(4,5)
         SUMSQ=DSUMSQ
      CASE(6,7)
         SUMSQ=DSQRT(DSUMSQ)
      END SELECT
      SCOMPAR=SUMSQ
      END


      SUBROUTINE SMOOTH(N,T,Y,C,ISMOOTH)
C Vyhlazeni neekvidistantni krivky spliny (ze 4 sousednich bodu).
C ISMOOTH =0  linearni spliny
C         >0  kvadraticke spliny
C         <0  median 
C Vektory Y a C mohou byt totozne (vyhlazeni na miste).
      DIMENSION T(*),Y(*),C(*),YS(40)
      NSAV=MIN0(40,MAX0(1,IABS(ISMOOTH))+1)
      YS(NSAV)=Y(2)
      YS(NSAV-1)=Y(1)
      C(1)=Y(1)
      C(2)=Y(2)
      DO I=2,N-2
        DT=T(I+1)-T(I)
C Linearni spliny NSAV=2. 
        IF(ISMOOTH.EQ.0)THEN
          SC=0
          SJ=0
          J1=MAX0(1,I-NSAV+1)
          J2=MIN0(N,I+NSAV)
          DO J=J1,J2
             IF(J.LE.I)THEN
                YJ=YS(NSAV+J-I)
             ELSE
                YJ=Y(J)
             ENDIF
             SC=SC+(YJ-C(I)*(T(I+1)-T(J))/DT)*(T(J)-T(I))/DT
             SJ=SJ+((T(J)-T(I))/DT)**2
          ENDDO
          DO K=1,NSAV-1
             YS(K)=YS(K+1)
          ENDDO
          YS(NSAV)=Y(I+1)
          C(I+1)=SC/SJ
        ELSEIF(ISMOOTH.GE.1)THEN
C Kvadraticke spliny. Pocitam C(I+1) jako hodnotu kvadraticke
C funkce, ktera prochazi bodem C(I) a ma nejmensi ctverec odchylek od
C bodu I+2,...,I+NSAV a I-2,...,I-NSAV+1 (tj. NSAV-1=ISMOOTH dalsich bodu 
C vpravo i vlevo.
          A2=0
          A3=0
          A4=0
          B1=0
          B2=0
          J1=MAX0(1,I-NSAV+1)
          J2=MIN0(N,I+NSAV)
          DO J=J1,J2
             IF(J.LE.I)THEN
                YJ=YS(NSAV+J-I)
             ELSE
                YJ=Y(J)
             ENDIF
             DT=T(J)-T(I)
             A2=A2+DT*DT
             A3=A3+DT**3
             A4=A4+DT**4
             B1=B1+DT*(YJ-C(I))
             B2=B2+DT*DT*(YJ-C(I))
          ENDDO
          DET=A2*A4-A3*A3
          DT=T(I+1)-T(I)
          DO K=1,NSAV-1
             YS(K)=YS(K+1)
          ENDDO
          YS(NSAV)=Y(I+1)
          C(I+1)=C(I)+((B1*A4-B2*A3)*DT+(A2*B2-A3*B1)*DT*DT)/DET
        ELSE
C MEDIAN - posloupnosti 2*NSVA+1 hodnot nahrazuje hodnotu C(i+1)
C C(I-NSAV+1),...,C(I-1),C(I),     C(I+1), C(I+2),...,C(I+NSAV),C(I+1+NSAV)
C YS(1),...   YS(NSAV-1),YS(NSAV), Y(I+1),  ...,  nsav  hodnot vpravo
          J1=MAX0(1,I-NSAV+1)
          J2=MIN0(N,I+NSAV+1)
          NVALUES=J2-J1+1
          MEDIAN=NVALUES/2+1
          DO J=J1,J2
C zjisteni, kolik prvku posloupnosti je vetsich nez Y(j)
            IF(J.LE.I)THEN
               YJ=YS(NSAV-I+J)
            ELSE
               YJ=Y(J)
            ENDIF
            NGT=0
            DO K=J1,J2
C porovnani s prvkem K
               IF(K.LE.I)THEN
                  YK=YS(NSAV-I+K)
               ELSE
                  YK=Y(K)
               ENDIF
               IF(YK.GE.YJ)NGT=NGT+1
            ENDDO
            IF(NGT.EQ.MEDIAN)THEN
                RMEDIAN=YJ
                EXIT
            ENDIF
          ENDDO
          DO K=1,NSAV-1
             YS(K)=YS(K+1)
          ENDDO
          YS(NSAV)=Y(I+1)
          C(I+1)=RMEDIAN
        ENDIF
      ENDDO
      C(N)=Y(N)
      END

      SUBROUTINE RNMOM(T,C,NC,V)
C Plocha, 1. a 2. moment pro neekvidistantni data (t,c) V1,V2,V3
C a dale teziste tmean=V4 a variance V5
C V6 - iteracne stanovena hodnota ekvivalentniho poctu misicu pocitana
C ze shody vazenych momentu.
      DIMENSION T(*),C(*),V(*)
      DOUBLE PRECISION T1,T2,C1,C2
      RM0=0.
      RM1=0.
      RM2=0.
      DO I=1,NC-1
        T1=T(I)
        T2=T(I+1)
        C1=C(I)
        C2=C(I+1)
C Oprava 20.2.2008
        IF(T1.GT.T2)EXIT
        RM0=RM0+(C1+C2)*(T2-T1)/2.
        RM1=RM1+(C1*(T2**2+T1*T2-2.*T1**2)-C2*(T1**2+T1*T2-2.*T2**2))/6.
        RM2=RM2+C1*(T2**3-T1**3)/3.+(C2-C1)*((T2**2+T1**2)*(T1+T2)/4.-
     /    T1*(T2**2+T1*T2+T1**2)/3.)
      ENDDO
      V(1)=RM0
      V(2)=RM1
      V(3)=RM2
      IF(RM0.LE.0.)THEN
         CALL HELPC(5,'Zero area of TC')
      ELSE
         V(4)=RM1/RM0
         V(5)=RM2/RM0-V(4)**2
         RM2=0.
         TM=V(4)
         S=1/TM
         DO I=1,NC-1
            T1=T(I)
            T2=T(I+1)
            C1=C(I)
            C2=C(I+1)
            IF(T1.GT.T2)EXIT
            RM2=RM2+((T2-TM)**2*C1*EXP(-S*T1)+(T1-TM)**2*C2*EXP(-S*T2))*
     /               (T2-T1)/(2*RM0)
         ENDDO
         RN=TM**2/RM2
         SN=0.
         DO WHILE(ABS(RN-SN).GT.0.01)
            SN=RN
            RN=TM**2/RM2*(1+(S*TM)**2/SN)/(1.+S*TM/SN)**(SN+2)
         ENDDO
         V(6)=RN
      ENDIF
      END

      SUBROUTINE RSMOM(T,C,NC,A,TM)
C Simplified  version of moments calculation
      DIMENSION T(*),C(*)
	A=0
	TT=0
      DO I=1,NC-1
        T1=T(I)
        T2=T(I+1)
        C1=C(I)
        C2=C(I+1)
        A=A+(T2-T1)*(C1+C2)/2.
	  TT=TT+(T2-T1)*(C1+C2)*(T1+T2)/4.
	ENDDO
	IF(A.GT.0.)THEN
	  TM=TT/A
      ELSE
	  TM=0.
	ENDIF
	END

      SUBROUTINE RFMOM(DT,C,NC,NMR,V)
C Plocha, 1. a 2. moment pro ekvidistantni data (c) V1,V2,V3
C a dale teziste tmean=V4 a variance V5
C Na rozdil od procedury RNMOM se uvazuje zrcadleni pocinajici bodem NMR,
C tj. prubeh funkce pocinajici bodem NMR se posunuje o periodu DTxNC vlevo,
C tudiz do zapornych hodnot casu.
      DIMENSION C(*),V(*)
      RM0=0.
      RM1=0.
      RM2=0.
      DO I=1,NC
        IF(I.LE.NMR)THEN
           T=(I-1)*DT
        ELSE
           T=(I-1-NC)*DT
        ENDIF
        RM0=RM0+C(I)
        RM1=RM1+C(I)*T
        RM2=RM2+C(I)*T**2
      ENDDO
      V(1)=RM0*DT
      V(2)=RM1*DT
      V(3)=RM2*DT
      IF(RM0.LE.0.)THEN
         CALL HELPC(5,'Zero area of TC')
      ELSE
         V(4)=RM1/RM0
         V(5)=RM2/RM0-V(4)**2
      ENDIF
      END

      SUBROUTINE RNORM(ICT,T,C,NC,V)
C ICT=0 normalizace na plochu
C    =1             na plochu i prvni moment
      DIMENSION T(*),C(*),V(*)
      CALL RNMOM(T,C,NC,V)
      IF(V(1).NE.0..AND.V(4).NE.0.)THEN
         IF(ICT.EQ.0)THEN
            DO1I=1,NC
1           C(I)=C(I)/V(1)
         ELSE
            DO2I=1,NC
            C(I)=C(I)*V(4)/V(1)
2           T(I)=T(I)/V(4)
         ENDIF
      ENDIF
      END

      SUBROUTINE RCMIDM(T,C,NC,DT,PMIX,TMEAN)
C Odezva serie PMIX-idealnich misicu se zadanou stredni dobou TMEAN
      DIMENSION T(NC),C(NC)
      IF(TMEAN.GT.0.)THEN
        IF(PMIX.EQ.1.)THEN
           C(1)=1./TMEAN
        ELSE
           C(1)=0.
        ENDIF
        T(1)=0
        CON=EXP(PMIX*LOG(PMIX)-LOG(TMEAN)-GAMMLN(PMIX))
        DO I=2,NC
           T(I)=T(I-1)+DT
           TM=T(I)/TMEAN
           C(I)=CON*TM**(PMIX-1.)*EXP(-PMIX*TM)
        ENDDO
      ELSE
        CALL HELPC(5,'Zero mean time')
      ENDIF
      END

      SUBROUTINE RCMPAS(T,C,NC,DT,PM1,PM2,F,ALFA,TMEAN)
C  Paralelni serie IDM
C  Bishoff, Mc Cranken Ind.Eng.Chem. 18, 58 (1966)
C  PM1-M, MP2-N pocet IDM ve vetvi 1 a 2, F=Q1/Q, ALFA=T2/T1
      DIMENSION T(*),C(*)
      IF(ALFA.GT.0..AND.TMEAN.GT.0..AND.PM1.GT.0..AND.PM2.GT.0.)THEN
        C(1)=0.
        T(1)=0
        BETA=F+ALFA*(1-F)
        BA=BETA/ALFA
        C1=F/TMEAN*EXP(PM1*LOG(PM1*BETA)-GAMMLN(PM1))
        C2=(1-F)/TMEAN*EXP(PM2*LOG(PM2*BA)-GAMMLN(PM2))
        DO I=2,NC
          T(I)=T(I-1)+DT
          TM=T(I)/TMEAN
        C(I)=C1*TM**(PM1-1)*EXP(-PM1*BETA*TM)+C2*TM**(PM2-1)*
     /     EXP(-PM2*BA*TM)
        ENDDO
      ELSE
        CALL HELPC(5,'Zero mean time or model parameters N1,N2')
      ENDIF
      END

      FUNCTION GAMMLN(XX)
C GAMMA FUNCTION NUMERICAL RECIPES P.157
      REAL*8 COF(6),STP,HALF,ONE,FPF,X,TMP,SER
      DATA COF,STP/76.18009173D0,-86.50532033D0,24.01409822D0,
     /     -1.231739516D0,.120858003D-2,-0.536382D-5,2.50662827465D0/
      DATA HALF,ONE,FPF/0.5D0,1.0D0,5.5D0/
      X=XX-ONE
      TMP=X+FPF
      TMP=(X+HALF)*LOG(TMP)-TMP
      SER=ONE
      DO J=1,6
         X=X+ONE
         SER=SER+COF(J)/X
      ENDDO
      GAMMLN=TMP+LOG(STP*SER)
      END

      SUBROUTINE TCOPY(I1,I2)
      INCLUDE '$FEM'
      DO I=1,NGR
         YGR(I,I2)=YGR(I,I1)
      ENDDO
      IQGR(I2)=IQGR(I1)
      INDG(I2)=INDG(I1)
      FILEXPERI(I2)=FILEXPERI(I1)
      END

      SUBROUTINE RCRND(N,Y,C,STD,ICT)
      DIMENSION Y(*),C(*)
      DO I=1,N
        S=RNDG(IDUMMY)*STD
        IF(ICT.EQ.0)THEN
           C(I)=Y(I)+S
        ELSE
           C(I)=Y(I)*(1.+S)
        ENDIF
      ENDDO
      END

      SUBROUTINE TCDELAY(T,X,Y,N,DT)
C Posunuti v case o DT. Vektory X (vstup), Y (posunuta data) nesmi byt totozne
      DIMENSION T(*),X(*),Y(*)
      DO I=1,N
         Y(I)=0
         TNEW=T(I)-DT
         IF(TNEW.GT.T(1))THEN
           DO J=2,N
              IF(T(J).GE.TNEW.AND.T(J).NE.T(J-1))THEN
                 Y(I)=X(J-1)+(TNEW-T(J-1))*(X(J)-X(J-1))/(T(J)-T(J-1))
                 EXIT
              ENDIF
           ENDDO
         ENDIF
      ENDDO
      END

      SUBROUTINE TCONDT(T,X,Y,N,NEW,DT)
C Neekvidistantni data T1,X1,...,TN,XN jsou interpolovana na ekvidistantni
C data Y1,...,Ynew s konstantnim casovym krokem DT. Prvni casovy udaj T1,
C je povazovan za pocatek nove casove skaly (T=0), tudiz Y1=X1.
C Pocet novych kroku NEW i casovy krok DT je treba zadavat.
      DIMENSION T(*),X(*),Y(*)
      Y(1)=X(1)
      T0=T(1)
      DO I=2,NEW
         TNEW=(I-1)*DT
         Y(I)=0
         DO J=2,N
            T1=T(J-1)-T0
            T2=T(J)-T0
            IF(TNEW.GE.T1.AND.TNEW.LE.T2.AND.T1.NE.T2)THEN
                Y(I)=X(J-1)+(TNEW-T1)*(X(J)-X(J-1))/(T2-T1)
                EXIT
            ENDIF
         ENDDO
      ENDDO
      END

      SUBROUTINE LGRRD(A,AT,SQE,N,R,RD)
C Laguerrovy funkce a jejich derivace
      DIMENSION R(N),RD(N)
      R(1)=SQE
      R(2)=SQE*(1.-AT)
C Laguerrovy funkce L(a,t), zadava se AT= a.t SQE=s qrt(a).exp(-a.t/2)
      RD(1)=R(1)*(-A/2.)
      RD(2)=RD(1)+RD(1)*A
C Rekurence WHITE a ANDERSEN
      DO IB=1,N-2
        R(IB+2)=((2*IB+1-AT)*R(IB+1)-IB*R(IB))/(IB+1)
        RD(IB+2)=(-A*R(IB+1)+(2.*IB+1-AT)*RD(IB+1)-IB*RD(IB))/(IB+1) 
	ENDDO
      END

      SUBROUTINE LGRR(AT,SQE,N,R)
C Laguerrovy funkce L(a,t); zadava se AT=a.t
C SQE=sqrt(a).exp(-at/2)
C pouziva se rekurence WHITE a ANDERSEN
      DIMENSION R(N)
      R(1)=SQE
      R(2)=SQE*(1.-AT)
      DO K=1,N-2
        R(K+2)=((2*K+1-AT)*R(K+1)-K*R(K))/(K+1)
	ENDDO
      END

      SUBROUTINE LGCOEF(T,C,N,CL,NL,A)
C Laguerrovy koeficienty pro neekvidistantni data
      DIMENSION T(N),C(N),CL(NL),R(80)
      IF(NL.LE.80)THEN
        DO J=1,NL
          CL(J)=0.
	  ENDDO
        SQE=SQRT(A)
        DO IT=1,N-1
	    DT=T(IT+1)-T(IT)
	    CM=(C(IT)+C(IT+1))/2.*DT
	    AT=A*(T(IT)+T(IT+1))/2.
          CT=CM*SQE*EXP(-AT/2.)
          CALL LGRR(AT,CT,NL,R)
          DO J=1,NL
             CL(J)=CL(J)+R(J)
	    ENDDO
        ENDDO
      ENDIF
      END

	SUBROUTINE TRCOR(N,T,C,COR,TAU,ITYP,NL)
C Korekce na konecky objem detektoru neb RC integracni konstantu
C ITYP=0  KOREKCE   ITYP=1 KOREKCE +FILTRACE
      DIMENSION T(N),COR(N),C(N),CL(80),R(80),RD(80)
C Odhad casoveho meritka z prvniho momentu
      CALL RSMOM(T,C,N,AREA,TM)
	IF(TM.GT.0.)THEN
         A=(NL+2)/TM
         CALL LGCOEF(T,C,N,CL,NL,A)
C c1 cor(k)=c(k)+tau*sum(CLj.R'j(ti,a))  KOREKCE
C c2 cor(k)=sumCLj.Rj(ti,a)+tau*sum(CLj.R'j(tri,a))  FILTRACE
         SQEA=SQRT(A)
         DO K=1,N
	     AT=A*T(K)
           SQE=SQEA*EXP(-AT/2.)
           CALL LGRRD(A,AT,SQE,NL,R,RD)
           IF(ITYP.EQ.0)THEN
C Korekce
             COR(K)=C(K)
             DO J=1,NL
               COR(K)=COR(K)+TAU*RD(J)*CL(J)
	       ENDDO
           ELSE
C Korekce+filtrace
             COR(K)=0.
             DO J=1,NL
               COR(K)=COR(K)+CL(J)*(R(J)+TAU*RD(J))
	       ENDDO
           ENDIF
	   ENDDO
      ENDIF
      END

      SUBROUTINE TCBGR(N,T,YIN,YOUT)
      DIMENSION T(*),YIN(*),YOUT(*)
C YIN merena data (treba posunout do nuly)
      IF(N.LE.1.OR.T(N).LE.T(1))RETURN
      NAV0=N/200+1
      NAV1=N/100+1
      Y0=0
      DO I=1,NAV0
        Y0=Y0+YIN(I)
      ENDDO
      Y1=0
      DO I=N-NAV1+1,N
        Y1=Y1+YIN(I)
      ENDDO
      Y0=Y0/NAV0         
      Y1=Y1/NAV1
      WRITE(9,'(/'' Background correction C:'',2eS10.3)')Y0,Y1
      DO I=1,N
        YOUT(I)=YIN(I)-Y0-(Y1-Y0)/(T(N)-T(1))*(T(I)-T(1))
      ENDDO
      IF(Y1.LE.Y0)RETURN
C ODHAD PLOCHY 
      RK=0
      RELFAKT=.5
      DO ITER=1,10
        AREA=0
        DO I=1,N-1
          AREA=AREA+ABS((YOUT(I+1)+YOUT(I)))*.5*(T(I+1)-T(I))
        ENDDO
        IF(AREA.EQ.0.)RETURN
        RK=AMAX1(0.,(Y1-Y0)/AREA*RELFAKT+RK*(1.-RELFAKT))
        DO I=2,N
           SUM=0
           DO J=1,I-1
C INTEGRAL OD T=0 TO T(I)
              SUM=SUM+((YIN(J)-Y0)*EXP(-RK*(T(I)-T(J)))
     /                +(YIN(J+1)-Y0)*EXP(-RK*(T(I)-T(J+1))))
     /                *(T(J+1)-T(J))
           ENDDO
           YOUT(I)=YIN(I)-Y0-SUM*RK/2
        ENDDO
        WRITE(9,'('' iter='',i2,'' rk='',ES10.3)')iter,rk
      ENDDO
      END

      SUBROUTINE TAIL(N,NDIM,TV,YV,CV,ICT,M1,M2,NBEG,CINF,A,B)
C YV(*) zdrojova data (nemela by byt prepsana)
C CV(*) data s chvostem a odriznutym pozadim
C ICT=1 exponencialni chvost Y=CINF+A*EXP(-B*T)
C ICT=2                      Y=CINF+A*T*EXP(-B*T)
C ICT=3 mocninovy chvost     Y=CINF+A/T**3
C ICT=-1 exponencialni chvost Y=A*EXP(-B*T)
C ICT=-2                      Y=A*T*EXP(-B*T)
C ICT=-3 mocninovy chvost     Y=A/T**3
C M1-M2 interval bodu pozorovani pouzity pro regresi
C M1=0 nebo M2=0  muze nasledovat az pote, co je vypoctena regrese
      DIMENSION TV(NDIM),CV(NDIM),YV(NDIM)
C Nataen osy asu, pokud tam nejsou rostouc hodnoty
      IF(N.LE.2.OR.TV(N).LE.TV(1))RETURN
      DTT=(TV(N)-TV(1))/(N-1)
      DO I=N+1,NDIM
	  IF(TV(I).LE.TV(I-1))TV(I)=TV(I-1)+DTT
      ENDDO
      ICTA=IABS(ICT)
	IF(M1.GT.0.AND.M2.GT.0)THEN
C M1<=0 nebo M2<=0  - jen vycisleni korekce pro stavajici hodnoty A,B,CINF
      IF(ICT.GT.0)THEN
        CINF=1E10
        DO I=1,N
           CINF=AMIN1(CINF,YV(I))
        ENDDO
        CINF=CINF-0.0001
      ELSE
        CINF=0
      ENDIF
C Nejprve logaritmicka aproximace
      A12=0
      A22=0
      B1=0
      B2=0
      DO I=M1,M2
        T=TV(I)
        IF(T.GT.0.)THEN
           Z=AMAX1(1E-10,(YV(I)-CINF)**2)
           SELECT CASE(ICTA)
           CASE(1)
             A12=A12+T
             A22=A22+T*T
             ZZ=LOG(Z)
             B1=B1+ZZ
             B2=B2+ZZ*T
           CASE(2)
             A12=A12+T
             A22=A22+T*T
             ZZ=LOG(Z/T**2)
             B1=B1+ZZ
             B2=B2+ZZ*T
           CASE(3)
             RT=1./T**3
             A12=A12+RT
             A22=A22+RT*RT
             B1=B1+YV(I)
             B2=B2+YV(I)*RT
           ENDSELECT
        ENDIF
      ENDDO
      M=(M2-M1)+1
      DET=M*A22-A12*A12
      IF(ABS(DET).GT.1E-20)THEN
         A=(B1*A22-B2*A12)/DET
         B=-(B2*M-B1*A12)/DET
      ELSE
         RETURN
      ENDIF

      IF(ICT.EQ.1)THEN
C ZPRESNENI NELINEARNI REGRESI PRO 
C = CINF + A * EXP(-B*T)
C NEJPRVE METODA PULENI INTERVALU
         B=ABS(B)*.5
         BL=B/20.
         BR=B*40.
         CALL FTAIL(TV,YV,M1,M2,BL,FL,CL,AL)
         CALL FTAIL(TV,YV,M1,M2,BR,FR,CR,AR)
         IHALF=0
         DO WHILE(FL*FR.LE.0..AND.IHALF.LE.50)
            IHALF=IHALF+1
            B=(BL+BR)*.5
            CALL FTAIL(TV,YV,M1,M2,B,F,CINF,A)
            IF(F*FL.LE.0.)THEN
               BR=B
               FR=F
            ELSE
               BL=B
               FL=F
            ENDIF
         ENDDO
         WRITE(9,'('' Y(t)='',ES10.3,'' + '',ES10.3,''*EXP(-'',ES10.3,''
     /*t)'')')CINF,A,B
      ELSEIF(ICT.EQ.-1)THEN
	   B=.5*B
         A=EXP(.5*A)
         WRITE(9,'('' Y(t)='',ES10.3,''*EXP(-'',ES10.3,''*t)'')')A,B
      ELSEIF(ICTA.EQ.2)THEN
	   B=.5*B
         A=EXP(.5*A)
         WRITE(9,'('' Y(t)='',ES10.3,'' + '',ES10.3,''*t*EXP(-'',ES10.3,
     /''*t)'')')CINF,A,B
      ELSEIF(ICTA.EQ.3)THEN
         CINF=A
         WRITE(9,'('' Y(t)='',ES10.3,'' + '',ES10.3,''/t^3'')')
     /         CINF,-B
      ENDIF
C ENDIF varianty kdy se resi regrese
	ENDIF
C Extrapolaci provadi i udajem o poctu dat
      DO I=1,NDIM
        IF(I.LE.NBEG)THEN
           CV(I)=YV(I)-CINF
        ELSE
           SELECT CASE(ICTA)
           CASE(1)
             CV(I)=A*EXP(-B*TV(I))
           CASE(2)
             CV(I)=A*TV(I)*EXP(-B*TV(I))
           CASE(3)
             CV(I)=-B/TV(I)**3
           ENDSELECT
        ENDIF
      ENDDO
      END

      SUBROUTINE FTAIL(T,Y,N1,N2,B,FT,CINF,A)
C hodnota FT by mela byt nulova - je to rovnice pro neznamou hodnotu B
C DFT je derivace FT dle parametru B
      DIMENSION T(*),Y(*)
      REAL*8 SYTE,SE,SE2,STE,SYE,SY,STE2,E
      SYTE=0
      SE=0
      SE2=0
      STE=0
      SYE=0
      SY=0
      STE2=0
      DO I=N1,N2
        E=DEXP(-DBLE(B*T(I)))
        SYTE=SYTE+Y(I)*T(I)*E
        SE=SE+E
        SE2=SE2+E*E
        STE=STE+T(I)*E
        SYE=SYE+Y(I)*E
        SY=SY+Y(I)
        STE2=STE2+T(I)*E*E
      ENDDO
      NP=N2-N1+1
      FT=SYTE*(SE**2-NP*SE2)-STE*(SYE*SE-SY*SE2)-STE2*(SE*SY-NP*SYE)
      DET=SE**2-NP*SE2
      IF(ABS(DET).GT.1E-20)THEN
         CINF=(SYE*SE-SY*SE2)/DET
         A=(SE*SY-NP*SYE)/DET
      ENDIF
      END

      SUBROUTINE TCMODIFY(LINE)
      INCLUDE '$FEM-PAR'
      INCLUDE '$FEM-COM'
      CHARACTER*(LENLIN) LINE,LLINE
      CHARACTER*1 C1,C2,C3
C Nahrazeni C1  c1(i)
      LENG=MIN0(LENLIN,LEN(TRIM(LINE))+1)
      CALL TUPC(LENG,LINE,LINE)
      IF(INDEX(LINE,'TCFUN').LE.0.AND.
     /   INDEX(LINE,'TCFR').LE.0.AND.
     /   INDEX(LINE,'TCF').LE.0)RETURN
      IL=0
      I=0
      DO WHILE(I.LT.LENG)
         I=I+1
         IL=IL+1
         LLINE(IL:IL)=LINE(I:I)
         IF(LINE(I:I).EQ.'C'.AND.I.LT.LENG)THEN
            I1=I+1
            C1=LINE(I1:I1)
            I2=MIN0(I+2,LENG)
            C2=LINE(I2:I2)
            I3=MIN0(I+3,LENG)
            C3=LINE(I3:I3)
            IF(C1.GE.'1'.AND.C1.LE.'9'.AND.C2.NE.'(')THEN
               IF(C2.LT.'0'.OR.C2.GT.'9')THEN
                  LLINE(IL+1:IL+4)=C1//'(I)'
                  IL=IL+4
                  I=I+1
               ELSEIF(C3.NE.'(')THEN
                  LLINE(IL+1:IL+5)=C1//C2//'(I)'
                  IL=IL+5
                  I=I+2
               ENDIF
            ENDIF
         ENDIF
      ENDDO
      LINE=LLINE(1:IL)
      LENG=LEN(LINE)
      IAUX(49)=MAXNTS
      END

      SUBROUTINE RU03MO(X,M,DT,N,V)
C Vypocet N-prvnich momentu ekvidistantne tabelovane funkce X(T)
C Linearni Splajnova aproximace
      DIMENSION X(*),V(*)
      IF(N.GE.1)THEN
         S=X(1)*.5
         DO1I=2,M
1        S=S+X(I)
         V(1)=S*DT
      ENDIF
      IF(N.GE.2)THEN
         S=X(1)/6
         DO2I=2,M
2        S=S+X(I)*(I-1)
         V(2)=S*DT*DT
      ENDIF
      IF(N.GE.3)THEN
         S=X(1)/12
         DO3I=2,M
3        S=S+X(I)*(FLOAT(I-1)**2+0.1667)
         V(3)=S*DT**3
      ENDIF
      IF(N.GE.4)THEN
         DO4J=4,N
         S=X(1)/(J*(J+1))
         DO5I=2,M
5        S=S+X(I)*FLOAT(I-1)**(J-1)
4        V(J)=S*DT**J
      ENDIF
      END

      SUBROUTINE RSUNOR(ITYP,NXY,DT,DTOUT,XIN,XOUT,YIN,YOUT,TSX,TSY)
C Normalizace dvou krivek na jednotkovou plochu a jednotkovy rozdil
C prvnich momentu. Prvni momenty puvodnich dat jsou TSX, TSY
C ITYP=0 plocha
C ITYP=1 normalizace plochy i prvniho momentu
      DIMENSION XIN(*),XOUT(*),YIN(*),YOUT(*),VX(2),VY(2)
      EQUIVALENCE (SX,VX(1)),(TX,VX(2)),(SY,VY(1)),(TY,VY(2))
C 1.Krivka
      CALL RU03MO(XIN,NXY,DT,2,VX)
C 2.Krivka
      CALL RU03MO(YIN,NXY,DT,2,VY)
      IF(SX.LE.0..OR.TX.LE.0..OR.SY.LE.0..OR.TY.LE.0.) GOTO 9998
C Vyhodnoceni
      TSX=TX/SX
      TSY=TY/SY
      IF(ITYP.EQ.0)THEN
         TAU=1.
      ELSE
         TAU=TSY-TSX
      ENDIF
      IF(TAU.LE.0.) GOTO 9999
      CX=TAU/SX
      CY=TAU/SY
      DO I=1,NXY
         XOUT(I)=XIN(I)*CX
         YOUT(I)=YIN(I)*CY
      ENDDO
      DTOUT=DT/TAU
      RETURN
9998  CALL HELPC(5,'zero moments of normalised curves')
      RETURN
9999  CALL HELPC(5,'the same first moments of input/output')
      END

      SUBROUTINE FRMOD(F,I,NF,DT,MODEL,TMEANE)
C Model serie N-idealnich misicu Em=1/(1-pi.N.m/T)**N pro regularizaci
C F  - I-ty koeficient Fourierova rozvoje
C NF - pocet clenu rozvoje
C DT - casovy krok
C MODEL - pocet clenu serie
C TMEAN - stredni doba prodleni
      COMPLEX F
      IF(TMEANE.GT.0.)THEN
        TM=TMEANE
      ELSE
        TM=1.
      ENDIF
      IF(MODEL.GT.0)THEN
        N=MODEL
      ELSE
        N=2
      ENDIF
      IF(I.LE.NF/2)THEN
         M=I-1
      ELSE
         M=I-1-NF
      ENDIF
      F=CMPLX(1.,0.)/(CMPLX(1.,-6.28*M*TM/(N*NF*DT)))**N
      END

      SUBROUTINE FFTDC(ICT,NGR,NGRMAX,DT,X,Y,E,
     /           SMOOTH,NFINI,FX,FY,FE,W1,TMEAN,MODEL)
C FFT transformace x,y a
C ICT=1 dekonvoluce E = Y/X     (predbezna normalizace dat!)
C ICT=2 konvoluce   E = Y*X
C ICT=3 korelace    E = X*CONJG(Y)
C Vsechny vysledky se filtruji kdyz SMOOTH >0 [0,1] v proc. FREQ
      COMPLEX FX(*),FY(*),FE(*),AW,CX,CY
      DIMENSION X(*),Y(*),E(*)
C Vsechny vektory stejne delky NF
      CALL FROUND(NFINI,NF,NGRMAX)
      WRITE(10,'('' FFT analysis of'',i6,''-points, using'',i6,''-coefs.
     / Smoothing level'',f6.3)')NGR,NF,SMOOTH
      DO I=NGR+1,NF
        X(I)=0
        Y(I)=0
      ENDDO
      T=NF*DT
      IF(T.LE.0.)RETURN
C Regularizace: normalizace X & Y, vypocet stredni doby prodleni Te
      IF(ICT.EQ.1)THEN
        W=W1**2*(6.28319/T)**4
        CALL RSUNOR(0,NGR,DT,DT,X,X,Y,Y,TSX,TSY)
        TMEAN=TSY-TSX
        WRITE(10,'('' Deconvolution. Normalizing X,Y, Tmean='',ES10.3)')
     /TMEAN
      ENDIF
      NF2=NF/2+1
      DO I=1,NF
        FX(I)=CMPLX(X(I),0.)
        FY(I)=CMPLX(Y(I),0.)
      ENDDO
C Fourierova transformace X,Y
      CALL FOUR1(FX,NF,1)
      CALL FOUR1(FY,NF,1)
      WRITE(10,'('' Forward FFT of X,Y performed successfuly.'')')
      DO I=1,NF
         CY=FY(I)*DT
         FY(I)=CY
         CX=FX(I)*DT
         FX(I)=CX
         IF(ICT.EQ.1)THEN
C DEKONVOLUCE
            IF(CABS(CX).EQ.0.)THEN
              WW=1.
            ELSE
              IF(I.LE.NF2)THEN
                 M=I-1
              ELSE
                 M=I-1-NF
              ENDIF
              WW=W*FLOAT(M)**4
            ENDIF
C AW - I-ty koeficient regularizacniho modelu
            CALL FRMOD(AW,I,NF,DT,MODEL,TMEAN)
            FE(I)=(CY*CONJG(CX)+WW*AW)/(CX*CONJG(CX)+WW)
         ELSEIF(ICT.EQ.2)THEN
C KONVOLUCE
            FE(I)=CX*CY
         ELSEIF(ICT.EQ.3)THEN
C KORELACE
            FE(I)=CY*CONJG(CX)
         ENDIF
      ENDDO
C Event. dalsi filtrace a zpetna transformace
C Vynulovani koeficientu K-1 nejvyssich frekvenci
      SELECT CASE(ICT)
      CASE(1)
         WRITE(10,'('' FFT of impulse response calculated. Regularisatio
     /n model'',i3,'', weight'',e9.2)')MODEL,W1
      CASE(2)
         WRITE(10,'('' FFT of response (convolution) calculated.'')')
      CASE(3)
         WRITE(10,'('' FFT of cross-correlation calculated.'')')
      ENDSELECT
C od tohoto okamziku jiz FX ani FY nepotrebuji, mohu je dat k dispozici
C procedure FREQ k volnemu pouziti. Stejne tak lze vyuzit E
      IF(SMOOTH.GE.0.999)
     /      CALL PSD(ICT,MODEL,W1,TMEAN,FE,FY,E,NF,DT,SMOOTH)
      CALL FREQ(FE,NF,SMOOTH)
      CALL FOUR1(FE,NF,-1)
      IF(ICT.EQ.3)THEN
         RR=1./T**2
      ELSE
         RR=1./T
      ENDIF
      DO I=1,NGR
         E(I)=REAL(FE(I))*RR
      ENDDO
      END

      SUBROUTINE FFTFILT(NGR,NGRMAX,DT,X,E,
     /           SMOOTH,NFINI,FX,FE)
C ICT=0 pouze filtrace dat X vysledek E (moze byt totozny)
C Vsechny vysledky se filtruji kdyz SMOOTH >0 [0,1] v proc. FREQ
      COMPLEX FX(*),FE(*)
      DIMENSION X(*),E(*)
C Vsechny vektory stejne delky NF
      CALL FROUND(NFINI,NF,NGRMAX)
      WRITE(10,'('' FFT filter of'',i6,''-points, using'',i6,''-coefs.
     / Smoothing level'',f6.3)')NGR,NF,SMOOTH
      T=NF*DT
      NF2=NF/2+1
      DO I=1,NF
        IF(I.LE.NGR)THEN
           FE(I)=CMPLX(X(I),0.)
        ELSE
           FE(I)=CMPLX(0.,0.)
        ENDIF
      ENDDO
C Fourierova transformace E
      CALL FOUR1(FE,NF,1)
C Event. dalsi filtrace a zpetna transformace
C od tohoto okamziku jiz FX ani FY nepotrebuji, mohu je dat k dispozici
C procedure FREQ k volnemu pouziti. Stejne tak lze vyuzit E
      IF(SMOOTH.GE.0.999)THEN
         CALL PSD(0,0,0.,0.,FE,FX,E,NF,DT,SMOOTH)
      ELSEIF(SMOOTH.LT.0.)THEN
C WIENER FILTERING
         PSDMIN=1E10
         DO I=1,NF
            PSDR=REAL(FE(I)*CONJG(FE(I)))
            PSDMIN=AMIN1(PSDR,PSDMIN)
         ENDDO
         DO I=1,NF
            FE(I)=FE(I)*(1.-PSDMIN/REAL(FE(I)*CONJG(FE(I))))
         ENDDO
         WRITE(10,'('' Wiener filtering activated PSD-noise='',e9.2)')
     /        PSDMIN
         SMOOTH=0.
      ENDIF
      CALL FREQ(FE,NF,SMOOTH)
      CALL FOUR1(FE,NF,-1)
      DO I=1,NGR
         E(I)=REAL(FE(I))/NF
      ENDDO
      END

      SUBROUTINE FREQ(F,NF,SMOOTH)
C Odriznuti vyssich frekvenci. 
      COMPLEX F(NF)
      NF2=NF/2
      K=NF2*(1.-SMOOTH)+1
      K=MAX0(1,K)
      DO I=K,NF-K+1
          F(I)=CMPLX(0.,0.)
      ENDDO
      END

      SUBROUTINE PSD(ICT,MODEL,W,TMEAN,F,FA,E,NF,DT,SMOOTH)
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
C ICT=0 PSD filter, ICT=1 identifikace, =2 konvoluce, =3 Rxy
C MODEL, TMEAN maji vyznam pouze pro ICT=1 (vykresleni regularizacniho modelu)
C F(NF) - fourierovy koeficienty, ktere nebudou zmeneny
C FA(NF)- pracovni vektor (odriznuti vyssich frekvenci F)
C E     - pracovni vektor 
      COMPLEX F(NF),FA(NF)
      REAL E(NF)
      CHARACTER*24 LABEL,HEAD*11
      INCLUDE '$PLT-COM'
      OPEN(29,FILE='PSD.TXT')
      WRITE(29,'(''  ROW FREQ[1/S] PSD[f^2]  FPSD[integral PSD]'')')
      NF2=NF/2
      KBD=1
      PSDMI=1E20
      PSDMA=-1E20
      DF=1./(NF*DT)
      FRMA=NF2*DF
      PSDINT=0.
      DO I=1,NF2
         J=NF-I+1
         FRE=(I-1)*DF
         PSDFFT=REAL(F(I)*CONJG(F(I))+F(J)*CONJG(F(J)))
         WRITE(29,'(I5,3ES10.3)')I,FRE,PSDFFT,PSDINT
         PSDINT=PSDINT+PSDFFT*DF
         E(I)=SQRT(PSDFFT)
         IF(E(I).GT.0.)THEN
            E(I)=ALOG10(E(I))
            PSDMI=AMIN1(PSDMI,E(I))
            PSDMA=AMAX1(PSDMA,E(I))
         ENDIF
      ENDDO
      IF(PSDINT.LE.0.)GOTO 999
C Vykresleni grafu integralni PSD ve vedlejsim okne 21.
C (na ose x frekvence od nuly do Nyquistovy frekvence, na ose Y relativni
C integralni PSD od nuly do 1)
C Logaritmicka stupnice frekvenci, aritmeticka stupnice integralu
      FREQMI=ALOG10(DF)
      FREQMA=ALOG10(FRE)
      CALL GMFSTW(4,1,21,5,12,'f [1/s]','Intg PSD',0.,1.,0.,1.,
     /                       FREQMI,FREQMA,0.,1.)
      CALL GMFAXE(4,5,15)
      PSDI=0.
      DO I=1,NF2
         J=NF-I+1
         FRE=(I-1)*DF
         PSDFFT=REAL(F(I)*CONJG(F(I))+F(J)*CONJG(F(J)))
         IF(I.GT.1)THEN
           FREL=ALOG10(FRE)
           IF(I.LE.10)THEN
              CALL GMFMRK(FREL,PSDI/PSDINT,50)
           ELSE
              CALL GMFMRKS(FREL,PSDI/PSDINT,50)
           ENDIF
         ENDIF
         PSDI=PSDI+PSDFFT*DF
      ENDDO
      WRITE(10,'('' Specify cut-off frequency using mouse (L-click confi
     /rm, R-click quit)'')')
      II=SETACTIVEQQ(20)
      II=FOCUSQQ(20)
      IF(ICT.EQ.1)THEN
         HEAD='Impulse'
      ELSEIF(ICT.EQ.2)THEN
         HEAD='Response'
      ELSEIF(ICT.EQ.3)THEN
         HEAD='correlation'
      ELSE
         HEAD='filter'
      ENDIF
      CALL GMFSTW(3,2,20,3,16,'f [1/s]','PSD '//HEAD,0.,1.,0.,1.,
     /                       DF,FRMA,PSDMI-.5,PSDMA)
      CALL GMFAXE(3,2,15)
      DO I=1,NF2
         IF(I.LE.10)THEN
            CALL GMFMRK(DF*I,E(I),50)
         ELSE
            CALL GMFMRKS(DF*I,E(I),50)
         ENDIF
      ENDDO
      DO WHILE(KBD.EQ.1)
        CALL GMFSW(3)
        II=SETACTIVEQQ(20)
        II=FOCUSQQ(20)
        CALL GMFLCC(PX,PY,KBD)
        IF(KBD.EQ.2)EXIT
        DISMIN=1E10
        IMI=1
        DO I=1,NF2
           DIST=ABS(DF*I-PX)
           IF(DIST.LT.DISMIN)THEN
              IMI=I
              DISMIN=DIST
           ENDIF
        ENDDO      
C Pokusne odriznuti vyssich frekvenci
        SMOOTH=1.-FLOAT(IMI)/(NF2-1)
        WRITE(10,'('' Smoothing level adjusted to'',f6.3,'' components 1
     /,...,'',i3)')SMOOTH,IMI
        DO I=1,NF
           FA(I)=F(I)
        ENDDO
        CALL FREQ(FA,NF,SMOOTH)
        CALL FOUR1(FA,NF,-1)
C normalizace na jednotkovou plochu
        S=0
        DO I=1,NF
           E(I)=REAL(FA(I))
           S=S+AMAX1(0.,E(I))
        ENDDO
        S=S*DT
        IF(S.EQ.0.)GOTO 999
        EMI=1E10
        EMA=-1E10
        DO I=1,NF
           E(I)=E(I)/S
           EMI=AMIN1(EMI,E(I))
           EMA=AMAX1(EMA,E(I))
        ENDDO
        CALL GMFSTW(4,1,21,5,12,'t [s]',HEAD,0.,1.,0.,1.,
     /                       0.,DT*NF,EMI,EMA)
        CALL GMFAXE(4,7,15)
        CALL GMFPLD(0.,DT,NF,E,12)
C Model odezva serie MODEL-misicu se stredni dobou prodleni TMEAN
        IF(ICT.EQ.1.AND.TMEAN.GT.0.)THEN
          WRITE(LABEL,'(''MODEL'',I2,'' WEIGHT='',E9.2)')MODEL,W
          DO I=1,NF
             T=I*DT
             R=MODEL/TMEAN*T
             C=1
             DO J=1,MODEL
                C=C*R/J
             ENDDO
             E(I)=C/T*EXP(-MODEL*T/TMEAN)
             IF(I.EQ.NF/3)CALL GMFTEXT(T,E(I),13,24,LABEL)
          ENDDO
          CALL GMFPLD(DT,DT,NF,E,13)
        ENDIF
        IST20=3
      ENDDO
      WRITE(10,'('' Final level of smoothing'',F6.3)')SMOOTH
999   CLOSE(29)
      END

