C $s3-comm.for
      SUBROUTINE WRITEL(KEYWORD)
C
C ZAPIS TEXTU PRIKAZOVEHO RADKU DO SESSION FILU (UNIT=1)
C a provedeni vykonne operace
C Generuje se text LINOP, vytvoreny z jednotlivych polozek TP(i). Pocet ukladanych parametru je
C dan posledni hodnotou TP(i) o delce alespon jednoho znaku, nebo vycerpanim delky vektoru.
C Poznamenejme, ze vstupem pro OPERAT nejsou jednotlive polozky RP,IP,TP (ty dokonce na zacatku
C procedura OPERAT nuluje), ale pouze textovy parametr LINOP.
C
      INCLUDE '$FEM'
      CHARACTER *(*) KEYWORD
      CHARACTER *(LENLIN) LINE,LINOP
      CHARACTER *(LENITE) ITEM
	CHARACTER*40 FILENAME
      LINE=''
      N=0
      DO J=1,MAXPAR
C
C ODSTRANENI LEVYCH A PRAVYCH MEZER Z POLOZKY J
C
         ITEM=TRIM(ADJUSTL(TP(J)))
         LITEM=LEN_TRIM(ITEM)
         IF(LITEM.GT.0.AND.N+LITEM.LE.LENLIN)THEN
             IF(N.GT.0)LINE(N:N)=','
             LINE(N+1:N+LITEM)=ITEM
             N=N+LITEM+1
         ELSE
             N=MAX0(1,N)
             IF(N.LE.LENLIN)LINE(N:N)=';'
             EXIT
         ENDIF
      ENDDO
      WRITE(1,'(A,1X,A)')KEYWORD,TRIM(LINE)
      IF(RECORW)THEN
           CALL TUPC(LENLIN,LINE,LINE)
           WRITE(8,'(A,1X,A)')KEYWORD,TRIM(LINE)
           INQUIRE(UNIT=8,NAME=FILENAME)
           WRITE(10,'('' Recording '',A,'' into file '',A)')
     /               KEYWORD,FILENAME
      ENDIF
      LINOP=KEYWORD//' '//TRIM(LINE)
      CALL OPERAT(LINOP,1)
      END

      SUBROUTINE COMFIL(IUNITIN,IUNCOPY,RUN)
C
C ZPRACOVANI SOUBORU UNIT=IUNITIN PRO INTERPRETACI PRIKAZU
C RUN=.TRUE. IDENTIFIKACE NAVESTI A CYKLU A KOPIROVANI DO SOUBORU IUNCOPY (jen protokol)
C RUN=.FALSE.PROBEHNE JEN ZPRACOVANI VSECH PRIKAZU NA IUNIT V REZIMU READFI=.FALSE.
C prazdne radky se vynechaji
C 
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$fem'
	COMMON /$ENDIF/ENDI
C NLABELS  - pocet navesti 
C  kazde navesti ma tyto charakteristiky
C LABELS   - jmena navesti (na 4 znaky)
C LABELINE - cislo radku v interpretovanem souboru, ktere odpovida navesti
C LOOPMAX  - pocet cyklu LOOP 
C LOOPCOUNT- pocitadlo cyklu
C LOOPLINE - cislo radku za prikazem #LOOP
      LOGICAL RUN,OPE,ENDI
      CHARACTER *(LENLIN) LINE,LINESAV,ITEM*4,PROCNAME*12,CH*1
	IUNIT=IUNITIN
      INQUIRE(UNIT=IUNIT,OPENED=OPE)
      IF(.NOT.OPE)THEN
         CALL HELPC(4,'UNIT not opened, try OPEN command')
         RETURN
      ENDIF
      IF(RUN)THEN
C HLEDANI NAVESTI
         READFI=.TRUE.
         REWIND(IUNIT)
         IC=0
         NLABELS=0
1        READ(IUNIT,'(A)',END=100,ERR=100)LINE
C         IF(LEN(TRIM(LINE)).EQ.0) GOTO 1
         if(len(trim(line)).eq.0)line='C*'
C Duplicitni radky se neukladaji do protokolu 
         IF(LINESAV.NE.LINE)WRITE(IUNCOPY,'(A)')TRIM(LINE)
         LINESAV=LINE
         CALL TUPC(40,LINE,LINE)
         IC=IC+1
         IF(LINE(1:6).EQ.'#LABEL'.AND.NLABELS.LT.MAXLABELS)THEN
             NLABELS=NLABELS+1
             ITEM=ADJUSTL(LINE(8:40))
             CALL CITEM(ITEM)
             LABELS(NLABELS)=ITEM
             LABELINE(NLABELS)=IC
             LOOPMAX(NLABELS)=-1
	       LOOPLINE(NLABELS)=IC
         ENDIF
         GOTO 1
C HLEDANI LOOPS A PRIRAZENI ADRES SKOKU
100      IC=0
         REWIND(IUNIT)
2        READ(IUNIT,'(A)',END=200)LINE
         CALL TUPC(40,LINE,LINE)
         IC=IC+1
         IF(LINE(1:5).EQ.'#LOOP')THEN
             ITEM=ADJUSTL(LINE(7:40))
             CALL LABINT(ITEM,NUMLAB)
             IF(NUMLAB.GE.1)LOOPLINE(NUMLAB)=IC
         ENDIF
         GOTO 2
200      REWIND (IUNIT)
      ENDIF
C Interpretace
      REWIND (IUNIT)
C      INQUIRE(UNIT=IUNIT,NAME=PROCNAME)
      CALL FINQUIRE(IUNIT,PROCNAME)
      WRITE(10,'('' Processing file ['',A,''] on unit'',I2)')PROCNAME,
     /      IUNIT
      ILINE=0
	ENDI=.FALSE.
3     READ(IUNIT,'(A)',END=300,ERR=300)LINE
      IF(LINE(1:2).EQ.'Q*')GOTO300
      IUNITA=IUNIT
      CALL OPERAT(LINE,IUNITA)
      ILINE=ILINE+1
      WRITE(10,'(I4,'':'',A,''      ''\)')ILINE,TRIM(LINE(1:20))
      IF(IFISTEP.NE.0)THEN
         II=SETTEXTCOLOR(INT2(11))      
         WRITE(10,'('' Press Enter,Esc,...'')')
         II=SETTEXTCOLOR(INT2(15))      
         CALL GCU(CH,IEND)
         IF(IEND.EQ.227)THEN
C Esc
             GOTO 300
         ELSEIF(IEND.NE.213)THEN
             IFISTEP=0
         ENDIF
      ELSE
         WRITE(10,*)
      ENDIF
      GOTO 3
300   READFI=.FALSE.
      BACKSPACE IUNIT
      IFISTEP=0
      END

      SUBROUTINE LABINT(ITEM,NUMLAB)
C
C VYHLEDEJ CISLO NAVESTI ITEM
C
      INCLUDE '$fem'
      CHARACTER *(*) ITEM
      NUMLAB=0
      CALL TUPC(4,ITEM,ITEM)
      CALL CITEM(ITEM)
      DO I=1,NLABELS
         IF(ITEM.EQ.LABELS(I))THEN
            NUMLAB=I
            EXIT
         ENDIF
      ENDDO
      IF(NUMLAB.EQ.0)WRITE(10,*)' MISSING LABEL ',ITEM
      END

      SUBROUTINE SKIPE(IUNIT)
C
C IUNIT - cislo zarizeni, kde je interpretovany session file
C SKIP COMMANDS UNTIL #E... 
C
      CHARACTER *2 LINE
      LINE='  '
      DO WHILE(LINE.NE.'#E')
         READ(IUNIT,'(A)',END=100)LINE
      ENDDO
100   RETURN
      END

      SUBROUTINE GOLINE(ILINE,IUNIT)
C
C Nastav UNIT=IUNIT na radku ILINE
C
      REWIND IUNIT
      DO I=1,ILINE
         READ(IUNIT,*,END=100)
      ENDDO
100   RETURN
      END      

      SUBROUTINE LOVARI(ICRPN,NCRPN,LLL,JJJ)
C
C Zjisteni pozice promenne nebo prvku vektoru v zone /FEM/
C Vstup:  
C ICRPN vektor kodu RPN, prelozeny procedurou TRANSQ
C NCRPN delka kodu RPN
C    Kod RPN muze mit v nejjednodussim pripade nasledujici tvar:
C    100 3  -LLL  JJJ   0        (jednoduche promenne)
C    100 5  -LOCONST JJJindex -LLLVECT JJJ+2 0  (vektor s indexem jako konstanta)
C Vystup:
C LLL - pozice promenne
C JJJ - typ promenne (=1 real,=2 integer)
C
      INCLUDE '$FEMLOC'
      INTEGER ICRPN(*)
      COMMON /SCOM/IER,LASTINDEX,F(48)
      EXTERNAL TFUW
      LLL=1
      JJJ=0
      IF(NCRPN.GE.5)THEN
        IF(ICRPN(2).EQ.3)THEN
C Jednoducha promenna
           LLL=-ICRPN(3)
           JJJ=ICRPN(4)
        ELSEIF(ICRPN(2).EQ.5)THEN
C Prvek vektoru s indexem jako konstanta
           IF(ICRPN(4).EQ.1)THEN
              RINDEX=REALRC(-ICRPN(3))
           ELSE
              RINDEX=INTERC(-ICRPN(3))
           ENDIF
           LLL=-ICRPN(5)+FLOOR(RINDEX-.5)
           JJJ=ICRPN(6)-2
        ELSE
C Prvek vektoru s indexem, ktery je definovan jako libovolny vyraz
           CALL TINE(ICRPN(3),ICRPN(2),IAUX,TFUW,RES)
           IF(IER.EQ.0)THEN
              JJJ=ICRPN(NCRPN-1)-2
              LLL=LASTINDEX
           ENDIF
        ENDIF
      ENDIF
      END

	SUBROUTINE CLOSEFILE(FILC)
C Pokud je nahodou soubor FILC (na nezname jednotce) otevren, zavirame.
C
C puvodne delka 12
	CHARACTER*(*) FILC
	LOGICAL EXST,OPND
	INQUIRE(FILE=FILC,EXIST=EXST,OPENED=OPND,NUMBER=IUN)
	IF(EXST.AND.OPND)CLOSE(IUN)
	END

      SUBROUTINE RUNFEM
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEMLOC'
C Info o cartesian BOXING
      WRITE(9,'('' RUNFEM: XBOX'',2E10.3,I5,'' YBOX'',2E10.3,I5)')
     /XBOXMI,DXBOX,NXBOX,YBOXMI,DYBOX,NYBOX
C Testovani, zda $RUNFEM.BIN nahodou nezustal otevreny pro jiny proces
	CALL CLOSEFILE('$RUNFEM.BIN ')
C Volani externiho programu RUNFEM.EXE a predani dat v souboru RUNFEM.BIN
      WRITE(10,'('' Writing database to RUNFEM.BIN'')')
      OPEN(3,FILE='$RUNFEM.BIN',FORM='BINARY')
      CALL WRITEBIN(3,0)
      CLOSE(3)
	CLOSE(6)
      IF(KEYW.EQ.'DSOLVE')THEN
         WRITE(10,'('' Running RUNFEMD.EXE (double precision frontal sol
     /ver)'')')
         IRESULT=RUNQQ(trim(filepath)//'RUNFEMD.EXE','')
      ELSEIF(KEYW.EQ.'PSOLVE')THEN
         WRITE(10,'('' Running RUNFEMP.EXE (single precision frontal sol
     /ver with particles)'')')
         IRESULT=RUNQQ(trim(filepath)//'RUNFEMP.EXE','')
      ELSE
         WRITE(10,'('' Running RUNFEM.EXE (single precision frontal solv
     /er)'')')
         IRESULT=RUNQQ(trim(filepath)//'RUNFEM.EXE','')
      ENDIF   
      IF(IRESULT.EQ.-1)THEN
         WRITE(10,*)' RUNFEM.EXE fails. PAUSE...'
         PAUSE
      ENDIF
      WRITE(10,'('' Reading results from $RUNFEM.BIN'')')
      OPEN(3,FILE='$RUNFEM.BIN',FORM='BINARY')
      CALL READBIN(3,IEND)
      CLOSE(3)
	ISTATUS=1
      IF(IENDCHECK.EQ.27)THEN
        CALL HELPC(4,'Interrupted by Esc.')
      ELSEIF(IENDCHECK.EQ.-1)THEN
        CALL HELPC(4,'Error in reading data from $RUNFEM.BIN.')
      ELSEIF(IENDCHECK.NE.0)THEN
        CALL HELPC(4,'Error (see RUNFEM.OUT) or interrupted by a key.')
      ELSE
        CALL CHECKRES
        WRITE(10,'('' Calculated POWERS(Elect,Flow,Therm)='',3E11.4)')
     /        $RPOWERE,$RPOWERF,$RPOWERT
      ENDIF
      END

      SUBROUTINE RUNMOD
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEMLOC'
      IF($FAST.EQ.1)THEN
         CALL $RUNMOD
      ELSE
C Volani externiho programu RUNMOD.EXE a predani dat v souboru $RUNFEM.BIN
         CALL CLOSEFILE('$RUNFEM.BIN ')
	   WRITE(10,'('' Writing database to $RUNFEM.BIN'')')
         OPEN(3,FILE='$RUNFEM.BIN',FORM='BINARY')
         CALL WRITEBIN(3,0)
         CLOSE(3)
         WRITE(10,'('' Running RUNMOD.EXE with keyword '',A)')KEYW
         IRESULT=RUNQQ(trim(filepath)//'RUNMOD.EXE','')
         IF(IRESULT.EQ.-1)THEN
            WRITE(10,*)' RUNMOD.EXE fails. PAUSE...'
            PAUSE
         ENDIF
         WRITE(10,'('' Reading results from $RUNFEM.BIN'')')
         OPEN(3,FILE='$RUNFEM.BIN',FORM='BINARY')
         CALL READBIN(3,IEND)
         CLOSE(3)
         IF(IENDCHECK.EQ.27)THEN
           CALL HELPC(6,'Interrupted by Esc.')
         ELSEIF(IENDCHECK.EQ.-1)THEN
           CALL HELPC(6,'Error in reading data from $RUNFEM.BIN')
         ELSEIF(IENDCHECK.NE.0)THEN
           CALL HELPC(6,'Interrupted by a key. Continuing...')
         ENDIF
      ENDIF
      END

      SUBROUTINE RUNBOX
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEMLOC'
C Volani externiho programu RUNBOX.EXE a predani dat v souboru RUNFEM.BIN
	CALL CLOSEFILE('$RUNFEM.BIN ')
      WRITE(10,'('' Writing database to $RUNFEM.BIN'')')
      OPEN(3,FILE='$RUNFEM.BIN',FORM='BINARY')
      CALL WRITEBIN(3,0)
      CLOSE(3)
      CLOSE(6)
      WRITE(10,'('' Running RUNBOX.EXE'')')
      IRESULT=RUNQQ(trim(filepath)//'RUNBOX.EXE','')
      IF(IRESULT.EQ.-1)THEN
         WRITE(10,*)' RUNBOX.EXE fails. PAUSE...'
         PAUSE
      ENDIF
      WRITE(10,'('' Reading results from $RUNFEM.BIN'')')
      OPEN(3,FILE='$RUNFEM.BIN',FORM='BINARY')
      CALL READBIN(3,IEND)
      CLOSE(3)
      IF(IENDCHECK.EQ.27)THEN
        CALL HELPC(6,'Interrupted by Esc.')
      ELSEIF(IENDCHECK.EQ.-1)THEN
        CALL HELPC(6,'Error in reading data from $RUNFEM.BIN.')
      ELSEIF(IENDCHECK.NE.0)THEN
        CALL HELPC(6,'Interrupted by a key. Continuing...')
      ENDIF
      OPEN(6,FILE='$RUNBOX.BIN',ACCESS='DIRECT',RECL=4)
      END

      SUBROUTINE RUNDET
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEMLOC'
C Volani externiho programu RUNDET.EXE a predani dat v souboru RUNFEM.BIN
	CALL CLOSEFILE('$RUNFEM.BIN ')
      WRITE(10,'('' Writing database to $RUNFEM.BIN'')')
      OPEN(3,FILE='$RUNFEM.BIN',FORM='BINARY')
      CALL WRITEBIN(3,0)
      CLOSE(3)
	CLOSE(6)
      NDET=IP(5)
      ITIME=IP(2*NDET+6)
      IF(ITIME.LE.0)THEN
         WRITE(10,'('' Running RUNDET.EXE'')')
         IRESULT=RUNQQ(trim(filepath)//'RUNDET.EXE','')
      ELSEIF(ITIME.LE.MAXNTS)THEN
         WRITE(10,'('' Running RUNDET1.EXE'')')
         IRESULT=RUNQQ(trim(filepath)//'RUNDET1.EXE','')
      ELSE
         IRESULT=-1
      ENDIF
      IF(IRESULT.EQ.-1)THEN
         WRITE(10,*)' RUNDET.EXE fails. PAUSE...'
         PAUSE
      ENDIF
      WRITE(10,'('' Reading results from $RUNFEM.BIN'')')
      OPEN(3,FILE='$RUNFEM.BIN',FORM='BINARY')
      CALL READBIN(3,IEND)
      CLOSE(3)
      IF(IENDCHECK.EQ.27)THEN
        CALL HELPC(6,'Interrupted by Esc.')
      ELSEIF(IENDCHECK.EQ.-1)THEN
        CALL HELPC(6,'Error in reading data from $RUNFEM.BIN.')
      ELSEIF(IENDCHECK.NE.0)THEN
        CALL HELPC(6,'Interrupted by a key. Continuing...')
      ENDIF
      END

      SUBROUTINE RUNMESH
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEMLOC'
C Volani externiho programu RUNMESH.EXE a predani dat v souboru RUNFEM.BIN
	CALL CLOSEFILE('$RUNFEM.BIN')
      WRITE(10,'('' Writing database to $RUNFEM.BIN'')')
      OPEN(3,FILE='$RUNFEM.BIN',FORM='BINARY')
      CALL WRITEBIN(3,0)
      CLOSE(3)
      SELECT CASE(KEYW)
      CASE('MCT')
          WRITE(10,'('' Running RUNMCT.EXE'')')
          IRESULT=RUNQQ(trim(filepath)//'RUNMCT.EXE','')
      CASE('MPT')
          WRITE(10,'('' Running RUNMPT.EXE'')')
          IRESULT=RUNQQ(trim(filepath)//'RUNMPT.EXE','')
      CASE('MND')
          WRITE(10,'('' Running RUNMND.EXE'')')
          IRESULT=RUNQQ(trim(filepath)//'RUNMND.EXE','')
      CASE('MRG')
          WRITE(10,'('' Running RUNMRG.EXE'')')
          IRESULT=RUNQQ(trim(filepath)//'RUNMRG.EXE','')
      ENDSELECT
      IF(IRESULT.EQ.-1)THEN
         WRITE(10,*)' RUNM....EXE fails. PAUSE...'
         PAUSE
      ENDIF
      WRITE(10,'('' Reading results of meshing from $RUNFEM.BIN'')')
      OPEN(3,FILE='$RUNFEM.BIN',FORM='BINARY')
      CALL READBIN(3,IEND)
      CLOSE(3)
      IF(IENDCHECK.EQ.27)THEN
        CALL HELPC(6,'Interrupted by Esc.')
      ELSEIF(IENDCHECK.EQ.-1)THEN
        CALL HELPC(6,'Error in reading data from $RUNFEM.BIN.')
      ELSEIF(IENDCHECK.NE.0)THEN
        CALL HELPC(6,'Interrupted by a key. Continuing...')
      ENDIF
      END

      SUBROUTINE RUNMOPED(IDUMMY)
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEMLOC'
	LOGICAL IDUMMY,LDUMMY
	LDUMMY=IDUMMY
      OPEN(3,FILE='$MOPED.TXT')
	DO I=1,MAX0(1,NTSTEP)
	WRITE(3,'(I5,10E12.4)')I,(YGR(I,J),J=1,10)
	ENDDO
	CLOSE(3)
	IRESULT=RUNQQ('NOTEPAD.EXE','$MOPED.TXT')
      OPEN(3,FILE='$MOPED.TXT',ERR=999)
	DO I=1,MAX0(1,NTSTEP)
	READ(3,*,END=999,ERR=999)III,(YGR(I,J),J=1,10)
	ENDDO
999	CLOSE(3)
	END

      SUBROUTINE RUNEXCEL(IDUMMY)
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEMLOC'
	LOGICAL IDUMMY,LDUMMY
	LDUMMY=IDUMMY
      OPEN(3,FILE='$EXCEL.TXT')
	DO I=1,MAX0(1,NTSTEP)
	WRITE(3,'(10(A1,E11.3))')(CHAR(9),YGR(I,J),J=1,10)
	ENDDO
	CLOSE(3)
	IRESULT=RUNQQ('EXCEL.EXE','$EXCEL.TXT')
      OPEN(3,FILE='$EXCEL.TXT',ERR=999)
	DO I=1,MAX0(1,NTSTEP)
	READ(3,*,ERR=999,END=999)(YGR(I,J),J=1,10)
	ENDDO
999	CLOSE(3)
	END


      SUBROUTINE RUNOUT(IDUMMY)
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEMLOC'
	LOGICAL IDUMMY,LDUMMY
	LDUMMY=IDUMMY
	IRESULT=RUNQQ('NOTEPAD.EXE',TRIM(PROBLEM)//'.OUT')
      END

      SUBROUTINE RUNTEP(IDUMMY)
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEMLOC'
	LOGICAL IDUMMY,LDUMMY
	LDUMMY=IDUMMY
	IRESULT=RUNQQ('NOTEPAD.EXE',TRIM(PROBLEM)//'.TEP')
      END

      SUBROUTINE RUNJOU(IDUMMY)
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEMLOC'
	LOGICAL IDUMMY,LDUMMY
	LDUMMY=IDUMMY
	IRESULT=RUNQQ('NOTEPAD.EXE','$RUNFEM.OUT')
      END

      SUBROUTINE RUNREG(IDUMMY)
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEMLOC'
	LOGICAL IDUMMY,LDUMMY
	LDUMMY=IDUMMY
	IRESULT=RUNQQ('NOTEPAD.EXE','RANNREG.OUT')
      END


      SUBROUTINE RUNREG2(IDUMMY)
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEMLOC'
	LOGICAL IDUMMY,LDUMMY
	LDUMMY=IDUMMY
	IRESULT=RUNQQ('NOTEPAD.EXE','RANNREG2.OUT')
      END


      SUBROUTINE PROCOM(LINE)
C ZPRACOVANI PRIKAZOVE RADKY, vysledek je klicove slovo KEYW, 
C                             vektory parametru TP,IP,RP v zone FEM.
C                             LAST,ISEMI v zone $FEM - posledni zadavany parametr, pozice stredniku
      INCLUDE '$fem'
      CHARACTER LINE*(*)
      CHARACTER *(LENITE) ITEM
      TP=''
      LAST=0
      LLINE=MIN0(LENLIN,MAX0(1,LEN(LINE)))
      CALL TUPC(LLINE,LINE,LINE)
C RADKA: KEYWORD P1,P2,P3,...
      ISEMI=INDEX(LINE,';')
C To, co je za strednikem je poznamka, kterou pro jistotu vymazeme
	IF(ISEMI.GT.0)THEN
	   DO I=ISEMI+1,LLINE
	        LINE(I:I)=' '
	   ENDDO
	ENDIF
C PROCEDURA SELITE PROHLEDAVA LINE ZNAKEM J+1 POCINAJE A VYBIRA RETEZEC
C ITEM OMEZENY BUD MEZEROU, CARKOU NEBO STREDNIKEM. NA VYSTUPU Z PROCE-
C DURY JE BUD 
C J>0 - POZICE OMEZOVACE ZA PLATNOU POLOZKOU (MUZE BYT I PRAZDNA ,,)
C J=0 - PLATNA POLOZKA, ALE POSLEDNI (OMEZENA BUD KONCEM TEXTU NEBO STREDNIKEM)
C J<0 - NEPLATNA POLOZKA 
      CALL SELITE(LINE,0,ITEM,J)
      IF(J.GE.0)KEYW=ITEM
C Vynechavame zpracovani radku typu komentar, ale i tech, ktere zacinaji 
C na klicova slova skriptovaciho jazyka
      IF(INDEX(LINE,'=').NE.0.AND.LINE(1:3).NE.'TCF')RETURN
      DO WHILE(J.GT.0)
        CALL SELITE(LINE,J,ITEM,J)
        IF(J.GE.0)THEN
           LAST=LAST+1
           CALL PROITE(LAST,ITEM,IEND)
        ENDIF
      ENDDO
      END

      SUBROUTINE PROITE(L,ITEM,IEND)
C ZPRACOVANI POLOZKY ITEM A ULOZENI HODNOTY DO P(LAST)
C Vystupni parametr IEND
C IEND>0 preklad bez chyby
C IEND=0 vycerpany text
C IEND<0 syntakticka chyba
C
      CHARACTER *(*) ITEM
      INCLUDE '$FEMB'
	INCLUDE '$RPN'
      EXTERNAL TFUW
      INTEGER $LEPAR,$LELEM,$LMETHOD
      PARAMETER ($LELEM=70,$LEPAR=90,$LMETHOD=120)
      IF(L.LE.0.OR.L.GT.MAXPAR)STOP
C
C Promenne v zone AUX odpovidaji pracovnim hodnotam velicin TEMP,UX,...
C V teto procedure jsou jejich hodnoty nastaveny jako indexy (1 az 24),
C coz umozni identifikovat promennou bud indexem, nebo jejim jmenem.
C $LDOF=10
      DO I=1,MAXTDOF
        AUX(I+$LDOF)=I
      ENDDO
C Totez pro nazvy elementu ($LELEM=70)
      DO I=1,MAXELEM
        AUX(I+$LELEM)=I
      ENDDO
C Totez pro nazvy parametru elementu ($LEPAR=90)
      DO I=1,MAXTEPAR
        AUX(I+$LEPAR)=I
      ENDDO
C Totez pro nazvy metod reseni FLOW ($LMETHOD=120, UVP,...)
      DO I=1,MAXMET
        AUX(I+$LMETHOD)=I
      ENDDO
C
      LENIT=LEN(ITEM)
C Ignorovani stredniku
      ISEMIC=INDEX(ITEM,';')
      IF(ISEMIC.GT.0)ITEM(ISEMIC:ISEMIC)=' '
      CALL TRAN(ITEM,LENIT,0,ICRPN,MAXCRPN,NRPN,IEND)
C Vypisy do souboru *.DBG
C TINQ je rizikova operace, ktera muze mit vedlejsi efekty,
C zalezi na tom, jaky prikaz uzivatel misto parametru uvede.
C TINQ by se mela potlacit pri provadeni prirazovacich prikazu
C u funkci TCF,TCFR
      CALL TINQ(ICRPN,NRPN,IAUX,TFUW,RP(L),9)
      TP(L)=ITEM
      IF(ABS(RP(L)).LE.1E6)THEN
         IP(L)=FLOOR(RP(L)+.5)
      ELSE
         IP(L)=0
      ENDIF
      END

      SUBROUTINE SELITE(LINE,J,ITEM,K)
C VYBER POLOZKY ITEM Z TEXTU LINE POZICI J+1 POCINAJE
      CHARACTER *(*) LINE,ITEM
      CHARACTER *3 SEP
      INTEGER ICOL(10)
      DATA SEP/' ;,'/
C NCOL je pocet carek, nahrazenych dvojteckou (MAX. 10)
      NCOL=0
      NL=LEN(LINE)
      I=J+1
C PRESKOCENI UVODNICH MEZER
      DO WHILE(I.LE.NL.AND.LINE(I:I).EQ.' ')
        I=I+1
      ENDDO
      IF(I.GE.NL)THEN
        K=-1
        GOTO 999
      ENDIF
C Testujeme pocty levych a pravych zavorek v polozce ITEM
C od pozice I az k pozici NL
      ILZAV=INDEX(LINE(I:NL),'(')
      IF(ILZAV.GT.0)THEN
        NZAV=0
        DO L=I,NL
           IF(LINE(L:L).EQ.'(')THEN
                NZAV=NZAV+1
           ELSEIF(LINE(L:L).EQ.')')THEN
                NZAV=NZAV-1
           ELSEIF(LINE(L:L).EQ.','.AND.NZAV.GT.0.AND.NCOL.LT.10)THEN
C nahrad carku dvojteckou a zapamatuj si jeji pozici
                LINE(L:L)=':'
                NCOL=NCOL+1
                ICOL(NCOL)=L
           ENDIF
        ENDDO
      ENDIF
      IMI=1000
      DO L=1,3
        ISEP=INDEX(LINE(I:NL),SEP(L:L))
        IF(ISEP.GT.0)IMI=MIN0(IMI,ISEP)
      ENDDO
C Po vyhledani separatoru restaurujeme puvodni carky
      DO L=1,NCOL
         IC=ICOL(L)
         LINE(IC:IC)=','
      ENDDO
      IF(IMI.EQ.1000)THEN
C KONEC RADKU
        ITEM=LINE(I:NL)
        K=0
      ELSE
        K=I+IMI-1
        IF(K.GT.I)THEN
           ITEM=LINE(I:K-1)
        ELSE
           ITEM=' '
        ENDIF
      ENDIF
999   CONTINUE
      END

      SUBROUTINE CITEM(ITEM)
C Vymezerovani retezce ITEM od prvni mezery nebo stredniku
      CHARACTER *4 ITEM
      LOGICAL SPACE
      SPACE=.FALSE.
      DO I=1,4
        IF(ITEM(I:I).EQ.';'.OR.ITEM(I:I).EQ.' '.OR.ITEM(I:I).EQ.',')
     /SPACE=.TRUE.
        IF(SPACE)ITEM(I:I)=' '
      ENDDO
      END
          
      SUBROUTINE TRAN(ITEM,LEN,INDCON,ICRPN,MAXCRPN,NCRPN,IEND)
C
C PREKLAD PROGRAMU (NEBO VYRAZU) pro dialog (INDCON=0) nebo 
C pro definovani funkci (INDCON=1,2,...,9)
C 
C ITEM*(LEN).  - prekladany text (od zacatku)
C INDCON (0,1,2,..,9) konstanty se ukladaji do zony konstant COMMON/FEM/ 
C                     (vektor IICONS )
C Zmena: vsechny nove konstanty se ukladaji do jedine spolecne zony pro 
C        funkce 1,2,...,9. Pouze konstanty, vyskytujici se v dialogovych vyrazech
C        (INDCON=0), se ukladaji jen docasne pro jedno pouziti
C ICRPN(NCRPN) - prelozeny vyraz do RPN (vystupni parametr)
C MAXCRP       - maximalni delka kodu RPN (vstupni parametr)
C NCRPN        - skutecna delka kodu RPN (vystupni parametr)
C IEND         - kod ukonceni 
C                IEND>= 0 spravny vysledek, =0 znamena docerpani textu
C                IEND<0   chyba syntaxe       
C COMMON /TRANDAT/ jmena a atributy promennych
C NVARSYS       - pocet preddefinovanych promennych a funkci (<MAXATR)
C NVARTOT       - Celkovy pocet promennych a funkci (>NVARSYS a <MAXATR)
C IATTR(2,MAXATR)-Atributy promennych a funkci
C                (1.radek pozice v zone FEM, 2.radek typ /1-R,2-I,3-RV,4-IV,5-F/)
C
      INCLUDE '$femloc'
	INCLUDE '$TRANDAT'
      CHARACTER *(*) ITEM
      CHARACTER *(MAXATR*8) NAMES
      DIMENSION ICRPN(MAXCRPN)
      EQUIVALENCE (NAME,NAMES)
C Kopirovani systemovych atributu do pracovni zony IATTW
      DO I=1,NVARTOT
         IATTW(1,I)=IATTR(1,I)
         IATTW(2,I)=IATTR(2,I)
      ENDDO
C Nova verze:
C NCONST zahrnuje nove definovane promenne (prikazy REAL...) a konstanty
C ktere byly pouzity pri definici funkci.
C ITEM -prekladany text delky LEN od zacatku (0). 
C NAMES vektor identifikatoru, IATTW atributy, 8-delka identifikatoru.
C NVARTOT vychozi pocet identifikatoru,
C LOCONST+NCONST  pocet preddefinovanych konstant a promennych IAUX(1),...
C LOCONST+MAXCON-1 maximalni index konstanty ve vektoru IAUX
C MAXCRPN max.pocet kodu ICRPN
C NLST posledni identifikator, KLST posledni konstanta, NCRPN kod RPN.
      CALL TRANSQ(ITEM,LEN,0,NAMES,IATTW,8,NVARTOT,
     / LOCONST+NCONST,
     / MAXATR,LOCONST+MAXCON-1,MAXCRPN, 
     / NLST,KLST,NCRPN, IAUX,ICRPN,IEND)
C Rozsireni seznamu promennych a konstant, kdyz se bud
C a) definovala nova funkce (rozsiri se NCONST o nove konstanty), nebo
C b) kdyz se interpretuje radek s explicitni deklaraci (real ...,int ...)
      IF((INDCON.GT.0.OR.NLST.GT.NVARTOT).AND.
     /   KLST-LOCONST.LT.MAXCON)THEN
         NCONST=KLST-LOCONST
         DO I=NVARTOT+1,NLST
           IATTR(1,I)=IATTW(1,I)
           IATTR(2,I)=IATTW(2,I)
         ENDDO
         NVARTOT=NLST
      ENDIF 
      END

      SUBROUTINE DEFPUM(KG,KR,ICLASS,D,Q,H)
c
c Vyber cerpadla z databaze SIGMA na zaklade nasledujicich udaju
C ICLASS=0 jakekoliv
C      =1 mlekarske  NPB
C      =2 vodarenske CVE
C      =3 napajeci   CHN
C      =4 vodni      CVX, VHD, SVA
C      =5 chemie potrav SPB-SPA
C      =6 jednovreten EFS EFM EFT EQPV
C      =7 monoblok   OVE
C D- POZADOVANY PRUMER SACIHO POTRUBI
C Q- PREDPOKLADANY PRUTOK
C H- PREDPOKLADANA VYTLACNA VYSKA
C
C soubor '$PUMPS.TXT'
C CLASS filename typ n Ds Dv Qmi Qmax Qmean Hmin Hmax Hmean
C
C parametry RC
C $D=D $P=Q 
C $H=H       odhadovana i vypoctena vytlacna vyska
C $RX8=QMIN $RX9=QMAX  
C $RX1=a    $RX2=b  $RX3=c    koeficienty Q=a+b.DP+c.DP^2
C $RX4=e    $RX5=f            koeficienty Q=e+f.DP
C $RX6=PMIN $RX7=PMAX
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEMB'
      CHARACTER(40) TYPE,TYPEBEST
      CHARACTER(12) FILENAME,FILEBEST,PURPOSE(7)
      LOGICAL EX
      DATA PURPOSE/'Milk,food','Waterworks','Feed pump','Water pump',
     /             'Chemistry','Screw pump','Monoblock'/
      IF(D.LE.0.)THEN
         CALL HELPC(4,'Nozzle diameter<=0 of pump. Repeat pump specifica
     /tion RCP.')
         RETURN
      ELSEIF(Q.LE.0.)THEN
         CALL HELPC(4,'Flowrate<=0 specified for a pump. Repeat RCP.')
         RETURN
      ENDIF
      KGROUP=KG
      KRCONS=KR
      MGROUP=MAX0(MGROUP,KGROUP)
      MRCONS=MAX0(MRCONS,KRCONS)
      JGROUP(KGROUP,$ENAME)=$PUMP
      JGROUP(KGROUP,$AXIS)=ICLASS
      RRCONS(KRCONS,$D)=D
      RRCONS(KRCONS,$P)=Q
      DIFMIN=1E10
C Look for file
      INQUIRE(FILE='$PUMPS.TXT',EXIST=EX)
      IF(EX)THEN
        OPEN(5,FILE='$PUMPS.TXT')
      ELSE
        OPEN(5,FILE='.\FILES\$PUMPS.TXT')
      ENDIF
      IBEST=0
      ICLBEST=1
      I=0
1     READ(5,*,END=100,ERR=100)ICL,FILENAME,TYPE,N,DS,DV,
     /     QMIN,QMAX,QMEAN,HMIN,HMAX,HMEAN
      I=I+1
      DIF=ABS((H-HMEAN)/H)+ABS((Q-QMEAN)/Q)+ABS((DS-D)/D)
      IF(DIF.LE.DIFMIN.AND.(ICLASS.EQ.0.OR.ICL.EQ.ICLASS))THEN
         ICLBEST=ICL
         FILEBEST=FILENAME
         TYPEBEST=TYPE
         NBEST=N
         DSBEST=DS
         DVBEST=DV
         HMAXBEST=HMAX
         QMAXBEST=QMAX        
         HMINBEST=HMIN
         QMINBEST=QMIN        
         HMEANBEST=HMEAN
         QMEANBEST=QMEAN        
         DIFMIN=DIF
         IBEST=I
      ENDIF
      GOTO 1
C Vypocet koeficientu kvadraticke charakteristiky cerpadla 
C a ulozeni do zonu RCONST
100   CLOSE(5)
      WRITE(9,101)TYPEBEST,PURPOSE(ICLBEST),IBEST,NBEST,DSBEST,DVBEST,
     /      QMINBEST,QMAXBEST,HMINBEST,HMAXBEST,QMEANBEST,HMEANBEST
101   FORMAT(/' Selected pump SIGMA ',A/' Purpose ',A,' catalogue',I4/
     /       ' No of stages=',I2/
     /       ' Ds=',E9.2,' Dv=',E9.2,' [m]'/
     /       ' Qmin=',E9.2,' Qmax=',E9.2,' [m^3/s]'/
     /       ' Hmin=',E9.2,' Hmax=',E9.2,' [m] discharge'/
     /       ' Design point Q=',E9.2,' H=',E9.2) 
C $D=D $P=Q $H=H $ALFA=QMIN $TE=QMAX  $AREA=a  $PERIM=b  $VOL=c 
      JGROUP(KGROUP,$METHOD)=IBEST
      RRCONS(KRCONS,$RX8) =QMINBEST
      RRCONS(KRCONS,$RX9) =QMAXBEST
      RRCONS(KRCONS,$H)   =HMEANBEST
      P1=9810*HMINBEST
      P2=9810*HMAXBEST
      P3=9810*HMEANBEST
      Q1=QMINBEST
      Q2=QMAXBEST
      Q3=QMEANBEST
      IF(Q3.LE.0.)THEN
        CALL HELPC(4,'Error in $PUMPS.TXT (damaged or empty file)')
        RETURN
      ENDIF
C Kvadraticka charakteristika
      DET=(P1-P2)*(P3-P1)*(P3-P2)
      IF(DET.NE.0.)THEN
        A0=((Q2-Q1)*(P3-P2)**2-(Q3-Q1)*(P1-P2)**2)/DET
        B0=((Q3-Q1)*(P1-P2)-(Q2-Q1)*(P3-P2))/DET
        A=Q1-A0*P2+B0*P2**2
        B=A0-2*B0*P2
        C=B0
        RRCONS(KRCONS,$RX1)=A
        RRCONS(KRCONS,$RX2)=B
        RRCONS(KRCONS,$RX3)=C
      ENDIF
C Linearni charakteristika
      RRCONS(KRCONS,$RX4)=Q2-P1*(Q3-Q2)/(P3-P1)      
      RRCONS(KRCONS,$RX5)=(Q3-Q2)/(P3-P1)      
      RRCONS(KRCONS,$RX6)=P1
      RRCONS(KRCONS,$RX7)=P2
      WRITE(10,200)(A+B*P2+C*P2**2),(A+B*P1+C*P1**2),(A+B*P3+C*P3**2)
200   FORMAT(' Qmin=',E10.3,' Qmax=',E10.3,' Qmean=',E10.3,' [m^3/s]')
      CALL PLOTCHAR(KRCONS,KGROUP)
C Vytazeni okna 22 do popredi
      IAUX(10)=1
      END

      SUBROUTINE PLOTCHAR(KR,KG)
C Vykresleni hydraulicke charakteristiky cerpadla
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      CHARACTER(12)FILENAME
      CHARACTER(40)TYPE
      INCLUDE '$FEMB'
      DIMENSION H(51),Q(51)
      LOGICAL EX
      IBEST=JGROUP(KG,$METHOD)
      IF(IBEST.LE.0)CALL HELPC(4,'Zero index of PUMP. Repeat RCP.')
C Look for file
      INQUIRE(FILE='$PUMPS.TXT',EXIST=EX)
      IF(EX)THEN
        OPEN(5,FILE='$PUMPS.TXT')
        CALL HELPC(4,'Pump selected from database $PUMPS.TXT in the curr
     /ent directory')
      ELSE
        OPEN(5,FILE='.\FILES\$PUMPS.TXT')
        CALL HELPC(4,'Pump selected from database $PUMPS.TXT in the dire
     /ctory \FILES')
      ENDIF
      DO I=1,IBEST
        READ(5,*,END=100,ERR=100)ICL,FILENAME,TYPE,N,DS,DV,
     /     QMIN,QMAX,QMEAN,HMIN,HMAX,HMEAN
      ENDDO
100   CLOSE(5)
      A=RRCONS(KR,$RX1)
      B=RRCONS(KR,$RX2)
      C=RRCONS(KR,$RX3)
      E=RRCONS(KR,$RX4)
      F=RRCONS(KR,$RX5)
C HMEAN - skutecna vyska v metrech vodniho sloupce (kladna)
      HMEAN=RRCONS(KR,$H)
      HMI=AMAX1(0.,AMIN1(HMEAN,HMIN))
      HMA=AMAX1(HMAX,HMEAN)
      IF(C.NE.0.)THEN
        DH=(HMA-HMI)/50.
        HH=HMI
        DO I=1,51
          P=HH*9800
          IF(HH.LE.HMIN)THEN
             Q(I)=E+F*P
          ELSE
             Q(I)=A+B*P+C*P*P
          ENDIF
          H(I)=HH
          HH=HH+DH
        ENDDO
        PMEAN=HMEAN*9810.
        IF(HMEAN.GE.HMIN)THEN
           QMEAN=A+B*PMEAN+C*PMEAN*PMEAN
        ELSE
           QMEAN=E+F*PMEAN
        ENDIF
        QMEAN=AMAX1(0.,QMEAN)
        QMA=AMAX1(QMEAN,QMAX)
C Graf
        II=SETACTIVEQQ(22)
        II=FOCUSQQ(22)
        II=SETBKCOLOR(15)
        CALL CLEARSCREEN($GCLEARSCREEN)
        CALL GMFSTW(5,1,22,5,8,'Q','H',0.,1.,0.,0.5,0.,QMA,HMI,HMA)
        CALL GMFAXE(5,3,15)
        CALL GMFPL(51,Q,H,0)
        CALL GMFMRK(QMEAN,HMEAN,20)
C nove nastaveni okna pro vypisy
        CALL GMFSTW(4,1,22,5,8,'Q','H',0.,1.,0.,1.,0.,1.,0.,1.)
        CALL GMFSW(4)
        II=LOADIMAGE('.\FILES\'//FILENAME,0,0)
C Vypis parametru do okna
        CALL GMFFONT(1,14)
        CALL GMFTEXT(.63,.95,0,40,TYPE)
        Q1000=QMEAN*1000
        IF(Q1000.GT.1.)THEN
           WRITE(TYPE,'(''Q='',F5.1,'' [l/s]'')')Q1000
        ELSE
           WRITE(TYPE,'(''Q='',F7.4,'' [l/s]'')')Q1000
        ENDIF
        CALL GMFTEXT(.63,.85,0,13,TYPE)
        WRITE(TYPE,'(''H=('',F4.0,'','',F4.0,'') [m]'')')HMIN,HMAX
        CALL GMFTEXT(.63,.75,0,17,TYPE)
        WRITE(TYPE,'(''No.of stages='',I3)')N
        CALL GMFTEXT(.63,.65,0,16,TYPE)
        WRITE(TYPE,'(''Ds='',F4.0,'' Dv='',F4.0)')DS*1000.,DV*1000.
        CALL GMFTEXT(.63,.55,0,15,TYPE)
        CALL GMFSW(1)
      ELSE
        CALL HELPC(4,'Error in pump characteristics selected from databa
     /se. Use RCP to select the pump correctly.')
      ENDIF
      END

      SUBROUTINE GMFEDLC(IUNIT,LINE,IEND)
C
C EDITACE RADKU TEXTU LINE (NAHRADA PRIKAZU READ(IUNIT,*)LINE
C KTERA ALE UMOZNUJE ROZLISIT UKONCENI KLAVESOU ESC A ENTER.
C VSTUPNI PARAMETR
C IUNIT - CISLO ZARIZENI (OKNA) NA KTERE JE NASTAVEN FOCUS
C LENG  - MAXIMALNI DELKA TEXTU LINE
C VYSTUPNI PARAMETR LINE *(*)
C IEND >0 UKONCENI SPECIALNI KLAVESOU
C      =0 UKONCENI ENTER
C      =-1 UKONCENI ESC
C 
C [Tab]  panel prikazu
C F1     vypis session
C F2     vypis $VARLIST
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      USE DIALOGM
      INCLUDE 'OPTION.FD'
      INCLUDE '$FEM'
	INCLUDE '$NAVIG'
      PARAMETER (MAXCOMM=50)
      CHARACTER*120 LCOMMAND(MAXCOMM)
      CHARACTER*56 LIST
      INTEGER RETINT
      LOGICAL RETLOG
      TYPE(DIALOG)DLG
      CHARACTER*(*) LINE
      CHARACTER*1 C
      INTEGER*2   COLRTX,COLRBK,COLINI,ROWINI,C1,C2
      TYPE (RCCOORD) TPOS
	INCLUDE '$WIN'
      CHARACTER*(LENLIN)TEXT
      DATA NCOMMANDS/0/
      LENG=LEN(LINE)
C IUNIT=0 - pouze ulozeni textu LINE do zasobniku
      IF(IUNIT.LE.0)GOTO 999
      LINE=''
      II=FOCUSQQ(IUNIT)
      IBK=GETBKCOLOR()
      COLRBK=INT2(IBK)
      IL=0
      IC=0
      CALL GETTEXTPOSITION(TPOS)
      COLINI=TPOS.COL
      ROWINI=TPOS.ROW
      DO WHILE((IC.LE.209.OR.IC.GE.260.AND.IC.LE.265).AND.IL.LT.LENG)
	  CALL GCU(C,IC)
c Pro dialog: testovani hodnoty IALGOR(50)-signal umozneni zapisu (COMPAQ toto omezeni nema, zapisuje se primo z dialogu)
c        IF(IALGOR(50).GT.0)THEN
c          KT=MIN0(IALGOR(50),MAXPAR)
c TPREDUC se snazi zkratit zapis cisel TP(1),... do kompaktniho tvaru
c          CALL TPREDUC(1,KT)
c          WRITE(1,'(A,1X,30(A,'',''))')TRIM(KEYW),(TRIM(TP(KK)),KK=1,KT)
c          IALGOR(50)=0
c        ENDIF
        SELECT CASE(IC)
        CASE(208)
C BACKSPACE=208 TAB=209
          IF(IL.GT.0)THEN
            CALL SETTEXTPOSITION(ROWINI,COLINI,TPOS)
            COLRTX=SETTEXTCOLOR(COLRBK)
            CALL OUTTEXT(LINE(1:IL))
            LINE(IL:IL)=' '
            CALL SETTEXTPOSITION(ROWINI,COLINI,TPOS)
            COLRBK=SETTEXTCOLOR(COLRTX)
            IL=MAX0(0,IL-1)
            CALL OUTTEXT(LINE(1:IL))
          ENDIF
        CASE(:122)
C IC<=122 normalni znaky A=65,...,Z=90, a=97,...,z=122
C musime rozlisit, zda je kurzor za koncem textu nebo uvnitr
            IL=MIN0(IL+1,LENG)
            LINE(IL:IL)=C
            CALL SETTEXTPOSITION(ROWINI,COLINI,TPOS)
C            LLAST=MIN0(120,IL+10)
            LLAST=MIN0(120,IL)
            CALL OUTTEXT(LINE(1:LLAST))
        CASE(209)
C Tabelator vola dialogove okno pro editaci radku
C -----------------------------------------------
           IF(.NOT.DLGINIT(IDD_GMFEDLC,DLG))THEN
              WRITE(*,*)' ERROR DIALOG NOT FOUND'
           ELSE
              RETLOG=DLGSET(DLG,IDC_COMMANDS,NCOMMANDS,DLG_NUMITEMS)
              DO I=1,NCOMMANDS
                II=NCOMMANDS-I+1
                RETLOG=DLGSET(DLG,IDC_COMMANDS,LCOMMAND(II),I)
              ENDDO
              RETINT=DLGMODAL(DLG)
              IF(RETINT.EQ.IDOK)THEN   
                RETLOG=DLGGET(DLG,IDC_COMMANDS,LINE)
                CALL DLGUNINIT(DLG)
                CALL SETTEXTPOSITION(ROWINI,COLINI,TPOS)
                CALL OUTTEXT(TRIM(LINE)//'            ')
                IC=213
                GOTO 500
              ELSE
                CALL DLGUNINIT(DLG)
              ENDIF
           ENDIF
        CASE(260)
C F2 vola okno pro zobrazeni seznamu promennych
C ---------------------------------------------
           CLOSE(88) 
           OPEN(88,FILE='./FILES/$VARLIST')
           unita =39
           CALL WOPENH(unita,labela(unita),ixpos(unita),iypos(unita),
     / ixpix(unita),iypix(unita),nrow(unita),ncol(unita),
     / ifontph(unita),ihfontph(unita),icursor(unita),
     / fontphattr(unita),
     / icfR(unita),icfG(unita),icfB(unita),
     / icbR(unita),icbG(unita),icbB(unita),ioldwopen)       
           II=SETBKCOLOR(3)
           CALL CLEARSCREEN($GCLEARSCREEN)
50         READ(88,'(A)',END=51)LIST
           IF(INDEX(LIST,'----------').GT.0)THEN
              C2=SETTEXTCOLOR(INT2(16))
           ELSE
              C2=SETTEXTCOLOR(INT2(11))
           ENDIF
           WRITE(39,'(1X,A)')LIST
           C1=SETTEXTCOLOR(C2)
           GOTO 50
51         CLOSE(88)
           IC=1
           C1=SETTEXTCOLOR(INT2(11))
           II=FOCUSQQ(10)
        CASE(261)
C F3 vola okno pro vypis session filu
C ---------------------------------------------
           LIST=TRIM(PROBLEM)//'.SES'
           unita =39
           CALL WOPENH(unita,LIST,ixpos(unita),iypos(unita),
     / ixpix(unita),iypix(unita),nrow(unita),ncol(unita),
     / ifontph(unita),ihfontph(unita),icursor(unita),
     / fontphattr(unita),
     / icfR(unita),icfG(unita),icfB(unita),
     / icbR(unita),icbG(unita),icbB(unita),ioldwopen)       
           II=SETBKCOLOR(3)
           CALL CLEARSCREEN($GCLEARSCREEN)
           REWIND 1
60         READ(1,'(A)',END=61)LIST
           WRITE(39,'(1X,A)')LIST
           GOTO 60
61         IC=1
           BACKSPACE 1
           II=FOCUSQQ(10)
        CASE(262)
C F4 vyber souboru pro napovedu
C ---------------------------------------------
           CALL DIAFIL1(IEND,'*.HLP',1)
           CLOSE(41)
           IF(IEND.EQ.0)THEN
              OPEN(41,FILE=TP(1))
              TEXT='F5-next step, F6-current step, F7-previous step.' 
              CALL HELPC(6,TEXT) 
	        NAVIG=.TRUE.
	     ELSE
	        NAVIG=.FALSE.
           ENDIF
71         II=FOCUSQQ(10)
        CASE(263)
C F5 nasledujici veta napovedy
C ---------------------------------------------
           INQUIRE(UNIT=41,OPENED=RETLOG)
           IF(RETLOG)THEN
80            READ(41,'(A)',ERR=81,END=81)TEXT
              IF(TEXT(1:1).EQ.':')GOTO 80
              CALL HELPC(6,TEXT) 
	        NAVIG=.TRUE.
              GOTO 82
81            CALL HELPC(6,'Repeat from the first step')
              NAVIG=.FALSE.
              REWIND 41
82            II=FOCUSQQ(10)
           ELSE
              CALL HELPC(6,'Open help file F4')
              II=FOCUSQQ(10)
           ENDIF
        CASE(264)
C F6 opakovani teze vety
C ---------------------------------------------
           CALL HELPC(6,TEXT) 
           II=FOCUSQQ(10)
        CASE(265)          
C F7 predchozi
C ---------------------------------------------
           INQUIRE(UNIT=41,OPENED=RETLOG)
           IF(RETLOG)THEN
              BACKSPACE 41
              BACKSPACE 41
90            READ(41,'(A)',END=91,ERR=91)TEXT
              IF(TEXT(1:1).EQ.':')GOTO 90
              CALL HELPC(6,TEXT) 
91            II=FOCUSQQ(10)
           ELSE
              CALL HELPC(6,'Open help file F4')
              II=FOCUSQQ(10)
           ENDIF
        END SELECT
      END DO
500   IF(IC.EQ.227)THEN
C IC=227 kod ESC
          IEND=-1
      ELSEIF(IC.EQ.213.OR.IC.EQ.999)THEN
C IC=213 kod ENTER
          IEND=0
      ELSE
C IC>122 specialni klavesy 259=F1, ...,270=F10
          IEND=IC
      ENDIF
C NEW LINE pouze kdyz nebyl BREAK pri cteni znaku
      IF(IC.NE.999)WRITE(IUNIT,*)
      CLOSE(39)
C Ulozeni radku do seznamu
999   IF(IEND.GE.0.AND.LEN(TRIM(LINE)).GT.1)THEN
         IF(NCOMMANDS.EQ.MAXCOMM)THEN
            DO I=1,NCOMMANDS-1
              LCOMMAND(I)=LCOMMAND(I+1)
            ENDDO
         ELSE
            NCOMMANDS=NCOMMANDS+1
         ENDIF
         LCOMMAND(NCOMMANDS)=TRIM(LINE)
      ENDIF
      END

      SUBROUTINE TPREDUC(I1,I2)
C Modifikace vsech textovych polozek TP(i1 az i2)
C Nahrazeni nul ve formatu jedinou nulou
C Nahrazeni 1.000 jedinou jednickou
C Vynechani E+00 
      INCLUDE '$FEM'
      CHARACTER*(LENITE)TAUX
      DO I=I1,I2
         TAUX=TRIM(ADJUSTL(TP(I)))
         LTAUX=LEN(TAUX)
         IF(TAUX.EQ.'.000'.OR.TAUX.EQ.'0.000')THEN
            TP(I)='0'
         ELSEIF(TAUX(2:LTAUX).EQ.'.000')THEN
            TP(I)=TAUX(1:1)
         ELSE
            IZ=INDEX(TAUX,'0E')
            IF(IZ.GT.1)THEN
              TP(I)=TAUX(1:IZ-1)//TAUX(IZ+1:LTAUX)
              TAUX=TRIM(ADJUSTL(TP(I)))
              LTAUX=LEN(TAUX)
              IZ=INDEX(TAUX,'0E')
              IF(IZ.GT.1)TP(I)=TAUX(1:IZ-1)//TAUX(IZ+1:LTAUX)
            ENDIF
         ENDIF
         TAUX=TRIM(ADJUSTL(TP(I)))
         LTAUX=LEN(TAUX)
         IZ=INDEX(TAUX,'E+00')
         IF(IZ.GT.1)THEN
           IF(IZ+4.LE.LTAUX)THEN
               TP(I)=TAUX(1:IZ-1)//TAUX(IZ+4:LTAUX)
           ELSE
               TP(I)=TAUX(1:IZ-1)
           ENDIF
         ENDIF
      ENDDO
      END

C      INCLUDE '$$-COMM.FOR'
