C $s4c-klo.for FITUBE a FISHELL pro kotlove vymeniky
C
      SUBROUTINE FITUBE(NCH,NT,TLT,DT2,RLT,RD1,FI2,RE,RHO)
      INCLUDE '$FEMEQ'

        DT1=DT2-2*TLT
        IF(RE.LE.2320)THEN
          XLAMBDA1=64/RE
        ELSE
          X9=(2.457*LOG(1/((7/RE)**0.9+0.27*RD1/DT1)))**16.
          X10=(37530./RE)**16.
          XLAMBDA1=8.*((8./RE)**12.+1./(X9+X10)**1.5)**(1./12.)
        ENDIF
        Z1=RLT/DT1
        Z2=1.
        XKAPA=XLAMBDA1*NCH*Z1*Z2+0.7*NCH+0.4*(NCH-1)
        FI2=3.14159*DT1**2.*NT/NCH/(XKAPA*8.*RHO)**0.5
      END SUBROUTINE


      SUBROUTINE FISHELL(TLT,DT2,ALFAT,DP1,XTP,SP,HP,
     /TT,DPS,NP,NCH,NPL,FI1,RE,RHO,VISC,Q,NT,XLTN,SPP,STP)
        DIMENSION S(2),D(2)
        INCLUDE '$FEMEQ'
C* vnitrni prumer trubky
        DT1=DT2-2*TLT
        IF(ALFAT.GT.25..AND.ALFAT.LE.35.)THEN
          C1=0.866
        ELSE
          C1=1.
        ENDIF
        FIVSC=2*ACOSD(2/(DPS-DT2)*(HP-DP1/2))
        XNTV=(DPS-DT2)**2/8/TT**2/C1*(FIVSC*3.14159/180-SIND(FIVSC))
        NTV=NINT(XNTV)
C* prutocy prurez TP        
        S(2)=(3.14159*DT1**2.*NT)/(4.*NCH)
        TT1=2.*TT*SIND(ALFAT)
        TT2=TT*COSD(ALFAT)
        STS=DP1-DPS
        STT=TT-DT2
        IF(ALFAT.GT.25..AND.ALFAT.LT.35.)THEN
          SUMSTT=(DPS-DT2)/TT1*STT
        ELSEIF(ALFAT.GT.85..AND.ALFAT.LE.90.)THEN
          SUMSTT=(DPS-DT2)/TT1*STT
        ELSE
          SUMSTT=(DPS-DT2)/TT1*STT*2
        ENDIF
        S(1)=(STS+SUMSTT)*(XTP-SP)
        D(2)=DT1
        D(1)=3.14159*DT2/2.
   
        IF(ALFAT.LE.38.)THEN
          IF(RE.LT.1.E1)THEN
            C1=48.
            A1=-1.
          ELSEIF(RE.GE.1.E1.AND.RE.LT.1.E2)THEN
            C1=45.1
            A1=-0.973
          ELSEIF(RE.GE.1.E2.AND.RE.LT.1.E3)THEN 
            C1=0.57
            A1=-0.476
          ELSEIF(RE.GE.1.E3.AND.RE.LT.1.E4)THEN
            C1=0.486
            A1=-0.152
          ELSEIF(RE.GE.1.E4)THEN
            C1=0.372
            A1=-0.123
          ENDIF
          C2=7.
          A2=0.5
          ELSEIF(ALFAT.GT.38.AND.ALFAT.LE.68.)THEN
          IF(RE.LT.1.E1)THEN
            C1=32.
            A1=-1.
          ELSEIF(RE.GE.1.E1.AND.RE.LT.1.E2)THEN
            C1=26.2
            A1=-0.913
          ELSEIF(RE.GE.1.E2.AND.RE.LT.1.E3)THEN 
            C1=3.5
            A1=-0.476
          ELSEIF(RE.GE.1.E3.AND.RE.LT.1.E4)THEN
            C1=0.333
            A1=-0.136
          ELSEIF(RE.GE.1.E4)THEN
            C1=0.303
            A1=-0.126
          ENDIF
          C2=6.59
          A2=0.52
          ELSEIF(ALFAT.GT.68.AND.ALFAT.LE.90.)THEN
          IF(RE.LT.1.E1)THEN
            C1=35.
            A1=-1.
          ELSEIF(RE.GE.1.E1.AND.RE.LT.1.E2)THEN
            C1=32.1
            A1=-0.963
          ELSEIF(RE.GE.1.E2.AND.RE.LT.1.E3)THEN 
            C1=6.09
            A1=-0.602
          ELSEIF(RE.GE.1.E3.AND.RE.LT.1.E4)THEN
            C1=0.0815
            A1=0.022
          ELSEIF(RE.GE.1.E4)THEN
            C1=0.391
            A1=-0.148
          ENDIF
          C2=6.30
          A2=0.378
          ENDIF

          AX=C2/(1+0.14*RE**A2)
          XLAMBDA2=C1*(1.33*DT2/TT)**AX*RE**A1
          Z2=1.

C  SOUCINITEL Z3     
      
          IF(RE.LT.100)THEN
            C1Z=4.5
          ELSE
            C1Z=3.7
          ENDIF
  
          SSS=(DP1-DPS-STT)*(XTP-SP)

          NRP=(2*HP-DP1)/TT2 
          IF(NPL.GE.(NRP/2.).OR.STT.GE.(DP1-DPS))THEN
            Z3=1.
          ELSE
            Z3=EXP(-C1Z*SSS/S(1)*(1.-(2.*NPL/NRP)**(1./3.)))
          ENDIF

          IF((SSS/S(1)).LE.0.5)THEN
            WRITE(2,*)'$s4c-klo: NENI SPLNENA PODMINKA PRO SOUCINITEL
     /VLIVU OBTOKOVYCH PROUDU (Z3)'
            Z3=1.
          ENDIF

C  KONEC VYPOCTU SOUCINITELE Z3


C  SOUCINITEL Z4
       
          DT2P=DT2+2*STP
          STPP=(NT-NTV/2.)*3.14159*(DT2P**2.-DT2**2.)/4.
          DPP=DP1-2*SPP
          FIVP=2*ACOSD(2.*HP/DP1-1.)
          SPS=3.14159/4.*(DP1**2-DPP**2)*(360.-FIVP)/360.
          X13=(-0.15*(1+SPS/(SPS+STPP)))+0.8
          Z4=EXP(-1.33*(1+SPS/(SPS+STPP))*((SPS+STPP)/S(1))**X13)

C KONEC VYPOCTU SOUCINITELE Z4


C  SOUCINITEL Z5

          IF(RE.LT.100.)THEN
            AX=1. 
          ELSE
            AX=0.2
          ENDIF
            Z5=2.*(2.*XTP/XLTN)**(2.-AX)

C KONEC VYPOCTU SOUCINITELE Z5
          DPSS=DPS-dt2
          FIVS=2*ACOSD(2/DPSS*(HP-DP1/2))
          IF(NPL.EQ.0)THEN
            SVN=3.14159*DP1**2/4.*(FIVP/360-SIND(FIVP)/2./3.14159)
          ELSE
            SVN=3.14159*DP1**2/4.*(FIVS/360-SIND(FIVS)/2./3.14159)
          ENDIF
          SVZ=SVN-NTV*3.14159*DT2**2/4.
          DHV=4.*SVZ/(NTV*3.14159*DT2+3.14159*DP1*FIVP/360.)
          QS=AMAX1(Q,1.E-8)
          XNRV=0.8/TT2*((DP1+DPS-DT2)/2-HP)
          NRV=NINT(XNRV)
          IF(RE.LE.100)THEN
            XKAPA=0.5+(13.*VISC*RHO*(S(1)*SVZ)**0.5)/QS*
     /(NRV/(TT-DT2)+XTP/DHV**2)
            XOMEGA=XLAMBDA2*NRP*(NP-1)*Z2*Z3*Z4/S(1)**2+XLAMBDA2*
     /(NRP+NRV)*Z2*Z3*Z5/S(1)**2+NP*Z4*XKAPA/S(1)/SVZ
            FI1=1/(2*RHO*XOMEGA)**0.5
          ELSE
            XOMEGA=2*XLAMBDA2*NRP*(NP-1)*Z2*Z3*Z4/S(1)**2+2*XLAMBDA2*
     /(NRP+NRV)*Z2*Z3*Z5/S(1)**2+NP*((2+0.6*NRV)/2/S(1)/SVZ)*Z4
            FI1=1/(RHO*XOMEGA)**0.5 
          ENDIF
      END SUBROUTINE

      SUBROUTINE FISHELLH(TLT,DT2,ALFAT,DP1,HS,SP,FIS,
     /TT,DPS,NCH,NPL,FI1,RE,RHO,NT,DMT,RLT,XLT0)
         DIMENSION S(2),D(2)
        INCLUDE '$FEMEQ'
       

        DT1=DT2-2*TLT
        S(2)=(3.14159*DT1**2.*NT)/(4.*NCH)
        TT1=TT*SIND(ALFAT)*2.
        TT2=TT*COSD(ALFAT)
        IF(ALFAT.GT.25..AND.ALFAT.LE.35.)THEN
          C2=0.866
        ELSEIF(ALFAT.GT.50..AND.ALFAT.LE.70.)THEN
          C2=0.866
        ELSE
          C2=0.707
        ENDIF
        IF(DMT.EQ.0)THEN
          S(1)=((DP1-DPS)/2+(DPS-DT2)*(1+1/C2)*(TT-DT2)/4/TT)*
     /(HS-SP/COSD(FIS))
        ELSE
          S(1)=((DP1-DPS)/2+(DPS-DMT-2*DT2)*(1+1/C2)*(TT-DT2)/4/TT)*
     /(HS-SP/COSD(FIS))
        ENDIF
        D(2)=DT1
        D(1)=3.14159*DT2/2.
   
        IF(ALFAT.LE.38.)THEN
          IF(RE.LT.1.E1)THEN
            C1=48.
            A1=-1.
          ELSEIF(RE.GE.1.E1.AND.RE.LT.1.E2)THEN
            C1=45.1
            A1=-0.973
          ELSEIF(RE.GE.1.E2.AND.RE.LT.1.E3)THEN 
            C1=0.57
            A1=-0.476
          ELSEIF(RE.GE.1.E3.AND.RE.LT.1.E4)THEN
            C1=0.486
            A1=-0.152
          ELSEIF(RE.GE.1.E4)THEN
            C1=0.372
            A1=-0.123
          ENDIF
        C2=7.
        A2=0.5
        ELSEIF(ALFAT.GT.38.AND.ALFAT.LE.68.)THEN
          IF(RE.LT.1.E1)THEN
            C1=32.
            A1=-1.
          ELSEIF(RE.GE.1.E1.AND.RE.LT.1.E2)THEN
            C1=26.2
            A1=-0.913
          ELSEIF(RE.GE.1.E2.AND.RE.LT.1.E3)THEN 
            C1=3.5
            A1=-0.476
          ELSEIF(RE.GE.1.E3.AND.RE.LT.1.E4)THEN
            C1=0.333
            A1=-0.136
          ELSEIF(RE.GE.1.E4)THEN
            C1=0.303
            A1=-0.126
          ENDIF
        C2=6.59
        A2=0.52
        ELSEIF(ALFAT.GT.68.AND.ALFAT.LE.90.)THEN
          IF(RE.LT.1.E1)THEN
            C1=35.
            A1=-1.
          ELSEIF(RE.GE.1.E1.AND.RE.LT.1.E2)THEN
            C1=32.1
            A1=-0.963
          ELSEIF(RE.GE.1.E2.AND.RE.LT.1.E3)THEN 
            C1=6.09
            A1=-0.602
          ELSEIF(RE.GE.1.E3.AND.RE.LT.1.E4)THEN
            C1=0.0815
            A1=0.022
          ELSEIF(RE.GE.1.E4)THEN
            C1=0.391
            A1=-0.148
          ENDIF
          C2=6.30
          A2=0.378
          ENDIF

          AX=C2/(1+0.14*RE**A2)
          XLAMBDA2=C1*(1.33*DT2/TT)**AX*RE**A1
          Z2=1.

C  SOUCINITEL Z3      
        
        IF(RE.LT.100)THEN
          C1Z=4.5
        ELSE
          C1Z=3.7
        ENDIF
        IF(ALFAT.GT.25..AND.ALFAT.LE.35.)THEN
          IF(DMT.EQ.0)THEN
            SUMSTT=1/TT/2*(DPS-DT2)*(TT-DT2)*2.1547
          ELSE
            SUMSTT=1/TT/2*(DPS-DMT-2*DT2)*(TT-DT2)*2.1547
          ENDIF
        ELSEIF(ALFAT.GT.50..AND.ALFAT.LE.70.)THEN
          IF(DMT.EQ.0)THEN
            SUMSTT=1/TT/2*(DPS-DT2)*(TT-DT2)*2.1547
          ELSE
            SUMSTT=1/TT/2*(DPS-DMT-2*DT2)*(TT-DT2)*2.1547
          ENDIF
        ELSE
          IF(DMT.EQ.0)THEN
            SUMSTT=1/TT/2*(DPS-DT2)*(TT-DT2)*2.4142
          ELSE
            SUMSTT=1/TT/2*(DPS-DMT-2*DT2)*(TT-DT2)*2.4142
          ENDIF
        ENDIF
        STS=DP1-DPS
        STT=TT-DT2
        SZ=0.5*(STS+SUMSTT)*(HS-SP/COSD(FIS))
        SSS=0.5*(DP1-DPS-STT)*(HS-SP/COSD(FIS))
        IF(NPL.GE.(DP1/6./TT).OR.STT.GE.(DP1-DPS))THEN
          Z3=1.
        ELSE
          Z3=EXP(-C1Z*SSS/SZ*(1.-(2.*NPL**3*TT/3.14159/DP1)**(1./3.)))
        ENDIF

        IF((SSS/SZ).LE.0.5)THEN
          WRITE(2,*)'PIPE2: NENI SPLNENA PODMINKA PRO SOUCINITEL
     /VLIVU OBTOKOVYCH PROUDU'
          Z3=1.
        ENDIF

C  KONEC VYPOCTU SOUCINITELE Z3


C  SOUCINITEL Z5
        IF(RE.LT.100)THEN
          XA=1
        ELSE
          XA=0.2
        ENDIF
        Z5=(2*HS/(RLT+HS+XLT0))**(2-XA)
C KONEC VYPOCTU SOUCINITELE Z5

C  SOUCINITEL Z6
        Z6=0.3614*EXP(-0.478*(3.14159/180*(90-FIS))**(-1.733))
C KONEC VYPOCTU SOUCINITELE Z6

C  SOUCINITEL Z7
        IF(RE.LE.100)THEN
          Z7=1.
        ELSEIF(RE.GE.5000)THEN
          Z7=-5.589+0.3848*FIS-0.004044*FIS**2
          IF(Z7.LT.1.)THEN
            WRITE(2,*)'NENI SPLNENA PODMINKA PRO SOUCINITEL Z7'
            Z7=1.
          ENDIF
        ELSE
          ZX=-5.589+0.3848*FIS-0.004044*FIS**2
          Z7=(ZX-1)/4900*(RE-100)+1
          IF(Z7.LT.1.)THEN
            WRITE(2,*)'NENI SPLNENA PODMINKA PRO SOUCINITEL Z7'
            Z7=1.
          ENDIF
        ENDIF
C KONEC VYPOCTU SOUCINITELE Z7
        IF(ALFAT.GT.25..AND.ALFAT.LE.35.)THEN
          XC1=1.366
        ELSEIF(ALFAT.GT.50..AND.ALFAT.LE.70.)THEN
          XC1=1.366
        ELSE
          XC1=1.707
        ENDIF

        XNR1=3.14159*(DPS+DMT)/TT/XC1
        FI1=S(1)*COSH(FIS)/(2.*XLAMBDA2*XNR1*RHO*Z2*Z3*Z6*Z7*
     /(XLT0/HS+Z5))**0.5

      END	SUBROUTINE


