c  Nelinearni regrese Marquardt dle Numerical recipes (Axialni disperse) 
      PARAMETER (NCVM=10,NDM=5096)
C SIG -
      DIMENSION X(NDM),Y(NDM),SIG(NDM),COVAR(NCVM,NCVM),DYDA(NCVM)
      DIMENSION LISTA(NCVM),ALPHA(NCVM,NCVM),AOLD(NCVM),ASTART(NCVM,8)
      COMMON /$REGRES/MODEL,A(NCVM)
      EXTERNAL FUN,FUNLIN
      LOGICAL DEFSIG

      OPEN(1,FILE='RANNREG.DAT')
      READ(1,*,END=1000,ERR=1000)MODELI,NDATA
      DEFSIG=.TRUE.
      DO I=1,NDATA
         READ(1,*,END=1000,ERR=1000)IDUMMY,X(I),Y(I),SIG(I)
         IF(SIG(I).GT.0.)DEFSIG=.FALSE.
      ENDDO
      IF(DEFSIG)SIG=1.
      CLOSE(1)
	OPEN(2,FILE='$RANNREG.DBG')
      OPEN(1,FILE='RANNREG.OUT')
	Open(3,file='RANREGC.OUT',access='append')
      WRITE(1,'('' ERROR IN RANNREG PROCESSING'')')
      CLOSE(1)
C MODEL=1  A1+A2*EXP(-A3*X)
C MODEL=2  A1+A2*EXP(-A4*X)+A3*EXP(-A5*X)
C MODEL=3  A1+A2*EXP(-((X-A3)/A4)**2)
C MODEL=4  (A1+A2*X)/(1+A3*X)
C MODEL=5  A1/(1+A2*exp(-A3*X))
C MODEL=6  A1*X**(A3-1)*EXP(-A2*X)
C MODEL=7  A1*exp(-(A3-X)**2/X)/X^.5
C MODEL=8  A1*exp(-(A3-X)**2/X)/X^1.5
C MODEL=9  A1+A2*SIN(A3*X+A4)
C MODEL=10 A1+A2*X+A3*SIN(A4*X+A5)
C MODEL=11 A1+A2*SIN(A4*X+A5)+A3*SIN(A6*X+A7)
C MODEL=12 A1*X^A2
C MODEL=13 A1*X**(A4-1)*EXP(-A3*X)+A2*X**(A6-1)*EXP(-A5*X)
C MODEL=14 A1+A2*exp(-A3(A4-X)**2/X)/X^.5
C MODEL=15 A1+A2*exp(-A3(A4-X)**2/X)/X^1.5
C MODEL=16 A1+A2*X**(A4-1)*EXP(-A3*X)
C MODEL=17 (A1*/(3.14*A2*X))^.5*EXP[-A1(A2-X)**2/(A2*X)] 
C MODEL=18 (A1*/(3.14*A2*X^3))^.5*EXP[-A1(A2-X)**2/(A2*X)] 
C MODEL=19 A1+A2*X^a3 
C MODEL=20 A1+A2*X+A3*X^a4
C MODEL=21 A1+A2/(a5+X)+A3*X+A4*X^2 
C MODEL=22 A1+A2/(A5+X)+(A3+A4.X).EXP(-((X-A6)/A7)^2)
C MODEL=23 A1+A2.X+A3.J0(A5.X)+A4.J1(A6.X)
C MODEL=24 A1+A2.J0(A4.X)+A3.EXP(-A5.X)
C MODEL=25 A1+A2.J1(A4.X)+A3.EXP(-A5.X)
      XRANGE=ABS(X(NDATA)-X(1))
      IF(XRANGE.LE.1E-10)STOP
      YMA=-1E10
      YMEAN=0
      DO I=1,NDATA
        IF(ABS(Y(I)).GT.YMA)THEN
           YMA=ABS(Y(I))
           XMA=X(I)
        ENDIF
        YMEAN=YMEAN+Y(I)
      ENDDO
      YMEAN=YMEAN/NDATA
C
      IF(MODELI.LE.0)THEN
         MODEL1=1
         MODEL2=25
         NITER=50
      ELSE
         MODEL1=MODELI
         MODEL2=MODELI
         NITER=300
      ENDIF
      BEST=1E8
      DO MODEL=MODEL1,MODEL2
	  NREP=1
        SELECT CASE(MODEL)
         CASE(1)
           MFIT=3
           MLIN=2
           A(3)=1/X(NDATA)
         CASE(2)
           MFIT=5
           MLIN=3
	     NREP=4
	     ASTART(4,1:NREP)=(/5.,5.,10.,10./)
	     ASTART(5,1:NREP)=(/1.,2.,1.,3./)
	     DO K=1,NREP
             ASTART(4,K)=ASTART(4,K)/X(NDATA)
             ASTART(5,K)=ASTART(5,K)/X(NDATA)
	     ENDDO
         CASE(3)
           MFIT=4
           MLIN=2
           A(3)=XMA
           A(4)=0.3*X(NDATA)
         CASE(4)
           MFIT=3
           MLIN=2
           A(3)=1./X(NDATA)
         CASE(5)
           MFIT=3
           MLIN=1
           A(2)=.5
           A(3)=2/X(NDATA)
         CASE(6)
           MFIT=3
           MLIN=1
           A(3)=3
           A(2)=2/X(NDATA)
         CASE(9)
           MFIT=4
           MLIN=2
           A(3)=9/XRANGE
           A(4)=0
         CASE(10)
           MFIT=5
           MLIN=3
           A(4)=9/XRANGE
           A(5)=0
         CASE(11)
           MFIT=7
           MLIN=3
           A(4)=9/XRANGE
           A(5)=0
           A(6)=20/XRANGE
           A(7)=0
         CASE(12)
           MFIT=2
           MLIN=1
           NPOS=0
           SX=0
           SY=0
           SXY=0
           SXX=0
           DO I=1,NDATA
             XX=X(I)
             YY=Y(I)
             IF(XX.GT.0..AND.YY.GT.0.)THEN
               NPOS=NPOS+1
               XL=ALOG(XX)
               YL=ALOG(YY)
               SX=SX+XL
               SY=SY+YL
               SXX=SXX+XL*XL
               SXY=SXY+XL*YL
             ENDIF
           ENDDO
           DET=NPOS*SXX-SX*SX
           IF(DET.NE.0.)A(2)=(NPOS*SXY-SX*SY)/DET
         CASE(13)
           MFIT=6
           MLIN=2
	     NREP=8
	     ASTART(4,1:NREP)=(/2.,2.,2.,2.,3.,4.,4.,4./)
	     ASTART(6,1:NREP)=(/4.,5.,6.,8.,5.,6.,8.,10./)
           XXX=AMAX1(1E-10,X(NDATA)*.3)
	     DO K=1,NREP
C             ASTART(3,K)=(ASTART(4,K)-1.)*ALOG(XXX)/XXX
C             ASTART(5,K)=(ASTART(6,K)-1.)*ALOG(XXX)/XXX
             ASTART(3,K)=(ASTART(4,K)-1.)/XXX
             ASTART(5,K)=(ASTART(6,K)-1.)/XXX
	     ENDDO
         CASE(14,15)
           MFIT=4
           MLIN=2
           A(3)=X(NDATA)
           A(4)=XMA
         CASE(16)
           MFIT=4
           MLIN=2
	     NREP=4
           ASTART(4,1:NREP)=(/1.5,2.,3.,5./)
           ASTART(3,1:NREP)=2/X(NDATA)
	   CASE(17,18)
	     MFIT=2
           MLIN=0
           A(1)=6.
           A(2)=X(NDATA)/3
	   CASE(19)
	     MFIT=3
	     MLIN=2
	     A(3)=1
	   CASE(20)
	     MFIT=4
	     MLIN=3
	     NREP=4
	     ASTART(4,1:NREP)=(/.5,1.5,2.,3./)
	   CASE(21)
	     MFIT=5
	     MLIN=4
	     A(5)=X(NDATA)/3.
	   CASE(22)
	     MFIT=7
	     MLIN=4
	     A(5)=X(NDATA)
	     A(6)=X(NDATA)/3.
	     A(7)=X(NDATA)/3.
         CASE(23)
	     MFIT=6
	     MLIN=4
	     IF(XMA.GT..05*X(NDATA).AND.XMA.LT..5*X(NDATA))THEN
	         A(6)=2./XMA
	     ELSE
               A(6)=10/X(NDATA)
	     ENDIF
	     A(5)=5/X(NDATA)
         CASE(24,25)
	     MFIT=5
	     MLIN=3
           A(4)=10./X(NDATA)
	     A(5)=1./X(NDATA)
         CASE DEFAULT
           MFIT=3
           MLIN=1
           A(2)=X(NDATA)
           A(3)=XMA
        END SELECT
        IF(NDATA.LE.MFIT.OR.MFIT.GT.NCVM)STOP
	  DO IREP=1,NREP
C Opakovani reseni pro tentyz model, ale s jinym nastrelem A(i)
        IF(NREP.GT.1)THEN
	     DO I=MLIN+1,MFIT
	        A(I)=ASTART(I,IREP)
	     ENDDO
	  ENDIF
C Linear regression
        IF(MLIN.GT.0)THEN
           DO I=1,MLIN
             LISTA(I)=I
           ENDDO
           CALL LFIT(X,Y,SIG,NDATA,A,MLIN,LISTA,MLIN,COVAR,NCVM,CHISQ,
     /                                                     FUNLIN)
        WRITE(*,'('' Linearisation. Estimated parameters''/1X,5E10.3)')
     /(A(I),I=1,MFIT)
        ENDIF
C Nonlinear regression
        DO I=1,MFIT
          LISTA(I)=I
        ENDDO
        ALAMDA=-1.
        CALL MRQMIN(X,Y,SIG,NDATA,A,MFIT,LISTA,MFIT,COVAR,ALPHA,NCVM,
     /            CHISQ,FUN,ALAMDA,IER)
        IF(IER.NE.0)THEN
           CHISQ=1E10
           GOTO 888
        ENDIF
        DO ITER=1,NITER
           AOLD=A
           CALL MRQMIN(X,Y,SIG,NDATA,A,MFIT,LISTA,MFIT,COVAR,ALPHA,NCVM,
     /            CHISQ,FUN,ALAMDA,IER)
           IF(IER.NE.0)THEN
              WRITE(*,*)' Error in MRQMIN ',ier
              A=AOLD
              CHISQ=1E10
              EXIT
           ENDIF
           WRITE(*,'('' Model'',i2,'' Iter'',i2,'' chisq='',e12.5,'' Lam
     /='',e9.2)')MODEL,ITER,CHISQ,ALAMDA
           IF(ALAMDA.GT.1E5)EXIT
        ENDDO
        ALAMDA=0
        CALL MRQMIN(X,Y,SIG,NDATA,A,MFIT,LISTA,MFIT,COVAR,ALPHA,NCVM,
     /            CHISQ,FUN,ALAMDA,IER)
        Q=GAMMQ(0.5*(NDATA-MFIT),0.5*CHISQ)
        WRITE(*,777)MODEL,CHISQ,(A(I),I=1,MFIT)
        WRITE(2,777)MODEL,CHISQ,(A(I),I=1,MFIT)
777     FORMAT(' MODEL',I3,' CHISQ=',E12.5/' P:',8E11.3)
C
888     CONTINUE
C end of nonlinear regression
C Test best results
        IF(CHISQ.LT.BEST)THEN
          BEST=CHISQ
          OPEN(1,FILE='RANNREG.OUT')
          WRITE(1,'(I3,\)')MODEL
          SELECT CASE(MODEL)
          CASE(1)
      WRITE(1,'('' NONLINEAR REGRESSION A1+A2*EXP(-A3*X)'')')
          CASE(2)
      WRITE(1,'('' NONLINEAR REGRESSION A1+A2*EXP(-A4*X)+A3*EXP(-A5*X)''
     /)')
          CASE(3)
      WRITE(1,'('' NONLINEAR REGRESSION A1+A2*EXP(-((X-A3)/A4)**2)'')')
          CASE(4)
      WRITE(1,'('' NONLINEAR REGRESSION (A1+A2*X)/(1+A3*X)'')')
          CASE(5)
      WRITE(1,'('' NONLINEAR REGRESSION A1/(1+A2*exp(-A3*X))'')')
          CASE(6)
      WRITE(1,'('' NONLINEAR REGRESSION A1*X**(A3-1)*EXP(-A2*X)'')')
          CASE(7)
      WRITE(1,'('' NONLINEAR REGRESSION A1*exp(-A2(A3-X)^2/X)/X^.5'')')
          CASE(8)
      WRITE(1,'('' NONLINEAR REGRESSION A1*exp(-A2(A3-X)^2/X)/X^1.5'')')
          CASE(9)
      WRITE(1,'('' NONLINEAR REGRESSION A1+A2*sin(A3*X+A4)'')')
          CASE(10)
      WRITE(1,'('' NONLINEAR REGRESSION A1+A2*X+A3*sin(A4*X+A5)'')')
          CASE(11)
      WRITE(1,'('' NONLINEAR REGRESSION A1+A2*SIN(A4*X+A5)+A3*SIN(A6*X+A
     /7)'')')
          CASE(12)
      WRITE(1,'('' NONLINEAR REGRESSION A1*X^A2'')')
          CASE(13)
      WRITE(1,'('' NONLINEAR REGRESSION A1*X^(A4-1)*EXP(-A3*X)+A2*X^(A6-
     /1)*EXP(-A5*X)'')')
          CASE(14)
      WRITE(1,'('' NONLINEAR REGRESSION A1+A2*exp(-A3(A4-X)^2/X)/X^.5'')
     /')
          CASE(15)
      WRITE(1,'('' NONLINEAR REGRESSION A1+A2*exp(-A3(A4-X)^2/X)/X^1.5''
     /)')
          CASE(16)
      WRITE(1,'('' NONLINEAR REGRESSION A1+A2*X**(A4-1)*EXP(-A3*X)'')/')
	    CASE(17)
      WRITE(1,'('' NONLINEAR REGRESSION (A1/(A2*3.14*X))^.5*EXP(-A1*(A2-
     /X)^2/(X*A2))'')')
	    CASE(18)
      WRITE(1,'('' NONLINEAR REGRESSION (A1/(A2*3.14*X^3))^.5*EXP(-A1*(A
     /2-X)^2/(X*A2))'')')
	    CASE(19)
      WRITE(1,'('' NONLINEAR REGRESSION A1+A2*X^A3'')')
	    CASE(20)
      WRITE(1,'('' NONLINEAR REGRESSION A1+A2*X+A3*X^A4'')')
	    CASE(21)
      WRITE(1,'('' NONLINEAR REGRESSION A1+A2/(A5+X)+A3*X+A4*X^2'')')
	    CASE(22)
      WRITE(1,'('' NONLINEAR REGRESSION A1+A2/(A5+X)+(A3+A4*X)*EXP(-((X-
     /A6)/A7)^2)'')')
	    CASE(23)
      WRITE(1,'('' NONLINEAR REGRESSION A1+A2.X+A3.J0(A5.X)+A4.J1(A6.X)'
     /')')
	    CASE(24)
      WRITE(1,'('' NONLINEAR REGRESSION A1+A2.J0(A4.X)+A3.EXP(-A5.X)'')'
     /)
	    CASE(25)
      WRITE(1,'('' NONLINEAR REGRESSION A1+A2.J1(A4.X)+A3.EXP(-A5.X)'')'
     /)
	    case(26)
	write(1,'('' novy model'')')
          END SELECT
          SUMD=0
          SUMM=0
          YMI=1E10
          YMA=-1E10
          NFIT=0
          DO I=1,NDATA
            IF(SIG(I).GT.0.)THEN
              CALL FUN(X(I),A,S,DYDA,MFIT)
              SUMD=SUMD+(Y(I)-S)**2
              SUMM=SUMM+(Y(I)-YMEAN)**2
              YMI=AMIN1(YMI,Y(I))
              YMA=AMAX1(YMA,Y(I))
              NFIT=NFIT+1
            ENDIF
          ENDDO
          IF(SUMM.GT.0.)R=SQRT(AMAX1(0.,1.-SUMD/SUMM))
          IF(NFIT.GT.MFIT)STDEV=SQRT(SUMD/(NFIT-MFIT))
          WRITE(1,1)MFIT,(A(LISTA(I)),I=1,MFIT)
          WRITE(3,1)MFIT,(A(LISTA(I)),I=1,MFIT)
1         FORMAT(I3,' -parameters:'/10E12.4)
          WRITE(1,2)NDATA,STDEV,R,CHISQ,Q
2         FORMAT(I5,' points Stdev=',E10.4,' R=',F6.4,' CHISQ=',E10.4,
     /' Probability=',E9.3/' Covariance matrix')
          DO I=1,MFIT
            WRITE(1,'(10E11.3)')(COVAR(I,J),J=1,MFIT)
          ENDDO
          WRITE(1,3)
3         FORMAT(' PREDICTION (X,Ydata,Ymodel)')
          DO I=1,NDATA
            CALL FUN(X(I),A,S,DYDA,MFIT)
            WRITE(1,'(3E12.4)')X(I),Y(I),S
          ENDDO
          WRITE(1,4)X(1),X(NDATA),YMI,YMA
4         FORMAT(' Range XMIN,XMAX, YMIN,YMAX'/4e11.3)
          XX=X(1)
          DX=(X(NDATA)-X(1))/199
          DO I=1,200
            CALL FUN(XX,A,S,DYDA,MFIT)
            WRITE(1,'(2E12.4)')XX,S
            XX=XX+DX
          ENDDO
          CLOSE(1)
C ENDIF zpracovani zatim nejlepsiho vysledku
        ENDIF
C ENDDO opakovani reseni s jinym nastrelem
	  ENDDO
C ENDDO dalsi model 
      ENDDO
1000  CLOSE(1)
      CLOSE(2)
      END

      SUBROUTINE FUNLIN(X,B,M)
C MODEL=1  A1+A2*EXP(-A3*X)
C MODEL=2  A1+A2*EXP(-A4*X)+A3*EXP(-A5*X)
C MODEL=3  A1+A2*EXP(-((X-A3)/A4)**2)
      PARAMETER (NCVM=10)
      COMMON /$REGRES/MODEL,A(NCVM)
      DIMENSION B(*)
      MDUM=M
      B(1)=1
      SELECT CASE(MODEL)
      CASE(1)
        B(2)=EXP(-A(3)*X)
      CASE(2)
        B(2)=EXP(-A(4)*X)
        B(3)=EXP(-A(5)*X)
      CASE(3)
        B(2)=EXP(-((X-A(3))/A(4))**2)
      CASE(4)
        B(1)=1/(1+A(3)*X)
        B(2)=X/(1+A(3)*X)
      CASE(5)
        B(1)=1/(1+A(2)*EXP(-A(3)*X))
      CASE(6)
        XM=AMAX1(1E-3,X)
        B(1)=XM**(A(3)-1)*EXP(-A(2)*XM)
      CASE(7)
        XM=AMAX1(1E-3,X)
        B(1)=EXP(-A(2)*(XM-A(3))**2/XM)/SQRT(XM)
      CASE(8)
        XM=AMAX1(1E-3,X)
        B(1)=EXP(-A(2)*(XM-A(3))**2/XM)/XM**1.5
      CASE(9)
        B(2)=SIN(A(3)*X+A(4))
      CASE(10)
        B(2)=X
        B(3)=SIN(A(4)*X+A(5))
      CASE(11)
        B(2)=SIN(A(4)*X+A(5))
        B(3)=SIN(A(6)*X+A(7))
      CASE(12)
        IF(X.GT.0.)B(1)=X**A(2)
      CASE(13)
        XM=AMAX1(1E-5,X)
        B(1)=XM**(A(4)-1)*EXP(-A(3)*XM)
        B(2)=XM**(A(6)-1)*EXP(-A(5)*XM)
      CASE(14)
        XM=AMAX1(1E-3,X)
        B(2)=EXP(-A(3)*(XM-A(4))**2/XM)/SQRT(XM)
      CASE(15)
        XM=AMAX1(1E-3,X)
        B(2)=EXP(-A(3)*(XM-A(4))**2/XM)/XM**1.5
      CASE(16)
        XM=AMAX1(1E-3,X)
        B(2)=XM**(A(4)-1)*EXP(-A(3)*XM)
      CASE(17)
        XM=AMAX1(1E-3,X)
        B(2)=EXP(-A(1)*(A(2)-XM)**2/(A(2)*XM))/(3.14*XM)**.5 	
      CASE(18)
        XM=AMAX1(1E-3,X)
        B(2)=EXP(-A(1)*(A(2)-XM)**2/(A(2)*XM))/(3.14*XM**3)**.5 	
	CASE(19)
	  IF(X.GT.0.)B(2)=X**A(3)
	CASE(20)
	  B(2)=X
	  IF(X.GT.0.)THEN
	      B(3)=X**A(4)
	  ELSE
	      B(3)=0.
	  ENDIF
	CASE(21)
	  IF(X.NE.A(5))B(2)=1./(A(5)+X)
	  B(3)=X
	  B(4)=X**2
	CASE(22)
	  IF(X.NE.A(5))B(2)=1./(A(5)+X)
	  IF(A(7).NE.0.)THEN
 	     EAR=((X-A(6))/A(7))**2
	     IF(ABS(EAR).GT.20.)THEN
	        E=0
	     ELSE
	        E=EXP(-EAR)
	     ENDIF
	  ELSE
	     E=0
	  ENDIF
	  B(3)=E
	  B(4)=X*E
	CASE(23)
	  B(2)=X
	  B(3)=BESJN(0,A(5)*X)
	  B(4)=BESJN(1,A(6)*X)
	CASE(24)
	  B(2)=BESJN(0,A(4)*X)
	  B(3)=EXP(-A(5)*X)
	CASE(25)
	  B(2)=BESJN(1,A(4)*X)
	  B(3)=EXP(-A(5)*X)
      ENDSELECT
      END      

      SUBROUTINE FUN(X,A,Y,DYDA,M)
      PARAMETER (NCVM=10)
      COMMON /$REGRES/MODEL,AAA(NCVM)
      DIMENSION A(NCVM),DYDA(NCVM)
      MDUM=M
      DYDA(1)=1.
      SELECT CASE(MODEL)
      CASE(1)
        A(3)=AMAX1(-3.,A(3))
        E=EXP(-A(3)*X)
        Y=A(1)+A(2)*E
        DYDA(2)=E
        DYDA(3)=-A(2)*X*E
      CASE(2)
        A(4)=AMAX1(-1.,A(4))
        A(5)=AMAX1(-1.,A(5))
        E1=EXP(-A(4)*X)
        E2=EXP(-A(5)*X)
        Y=A(1)+A(2)*E1+A(3)*E2
        DYDA(2)=E1
        DYDA(3)=E2
        DYDA(4)=-A(2)*X*E1
        DYDA(5)=-A(3)*X*E2
      CASE(3)
        A(4)=AMAX1(1E-6,A(4))
        E=EXP(-((X-A(3))/A(4))**2)
        Y=A(1)+A(2)*E
        DYDA(2)=E
        DYDA(3)=2*A(2)*(X-A(3))/A(4)**2*E
        DYDA(4)=2*A(2)*(X-A(3))**2/A(4)**3*E
      CASE(4)
        R=1./(1+A(3)*X)
        Y=(A(1)+A(2)*X)*R
        DYDA(1)=R
        DYDA(2)=R*X
        DYDA(3)=-(A(1)+A(2)*X)*X*R
      CASE(5)
        A(3)=AMAX1(-2.,A(3))
        E=EXP(-A(3)*X)
        Y=A(1)/(1+A(2)*E)
        DYDA(1)=1/(1+A(2)*E)
        DYDA(2)=-A(1)*E/(1+A(2)*E)**2
        DYDA(3)=A(1)*A(3)*X*E/(1+A(2)*E)**2
      CASE(6)
        XM=AMAX1(1E-3,X)
        A(2)=AMAX1(1E-6,A(2))
        A(3)=AMAX1(1.,A(3))
        E=EXP(-A(2)*XM)
        Q=XM**(A(3)-1.)
        Y=A(1)*Q*E
        DYDA(1)=Q*E
        DYDA(2)=-A(1)*Q*XM*E
        DYDA(3)=A(1)*Q*E*ALOG(XM)
      CASE(7)
        XM=AMAX1(1E-3,X)
        A(2)=AMAX1(1E-6,A(2))
        A(3)=AMAX1(1E-6,A(3))
        E=EXP(-A(2)*(XM-A(3))**2/XM)/SQRT(XM)
        Y=A(1)*E
        DYDA(1)=E
        DYDA(2)=-A(1)*(XM-A(3))**2*E/XM
        DYDA(3)=2*A(1)*A(2)*(XM-A(3))*E/XM
      CASE(8)
        XM=AMAX1(1E-3,X)
        A(2)=AMAX1(1E-6,A(2))
        A(3)=AMAX1(1E-6,A(3))
        E=EXP(-A(2)*(XM-A(3))**2/XM)/XM**1.5
        Y=A(1)*E
        DYDA(1)=E
        DYDA(2)=-A(1)*(XM-A(3))**2*E/XM
        DYDA(3)=2*A(1)*A(2)*(XM-A(3))*E/XM
      CASE(9)
        E=A(3)*X+A(4)
        SE=SIN(E)
        CE=COS(E)
        Y=A(1)+A(2)*SE
        DYDA(2)=SE
        DYDA(3)=A(2)*X*CE
        DYDA(4)=A(2)*CE
      CASE(10)
        E=A(4)*X+A(5)
        SE=SIN(E)
        CE=COS(E)
        Y=A(1)+A(2)*X+A(3)*SE
        DYDA(2)=X
        DYDA(3)=SE
        DYDA(4)=A(3)*X*CE
        DYDA(5)=A(3)*CE
      CASE(11)
        E1=A(4)*X+A(5)
        E2=A(6)*X+A(7)
        SE1=SIN(E1)
        CE1=COS(E1)
        SE2=SIN(E2)
        CE2=COS(E2)
        Y=A(1)+A(2)*SE1+A(3)*SE2
        DYDA(2)=SE1
        DYDA(3)=SE2
        DYDA(4)=A(2)*X*CE1
        DYDA(5)=A(2)*CE1
        DYDA(6)=A(3)*X*CE2
        DYDA(7)=A(3)*CE2
      CASE(12)
        XA=AMAX1(1E-10,X)
        A(2)=AMAX1(0.1,AMIN1(15.,A(2)))
        E=XA**A(2)
        Y=A(1)*E
        DYDA(1)=E
        DYDA(2)=A(1)*E*ALOG(XA)
      CASE(13)
        IF(X.EQ.0.)THEN
           Y=0
           DYDA(1)=0
           DYDA(2)=0
           DYDA(3)=0
           DYDA(4)=0
           DYDA(5)=0
        ELSE
           XM=AMAX1(1E-5,X)
           A(3)=AMAX1(1E-7,A(3))
           A(4)=AMIN1(15.,AMAX1(0.2,A(4)))
           E=EXP(-A(3)*XM)
           Q=XM**(A(4)-1.)
           Y=A(1)*Q*E
           DYDA(1)=Q*E
           DYDA(3)=-A(1)*Q*XM*E
           DYDA(4)=A(1)*Q*E*ALOG(XM)
           A(5)=AMAX1(1E-7,A(5))
           A(6)=AMIN1(15.,AMAX1(0.2,A(6)))
           E=EXP(-A(5)*XM)
           Q=XM**(A(6)-1.)
           Y=Y+A(2)*Q*E
           DYDA(2)=Q*E
           DYDA(5)=-A(2)*Q*XM*E
           DYDA(6)=A(2)*Q*E*ALOG(XM)
        ENDIF
      CASE(14)
        XM=AMAX1(1E-3,X)
        A(3)=AMAX1(1E-6,A(3))
        A(4)=AMAX1(1E-6,A(4))
        E=EXP(-A(3)*(XM-A(4))**2/XM)/SQRT(XM)
        Y=A(1)+A(2)*E
        DYDA(2)=E
        DYDA(3)=-A(2)*(XM-A(4))**2*E/XM
        DYDA(4)=2*A(2)*A(3)*(XM-A(4))*E/XM
      CASE(15)
        XM=AMAX1(1E-3,X)
        A(3)=AMAX1(1E-6,A(3))
        A(4)=AMAX1(1E-6,A(4))
        E=EXP(-A(3)*(XM-A(4))**2/XM)/XM**1.5
        Y=A(1)+A(2)*E
        DYDA(2)=E
        DYDA(3)=-A(2)*(XM-A(4))**2*E/XM
        DYDA(4)=2*A(2)*A(3)*(XM-A(4))*E/XM
      CASE(16)
        XM=AMAX1(1E-3,X)
        A(3)=AMAX1(1E-6,A(3))
        A(4)=AMAX1(1.,A(4))
        E=EXP(-A(3)*XM)
        Q=XM**(A(4)-1.)
        Y=A(1)+A(2)*Q*E
        DYDA(2)=Q*E
        DYDA(3)=-A(2)*Q*XM*E
        DYDA(4)=A(2)*Q*E*ALOG(XM)
      CASE(17)
        XM=AMAX1(1E-3,X)
C A1 = Pe/4,  A2= tmean
        A(1)=AMAX1(1E-6,A(1))
      	A(2)=AMAX1(1E-6,A(2))
        FI=(A(1)/(3.141*A(2)*XM))**0.5
        BETA=A(1)*(A(2)-XM)/(A(2)*XM)
	E=EXP(-BETA*(A(2)-XM))
	Y=FI*E
	DYDA(1)= FI*E/A(1)*(0.5-BETA*(A(2)-XM))
	DYDA(2)=-FI*E/A(2)*(0.5+BETA*(A(2)+XM))
      CASE(18)
        XM=AMAX1(1E-3,X)
C A1 = Pe/4,  A2= tmean
        A(1)=AMAX1(1E-6,A(1))
      	A(2)=AMAX1(1E-6,A(2))
        FI=(A(1)*A(2)/(3.141*XM**3))**0.5
        BETA=A(1)*(A(2)-XM)/(A(2)*XM)
	E=EXP(-BETA*(A(2)-XM))
	Y=FI*E
	DYDA(1)= FI*E/A(1)*(0.5-BETA*(A(2)-XM))
	DYDA(2)= FI*E/A(2)*(0.5-BETA*(A(2)+XM))
      CASE(19)
        XA=AMAX1(1E-10,X)
        A(3)=AMAX1(0.1,AMIN1(15.,A(3)))
        E=XA**A(3)
        Y=A(1)+A(2)*E
	  DYDA(1)=1
        DYDA(2)=E
        DYDA(3)=A(2)*E*ALOG(XA)
      CASE(20)
        XA=AMAX1(1E-10,X)
        A(4)=AMAX1(0.1,AMIN1(15.,A(4)))
        E=XA**A(4)
        Y=A(1)+A(2)*X+A(3)*E
	  DYDA(1)=1
        DYDA(2)=X
	  DYDA(3)=E
        DYDA(4)=A(3)*E*ALOG(XA)
      CASE(21)
        A5=A(5)+X
	  IF(ABS(A5).LT.1E-6)A5=1E-6
        Y=A(1)+A(2)/A5+A(3)*X+A(4)*X*X
	  DYDA(1)=1
        DYDA(2)=1./A5
	  DYDA(3)=X
        DYDA(4)=X*X
	  DYDA(5)=-A(2)/A5**2
      CASE(22)
        A5=A(5)+X
	  IF(ABS(A5).LT.1E-6)A5=1E-6
	  IF(A(7).NE.0.)THEN
	     A7=A(7)
 	     EAR=((X-A(6))/A(7))**2
	     IF(ABS(EAR).GT.20.)THEN
	        E=0
	     ELSE
	        E=EXP(-EAR)
	     ENDIF
	  ELSE
	     A7=1E-3
	     E=0
	  ENDIF
        Y=A(1)+A(2)/A5+(A(3)+A(4)*X)*E
	  DYDA(1)=1
        DYDA(2)=1./A5
	  DYDA(3)=E
        DYDA(4)=X*E
	  DYDA(5)=-A(2)/A5**2
	  DYDA(6)=(A(3)+A(4)*X)*2*(X-A(6))/A7**2*E
	  DYDA(7)=(A(3)+A(4)*X)*2*(X-A(6))**2/A7**3*E
	CASE(23)
C MODEL=23 A1+A2.X+A3.J0(A5.X)+A4.J1(A6.X)
        A5=A(5)
	  A6=A(6)
        B0=BESJN(0,A5*X)
	  B1=BESJN(1,A6*X)
        Y=A(1)+A(2)*X+A(3)*B0+A(4)*B1
	  DYDA(1)=1
        DYDA(2)=X
	  DYDA(3)=B0
        DYDA(4)=B1
	  DYDA(5)=-A(3)*BESJN(1,A5*X)*X
	  DYDA(6)=A(4)*(BESJN(0,A6*X)*X-B1/A6)
	CASE(24)
C MODEL=24 A1+A2.J0(A4.X)+A3.EXP(-A5.X)
        A1=A(1)
	  A2=A(2)
	  A3=A(3)
	  A4=A(4)
        A5=AMAX1(-3.,A(5))
        E=EXP(-A5*X)
        B0=BESJN(0,A4*X)
	  B1=BESJN(1,A4*X)
        Y=A1+A2*B0+A3*E
	  DYDA(1)=1
        DYDA(2)=B0
	  DYDA(3)=E
	  DYDA(4)=-A2*B1*X
	  DYDA(5)=-E*A3*X
	CASE(25)
C MODEL=25 A1+A2.J1(A3.X)
        A1=A(1)
	  A2=A(2)
	  A3=A(3)
	  A4=A(4)
        A5=AMAX1(-3.,A(5))
        E=EXP(-A5*X)
        B0=BESJN(0,A4*X)
	  B1=BESJN(1,A4*X)
        Y=A1+A2*B1+A3*E
	  DYDA(1)=1
        DYDA(2)=B1
	  DYDA(3)=E
	  DYDA(4)=A2*(B0*X-B1/A4)
	  DYDA(5)=-E*A3*X
	 
      END SELECT
      END

      SUBROUTINE COVSRT(COVAR,NCVM,MA,LISTA,MFIT)
      DIMENSION COVAR(NCVM,NCVM),LISTA(NCVM)
      DO J=1,MA-1
        DO I=J+1,MA
           COVAR(I,J)=0
        ENDDO
      ENDDO
      DO I=1,MFIT-1
         DO J=I+1,MFIT
            IF(LISTA(J).GT.LISTA(I))THEN
                COVAR(LISTA(J),LISTA(I))=COVAR(I,J)
            ELSE
                COVAR(LISTA(I),LISTA(J))=COVAR(I,J)
            ENDIF
         ENDDO
      ENDDO
      SWAP=COVAR(1,1)
      DO J=1,MA
         COVAR(1,J)=COVAR(J,J)
         COVAR(J,J)=0.
      ENDDO
      COVAR(LISTA(1),LISTA(1))=SWAP
      DO J=2,MFIT
         COVAR(LISTA(J),LISTA(J))=COVAR(1,J)
      ENDDO
      DO J=2,MA
         DO I=1,J-1
             COVAR(I,J)=COVAR(J,I)
         ENDDO
      ENDDO
      END

      SUBROUTINE GAUSSJ(A,N,NP,B,M,MP,ier)
C
C RESENI SOUSTAVY LINEARNICH ALGEBRAICKYCH ROVNIC GAUSS-JORDANOVOU ELIMINACI
C VSTUPNI PARAMETRY:
C N         - POCET RESENYCH ROVNIC
C M         - POCET RESENYCH PRAVYCH STRAN
C NP,MP     - DEKLARACNI ROZMERY A(NP,NP),B(NP,MP)
C VSTUPNI A VYSTUPNI PARAMETRY
C A(NP,NP)  - MATICE SOUSTAVY
C B(NP,MP)  - PRAVA STRANA A RESENI
C MAXIMALNI POCET ROVNIC = 100
C
C Numerical Recipes p. 28
C
      parameter (nmax=100)
      dimension a(np,np),b(np,mp),ipiv(nmax),indxr(nmax),indxc(nmax)
      ier=0
      do i=1,n
         ipiv(i)=0
      enddo
      do i=1,n
         big=0
         do j=1,n
             if(ipiv(j).ne.1)then
                   do k=1,n
                         if(ipiv(k).eq.0)then
                               if(abs(a(j,k)).ge.big)then
                                    big=abs(a(j,k))
                                    irow=j
				    icol=k
                               endif
                         elseif(ipiv(k).gt.1)then
                               IER=1
                               return
                         endif
                    enddo
               endif
          enddo
          ipiv(icol)=ipiv(icol)+1
          if(irow.ne.icol)then
              do l=1,n
                 dum=a(irow,l)
                 a(irow,l)=a(icol,l)
                 a(icol,l)=dum
              enddo
              do l=1,m
                 dum=b(irow,l)
                 b(irow,l)=b(icol,l)
                 b(icol,l)=dum
              enddo
          endif
          indxr(i)=irow
          indxc(i)=icol
          if(a(icol,icol).eq.0.)THEN
              IER=2
              return
          endif
          pivinv=1/a(icol,icol)
          a(icol,icol)=1
          do l=1,n
             a(icol,l)=a(icol,l)*pivinv
          enddo
          do l=1,m
             b(icol,l)=b(icol,l)*pivinv
          enddo
          do ll=1,n
              if(ll.ne.icol)then
                  dum=a(ll,icol)
                  a(ll,icol)=0
                  do l=1,n
                     a(ll,l)=a(ll,l)-a(icol,l)*dum
                  enddo
                  do l=1,m
                     b(ll,l)=b(ll,l)-b(icol,l)*dum
                  enddo
               endif
           enddo
      enddo
      do l=n,1,-1
         if(indxr(l).ne.indxc(l))then
            do k=1,n
               dum=a(k,indxr(l))
               a(k,indxr(l))=a(k,indxc(l))
               a(k,indxc(l))=dum
            enddo
         endif
      enddo
      end

      SUBROUTINE MRQMIN(X,Y,SIG,NDATA,A,MA,LISTA,MFIT,COVAR,ALPHA,NCA,
     /                CHISQ,FUNCS,ALAMDA,IER)
C Numerical recipes p.513
      PARAMETER (MMAX=10)
      DIMENSION X(NDATA),Y(NDATA),SIG(NDATA),A(MA),LISTA(NCA),
     /          COVAR(NCA,NCA),ALPHA(NCA,NCA),
     /          ATRY(MMAX),BETA(MMAX), DA(MMAX)
      EXTERNAL FUNCS
      IER=0
      IF(ALAMDA.LT.0.)THEN
        KK=MFIT+1
        DO J=1,MA
           IHIT=0
           DO K=1,MFIT
              IF(LISTA(K).EQ.J)IHIT=IHIT+1
           ENDDO
           IF(IHIT.EQ.0)THEN
              LISTA(KK)=J
              KK=KK+1
           ELSEIF(IHIT.GT.1)THEN
              PAUSE 'Improper set in LISTA'
           ENDIF
        ENDDO
        IF(KK.NE.(MA+1))PAUSE' Improper set in LISTA'
        ALAMDA=0.001
        CALL MRQCOF(X,Y,SIG,NDATA,A,MA,LISTA,MFIT,ALPHA,BETA,
     /              NCA,CHISQ,FUNCS)
        OCHISQ=CHISQ
        DO J=1,MA
           ATRY(J)=A(J)
        ENDDO
      ENDIF
      DO J=1,MFIT
         DO K=1,MFIT
            COVAR(J,K)=ALPHA(J,K)
         ENDDO
         COVAR(J,J)=ALPHA(J,J)*(1.+ALAMDA)
         DA(J)=BETA(J)
      ENDDO
      CALL GAUSSJ(COVAR,MFIT,NCA,DA,1,1,IER)
      IF(IER.NE.0)RETURN
      IF(ALAMDA.EQ.0.)THEN
         CALL COVSRT(COVAR,NCA,MA,LISTA,MFIT)
         RETURN
      ENDIF
      DO J=1,MFIT
        ATRY(LISTA(J))=A(LISTA(J))+DA(J)
      ENDDO
      CALL MRQCOF(X,Y,SIG,NDATA,ATRY,MA,LISTA,MFIT,COVAR,DA,NCA,
     /            CHISQ,FUNCS)
      IF(CHISQ.LT.OCHISQ)THEN
         ALAMDA=ALAMDA*.1
         OCHISQ=CHISQ
         DO J=1,MFIT
            DO K=1,MFIT
              ALPHA(J,K)=COVAR(J,K)
            ENDDO
            BETA(J)=DA(J)
            A(LISTA(J))=ATRY(LISTA(J))
         ENDDO
      ELSE
         ALAMDA=10.*ALAMDA
         CHISQ=OCHISQ
      ENDIF
      END

      SUBROUTINE MRQCOF(X,Y,SIG,NDATA,A,MA,LISTA,MFIT,
     /                 ALPHA,BETA,NALP,CHISQ,FUNCS)
      PARAMETER (MMAX=10)
      DIMENSION X(NDATA),Y(NDATA),SIG(NDATA),ALPHA(NALP,NALP),BETA(MA),
     /      DYDA(MMAX),LISTA(MFIT),A(MA)
      DO J=1,MFIT
         DO K=1,J
            ALPHA(J,K)=0
         ENDDO
         BETA(J)=0.
      ENDDO
      CHISQ=0.
      DO I=1,NDATA
         CALL FUNCS(X(I),A,YMOD,DYDA,MA)
         IF(SIG(I).LE.0.)THEN
           SIG2I=0.
         ELSE
           SIG2I=1./(SIG(I)*SIG(I))
         ENDIF
         DY=Y(I)-YMOD
         IF(ABS(DY).GT.1E10)THEN
              CHISQ=1E20
              RETURN
         ENDIF
         DO J=1,MFIT
             WT=DYDA(LISTA(J))*SIG2I
             DO K=1,J
                ALPHA(J,K)=ALPHA(J,K)+WT*DYDA(LISTA(K))
             ENDDO
             BETA(J)=BETA(J)+DY*WT
         ENDDO
         CHISQ=CHISQ+DY*DY*SIG2I
      ENDDO
      DO J=2,MFIT
         DO K=1,J-1
            ALPHA(K,J)=ALPHA(J,K)
         ENDDO
      ENDDO
      END

      SUBROUTINE LFIT(X,Y,SIG,NDATA,A,MA,LISTA,MFIT,COVAR,NCVM,
     /                CHISQ,FUNCS)
C Numerical recipes p.513
      PARAMETER (MMAX=10)
      DIMENSION X(NDATA),Y(NDATA),SIG(NDATA),A(MA),LISTA(NCVM),
     /          COVAR(NCVM,NCVM),BETA(MMAX), AFUNC(MMAX)
      KK=MFIT+1
      DO J=1,MA
         IHIT=0
         DO K=1,MFIT
            IF(LISTA(K).EQ.J)IHIT=IHIT+1
         ENDDO
         IF(IHIT.EQ.0)THEN
            LISTA(KK)=J
            KK=KK+1
         ELSEIF(IHIT.GT.1)THEN
            PAUSE 'Improper set in LISTA'
         ENDIF
      ENDDO
      IF(KK.NE.(MA+1))PAUSE' Improper set in LISTA'
      DO J=1,MFIT
         DO K=1,MFIT
            COVAR(J,K)=0.
         ENDDO
         BETA(J)=0.
      ENDDO
      DO I=1,NDATA
         CALL FUNCS(X(I),AFUNC,MA)
         YM=Y(I)
         IF(MFIT.LT.MA)THEN
             DO J=MFIT+1,MA
                YM=YM-A(LISTA(J))*AFUNC(LISTA(J))
             ENDDO
         ENDIF
         IF(SIG(I).LE.0.)THEN
            SIG2I=0.
         ELSE
            SIG2I=1./SIG(I)**2
         ENDIF
         DO J=1,MFIT
            WT=AFUNC(LISTA(J))*SIG2I
            DO K=1,J
               COVAR(J,K)=COVAR(J,K)+WT*AFUNC(LISTA(K))
            ENDDO
            BETA(J)=BETA(J)+YM*WT
         ENDDO
      ENDDO
      IF(MFIT.GT.1)THEN
         DO J=2,MFIT
            DO K=1,J-1
               COVAR(K,J)=COVAR(J,K)
            ENDDO
         ENDDO
      ENDIF
      CALL GAUSSJ(COVAR,MFIT,NCVM,BETA,1,1,IER)
      IF(IER.NE.0)THEN
         PAUSE 'SINGULAR'
         RETURN
      ENDIF
      DO J=1,MFIT
          A(LISTA(J))=BETA(J)
      ENDDO
      CHISQ=0
      DO I=1,NDATA
          CALL FUNCS(X(I),AFUNC,MA)
          SUM=0
          DO J=1,MA
             SUM=SUM+A(J)*AFUNC(J)
          ENDDO
          IF(SIG(I).GT.0.)THEN
              CHISQ=CHISQ+((Y(I)-SUM)/SIG(I))**2
          ENDIF
      ENDDO
      CALL COVSRT(COVAR,NCVM,MA,LISTA,MFIT)
      END
