C RUNBOX.for (nova verze-puvodne runbox1)
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEMLOC'
      CHARACTER*1 C
      DIMENSION XND(20),YND(20),ZND(20)
      LOGICAL PRESSED
C
C IENDCHECK - signalizace vysledku =0 O.K. bez preruseni
C                                  =-1 chyba pri cteni dat
C                                  kod klavesy (Esc-27, Enter-13, ...)
      IENDCHECK=-1
      OPEN(1,FILE='$RUNFEM.BIN',FORM='BINARY',ERR=1000)
      CALL READBIN(1,IEND)
      IENDCHECK=0
      WRITE(*,'('' RUNBOX read RUNFEM.BIN successfully'')')
      WRITE(*,'('' You can quit computation by pressing any key...'')')
C Binarni soubor pro zapis indexu elementu, ktere odpovidaji boxu x,y,z
      OPEN(6,FILE='$RUNBOX.BIN',ACCESS='DIRECT',RECL=4)
C
C Vstupni parameter je $RBOXRATIO. Kdy je nula, nastavi se default 0.3.
      IF($RBOXRATIO.LE.0.)$RBOXRATIO=0.3
C --------------------------------------
C Vnejsi rozmery boxu
      XBOXMI=1E10
      YBOXMI=1E10
      ZBOXMI=1E10
      XBOXMA=-1E10
      YBOXMA=-1E10
      ZBOXMA=-1E10
C Minimalni rozmery elementu
      XEBOXMI=1E10
      YEBOXMI=1E10
      ZEBOXMI=1E10
      DO IE=1,NE
         CALL EBOX(IE,NUE,IG,IR,NAMEL,JAXIS,RR,XND,YND,ZND,
     /             XEMI,XEMA,YEMI,YEMA,ZEMI,ZEMA)
         SELECT CASE(NAMEL)
         CASE($HEXC,$VALVE)
         CASE DEFAULT
            XBOXMI=AMIN1(XBOXMI,XEMI)
            YBOXMI=AMIN1(YBOXMI,YEMI)
            ZBOXMI=AMIN1(ZBOXMI,ZEMI)
            XBOXMA=AMAX1(XBOXMA,XEMA)
            YBOXMA=AMAX1(YBOXMA,YEMA)
            ZBOXMA=AMAX1(ZBOXMA,ZEMA)
            XEBOXMI=AMIN1(XEBOXMI,XEMA-XEMI)
            YEBOXMI=AMIN1(YEBOXMI,YEMA-YEMI)
            ZEBOXMI=AMIN1(ZEBOXMI,ZEMA-ZEMI)
         ENDSELECT
      ENDDO
      DXB=(XBOXMA-XBOXMI)*0.001
      DYB=(YBOXMA-YBOXMI)*0.001
      DZB=(ZBOXMA-ZBOXMI)*0.001
C ROZMER elementarniho boxu = rozmer nejmensiho elementu/2
      DXBOX=XEBOXMI*$RBOXRATIO
      IF(XBOXMA.EQ.XBOXMI)THEN
         NXBOX=1
         XBOXMI=-1E10
         XBOXMA=1E10
         DXBOX=2E10
      ELSEIF(DXBOX.GT.0.)THEN
         XBOXMI=XBOXMI-DXB
         XBOXMA=XBOXMA+DXB
         NXBOX=(XBOXMA-XBOXMI)/DXBOX
      ELSE
         NXBOX=10
      ENDIF
      DYBOX=YEBOXMI*$RBOXRATIO
      IF(YBOXMA.EQ.YBOXMI)THEN
         NYBOX=1
         YBOXMI=-1E10
         YBOXMA=1E10
         DYBOX=2E10
      ELSEIF(DYBOX.GT.0.)THEN
         YBOXMI=YBOXMI-DYB
         YBOXMA=YBOXMA+DYB
         NYBOX=(YBOXMA-YBOXMI)/DYBOX
      ELSE
         NYBOX=10
      ENDIF
      DZBOX=ZEBOXMI*$RBOXRATIO
      IF(ZBOXMA.EQ.ZBOXMI)THEN
         NZBOX=1
         ZBOXMI=-1E10
         ZBOXMA=1E10
         DZBOX=2E10
      ELSEIF(DZBOX.GT.0.)THEN
         ZBOXMI=ZBOXMI-DZB
         ZBOXMA=ZBOXMA+DZB
         NZBOX=(ZBOXMA-ZBOXMI)/DZBOX
      ELSE
         NZBOX=10
      ENDIF
      WRITE(*,'('' BOXRATIO='',F6.2,'' Edim:'',3F8.3,'' NBOX:'',3I4)')
     /$RBOXRATIO,XEBOXMI,YEBOXMI,ZEBOXMI,NXBOX,NYBOX,NZBOX
C Vynulovani souboru s primym pristupem
      IREC=0
      DO IX=1,NXBOX
       DO IY=1,NYBOX
        DO IZ=1,NZBOX
         IREC=IREC+1
         WRITE(6,REC=IREC)0
        ENDDO
       ENDDO
      ENDDO
C Cyklus pres elementy a dosazovani jejich indexu do prislusnych BOXu
      NCOUNT=0
      DO IE=1,NE     
        CALL EBOX(IE,NUE,IG,IR,NAMEL,JAXIS,RR,XND,YND,ZND,
     /            XEMI,XEMA,YEMI,YEMA,ZEMI,ZEMA)
C minimalni a maximalni souradnice boxu
        IXMI=IFIX((XEMI-XBOXMI)/DXBOX)+1
        IXMA=IFIX((XEMA-XBOXMI)/DXBOX)+1
        IYMI=IFIX((YEMI-YBOXMI)/DYBOX)+1
        IYMA=IFIX((YEMA-YBOXMI)/DYBOX)+1
        IZMI=IFIX((ZEMI-ZBOXMI)/DZBOX)+1
        IZMA=IFIX((ZEMA-ZBOXMI)/DZBOX)+1
        IXMA=MIN0(IXMA,NXBOX)
        IYMA=MIN0(IYMA,NYBOX)
        IZMA=MIN0(IZMA,NZBOX)
        IXMI=MAX0(IXMI,1)
        IYMI=MAX0(IYMI,1)
        IZMI=MAX0(IZMI,1)
        DO IZ=IZMI,IZMA
          Z=ZBOXMI+(IZ-0.5)*DZBOX
          DO IY=IYMI,IYMA
            Y=YBOXMI+(IY-0.5)*DYBOX
            DO IX=IXMI,IXMA
               X=XBOXMI+(IX-0.5)*DXBOX
C bod X,Y,Z lezi v tezisti boxu IX,IY,IZ. Patri tento bod elementu IE?
               CALL EIN(NUE,NAMEL,JAXIS,RR,XND,YND,ZND,X,Y,Z,IN)
               IF(IN.EQ.1)THEN
                 NCOUNT=NCOUNT+1
                 CALL WRITEBOX(6,IX,IY,IZ,IE)
               ENDIF
            ENDDO
          ENDDO
        ENDDO
        PRESSED=PEEKCHARQQ()
        IF(PRESSED)THEN
            C=GETCHARQQ()
            IENDCHECK=ICHAR(C)
            GOTO 999
        ENDIF
        WRITE(*,*)' Processed element: ',IE,' boxes written:',NCOUNT
      ENDDO
999   WRITE(*,'(1X,''Exit from RUNBOX'')')
      REWIND 1
      CALL WRITEBIN(1,0)
      WRITE(*,'('' BOX X:'',2E9.2,'' Y:'',2E9.2,'' Z:'',2E9.2)')
     /         XBOXMI,XBOXMA,YBOXMI,YBOXMA,ZBOXMI,ZBOXMA
      WRITE(*,'('' Size of voxels dx,dy,dz:'',3E9.2)')
     /      XEBOXMI,YEBOXMI,ZEBOXMI
1000  CONTINUE
      CLOSE(6)
      END

      SUBROUTINE WRITEBOX(IUNIT,IX,IY,IZ,IE)
      INCLUDE '$FEM'
C Vypocet cisla vety a zapis hodnoty IE
      IR=((IZ-1)*NYBOX+(IY-1))*NXBOX+IX 
      WRITE(IUNIT,REC=IR)IE
      END

      SUBROUTINE EIN(NUE,NAMEL,JAXIS,RR,XND,YND,ZND,X,Y,Z,IN)
C
C Lezi bod X,Y,Z v elementu IE? Element je jiz expandovan do 3D (XND,...).
C
      INCLUDE '$FEMB'
      DIMENSION XND(*),YND(*),ZND(*)
      IF(JAXIS.EQ.1)THEN
C ........... je treba rozlisit rotacni symetrii a 1D elementy
        SELECT CASE(NAMEL)
        CASE($PLANE2D,$FLOW2D)
C    ........ osa symetrie X
           RR=SQRT(Y**2+Z**2)
           SELECT CASE(NUE)
           CASE(3,6)
             CALL EINS2D3(XND,YND,X,RR,IN)
           CASE(4,8)
             CALL EINS2D4(XND,YND,X,RR,IN)
           ENDSELECT
        CASE DEFAULT
C    ........ 1D elementy PIPE (uzly na ose zacinaji az od uzlu 9,10)
           CALL EINSCYL(XND(1),YND(1),ZND(1),RR,X,Y,Z,IN)
        ENDSELECT
      ELSE
C ........... bod uvnitr 3D polygonu. Vyjimkou je trubka pro JAXIS=0
        IF(JAXIS.EQ.0.AND.(
     /     NAMEL.EQ.$PIPE2D.OR.NAMEL.EQ.$TRUSS2D.OR.NAMEL.EQ.$BEAM2D.OR.
     /     NAMEL.EQ.$CSTR.OR.NAMEL.EQ.$PUMP.OR.NAMEL.EQ.$VALVE))THEN
           CALL EINSCYL(XND(9),YND(9),ZND(9),RR,X,Y,Z,IN)
        ELSE
           CALL EINSP(NUE,XND,YND,ZND,X,Y,Z,IN)
        ENDIF
      ENDIF
      END

      SUBROUTINE EBOX(IE,NUE,IG,IR,NAMEL,JAXIS,RR,XND,YND,ZND,
     /                XMI,XMA,YMI,YMA,ZMI,ZMA)
C
C Zjisteni rozsahu souradnic X,Y,Z elementu IE.
C Zakladni strategie: odlisne zpracovani dle JAXIS
C JAXIS=0,1 pro elementy PIPE
C JAXIS=1   rotacni symetrie dle osy X (SHELLAX a 2D)
C JAXIS=0,2,... kazdy element expandovat na 3D mnohosten
C
      INCLUDE '$FEMB'
      DIMENSION XND(*),YND(*),ZND(*)
C Zakladni charakteristiky elementu IE (vsechny parametry vystupni)
      IR=MAX0(1,IRCONS(IE))
      IG=MAX0(1,IGROUP(IE))
      NAMEL=JGROUP(IG,$ENAME)
      JAXIS=JGROUP(IG,$AXIS)

      IF(JAXIS.EQ.1)THEN
C ........... je treba rozlisit rotacni symetrii a 1D elementy
        SELECT CASE(NAMEL)
        CASE($PLANE2D,$FLOW2D,$SHELLAX)
C    ........ osa symetrie X
           CALL POLY3D(IE,NUE,XND,YND,ZND)
           CALL POLMAX(NUE,XND,YND,ZND,XMI,XMA,YMI,YMA,ZMI,ZMA)
           YMI=-YMA
           ZMI=YMI
           ZMA=YMA
           RETURN
        CASE DEFAULT
C    ........ 1D elementy PIPE
C          CALL POLY1D(IE,NUE,XND,YND,ZND,RR)
           NUE=2
           L0=LUE(IE)
           DO J=1,2
              IU=IABS(IUE(L0+J))
              XND(J)=XX(IU)
              YND(J)=YY(IU)
              ZND(J)=ZZ(IU)
           ENDDO
           H=SQRT((XND(1)-XND(2))**2+(YND(1)-YND(2))**2+
     /       (ZND(1)-ZND(2))**2)
           R=RADEL(NAMEL,H,IR)
           CALL BOXCYL(XND,YND,ZND,R,XMI,XMA,YMI,YMA,ZMI,ZMA)
           RETURN
        ENDSELECT
      ELSE
C ........... generovani polygonu 3D dle typu elementu
        SELECT CASE(NAMEL)
        CASE($PIPE2D,$TRUSS2D,$BEAM2D,$CSTR,$PUMP,$VALVE)
           CALL POLY1D(IE,NUE,XND,YND,ZND,RR)
        CASE($PLANE2D,$FLOW2D)
           CALL POLY2D(IE,NUE,XND,YND,ZND)
        CASE DEFAULT
           CALL POLY3D(IE,NUE,XND,YND,ZND)
        END SELECT
      ENDIF
C 
      CALL POLMAX(NUE,XND,YND,ZND,XMI,XMA,YMI,YMA,ZMI,ZMA)
      END

      SUBROUTINE POLY1D(IE,NUE,XND,YND,ZND,R)
C
C PIPE2D GENEROVANI 8-MI UZLU SESTISTENU. NUE=10 (poslecni dva uzly jsou osa a
C                                         prvni uzly 1-8 jsou vrcholy kvadru).
C JAXIS=0,1    kruhova trubka s polomerem R (vystupni parametr)
C JAXIS=2,3,4  obdelnikova trubka s rozmerem A x B urcenych hydraulickym prumerem
C          a plochou prurezu AREA. 
C          J=2 strana A lezi v rovine XY
C          J=3 strana A lezi v rovine YZ
C          J=4 strana A lezi v rovine XZ
C
      INCLUDE '$FEMB'
      DIMENSION ISA(4),ISB(4),XND(*),YND(*),ZND(*)
      DATA ISA,ISB/-1,-1,1,1,1,-1,-1,1/
C
      IG   =MAX0(1,IGROUP(IE))
      IR   =MAX0(1,IRCONS(IE))
      D    =RRCONS(IR,$D)
      AREA =RRCONS(IR,$AREA)
      NAMEL=JGROUP(IG,$ENAME)
      JAXIS=JGROUP(IG,$AXIS)
      L0=LUE(IE)
      DO J=1,2
        IU=IABS(IUE(L0+J))
        XND(J+8)=XX(IU)
        YND(J+8)=YY(IU)
        ZND(J+8)=ZZ(IU)
      ENDDO
      H=SQRT((XND(9)-XND(10))**2+(YND(9)-YND(10))**2+
     /       (ZND(9)-ZND(10))**2)
C transformace ksi,eta,zeta
      IF(JAXIS.LE.1)THEN
        R=RADEL(NAMEL,H,IR)
        AH=R
        BH=R
      ELSE
        CALL RECTAB(D,AREA,A,B)
        AH=A/2.
        BH=B/2.
      ENDIF
      DO I=1,4
        AHH=AH*ISA(I)
        BHH=BH*ISB(I)
        CALL TKEZXYZ(JAXIS,XND(9),YND(9),ZND(9),0.,AHH,BHH,
     /               XND(I),YND(I),ZND(I))
        CALL TKEZXYZ(JAXIS,XND(9),YND(9),ZND(9),H ,AHH,BHH,
     /               XND(I+4),YND(I+4),ZND(I+4))
      ENDDO
      NUE=8
      END

      SUBROUTINE POLY2D(IE,NUE,XND,YND,ZND)
C
C 3D element z 2D elementu (uvazovana tloustka desky)
C    NUE - dvojnasobek poctu 2D uzlu 
C    Pocet 2D uzlu je redukovan na 3 nebo 4 
C
      INCLUDE '$FEMB'
      DIMENSION XND(*),YND(*),ZND(*)
      IG   =MAX0(1,IGROUP(IE))
      IR   =MAX0(1,IRCONS(IE))
      H    =RRCONS(IR,$H)
      NAMEL=JGROUP(IG,$ENAME)
      NUE1=IABS(MUE(IE))-IABS(MINT(IE))
      SELECT CASE(NUE1)
      CASE(6,7)
        NUE1=3
      CASE(8,9)
        NUE1=4
      ENDSELECT
      NUE=2*NUE1
      L0=LUE(IE)
C Uvazujeme pouze variantu, ze ploch je v rovine XY
      DO J=1,NUE1
        IU=IABS(IUE(L0+J))
        XND(J)=XX(IU)
        YND(J)=YY(IU)
        ZND(J)=ZZ(IU)+H/2.
        XND(J+NUE1)=XX(IU)
        YND(J+NUE1)=YY(IU)
        ZND(J+NUE1)=ZZ(IU)-H/2.
      ENDDO
      IF(MUE(IE).EQ.-4)THEN
           CALL TEXP(XND,YND,XND,YND)
           CALL TEXP(XND(4),YND(4),XND(4),YND(4))
      ENDIF
      END

      SUBROUTINE POLY3D(IE,NUE,XND,YND,ZND)
C
C Uzly elementu (NUE,.. jsou vystupni parametry)
C
      INCLUDE '$FEM'
      DIMENSION XND(*),YND(*),ZND(*)
      NUE=IABS(MUE(IE))-IABS(MINT(IE))
      L0=LUE(IE)
      DO J=1,NUE
        IU=IABS(IUE(L0+J))
        XND(J)=XX(IU)
        YND(J)=YY(IU)
        ZND(J)=ZZ(IU)
      ENDDO
      END

      SUBROUTINE POLMAX(NUE,X,Y,Z,XMI,XMA,YMI,YMA,ZMI,ZMA)
C
C Min/max uzlu elementu (bez uprav)
C
      DIMENSION X(*),Y(*),Z(*)
      XMI=1E10      
      XMA=-1E10
      YMI=1E10      
      YMA=-1E10
      ZMI=1E10      
      ZMA=-1E10
      DO I=1,NUE
         XMI=AMIN1(XMI,X(I))
         XMA=AMAX1(XMA,X(I))
         YMI=AMIN1(YMI,Y(I))
         YMA=AMAX1(YMA,Y(I))
         ZMI=AMIN1(ZMI,Z(I))
         ZMA=AMAX1(ZMA,Z(I))
      ENDDO
      END

C      INCLUDE '$$-COMM.FOR'
C	INCLUDE '$$-COME.FOR'
C	INCLUDE '$$-PARF.FOR'
C	INCLUDE '$RUN-COL.FOR'
C	INCLUDE '$O-WREAD.FOR'