C  RUNDET1.for
C lisi se od RUNDET tim, ze zpracovava pouze aktualni distribuci v pameti
C a nikoliv historii distribuci traceru v souboru OUT.
      INCLUDE '$FEMLOC'
      DIMENSION IDET(MAXDET),IDCOL(MAXDET)
C
C IENDCHECK - signalizace vysledku =0 O.K. bez preruseni
C                                  =-1 chyba pri cteni dat
C                                  kod klavesy (Esc-27, Enter-13, ...)
      IENDCHECK=-1
      OPEN(1,FILE='$RUNFEM.BIN',FORM='BINARY',ERR=1000)
      CALL READBIN(1,IEND)
      IENDCHECK=0
      WRITE(*,'('' RUNDET1 read $RUNFEM.BIN successfully'')')
C Binarni soubor pro zapis indexu elementu, ktere odpovidaji boxu x,y,z
      OPEN(6,FILE='$RUNBOX.BIN',ACCESS='DIRECT',RECL=4)
C Protokol vysledku
      OPEN(4,FILE='$RUNDET1.OUT')
C
      IDOF=IP(1)
      ATTENUAT=RP(2)
      IATTENUAT=IP(3)
      IVIEW=IP(4)
      NDET=IP(5)
      IF(IVIEW.LE.0.OR.IVIEW.GT.6)THEN
         WRITE(4,*)' Incorrect method selected (1-6)'
         STOP
      ELSEIF(NDET.LE.0)THEN
         WRITE(4,*)' Incorrect number of detectors',NDET
         STOP
      ENDIF
      DO I=1,NDET
         IDET(I)=IP(2*I+4)
         IDCOL(I)=IP(2*I+5)
      ENDDO
      ITIME=IP(2*NDET+6)
      IF(KEYW.EQ.'DETDOF')THEN
        IAL=1
      ELSE
        IAL=2
      ENDIF
      CALL DETREC(IAL,IDOF,ATTENUAT,IATTENUAT,IVIEW,NDET,IDET,IDCOL,
     /            ITIME)
      REWIND 1
      CALL WRITEBIN(1,0)
1000  CONTINUE
      END

      SUBROUTINE DETREC(IAL,IDOF,ATTENUAT,IATTENUAT,IVIEW,NDET,IDET,
     /                  IDCOL,ITIME)
C IAL=1 Concentration defined as DOF IDOF
C IAL=2 Concentration defined as FUNCTION IDOF
      INCLUDE '$FEMLOC'
      DIMENSION  IDET(MAXDET),IDCOL(MAXDET),DET(MAXDET)
      WRITE(4,'('' Responses from results ['',A,''] calculated for'',i2,
     /''-detectors.''//'' Media attenuation'',e10.2,'' multiplied by fun
     /ction'',i3//'' Algorithm used'',i2,'' (1-view factor, 2-with corre
     /ction to near points, 3,4-single ray, 5,6-triple ray)''//'' Result
     /s in the row of MOP='',i4/'' Detector   Column''/(2i9))')
     /                   TRIM(PROBLEM),NDET,ATTENUAT,IATTENUAT,IVIEW,
     /                   ITIME,(IDET(I),IDCOL(I),I=1,NDET)
C
      CALL DETEL(IAL,IDOF,ATTENUAT,IATTENUAT,
     /             IVIEW,NDET,IDET,ITIME,DET)
C
C Prenos vypoctenych odezev do specifikovanych sloupcu MOP
      IF(ITIME.GT.0.AND.ITIME.LE.MAXNTS)THEN
        DO I=1,NDET
          IC=IDCOL(I)
          IF(IC.GT.1.AND.IC.LE.MAXSEL)THEN
		   YGR(ITIME,IC)=DET(I)
	       WRITE(4,'('' MOP('',I3,'','',I2,'')='',E10.3)')
     /ITIME,IC,DET(I)
	    ENDIF
        ENDDO
      ENDIF
      WRITE(*,'(1X,''Exit from RUNDET1'')')
      END

      INCLUDE '$RUN-DET.FOR'
      INCLUDE '$$-COMM.FOR'
	INCLUDE '$$-COME.FOR'
	INCLUDE '$RUN-COL.FOR'
