C RUNFEMD.for  DOUBLE PRECISION
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEMLOC'
      EXTERNAL EDOF,FEL
      INTEGER JDOFEPS(MAXDOF)
      integer*2 ihr,imin,isec,i100th
      LOGICAL PRESSED,OKEPS,PIPE,CONVE
      CHARACTER*1 C
C
C IENDCHECK - signalizace vysledku =0 O.K. bez preruseni
C                                  =-1 chyba pri cteni dat
C                                  kod klavesy (Esc-27, Enter-13, ...)
      IENDCHECK=-1
      OPEN(1,FILE='$RUNFEM.BIN',FORM='BINARY',ERR=1000)
      CALL READBIN(1,IEND)
      IENDCHECK=0
      WRITE(*,'('' RUNFEM read $RUNFEM.BIN successfully'')')
      WRITE(*,'('' You can quit computation by pressing any key...'')')
C ITELIM-minimalni pocet rovnic pro eliminaci
      ITELIM=IALGOR(7)
      OPEN(2,FILE='$RUNFEM.OUT',ACCESS='APPEND')
C================================================
C SOLVE TIME,NTSTEP,DTIME,IAPPENDCLEAR,IELEC,IFLOW,ITHER,ICONC,ISTAT
C IAPPENDCLEAR = 0 otevreni noveho souboru a vynulovani zony EPA
C              = 1 otevreni noveho souboru, ale ponechani zony EPA
C              > 1 pokracovani do jiz otevreneho souboru a ponechani zony EPA
C      (vektor IALGOR=pocet iteraci)
C         ELEC FLOW THER CONC COND CONA STAT
C          21   22   23   24   25   26   27
C
      TIME=RP(1)
      NTSTEP=IP(2)
      DTIME=RP(3)
      IAPPEND=IP(4)
      DO I=5,9
         IALGOR(16+I)=IP(I)
      ENDDO
C Minimum and maximum values of dispersion coefficient and Peclet number
      RALGOR(32)=1E10
      RALGOR(33)=-1E10
      RALGOR(34)=1E10
      RALGOR(35)=-1E10
      WRITE(2,'(/'' RUNFEMD STARTS'',I4,'' TIME STEPS''/1X,50(''=''))')
     /  NTSTEP
      CALL CHECK(IERRR,2,2,IOBR)
C
C Zjisteni, zda jde o reseni potrubni site 
C a vypocet teplotniho, ci koncentracniho pole 
C $IHEPI=2 - metoda charakteristik
C $IHEPI=1 - metoda entalpickych bilanci
C 
      NPIPES=0
      NCONVE=0
      DO IE=1,NE
        IG=IGROUP(IE)
        IF(IG.GT.0.AND.IG.LE.MAXMGROUP)THEN
          IF(JGROUP(IG,$ENAME).EQ.$PIPE2D)NPIPES=NPIPES+1
          IF(JGROUP(IG,$ENAME).EQ.$FLOW2D.OR.
     /       JGROUP(IG,$ENAME).EQ.$PLANE2D)NCONVE=NCONVE+1
        ENDIF
      ENDDO
      IF(NPIPES.GT.0.AND.$IHEPI.EQ.2)THEN
          PIPE=.TRUE.
      ELSE
          PIPE=.FALSE.
      ENDIF
      IF(NCONVE.GT.0.AND.$IHEPI.GE.2)THEN
          CONVE=.TRUE.
C Je treba otevrit soubor pro boxing
          OPEN(6,FILE='$RUNBOX.BIN',ACCESS='DIRECT',RECL=4)
      ELSE
          CONVE=.FALSE.
      ENDIF
C
C Pri prvnim pouziti otevreni souboru PROBLEM.OUT a PROBLEM.TEP
      IF(IAPPEND.LE.1)THEN
C UNIT 3 - stupne volnosti
         CLOSE(3)
         WRITE(*,'(/'' Open file ['',A,''.OUT] for resulting DOFs'')')
     /             TRIM(PROBLEM)
         OPEN(3,FILE=TRIM(PROBLEM)//'.OUT')
         WRITE(3,'('' SOLVE '',A,'' ND='',I6)')PROBLEM,ND
         WRITE(3,'(E11.3,F15.3,'' (time, dtime) INITIAL'')')TIME,DTIME
C Nazvy pouzitych velicin - hlavicka tabulky
         WRITE(3,'(6X,20(7X,A4))')(TDOF(JPU(J)),J=1,MDOF)
         DO I=1,ND
           WRITE(3,'(I6,20E11.3)')I,(VAL((J-1)*MAXND+I,3),J=1,MDOF)
         ENDDO
C UNIT 4 - parametry elementu
         CLOSE(4)
         WRITE(*,'(/'' Open file ['',A,''.TEP] for resulting EPAram'')')
     /             TRIM(PROBLEM)
         OPEN(4,FILE=TRIM(PROBLEM)//'.TEP')
         WRITE(4,'('' SOLVE '',A,'' NE='',I6)')PROBLEM,NE
C Prenos pocatecnich podminek TEMP,VX,VY,PRESS,C,PS,PSX,PSY do pracovni zony 4
         NDOF=8
         JDOF(1:8)=(/$TEMP,$VX,$VY,$PRES,$CN,$PS,$PSX,$PSY/)
         CALL COPY(3,4)
C IAPPEND=0 Vynulovani pracovni zony elementu EPAR 
C (s vyjimkou poslednich dvou sloupcu,
C ktere obsahuji indexy proudu vymeniku).
         IF(IAPPEND.EQ.0)THEN
            WRITE(*,'(/'' Clear'',i3,'' columns of EPAR'')')MAXEPAR-2
            KEPAR=0
            DO IE=1,NE
              IG=IGROUP(IE)
              IF(IG.GT.0.AND.IG.LE.MAXMGROUP)THEN
                 NAMELE=JGROUP(IG,$ENAME)
                 DO I1=1,NEPAR(NAMELE)
                    IF(JEPAR(NAMELE,I1).NE.$EE1.AND.
     /                 JEPAR(NAMELE,I1).NE.$EE2)EPAR(IE,I1)=0.
                 ENDDO
              ENDIF
            ENDDO
         ENDIF
      ELSE
C IAPPEND=2,3,... - pokracovani vypoctu otevreni souboru 3,4
         OPEN(3,FILE=TRIM(PROBLEM)//'.OUT',ACCESS='APPEND')
         OPEN(4,FILE=TRIM(PROBLEM)//'.TEP',ACCESS='APPEND')
         WRITE(*,501)
         WRITE(2,501)
501      FORMAT(/' Append results to files .OUT and .TEP'/)
      ENDIF
COPER FEM  Cyklus casovych / iteracnich kroku 
C -------------------------------------
      DO ITIME=1,NTSTEP
         TIME=TIME+DTIME
         WRITE(*,100)ITIME,TIME
         WRITE(2,100)ITIME,TIME
100      FORMAT(/' BEGIN TIME STEP=',I4,' TIME CALCULATED=',E10.3/
     /            1X,50('-'))
C Cyklus pres operace
         DO IOPER=1,MAXOPER
           NITER=IALGOR(20+IOPER)
           IF(NITER.GT.0)THEN
C
C Pred zacatkem kazde operace se vola funkce $IFUN (pokud je definovana)
C
             IF($IFUN.NE.0)THEN
               IAUX(49)=IOPER
               IDUMMY=CURFUN($IFUN)
             ENDIF
C
             SELECT CASE(IOPER)
             CASE($ELEC)
C   ELEC
                NDOF=1
                JDOF(1)=$VOLT
                JDOFEPS(1)=$VOLTEPS
             CASE($FLOW)
C   FLOW
                NDOF=12
                JDOF(1:NDOF)=(/$VX,$VY,$VZ,$PRES,$OMG,$PS,
     /                         $PSX,$PSY,$PSZ,$OMGX,$OMGY,$OMGZ/)
                JDOFEPS(1:NDOF)=(/$VEPS,$VEPS,$VEPS,$PRESEPS,
     /                            $OMGEPS,$PSEPS,
     /                            $PSDEPS,$PSDEPS,$PSDEPS,
     /                            $OMGEPS,$OMGEPS,$OMGEPS/)
             CASE($THER)
C   THER
                IF($IPHASE.NE.1)THEN
                   NDOF=1
                   JDOF(1)=$TEMP
                   JDOFEPS(1)=$TEMPEPS
                ELSE
                   NDOF=2
                   JDOF(1:2)=(/$TEMP,$HT/)
                   JDOFEPS(1:2)=(/$TEMPEPS,$TEMPEPS/)
                ENDIF
             CASE($CONC)
C   CONC
                NDOF=1
                JDOF(1)=$CN
                JDOFEPS(1)=$CNEPS
             CASE($COND)
C   COND
                NDOF=1
                JDOF(1)=$CD
                JDOFEPS(1)=$CNEPS
             CASE($CONA)
C   CONA
                NDOF=1
                JDOF(1)=$CA
                JDOFEPS(1)=$CNEPS
             CASE($STAT)
C   STAT
                NDOF=3
                JDOF(1:3)=(/$UX,$UY,$RZ/)
                JDOFEPS(1:3)=(/$UEPS,$UEPS,$REPS/)
             END SELECT  
C
             ICOUNTS=0
             CALL FMFRIN(IOPER,EDOF,IUE,LUE,MUE,NE,ND)
             WRITE(*,101)TOPER(IOPER),ICOUNTS,(TDOF(JDOF(I)),I=1,NDOF)
             WRITE(2,101)TOPER(IOPER),ICOUNTS,(TDOF(JDOF(I)),I=1,NDOF)
101          FORMAT(4X,A,' FMFRIN(',I7,' elements) start solution of',
     /7(1X,A4))
             DO ITER=1,NITER
C LOADIN kopiruje NDOF V1->V2 (s eventualni funkcni transformaci dle IPU)
C Okrajove podminky a zatizeni se vyhodnocuji v case TIME+DTIME (ne tedy
C pro case TIME, ktery odpovida pocatecnim podminkam)
               CALL LOADIN
C 
C Konvektivni pulkroky se pocitaji jen v prvni iteraci. Vysledek je zona 3,
C tj. nove pocatecni podminky.
C
               IF(PIPE.AND.(IOPER.EQ.$CONC.OR.IOPER.EQ.$THER).AND.
     /           ITER.EQ.1)THEN
C Konvektivni pulkrok: BPIPE vychazi ze zony 3 a vysledky uklada nejprve
C do zony 2 (pracovni) a pak je prenese zpet do zony 3 (poc.podminky)
                 CALL BPIPE(IOPER,MAXLEV)
                 CALL LOADIN
                 WRITE(*,106)TOPER(IOPER),MAXLEV
                 WRITE(2,106)TOPER(IOPER),MAXLEV
106              FORMAT(4X,A,' BPIPE convective step changed init.condit
     /ions. Reccursion level=',i2) 
               ENDIF
               IF(CONVE.AND.(IOPER.EQ.$CONC.OR.IOPER.EQ.$THER).AND.
     /           ITER.EQ.1)THEN
C Konvektivni pulkrok: BCONVE vychazi ze zony 3 a vysledky uklada nejprve
C do zony 2 (pracovni) a pak je prenese zpet do zony 3 (poc.podminky)
                 CALL BCONVE(IOPER)
C LOADIN aktualizuje pouze zonu 2 bez ohledu na pocatecni podminky v zone 3
                 CALL LOADIN
                 WRITE(*,110)TOPER(IOPER)
                 WRITE(2,110)TOPER(IOPER)
110              FORMAT(4X,A,' BCONVE convective step has changed initia
     /l conditions.') 
               ENDIF
               IF($IPHASE.EQ.1.AND.IOPER.EQ.$THER.AND.ITER.EQ.1)THEN
C Fazove zmeny : prepocet entalpii z teplot v zone pocatecnich podminek
                 WRITE(*,111)TOPER(IOPER)
                 WRITE(2,111)TOPER(IOPER)
111              FORMAT(4X,A,' BPHASE calculates enthalpies from intial 
     /temperatures.') 
                 CALL BPHASE
               ENDIF
C
               ICOUNTS=0
               CALL GETTIM(ihr,imin,isec,i100th)
               TIM0=60*imin+isec+i100th*0.01
               CALL FDFRON(0,IOPER,EDOF,IPU,VAL(1,2),NE,$REPSPIV,ITELIM,
     /                     0,FEL)
               CALL GETTIM(ihr,imin,isec,i100th)
               TIM=60*imin+isec+i100th*0.01-TIM0
C Procedura COPY kopiruje NDOF-parametru do zony 4 s podrelaxaci $RELFAKT
C a soucasne pocita jejich residua
               CALL COPYREL(2,4)
               IF(NITER.GT.1)THEN
                 WRITE(*,102)ITER,TOPER(IOPER),ICOUNTS,$RELFAKT
                 WRITE(2,102)ITER,TOPER(IOPER),ICOUNTS,$RELFAKT
102              FORMAT(I3,1X,A,' FDFRON(0;',i5,') copy result to tempor
     /ary zone [',F4.2,']')
C Ukonceni iteraci po dosazeni presnosti. Procedura COPY vyhodnotila rozdily
C vypoctenych DOF a pro kazdy z nich je specifikovana max hodnota ve vektoru
C RALGOR. 
                 OKEPS=.TRUE.
                 DO I=1,NDOF
                   IF(DOFRESI(JDOF(I)).GT.RALGOR(JDOFEPS(I)))
     /                       OKEPS=.FALSE.
                 ENDDO
                 IF(OKEPS)EXIT
C Vypis residui pokud nebylo dosazeno pozadovane presnosti
                 WRITE(*,108)TOPER(IOPER)
                 WRITE(2,108)TOPER(IOPER)
108              FORMAT(4X,A,' residuals:'\)
                 DO I=1,NDOF
                    DR=DOFRESI(JDOF(I))
                    IF(DR.GT.0.)THEN
                         WRITE(*,107)TDOF(JDOF(I)),DR
                         WRITE(2,107)TDOF(JDOF(I)),DR
107                      FORMAT(1X,A4,'=',E8.2\)
                    ENDIF
                 ENDDO
                 WRITE(*,109)
                 WRITE(2,109)
109              FORMAT(1X)
C Postprocessing iteracni (ICNTR=2), 
C vypocet prutoku z tlaku, rychlosti z PSI ap.
C Pouziva se pouze pri typu analyzy FLOW
                 IF(IOPER.EQ.$FLOW)THEN
                    ICOUNTS=0
                    CALL FDFRON(2,IOPER,EDOF,IPU,VAL(1,2),NE,
     /                          $REPSPIV,ITELIM,0,FEL)
                    WRITE(*,306)TOPER(IOPER),ICOUNTS
                    WRITE(2,306)TOPER(IOPER),ICOUNTS
306                 FORMAT(4X,A,' FDFRON(2;',I5,') flow postprocessing')
                 ENDIF
               ELSE
                 WRITE(*,105)TOPER(IOPER),ICOUNTS,TIM
                 WRITE(2,105)TOPER(IOPER),ICOUNTS,TIM
105              FORMAT(4X,A,' FDFRON(0;',i5,' elements) without accurac
     /y check. RUN time=',F7.2)
               ENDIF
             ENDDO
C Prenos doiterovaneho vysledku do zony pocatecnich podminek
             CALL COPY(2,3)
C Postprocessing na zaver casoveho kroku (ICNTR=1)
C Nulujeme scitaci promenne POWERE, POWERF,...
             RALGOR(38+IOPER)=0
             ICOUNTS=0
             CALL FDFRON(1,IOPER,EDOF,IPU,VAL(1,2),NE,$REPSPIV,ITELIM,
     /                   0,FEL)
             WRITE(*,103)TOPER(IOPER),ICOUNTS,RALGOR(38+IOPER)
             WRITE(2,103)TOPER(IOPER),ICOUNTS,RALGOR(38+IOPER)
103          FORMAT(4X,A,' FDFRON(1;',I5,') postprocessing. POWER=',E10.
     /3)
C Vytvoreni souboru s primym pristupem v nemz jsou ulozeny informace 
C o konektivite elementu PIPE2D a vypoctene rychlosti
             IF(NPIPES.GT.0.AND.IOPER.EQ.$FLOW)THEN
C WPIPE vytvori soubor $BPIPE.BIN
               CALL WPIPE
               WRITE(*,307)TOPER(IOPER)
               WRITE(2,307)TOPER(IOPER)
307            FORMAT(4X,A,' Writing $BPIPE.BIN for backtracking')
C Pokud se bude pocitat i teplotni pole, vypocitaji se i tloustky teplotni
C mezni vrstvy (IALGOR(23)-pocet iteraci THERM)
               IF(IALGOR(23).GT.0)THEN
                  CALL BLAYERS(MITER)
                  WRITE(*,311)TOPER(IOPER),MITER
                  WRITE(2,311)TOPER(IOPER),MITER
311               FORMAT(4X,A,' Thermal boundary layer EQZ calculated in
     /',i3,' iterations.')
               ENDIF
             ENDIF
C          ENDIF - NITER.GT.0
           ENDIF
         ENDDO
C --------------------------------------
C Zapis vysledku casoveho kroku 
C
         WRITE(*,104)ITIME,TIME
         WRITE(2,104)ITIME,TIME
104      FORMAT(/' END of TIME STEP=',I4,' time=',E9.2)
         WRITE(3,'(E12.4,E15.2,7E10.3,'' (time,dtime,PowerE,PowerF,Power
     /T,PowerC,PowerD,PowerA,PowerS)'')')TIME,DTIME,(RALGOR(I),I=39,45)
         WRITE(3,'(6X,20(7X,A4))')(TDOF(JPU(J)),J=1,MDOF)
         DO I=1,ND
           WRITE(3,'(I6,20E11.3)')I,(VAL((J-1)*MAXND+I,3),J=1,MDOF)
         ENDDO
         WRITE(4,'(E12.4,E15.2,7E10.3,'' (time, dtime, PowerE,...)'')') 
     /TIME,DTIME,(RALGOR(I),I=39,45)
         NAMELE=JGROUP(IGROUP(1),$ENAME)
         WRITE(4,'(6X,20(7X,A4))')
     /             (TEPAR(JEPAR(NAMELE,J)),J=1,NEPAR(NAMELE))
         DO I=1,NE
           NAMELE=JGROUP(IGROUP(I),$ENAME)
           WRITE(4,'(I6,20E11.3)')I,(EPAR(I,J),J=1,NEPAR(NAMELE))
         ENDDO
C --------------------------------------
         PRESSED=PEEKCHARQQ()
         IF(PRESSED)THEN
            C=GETCHARQQ()
            IENDCHECK=ICHAR(C)
            GOTO 999
         ENDIF
      ENDDO

999   IF(RALGOR(32).LE.RALGOR(33))WRITE(2,'(/'' Axial dispersion De='',
     /e10.3,''-min, '',e10.3,''-max'')')RALGOR(32),RALGOR(33)
      IF(RALGOR(34).LE.RALGOR(35))WRITE(2,'(/'' Peclet number Pe='',
     /e10.3,''-min, '',e10.3,''-max'')')RALGOR(34),RALGOR(35)
      WRITE(*,'(1X,''Exit from RUNFEMD, writing $RUNFEM.BIN'')')
      WRITE(2,'(//'' RUNFEMD ends'')')
      REWIND 1
      CALL WRITEBIN(1,0)
1000  CONTINUE
      END

      SUBROUTINE FEL(ICNTR,IE,IOPER,NL,NUE,AL,BL)
      DIMENSION AL(NL,NL),BL(NL)
C Vstupni parametry IE-index elementu, IOPER-operace
C 
      INCLUDE '$FEMEQ'
C INAME=1 PIPE2D,...
      INAME=JGROUP(IGROUP(IE),$ENAME)
      IF(INAME.EQ.$USER)THEN
         CALL USER(ICNTR,IOPER,IE,NL,NUE,AL,BL)
      ELSE
      SELECT CASE(IOPER)
      CASE($ELEC)
C ELEC
        SELECT CASE(INAME)
        CASE($PIPE2D,$TRUSS2D,$BEAM2D)
          CALL ELE1(ICNTR,IE,NL,NUE,AL,BL)
        CASE($PLANE2D,$FLOW2D)
          CALL ELEC(ICNTR,IE,NL,NUE,AL,BL)
        CASE($SOLID)
          CALL ELEC3(ICNTR,IE,NL,NUE,AL,BL)
        ENDSELECT
      CASE($THER)
C THER
        SELECT CASE(INAME)
        CASE($TRUSS2D,$BEAM2D)
          CALL HEXC(ICNTR,IE,NL,NUE,AL,BL)
        CASE($PIPE2D,$CSTR,$HEXC,$PUMP)
          IF($IHEPI.EQ.1)THEN
C ENTALPICKA BILANCE
            CALL HHEXC(ICNTR,IE,NL,NUE,AL,BL)
          ELSEIF($IHEPI.EQ.2)THEN
C METODA CHARAKTERISTIK PRO 1D
            CALL BHEXC(ICNTR,IE,NL,NUE,AL,BL)
          ELSE
C METODA VAZENYCH RESIDUI
            CALL HEXC(ICNTR,IE,NL,NUE,AL,BL)
          ENDIF
        CASE($PLANE2D,$FLOW2D)
          IF($IPHASE.NE.0)THEN
C PHASE CHANGES
            CALL PTHER(ICNTR,IE,NL,NUE,AL,BL)
          ELSEIF($IHEPI.GE.2)THEN
C METODA CHARAKTERISTIK PRO 2D
            CALL BTHER(ICNTR,IE,NL,NUE,AL,BL)
          ELSE 
            CALL THER(ICNTR,IE,NL,NUE,AL,BL)
          ENDIF
        CASE($SOLID)
          CALL THER3(ICNTR,IE,NL,NUE,AL,BL)
        ENDSELECT
      CASE($CONC,$COND,$CONA)
C CONC
        SELECT CASE(INAME)
        CASE($PIPE2D,$CSTR,$PUMP,$VALVE)
          IF($IHEPI.EQ.1)THEN
C HMOTNOSTNI BILANCE slozek cn,cd,ca
            CALL RRTD(IOPER,ICNTR,IE,NL,NUE,AL,BL)
          ELSEIF($IHEPI.EQ.2)THEN
C METODA CHARAKTERISTIK PRO 1D
            CALL BRTD(IOPER,ICNTR,IE,NL,NUE,AL,BL)
          ELSE
C METODA VAZENYCH RESIDUI
            CALL RTD(IOPER,ICNTR,IE,NL,NUE,AL,BL)
          ENDIF
        CASE($PLANE2D,$FLOW2D)
          IF($IHEPI.GE.2)THEN
            CALL BCONC(IOPER,ICNTR,IE,NL,NUE,AL,BL)
          ELSE
            CALL CONC(IOPER,ICNTR,IE,NL,NUE,AL,BL)
          ENDIF
        CASE($SOLID)
          CALL CONC3(IOPER,ICNTR,IE,NL,NUE,AL,BL)
        ENDSELECT
      CASE($FLOW)
C FLOW
        SELECT CASE(INAME)
        CASE($PIPE2D,$CSTR,$PUMP,$VALVE,$HEXC)
          IF($IHEPI.EQ.1)THEN
            CALL HPIPE(ICNTR,IE,NL,NUE,AL,BL)
          ELSE
            CALL PIPE(ICNTR,IE,NL,NUE,AL,BL)
          ENDIF
        CASE($FLOW2D)
          MET=JGROUP(IGROUP(IE),$METHOD)
          SELECT CASE(MET)
          CASE($UVP)
            CALL UVP(ICNTR,IE,NL,NUE,AL,BL)
          CASE($UVPP)
            CALL UVPP(ICNTR,IE,NL,NUE,AL,BL)
          CASE($MIKE)
            CALL MIKE(ICNTR,IE,NL,NUE,AL,BL)
          CASE($PENS)
            CALL PENS(ICNTR,IE,NL,NUE,AL,BL)
          CASE($MIDE)
            CALL MIDE(ICNTR,IE,NL,NUE,AL,BL)
          CASE($PSIN)
            CALL PSIN(ICNTR,IE,NL,NUE,AL,BL)
          CASE($CREE)
            CALL CREE(ICNTR,IE,NL,NUE,AL,BL)
          CASE($PSOM)
            CALL PSOM(ICNTR,IE,NL,NUE,AL,BL)
          CASE($CARE)
            CALL CARE(ICNTR,IE,NL,NUE,AL,BL)
          END SELECT
        END SELECT
      CASE($STAT)
C STAT
        SELECT CASE(INAME)
        CASE($TRUSS2D)
          CALL TRUSS2D(ICNTR,IE,NL,NUE,AL,BL)
        CASE($BEAM2D,$PIPE2D)
          CALL BEAM(ICNTR,IE,NL,NUE,AL,BL)
        CASE($SHELLAX)
          CALL SHEL(ICNTR,IE,NL,NUE,AL,BL)
        CASE($PLANE2D)
          CALL PLANE2(ICNTR,IE,NL,NUE,AL,BL)
        ENDSELECT
      END SELECT  
      ENDIF
      END

C      INCLUDE '$S4-KLOC.FOR'
C      INCLUDE '$S4A-KLO.FOR'
C      INCLUDE '$S4B-KLO.FOR'
C      INCLUDE '$S4C-KLO.FOR'
C      INCLUDE '$S5-KLOC.FOR'
C      INCLUDE '$S5A-KLO.FOR'
C      INCLUDE '$S6-KLOC.FOR'
C      INCLUDE '$S7-KLOC.FOR'
C      INCLUDE '$S8-KLOC.FOR'
C      INCLUDE '$S9-KLOC.FOR'
C      INCLUDE '$S12-KLO.FOR'
C      INCLUDE '$S14-KLO.FOR'
C      INCLUDE '$S15-KLO.FOR'
C      INCLUDE '$S16-KLO.FOR'
C      INCLUDE '$S17-KLO.FOR'
C      INCLUDE '$$-COMM.FOR'
C      INCLUDE '$USER.FOR'
C	INCLUDE '$$-COME.FOR'
C	INCLUDE '$$-PARF.FOR'
C	INCLUDE '$RUN-COL.FOR'
