C SETUP.for 
      SUBROUTINE SETUP()
C$IF DEFINED (compaq)
      USE DFLIB
C$ELSE
C      USE MSFLIB
C$ENDIF
      PARAMETER (LENLIN=200)
      INTEGER*2 C1,C2
      INTEGER*4 UNIT
      CHARACTER*(LENLIN) LINE,LINES(200)
COMMON
	INCLUDE '$WIN'
      CHARACTER HETEXT
      LOGICAL SAVED,WESULT,REPEAT
      INQUIRE(FILE='$FEMWIN.CFG',EXIST=WESULT)
      IF(WESULT)THEN
         OPEN(98,FILE='$FEMWIN.CFG')
         WRITE(*,*)' Setup file $FEMWIN.CFG from the current directory'
      ELSE       
         INQUIRE(FILE='.\FILES\$FEMWIN.CFG',EXIST=WESULT)
         IF(WESULT)THEN
           OPEN(7,FILE='.\FILES\$FEMWIN.CFG')
           WRITE(*,*)' Setup file $FEMWIN.CFG from the directory FILES'
         ELSE
           WRITE(10,*)' Unable to find setup file $FEMWIN.CFG. Default s
     /ettings are used.'
           GOTO 2010
         ENDIF
      ENDIF
C OPEN $FEMWIN.CFG file     
      ILIN=0
2005  READ(7,'(A)',END=2010)LINE
      CALL TUPC(LENLIN,LINE,LINE)
      IF(LINE(1:1).NE.'#')THEN
        IF(LINE(1:10).EQ.'\\WINCOUNT')THEN
          READ(7,*,ERR=2010)NWINS,IOLDWOPEN
          DO I=1,NWINS
            READ(7,'(I3,A)',ERR=2010)UNIT,LABELA(UNIT) 
            UNITAS(I) = UNIT
            READ(7,*,ERR=2010)ixpos(unit),iypos(unit),ixpix(unit),
     /         iypix(unit),nrow(unit),ncol(unit)
            READ(7,*,ERR=2010)ifontph(unit),ihfontph(unit),
     /         icursor(unit)
            READ(7,'(A)',ERR=2010)fontphattr(unit)
            READ(7,*,ERR=2010)icfR(unit),icfG(unit),icfB(unit)
            READ(7,*,ERR=2010)icbR(unit),icbG(unit),icbB(unit)
          ENDDO
        ENDIF
      ELSE
        ILIN=ILIN+1
        LINES(ILIN)=LINE
      ENDIF
      GOTO 2005
2010  CLOSE(7)
C Aktivace WIN
      SAVED=.TRUE.
      REPEAT=.TRUE.
      IOLDWOPEN=0
      DO WHILE(REPEAT)
        II=FOCUSQQ(20)
        CALL CLEARSCREEN($GCLEARSCREEN)
        C1=SETTEXTCOLOR(INT2(15))      
        WRITE(20,*)'This is main configuration menu selected by letters 
     /E,B,X,D or [Esc].'
        WRITE(20,*)
        C2=SETTEXTCOLOR(INT2(11))      
        WRITE(20,*)'Resume FEMINA processing by [Esc] or'
        WRITE(20,*) 'select [E]asy, [B]asic, e[X]pert menu or [D]efault 
     /configuration'
        C1=SETTEXTCOLOR(INT2(15))      
        WRITE(20,*)
        CALL GCU(HETEXT,IEND)
        IF(IEND.EQ.227)REPEAT=.FALSE.
        SELECT CASE (hetext)
        CASE ('e','E')    ! EASY config
           CALL EASY(SAVED,LINES,ILIN,NWINS)
        CASE ('b','B')    ! Basic config
           CALL BASIC(SAVED,LINES,ILIN,NWINS)
        CASE ('x','X')    ! Expert config
           CALL EXPERT(SAVED,LINES,ILIN,NWINS)
        CASE ('D','d')
           IOLDWOPEN=1
           SAVED=.FALSE.
           REPEAT=.FALSE.
           WRITE(20,'('' Native fonts will be restored in the $FEMWIN.CF
     /G (concerns the next FEMINA run'')')
        END SELECT
      END DO
      IF (.NOT.SAVED) THEN
            CALL WRITEWIN(LINES,ILIN,NWINS,SAVED)
      ELSE ! SAVE = n
            WRITE(*,*)'Exiting without $FEMWIN.CFG save!!!'
      ENDIF !SAVE = y
      END

      SUBROUTINE DEFS(IXRES,IYRES,NCOLA,NROWA)
C Standardni nastaveni
      PARAMETER (LENLIN=200)
	INCLUDE '$WIN'

      IDUMMX=IXRES
      IDUMMY=IYRES

$IF DEFINED (compaq)         
      ixpos(20)=0
      ixpos(10)=0
      ixpos(11)=0
      ixpos(30)= floor(0.079*IXRES)
      ixpos(21)=ixpos(30)
      ixpos(22)=ixpos(30)
      ixpos(40)=ixpos(30)
      ixpos(39)=ixpos(30)
      iypos(20)=0
      iypos(30)=0
      iypos(11)=floor(0.04*IYRES)
      iypos(10)= 0.045*IYRES
      iypos(40)=iypos(10)
      iypos(39)=iypos(10)
      iypos(21)=floor(iypos(10)/2.25)
      iypos(22)=iypos(21)
      ixpix(20)=floor(0.62*IXRES) 
      ixpix(10)=ixpix(20)     
      ixpix(11)=ixpix(20)     
      ixpix(30)=floor(0.375*IXRES) 
      ixpix(21)=ixpix(30)     
      ixpix(22)=ixpix(30)     
      ixpix(40)=IXRES  
      ixpix(39)=ixpix(40)     
      iypix(20)=floor(0.615*IYRES)
      iypix(10)=floor(0.143*IYRES)
      iypix(11)=floor(0.065*IYRES)
      iypix(30)=floor(0.287*IYRES)
      iypix(21)=floor(0.371*IYRES)
      iypix(22)=iypix(21)
      iypix(40)=IYRES
      iypix(39)=IYRES
      DO I=1,7
         unita =unitas(i)
         ncol(unita)=floor(ixpix(unita)/8.+0.5) 
         nrow(unita)=floor(iypix(unita)/15.8+0.5) 
         ihfontph(unita)=floor(0.02083*IYRES+0.5)
      ENDDO
      ncol(40)=floor(ixpix(21)/8.+0.5 - 2) 
      nrow(40)=floor(iypix(10)/15.8+0.5 - 1)
      ncol(39)=NCOLA*0.9
      nrow(39)=nrow(40)
      nrow(11)=3
$ELSE  
      nrow(10)=0.2*NROWA
      nrow(11)=4
      nrow(20)=int2(0.62*NROWA)
      nrow(30)=0.32*NROWA
      nrow(21)=0.42*NROWA
      nrow(22)=0.42*NROWA
      nrow(40)=0.125*NROWA
      nrow(39)=0.85*NROWA 
      MAXTROWS=nrow(22)
      ncol(10)=0.705*NCOLA
      ncol(11)=ncol(10)
      ncol(20)=ncol(10)
      ncol(30)=0.4*NCOLA
      ncol(21)=ncol(30)
      ncol(22)=ncol(30)
      ncol(40)=0.34*NCOLA
      ncol(39)=ncol(40)
      ixpos(10)=0
      ixpos(11)=0
      ixpos(20)=0
      ixpos(21)=0.64*NCOLA
      ixpos(22)=ixpos(21)
      ixpos(30)=ixpos(21)
      ixpos(40)=ixpos(21)
      ixpos(39)=ixpos(21)
C      iypos(10)=0.688*NROWA
C      iypos(11)=0.61*NROWA
      iypos(10)=0.71*NROWA
      iypos(11)=0.63*NROWA
      iypos(20)=0
      iypos(21)=0.325*NROWA
      iypos(22)=iypos(21)
      iypos(30)=0
      iypos(40)=iypos(10)
      iypos(39)=0
      ixpix(10)=0.625*IXRES
      ixpix(11)=0.625*IXRES
      ixpix(20)=0.625*IXRES
      ixpix(21)=0.3555*IXRES
      ixpix(22)=0.3555*IXRES
      ixpix(30)=0.3555*IXRES
      ixpix(40)=IXRES 
      ixpix(39)=IXRES 
      iypix(10)=0.15*IYRES
      iypix(11)=0.050*IYRES
      iypix(20)=0.6*IYRES
      iypix(21)=0.345*IYRES
      iypix(22)=0.345*IYRES
      iypix(30)=0.28*IYRES
      iypix(40)=IYRES
      iypix(39)=6*IYRES
$ENDIF    
      END

      SUBROUTINE WRITEWIN(LINES,ILIN,NWINS,SAVED)
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
C Zapis do souboru $FEMWIN.CFG
      PARAMETER (LENLIN=200)
      CHARACTER*(LENLIN) LINES(200)
	INCLUDE '$WIN'
      INTEGER*4 UNIT
      INTEGER*2 C1,C2
      CHARACTER HETEXT
      LOGICAL SAVED
      C2=SETTEXTCOLOR(INT2(11))
      WRITE(20,'('' Save all changes to a $FEMWIN.CFG file? y/n'')')  
      C1=SETTEXTCOLOR(INT2(15))
      CALL GCU(HETEXT,IEND)
      IF(HETEXT.EQ.'Y'.OR.HETEXT.EQ.'y')THEN
         WRITE(20,*)'Saving a new $FEMWIN.CFG file'
         CLOSE (7) 
         OPEN(7,FILE='.\FILES\$FEMWIN.CFG')
         DO I=1,ILIN
            WRITE(7,'(A)')TRIM(LINES(i))
         ENDDO
          WRITE(7,'(A)')'\\WINCOUNT'
         WRITE(7,'(2I2)')NWINS,IOLDWOPEN
         DO I=1,NWINS
           unit =unitas(i)
           WRITE(7,'(I2,A1,A)')UNIT,'',TRIM(LABELA(UNIT))
           WRITE(7,'(6I5)')ixpos(unit),iypos(unit),ixpix(unit),
     /     iypix(unit),nrow(unit),ncol(unit)
           WRITE(7,'(3I4)')ifontph(unit),ihfontph(unit),
     /     icursor(unit)
           WRITE(7,'(A)')fontphattr(unit)
           WRITE(7,'(3I4)')icfR(unit),icfG(unit),icfB(unit)
           WRITE(7,'(3I4)')icbR(unit),icbG(unit),icbB(unit)  
         ENDDO
         CLOSE(7)
         SAVED=.TRUE.
      ELSE
         SAVED=.FALSE.
      ENDIF
      END

      SUBROUTINE EASY(SAVED,LINES,ILIN,NWINS)
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      PARAMETER (LENLIN=200)
      CHARACTER*(LENLIN) LINES(200)
      INTEGER*2 C1,C2
	INCLUDE '$WIN'
      REAL RNCOL,RNROW
      CHARACTER HETEXT,KEY
      LOGICAL SAVED,EXITA,CHANGE
      TYPE (windowconfig) MY_WC 
      WRITE(20,*)'EASY config sets window size and position automaticall
     /y,'
      WRITE(20,*)'according to specified screen resolution. It is also p
     /ossible '
      WRITE(20,*)'to adjust font size in specified windows.'
      WRITE(20,*)'[Esc] returns you to the main menu. Press any key...'
      CALL GCU(KEY,IEND)
      IF(IEND.EQ.227)RETURN
      OPEN(99,file='user',title='temporary window')
      STATUS=GETWINDOWCONFIG(MY_WC)
      CLOSE(99)
      EXITA=.true.
      DO WHILE (EXITA)
         CALL DISWIN
         II=FOCUSQQ(20)
         C2=SETTEXTCOLOR(INT2(11))      
         WRITE(20,'('' EASY menu changes: screen [R]esolution, [F]ont or
     / [S]ave and [E]xit'')')      
         C1=SETTEXTCOLOR(INT2(15))      
         CALL GCU(HETEXT,IEND)
         IF(IEND.EQ.227)HETEXT='E'
         SELECT CASE (hetext)
         CASE ('R','r')    ! Windows position     
             SAVED=.false.      
             WRITE(20,'('' Current resolution is: '',I4,'' x '',I4,'' pi
     /xels '')')MY_WC.NUMXPIXELS,MY_WC.NUMYPIXELS
             C2=SETTEXTCOLOR(INT2(11))      
             WRITE(20,'('' [r]reset to default or [c]hange resolution? '
     /')')      
             C1=SETTEXTCOLOR(INT2(15))      
             CALL GCU(HETEXT,IEND)      
             SELECT CASE (hetext)
             CASE ('C','c')  
                 CHANGE=.true.
C pomery mezi pixely a sloupky/radky                 
                 RNCOL=MY_WC.NUMXPIXELS/MY_WC.NUMTEXTCOLS
                 RNROW=MY_WC.NUMYPIXELS/MY_WC.NUMTEXTROWS 
                 WRITE(20,'('' Change the screen resolution '')')
                 WRITE(20,'('' Current x-resolution is: '',I4,'' '')') 
     /MY_WC.NUMXPIXELS
                 WRITE(20,'('' Input a new x-resolution:  ''\)')
                 READ(20,'(I4)')IXRES
                 IF(IXRES.LE.0)IXRES=MY_WC.NUMXPIXELS
                 WRITE(20,'('' Current y-resolution is: '',I4,'' '')') 
     /MY_WC.NUMYPIXELS
                 WRITE(20,'('' Input a new y-resolution:  ''\)')
                 READ(20,'(I4)')IYRES
                 IF(IYRES.LE.0)IYRES=MY_WC.NUMYPIXELS
C Kde je definovano NCOLA,NROWA?????
C Odp. tady: - doplnil jsem
                 NCOLA=IXRES/RNCOL
                 NROWA=IYRES/RNROW              
             CASE ('R','r')
                 CHANGE=.true.
                 WRITE(20,'('' Default resolution set.'')')
                 IXRES=MY_WC.NUMXPIXELS
                 IYRES=MY_WC.NUMYPIXELS
                 NCOLA=MY_WC.NUMTEXTCOLS
                 NROWA=MY_WC.NUMTEXTROWS
             CASE  DEFAULT
                 CHANGE=.false.
                 WRITE(20,*)' Calculation with your current resolution'
             END SELECT  !SELECT CASE (resolution)
             IF(CHANGE)CALL DEFS(IXRES,IYRES,NCOLA,NROWA)
         CASE ('F','f')    ! text properties
             WRITE(20,*)'Change font size of selected unit'
             WRITE(20,'('' Input a unit no.:  ''\)')
             READ(20,'(I2)')iunit
             IF(IUNIT.LE.0.OR.IUNIT.GT.50)THEN
                WRITE(20,'('' Wrong unit number specified. Default=10'')
     /')
                IUNIT=10
             ENDIF
             WRITE(20,'('' Current font size of'',I3,'' unit  is: '',I3
     /,'' '')')iunit,ihfontph(iunit)
             WRITE(20,'('' Input a new font size:  ''\)')
             READ(20,'(I3)')itemp 
             IF(ITEMP.LE.0)THEN
                WRITE(20,*)' Wrong font size. Default=16'
                ITEMP=16
             ENDIF
             ihfontph(iunit)=itemp
         CASE ('S','s')    ! Save CFG     
             CALL WRITEWIN(LINES,ILIN,NWINS,SAVED)
         CASE DEFAULT !('E','e') exit config     
             exita=.false.
             DO I=1,7
                IF(UNITAS(I).NE.20.AND.UNITAS(I).NE.10)CLOSE(UNITAS(I))
             END DO
         END SELECT
      END DO !WHILE (exita)
      END

      SUBROUTINE BASIC(SAVED,LINES,ILIN,NWINS)
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      PARAMETER (LENLIN=200)
	INCLUDE '$WIN'
      CHARACTER*(LENLIN) LINES(200)
      CHARACTER HETEXT,KEY
      INTEGER*2 C1,C2
      LOGICAL SAVED,EXITA,POSOK
      WRITE(20,*)'BASIC setting of window size (pixels, no.of text rows 
     /and columns),'
      WRITE(20,*)'vertical and horizontal position of windows, and font 
     /size.'
      WRITE(20,*)'[Esc] returns you to the main menu. Press any key...'
      CALL GCU(KEY,IEND)
      IF(IEND.EQ.227)RETURN
      EXITA=.true.
      DO WHILE (EXITA)
         CALL DISWIN
         II=FOCUSQQ(20)
         C2=SETTEXTCOLOR(INT2(11))      
         WRITE(20,'('' BASIC menu, change: [P]osition, [D]imension, [F]o
     /nt or [S]ave and [E]xit'')')      
         C1=SETTEXTCOLOR(INT2(15))      
         CALL GCU(HETEXT,IEND)
         IF(IEND.EQ.227)HETEXT='E'
         SELECT CASE (HETEXT)
         CASE ('P','p')    ! Windows position     
           SAVED=.false.      
           C2=SETTEXTCOLOR(INT2(11))      
           WRITE(20,'('' Change windows properties: [X]position, [Y]posi
     /tons or [E]xit'')')      
           C1=SETTEXTCOLOR(INT2(15))      
           CALL GCU(HETEXT,IEND)
           IF(IEND.EQ.227)HETEXT='E'
           SELECT CASE (hetext)
           CASE ('X','x')  
              WRITE(20,'('' Change the horizontal position of units [30,
     /22,21,40,39]-windows right'')')
              WRITE(20,'('' Current x-position is: '',I3,'' '')')
     /ixpos(30)
              WRITE(20,'('' Input a new position:  ''\)')
              READ(20,'(I3)')itemp
              ixpos(30)=itemp
              ixpos(22)=itemp
              ixpos(21)=itemp
              ixpos(40)=itemp 
              ixpos(39)=itemp 
              posok=.true.
           CASE ('Y','y')
              WRITE(20,'('' Change the y position of selected unit(s): 
     /'')')
              WRITE(20,'('' Input a unit no.:  ''\)')
              READ(20,'(I2)')iunit
              IF(IUNIT.LE.0.OR.IUNIT.GT.50)THEN
                WRITE(20,'('' Wrong unit number specified. Default=10'')
     /')
                IUNIT=10
              ENDIF
              WRITE(20,'('' Current y-position of'',I3,'' unit  is:'',I4
     /,'' '')')iunit,iypos(iunit)
              WRITE(20,'('' Input a new y-position:  ''\)')
              READ(20,'(I3)')itemp
              SELECT CASE (iunit)
              CASE (21,22)
                 iypos(21)=itemp
                 iypos(22)=itemp
              CASE (10,40)
                 iypos(10)=itemp
                 iypos(40)=itemp
              CASE (39)
                 iypos(39)=itemp
              CASE DEFAULT
                 iypos(iunit)=itemp
              END SELECT
              posok=.true.
           CASE DEFAULT
              posok=.true.
           END SELECT  !SELECT CASE (position)
         CASE ('D','d')    ! Windows size     
           SAVED=.false.
           WRITE(20,*)'Change the size of sel. unit(s) in pixels '
           WRITE(20,'('' Input a unit no.:  ''\)')
           READ(20,'(I2)')iunit
           IF(IUNIT.LE.0.OR.IUNIT.GT.50)THEN
              WRITE(20,'('' Wrong unit number specified. Default=10'')')
              IUNIT=10
           ENDIF
           C2=SETTEXTCOLOR(INT2(11))      
           WRITE(20,'('' Change the [x], [y] dimension or [e]xit: '')')      
           C1=SETTEXTCOLOR(INT2(15))      
           CALL GCU(HETEXT,IEND)
           IF(IEND.EQ.227)HETEXT='E'
           SELECT CASE (hetext)
           CASE ('X','x')
              WRITE(20,'('' Current x-pixel size of'',I3,'' unit  is:
     /  '',I4,'' '')')iunit,ixpix(iunit)
              WRITE(20,'('' Input a new x-pixel size:  ''\)')
              READ(20,'(I4)')itemp
              IF(ITEMP.LE.0)THEN
                 WRITE(20,*)' Wrong pixel size. Default=',IXPIX(IUNIT)
                 ITEMP=IXPIX(IUNIT)
              ENDIF
              SELECT CASE (iunit)
              CASE (20,10,11)
                ixpix(20)=itemp
                ixpix(10)=itemp
                ixpix(11)=itemp
              CASE (30,21,22)
                ixpix(30)=itemp
                ixpix(21)=itemp
                ixpix(22)=itemp
              CASE (40,39)
                ixpix(40)=itemp
                ixpix(39)=itemp
              CASE DEFAULT
                ixpix(iunit)=itemp
              END SELECT
              WRITE(20,'('' Current no.of text-columns of'',I3,'' unit  
     /is:    '',I3,'' '')')iunit,ncol(iunit)
              WRITE(20,'('' Input a new text-columns size:  ''\)')
              READ(20,'(I3)')itemp
              IF(ITEMP.LE.0)THEN
                 WRITE(20,*)' Wrong textcol size. Default=',ncol(IUNIT)
                 ITEMP=NCOL(IUNIT)
              ENDIF
              SELECT CASE (iunit)
              CASE (20,10,11)
                ncol(20)=itemp
                ncol(10)=itemp
                ncol(11)=itemp
              CASE (30,21,22)
                ncol(30)=itemp
                ncol(21)=itemp
                ncol(22)=itemp
              CASE (40,39)
                ncol(40)=itemp
                ncol(39)=itemp
              CASE DEFAULT
                ncol(iunit)=itemp
              END SELECT
           CASE ('Y','y')   
              WRITE(20,'('' Change the  y-size of sel. unit(s): 
     /  in pixels '')')
              WRITE(20,'('' Current y-pixel size of'',I3,'' unit  is:
     /    '',I4,'' '')')iunit,iypix(iunit)
              WRITE(20,'('' Input a new y-pixel size:  ''\)')
              READ(20,'(I4)')itemp
              IF(ITEMP.LE.0)THEN
                 WRITE(20,*)' Wrong pixel size. Default=',IYPIX(IUNIT)
                 ITEMP=IYPIX(IUNIT)
              ENDIF
              SELECT CASE (iunit)
              CASE (21,22)
                iypix(21)=itemp
                iypix(22)=itemp
              CASE (40)
                iypix(40)=itemp
              CASE (39)
                iypix(39)=itemp
              CASE DEFAULT
                iypix(iunit)=itemp
              END SELECT
              WRITE(20,'('' Current no of text-rows of'',I3,'' unit  is:
     /    '',I4,'' '')')iunit,nrow(iunit)
              WRITE(20,'('' Input a new textrow size:  ''\)')
              READ(20,'(I4)')itemp
              IF(ITEMP.LE.0)THEN
                 WRITE(20,*)' Wrong no of row. Default=',NROW(IUNIT)
                 ITEMP=NROW(IUNIT)
              ENDIF
              SELECT CASE (iunit)
              CASE (21,22)
                nrow(21)=itemp
                nrow(22)=itemp
              CASE (40)
                nrow(40)=itemp
              CASE (39)
                nrow(39)=itemp
              CASE DEFAULT
                nrow(iunit)=itemp
              END SELECT
           CASE DEFAULT
           END SELECT
           !win dim properties
         CASE ('F','f')    ! text properties
           SAVED=.FALSE.
           WRITE(20,*)'Change font properties of a selected unit '
           WRITE(20,'('' Input a unit no.:  ''\)')
           READ(20,'(I4)')iunit
           IF(IUNIT.LE.0.OR.IUNIT.GT.50)THEN
              WRITE(20,'('' Wrong unit number specified. Default=10'')')
              IUNIT=10
           ENDIF
           WRITE(20,'('' Current font size of'',I3,'' unit  is:
     /    '',I4,'' '')')iunit,ihfontph(iunit)
           WRITE(20,'('' Input a new font size:  ''\)')
           READ(20,'(I4)')itemp 
           IF(ITEMP.LE.0)THEN
              WRITE(20,*)'Wrong font size. Default=16'
              ITEMP=16
           ENDIF
           ihfontph(iunit)=itemp
         CASE ('S','s')    ! Save CFG     
           CALL WRITEWIN(LINES,ILIN,NWINS,SAVED)
         CASE DEFAULT ! ('E','e')  exit config     
           exita=.false.
           DO I=1,7
             IF(UNITAS(I).NE.20.AND.UNITAS(I).NE.10)CLOSE(UNITAS(I))
           END DO
         END SELECT
      END DO !WHILE (exita)
      END

      SUBROUTINE EXPERT(SAVED,LINES,ILIN,NWINS)
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      PARAMETER (LENLIN=200)
	INCLUDE '$WIN'
      CHARACTER*(LENLIN) LINES(200),LABELCH
      CHARACTER HETEXT,KEY
      LOGICAL SAVED,EXITA
      CHARACTER*3 fatrib
      WRITE(20,*)'EXPERT menu allows changes of all windows properties,'
      WRITE(20,*)'size, position, font height, fonts type, cursor, etc.'
      WRITE(20,*)'[Esc] returns you to the main menu. Press any key...'
      CALL GCU(KEY,IEND)  
      IF(IEND.EQ.227)RETURN
      EXITA=.true.
      DO WHILE (exita)
         CALL DISWIN
         II=FOCUSQQ(20)
         C2=SETTEXTCOLOR(INT2(11))      
         WRITE(20,*)'EXPERT menu, change windows [p]roperties, [s]ave an
     /d [e]xit '      
         C1=SETTEXTCOLOR(INT2(15))      
         CALL GCU(HETEXT,IEND)   
         IF(IEND.EQ.227)HETEXT='E'        
         SELECT CASE (hetext)
         CASE ('P','p')    ! Windows position     
           SAVED=.false.      
           WRITE(20,*)'Change properties of selected unit(s) '
           WRITE(20,'('' Input a unit no.:  ''\)')
           READ(20,'(I4)')iunit
           IF(IUNIT.LE.0.OR.IUNIT.GT.50)THEN
              WRITE(20,'('' Wrong unit number specified. Default=10'')')
              IUNIT=10
           ENDIF
           WRITE(20,'('' Current label of'',I3,'' unit  is: '',A,'' '')
     /')iunit,labela(iunit)
           WRITE(20,*)'Input a new window label, ";" is the same.'
           READ(20,'(A)')labelch
           IF(.not.labelch.eq.';') then
              labela(iunit)=labelch
           ENDIF 
           WRITE(20,'('' Change the x position left up corner of selecte
     /d unit '')')
           WRITE(20,'('' Current x-position is: '',I4,'' '')')
     /   ixpos(iunit)
           WRITE(20,'('' Input a new position:  ''\)')
           READ(20,'(I4)')itemp
           ixpos(iunit)=itemp 
           WRITE(20,*)'Change the y position of selected unit(s):'
           WRITE(20,'('' Current y-position of'',I3,'' unit  is:
     /    '',I4,'' '')')iunit,iypos(iunit)
           WRITE(20,'('' Input a new y-position:  ''\)')
           READ(20,'(I4)')itemp
           iypos(iunit)=itemp
           WRITE(20,*)'Change the size of sel. unit(s) in pixels '
           WRITE(20,'('' Current x-pixel size of'',I3,'' unit  is:
     /    '',I4,'' '')')iunit,ixpix(iunit)
           WRITE(20,'('' Input a new x-pixel size:  ''\)')
           READ(20,'(I4)')itemp
           IF(ITEMP.GT.0)ixpix(iunit)=itemp
           WRITE(20,'('' Current y-pixel size of'',I3,'' unit  is:
     /    '',I4,'' '')')iunit,iypix(iunit)
           WRITE(20,'('' Input a new y-pixel size:  ''\)')
           READ(20,'(I4)')itemp
           IF(ITEMP.GT.0)iypix(iunit)=itemp
           WRITE(20,'('' Current textcols of'',I3,'' unit  is:
     /    '',I4,'' '')')iunit,ncol(iunit)
           WRITE(20,'('' Input a new textcols size:  ''\)')
           READ(20,'(I4)')itemp
           IF(ITEMP.GT.0)ncol(iunit)=itemp
           WRITE(20,'('' Current textrows of'',I3,'' unit  is:
     /    '',I4,'' '')')iunit,nrow(iunit)
           WRITE(20,'('' Input a new textrow size:  ''\)')
           READ(20,'(I4)')itemp
           IF(ITEMP.GT.0)nrow(iunit)=itemp
           WRITE(20,*)'Change font properties of a selected unit'
           WRITE(20,'('' Current font size of'',I3,'' unit  is:
     /    '',I4,'' '')')iunit,ihfontph(iunit)
           WRITE(20,'('' Input a new font size:  ''\)')
           READ(20,'(I4)')itemp 
           IF(ITEMP.GT.0)ihfontph(iunit)=itemp
           WRITE(20,'('' Current font type of'',I3,'' unit  is:
     /    '',I4,'' '')')iunit,ifontph(iunit)
           WRITE(20,'('' Input a new font type (1-Times,2-Arial,3-Algeri
     /an,4-Courier,...,8-Tahoma): ''\)')
           READ(20,'(I4)')itemp 
           ifontph(iunit)=itemp
           WRITE(20,'('' Current cursor status of'',I3,'' unit  is:
     /    '',I4,'' '')')iunit,icursor(iunit)
           WRITE(20,'('' Input a new cursor status [1]visible [0]not:''
     \)')
           READ(20,'(I4)')itemp 
           icursor(iunit)=itemp
           WRITE(20,'('' Current Font Attributes of'',I3,'' unit  is:
     /    '',A,'' '')')iunit,fontphattr(iunit)
           WRITE(20,'('' Input a new font attributes [B,D,I,N]  ''\)')
           READ(20,'(A)') fatrib
           fontphattr(iunit)=fatrib
           WRITE(20,'('' Current Font RGB color indexes of'',I3,'' unit
     /is: '',3I4,'' '')')iunit,icfR(iunit),icfG(iunit),icfB(iunit)
           WRITE(20,'('' Input a new Font RGB color indexes ''\)')
           READ(20,'(I4)')itemp1, itemp2, itemp3  
           IF(ITEMP1.GT.0)icfR(iunit)=itemp1
           IF(ITEMP2.GT.0)icfG(iunit)=itemp2
           IF(ITEMP3.GT.0)icfB(iunit)=itemp3
           WRITE(20,'('' Current background RGB color indexes of'',I3,''
     / unit  is: '',3I4,'' '')')
     / iunit,icbR(iunit),icbG(iunit),icbB(iunit)
           WRITE(20,'('' Input a new background RGB color indexes ''\)')
           READ(20,'(3I3)')itemp1, itemp2, itemp3  
           icbR(iunit)=itemp1
           icbG(iunit)=itemp2
           icbB(iunit)=itemp3
         CASE ('s','S')    ! Save CFG     
           CALL WRITEWIN(LINES,ILIN,NWINS,SAVED)
         CASE DEFAULT  ! ('E','e')  exit config     
           EXITA=.false.
           DO I=1,7
              IF(UNITAS(I).NE.20.AND.UNITAS(I).NE.10)CLOSE(UNITAS(I))
           END DO
         END SELECT
      END DO !WHILE (exita)
      END  

      SUBROUTINE DISWIN
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      PARAMETER (LENLIN=200)
	INCLUDE '$WIN'
      DO I=1,7
         unita =unitas(i)
	   IF(UNITA.NE.10)THEN
         CALL WOPENH(unita,labela(unita),ixpos(unita),
     /iypos(unita),ixpix(unita),iypix(unita),nrow(unita),ncol(unita),
     /ifontph(unita),ihfontph(unita),icursor(unita),fontphattr(unita),
     /icfR(unita),icfG(unita),icfB(unita),
     /icbR(unita),icbG(unita),icbB(unita),IOLDWOPEN)
	   ENDIF
         CALL CLEARSCREEN($GCLEARSCREEN)
         WRITE(UNITAS(i),'('' 123456789 SOME Text on window unit no.'',I
     /2,'' '')')UNITAS(i)
      ENDDO
      END


