	parameter (nmax=500)
	real L,mju,Lh
	real*8 anew(nmax),aold(nmax),qnew(nmax),qold(nmax),pres(nmax)
	real*8 at(nmax),bt(nmax),ct(nmax),rt(nmax),ut(nmax)
c standardni zadani rozmerove veliciny SI
c	q(time)=qz*(1+0.2*sin(omg*time))
c	qdot(time)=qz*0.2*f*cos(omg*time)
	qs(tau)=qz*(1+0.2*sin(omg*tau*h/c))/(s0*c)
	qdots(tau)=qz*0.2*omg*h/c*cos(omg*tau*h/c)/(s0*c)
	d=0.015
	th=0.0008
	h=0.15
	l=0.0000002
	E=1e6
	mju=0.5
	rho=1000
	visc=1e-3
	pi=3.141
	tmax=5
	tc=0.75
	qz=0.00002
	omg=2*pi/tc
	s0=pi*d**2/4
	eps0=0.2
	write(*,*)' Pulse simulation'
c bezrozmerne veliciny
      c=sqrt(e*th/(d*rho*(1-mju**2)))
	f=8*pi*visc*h/(rho*c*s0)
	gama=d/(2*h)
	Lh=L/H
c sit
      n=500
	dksi=1./(n-1)
	dtau=dksi*10
	taumax=tmax*c/h
	ntau=taumax/dtau
c pocatecni podminky 
      do i=1,n
	  anew(i)=0
	  aold(i)=0
	  qnew(i)=0
	  qold(i)=0
	  pres(i)=0
      enddo
	tau=0
	do it=1,ntau
c cas n+1
	tau=tau+dtau
      qss=qs(tau)
	qdotss=qdots(tau)
c iterace na hladine n+1
      write(*,*)' Tau=',tau,' tim=',tau*c/h
      do iter=1,15
c Anew tridag
		at(1)=0
		bt(1)=1
		ct(1)=0
		rt(1)=0
		at(n)=0
		bt(n)=1
		ct(n)=0
		rt(n)=0
		rn=2*mju*eps0
c	rn=0
		do i=2,n-1
		rm=-gama**2*(eps0+mju*anew(i)/2)
		at(i)=rm/dksi**2
		ct(i)=at(i)
		bt(i)=1-2*at(i)
		rt(i)=-rn+(lh+1-(i-1)*dksi)*(qdotss+f+qss)+pres(i)
		enddo
		call tridagd(at,bt,ct,rt,ut,n)
	    relf=.98
          do i=1,n
	       anew(i)=anew(i)*relf+ut(i)*(1-relf)
	    enddo
	    write(*,'('' A'',5e10.2)')(anew(i),i=1,5)
	    write(*,'('' p'',5e10.2)')(pres(i),i=1,5)
	pause
c Qnew
		do i=1,n-1
		qnew(i+1)=qnew(i)-dksi/(2*dtau)*
     /(anew(i)+anew(i+1)-aold(i)-aold(i+1))
		enddo
c Pres
          res=pres(n)
		pres(n)=lh*(qnew(n)-qold(n))/dtau+f*lh*qnew(n)
	    res=res+abs(pres(n))
		do i=n,2,-1
		aa=1+(anew(i)+anew(i-1))/2
		qqnew=(qnew(i)+qnew(i-1))/2
		qqold=(qold(i)+qold(i-1))/2
	    p=pres(i-1)
		pres(i-1)=pres(i)-dksi*
     /(f*(qss-(qss+qqnew)/aa**2)+(qdotss*(aa-1)-(qqnew-qqold)/dtau)/aa)
	    res=res+abs(p)
		enddo
          write(*,*)' iter=',iter,' p-res=',res
	enddo
c nova hladina
      do i=1,n
	aold(i)=anew(i)
	qold(i)=qnew(i)
      enddo
	enddo
	end


      SUBROUTINE TRIDAGD(A,B,C,R,U,N)
c
c DOUBLE PRECISION
c Tridiagonal linear set of equations (A-lower, B-diagonal, C-upper, R-RHS)
c according to Press: Numerical recipes, p. 40
c Vectors A,B,C,R are not destroyed.
c
      parameter (nmax=500)
      real*8 gam(nmax),a(n),b(n),c(n),r(n),u(n),bet
      bet=b(1)
      u(1)=r(1)/bet
      do j=2,n
         gam(j)=c(j-1)/bet
         bet=b(j)-a(j)*gam(j)
         u(j)=(r(j)-a(j)*u(j-1))/bet
      enddo
      do j=n-1,1,-1
         u(j)=u(j)-gam(j+1)*u(j+1)
      enddo
      end

