      SUBROUTINE FDCR(NUE,X,Y,G,F,FK,FX,FY,DET)
C
C Linearni a kvadraticke bazove funkce na krivce. Element definovany
C bud 2 nebo 3 uzlovymi body (NUE, souradnice X(*),Y(*)).
C Hodnoty F(),FK(),FX(),FY(),DET jsou vycislovany v bode G (-1,1).
C
      DIMENSION X(*),Y(*),F(*),FX(*),FY(*),FK(*)
      IF(NUE.EQ.2)THEN
C
C Usecka se 2 uzly
C
         F(1)=0.5*(1.-G)
         F(2)=0.5*(1.+G)
         FK(1)=-0.5
         FK(2)=0.5
      ELSE
C
C Kvadraticka krivka (3 uzly)
C
         F(1)=-0.5*(1.-G)*G
         F(2)=0.5*(1.+G)*G
         F(3)=1.-G*G
         FK(1)=-0.5+G
         FK(2)=0.5+G
         FK(3)=-2*G
      ENDIF
      DKDX=0
      DKDY=0
      DO I=1,NUE
         DKDX=DKDX+X(I)*FK(I)
         DKDY=DKDY+Y(I)*FK(I)
      ENDDO
      DO I=1,NUE
         IF(DKDX.NE.0.)THEN
            FX(I)=FK(I)/DKDX
         ELSE
            FX(I)=0.
         ENDIF
         IF(DKDY.NE.0.)THEN
            FY(I)=FK(I)/DKDY
         ELSE
            FY(I)=0.
         ENDIF
      ENDDO
      DET=SQRT(DKDX**2+DKDY**2)
      END
 
 
