      SUBROUTINE FFMERGS(XMI,XMA,YMI,YMA,ZMI,ZMA,X,Y,Z,N,IUE,LUE,MUE,NE
     /,TOL)
C
C MERGE UZLU, VZDALENYCH O MENE NEZ -TOL- A UPRAVA MATICE KONEKTIVITY
C VEKTORY SOURADNIC SE NEZKRACUJI (i sloucene uzly zustavaji jako dvojice).
C
C SLUCOVANI POUZE V UVEDENE OBDELNIKOVE OBLASTI

C VSTUPNI PARAMETRY:
C X(N),Y(N),Z(n)   SOURADNICE UZLU
C IUE(*)      VEKTOR KONEKTIVITY
C LUE(*)      INDEXY PRVNICH UZLU ELEMENTU
C MUE(*)      POCET UZLU ELEMENTU (ZAPORNA HODNOTA MY VYZNAM JEN PRO GRAFIKU)
C TOL         MINIMALNI VZDALENOST ODLISNYCH UZLU
C
      DIMENSION X(*),Y(*),Z(*),IUE(*),LUE(*),MUE(*)
      TOL2=TOL*TOL
      I=1
      DO WHILE(I.LT.N)
C TESTUJEME VYSKYT TOTOZNYCH UZLU I+1,...,NEW
        XI=X(I)
        YI=Y(I)
        ZI=Z(I)
	  IF(XI.GE.XMI.AND.XI.LE.XMA.AND.
     /     YI.GE.YMI.AND.YI.LE.YMA.AND.
     /     ZI.GE.ZMI.AND.ZI.LE.ZMA)THEN
        J=I+1
        DO WHILE(J.LE.N)
          IF((XI-X(J))**2+(YI-Y(J))**2+(ZI-Z(J))**2.LT.TOL2)THEN
C VYRAD UZEL J (V MATICI KONEKTIVITY MISTO NEHO DOSAD I)
            DO IE=1,NE
              NUE=IABS(MUE(IE))
              L0=LUE(IE)
              DO IU=1,NUE
                INDU=IABS(IUE(L0+IU))
                IF(INDU.EQ.J)IUE(L0+IU)=I
              ENDDO
            ENDDO
          ENDIF
          J=J+1
        ENDDO
	  ENDIF
        I=I+1
      ENDDO
      END
