      SUBROUTINE FMFRIN(IOPER,EDOF,IUE,LUE,MUE,NE,NU)
C ͻ
C  PREFRONT inicializacni procedura zjistujici posledni vyskyt uzlu   
C  ve VEKTORU KONEKTIVITY IUE. LUE je vektor pointeru do IUE.         
C ͼ
C OD PROCEDURY FEFRIN SE LISI MOZNOSTI SELEKCE ELEMENTU.
C VSTUPNI A VYSTUPNI PARAMETR:
C  IUE(*)    - VEKTOR KONEKTIVITY (BUDOU ZMENENA ZNAMENKA U UZLU,
C              KTERE SE VE VEKTORU KONEKTIVITY OBJEVI JAKO POSLEDNI)
C VSTUPNI PARAMETRY:
C  IOPER     - operace (=1 ELEC, =2 THER, =3 CONC, =4 FLOW, =5 STAT)
C  subroutine EDOF(ie,ioper,ndl,indl,mdofl,ndofl,idofl)
C     dimension indl(maxndl),ndofl(maxndl),idofl(maxndl,maxndofl)
C     Pokud preda procedura EDOF nulovy pocet pocitanych stupnu volnosti MDOFL,
C     element se neuvazuje.
C  LUE(NE+1) - I-TY UZEL IE-TEHO ELEMENTU JE NA POZICI LUE(IE)+I.
C  MUE(NE)     IABS(MUE(IE))=POCET UZLU IE-TEHO ELEMENTU. 0=ZRUSENY ELEMENT.
C  NE        - POCET ELEMENTU
C  NU        - POCET UZLU
C
      PARAMETER (MAXNDL=20,MAXNDOFL=6)
      DIMENSION INDL(MAXNDL),NDOFL(MAXNDL),IDOFL(MAXNDL,MAXNDOFL)
      DIMENSION IUE(*),LUE(*),MUE(*)
      ICOUNT=0
C
C 1.faze Identifikace blokovanych elementu (v nichz se nevyskytuji pocitane DOF),
C        jsou oznaceny tim, ze od LUE je odecteno 1000000 (pak to bude zcela
C        jiste zaporne cislo).
C
      DO IE=1,NE
         L0=LUE(IE)
         CALL EDOF(IE,IOPER,NDL,INDL,MDOFL,NDOFL,IDOFL)
         DO I=1,NDL
            IUE(L0+I)=IABS(IUE(L0+I))
         ENDDO
         IF(MDOFL.LE.0)LUE(IE)=LUE(IE)-1000000
      ENDDO
C 2.faze - klasicky prefront
      DO IU=1,NU
        LSTI=0
        DO IE=1,NE
          L0=LUE(IE)
          IF(L0.GE.0)THEN
             NUE=IABS(MUE(IE))
             DO I=1,NUE
               IF(IABS(IUE(L0+I)).EQ.IU)LSTI=L0+I
             ENDDO
          ENDIF
        ENDDO
        IF(LSTI.GT.0)THEN
          IUE(LSTI)=-IU
        ELSEIF(ICOUNT.LE.3)THEN
          WRITE(*,*)' Node',IU,' not used in this problem'
          IF(ICOUNT.EQ.3)WRITE(*,*)'  ... (probably FLOW phase with SOLI
     /D elements)'
          ICOUNT=ICOUNT+1
        ENDIF
      ENDDO
C 3.faze - regenerace blokovanych LUE
      DO IE=1,NE
        IF(LUE(IE).LT.0)LUE(IE)=LUE(IE)+1000000
      ENDDO
      END
