      SUBROUTINE FTLINT(X,Y,C,XC,YC,CC,CCX,CCY)
C
C INTERPOLACE V TRIUZLOVEM TROJUHELNIKU
C
C VSTUPY:
C X(3),Y(3)       SOURADNICE UZLU (1,2,3)
C C(3)            HODNOTY VE VRCHOLECH
C XC,YC SOURADNICE LIBOVOLNEHO BODU 
C
C VYSTUP:
C CC,CCX,CCY  HODNOTA A PRVNI DERIVACE 
C
      DIMENSION Y(*),X(*),C(*)
      DET=Y(1)*(X(2)-X(3))+Y(2)*(X(3)-X(1))+Y(3)*(X(1)-X(2))
      CC=0.
      CCX=0.
      CCY=0.
      IF(DET.EQ.0.)RETURN
      DO I=1,3
        I1=MOD(I,3)+1
        I2=MOD(I1,3)+1
        FY=(X(I1)-X(I2))/DET
        FX=(Y(I2)-Y(I1))/DET
        F=(X(I2)*Y(I1)-X(I1)*Y(I2))/DET
        CC=CC+C(I)*(F+FX*XC+FY*YC)
        CCX=CCX+C(I)*FX
        CCY=CCY+C(I)*FY
      ENDDO
      END
 
