      SUBROUTINE GMFARROW(ITYP,X,Y,P,ICOL)
C
C ITYP=0  Vykresleni usecky X(),Y() s ohledem na velikost a znamenko P
C ITYP=-1 Dtto, ale jinou barvou (rozliseni laminar/turbulence)
C ITYP=-2 mensi sipka
C ITYP=-3 jeste mensi sipka
C ...
C ITYP=1  Vykresleni sipky kolme k usecce X(),Y() v tezisti, 
C        s ohledem na znamenko P.
C ICOL    barva usecky
C
      DIMENSION X(*),Y(*),XG(6),YG(6)
      INCLUDE '$GMF'
      DXW=WXMA-WXMI
      DYW=WYMA-WYMI
      DX=(X(2)-X(1))/DXW
      DY=(Y(2)-Y(1))/DYW
      H=SQRT(DY**2+DX**2)
      IF(H.LT.1E-10)RETURN
      ICOL2=ICOL+1
      IF(ICOL2.LT.11)THEN
        ICOL3=11
        ICOL4=12
      ELSE
        ICOL3=1
        ICOL4=2
      ENDIF
      XG(2)=(X(1)+X(2))*.5
      YG(2)=(Y(1)+Y(2))*.5
      IF(ITYP.NE.1)THEN
C sipka ve smery usecky
        DXN=0.010*DY/H*DXW
        DYN=0.015*DX/H*DYW
        IF(ITYP.LT.-1)THEN
          DXN=DXN/IABS(ITYP)
          DYN=DYN/IABS(ITYP)
        ENDIF
        XG(1)=XG(2)-P*(XG(2)-X(1))
        YG(1)=YG(2)-P*(YG(2)-Y(1))
        XG(4)=XG(2)+P*(X(2)-XG(2))
        YG(4)=YG(2)+P*(Y(2)-YG(2))
        XG(3)=XG(2)-DXN
        YG(3)=YG(2)+DYN
        XG(5)=XG(2)+DXN
        YG(5)=YG(2)-DYN
        XG(6)=XG(2)
        YG(6)=YG(2)
        N=5
      ELSE
C sipka kolma na usecku
        IF(P.GT.0.)THEN
           C=.02
        ELSEIF(P.LT.0.)THEN
           C=-0.02
        ELSE
           C=0
        ENDIF
        DXN=C*DY/H*DXW*.7
        DYN=C*DX/H*DYW
        XG(1)=XG(2)+DXN
        YG(1)=YG(2)-DYN
        XG(3)=.7*XG(1)+.3*X(2)
        YG(3)=.7*YG(1)+.3*Y(2)
        XG(4)=.7*XG(1)+.3*X(1)
        YG(4)=.7*YG(1)+.3*Y(1)
        XG(5)=XG(2)
        YG(5)=YG(2)
        N=4
      ENDIF
      XT=0
      YT=0
      DO I=2,N
        XT=XT+XG(I)
        YT=YT+YG(I)
      ENDDO
      CALL GMFPLC(N,XG(2),YG(2),ICOL2)
      IF(ITYP.EQ.0)THEN
         ICOLOR=ICOL3
      ELSE
         ICOLOR=ICOL4
      ENDIF
      CALL GMFILL(XT/(N-1),YT/(N-1),ICOLOR,ICOL2)
      CALL GMFPLC(N,XG(2),YG(2),ICOL)
      CALL GMFPLC(2,XG,YG,ICOL)
      END
