      SUBROUTINE GMFCTR(V3,X3,Y3,VMIN,VMAX,IVMIN,IVMAX)
C  
C SPOJITE SE MENICI BARVY V TROJUHELNIKU RGB (linearni interpolace)
C V3(3)       - FUNKCNI HODNOTY VE VRCHOLECH
C X3(3),Y3(3) - SOURADNICE VRCHOLU
C VMIN,VMAX   - ROZSAH HODNOT (TRANSFORMOVANY NA SKALU BAREV OD 0 DO 3000)
C IVMIN,IVMAX - vyber barevne skaly (v intervalu 0 az 3000) pri zadani
C               vyssich hodnot se objevi skoky v barevnem podani
C
C POUZITE PROCEDURY: GMFTRGB
C
C$IF DEFINED (compaq)
      USE DFLIB
C$ELSE
C      USE MSFLIB
C$ENDIF
      INCLUDE 'GMF$'
      DIMENSION V3(3),X3(3),Y3(3),VM(3),XM(3),YM(3),IB(3),JXM(3),JYM(3)
      INTEGER *2 JX,JY,JY0,JY1,JYM0,JYM1
      IF(VMAX.LE.VMIN)RETURN
      FYJY=(FYMA-FYMI)/(JYMA-JYMI)
C SETRIDENI DLE HODNOT V
      DOI=1,3
      IB(I)=I
      ENDDO
C PARAMETR CYKLU J JE JEN POCITADLO
      DOJ=1,2
         DOI=1,2
         I1=IB(I)
         I2=IB(I+1)
         IF(X3(I1).GT.X3(I2))THEN
            IB(I)=I2
            IB(I+1)=I1
         ENDIF
         ENDDO
      ENDDO
      DOI=1,3
      IBI=IB(I)
      VM(I)=V3(IBI)
      XM(I)=X3(IBI)
      YM(I)=Y3(IBI)
C ODPOVIDAJICI HODNOTY PIXELU JX,JY
      JXM(I)=JXMI+(JXMA-JXMI)*(XM(I)-FXMI)/(FXMA-FXMI)
      JYM(I)=JYMI+(JYMA-JYMI)*(YM(I)-FYMI)/(FYMA-FYMI)
      ENDDO
C NYNI JIZ PLATI XM1<=XM2<=XM3
C LINEARNI INTERPOLACNI FUNKCE V(X,Y)=A+B*X+C*Y
      S=XM(1)*(YM(2)-YM(3))+XM(2)*(YM(3)-YM(1))+XM(3)*(YM(1)-YM(2))
      IF(S.NE.0.)THEN
      A=(VM(1)*(XM(2)*YM(3)-XM(3)*YM(2))+
     /   VM(2)*(XM(3)*YM(1)-XM(1)*YM(3))+
     /   VM(3)*(XM(1)*YM(2)-XM(2)*YM(1)))/S
      B=(VM(1)*(YM(2)-YM(3))+
     /   VM(2)*(YM(3)-YM(1))+
     /   VM(3)*(YM(1)-YM(2)))/S
      C=(VM(1)*(XM(3)-XM(2))+
     /   VM(2)*(XM(1)-XM(3))+
     /   VM(3)*(XM(2)-XM(1)))/S
      ELSE
         RETURN
      ENDIF
C CYKLUS PRES SLOUPECKY PIXELU VE SMERU X
      DO JX=JXM(1),JXM(3)
C STANOVENI SOURADNICE X V UZIVATELSKYCH SOURADNICICH
        X=FXMI+(FXMA-FXMI)*(JX-JXMI)/(JXMA-JXMI)
C STRANA 1-3
        IF(JXM(3).NE.JXM(1))THEN
          JY0=JYM(1)+(JYM(3)-JYM(1))*(JX-JXM(1))/(JXM(3)-JXM(1))
        ELSE
          JY0=JYM(1)
        ENDIF
        IF(JX.LE.JXM(2))THEN
C STRANA 1-2
          IF(JXM(2).NE.JXM(1))THEN
            JY1=JYM(1)+(JYM(2)-JYM(1))*(JX-JXM(1))/(JXM(2)-JXM(1))
          ELSE
            JY1=JYM(2)
          ENDIF
        ELSE
C STRANA 2-3
          IF(JXM(2).NE.JXM(3))THEN
            JY1=JYM(2)+(JYM(3)-JYM(2))*(JX-JXM(2))/(JXM(3)-JXM(2))
          ELSE
            JY1=JYM(2)
          ENDIF
        ENDIF
C CYKLUS PRES SLOUPECEK PIXELU OD JY0 DO JY1
C$IF DEFINED (compaq)
        JYM0=IMIN0(JY0,JY1)
        JYM1=IMAX0(JY0,JY1)
C$ELSE
C        JYM0=MIN0(JY0,JY1)
C        JYM1=MAX0(JY0,JY1)
C$ENDIF
        VX=A+B*X
        DO JY=JYM0,JYM1
C ZJISTENI SOURADNICE Y
           Y=FYMI+FYJY*(JY-JYMI)
C STANOVENI FUNKCNI HODNOTY
           V=VX+C*Y
C OPOVIDAJICI INDEX BARVY
           ICOL=IVMIN+(IVMAX-IVMIN)*(V-VMIN)/(VMAX-VMIN)
           CALL GMFRGB(ICOL,IRGB)
           DUMMY=SETPIXELRGB(JX-JXMI,JY-JYMA,IRGB)
        ENDDO
      ENDDO
      END
