      SUBROUTINE GMFDASH(N,X,Y,ICOL,XM,YM,NDASH)
C
C GMFDASH - DASHED LINE
C
C N,X,Y,ICOL THE SAME AS IN GMFPL
C XM, YM     RANGE OF X,Y (USER COORDINATES)
C ND         NUMBER OF DASHES
C
      DIMENSION X(1),Y(1),XG(2),YG(2)
      IF(N.LE.1.OR.NDASH.LE.0.OR.XM.LE.0..OR.YM.LE.0.)RETURN
      Z=0
      DO I=1,N-1
        Z=Z+SQRT(((X(I+1)-X(I))/XM)**2+((Y(I+1)-Y(I))/YM)**2)
      ENDDO
      DZ=Z/NDASH
      DZF=DZ*0.7
      RDZ=0.
      DO I=1,N-1
C DRAW LINE I I+1
        ZI=SQRT(((X(I+1)-X(I))/XM)**2+((Y(I+1)-Y(I))/YM)**2)
        IF(ZI.GT.0.)THEN
           DX=X(I+1)-X(I)
           DY=Y(I+1)-Y(I)
C DASH = FULL LINE (0.7) EMPTY LINE (0.3)
C DRAW REST OF PREVIOUS DASH RDZ
           IF(DZF.GT.DZ-RDZ)THEN
              XG(1)=X(I)
              YG(1)=Y(I)
              DL=AMIN1(1.,(DZF-DZ+RDZ)/ZI)
              XG(2)=XG(1)+DX*DL
              YG(2)=YG(1)+DY*DL
              CALL GMFPL(2,XG,YG,ICOL)
           ENDIF
1          IF(RDZ.GE.ZI)THEN
              RDZ=RDZ-ZI
           ELSE
              DL1=RDZ/ZI
              DL2=AMIN1(1.,(RDZ+DZF)/ZI)
              XG(1)=X(I)+DX*DL1
              XG(2)=X(I)+DX*DL2
              YG(1)=Y(I)+DY*DL1
              YG(2)=Y(I)+DY*DL2
              CALL GMFPL(2,XG,YG,ICOL)
              RDZ=RDZ+DZ
              GOTO 1
           ENDIF
        ENDIF
      ENDDO
      END
