      SUBROUTINE GMFSTW(INDS,ITYPE,IWINS,IFONT,IHEIGH,LABELX,LABELY,
     /                  CXMI,CXMA,CYMI,CYMA,XMI,XMA,YMI,YMA)
C
C NASTAVENI SOUR. SYSTEMU :
C   INDS = 1,2,3,4,5,6
C   ITYPE= 0 slouzi k vykreslovani vrstevnic (vymezuje se
C            prostor pro zobrazeni skaly vrstevnic), nezaokrouhluji
C            se rozsahy os.
C        = 1 aritmeticke osy se zaokrouhlovanim zadaneho rozsahu.
C        = 2 log-log, lisi se jen jinym pomerem velikosti vnitrniho a vnejsiho okna.
C   IWIN = 1,2,...40  child window
C   IFONT= 1,2,3,4,5  font (Courier, Arial, Times, Sans Serif, Small)
C   IHEIGH  vyska fontu (v pixelech)
C   LABELX,LABELY *16 popisy os
C
C Nic se nekresli, ani se nenastavuji fonty ci souradne systemy.
C Jen se pocitaji rozsahy vnitrniho a vnejsiho okna, delky textu dle
C aktualniho fontu. Nastaveni odpovida procedure GMFAXE.
C Vsechny vypoctene udaje se ulozi do zony GMFB$ - pouzije je
C procedura GMFAX nebo
C
 
C$IF DEFINED (compaq)
      USE DFLIB
C$ELSE
C      USE MSFLIB
C$ENDIF
      INCLUDE 'GMFB$'
      PARAMETER (MAXW=40)
      INTEGER *2 MAXWX,MAXWY,ROWS,COLS,ROWSHF,COLSHF
      COMMON /GPFWIN$/
     /   MAXWX(MAXW),MAXWY(MAXW),ROWS(MAXW),COLS(MAXW),
     /   ROWSHF(MAXW),COLSHF(MAXW)
      CHARACTER *(*) LABELX,LABELY
C
C POMOCNE PROMENNE
C
      INTEGER *2 DUMMY,NEWX,NEWY,LXMI,LXMA,LYMI,LYMA,LENTEX,MAXX,MAXY
      DOUBLE PRECISION WPIX
      type (FONTINFO)F
C JEDNOPRIKAZOVE TRANSFORMACNI FUNKCE
      NEWX(XCOORD)=MAXX*XCOORD+.5
      NEWY(YCOORD)=MAXY*(1.-YCOORD)+.5
C
C IWIN - INDEX OTEVRENEHO OKNA
C IND  - INDEX GRAFU
C
      IND=MIN0(MAX0(1,IABS(INDS)),MAXG)
      IWIN=MIN0(MAX0(1,IABS(IWINS)),MAXW)
      IBWIN(IND)=IWIN
      IBFON(IND)=IFONT
      IBHEI(IND)=IHEIGH
      SBYMX(IND)=LABELX
      SBYMY(IND)=LABELY
      NBXS(IND)=MIN0(16,LEN(LABELX))
      NBYS(IND)=MIN0(16,LEN(LABELY))
      MAXX=MAXWX(IWIN)
      MAXY=MAXWY(IWIN)
C
C VNEJSI OKENKO VIEWPORT   [I]
C
      IBXMI(IND)=NEWX(CXMI)
      IBXMA(IND)=NEWX(CXMA)
      IBYMI(IND)=NEWY(CYMI)
      IBYMA(IND)=NEWY(CYMA)
C
C procedura GSCL dostane informaci o uzivatelskych souradnicich
C XMIN,XMAX a vygeneruje
C RXMI,RXMA zaokrouhleny interval
C NBX       pocet delicich intervalu,
C DBNX      meritko (rad)
C DBX       vzdalenost tiku je DBX*10**DBNX
C
      CALL GSCL(XMI,XMA,RXMI,RXMA,NBX(IND),DBNX(IND),DBX(IND))
      CALL GSCL(YMI,YMA,RYMI,RYMA,NBY(IND),DBNY(IND),DBY(IND))
      QBXMI(IND)=RXMI
      QBXMA(IND)=RXMA
      QBYMI(IND)=RYMI
      QBYMA(IND)=RYMA
C
C VNITRNI OKENKO [F]
C
      IF(ITYPE.EQ.0)THEN
C Fixed
         DXIN=XMA-XMI
         DYIN=YMA-YMI
         FBXMI(IND)=XMI-DXIN*.05
         FBXMA(IND)=XMA+DXIN*.2
         FBYMI(IND)=YMI-DYIN*.05
         FBYMA(IND)=YMA+DYIN*.18
      ELSE
C Vnitrni okenko v zaokrouhlenych rozsazich
         FBXMI(IND)=RXMI
         FBXMA(IND)=RXMA
         FBYMI(IND)=RYMI
         FBYMA(IND)=RYMA
      ENDIF
C
C velikost pouziteho pisma urcujici vzdalenost
C vnitrniho a vnejsiho ramecku
C
      CALL GMFFONT(IFONT,IHEIGH)
      DUMMY=GETFONTINFO(F)
      LYMI=(F.PIXHEIGHT+5)*2
      LYMA=F.PIXHEIGHT+5
C
      IF(ITYPE.EQ.2)THEN
C log-log
         LENTEX=GETGTEXTEXTENT('1.E+02')
         LXMI=LENTEX+(IBXMA(IND)-IBXMI(IND))/40
         LXMA=LENTEX/2
      ELSE
C aritmeticke
         LENTEX=GETGTEXTEXTENT('1234')
         LXMI=LENTEX+(IBXMA(IND)-IBXMI(IND))/100
         LXMA=20
      ENDIF
C
C VNITRNI OKENKO VIEWPORT  [J]
C
      JBXMI(IND)=IBXMI(IND)+LXMI
      JBXMA(IND)=IBXMA(IND)-LXMA
      JBYMI(IND)=IBYMI(IND)-LYMI
      JBYMA(IND)=IBYMA(IND)+LYMA
C
C VNEJSI OKENKO WINDOW     [W]
C
      WPIX=(FBXMA(IND)-FBXMI(IND))/(JBXMA(IND)-JBXMI(IND))
      WBXMI(IND)=FBXMI(IND)-WPIX*LXMI
      WBXMA(IND)=FBXMA(IND)+WPIX*LXMA
      WBXT(IND)=WPIX*LENTEX
      WPIX=(FBYMA(IND)-FBYMI(IND))/(JBYMI(IND)-JBYMA(IND))
      WBYMI(IND)=FBYMI(IND)-WPIX*LYMI
      WBYMA(IND)=FBYMA(IND)+WPIX*LYMA
      WBYT(IND)=WPIX*F.PIXHEIGHT
      END
