      SUBROUTINE GSCL(Z1,Z2,B1,B2,N,DNK,DZ)
C
C Vypocet deleni pro popis os
C Vstup : Z1,Z2 zadany interval
C Vystup:
C B1,B2 novy interval
C N     pocet delicich bodu
C DNK   meritko. Osy se popisuji cisly Z/DNK (radove jednotky)
C DZ    vzdalenost delicich bodu v uzivatelskych souradnicich
C
      DZ=(Z2-Z1)*.2
      IF(DZ.LE.0.)DZ=1.
      R=ALOG10(DZ)
      IF(R.GT.0.)K=R
      IF(R.LE.0.)K=R-1.
      DNK=10.**K
      DZN=DZ/DNK
      IF(DZN.LT.2.5)THEN
         DZK=1.
      ELSEIF(DZN.LT.7)THEN
         DZK=5.
      ELSE
         DZK=1.
         DNK=10*DNK
      ENDIF
      DZ=DZK*DNK
      B1=IFIX(Z1/DZ+.5)*DZ
      B2=IFIX(Z2/DZ+.5)*DZ
      if(b1.gt.z1)b1=b1-dz
      if(b2.lt.z2)b2=b2+dz
      N=(B2-B1)/DZ+.1
      END
