      SUBROUTINE LFIT(X,Y,SIG,NDATA,A,MA,LISTA,MFIT,COVAR,NCVM,
     /                CHISQ,FUNCS)
C Numerical recipes p.513
      PARAMETER (MMAX=50)
      DIMENSION X(NDATA),Y(NDATA),SIG(NDATA),A(MA),LISTA(MFIT),
     /          COVAR(NCVM,NCVM),BETA(MMAX), AFUNC(MMAX)
      KK=MFIT+1
      DO J=1,MA
         IHIT=0
         DO K=1,MFIT
            IF(LISTA(K).EQ.J)IHIT=IHIT+1
         ENDDO
         IF(IHIT.EQ.0)THEN
            LISTA(KK)=J
            KK=KK+1
         ELSEIF(IHIT.GT.1)THEN
            PAUSE 'Improper set in LISTA'
         ENDIF
      ENDDO
      IF(KK.NE.(MA+1))PAUSE' Improper set in LISTA'
      DO J=1,MFIT
         DO K=1,MFIT
            COVAR(J,K)=0.
         ENDDO
         BETA(J)=0.
      ENDDO
      DO I=1,NDATA
         CALL FUNCS(X(I),AFUNC,MA)
         YM=Y(I)
         IF(MFIT.LT.MA)THEN
             DO J=MFIT+1,MA
                YM=YM-A(LISTA(J))*AFUNC(LISTA(J))
             ENDDO
         ENDIF
         SIG2I=1./SIG(I)**2
         DO J=1,MFIT
            WT=AFUNC(LISTA(J))*SIG2I
            DO K=1,J
               COVAR(J,K)=COVAR(J,K)+WT*AFUNC(LISTA(K))
            ENDDO
            BETA(J)=BETA(J)+YM*WT
         ENDDO
      ENDDO
      IF(MFIT.GT.1)THEN
         DO J=2,MFIT
            DO K=1,J-1
               COVAR(K,J)=COVAR(J,K)
            ENDDO
         ENDDO
      ENDIF
      CALL GAUSSJ(COVAR,MFIT,NCVM,BETA,1,1)
      DO J=1,MFIT
          A(LISTA(J))=BETA(J)
      ENDDO
      CHISQ=0
      DO I=1,NDATA
          CALL FUNCS(X(I),AFUNC,MA)
          SUM=0
          DO J=1,MA
             SUM=SUM+A(J)*AFUNC(J)
          ENDDO
          CHISQ=CHISQ+((Y(I)-SUM)/SIG(I))**2
      ENDDO
      CALL COVSRT(COVAR,NCVM,MA,LISTA,MFIT)
      END
