      SUBROUTINE MRQMIN(X,Y,SIG,NDATA,A,MA,LISTA,MFIT,COVAR,ALPHA,NCA,
     /                CHISQ,FUNCS,ALAMDA)
C Numerical recipes p.513
      PARAMETER (MMAX=20)
      DIMENSION X(NDATA),Y(NDATA),SIG(NDATA),A(MA),LISTA(MFIT),
     /          COVAR(NCA,NCA),ALPHA(NCA,NCA),
     /          ATRY(MMAX),BETA(MMAX), DA(MMAX)
      IF(ALAMDA.LT.0.)THEN
        KK=MFIT+1
        DO J=1,MA
           IHIT=0
           DO K=1,MFIT
              IF(LISTA(K).EQ.J)IHIT=IHIT+1
           ENDDO
           IF(IHIT.EQ.0)THEN
              LISTA(KK)=J
              KK=KK+1
           ELSEIF(IHIT.GT.1)THEN
              PAUSE 'Improper set in LISTA'
           ENDIF
        ENDDO
        IF(KK.NE.(MA+1))PAUSE' Improper set in LISTA'
        ALAMDA=0.001
        CALL MRQCOF(X,Y,SIG,NDATA,A,MA,LISTA,MFIT,ALPHA,BETA,
     /              NCA,CHISQ,FUNCS)
        OCHISQ=CHISQ
        DO J=1,MA
           ATRY(J)=A(J)
        ENDDO
      ENDIF
      DO J=1,MFIT
         DO K=1,MFIT
            COVAR(J,K)=ALPHA(J,K)
         ENDDO
         COVAR(J,J)=ALPHA(J,J)*(1.+ALAMDA)
         DA(J)=BETA(J)
      ENDDO
      CALL GAUSSJ(COVAR,MFIT,NCA,DA,1,1)
      IF(ALAMDA.EQ.0.)THEN
         CALL COVSRT(COVAR,NCA,MA,LISTA,MFIT)
         RETURN
      ENDIF
      DO J=1,MFIT
        ATRY(LISTA(J))=ATRY(LISTA(J))+DA(J)
      ENDDO
      CALL MRQCOF(X,Y,SIG,NDATA,ATRY,MA,LISTA,MFIT,COVAR,DA,NCA,
     /            CHISQ,FUNCS)
      IF(CHISQ.LT.OCHISQ)THEN
         ALAMDA=ALAMDA*.1
         OCHISQ=CHISQ
         DO J=1,MFIT
            DO K=1,MFIT
              ALPHA(J,K)=COVAR(J,K)
            ENDDO
            BETA(J)=DA(J)
            A(LISTA(J))=ATRY(LISTA(J))
         ENDDO
      ELSE
         ALAMDA=10.*ALAMDA
         CHISQ=OCHISQ
      ENDIF
      END

