      FUNCTION PTANGLE(X1,Y1,X2,Y2,X3,Y3,IER)
C
C Uhel mezi dvema navazujicimi orientovanymi useckami 1-2 a 2-3.
C Vystupni hodnota je v uhel v radianech
C
      PARAMETER (PI=3.1415926)
      D1=SQRT((X2-X1)**2+(Y2-Y1)**2)
      D2=SQRT((X2-X3)**2+(Y2-Y3)**2)
      IF(D1.GT.1E-8.AND.D2.GT.1E-8)THEN
         IER=0
      ELSE
         IER=-1
         PTANGLE=0.
         RETURN
      ENDIF
C jednotkove vektory 2-1 a 2-3
      XA=(X1-X2)/D1
      YA=(Y1-Y2)/D1
      XB=(X3-X2)/D2
      YB=(Y3-Y2)/D2
C jednotkovy vektor pootocene usecky 2-3 o 90 stupnu
      XC=-YB
      YC=XB
C SKALARNI SOUCINY
      SAB=XA*XB+YA*YB
      SAC=XA*XC+YA*YC
      ASAB=AMIN1(1.,ABS(SAB))
      ASAC=AMIN1(1.,ABS(SAC))
C
      IF(SAB.GE.0..AND.SAC.GT.0.)THEN
C 0-90
         PTANGLE=ASIN(ASAC)
      ELSEIF(SAB.LE.0..AND.SAC.GE.0.)THEN
C 90-180
         PTANGLE=PI-ASIN(ASAC)
      ELSEIF(SAB.LE.0.AND.SAC.LE.0.)THEN
C 180-270        
         PTANGLE=ASIN(ASAC)+PI
      ELSE
C 270-360
         PTANGLE=ASIN(ASAB)+1.5*PI
      ENDIF
      END



