      SUBROUTINE PTCIN(X,Y,XPT,YPT,I1,IC,IB,NC,IN)
C
C Zjisteni, zda bod X,Y lezi uvnitr oblasti (polygonu), vymezene obrysem.
C Obrys je definovan cyklickym seznamem nasledniku IC(i). 
C I1 je vychozi index seznamu IC(i1) naslednik i1, ...,IC(iNC)=i1
C IB(i1) je index uzlu (souradnic XPT,YPT), ktery odpovida prvku cyklickeho
C seznamu. Poznamka: tato konstrukce umoznuje, aby nekolik ruznych prvku
C cyklickeho seznamu odkazovalo na jeden a tyz uzel (krizeni drahy).
C
C Vystupni parametr
C IN =0  vnejsi bod
C IN =1  vnitrni bod
C
      DIMENSION XPT(*),YPT(*),IC(*),IB(*)
      REAL*8 X1,X2,Y1,Y2,T
      NPOS=0
      NNEG=0
      IBEG=I1
      NC=0
      DO WHILE(NC.LE.1000)
        NC=NC+1
C Usecka definovana uzly IP1,IP2
        I2=IC(I1)
C
C Hledame pruseciky usecky IP1,IP2 s vertikalou X=const
C
        IP1=IB(I1)
        IP2=IB(I2)
        X1=XPT(IP1)
        Y1=YPT(IP1)
        X2=XPT(IP2)
        Y2=YPT(IP2)
C mala korekce souradnice x1 slouzi k tomu, aby nebyly zapocitavany uzlove body dvakrat
        IF(X1.EQ.0.D0)THEN
           X1=1D-8
        ELSE
           X1=X1*1.00000001D0
        ENDIF
        IF(X1.NE.X2)THEN
           T=(X-X1)/(X2-X1)
           IF(T.GE.0.D0.AND.T.LE.1.D0)THEN
              YP=Y1+(Y2-Y1)*T
              IF(YP.GE.Y)THEN
                 NPOS=NPOS+1
              ELSE
                 NNEG=NNEG+1
              ENDIF
           ENDIF
        ENDIF
        I1=I2
        IF(I2.EQ.IBEG)EXIT
      ENDDO
C
C NPOS,NNEG jsou pocty pruseciku
      IN=0
      IF(NPOS.GT.0.AND.MOD(NPOS,2).EQ.1)THEN
        IF(NNEG.GT.0.AND.MOD(NNEG,2).EQ.1)THEN
           IN=1
        ELSE
           IN=-1
        ENDIF
      ENDIF
      END
