      SUBROUTINE PTCRDIST(X1,Y1,Z1,N1,PX1,PY1,PZ1,DIST)
C
C Vzdalenost bodu PX1,PY1,PZ1 od krivky definovane N1 body.
C    
      DIMENSION X1(3),Y1(3),Z1(3)
      AX1=X1(1)
      AY1=Y1(1)
      AZ1=Z1(1)
      IF(N1.EQ.2)THEN
        BX1=X1(2)-X1(1)
        BY1=Y1(2)-Y1(1)
        BZ1=Z1(2)-Z1(1)
        CX1=0
        CY1=0
        CZ1=0
      ELSEIF(N1.EQ.3)THEN
        BX1=-3*X1(1)-X1(2)+4*X1(3)
        BY1=-3*Y1(1)-Y1(2)+4*Y1(3)
        BZ1=-3*Z1(1)-Z1(2)+4*Z1(3)
        CX1=2*X1(2)-4*X1(3)+2*X1(1)
        CY1=2*Y1(2)-4*Y1(3)+2*Y1(1)
        CZ1=2*Z1(2)-4*Z1(3)+2*Z1(1)
      ENDIF
C Rozdeleni krivky 1 na NSEG bodu
      NSEG=50
      DIST2=1E10
      DT=1./NSEG
      DO I1=1,NSEG+1
       T1=DT*(I1-1)
       T2=T1*T1
       X11=AX1+BX1*T1+CX1*T2
       Y11=AY1+BY1*T1+CY1*T2
       Z11=AZ1+BZ1*T1+CZ1*T2
       DIST2=AMIN1(DIST2,(PX1-X11)**2+(PY1-Y11)**2+(PZ1-Z11)**2)
      ENDDO
      DIST=SQRT(DIST2)
      END

