      FUNCTION RNDG(IDUM)
C
C Generator nahodnych cisel s normalnim rozlozenim (0-stredni hodnota,1-variance)
C
C Algoritmus: Box Muler, Numerical recipes str. 197
C
      DATA ISET/0/
      IF(ISET.EQ.0)THEN
1        V1=2.*RND(IDUM)-1.
         V2=2.*RND(IDUM)-1.
         R=V1*V1+V2*V2
         IF(R.GE.1.)GOTO1
         FAC=SQRT(-2.*ALOG(R)/R)
         GSET=V1*FAC
         RNDG=V2*FAC
         ISET=1
      ELSE
         RNDG=GSET
         ISET=0
      ENDIF
      END

