      SUBROUTINE TAKITM(ITEXT,ICT,JINI,ILIM,NL,LG,ITYPX,MVX,ITYP,
     /                  MV,ITM,IVAL,K)
C ͻ
C  Vyber textoveho retezce z textu ITEXT, vymezeni seznamem ILIM 
C ͼ
C
C Vstupni parametry:
C
C ITEXT - analyzovany text delky ICT slabik
C J     - pozice prvniho analyzovaneho znaku J+1
C ILIM  - seznam NL-omezovacu
C LG    - delka polozky (LG=0 - volny format)
C ITYPX - zadavany typ polozky (-1/REAL,0-TEXT,1/INTEGER,2/?)
C MVX   - maximalni delka vystupniho pole ve slabikach
C
C Vystupni parametry:
C
C ITYP  - typ polozky
C MV    - delka vystupniho pole ve slabikach (MV<=MVX). Tento parametr
C         je rovnez indikatorem toho, zda analyzovana polozka je neprazdna;
C         MV=0 znamena, ze u ciselne polozky byly zpracovany mezery a omezovac,
C         zatimco u textove polozky byl omezovac hned prvnim znakem textu.
C ITM   - >0 index pouziteho omezovace
C         <0 polozka byla vymezena predepsanou delkou LG nebo koncem textu
C IVAL  - vystupni pole obsahujici ciselnou hodnotu nebo text
C K     - >0 pozice posledniho zpracovaneho znaku (omezovace nebo
C            posledniho znaku platne polozky u fix-formatu LG>0)
C         =0 je treba dodat novy vektor ITEXT, protoze doslo k prekroceni
C            delky textu ICT, aniz byla vytvorena spravna polozka
C         <0 chyba syntaxe [u ciselne polozky]; zaporna hodnota
C            -K udava pozici omezovace teto spatne polozky
C
C Pouzite procedury: TETIS$,TETR$,TCHL$,TPCHAR
C
C Fortran PowerStation 16-Jul-02
C -----------------------------------------------------------
      CHARACTER *(*) ITEXT,ILIM,IVAL
      CHARACTER *1 KZ,MEZ
      DATA MEZ/' '/
      LST=ICT
      J  =JINI
      IF(LG.GT.0)LST=MIN0(LST,J+LG)
C
C PRESUN TEXTU
C
      ITYP=0
      MV=0
      IF (J.GE.ICT) THEN
        K=0
        RETURN
      ENDIF
      K=J
410   CALL TCHL$(ITEXT,K,KZ,ITM,LST,ILIM,NL)
      IF(ITM)412,411,413
411   IF(MV.GE.MVX) GOTO 415
      MV=MV+1
      CALL TPCHAR(MV,KZ,IVAL)
      GOTO 410
413   IF(KZ.EQ.MEZ.AND.MV.EQ.0) GOTO 410
C
C DOPLNENI MEZER NA ZADANOU DELKU VYSTUPNIHO TEXTU
C
412   M1=MV+1
      DO 401 J=M1,MVX
401   CALL TPCHAR(J,MEZ,IVAL)
      RETURN
415   K=K-1
      END
