      SUBROUTINE TSS(ITX,ICT,J,LIST,N,LDEF,L,INDEX,K)
C
C ͻ
C  Vyhledani retezce (zacinajiciho na J+1 pozici ITX) v seznamu LIST     
C  Mezery ve vektoru ITX jsou zcela ignorovany.                          
C  Porovnavaci delka je promenna (<=L) a je dana poctem nemezerovych     
C  znaku v LIST-polozce.                                                 
C ͼ
C
C Vstupni parametry:
C ITX - textovy vektor delky ICT slabik
C J   - extrakce porovnavaneho textu zacne J+1 znakem vektoru ITX
C LIST- textovy vektor seznamu N polozek konstantni delky LDEF
C L   - porovnavaci delka (<=LDEF)
C
C Vystupni parametry:
C INDEX- index nalezene polozky v seznamu LIST (1<=INDEX<=N) nebo 0
C        pri neuspesnem hledani.
C K    - pozice posledniho zpracovaneho znaku ITX
C
      CHARACTER *(*) ITX,LIST
      CHARACTER *1 MEZ,KZF,KZ
      DATA MEZ /' '/
      K=0
      I1=0
      IF(N.LE.0) GOTO 6
      DO 5 INDX=1,N
      J1=J
      DO 2 IL=1,L
      KZF=LIST(I1+IL:I1+IL)
      IF (KZF.EQ.MEZ) GO TO 3
      CALL TAKCH$(ITX,ICT,J1,KZ,J1)
      IF (J1) 4,4,1
1     IF (KZF.NE.KZ)GOTO4
2     CONTINUE
3     K=J1
      INDEX=INDX
      RETURN
4     I1=I1+LDEF
5     CONTINUE
6     INDEX=0
      RETURN
      END
