\\extern
PRESS  PULSPRES.EXE  implicitni metoda siti pro P (3hladiny casu). Q a dQ-dt jako UDF
R radius [m]: 0.0075
h wall thickness [m]: 0.0008
H length of elastic tube [m]: 0.15
L length of solid pipe [m]: 2
E modulus elasticity [Pa]: 1E6
Poisson constant: 0.5
viscosity [Pa.s]: 0.001
RHO density of fluid [kg/m3]: 1000
UDF flowrate Q [m^3/s]: 1
UDF dQ/dt [m^3/s^2]: 2
NX (<151): 100
TMAX [s]: 5
DT-mult: 1
EXPLICIT(=1): 0.5
\\extern
PULSE  PULSE.EXE  metoda charakteristik pro P,Q
R radius [m]: 0.0075
h wall thickness [m]: 0.0008
H length of elastic tube [m]: 0.15
L length of solid pipe [m]: 2
E modulus elasticity [Pa]: 1E6
Poisson constant: 0.5
viscosity [Pa.s]: 0.001
RHO density of fluid [kg/m3]: 1000
UDF for flowrate: 1
NX (<151): 100
TMAX [s]: 5
\\extern
WAFW  RUNFEMW.EXE FEM 2D Poissonova rovnice pro squeezing flow
Initial time: 0.
No.of time steps: 120
Time step [s]: 1.
Append (0-new,1-append): 0
Pressure iterations: 3
Width of mold X [m]:0.27
Height of mold Y [m]:0.2
\\extern
WAFI  RUNFEMI.EXE  FEM 2D + integralni model WAFI (expanze Possonova rovnice pro p)
Initial time: 0.
No.of time steps: 120
Time step [s]: 1.
Append (0-new,1-append): 0
Width of mold X [m]:0.27
Height of mold Y [m]:0.2
Thickness of plate [m]:0.01
Power of heater [W]:4000
Tmin-plate [C]:180
Tmax-plate [C]:190
Heat transfer top [W/m2/K]:5
Heat transfer side [W/m2/K]:10
NX-grid points:20
NY-grid points:20
\\model
ZA1    ztran1.mdt
\\model
ZA2    ztran2.mdt
\\model
ZA3    ztran3.mdt
\\model
ZA4    ztran4.mdt
\\model
ZC1    ztrcr1.mdt
\\model
ZC2    ztrcr2.mdt
\\model
ZC3    ztrcr3.mdt
\\model
ZC4    ztrcr4.mdt
\\model
ZC5    ztrcr5.mdt
\\model
ZC6    ztrcr6.mdt
\\model
ZC7    ztrcr7.mdt
\\model
ZC8    ztrcr8.mdt
\\model
ZC9    ztrcr9.mdt
\\model
ZC10   ztrcr10.mdt
\\model
f1     f1.mdt
\\model
f2     f2.mdt
\\model
f3     f3.mdt
\\model
f5     f5.mdt
\\model
S00  s00.mdt
\\model
S0A  s0a.mdt
\\model
S0B  s0b.mdt
\\model
S0L  s0l.mdt
\\model
SP0  sp0.mdt
\\model
SPA  spa.mdt
\\model
SPB  spb.mdt
\\model
SPL  spL.mdt
\\model
SR0  sr0.mdt
\\model
SRA  sra.mdt
\\model
SRB  srb.mdt
\\model
SRL  srl.mdt
\\model
SS0  ss0.mdt
\\model
SSA  ssa.mdt
\\model
SSB  ssb.mdt
\\model
SSL  ssl.mdt
\\model
SU0  su0.mdt
\\model
SUA  sua.mdt
\\model
SUB  sub.mdt
\\model
SUL  sul.mdt
\\model
SV0  sv0.mdt
\\model
SVA  sva.mdt
\\model
SVB  svb.mdt
\\model
SVL  svl.mdt
\\model
SW0  sW0.mdt
\\model
SWA  sWa.mdt
\\model
SWB  sWb.mdt
\\model
SWL  sWl.mdt
\\model
SX0  sx0.mdt
\\model
SXA  sxa.mdt
\\model
SXB  sxb.mdt
\\model
SXL  sxl.mdt
\\model
A00  A00.mdt
\\model
A0A  A0a.mdt
\\model
A0B  A0b.mdt
\\model
A0L  A0l.mdt
\\model
AR0  AR0.mdt
\\model
CA00  CA00.mdt
\\model
CA0A  CA0A.mdt
\\model
CA0B  CA0B.mdt
\\model
CA0L  CA0L.mdt
\\model
CAP0  CAP0.mdt
\\model
CAPA  CAPA.mdt
\\model
CAPB  CAPB.mdt
\\model
CAPL  CAPL.mdt
\\model
CAS0  CAS0.mdt
\\model
CASA  CASA.mdt
\\model
CASB  CASB.mdt
\\model
CASL  CASL.mdt
\\model
C00  C00.mdt
\\model
C0A  C0a.mdt
\\model
C0B  C0b.mdt
\\model
C0L  C0l.mdt
\\model
CS0  Cs0.mdt
\\model
CSA  Csa.mdt
\\model
CSB  Csb.mdt
\\model
CSL  Csl.mdt
\\model
CP0  Cp0.mdt
\\model
CPA  Cpa.mdt
\\model
CPB  Cpb.mdt
\\model
CPL  Cpl.mdt
\\model
DW0  dW0.mdt
\\model
DWA  DWa.mdt
\\model
DWB  DWb.mdt
\\model
DWL  DWl.mdt
\\model
D00  d00.mdt
\\model
D0A  d0A.mdt
\\model
D0B  d0B.mdt
\\model
D0L  d0L.mdt
\\model
DP0  dP0.mdt
\\model
DPA  dPA.mdt
\\model
DPB  dPB.mdt
\\model
DPL  dPL.mdt
\\model
B00  B00.mdt
\\model
B0A  B0a.mdt
\\model
B0B  B0b.mdt
\\model
B0L  B0L.mdt
\\model
BP0  Bp0.mdt
\\model
BPA  Bpa.mdt
\\model
BPB  Bpb.mdt
\\model
BPL  BpL.mdt
\\model
E00   E00.mdt
\\model
E0A   E0A.mdt
\\model
E0B   E0B.mdt
\\model
E0L   E0L.mdt
\\model
G00   G00.mdt
\\model
G0A   G0A.mdt
\\model
G0B   G0B.mdt
\\model
G0L   G0L.mdt
\\model
H00   H00.mdt
\\model
H0A   H0A.mdt
\\model
H0B   H0B.mdt
\\model
H0L   H0L.mdt
\\model
I00   I00.mdt
\\model
I0A   I0A.mdt
\\model
I0B   I0B.mdt
\\model
I0L   I0L.mdt
\\model
IP0   IP0.mdt
\\model
IPA   IPA.mdt
\\model
IPB   IPB.mdt
\\model
IPL   IPL.mdt
\\model
IS0   IS0.mdt
\\model
ISA   ISA.mdt
\\model
ISB   ISB.mdt
\\model
ISL   ISL.mdt
\\model
IR0   IR0.mdt
\\model
IRA   IRA.mdt
\\model
IRB   IRB.mdt
\\model
IRL   IRL.mdt
\\model
IU0   IU0.mdt
\\model
IUA   IUA.mdt
\\model
IUB   IUB.mdt
\\model
IUL   IUL.mdt
\\model
IV0   IV0.mdt
\\model
IVA   IVA.mdt
\\model
IVB   IVB.mdt
\\model
IVL   IVL.mdt
\\model
IW0   IW0.mdt
\\model
IWA   IWA.mdt
\\model
IWB   IWB.mdt
\\model
IWL   IWL.mdt
\\model
IX0   IX0.mdt
\\model
IXA   IXA.mdt
\\model
IXB   IXB.mdt
\\model
IXL   IXL.mdt
\\model
IY0   IY0.mdt
\\model
IYA   IYA.mdt
\\model
IYB   IYB.mdt
\\model
IYL   IYL.mdt
\\model
LS00 QLS00.mdt
\\model
LS0A QLS0a.mdt
\\model
LS0B QLS0b.mdt
\\model
LS0L QLS0l.mdt
\\model
HS00 QHS00.mdt
\\model
HS0A QHS0A.mdt
\\model
HS0B QHS0B.mdt
\\model
HS0L QHS0L.mdt
\\model
LSR0 QLSR0.mdt
\\model
LSRA QLSRA.mdt
\\model
LSRB QLSRB.mdt
\\model
LSRL QLSRL.mdt
\\model
HSR0 QHSR0.mdt
\\model
HSRA QHSRA.mdt
\\model
HSRB QHSRB.mdt
\\model
HSRL QHSRL.mdt
\\model
BIO  bio1.mdt
\\model
FOUL foul.mdt
\\model
WAFF waff.mdt
\\model
RWAY rway.mdt

