C* Rectangular channel PIPE2D $detest.bmp
C*
C* Detector looking inside a straight channel
C*
PT 1,.000E+00,.500E+00;
PT 2,.100E+01,.500E+00;
CR2PT 1,1,2;
MCR 1,4,1,2,1,0,1; four elements PIPE2D 
EGROUP 1,PIPE2D,0,2,0,0,0,0,0,0,0,0,0; steady state, rectangular cross-section (2)
RCONST 1,PIPE2D,.500E-01,.100E-03,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
RCROSS 1,.5,.2; cross section 0.5 x 0.2
NF 1,CN,-1,0;  fixed values of CN-tracer concentration
NF 2,CN,-1,0;
NF 3,CN,-1,1;  only at center is non-zero concentration
NF 4,CN,-1,0;
NF 5,CN,-1,0;
BOX .300E+00;  cartesian boxing is necessary for DETDOF
SOLVE 0,10,1,0,0,0,0,1,0,0,0; formal solution creates OUT-file of results
C* DETDEF Detector, x-front,x-back, y-f,y-b, z-f,z-b, aperture, view angle, range, attenuation 
DETDEF 1,.500E+00,.200E+00,0,.500E+00,.100E+00,0,.200E-01,30,.600E+00,0;
DETDOF CN,0,0,1,1,1,2; dof,method,atten.,atten.funct,no.det.,det1,c1,det2,c2,...
TSTEP 10,1;
DETDOF CN,0,0,1,1,1,2;
FUNDEF 1,DOF(CN,2,XX,YY,ZZ);
DISP XX
DISP DOF(CN,2,.5,.5,0)
XX=0 FOR I=1,10 DO [XX=XX+.1 DISP DOF(CN,2,XX,.5,0)]
DETFUN 1,0,0,1,1,1,3,1; function,method,atten.,atten.funct,no.det.,det1,c1,det2,c2,
