C* $ZTOMOV0.BMP
C* Macro file (use M ZTOMOVE0.GEO)
C* Remark: You CANNOT proces this file
C*         as a batch!!! It is a macro!
C*
C* Rectangular vessel with moving
C* cylindrical electrode (9 different
C* positions will be evaluated), the
C* second electrode is bottom.
C*
C* Identified function 1 is bilinear
C* polynomial of electrical conductivity
C* with parameters A,B,C,D.
C* 
C* The batch ZTOMOVE1.GEO calculates
C* FEM solutions of electric potential,
C* results are in the 2nd column of MOP
C* (9 rows with calculated electric power).
C* The batch ZTOMOVE1.GEO is used for calculation
C* of simulated experimental data 
C*
C*   column 2  FEM prediction
C*   column 3  simulated data
C*
C* Optimisation OPTIMA is carried out (3 iterations)
C* with the model ZTOMOVE1.GEO opened on unit 7, 
C* and identified function 1 is plotted as a CN
C* distribution (this is a trick only for graphics)
C*
C* Macro tested by Zitny 20.9.2004
C*
ANALYS 2;
EGROUP 1,PLANE2D,0,1,0,0,0;
MPROP 1,PLANE2D,.600E+00,0,4200,0,998,0,.400E-01,1,.210E+12,0,.280E+00,0,.120E-04,0;
FUNDEF 1,A+B*XX+C*YY+D*XX*YY; distribution of specific electrical conductivity
A=1
B=.5
C=.3
D=-1.5
F ZTOMOVE1.GEO
TSTEP 9,1; results of different positions in 9 rows of MOP
TCFUN C3=C2
PARDEF 4,a,b,c,d;
PARFIT .7,2,1,.7,2,1,.5,2,1,-1.3,2,1;
PARLIM 0,2,0,1,0,1,-2,2;
COMPAR 1,1,9,2,3,0;
OPEN 7,ZTOMOVE1.GEO
OPTIMA 7,3
INITIA CN,1; assign identified function to CN
GD2 CN,3; plot contours of calculated conductivity
