C* $ZTOMOV1.BMP
C* Batch called by macro ZTOMOVE0.GEO.
C* Cannot be performed independently!!
C* This batch assumes that material properties
C* are defined by a function (kappa=f(A,B,C,D)).
C*
C* Tested by Zitny 20.9.2004
C*
C* Variables defining cylindrical electrode G,E,F
C* rectangular vessel 1 x 1 [m]
G=0.05
E=.1
I=0
#LOOP E,3
E=E+.2
F=.1
#LOOP F,3
F=F+.2
NPT=0
NCR=0
NSF=0
PT 1,.000E+00,.000E+00;  corners of rectangulear vessel
PT 2,.100E+01,.000E+00;
PT 3,.100E+01,.100E+01;
PT 4,.000E+00,.100E+01;
PT 5,E,F;       center of electrode
PT 6,E+G,F+G;
CIRCLE 5,5,6,4; electrode defined four curves
PT 14,.5,0;  auxiliary midpoints for definion of curved surfaces
PT 15,E/2,F/2;
PT 16,(E+1)/2,F/2;
PT 17,0,0.5;
PT 18,E/2,(F+1)/2;
PT 19,.5,1;
PT 20,(E+1)/2,(F+1)/2;
PT 21,1,.5;
SF8PT 1,1,2,12,10,14,16,11,15; surfaces defined by 8-keypoints
SF8PT 2,2,3,6,12,21,20,13,16;
SF8PT 3,3,4,8,6,19,18,7,20;
SF8PT 4,4,1,10,8,17,15,9,18;
NE=0
ND=0
MSF 1,10,10,1,.5,3; mesh surfaces by triangular elements T3
MSF 2,10,10,1,.500E+00,3;
MSF 3,10,10,1,.500E+00,3;
MSF 4,10,10,1,.500E+00,3;
NMERGE ;
NFCR 5,VOLT,-1,0,0,0; zero voltage at bottom electrode
NFCR 1,VOLT,-1,1,1,1; unit voltage at electrode
NFCR 2,VOLT,-1,1,1,1;
NFCR 3,VOLT,-1,1,1,1;
NFCR 4,VOLT,-1,1,1,1;
SOLVE 1,1,1,0,1,0,0,0,0; steady distribution of electric field
I=I+1
C2(I)=POWERE
#LABEL F
#LABEL E