C* TWO PIPES - calculated FLOW,THERM amd STRESS
C* geometry of simple strut frame (two trusses)
C*
C* Expected results: Q=3.395e-2 m^3/s
C* Suspicious: thermal boundary thickness negative!!
C* this is caused if static analysis is used-the 
C* boundary layer thickness BL is overriden by 
C* calculated transversal forces.
C*
PT 1,.000E+00,.000E+00;
PT 2,.500E+00,.500E+00;
CR2PT 1,1,2;
PT 3,.100E+01,.000E+00;
CR2PT 2,2,3;
C* meshing
MCR 1,3,1,2,0,0,1;
MCR 2,3,1,2,0,0,1;
NMERGE ;
EGROUP 1,PIPE2D,0,0,0,0,0,0,0,0,0,0,0;
RCONST 1,PIPE2D,.500E-01,.100E-03,0,0.001,0,0,0,0,0,0,0,0,0,0,0,0,0;
C* Function 1 as an initial condition for temperature
FUNDEF 1,A;
NFPT 1,UX,-1,0;
NFPT 1,UY,-1,0;
NFPT 3,UY,-1,0;
NFPT 3,UX,-1,0;
C* Tinitial=100 degree C
A=100
INITIA TEMP,1;
NFPT 1,TEMP,-1,20;
NFPT 0,TEMP,-1,20;
NFPT 1,PRES,-1,1E5;
NFPT 3,PRES,-1,0;
I* if you want to insert something before SOLVE
SOLVE 2,1,1,0,0,5,1,0,0,0,1;
