C* Solution of Poisson's equation in an L-profile is used for
C* calculation of hydraulic characteristic of pipe with L-cross section
C* assuming fully developed laminar flow of a Newtonian liquid.
C* Results (parameter A of Equation lambda=A/Re) are transferred
C* to the 3rd column of MOP (1st column is H/L).
C*
C* Gauss integ. (def. 3)
C* VALUE J
J=3
C* Nonequidistant Z (default -1.5)
C* VALUE Z
Z=-2
C* Mesh M x N
C* VALUE M
C* VALUE N
M=50
N=50
C* Elements-number of nodes
C* VALUE L 
L=4
H=.025
OHMI=1
K=0
NT=39
#LOOP LAB,NT;
K=K+1
NPT=0
NCR=0
NSF=0
PT 1,0,0;
PT 2,1,0;
PT 3,1,H;
PT 4,H,H;
PT 5,H,1;
PT 6,0,1;
SF4PT 1,1,2,3,4;
SF4PT 2,1,4,5,6;
INIFEM
MSF 1,M,N,Z,Z,L,0;
MSF 2,N,M,Z,Z,L,0;
NMERGE ;
NFCR 1,TEMP,-1,0,0;
NFCR 2,TEMP,-1,0,0;
NFCR 3,TEMP,-1,0,0;
NFCR 5,TEMP,-1,0,0;
NFCR 6,TEMP,-1,0,0;
NFCR 7,TEMP,-1,0,0;
FUNDEF 1,1;
EGROUP 1,PLANE2D,0,J,0,0,1,0,0,0,0,0,0,0;
RCONST 1,PLANE2D,1,0,0,0,0,0;
MPROP 1,PLANE2D,1,0,1,0,1,0,.400E-01,0,.210E+12,0,.280E+00,0,.120E-04,0,0,0,0,0,.100E-08,0,.100E-08,0,.100E-08,0,0,0,0,0,0,0,0,0,0,0;
SOLVE 0,1,1,0,0,0,1,0,0,0,0;
INTEL TEMP,1,1,NE,1;
C1(K)=H
C2(K)=INTEGRAL
C3(K)=2*(2*C1(K)-C1(K)**2)**3/C2(K)
H=H+.025
#LABEL LAB;
C* KONECNA HODNOTA - CTVEREC
K=K+1
NT=NT+1
NPT=0
NCR=0
NSF=0
PT 1,0,0;
PT 2,1,0;
PT 3,1,1;
PT 4,0,1;
SF4PT 1,1,2,3,4;
INIFEM
MSF 1,M,N,Z,Z,L,0;
NMERGE ;
NFCR 1,TEMP,-1,0,0;
NFCR 2,TEMP,-1,0,0;
NFCR 3,TEMP,-1,0,0;
NFCR 4,TEMP,-1,0,0;
FUNDEF 1,1;
EGROUP 1,PLANE2D,0,J,0,0,1,0,0,0,0,0,0,0;
RCONST 1,PLANE2D,1,0,0,0,0,0;
MPROP 1,PLANE2D,1,0,1,0,1,0,.400E-01,0,.210E+12,0,.280E+00,0,.120E-04,0,0,0,0,0,.100E-08,0,.100E-08,0,.100E-08,0,0,0,0,0,0,0,0,0,0,0;
SOLVE 0,1,1,0,0,0,1,0,0,0,0;
INTEL TEMP,1,1,NE,1;
C1(K)=1
C2(K)=INTEGRAL
C3(K)=2*(2*C1(K)-C1(K)**2)**3/C2(K)
