C $$-COME.FOR  spolecna sekce pro FEMINA i RUNFEM
      FUNCTION TFUW(INDX,P,M)
C rozsireni funkce TFUS
C o interpolaci v tabulkach (operace 9,10,11)
C a o interpolaci v cele oblasti uzlovych parametru
      INCLUDE '$FEMB'
      DIMENSION P(*)
	REAL MJU,JM
      SELECT CASE(INDX)
      CASE(1:8)
          TFUW=TFUS(INDX,P,M)
          RETURN
      CASE(9)
C XVT(i,time) i-index vstupni funkce (vlastne vzdy 1)
         IND=P(1)+.5
         IF(IND.GT.0.AND.IND.LE.MAXINPUTS)THEN
            ITC=MINPUTS(IND)
            CALL CVAL(ITC,P(2),WESULT,-1)
         ELSE
            WESULT=0.
         ENDIF
      CASE(10)
C YVT(i,time) i-index odezvy (pokud je jen jedna bude i=1)
         IND=P(1)+.5
         IF(IND.GT.0.AND.IND.LE.MAXOUTPUTS)THEN
            ITC=MOUTPUTS(IND)
            CALL CVAL(ITC,P(2),WESULT,-1)
         ELSE
            WESULT=0.
         ENDIF
      CASE(11)
C CVT    (INDEX,TIME) index sloupce matice bodu pozorovani
         ITC=P(1)+.5
         CALL CVAL(ITC,P(2),WESULT,-1)
      CASE(12)
C DOF    (IDF,X,Y,Z)
         IDF=P(1)+.5
         IZONE=P(2)+.5
         IF(IZONE.GE.1.AND.IZONE.LE.4.AND.IDF.GT.0)
     /    CALL DOFINT(IDF,IZONE,P(3),P(4),P(5),IELEM,WESULT)
      CASE(13)
C EPA    (IEPA,X,Y,Z)
         IEPA=P(1)+.5
         IF(IEPA.GT.0)
     /    CALL EPAINT(IEPA,P(2),P(3),P(4),IELEM,WESULT)
      CASE(14)
C DET (IDET,IVIEW,AMU,X,Y,Z)
         IDET=P(1)+.5
         IVIE=P(2)+.5
         IF(IDET.GT.0.AND.IDET.LE.MAXDET)
     /    CALL DETCOL(IDET,IVIE,P(3),P(4),P(5),P(6),WESULT)
      CASE(15)
C ALEN (IDET,X,Y,Z,XC,YC,ZC,A,B,H,ITYP)
         IDET=P(1)+.5
         ITYP=P(11)+.5
         IF(IDET.GT.0.AND.IDET.LE.MAXDET)
     /    CALL ATILEN(IDET,P(2),P(3),P(4),P(5),P(6),P(7),P(8),P(9),
     /                     P(10),ITYP,WESULT)
      CASE(16)
C RLEN (IDET,X,Y,Z)   
         IDET=P(1)+.5
         IF(IDET.GT.0.AND.IDET.LE.MAXDET)
     /    CALL ATRLEN(IDET,P(2),P(3),P(4),WESULT)
      CASE(17)
C IEP (IEPA-nazev parametru,IE-index elementu)  - INDEX parametr v matici EPAR
         IEPA=P(1)+.5
         IELEM=P(2)+.5
         WESULT=1.
         IF(IELEM.GT.0.AND.IELEM.LE.NE)THEN
            NAMELE=JGROUP(IGROUP(IELEM),$ENAME)
            IPAR=LEPAR(NAMELE,IEPA)
            IF(IPAR.GT.0.AND.IPAR.LE.MAXEPAR)WESULT=MAXEL*(IPAR-1)+IELEM
         ENDIF
      CASE(18)
C CLEN (ICURVE) - vypocet delky krivky
         ICCC=P(1)+.5
         CALL CURLEN(ICCC,WESULT)
      CASE(19)
C BESSELOVA FUNKCE J(N,X)
         ICCC=P(1)+.5
         WESULT=BESJN(ICCC,P(2))
      CASE(20)
C BESSELOVA FUNKCE Y(N,X)
         ICCC=P(1)+.5
         IF(P(2).LE.0.)THEN
            WESULT=0.
         ELSE
            WESULT=BESYN(ICCC,P(2))
         ENDIF
      CASE(21)
C Tlak na vnitrnim povrchu aorty

         IF(M.EQ.10)THEN
C	    CALL AORTAF(RO,RSI,RSO,RLZ,THETA,C1,C2,B1,B2,B3,N,WESULT,FORCE)
C Fung
          RO=P(1)
	    RSI=P(2)
	    RSO=P(3)
	    RLZ=P(4)
	    THETA=P(5)
	    C1=P(6)
	    C2=P(7)
	    B1=P(8)
	    B2=P(9)
	    B3=P(10)
C Modifikace - soucasny vypocet axialni sily FORCEZ
	    CALL AORTAF(RO,RSI,RSO,RLZ,THETA,C1,C2,B1,B2,B3,100,WESULT,
     /ForceZ)
C Vysledna sila ukladana do pomocne promenne v COMMON POWERF (RALGOR(40))
           RALGOR(40)=FORCEZ

	   ELSEIF(M.EQ.9)THEN
C	     CALL AORTAH(RO,RSI,RSO,RLZ,ALFA,C1,RK1,RK2,SIN2,N,RESULT,F)
C Holtzapfel
          RO=P(1)
	    RSI=P(2)
	    RSO=P(3)
	    RLZ=P(4)
	    ALFA=P(5)
	    C1=P(6)
	    RK1=P(7)
	    RK2=P(8)
	    SIN2=P(9)
          CALL AORTAH(RO,RSI,RSO,RLZ,ALFA,C1,RK1,RK2,SIN2,N,WESULT,F)

	   ELSE
C Gent2
          RO=P(1)
	    RSI=P(2)
	    RSO=P(3)
	    RLZ=P(4)
	    THETA=P(5)
	    MJU=P(6)
	    JM=P(7)
	    SIN2=P(8)
	    CALL AORTAG(RO,RSI,RSO,RLZ,THETA,MJU,JM,SIN2,WESULT,F)
	   ENDIF
	CASE(22)
	   X=P(1)
	   WESULT=EXP(GAMMLN(X))
      END SELECT
      TFUW=WESULT
      END

      SUBROUTINE CURLEN(J,WESULT)
C Delka krivky (zatim jen usecka)
      INCLUDE '$FEM'
      IF(J.GT.0.AND.J.LE.NCR)THEN
         I1=MAX0(1,MIN0(NPT,ICR(1,J)))
         I2=MAX0(1,MIN0(NPT,ICR(2,J)))
         WESULT=SQRT((PTX(I1)-PTX(I2))**2+(PTY(I1)-PTY(I2))**2+
     /                   (PTZ(I1)-PTZ(I2))**2)
      ELSE
         WESULT=0
      ENDIF
      END

      SUBROUTINE DETCOL(IG,IVIEW,AMU,XXX,YYY,ZZZ,WESULT)
C Odezva detektoru IG na jednotkovy zaric v miste X,Y,Z
      INCLUDE '$FEM'
      DIMENSION XD(2),YD(2),ZD(2)
      DO I=1,2
         XD(I)=DETECT(IG,3*I-2)
         YD(I)=DETECT(IG,3*I-1)
         ZD(I)=DETECT(IG,3*I)
      ENDDO
      ACOL=DETECT(IG,10)
      APERTURE=DETECT(IG,7)
      HS=SQRT((XD(1)-XD(2))**2+(YD(1)-YD(2))**2+(ZD(1)-ZD(2))**2)
C Vzdalenost 
      CALL TXYZRZ(DETECT(IG,1),DETECT(IG,2),DETECT(IG,3),
     /            DETECT(IG,4),DETECT(IG,5),DETECT(IG,6),
     /            XXX,YYY,ZZZ,R,Z)
      WESULT=COLUNI(IVIEW,Z,R,APERTURE,HS,AMU,ACOL,0.1)
      END      

      SUBROUTINE DOFINV(NIDF,IDF,IZONE,X,Y,Z,IE,WESULT)
C Preda interpolovane hodnoty vybranych stupnu volnosti 
C IDF(1),...,IDF(NIDF) v libovolnem bode X,Y,Z, 
C Vystupni parametry:  IELEM cislo elementu (=0) kdyz mimo
C                      WESULT(1),...,WESULT(NIDF) interpolovane hodnoty
      INCLUDE '$FEM'
      INTEGER IDF(*)
      REAL WESULT(*)
C Bod lezici mimo elementy dava nulovou hodnotu!
      DO K=1,NIDF
         WESULT(K)=0.
      ENDDO
      IE=0
      IF(DXBOX.GT.0..AND.DYBOX.GT.0..AND.DZBOX.GT.0)THEN
        IF(X.LT.XBOXMI.OR.X.GT.XBOXMA.OR.
     /     Y.LT.YBOXMI.OR.Y.GT.YBOXMA.OR.
     /     Z.LT.ZBOXMI.OR.Z.GT.ZBOXMA)RETURN
        IX=MIN0(NXBOX,IFIX((X-XBOXMI)/DXBOX)+1)
        IY=MIN0(NYBOX,IFIX((Y-YBOXMI)/DYBOX)+1)
        IZ=MIN0(NZBOX,IFIX((Z-ZBOXMI)/DZBOX)+1)
        IR=((IZ-1)*NYBOX+(IY-1))*NXBOX+IX 
C 6 - $runbox.bin
        READ(6,REC=IR,ERR=100)IE
        IF(IE.GT.0.AND.IE.LE.NE)THEN
C Interpolace IDOF v elementu IE. Pouziti metody vazenych vzdalenosti.
           NUE=IABS(MUE(IE))
           LOC=IABS(LUE(IE))
           XEMA=-1E10
           XEMI=1E10
           YEMA=-1E10
           YEMI=1E10
           ZEMA=-1E10
           ZEMI=1E10
           DO I=1,NUE
              IU=IABS(IUE(LOC+I))
              XEMA=AMAX1(XEMA,XX(IU))                   
              XEMI=AMIN1(XEMI,XX(IU))                   
              YEMA=AMAX1(YEMA,YY(IU))                   
              YEMI=AMIN1(YEMI,YY(IU))                   
              ZEMA=AMAX1(ZEMA,ZZ(IU))                   
              ZEMI=AMIN1(ZEMI,ZZ(IU))                   
           ENDDO
           DXE=XEMA-XEMI
           IF(DXE.LE.0.)DXE=1.
           DYE=YEMA-YEMI
           IF(DYE.LE.0.)DYE=1.
           DZE=ZEMA-ZEMI
           IF(DZE.LE.0.)DZE=1.       
           D2=0
           DO I=1,NUE
             IU=IABS(IUE(LOC+I))
             DIST=
     /SQRT(((X-XX(IU))/DXE)**2+((Y-YY(IU))/DYE)**2+((Z-ZZ(IU))/DZE)**2)
             IF(DIST.LT.1E-10)THEN
               DO K=1,NIDF
                 IPAR=LPU(IDF(K))
                 IF(IPAR.LT.0)THEN
                   WESULT(K)=0.
                 ELSE
                   WESULT(K)=VAL(IPAR+IU,IZONE)
                 ENDIF
               ENDDO
               GOTO 100
             ELSE
               DO K=1,NIDF
                 IPAR=LPU(IDF(K))
                 IF(IPAR.GE.0)
     /               WESULT(K)=WESULT(K)+VAL(IPAR+IU,IZONE)/DIST
               ENDDO
               D2=D2+1./DIST
             ENDIF
           ENDDO
           DO K=1,NIDF
             WESULT(K)=WESULT(K)/D2
           ENDDO
        ELSE
           WRITE(*,'('' DOF not defined, use command ANALYS'')')
        ENDIF
      ELSE
	  IF(ICOUNTBOXERR.LE.10)THEN
	      ICOUNTBOXERR=ICOUNTBOXERR+1
            WRITE(*,*)' DOFINV cartesian boxing must be performed'
		  WRITE(*,'('' DX='',E10.3,'' DY='',E10.3,'' DZ='',E10.3)')
     /		  DXBOX,DYBOX,DZBOX
        ENDIF
      ENDIF
100   CONTINUE
      END

      SUBROUTINE DOFINT(IDF,IZONE,X,Y,Z,IE,WESULT)
C Preda interpolovanou hodnotu vybraneho stupne volnosti IDOF
C v libovolnem bode X,Y,Z
C Vystupni parametry:  IELEM cislo elementu (=0) kdyz mimo
C                      WESULT interpolovana hodnota
      INCLUDE '$FEM'
C Bod lezici mimo elementy dava nulovou hodnotu!
      DIMENSION XQ(3),YQ(3),CQ(3)
	LOGICAL OPE
      WESULT=0.
      IE=0
      IF(DXBOX.GT.0..AND.DYBOX.GT.0..AND.DZBOX.GT.0)THEN
        IF(X.LT.XBOXMI.OR.X.GT.XBOXMA.OR.
     /     Y.LT.YBOXMI.OR.Y.GT.YBOXMA.OR.
     /     Z.LT.ZBOXMI.OR.Z.GT.ZBOXMA)RETURN
        IX=MIN0(NXBOX,IFIX((X-XBOXMI)/DXBOX)+1)
        IY=MIN0(NYBOX,IFIX((Y-YBOXMI)/DYBOX)+1)
        IZ=MIN0(NZBOX,IFIX((Z-ZBOXMI)/DZBOX)+1)
        IR=((IZ-1)*NYBOX+(IY-1))*NXBOX+IX 
	  INQUIRE(6,OPENED=OPE)
	  IF(.NOT.OPE)THEN
	      WRITE(*,*)'  Warning: DOF function needs $RUNBOX.BIN opened'
            OPEN(6,FILE='$RUNBOX.BIN',ACCESS='DIRECT',RECL=4)
        ENDIF
        READ(6,REC=IR,ERR=100)IE
        IF(IE.GT.0.AND.IE.LE.NE)THEN
C Interpolace IDOF v elementu IE. Pouziti metody vazenych vzdalenosti.
           NUE=IABS(MUE(IE))
           D1=0
           D2=0
           LOC=IABS(LUE(IE))
           IPAR=LPU(IDF)
           IF(IPAR.GE.0)THEN
             IF(NUE.EQ.3)THEN
C specialni interpolace pro trojuhelnikovy element
                DO I=1,NUE
                   IU=IABS(IUE(LOC+I))
                   XQ(I)=XX(IU)
                   YQ(I)=YY(IU)
                   CQ(I)=VAL(IPAR+IU,IZONE)
                ENDDO
                CALL FTLINT(XQ,YQ,CQ,X,Y,WESULT,CXDUM,CYDUM)
             ELSE
                XEMA=-1E10
                XEMI=1E10
                YEMA=-1E10
                YEMI=1E10
                ZEMA=-1E10
                ZEMI=1E10
                DO I=1,NUE
                   IU=IABS(IUE(LOC+I))
                   XEMA=AMAX1(XEMA,XX(IU))                   
                   XEMI=AMIN1(XEMI,XX(IU))                   
                   YEMA=AMAX1(YEMA,YY(IU))                   
                   YEMI=AMIN1(YEMI,YY(IU))                   
                   ZEMA=AMAX1(ZEMA,ZZ(IU))                   
                   ZEMI=AMIN1(ZEMI,ZZ(IU))                   
                ENDDO
                DXE=XEMA-XEMI
                IF(DXE.LE.0.)DXE=1.
                DYE=YEMA-YEMI
                IF(DYE.LE.0.)DYE=1.
                DZE=ZEMA-ZEMI
                IF(DZE.LE.0.)DZE=1.
                DO I=1,NUE
                   IU=IABS(IUE(LOC+I))
                   DIST=
     /SQRT(((X-XX(IU))/DXE)**2+((Y-YY(IU))/DYE)**2+((Z-ZZ(IU))/DZE)**2)
                   V=VAL(IPAR+IU,IZONE)
                   IF(DIST.LT.1E-10)THEN
                      WESULT=V
                      GOTO 100
                   ELSE
                      D1=D1+V/DIST
                      D2=D2+1./DIST
                   ENDIF
                ENDDO
                WESULT=D1/D2
             ENDIF
           ENDIF
        ELSE
           WRITE(*,'('' DOF not defined, use command ANALYS'')')
        ENDIF
      ELSE
	  IF(ICOUNTBOXERR.LE.10)THEN
	      ICOUNTBOXERR=ICOUNTBOXERR+1
            WRITE(*,*)' DOFINT cartesian boxing must be performed'
		  WRITE(*,'('' DX='',E10.3,'' DY='',E10.3,'' DZ='',E10.3)')
     /		  DXBOX,DYBOX,DZBOX
        ENDIF
      ENDIF
100   CONTINUE
      END

      SUBROUTINE EPAINT(IEPA,X,Y,Z,IE,WESULT)
C Preda interpolovanou hodnotu vybraneho parametru elementu
C v libovolnem bode X,Y,Z
      INCLUDE '$FEMB'
      WESULT=0.
      IE=0
      IF(DXBOX.GT.0..AND.DYBOX.GT.0..AND.DZBOX.GT.0)THEN
        IF(X.LT.XBOXMI.OR.X.GT.XBOXMA.OR.
     /     Y.LT.YBOXMI.OR.Y.GT.YBOXMA.OR.
     /     Z.LT.ZBOXMI.OR.Z.GT.ZBOXMA)RETURN
        IX=IFIX((X-XBOXMI)/DXBOX)+1
        IY=IFIX((Y-YBOXMI)/DYBOX)+1
        IZ=IFIX((Z-ZBOXMI)/DZBOX)+1
        IR=((IZ-1)*NYBOX+(IY-1))*NXBOX+IX 
        READ(6,REC=IR,ERR=100)IE
        IF(IE.GT.0.AND.IE.LE.NE)THEN
C Predani hodnoty parametru elementu
           NAMELE=JGROUP(IGROUP(IE),$ENAME)
           IPAR=LEPAR(NAMELE,IEPA)
           IF(IPAR.GT.0)WESULT=EPAR(IE,IPAR)
        ELSE
           WRITE(*,'('' DOF not defined, use command ANALYS'')')
        ENDIF
      ELSE
	  IF(ICOUNTBOXERR.LE.10)THEN
	      ICOUNTBOXERR=ICOUNTBOXERR+1
            WRITE(*,*)' EPAINT cartesian boxing must be performed'
		  WRITE(*,'('' DX='',E10.3,'' DY='',E10.3,'' DZ='',E10.3)')
     /		  DXBOX,DYBOX,DZBOX
        ENDIF
      ENDIF
100   CONTINUE
      END

      SUBROUTINE CVAL(ITC,T,C,ISMOOTH)
C
C Preda hodnotu krivky ITC (1,2,...,MAXSEL) v case T do promenne C
C ISMOOTH=0  linearni interpolace
C        =1  kvadraticka interpolace (ze tri bodu i-2,i-1,i)
C
      INCLUDE '$FEM'
      IF(ITC.LE.0.OR.ITC.GT.MAXSEL.OR.NGR.GT.MAXNTS)THEN
        C=0
      ELSEIF(ISMOOTH.LT.0.AND.DTIME.GT.0.)THEN
C Konstantni casovy krok
        I1=T/DTIME+1.
        I2=I1+1
        IF(I1.GE.1.AND.I2.LE.MAXNTS)THEN
           T1=(I1-1)*DTIME
           T2=T1+DTIME
           C1=YGR(I1,ITC)
           C2=YGR(I2,ITC)
           C=AMAX1(0.,C1+(T-T1)*(C2-C1)/DTIME)
        ELSE
           C=0
        ENDIF
      ELSE
C Promenny casovy krok
        N=NGR
        DO INDT=2,N
          IF(T.LE.YGR(INDT,1))THEN
              CW=YGR(INDT-1,ITC)
              CP=YGR(INDT,ITC)
              TW=YGR(INDT-1,1)
              TC=YGR(INDT,1)
              IF(ISMOOTH.EQ.0.OR.INDT.LE.2)THEN
C Linearni interpolace (promenne DT)
                 IF(TC.GT.TW)THEN
                    C=CW+(T-TW)*(CP-CW)/(TC-TW)
                 ELSE
                    C=CW
                 ENDIF
              ELSE
C Kvadraticka interpolace (promenne DT)
                 TWW=YGR(INDT-2,1)
                 CWW=YGR(INDT-2,ITC)
                 DET=(TW-TWW)*(TC-TWW)**2-(TC-TWW)*(TW-TWW)**2
                 IF(DET.NE.0.)THEN
                    BB=((CW-CWW)*(TC-TWW)**2-(CP-CWW)*(TW-TWW)**2)/DET
                    CC=((CP-CWW)*(TW-TWW)-(CW-CWW)*(TC-TWW))/DET
                    C=CWW+BB*(T-TWW)+CC*(T-TWW)**2
                 ELSE
                    C=CW
                 ENDIF
              ENDIF
              RETURN
          ENDIF
        ENDDO
      ENDIF
      END

      SUBROUTINE INTGCR(IC,IFU,WESULT)
C
C Integral pres krivku cislo IC, integrandem je funkce cislo IFU
C
      INCLUDE '$FEM'
      DIMENSION X(3),Y(3),Z(3)
      NUCR=MCR(IC)
      DO I=1,NUCR
         J=ICR(I,IC)
         X(I)=PTX(J)
         Y(I)=PTY(J)
         Z(I)=PTZ(J)
      ENDDO
      IF(NUCR.EQ.3)THEN
        AX=-4*X(3)+2*(X(2)+X(1))
        BX=4*X(3)-3*X(1)-X(2)
        AY=-4*Y(3)+2*(Y(2)+Y(1))
        BY=4*Y(3)-3*Y(1)-Y(2)
        AZ=-4*Z(3)+2*(Z(2)+Z(1))
        BZ=4*Z(3)-3*Z(1)-Z(2)
      ELSE
        AX=0
        BX=X(2)-X(1)
        AY=0
        BY=Y(2)-Y(1)
        AZ=0
        BZ=Z(2)-Z(1)
      ENDIF
C Integrace pres T (0-1) lichobeznikovou methodou. 
C Pocet integracnich bodu ialgor(8)
      SUM=0
      DT=1./(IALGOR(8)-1)
      T=0
      DO I=1,IALGOR(8)
C Aktualni souradnice
         XT=X(1)+(BX+AX*T)*T
         YT=Y(1)+(BY+AY*T)*T
         ZT=Z(1)+(BZ+AZ*T)*T
         AUX(2)=XT
         AUX(3)=YT
         AUX(4)=ZT
         DXDT=BX+2*AX*T
         DYDT=BY+2*AY*T
         DZDT=BZ+2*AZ*T
         DET=SQRT(DXDT**2+DYDT**2+DZDT**2)
         IF(I.EQ.1.OR.I.EQ.IALGOR(8))DET=DET*.5
         CF=CURFUN(IFU)
         SUM=SUM+CF*DET
         T=T+DT
      ENDDO
      WESULT=SUM*DT
      END

      SUBROUTINE INTGSF(IS,IFU,WESULT)
C
C Integral pres plochu cislo IS, integrandem je funkce cislo IFU
C Plocha muze byt zakrivena, v libovolne poloze v prostoru
C
      INCLUDE '$FEM'
      DIMENSION X(8),Y(8),Z(8),F(8),FX(8),FY(8),FZ(8)
      NUSF=MSF(IS)
      DO I=1,NUSF
         J=ISF(I,IS)
         X(I)=PTX(J)
         Y(I)=PTY(J)
         Z(I)=PTZ(J)
      ENDDO
C Integrace pres KSI (-1,1) x ETA (-1,1) . 
C Pocet integracnich bodu v kazde ose ialgor(8) (systemova promenna NINTG)
      SUM=0
      DT=2./IALGOR(8)
      RKSI=-1.+DT/2
      DO IKSI=1,IALGOR(8)
         RETA=-1.+DT/2
         DO IETA=1,IALGOR(8)
            CALL FDFQ3(NUSF,X,Y,Z,RKSI,RETA,QX,QY,QZ,F,FX,FY,FZ,DET)
C Aktualni souradnice X,Y,Z
            AUX(2)=QX
            AUX(3)=QY
            AUX(4)=QZ
C           SUM=SUM+CURFUN(IFU)*DET*4
            SUM=SUM+CURFUN(IFU)*DET
            RETA=RETA+DT
         ENDDO
         RKSI=RKSI+DT
      ENDDO
      WESULT=SUM*DT*DT
      END

      SUBROUTINE INTGEL(IDOF,IFU,IFIRST,ILAST,ISTEP,WESULT)
C Integral DOF*CURFUB(IFU) pres elementy
      INCLUDE '$FEMB'
      DIMENSION X(20),Y(20),Z(20),T(20),G(3),W(3),FK(20),
     /          G1(16),G2(16),G3(16),WT(16),F(20),FX(20),FY(20),FZ(20)
      WESULT=0.
      IF(IFIRST.LE.0.OR.ILAST.LT.IFIRST.OR.ILAST.GT.NE)THEN
         WRITE(2,*)' INTGEL ERROR - WRONG INDEX OF ELEMENT'
      ELSE
       DO IE=IFIRST,ILAST,ISTEP
         LOC=LUE(IE)
         MUEL=MUE(IE)
         MINTN=MINT(IE)
         NDL=IABS(MUEL)
         NUE=NDL-MINTN
         IG=MAX0(1,IGROUP(IE))
         IETYP=JGROUP(IG,$ENAME)
         DO IU=1,NUE
           IND=IABS(IUE(LOC+IU))
           X(IU)=XX(IND)
           Y(IU)=YY(IND)
           Z(IU)=ZZ(IND)
           LOCT=LPU(IDOF)+IND
           T(IU)=VAL(LOCT,3)
         ENDDO
         SELECT CASE(IETYP)
         CASE($PLANE2D,$FLOW2D)
            IF(NUE.EQ.3.OR.NUE.EQ.6)THEN
C trojuhelnikove elementy
              CALL TGAUS(7,NGSS,G1,G2,WT)
            ELSE
C Isoparametric 4 or 8-node element.
              CALL QGAUS(3,NGSS,G1,G2,WT)
            ENDIF
         CASE($SOLID,$FLOW3D)
           IF(NUE.EQ.8.OR.NUE.EQ.20)THEN
C Isoparametric 4 or 8-node element.
             G(1:3)=(/-.77459666,0.,.77459666/)
             W(1:3)=(/.5555555,.8888888,.555555/)
             NGSS=0
             DO I=1,3
               DO J=1,3
                  DO K=1,3
                    NGSS=NGSS+1
                    G1(NGSS)=G(I)
                    G2(NGSS)=G(J)
                    G3(NGSS)=G(K)
                    WT(NGSS)=W(I)*W(J)*W(K)
                  ENDDO
               ENDDO
             ENDDO
           ENDIF
         CASE DEFAULT
           NGSS=1
           G1(1)=0.
           WT(1)=2.
         ENDSELECT
C Integration over an element summing integrands in Gauss points
         DO IG=1,NGSS
C Bazove funkce F(i) a jejich derivace v integracnim bode IG
           SELECT CASE(IETYP)
           CASE($PLANE2D,$FLOW2D)
              IF(NUE.EQ.3.OR.NUE.EQ.6)THEN 
                CALL FDFT(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
              ELSE
                CALL FDFQ(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
              ENDIF
           CASE($SOLID,$FLOW3D)
              CALL FDFVL(NUE,X,Y,Z,G1(IG),G2(IG),G3(IG),F,FX,FY,FZ,DET)
           CASE DEFAULT
              CALL FDCR(NUE,X,Y,G1(IG),F,FK,FX,FY,DET)
           ENDSELECT
           XT=0
           YT=0
           ZT=0
           WI=0
           DO I=1,NUE
              XT=XT+F(I)*X(I)
              YT=YT+F(I)*Y(I)
              ZT=ZT+F(I)*Z(I)
              WI=WI+F(I)*T(I)
           ENDDO
           AUX(2)=XT
           AUX(3)=YT
           AUX(4)=ZT
           WESULT=WESULT+DET*WT(IG)*WI*CURFUN(IFU)
         ENDDO
       ENDDO
      ENDIF
      END

      SUBROUTINE FTLINT(X,Y,C,XC,YC,CC,CCX,CCY)
C
C INTERPOLACE V TRIUZLOVEM TROJUHELNIKU
C
C VSTUPY:
C X(3),Y(3)       SOURADNICE UZLU (1,2,3)
C C(3)            HODNOTY VE VRCHOLECH
C XC,YC SOURADNICE LIBOVOLNEHO BODU 
C
C VYSTUP:
C CC,CCX,CCY  HODNOTA A PRVNI DERIVACE 
C
      DIMENSION Y(*),X(*),C(*)
      DET=Y(1)*(X(2)-X(3))+Y(2)*(X(3)-X(1))+Y(3)*(X(1)-X(2))
c      write(10,*)' ftlint x,y',(x(i),y(i),i=1,3)
c      write(10,*)' det=',det
      CC=0.
      CCX=0.
      CCY=0.
      DO I=1,3
        I1=MOD(I,3)+1
        I2=MOD(I1,3)+1
        FY=(X(I1)-X(I2))/DET
        FX=(Y(I2)-Y(I1))/DET
        F=(X(I2)*Y(I1)-X(I1)*Y(I2))/DET
        CC=CC+C(I)*(F+FX*XC+FY*YC)
        CCX=CCX+C(I)*FX
        CCY=CCY+C(I)*FY
      ENDDO
      END

      SUBROUTINE RECTAB(DE,AREA,A,B)
C
C Vypocet stran A,B obdelniku je-li zadany ekvivalentni prumer 4S/O a prurez.
C
      AAREA=ABS(AREA)
      IF(DE.GT.0..AND.AAREA.GE.DE**2)THEN
         IF(AREA.GT.0.)THEN
            B=AAREA/DE*(1.+SQRT(1.-DE**2/AAREA))
            A=AAREA/B
         ELSE
            A=AAREA/DE*(1.+SQRT(1.-DE**2/AAREA))
            B=AAREA/A
C           B=AREA/A
         ENDIF
      ELSE
         WRITE(9,'('' ! AREA='',e9.2,''< (D='',e9.2,'')^2'')')DE,AREA
      ENDIF
      END

      FUNCTION RADEL(NAMEL,H,IR)
C Vypocet polomeru elementu
      INCLUDE '$FEMB'
      SELECT CASE(NAMEL)
      CASE($PIPE2D,$PIPE3D,$TRUSS2D,$TRUSS3D,$BEAM2D,$BEAM3D)
        RADEL=RRCONS(IR,$D)*.5
      CASE($CSTR,$PUMP)
        AREA=ABS(RRCONS(IR,$VOL)/H)
        RADEL=SQRT(AREA/PI)
      ENDSELECT
      END

      SUBROUTINE ROT(X,Y,Z,XT,YT,ZT)
C Transformace 
C IPROJ=0 natocenim kolem vsech tri os X,Y,Z
C IPROJ=1 axonometrie
      INCLUDE '$FEM'
      SELECT CASE(IPROJ)
      CASE(0)
        Y1=Y*CFIX+Z*SFIX
        Z1=Z*CFIX-Y*SFIX
        X2=X*CFIY-Z1*SFIY
        ZT=Z1*CFIY+X*SFIY
        XT=X2*CFIZ+Y1*SFIZ
        YT=Y1*CFIZ-X2*SFIZ
      CASE(1)
        D=(XEYE-X)*BEYE+(ZEYE-Z)*AEYE
        IF(D.EQ.0.)THEN
            WRITE(9,'('' Wrong eye coordinates'')')
            D=1.
        ENDIF
        P=(ZEYE*AEYE+XEYE*BEYE)/D
        X1=XEYE+P*(X-XEYE)
        Z1=ZEYE+P*(Z-ZEYE)
        YT=YEYE+P*(Y-YEYE)
        XT=X1*AEYE-Z1*BEYE
      END SELECT
      END

      SUBROUTINE TKEZXYZ(JAXIS,XV,YV,ZV,RKSI,RETA,RZETA,X,Y,Z)
C
C TRANSFORMACE BODU Z LOKALNIHO SOURADNEHO SYSTEM RKSI,RETA,RZETA DO X,Y,Z
C Transformace je urcena useckou XV,YV,ZV, jejiz bod XV(1),YV(1),ZV(1) je
C pocatek lokalniho souradneho systemu a ktera je soucasne osou RKSI.
C Osa RETA (kolma na RKSI) lezi bud v rovine XY (JAXIS=2), XZ (JAXIS=3) nebo
C v rovine YZ (JAXIS=4) a osa RZETA je kolma k RKSI i RETA.
C
      REAL XV(2),YV(2),ZV(2),LXY,LYZ,LXZ,L
      X2=XV(2)-XV(1)
      Y2=YV(2)-YV(1)
      Z2=ZV(2)-ZV(1)
      SELECT CASE(JAXIS)
      CASE(3)
C Osa RETA lezi v rovine XZ
        IF(X2.EQ.0..AND.Z2.EQ.0.)X2=1E-10
        XZ=X2**2+Z2**2
        XYZ=XZ+Y2**2
        LXZ=SQRT(XZ)
        L=SQRT(XYZ)
        RK=RKSI/L
        X=X2*RK-Z2/LXZ*RETA-Y2*X2*RZETA/(L*LXZ)
        Y=Y2*RK+LXZ*RZETA/L
        Z=Z2*RK+X2/LXZ*RETA-Z2*Y2*RZETA/(L*LXZ)
      CASE(4)
C Osa RETA lezi v rovine YZ
        IF(Y2.EQ.0..AND.Z2.EQ.0.)Y2=1E-10
        YZ=Y2**2+Z2**2
        XYZ=YZ+X2**2
        LYZ=SQRT(YZ)
        L=SQRT(XYZ)
        RK=RKSI/L
        X=X2*RK+LYZ*RZETA/L
        Y=Y2*RK-Z2/LYZ*RETA-Y2*X2*RZETA/(L*LYZ)
        Z=Z2*RK+Y2/LYZ*RETA-Z2*X2*RZETA/(L*LYZ)
      CASE DEFAULT
C Osa RETA lezi v rovine XY
        IF(X2.EQ.0..AND.Y2.EQ.0.)X2=1E-10
        XY=X2**2+Y2**2
        XYZ=XY+Z2**2
        LXY=SQRT(XY)
        L=SQRT(XYZ)
        RK=RKSI/L
        X=X2*RK-Y2/LXY*RETA-Z2*X2*RZETA/(L*LXY)
        Y=Y2*RK+X2/LXY*RETA-Z2*Y2*RZETA/(L*LXY)
        Z=Z2*RK+LXY*RZETA/L
      ENDSELECT
      X=X+XV(1)
      Y=Y+YV(1)
      Z=Z+ZV(1)
      END

      SUBROUTINE TRZFXYZ(XV,YV,ZV,R,Zeta,PSI,X,Y,Z)
C INVERZNI TRANSFORMACE
C Dany dva body xv1,xv2  yv1,yv2, zv1,zv2 , 
C bod cislo 1 je celo kolimatoru a bod cislo 2 je zadek kolimatoru.
C Pocitany bod X,Y,Z ma vzdalenost od osy R a lezi na kruznici kolme
C k ose kolimatoru jejiz vzdalenost od cela je ZETA.
      DIMENSION XV(2),YV(2),ZV(2)
      ZZ=R*COS(PSI)
      ZY=R*SIN(PSI)
      ZX=ZETA
      H=SQRT((XV(2)-XV(1))**2+(YV(2)-YV(1))**2+(ZV(2)-ZV(1))**2)
      SINZ=-(YV(2)-YV(1))/H
      COSZ=SQRT(1-SINZ**2)
      IF(XV(1).LT.XV(2))COSZ=-COSZ
      IF(COSZ.EQ.0.)THEN
        Y=YV(1)+ZX
        X=XV(1)+ZY
        Z=ZV(1)+ZZ
      ELSE
        SINY=-(ZV(2)-ZV(1))/(H*COSZ)
        COSY=SQRT(1-SINY**2)
        X=(ZX*COSZ-ZY*SINZ)*COSY-ZZ*SINY+XV(1)
        Z=(ZX*COSZ-ZY*SINZ)*SINY+ZZ*COSY+ZV(1)
        Y=ZY*COSZ+ZX*SINZ+YV(1)
      ENDIF
      END

      SUBROUTINE TXYZRZ(X1,Y1,Z1,X2,Y2,Z2,X,Y,Z,RD,ZD)
c
c 1 - celo valcoveho otvoru (souradnice cela kolimatoru)
c 2 - libovolny bod za kolimacnim otvorem
c x,y,z - bod v nemz je umisten zaric s jednotkovou aktivitou
c rd - vypoctena vzdalenost od osy otvoru kolimatoru
c zd - vypoctena vzdalenost od roviny cela
c
      TK=((X-X1)*(X2-X1)+(Y-Y1)*(Y2-Y1)+(Z-Z1)*(Z2-Z1))/
     /   ((X2-X1)**2+(Y2-Y1)**2+(Z2-Z1)**2)
      XK=(X2-X1)*TK+X1
      YK=(Y2-Y1)*TK+Y1
      ZK=(Z2-Z1)*TK+Z1
      RD=SQRT((XK-X)**2+(YK-Y)**2+(ZK-Z)**2)
      ZD=SQRT((XK-X1)**2+(YK-Y1)**2+(ZK-Z1)**2)
      END

      SUBROUTINE SIDESIGN(X1,Y1,X2,Y2,X,Y,D)
C Orientovana vzdalenost bodu X,Y od primky dane dvema body
      D=(Y-Y1)*(X2-X1)-(X-X1)*(Y2-Y1)
      END

      SUBROUTINE DIST(X1,Y1,Z1,X2,Y2,Z2,X,Y,Z,DISTANCE)
C Vzdalenost bodu X,Y,Z od primky urcene dvema body
      DX=X2-X1
      DY=Y2-Y1
      DZ=Z2-Z1
      T=((X-X1)*DX+(Y-Y1)*DY+(Z-Z1)*DZ)/(DX**2+DY**2+DZ**2)
      XP=X1+T*DX
      YP=Y1+T*DY
      ZP=Z1+T*DZ
      DISTANCE=SQRT((X-XP)**2+(Y-YP)**2+(Z-ZP)**2)
      END

      SUBROUTINE VGAUS(NGAUS,NGSS,G1,G2,G3,WT)
C Ctyrsten 3D ELEMENT
      DIMENSION G1(*),G2(*),G3(*),WT(*)
      NGSS=NGAUS
      SELECT CASE(NGAUS)
      CASE(1)
           G1(1)=.25
           G2(1)=.25
           G3(1)=.25
           WT(1)=1
      CASE(4)
           G1(1:4)=(/.5854102,.1381966,.1381966,.1381966/)
           G2(1:4)=(/.1381966,.5854102,.1381966,.1381966/)
           G3(1:4)=(/.1381966,.1381966,.5854102,.1381966/)
           WT(1:4)=(/.25,.25,.25,.25/)
      CASE DEFAULT
           NGSS=5
           G1(1:5)=(/.25,.3333333,.16666666,.16666666,.16666666/)
           G2(1:5)=(/.25,.16666666,.3333333,.16666666,.16666666/)
           G1(1:5)=(/.25,.16666666,.16666666,.16666666,.3333333/)
           WT(1:5)=(/-.8,.45,.45,.45,.45/)
      ENDSELECT
      END

      SUBROUTINE SGAUS(NGAUS,NGSS,G1,G2,G3,WT,G,W)
C SOLID 3D ELEMENT
      DIMENSION G1(*),G2(*),G3(*),WT(*),G(4),W(4)
      IF(NGAUS.EQ.2)THEN
         G(1:2)=(/-.57735,.57735/)
         W(1:2)=(/1.,1./)
      ELSEIF(NGAUS.EQ.3)THEN
         G(1:3)=(/-.77459666,0.,.77459666/)
         W(1:3)=(/.5555555,.8888888,.555555/)
      ELSE
         NGAUS=1
         G(1)=0.
         W(1)=2.
      ENDIF
      NGSS=0
      DO I=1,NGAUS
        DO J=1,NGAUS
          DO K=1,NGAUS
              NGSS=NGSS+1
              G1(NGSS)=G(I)
              G2(NGSS)=G(J)
              G3(NGSS)=G(K)
              WT(NGSS)=W(I)*W(J)*W(K)
          ENDDO
        ENDDO
      ENDDO
      END

      SUBROUTINE TGAUS(NGAUS,NGSS,G1,G2,WT)
C TROJUHELNIKOVY ELEMENT
      DIMENSION G1(*),G2(*),WT(*)
      NGSS=NGAUS
      IF(NGAUS.EQ.3)THEN
           G1(1:3)=(/.5,.0,0.5/)
           G2(1:3)=(/.5,.5,0./)
           WT(1:3)=(/.3333333,.3333333,.3333333/)
      ELSEIF(NGAUS.EQ.4)THEN
           G1(1:4)=(/.3333333,11./15.,2./15.,2./15./)
           G2(1:4)=(/.3333333,2./15.,11./15.,2./15./)
           WT(1:4)=(/-27./48.,25./48.,25./48.,25./48./)
      ELSEIF(NGAUS.EQ.6)THEN
           G1(1:6)=(/.816847572980459,.091576213509771,.091576213509771,
     /             .108103018168070,.445948490915965,.445948490915965/)
           G2(1:6)=(/.091576213509771,.816847572980459,.091576213509771,
     /             .445948490915965,.108103018168070,.445948490915965/)
           WT(1:6)=(/.109951743655322,.109951743655322,.109951743655322,
     /              .223381589678011,.223381589678011,.223381589678011/)
      ELSEIF(NGAUS.EQ.7)THEN
           G1(1:7)=(/.3333333,.05971587,.47014206,.47014206,.79742699,
     /               .10128651,.10128651/)
           G2(1:7)=(/.3333333,.47014206,.05971587,.47014206,.10128651,
     /               .79742699,.10128651/)
           WT(1:7)=(/.225,.13239415,.13239415,.13239415,.12593918,
     /               .12593918,.12593918/)
      ELSEIF(NGAUS.EQ.12)THEN
          G1(1:12)=(/.873821971016996,.063089014491502,.063089014491502,
     /               .501426509658179,.249286745170910,.249286745170910,
     /               .636502499121399,.636502499121399,.310352451033785,
     /              .310352451033785,.053145049844816,.053145049844816/)
          G2(1:12)=(/.063089014491502,.873821971016996,.063089014491502,
     /               .249286745170910,.501426509658179,.249286745170910,
     /               .310352451033785,.053145049844816,.636502499121399,
     /              .053145049844816,.636502499121399,.310352451033785/)
          WT(1:12)=(/.050844906370207,.050844906370207,.050844906370207,
     /               .116786275726379,.116786275726379,.116786275726379,
     /               .082851075618374,.082851075618374,.082851075618374,
     /              .082851075618374,.082851075618374,.082851075618374/)
      ELSEIF(NGAUS.EQ.16)THEN
          G1(1:16)=(/1./3.,.658861384496478,.170569307751761,
     /              .170569307751761,.898905543365938,.050547228317031,
     /              .050547228317031,.081414823414554,.459292588292723,
     /              .459292588292723,.008394777409958,.008394777409958,
     /              .263112829634638,.263112829634638,.728492392955404,
     /              .728492392955404/)
          G2(1:16)=(/1./3.,.170569307751761,.658861384496478,
     /              .170569307751761,.050547228317031,.898905543365938,
     /              .050547228317031,.459292588292723,.081414823414554,
     /              .459292588292723,.263112829634638,.728492392955404,
     /              .008394777409958,.728492392955404,.008394777409958,
     /              .263112829634638/)
          WT(1:16)=(/.144315607677787,.103217370534718,.103217370534718,
     /              .103217370534718,.032458497623198,.032458497623198,
     /              .032458497623198,.095091634267284,.095091634267284,
     /              .095091634267284,.027230314174435,.027230314174435,
     /              .027230314174435,.027230314174435,.027230314174435,
     /              .027230314174435 /)
      ELSE
           NGSS=1
           G1(1)=0.3333333
           G2(1)=0.3333333
           WT(1)=1.
      ENDIF
      END

      SUBROUTINE QGAUS(NGAUS,NGSS,G1,G2,WT)
C CTYRUHELNIKOVY ELEMENT
      DIMENSION G1(*),G2(*),WT(*),G(4),W(4)
      IF(NGAUS.EQ.2)THEN
           G(1:2)=(/-.57735,.57735/)
           W(1:2)=(/1.,1./)
      ELSEIF(NGAUS.EQ.3)THEN
           G(1:3)=(/-.77459666,0.,.77459666/)
           W(1:3)=(/.5555555,.8888888,.555555/)
      ELSEIF(NGAUS.EQ.4)THEN
           G(1:4)=(/-0.86113631,-0.33998104,0.33998104,0.86113631/)
           W(1:4)=(/0.34785484,0.65214515,0.65214515,0.34785484/)
      ELSE
           NGAUS=1
           G(1)=0.
           W(1)=2.
      ENDIF
      NGSS=0
      DO I=1,NGAUS
         DO J=1,NGAUS
            NGSS=NGSS+1
            G1(NGSS)=G(I)
            G2(NGSS)=G(J)
            WT(NGSS)=W(I)*W(J)
         ENDDO
      ENDDO
      END

      SUBROUTINE CHECK(IERR,K9,K10,IOBR)
C
C Testovani parametru potrebnych pro operace 21 AZ 27
C Vysledky se zapisuji na zarizeni K10 (chyby), a K9 (informace)
C Vystupni parametr IOBR slouzi k tomu, aby bylo eventualne mozne
C vykreslit ikonu odpovidajici provadenemu typu analyzy.
C
      INCLUDE '$FEMEQ'
      DIMENSION NELET(MAXELEM,4),NFIXDOF(MAXTDOF),NLOADOF(MAXTDOF),
     /          METODA(MAXMET),METYPE(MAXELEM),MRCOUNT(MAXMRCONS)
      CHARACTER*30 TDMETHOD(MAXMET)
      LOGICAL FLOWPIPE,FLOW2D,SHEVRON,PLANE
      EQUIVALENCE 
     /(LFTERM,NFIXDOF($TEMP)),(LLTERM,NLOADOF($TEMP)),
     /(LFPRES,NFIXDOF($PRES)),(LLPRES,NLOADOF($PRES)),
     /(LFVX,NFIXDOF($VX)),(LLVX,NLOADOF($VX)),
     /(LFVY,NFIXDOF($VY)),(LLVY,NLOADOF($VY)),
     /(LFPS,NFIXDOF($PS)),(LLPS,NLOADOF($PS)),
     /(LFOMG,NFIXDOF($OMG)),(LLOMG,NLOADOF($OMG)),
     /(LFPSX,NFIXDOF($PSX)),(LLPSX,NLOADOF($PSX)),
     /(LFPSY,NFIXDOF($PSY)),(LLPSY,NLOADOF($PSY)),
     /(LFVOLT,NFIXDOF($VOLT)),(LLVOLT,NLOADOF($VOLT)),
     /(LFCONC,NFIXDOF($CN)),(LLCONC,NLOADOF($CN))

      TMETHOD=(/'UVP ','UVPP','MIKE','PENS','MIDE','PSIN','PSBL',
     /          'CREE','PSOM','CARE','CHEV','STUB','HAIR'/)

      DATA TDMETHOD/
     /'VX,VY,PRES (T6,T4 triangles)  ',
     /'VX,VY,PRES (T6,T4 triangles)  ',
     /'VX,VY,PRES (T6,T4 triangles)  ',
     /'VX,VY  (T3,T6, Q4,Q8 elements)',
     /'VX,VY  (T3,T6, Q4,Q8 elements)',
     /'PS,PSX,PSY (T3 triangles)     ',
     /'PS,PSX,PSY,PSXX,PSYY,PSXY (T3)',
     /'PS,PSX,PSY (T3 triangles)     ',
     /'OMG,PS (T3,T6, Q4,Q8)         ',
     /'OMG,PS (T3,T6, Q4,Q8)         ',
     /'PLATE HEAT EXCHANGER CHEVRON  ',
     /'SHELL AND TUBE HEAT ECHANGER  ',
     /'HAIRPIN HEAT ECHANGER         '/
      WRITE(K9,'(/1X,30(''-''),''CHECK SOLVE'')')
      IERR=0
C POCTY ELEMENTU SE 2,3,4,6,8 UZLY
      ND2=0
      NELET=0
C Pocty elementu METYPE(ityp), dle nazvu elementu
      METYPE=0
      METODA=0
      MESTAT=0
      MEAXIS=0
      MEFI=0
      MESOURH=0
      MESOURN=0
      MESOURD=0
      MESOURA=0
      MRCOUNT=0
      MHESHEL=0
      DO I=1,NE
        M=IABS(MUE(I))
        L=LUE(I)
        IF(L.GE.0)THEN
          I0=IUE(L+1)
          DO J=2,M
            IF(IUE(L+J).NE.I0)GOTO 666
          ENDDO
          WRITE(K9,'('' EQUAL NODES IN ELEMENT'',I7)')I
        ENDIF
666     IG=IGROUP(I)
        IRC=IRCONS(I)
        IMP=IMPROP(I)
        IF(IRC.GT.0.AND.IRC.LE.MRCONS)MRCOUNT(IRC)=MRCOUNT(IRC)+1
        IF(IG.GT.0.AND.IRC.GT.0.AND.IMP.GT.0)THEN
C MATERIALOVE PARAMETRY
          VISC=RMPROP(IMP,$VISC)
          RKAP=RMPROP(IMP,$KAPPA)
          EX=RMPROP(IMP,$E)
          RKX=RMPROP(IMP,$KX)
          DN=RMPROP(IMP,$DN)
C REALNE KONSTANTY
          H=RRCONS(IRC,$H)
          D=RRCONS(IRC,$D)
          P=RRCONS(IRC,$P)
          ALFA=RRCONS(IRC,$ALFA)
          AREA=RRCONS(IRC,$AREA)
          IF(JGROUP(IG,$ST).GT.0)MESTAT=MESTAT+1
          IF(JGROUP(IG,$AXIS).GT.0)MEAXIS=MEAXIS+1
          IF(JGROUP(IG,$FI).GT.0)MEFI=MEFI+1
          IF(JGROUP(IG,$HEAT).GT.0)MESOURH=MESOURH+1
          IF(JGROUP(IG,$NSOURCE).GT.0)MESOURN=MESOURN+1
          IF(JGROUP(IG,$DSOURCE).GT.0)MESOURD=MESOURD+1
          IF(JGROUP(IG,$ASOURCE).GT.0)MESOURA=MESOURA+1
          ITE=JGROUP(IG,$ENAME)
          IF(ITE.GT.0)THEN
             METYPE(ITE)=METYPE(ITE)+1
             IF(M.GE.2)THEN
                NNU=MIN0(5,M)-1
                NELET(ITE,NNU)=NELET(ITE,NNU)+1
             ENDIF
             SELECT CASE(ITE)
             CASE($PIPE2D,$PIPE3D,$CSTR,$PUMP,$VALVE)
                IF(M.NE.2.AND.IERR.EQ.0)THEN
                   WRITE(K10,120)M,I
120   FORMAT(' ERROR number of nodes',I2,' in E',i6,' (PIPE,CSTR,PUMP)')
                   IERR=20
                ENDIF
                IF(D.LE.0..AND.IERR.EQ.0)THEN
                   WRITE(K10,131)IRC
131   FORMAT(' ERROR parameter in RCONs group',i3,' PIPE,CSTR,PUMP (D)')
                   IERR=31
                ENDIF
             CASE($HEXC)
                IF(M.NE.4.AND.IERR.EQ.0)THEN
                   WRITE(K10,121)M,I
121   FORMAT(' ERROR number of nodes',I2,' in E',i6,' (HEXC)')
                   IERR=21
                ENDIF
                IF((AREA.LE.0..OR.ALFA.LE.0.).AND.IERR.EQ.0)THEN
                   WRITE(K10,130)IRC
130   FORMAT(' ERROR parameter in RCONS group',I3,' HEXC (area,alpha)')
                   IERR=30
                ENDIF
                MET=JGROUP(IG,$METHOD)
                IF(MET.EQ.$CHEV.OR.MET.EQ.$STUB)MHESHEL=MHESHEL+1
             CASE($TRUSS2D,$TRUSS3D,$BEAM2D,$BEAM3D,$SHELLAX)
                IF(M.NE.2.AND.IERR.EQ.0)THEN
                   WRITE(K10,122)M,I
122   FORMAT(' ERROR number of nodes',I2,' in E',i6,' (TRUSS,BEAM,SHELLA
     /X)')
                   IERR=22
                ENDIF
             CASE($PLANE2D,$FLOW2D)
                IF(M.LT.3.AND.IERR.EQ.0)THEN
                   WRITE(K10,123)M,I
123   FORMAT(' ERROR number of nodes',I2,' in E',i6,' (PLANE,FLOW2D)')
                   IERR=23
                ENDIF
                ND2=1
             END SELECT
          ENDIF
          IF(IERR.EQ.0)THEN
             IF(IALGOR($ELEC+20).GT.0.AND.RKAP.LE.0.)THEN
                IERR=110
                WRITE(K10,110)IMP
110   FORMAT(' ERROR parameter in MPROP group',I3,' KAPPA (Electric)')
             ENDIF
             IF(IALGOR($FLOW+20).GT.0.AND.VISC.LE.0.)THEN
                IERR=111
                WRITE(K10,111)IMP
111   FORMAT(' ERROR parameter in MPROP group',I3,' VISC (Flow)')
             ENDIF
             IF(IALGOR($THER+20).GT.0.AND.RKX.LE.0.)THEN
                IERR=112
                WRITE(K10,112)IMP
112   FORMAT(' ERROR parameter in MPROP group',I3,' KX (Thermal)')
             ENDIF
             IF(IALGOR($CONC+20).GT.0.AND.DN.LE.0..AND.
     /                                     $IHEPI.LE.1)THEN
                IERR=113
                WRITE(K10,113)IMP
113   FORMAT(' ERROR parameter in MPROP group',I3,' DN (Concentration)')
             ENDIF
             IF(IALGOR($STAT+20).GT.0.AND.EX.LE.0.)THEN
                IERR=114
                WRITE(K10,114)IMP
114   FORMAT(' ERROR parameter in MPROP group',I3,' EX (Stress anal.)')
             ENDIF
          ENDIF
          IME=JGROUP(IG,$METHOD)
          IF(IME.GT.0.AND.IME.LE.MAXMET.AND.
     /        JGROUP(IG,$ENAME).EQ.$FLOW2D)METODA(IME)=METODA(IME)+1
        ELSEIF(IERR.EQ.0)THEN
          WRITE(K10,'('' ERROR in Egroup,Rconst or Mprop index of elemen
     /t'',i6)')I
          IERR=1
        ENDIF
      ENDDO
C Odhad typu analyzy
      FLOWPIPE=.FALSE.
      FLOW2D=.FALSE.  
      PLANE=.FALSE.
      SHEVRON=.FALSE.
      IF(METYPE($PIPE2D).GT.0.OR.METYPE($HEXC).GT.0)FLOWPIPE=.TRUE.
      IF(METYPE($FLOW2D).GT.0)FLOW2D=.TRUE.
      IF(METYPE($PLANE2D).GT.0)PLANE=.TRUE.
      IF(MHESHEL.GT.0)SHEVRON=.TRUE.
C Zobrazeni ikony okna DIALOG
      IF(FLOWPIPE)THEN
        IF(SHEVRON)THEN
          IOBR=1
        ELSE
          IOBR=2
        ENDIF
        IF($IHEPI.GT.1)IOBR=3
      ENDIF
      IF(PLANE) IOBR=4
      IF(FLOW2D)THEN
        IF($IHEPI.GT.1)THEN
           IOBR=5
        ELSE
           IOBR=6
        ENDIF
      ENDIF
C
C Vypisy
      WRITE(K9,'('' Elimination treshold='',I2,'' RELFAKT='',F5.2)')
     /IALGOR(7),RALGOR(7)
	IF(IALGOR(7).LE.1)WRITE(K9,'('' PLEASE INCREASE THE ELIMINATION TR
     /ESHOLD!!!'')')
      IF(IALGOR($FLOW).NE.0.OR.IALGOR($THER).NE.0)THEN
        IF($IMASS.NE.0)THEN
         WRITE(K9,'('' Mass matrix enabled'')')
        ELSE
         WRITE(K9,'('' Mass matrix disabled'')')
        ENDIF
        IF($ICONV.NE.0)THEN
         WRITE(K9,'('' Convection enabled (CONV>0)'')')
        ELSE
         WRITE(K9,'('' Convection disabled (CONV=0)'')')
        ENDIF
        IF(FLOW2D.OR.FLOWPIPE)THEN
          IF($IBUOY.NE.0)THEN
            WRITE(K9,'('' Natural convection (BUOY='',I1,'') enabled Gx=
     /'',f6.2,'' Gy='',f6.2,'' Gz='',F6.2)')$IBUOY,$RGX,$RGY,$RGZ
          ELSE
            WRITE(K9,'('' Natural convection (BUOY=0) disabled'')')
          ENDIF
        ENDIF
        IF($ISOURCE.NE.0)THEN
         WRITE(K9,'('' Sources enabled (OHMI>0) HEAT='',I5,'' Cn='',
     /I4,'' Cd='',I4,'' Ca='',I4)')MESOURH,MESOURN,MESOURD,MESOURA
        ELSE
         WRITE(K9,'('' Sources disabled (OHMI=0) HEAT='',I5,'' Cn='',I4,
     /'' Cd='',I4,'' Ca='',I4)')MESOURH,MESOURN,MESOURD,MESOURA
        ENDIF
        IF($IUPW.NE.0)THEN
         WRITE(K9,'('' Upwind enabled Correct='',f8.2)')$RUPW
        ELSE
         WRITE(K9,'('' Upwind disabled (UPW=0)'')')
        ENDIF
        IF(FLOWPIPE)THEN
          IF($IHEPI.EQ.1)THEN
          WRITE(K9,'('' Enthalpy balancig for PIPEs''\)')
          ELSEIF($IHEPI.EQ.2)THEN
          WRITE(K9,'('' Method of characteristics for PIPEs''\)')
          ELSE
          WRITE(K9,'('' Standard MWR for PIPEs''\)')
          ENDIF
          IF($IVOLU.EQ.0)THEN
            WRITE(K9,'('' (mass flowrate balancing in nodes)'')')
          ELSE
            WRITE(K9,'('' (volumetric flow balancing in nodes)'')')
          ENDIF
        ELSEIF($IHEPI.GE.2)THEN
          WRITE(K9,'('' Method of characteristics for 2D enabled using''
     /,i3,'' increments'')')$IHEPI
        ENDIF
      ENDIF
      WRITE(K9,'('' Operats: '',7(A4,I2,'',''))')
     /                         (TOPER(I),IALGOR(20+I),I=1,MAXOPER)

      WRITE(K9,'('' E-NAME   number 2-NODE 3-NODE 4-NODE >4 NODES'')')
      DO I=1,MAXELEM
        IF(METYPE(I).GT.0)WRITE(K9,'(1X,A8,5I7))')
     /                    TELEM(I),METYPE(I),(NELET(I,J),J=1,4)
      ENDDO
      IF(MESTAT.EQ.0)THEN
          WRITE(K9,'('' All elements calculated at STEADY state'')')
      ELSE
          WRITE(K9,'('' Elements calculated as transient'',I8)')MESTAT
      ENDIF
      IF(ND2.NE.0)THEN
        IF(IALGOR(20+$FLOW).GT.0.AND.FLOW2D)THEN
          DO I=1,MAXMET
            IF(METODA(I).GT.0)WRITE(K9,'('' Method '',A,I6,2X,A)')
     /                    TMETHOD(I),METODA(I),TDMETHOD(I)
          ENDDO
        ENDIF
        IF(.NOT.FLOWPIPE)THEN
          IF(MEAXIS.EQ.0)THEN
            WRITE(K9,'('' All elements calculated at XY-Cartesian'')')
          ELSE
            WRITE(K9,'('' Elements calculated in XR-Cylindr.'',I8)')
     /            MEAXIS
          ENDIF
        ENDIF
      ENDIF
      IF(FLOWPIPE)THEN
        IF(MEFI.EQ.0)THEN
          WRITE(K9,'('' No elements with user defined hydr.charact.'')')
        ELSE
          WRITE(K9,'('' Elements with hydraulic charact.'',I8)')MEFI
        ENDIF
      ENDIF
C POCTY UZLOVYCH PARAMETRU, FIXOVANYCH PARAMETRU A ZATIZENI
      NFIXDOF=0
      NLOADOF=0
      DO IND=1,MDOF
         LP=LPU(JPU(IND))
         DO I=1,ND
            LOC=LP+I
            IF(IPU(LOC).LT.0)NFIXDOF(IND)=NFIXDOF(IND)+1
            IF(IPU(LOC).GT.0)NLOADOF(IND)=NLOADOF(IND)+1
         ENDDO
         IF(NFIXDOF(IND).GT.0)WRITE(K9,'('' DOF fixed='',I6.3,'' loaded=
     /'',I6.3,2X,A)')NFIXDOF(IND),NLOADOF(IND),TDOF(JPU(IND))
      ENDDO
      WRITE(K9,'('' Real constants ''\)')
      DO I=1,MRCONS
         WRITE(K9,'('' RC'',I1,I5\)')I,MRCOUNT(I)
      ENDDO
      WRITE(K9,'(/1X,30(''-''),''CHECK ENDS'')')
      END

      SUBROUTINE ATTACH(ICURVE,DISTANCE)
C
C Presun uzlu (1...ND) na krivku ICURVE, pokud je jejich vzdalenost mensi nez DISTANCE
C
	INCLUDE '$FEMEQ'
      DIMENSION X1(3),Y1(3),Z1(3)
C Parametry krivky ICURVE
      N1=MCR(ICURVE)
	DO I=1,N1
	   IND=ICR(I,ICURVE)
	   X1(I)=PTX(IND)
	   Y1(I)=PTY(IND)
	   Z1(I)=PTZ(IND)
	ENDDO
      AX1=X1(1)
      AY1=Y1(1)
      AZ1=Z1(1)
      IF(N1.EQ.2)THEN
        BX1=X1(2)-X1(1)
        BY1=Y1(2)-Y1(1)
        BZ1=Z1(2)-Z1(1)
        CX1=0
        CY1=0
        CZ1=0
      ELSEIF(N1.EQ.3)THEN
        BX1=-3*X1(1)-X1(2)+4*X1(3)
        BY1=-3*Y1(1)-Y1(2)+4*Y1(3)
        BZ1=-3*Z1(1)-Z1(2)+4*Z1(3)
        CX1=2*X1(2)-4*X1(3)+2*X1(1)
        CY1=2*Y1(2)-4*Y1(3)+2*Y1(1)
        CZ1=2*Z1(2)-4*Z1(3)+2*Z1(1)
      ENDIF
C Rozdeleni krivky 1 na NSEG bodu
      NSEG=50
      DT=1./NSEG
C Pro kazdy uzel 1,2,...,ND je treba nalezt nejblizsi bod krivky
C k dispozici jsou vektory XGR(ND) a VGR(ND). 
C Vektor VGR(i) bude nejmensi vzdalenost od krivky a XGR(i) hodnota parametru krivky T1
      VGR=1E10
      DO I1=2,NSEG
        T1=DT*(I1-1)
        T2=T1*T1
        X11=AX1+BX1*T1+CX1*T2
        Y11=AY1+BY1*T1+CY1*T2
        Z11=AZ1+BZ1*T1+CZ1*T2
        DO I=1,ND
          DIST=(XX(I)-X11)**2+(YY(I)-Y11)**2+(ZZ(I)-Z11)**2
	    IF(DIST.LT.VGR(I))THEN
	      XGR(I)=T1
	      VGR(I)=DIST
	    ENDIF
        ENDDO
      ENDDO
C Vyber uzlu ktere nelezi na krivce, ale jsou blizko
	DIST2=DISTANCE**2
	TOL2=$RTOL**2
      DO I=1,ND
	  IF(VGR(I).GT.TOL2.AND.VGR(I).LE.DIST2)THEN
	     T1=XGR(I)
           T2=T1*T1
           XX(I)=AX1+BX1*T1+CX1*T2
           YY(I)=AY1+BY1*T1+CY1*T2
           ZZ(I)=AZ1+BZ1*T1+CZ1*T2
 	     WRITE(10,'('' Node '',I4,'' attached'')')I
        ENDIF
      ENDDO
      END


C ------------------------------------------------------AORTA
C Nazvy modelu odvozene od autora F-Fung, H-Holzapfel, G-Gent

	SUBROUTINE AORTAF(RO,RSI,RSO,RLZ,ALFA,C1,C2,B1,B2,B3,N,WESULT,F)
C Numericka integrace pres tloustku steny dle vztahu L.Horny
C Konstitutivni rovnice W=c1(J-3)+c2.[exp(b1.Et^2+b2.Ez^2+2b3.Et.Ex)-1]
C VSTUP: polomer vnejsi RO
C        RSI,RSO - nezatizena trubice
C        RLZ-axialni stretch
C        ALFA-doplnek uhlu rozevreni (ve stupnich)
C VYSTUP: result - tlak na vnitrnim povrchu [Pa]
C VYSTUP: F      - axialni sila [N]
      PI=3.14159
	NINT=MAX0(10,N)
      THETA=180.-ALFA
	T=THETA/180.*PI
	RDIF2=RO**2-(RSO**2-RSI**2)/rlz
	IF(RDIF2.LE.0.)THEN
	   WESULT=0.
	   RETURN
	ENDIF
	RI=SQRT(RDIF2)
	RRO=.5*(PI/T*(RSO+RSI)+(RSO-RSI))
      DR=(RO-RI)/(NINT-1)
	S=0
	R=RI
C F-axial force
	F=0
	DO I=1,NINT
        RLT=PI*R/(T*SQRT(RRO**2-PI*RLZ/T*(RO**2-R**2)))
	  RLT2=RLT**2-1
	  RLZ2=RLZ**2-1
	  EE=EXP(B1*(RLT2/2)**2+B2*(RLZ2/2)**2+B3/2.*RLT2*RLZ2)
	  DWDE=2*C1*(1-1/(RLT**4*RLZ**2))+C2*(B1*RLT2+B3*RLZ2)*EE
	  DWDEZ=2*C1*(1-1/(RLT**2*RLZ**4))+C2*(B2*RLZ2+B3*RLT2)*EE
	  TERM=RLT**2*DWDE*DR/R
	  TERMF=(2*RLZ**2*DWDEZ-RLT**2*DWDE)*R*DR*3.141
	  IF(I.EQ.1.OR.I.EQ.NINT)THEN
	     TERM=TERM*.5
	     TERMF=TERMF*.5
	  ENDIF
	  S=S+TERM
	  F=F+TERMF
C
        R=R+DR
      ENDDO
	WESULT=S
	END

	SUBROUTINE AORTAH(RO,RSI,RSO,RLZ,ALFA,C1,RK1,RK2,SIN2,N,WESULT,F)
C Numericka integrace neo-Hook+Holzapfel, dle vztahu L.Horny
C Konstitutivni rovnice Holzapfel C1,RK1,RK2, SIN2=(sin beta)^2
C W=c1(J-1)+k1.exp[k2.(lt^2.cos beta^2+lz^2.sin beta^2-1)]
C VSTUP: polomer vnejsi RO
C        RSI,RSO - nezatizena trubice
C        RLZ - axialni stretch
C        ALFA-doplnek uhlu rozevreni (ve stupnich)
C VYSTUP: result - tlak na vnitrnim povrchu
C VYSTUP: F      - axialni sila
      COS2=1-SIN2
      PI=3.14159
	NINT=MAX0(10,N)
      THETA=180.-ALFA
	T=THETA/180.*PI
	RDIF2=RO**2-(RSO**2-RSI**2)/rlz
	IF(RDIF2.LE.0.)THEN
	   WESULT=0.
	   RETURN
	ENDIF
	RI=SQRT(RDIF2)
	RRO=.5*(PI/T*(RSO+RSI)+(RSO-RSI))
      DR=(RO-RI)/(NINT-1)
	S=0
	R=RI
C F-axial force
	F=0
	DO I=1,NINT
        RLT=PI*R/(T*SQRT(RRO**2-PI*RLZ/T*(RO**2-R**2)))
	  RLT2=RLT**2
	  RLZ2=RLZ**2
	  RCS=RLT2*COS2+RLZ2*SIN2-1
	  EE=EXP(RK2*RCS**2)
	  DWDE=2*C1*(RLT2-1/(RLT2*RLZ2))+4*RLT2*RK1*RCS*COS2*EE
	  DWDEZ=2*C1*(RLZ2-1/(RLT2*RLZ2))+4*RLZ2*RK1*RCS*SIN2*EE
	  TERM=DWDE*DR/R
	  TERMF=(2*DWDEZ-DWDE)*R*DR*3.141
	  IF(I.EQ.1.OR.I.EQ.NINT)THEN
	     TERM=TERM*.5
	     TERMF=TERMF*.5
	  ENDIF
	  S=S+TERM
	  F=F+TERMF
C
        R=R+DR
      ENDDO
	WESULT=S
	END

	SUBROUTINE AORTAG(RO,RSI,RSO,RLZ,ALFA,MJU,JM,SIN2,WESULT,F)
C Analyticke reseni modifikovany ortotropni Gent, dle vztahu L.Horny
C Konstitutivni rovnice Gent Jm, mju, SIN2=(sin beta)^2
C       W=-mju.Jm/2.ln(1-(I4-1)^2/Jm^2) povodne
C       W=-mju.Jm.ln(1-(I4-1)^2/Jm^2)   doufam, ze bez dvojky

C VSTUP: polomer vnejsi RO
C        RSI,RSO - nezatizena trubice
C        RLZ - axialni stretch
C        ALFA-doplnek uhlu rozevreni (ve stupnich)
C VYSTUP: result - tlak na vnitrnim povrchu
C VYSTUP: F      - axialni sila
	REAL MJU,JM,MU
	REAL*8 AA,A,P1,P2,T1,L1,J0,J1,J2,JP,PA,PB,PI,DAL,DAL2,D,D2,DKZ,DDZ
     #,RD,U,RSO2,RSI2,RO2,R1,R2,R3
	IF(SIN2.LT.0..OR.SIN2.GT.0.999)THEN
	    WRITE(10,'('' ERROR SIN BETA PARAMETER'')')
	    RETURN
	ENDIF
	IF(JM.LT.0.1.OR.JM.GT.100.)THEN
	    WRITE(10,'('' ERROR JM PARAMETER (SHOULD BE <100)'')')
	    RETURN
	ENDIF

C Horny maple 13.5.2008
      pi=3.14159
      mu=mju
	alpha=alfa
      WESULT=PI*mu * Jm * dble(1 - sin2) / (-PI
     # * dble(1 - sin2) + Jm * PI * dal * rlz 
     #/ 0.180D3 - rlz ** 3 * dble(sin2) * PI * dble(180 - al
     #pha) / 0.180D3 + PI * dal * rlz / 0.180D
     #3) * log(Jm * PI ** 2 * dble((180 - alpha) ** 2) * RSO
     # ** 2 / 0.32400D5 - PI ** 2 * RO ** 2 * dble(1 - sin2)
     # - rlz ** 2 * dble(sin2) * PI ** 2 * dble((180 - alpha
     #) ** 2) * RSO ** 2 / 0.32400D5 + RSO ** 2 * PI ** 2 * 
     #dble((180 - alpha) ** 2) / 0.32400D5) - PI * mu * Jm *
     # dble(1 - sin2) / (PI * dble(1 - sin2) + Jm * 0.314159
     #2654D1 * dal * rlz / 0.180D3 + rlz ** 3 * dble(sin2)
     # * PI * dal / 0.180D3 - PI *
     # dal * rlz / 0.180D3) * log(Jm * PI ** 2
     # * dble((180 - alpha) ** 2) * RSO ** 2 / 0.32400D5 + 0.3141592654D
     #1 ** 2 * RO ** 2 * dble(1 - sin2) + rlz ** 2 * dble(sin2) * 0.3141
     #592654D1 ** 2 * dble((180 - alpha) ** 2) * RSO ** 2 / 0.32400D5 - 
     #RSO ** 2 * PI ** 2 * dble((180 - alpha) ** 2) / 0.3240
     #0D5) - PI * mu * Jm * dble(1 - sin2) / (-0.3141592654D
     #1 * dble(1 - sin2) + Jm * PI * dal * rlz
     # / 0.180D3 - rlz ** 3 * dble(sin2) * PI * dble(180 - a
     #lpha) / 0.180D3 + PI * dal * rlz / 0.180
     #D3) * log(Jm * PI ** 2 * dble((180 - alpha) ** 2) * RS
     #O ** 2 / 0.32400D5 - Jm * PI ** 2 * dal 
     #* rlz * RO ** 2 / 0.180D3 + Jm * PI ** 2 * dble(180 - 
     #alpha) * rlz * (RO ** 2 - dal / rlz * (RSO ** 2 - RS
     #I ** 2) / 0.180D3) / 0.180D3 - PI ** 2 * (RO ** 2 - db
     #le(180 - alpha) / rlz * (RSO ** 2 - RSI ** 2) / 0.180D3) * dble(1 
     #- sin2) - rlz ** 2 * dble(sin2) * PI ** 2 * dble((180 
     #- alpha) ** 2) * RSO ** 2 / 0.32400D5 + rlz ** 3 * dble(sin2) * 0.
     #3141592654D1 ** 2 * dal * RO ** 2 / 0.180D3 - rlz **
     # 3 * dble(sin2) * PI ** 2 * dal * (RO **
     # 2 - dal / rlz * (RSO ** 2 - RSI ** 2) / 0.180D3) / 
     #0.180D3 + RSO ** 2 * PI ** 2 * dble((180 - alpha) ** 2
     #) / 0.32400D5 - PI ** 2 * dal * rlz * RO
     # ** 2 / 0.180D3 + PI ** 2 * dal * rlz * 
     #(RO ** 2 - dal / rlz * (RSO ** 2 - RSI ** 2) / 0.180
     #D3) / 0.180D3) + PI * mu * Jm * dble(1 - sin2) / (0.31
     #41592654D1 * dble(1 - sin2) + Jm * PI * dble(180 - alp
     #ha) * rlz / 0.180D3 + rlz ** 3 * dble(sin2) * PI * dbl
     #e(180 - alpha) / 0.180D3 - PI * dal * rl
     #z / 0.180D3) * log(Jm * PI ** 2 * dble((180 - alpha) *
     #* 2) * RSO ** 2 / 0.32400D5 - Jm * PI ** 2 * dble(180 
     #- alpha) * rlz * RO ** 2 / 0.180D3 + Jm * PI ** 2 * db
     #le(180 - alpha) * rlz * (RO ** 2 - dal / rlz * (RSO 
     #** 2 - RSI ** 2) / 0.180D3) / 0.180D3 + PI ** 2 * (RO 
     #** 2 - dal / rlz * (RSO ** 2 - RSI ** 2) / 0.180D3) 
     #* dble(1 - sin2) + rlz ** 2 * dble(sin2) * PI ** 2 * d
     #ble((180 - alpha) ** 2) * RSO ** 2 / 0.32400D5 - rlz ** 3 * dble(s
     #in2) * PI ** 2 * dal * RO ** 2 / 0.180D3
     # + rlz ** 3 * dble(sin2) * PI ** 2 * dal
     # * (RO ** 2 - dal / rlz * (RSO ** 2 - RSI ** 2) / 0.
     #180D3) / 0.180D3 - RSO ** 2 * PI ** 2 * dble((180 - al
     #pha) ** 2) / 0.32400D5 + PI ** 2 * dal *
     # rlz * RO ** 2 / 0.180D3 - PI ** 2 * dal
     # * rlz * (RO ** 2 - dal / rlz * (RSO ** 2 - RSI ** 2
     #) / 0.180D3) / 0.180D3)

C F-axial force
      dal=dble(180-alpha)
	dal2=dble(dal**2)
	u=0.18d3
	rso2=rso**2
	rsi2=rsi**2
	ro2=ro**2
	r1=rlz**2
	r2=rso2/0.324d5
	r3=rlz**3
	d2=dal2/0.324d5
	d=0.1d1
	p2=pi**2
	j2=jm**2
	jp=jm*p2
	rd=(rso2-rsi2)
	dkz=dal*rlz
	ddz=dal/rlz

	F=PI*(mu/(Jm*PI*dal *rlz/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)
     #/(Jm*PI*dal *rlz/U-R3*sin2*0.3141592654D1*dal/U-PI*(D-sin2)+
     #PI*DKZ/U)*RO2*P2*(D-sin2)*R3*sin2*dal/0.45D2-0.2D1*mu /(Jm*PI*DKZ/
     #U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)/(Jm*PI*DKZ/U-R3*sin2*PI*
     #dal/U-PI*(D-sin2)+PI*DKZ/U)*RO2*P2*(D-sin2)**2*Jm+mu/ (Jm*PI*DKZ/U
     #+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)/
     #(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*RO2*rlz**6*
     #sin2**2*P2*dal2/0.8100D4-mu/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+
     #PI*(D-sin2)-PI*DKZ/U)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI
     #*DKZ/U)*RO2*R3*sin2*P2*dal*Jm*(D-sin2)/0.90D2-mu/(Jm*PI*DKZ/U+R3*
     #sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-
     #PI*(D-sin2)+PI*DKZ/U)*RO2*P2*dal2*rlz**4*sin2/0.8100D4+
     #mu/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)/(Jm*PI*DKZ/
     #U-R3*sin2*PI*dal/U-PI*(D-sin2) +PI*DKZ/U)*RO2*P2*DKZ*Jm*(D-sin2)/
     #0.90D2-mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/0.90D2+R3*sin2*PI*dal/0.90D2
     #+0.2D1*PI*(D-sin2)-PI*DKZ/0.90D2) /(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+
     #PI*(D-sin2)-PI*DKZ/U)*log(JP*dal2*R2+P2*RO2*(D-sin2)+R1*sin2*P2*
     #dal2*R2-RSO2*P2*D2)*J2*RSO2/0.16200D5+mu*P2*dal*(D-sin2)/
     #(Jm*PI*DKZ/0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*PI*(D-sin2)-PI*DKZ/
     #0.90D2)/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)
     #-PI*DKZ/U)*log(JP*dal2*R2+P2*RO2*(D-sin2)+R1*sin2*P2*dal2*R2-RSO2*
     #P2*D2)*J2*rlz*RO2/0.90D2+mu*P2*dal*
     #(D-sin2)/(Jm*PI*DKZ/0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*PI*(D-sin2)
     #-PI*DKZ/0.90D2)/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U
     #)*log(JP*dal2*R2+P2*RO2*(D-sin2)+R1*sin2*P2*dal2*R2-RSO2*P2*D2)*Jm
     #*R3*sin2*RO2/0.90D2-mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/0.90D2+R3*sin2*
     #PI*dal/0.90D2+ 0.2D1*PI*(D-sin2)-
     #PI*DKZ/0.90D2)/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)
     #*log(JP*dal2*R2+P2*RO2*(D-sin2)+R1*sin2*P2*dal2*R2-RSO2*P2*D2)*Jm*
     #R1*sin2*RSO2/0.16200D5-mu*P2*dal*(D-sin2)/(Jm*PI*DKZ/0.90D2+R3*sin
     #2*PI*dal/0.90D2+0.2D1*PI*(D-sin2)-PI*DKZ/0.90D2)/(Jm*PI*DKZ/U+R3*
     #sin2*PI*dal/U+ PI*(D-sin2) -PI*DKZ/U)*log(JP*dal2*R2+
     #P2*RO2*(D-sin2)+R1*sin2*P2*dal2*R2-RSO2*P2*D2)*Jm*rlz*RO2/0.90D2+
     #mu*P2*dal2*(D- sin2) / 
     #(Jm*PI*DKZ/0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*PI*(D-sin2)-PI*DKZ/
     #0.90D2)/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+
     #PI*(D-sin2)-PI*DKZ/U)*log(JP*dal2*R2+P2*RO2*(D-sin2)+ R1*sin2*P2*
     #dal2*R2- RSO2*P2*D2)*Jm*RSO2/0.16200D5+mu*P2*dal*(D-sin2)/(Jm*PI*
     #DKZ/0.90D2+ R3*sin2*PI*dal/0.90D2+ 0.2D1*PI*(D-sin2)-
     #PI*DKZ/0.90D2)/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)
     #* log(JP*dal2*R2+P2*RO2*(D-sin2)+R1*sin2*P2*dal2*R2-
     #RSO2*P2*D2)*R3*sin2*RO2/0.45D2-mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/
     #0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*PI*(D-sin2)-
     #PI*DKZ/0.90D2)/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)
     #*log(JP*dal2*R2+P2*RO2*(D-sin2)+R1*sin2*P2*dal2*R2-
     #RSO2*P2*D2)*R1*sin2*RSO2/0.8100D4+mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/
     #0.90D2-R3*sin2*PI*dal/0.90D2-0.2D1*PI*(D-sin2)+PI*DKZ/0.90D2)/(Jm*
     #PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*log(JP*dal2*R2-P2*
     #RO2*(D-sin2)-R1*sin2*P2*dal2*R2+RSO2*P2*D2)*J2*RSO2/0.16200D5-mu*
     #P2*dal*(D-sin2)/(Jm*PI*DKZ/0.90D2-R3*sin2*PI*dal/0.90D2-0.2D1*PI*
     #(D-sin2)+PI*DKZ/0.90D2)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+
     #PI*DKZ/U)*log(JP*dal2*R2-P2*RO2*(D-sin2)-R1*sin2*P2*dal2*R2+RSO2*
     #P2*D2)*J2*rlz*RO2/0.90D2+mu*P2*dal*(D-sin2)/(Jm*PI*DKZ/0.90D2-R3*
     #sin2*PI*dal/0.90D2-0.2D1*PI*(D-sin2)+PI*DKZ/0.90D2)/(Jm*PI*DKZ/U-
     #R3*sin2*PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*log(JP*dal2*R2-P2*RO2*(D-
     #sin2)-R1*sin2*P2*dal2*R2+RSO2*P2*D2)*Jm*R3*sin2*RO2/0.90D2-mu*P2*
     #dal2*(D-sin2)/(Jm*PI*DKZ/0.90D2-R3*sin2*PI*dal/0.90D2-0.2D1*PI*(D-
     #sin2)+PI*DKZ/0.90D2)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-
     #PI*(D-sin2)+PI*DKZ/U)*log(JP*dal2*R2-P2*RO2*(D-sin2)-R1*sin2*P2*
     #dal2*R2+RSO2*P2*D2)*Jm*R1*sin2*RSO2/0.16200D5-mu*P2*dal*(D-sin2)/
     #(Jm*PI*DKZ/0.90D2-R3*sin2*PI*dal/0.90D2-0.2D1*PI*(D-sin2)+PI*DKZ/
     #0.90D2)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*
     #log(JP*dal2*R2-P2*RO2*(D-sin2)-R1*sin2*P2*dal2*R2+RSO2*P2*D2)*Jm*
     #rlz*RO2/0.90D2+mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/0.90D2-R3*sin2*PI*
     #dal/0.90D2-0.2D1*PI*(D-sin2)+PI*DKZ/0.90D2)/(Jm*PI*DKZ/U-R3*sin2*
     #PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*log(JP*dal2*R2-P2*RO2*(D-sin2)-
     #R1*sin2*P2*dal2*R2+RSO2*P2*D2)*Jm*RSO2/0.16200D5+mu*P2*dal*
     #(D-sin2)/(Jm*PI*DKZ/0.90D2-R3*sin2*PI*dal/0.90D2-0.2D1*PI*(D-sin2)
     #+PI*DKZ/0.90D2)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+
     #PI*DKZ/U)*log(JP*dal2*R2-P2*RO2*(D-sin2)-R1*sin2*P2*dal2*R2+RSO2*
     #P2*D2)*R3*sin2*RO2/0.45D2-mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/0.90D2-R3
     #*sin2*PI*dal/0.90D2-0.2D1*PI*(D-sin2)+PI*DKZ/0.90D2)/(Jm*PI*DKZ/U-
     #R3*sin2*PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*log(JP*dal2*R2-P2*RO2*
     #(D-sin2)-R1*sin2*P2*dal2*R2+RSO2*P2*D2)*R1*sin2*RSO2/0.8100D4)-PI*
     #(mu/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)/(Jm*PI*DKZ
     #/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*(RO2-DDZ*RD/U)*P2*
     #(D-sin2)*R3*sin2*dal/0.45D2-0.2D1*mu/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U
     #+PI*(D-sin2)-PI*DKZ/U)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+
     #PI*DKZ/U)*(RO2-DDZ*RD/U)*P2*(D-sin2)**2*Jm+mu/(Jm*PI*DKZ/U+R3*sin2
     #*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*
     #(D-sin2)+PI*DKZ/U)*(RO2-DDZ*RD/U)*rlz**6*sin2**2*P2*dal2/0.8100D4-
     #mu/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-
     #PI*DKZ/U)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*(RO2
     #-DDZ*RD/U)*R3*sin2*P2*dal*Jm*(D-sin2)/0.90D2-mu/(Jm*PI*DKZ/U+R3*
     #sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-
     #PI*(D-sin2)+PI*DKZ/U)*(RO2-
     #DDZ*RD/U)*P2*dal2*rlz**4*sin2/0.8100D4+mu/(Jm*PI*DKZ/U+R3*sin2*PI*
     #dal/U+PI*(D-sin2)-PI*DKZ/U)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-
     #sin2)+PI*DKZ/U)*(RO2-DDZ*RD/U)*P2*DKZ*Jm*(D-sin2)/0.90D2-mu*P2*
     #dal2*(D-sin2)/(Jm*PI*DKZ/0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*PI*(D-
     #sin2)-PI*DKZ/0.90D2)/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*
     #DKZ/U)*log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-
     #DDZ*RD/U)/U+P2*(RO2-DDZ*RD/U)*(D-sin2)+R1*sin2*P2*dal2*R2-R3*sin2*
     #P2*dal*RO2/U+R3*sin2*P2*dal*(RO2-DDZ*RD/U)/U-RSO2*P2*D2+P2*DKZ*RO2
     #/U-P2*DKZ*(RO2-
     #DDZ*RD/U)/U)*J2*RSO2/0.16200D5+mu*P2*dal*(D-sin2)/(Jm*PI*DKZ/
     #0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*PI*(D-sin2)-PI*DKZ/0.90D2)/(Jm*
     #PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-
     #PI*DKZ/U)*log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-DDZ*RD/U)/U+P2*
     #(RO2-DDZ*RD/U)*(D-sin2)+R1*sin2*P2*dal2*R2-R3*sin2*P2*dal*RO2/U+R3
     #*sin2*P2*dal*(RO2-DDZ*RD/U)/U-
     #RSO2*P2*D2+P2*DKZ*RO2/U-P2*DKZ*(RO2-DDZ*RD/U)/U)*J2*rlz*RO2/0.90D2
     #+mu*P2*dal*(D-sin2)/(Jm*PI*DKZ/0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*
     #PI*(D-sin2)-PI*DKZ/0.90D2)/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*
     #(D-sin2)-
     #PI*DKZ/U)*log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-DDZ*RD/U)/U+P2*
     #(RO2-DDZ*RD/U)*(D-sin2)+R1*sin2*P2*dal2*R2-R3*sin2*P2*dal*RO2/U+R3
     #*sin2*P2*dal*(RO2-DDZ*RD/U)/U-RSO2*P2*D2+P2*DKZ*RO2/U-P2*DKZ*(RO2-
     #DDZ*RD/U)/U)*Jm*R3*sin2*RO2/0.90D2-mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/
     #0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*PI*(D-sin2)-PI*DKZ/0.90D2)/(Jm*
     #PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)*log(JP*dal2*R2-JP*
     #DKZ*RO2/U+JP*DKZ*(RO2-
     #DDZ*RD/U)/U+P2*(RO2-DDZ*RD/U)*(D-sin2)+R1*sin2*P2*dal2*R2-R3*sin2*
     #P2*dal*RO2/U+R3*sin2*P2*dal*(RO2-DDZ*RD/U)/U-RSO2*P2*D2+P2*DKZ*RO2
     #/U-P2*DKZ*(RO2-
     #DDZ*RD/U)/U)*Jm*R1*sin2*RSO2/0.16200D5-mu*P2*dal*(D-sin2)/(Jm*PI*
     #DKZ/0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*PI*(D-sin2)-PI*DKZ/0.90D2)/
     #(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)*log(JP*dal2*R2
     #-JP*DKZ*RO2/U+JP*DKZ*(RO2-
     #DDZ*RD/U)/U+P2*(RO2-DDZ*RD/U)*(D-sin2)+R1*sin2*P2*dal2*R2-R3*sin2*
     #P2*dal*RO2/U+R3*sin2*P2*dal*(RO2-DDZ*RD/U)/U-RSO2*P2*D2+P2*DKZ*RO2
     #/U-P2*DKZ*(RO2-
     #DDZ*RD/U)/U)*Jm*rlz*RO2/0.90D2+mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/
     #0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*PI*(D-sin2)-PI*DKZ/0.90D2)/(Jm*
     #PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-
     #PI*DKZ/U)*log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-DDZ*RD/U)/U+P2*
     #(RO2-DDZ*RD/U)*(D-sin2)+R1*sin2*P2*dal2*R2-R3*sin2*P2*dal*RO2/U+R3
     #*sin2*P2*dal*(RO2-DDZ*RD/U)/U-RSO2*P2*D2+P2*DKZ*RO2/U-P2*DKZ*(RO2-
     #DDZ*RD/U)/U)*Jm*RSO2/0.16200D5+mu*P2*dal*(D-sin2)/(Jm*PI*DKZ/
     #0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*PI*(D-sin2)-PI*DKZ/0.90D2)/(Jm*
     #PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)*log(JP*dal2*R2-JP*
     #DKZ*RO2/U+JP*DKZ*(RO2-
     #DDZ*RD/U)/U+P2*(RO2-DDZ*RD/U)*(D-sin2)+R1*sin2*P2*dal2*R2-R3*sin2*
     #P2*dal*RO2/U+R3*sin2*P2*dal*(RO2-DDZ*RD/U)/U-RSO2*P2*D2+P2*DKZ*RO2
     #/U-P2*DKZ*(RO2-DDZ*RD/U)/U)*R3*sin2*RO2/0.45D2-mu*P2*dal2*(D-
     #sin2)/(Jm*PI*DKZ/0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*PI*(D-sin2)-PI
     #*DKZ/0.90D2)/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)*
     #log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-
     #DDZ*RD/U)/U+P2*(RO2-DDZ*RD/U)*(D-sin2)+R1*sin2*P2*dal2*R2-R3*sin2*
     #P2*dal*RO2/U+R3*sin2*P2*dal*(RO2-DDZ*RD/U)/U-RSO2*P2*D2+P2*DKZ*RO2
     #/U-P2*DKZ*(RO2-
     #DDZ*RD/U)/U)*R1*sin2*RSO2/0.8100D4+mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/
     #0.90D2-R3*sin2*PI*dal/0.90D2-0.2D1*PI*(D-sin2)+PI*DKZ/0.90D2)/(Jm*
     #PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*log(JP*dal2*R2-JP*
     #DKZ*RO2/U+JP*DKZ*(RO2-
     #DDZ*RD/U)/U-P2*(RO2-DDZ*RD/U)*(D-sin2)-R1*sin2*P2*dal2*R2+R3*sin2*
     #P2*dal*RO2/U-R3*sin2*P2*dal*(RO2-DDZ*RD/U)/U+RSO2*P2*D2-P2*DKZ*RO2
     #/U+P2*DKZ*(RO2-DDZ*RD/U)/U)*J2*RSO2/0.16200D5-mu*P2*dal*(D-
     #sin2)/(Jm*PI*DKZ/0.90D2-R3*sin2*PI*dal/0.90D2-0.2D1*PI*(D-sin2)+PI
     #*DKZ/0.90D2)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*
     #log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-DDZ*RD/U)/U-P2*(RO2-DDZ*RD
     #/U)*(D-sin2)-
     #R1*sin2*P2*dal2*R2+R3*sin2*P2*dal*RO2/U-R3*sin2*P2*dal*(RO2-DDZ*RD
     #/U)/U+RSO2*P2*D2-P2*DKZ*RO2/U+P2*DKZ*(RO2-DDZ*RD/U)/U)*J2*rlz*RO2/
     #0.90D2+mu*P2*dal*(D-
     #sin2)/(Jm*PI*DKZ/0.90D2-R3*sin2*PI*dal/0.90D2-0.2D1*PI*(D-sin2)+PI
     #*DKZ/0.90D2)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*
     #log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-DDZ*RD/U)/U-P2*(RO2-DDZ*RD
     #/U)*(D-sin2)-
     #R1*sin2*P2*dal2*R2+R3*sin2*P2*dal*RO2/U-R3*sin2*P2*dal*(RO2-DDZ*RD
     #/U)/U+RSO2*P2*D2-P2*DKZ*RO2/U+P2*DKZ*(RO2-DDZ*RD/U)/U)*Jm*R3*sin2*
     #RO2/0.90D2-mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/0.90D2-R3*sin2*PI*dal/
     #0.90D2-0.2D1*PI*(D-
     #sin2)+PI*DKZ/0.90D2)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*
     #DKZ/U)*log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-DDZ*RD/U)/U-P2*(RO2
     #-DDZ*RD/U)*(D-sin2)-
     #R1*sin2*P2*dal2*R2+R3*sin2*P2*dal*RO2/U-R3*sin2*P2*dal*(RO2-DDZ*RD
     #/U)/U+RSO2*P2*D2-P2*DKZ*RO2/U+P2*DKZ*(RO2-DDZ*RD/U)/U)*Jm*R1*sin2*
     #RSO2/0.16200D5-mu*P2*dal*(D-sin2)/(Jm*PI*DKZ/0.90D2-R3*sin2*PI*dal
     #/0.90D2-0.2D1*PI*(D-
     #sin2)+PI*DKZ/0.90D2)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*
     #DKZ/U)*log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-DDZ*RD/U)/U-P2*(RO2
     #-DDZ*RD/U)*(D-sin2)-
     #R1*sin2*P2*dal2*R2+R3*sin2*P2*dal*RO2/U-R3*sin2*P2*dal*(RO2-DDZ*RD
     #/U)/U+RSO2*P2*D2-P2*DKZ*RO2/U+P2*DKZ*(RO2-DDZ*RD/U)/U)*Jm*rlz*RO2/
     #0.90D2+mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/0.90D2-R3*sin2*PI*dal/0.90D2
     #-0.2D1*PI*(D-sin2)+PI*DKZ/0.90D2)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI
     #*(D-sin2)+PI*DKZ/U)*log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-
     #DDZ*RD/U)/U-P2*(RO2-DDZ*RD/U)*(D-sin2)-R1*sin2*P2*dal2*R2+R3*sin2*
     #P2*dal*RO2/U-R3*sin2*P2*dal*(RO2-DDZ*RD/U)/U+RSO2*P2*D2-P2*DKZ*RO2
     #/U+P2*DKZ*(RO2-DDZ*RD/U)/U)*Jm*RSO2/0.16200D5+mu*P2*dal*(D-
     #sin2)/(Jm*PI*DKZ/0.90D2-R3*sin2*PI*dal/0.90D2-0.2D1*PI*(D-sin2)+PI
     #*DKZ/0.90D2)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*
     #log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-DDZ*RD/U)/U-P2*(RO2-DDZ*RD
     #/U)*(D-sin2)-
     #R1*sin2*P2*dal2*R2+R3*sin2*P2*dal*RO2/U-R3*sin2*P2*dal*(RO2-DDZ*RD
     #/U)/U+RSO2*P2*D2-P2*DKZ*RO2/U+P2*DKZ*(RO2-DDZ*RD/U)/U)*R3*sin2*RO2
     #/0.45D2-mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/0.90D2-R3*sin2*PI*dal/
     #0.90D2-0.2D1*PI*(D-
     #sin2)+PI*DKZ/0.90D2)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*
     #DKZ/U)*log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-DDZ*RD/U)/U-P2*(RO2
     #-DDZ*RD/U)*(D-sin2)-
     #R1*sin2*P2*dal2*R2+R3*sin2*P2*dal*RO2/U-R3*sin2*P2*dal*(RO2-DDZ*RD
     #/U)/U+RSO2*P2*D2-P2*DKZ*RO2/U+P2*DKZ*(RO2-DDZ*RD/U)/U)*R1*sin2*
     #RSO2/0.8100D4)

      END

	SUBROUTINE AORTAGN(RO,RSI,RSO,RLZ,ALFA,C,MJU,JM,SIN2,WESULT,F)
C Analyticke reseni modifikovany ortotropni Gent+neoHook, dle vztahu L.Horny
C Konstitutivni rovnice Gent Jm, mju, SIN2=(sin beta)^2
C W=c.(I1-3)-mju.Jm/2.ln(1-(I4-1)^2/Jm^2)
C W=c.(I1-3)-mju.Jm.ln(1-(I4-1)^2/Jm^2)   ... doufam, ze je to bez te dvojky

C VSTUP: polomer vnejsi RO
C        RSI,RSO - nezatizena trubice
C        RLZ - axialni stretch
C        ALFA-doplnek uhlu rozevreni (ve stupnich)
C VYSTUP: result - tlak na vnitrnim povrchu
C VYSTUP: F      - axialni sila
	REAL MJU,JM,MU
	REAL*8 AA,A,P1,P2,T1,L1,J0,J1,J2,JP,PA,PB,PI,DAL,DAL2,D,D2,DKZ,DDZ
     #,RD,U,RSO2,RSI2,RO2,R1,R2,R3
	IF(SIN2.LT.0..OR.SIN2.GT.0.999)THEN
	    WRITE(10,'('' ERROR SIN BETA PARAMETER'')')
	    RETURN
	ENDIF
	IF(JM.LT.0.1.OR.JM.GT.100.)THEN
	    WRITE(10,'('' ERROR JM PARAMETER (SHOULD BE <100)'')')
	    RETURN
	ENDIF

C Horny maple 13.5.2008
      dal=dble(180-alpha)
	dal2=dble(dal**2)
	u=0.18d3
	rso2=rso**2
	rsi2=rsi**2
	ro2=ro**2
	r1=rlz**2
	r2=rso2/0.324d5
	r3=rlz**3
	d2=dal2/0.324d5
	d=0.1d1
	p2=pi**2
	j2=jm**2
	jp=jm*p2
	rd=(rso2-rsi2)
	dkz=dal*rlz
	ddz=dal/rlz

      pi=3.14159
      mu=mju
	alpha=alfa

      WESULT=PI*mu * Jm * dble(1 - sin2) / (-PI
     # * dble(1 - sin2) + Jm * PI * dal * rlz 
     #/ 0.180D3 - rlz ** 3 * dble(sin2) * PI * dble(180 - al
     #pha) / 0.180D3 + PI * dal * rlz / 0.180D
     #3) * log(Jm * PI ** 2 * dble((180 - alpha) ** 2) * RSO
     # ** 2 / 0.32400D5 - PI ** 2 * RO ** 2 * dble(1 - sin2)
     # - rlz ** 2 * dble(sin2) * PI ** 2 * dble((180 - alpha
     #) ** 2) * RSO ** 2 / 0.32400D5 + RSO ** 2 * PI ** 2 * 
     #dble((180 - alpha) ** 2) / 0.32400D5) - PI * mu * Jm *
     # dble(1 - sin2) / (PI * dble(1 - sin2) + Jm * 0.314159
     #2654D1 * dal * rlz / 0.180D3 + rlz ** 3 * dble(sin2)
     # * PI * dal / 0.180D3 - PI *
     # dal * rlz / 0.180D3) * log(Jm * PI ** 2
     # * dble((180 - alpha) ** 2) * RSO ** 2 / 0.32400D5 + 0.3141592654D
     #1 ** 2 * RO ** 2 * dble(1 - sin2) + rlz ** 2 * dble(sin2) * 0.3141
     #592654D1 ** 2 * dble((180 - alpha) ** 2) * RSO ** 2 / 0.32400D5 - 
     #RSO ** 2 * PI ** 2 * dble((180 - alpha) ** 2) / 0.3240
     #0D5) - PI * mu * Jm * dble(1 - sin2) / (-0.3141592654D
     #1 * dble(1 - sin2) + Jm * PI * dal * rlz
     # / 0.180D3 - rlz ** 3 * dble(sin2) * PI * dble(180 - a
     #lpha) / 0.180D3 + PI * dal * rlz / 0.180
     #D3) * log(Jm * PI ** 2 * dble((180 - alpha) ** 2) * RS
     #O ** 2 / 0.32400D5 - Jm * PI ** 2 * dal 
     #* rlz * RO ** 2 / 0.180D3 + Jm * PI ** 2 * dble(180 - 
     #alpha) * rlz * (RO ** 2 - dal / rlz * (RSO ** 2 - RS
     #I ** 2) / 0.180D3) / 0.180D3 - PI ** 2 * (RO ** 2 - db
     #le(180 - alpha) / rlz * (RSO ** 2 - RSI ** 2) / 0.180D3) * dble(1 
     #- sin2) - rlz ** 2 * dble(sin2) * PI ** 2 * dble((180 
     #- alpha) ** 2) * RSO ** 2 / 0.32400D5 + rlz ** 3 * dble(sin2) * 0.
     #3141592654D1 ** 2 * dal * RO ** 2 / 0.180D3 - rlz **
     # 3 * dble(sin2) * PI ** 2 * dal * (RO **
     # 2 - dal / rlz * (RSO ** 2 - RSI ** 2) / 0.180D3) / 
     #0.180D3 + RSO ** 2 * PI ** 2 * dble((180 - alpha) ** 2
     #) / 0.32400D5 - PI ** 2 * dal * rlz * RO
     # ** 2 / 0.180D3 + PI ** 2 * dal * rlz * 
     #(RO ** 2 - dal / rlz * (RSO ** 2 - RSI ** 2) / 0.180
     #D3) / 0.180D3) + PI * mu * Jm * dble(1 - sin2) / (0.31
     #41592654D1 * dble(1 - sin2) + Jm * PI * dble(180 - alp
     #ha) * rlz / 0.180D3 + rlz ** 3 * dble(sin2) * PI * dbl
     #e(180 - alpha) / 0.180D3 - PI * dal * rl
     #z / 0.180D3) * log(Jm * PI ** 2 * dble((180 - alpha) *
     #* 2) * RSO ** 2 / 0.32400D5 - Jm * PI ** 2 * dble(180 
     #- alpha) * rlz * RO ** 2 / 0.180D3 + Jm * PI ** 2 * db
     #le(180 - alpha) * rlz * (RO ** 2 - dal / rlz * (RSO 
     #** 2 - RSI ** 2) / 0.180D3) / 0.180D3 + PI ** 2 * (RO 
     #** 2 - dal / rlz * (RSO ** 2 - RSI ** 2) / 0.180D3) 
     #* dble(1 - sin2) + rlz ** 2 * dble(sin2) * PI ** 2 * d
     #ble((180 - alpha) ** 2) * RSO ** 2 / 0.32400D5 - rlz ** 3 * dble(s
     #in2) * PI ** 2 * dal * RO ** 2 / 0.180D3
     # + rlz ** 3 * dble(sin2) * PI ** 2 * dal
     # * (RO ** 2 - dal / rlz * (RSO ** 2 - RSI ** 2) / 0.
     #180D3) / 0.180D3 - RSO ** 2 * PI ** 2 * dble((180 - al
     #pha) ** 2) / 0.32400D5 + PI ** 2 * dal *
     # rlz * RO ** 2 / 0.180D3 - PI ** 2 * dal
     # * rlz * (RO ** 2 - dal / rlz * (RSO ** 2 - RSI ** 2
     #) / 0.180D3) / 0.180D3)
C pricteni neoHookovskeho clenu k vnitrnimu tlaku
      wesult=wesult+0.180D3/dble(180-alpha)*c/rlz*log(RSO ** 2 * 0.3141
     #592654D1 * dble(180 - alpha) / 0.180D3) + dble((180 - alpha) ** 2)
     # * c / rlz ** 2 / RO ** 2 * RSO ** 2 / 0.32400D5 - dble(180 - alph
     #a) * c / rlz / 0.180D3 - dble(180 - alpha) * c / rlz * log(RO) / 0
     #.90D2 - 0.180D3 / dble(180 - alpha) * c / rlz * log(RSO ** 2 * 0.3
     #141592654D1 * dble(180 - alpha) / 0.180D3 - 0.3141592654D1 * rlz *
     # RO ** 2 + 0.3141592654D1 * rlz * (RO ** 2 - dble(180 - alpha) / r
     #lz * (RSO ** 2 - RSI ** 2) / 0.180D3)) - dble((180 - alpha) ** 2) 
     #* c / rlz ** 2 / (RO ** 2 - dble(180 - alpha) / rlz * (RSO ** 2 - 
     #RSI ** 2) / 0.180D3) * RSO ** 2 / 0.32400D5 + dble(180 - alpha) * 
     #c / rlz / (RO ** 2 - dble(180 - alpha) / rlz * (RSO ** 2 - RSI ** 
     #2) / 0.180D3) * RO ** 2 / 0.180D3 + dble(180 - alpha) * c / rlz * 
     #log(RO ** 2 - dble(180 - alpha) / rlz * (RSO ** 2 - RSI ** 2) / 0.
     #180D3) / 0.180D3


C F-axial force
	F=PI*(mu/(Jm*PI*dal *rlz/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)
     #/(Jm*PI*dal *rlz/U-R3*sin2*0.3141592654D1*dal/U-PI*(D-sin2)+
     #PI*DKZ/U)*RO2*P2*(D-sin2)*R3*sin2*dal/0.45D2-0.2D1*mu /(Jm*PI*DKZ/
     #U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)/(Jm*PI*DKZ/U-R3*sin2*PI*
     #dal/U-PI*(D-sin2)+PI*DKZ/U)*RO2*P2*(D-sin2)**2*Jm+mu/ (Jm*PI*DKZ/U
     #+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)/
     #(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*RO2*rlz**6*
     #sin2**2*P2*dal2/0.8100D4-mu/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+
     #PI*(D-sin2)-PI*DKZ/U)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI
     #*DKZ/U)*RO2*R3*sin2*P2*dal*Jm*(D-sin2)/0.90D2-mu/(Jm*PI*DKZ/U+R3*
     #sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-
     #PI*(D-sin2)+PI*DKZ/U)*RO2*P2*dal2*rlz**4*sin2/0.8100D4+
     #mu/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)/(Jm*PI*DKZ/
     #U-R3*sin2*PI*dal/U-PI*(D-sin2) +PI*DKZ/U)*RO2*P2*DKZ*Jm*(D-sin2)/
     #0.90D2-mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/0.90D2+R3*sin2*PI*dal/0.90D2
     #+0.2D1*PI*(D-sin2)-PI*DKZ/0.90D2) /(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+
     #PI*(D-sin2)-PI*DKZ/U)*log(JP*dal2*R2+P2*RO2*(D-sin2)+R1*sin2*P2*
     #dal2*R2-RSO2*P2*D2)*J2*RSO2/0.16200D5+mu*P2*dal*(D-sin2)/
     #(Jm*PI*DKZ/0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*PI*(D-sin2)-PI*DKZ/
     #0.90D2)/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)
     #-PI*DKZ/U)*log(JP*dal2*R2+P2*RO2*(D-sin2)+R1*sin2*P2*dal2*R2-RSO2*
     #P2*D2)*J2*rlz*RO2/0.90D2+mu*P2*dal*
     #(D-sin2)/(Jm*PI*DKZ/0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*PI*(D-sin2)
     #-PI*DKZ/0.90D2)/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U
     #)*log(JP*dal2*R2+P2*RO2*(D-sin2)+R1*sin2*P2*dal2*R2-RSO2*P2*D2)*Jm
     #*R3*sin2*RO2/0.90D2-mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/0.90D2+R3*sin2*
     #PI*dal/0.90D2+ 0.2D1*PI*(D-sin2)-
     #PI*DKZ/0.90D2)/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)
     #*log(JP*dal2*R2+P2*RO2*(D-sin2)+R1*sin2*P2*dal2*R2-RSO2*P2*D2)*Jm*
     #R1*sin2*RSO2/0.16200D5-mu*P2*dal*(D-sin2)/(Jm*PI*DKZ/0.90D2+R3*sin
     #2*PI*dal/0.90D2+0.2D1*PI*(D-sin2)-PI*DKZ/0.90D2)/(Jm*PI*DKZ/U+R3*
     #sin2*PI*dal/U+ PI*(D-sin2) -PI*DKZ/U)*log(JP*dal2*R2+
     #P2*RO2*(D-sin2)+R1*sin2*P2*dal2*R2-RSO2*P2*D2)*Jm*rlz*RO2/0.90D2+
     #mu*P2*dal2*(D- sin2) / 
     #(Jm*PI*DKZ/0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*PI*(D-sin2)-PI*DKZ/
     #0.90D2)/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+
     #PI*(D-sin2)-PI*DKZ/U)*log(JP*dal2*R2+P2*RO2*(D-sin2)+ R1*sin2*P2*
     #dal2*R2- RSO2*P2*D2)*Jm*RSO2/0.16200D5+mu*P2*dal*(D-sin2)/(Jm*PI*
     #DKZ/0.90D2+ R3*sin2*PI*dal/0.90D2+ 0.2D1*PI*(D-sin2)-
     #PI*DKZ/0.90D2)/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)
     #* log(JP*dal2*R2+P2*RO2*(D-sin2)+R1*sin2*P2*dal2*R2-
     #RSO2*P2*D2)*R3*sin2*RO2/0.45D2-mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/
     #0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*PI*(D-sin2)-
     #PI*DKZ/0.90D2)/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)
     #*log(JP*dal2*R2+P2*RO2*(D-sin2)+R1*sin2*P2*dal2*R2-
     #RSO2*P2*D2)*R1*sin2*RSO2/0.8100D4+mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/
     #0.90D2-R3*sin2*PI*dal/0.90D2-0.2D1*PI*(D-sin2)+PI*DKZ/0.90D2)/(Jm*
     #PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*log(JP*dal2*R2-P2*
     #RO2*(D-sin2)-R1*sin2*P2*dal2*R2+RSO2*P2*D2)*J2*RSO2/0.16200D5-mu*
     #P2*dal*(D-sin2)/(Jm*PI*DKZ/0.90D2-R3*sin2*PI*dal/0.90D2-0.2D1*PI*
     #(D-sin2)+PI*DKZ/0.90D2)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+
     #PI*DKZ/U)*log(JP*dal2*R2-P2*RO2*(D-sin2)-R1*sin2*P2*dal2*R2+RSO2*
     #P2*D2)*J2*rlz*RO2/0.90D2+mu*P2*dal*(D-sin2)/(Jm*PI*DKZ/0.90D2-R3*
     #sin2*PI*dal/0.90D2-0.2D1*PI*(D-sin2)+PI*DKZ/0.90D2)/(Jm*PI*DKZ/U-
     #R3*sin2*PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*log(JP*dal2*R2-P2*RO2*(D-
     #sin2)-R1*sin2*P2*dal2*R2+RSO2*P2*D2)*Jm*R3*sin2*RO2/0.90D2-mu*P2*
     #dal2*(D-sin2)/(Jm*PI*DKZ/0.90D2-R3*sin2*PI*dal/0.90D2-0.2D1*PI*(D-
     #sin2)+PI*DKZ/0.90D2)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-
     #PI*(D-sin2)+PI*DKZ/U)*log(JP*dal2*R2-P2*RO2*(D-sin2)-R1*sin2*P2*
     #dal2*R2+RSO2*P2*D2)*Jm*R1*sin2*RSO2/0.16200D5-mu*P2*dal*(D-sin2)/
     #(Jm*PI*DKZ/0.90D2-R3*sin2*PI*dal/0.90D2-0.2D1*PI*(D-sin2)+PI*DKZ/
     #0.90D2)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*
     #log(JP*dal2*R2-P2*RO2*(D-sin2)-R1*sin2*P2*dal2*R2+RSO2*P2*D2)*Jm*
     #rlz*RO2/0.90D2+mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/0.90D2-R3*sin2*PI*
     #dal/0.90D2-0.2D1*PI*(D-sin2)+PI*DKZ/0.90D2)/(Jm*PI*DKZ/U-R3*sin2*
     #PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*log(JP*dal2*R2-P2*RO2*(D-sin2)-
     #R1*sin2*P2*dal2*R2+RSO2*P2*D2)*Jm*RSO2/0.16200D5+mu*P2*dal*
     #(D-sin2)/(Jm*PI*DKZ/0.90D2-R3*sin2*PI*dal/0.90D2-0.2D1*PI*(D-sin2)
     #+PI*DKZ/0.90D2)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+
     #PI*DKZ/U)*log(JP*dal2*R2-P2*RO2*(D-sin2)-R1*sin2*P2*dal2*R2+RSO2*
     #P2*D2)*R3*sin2*RO2/0.45D2-mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/0.90D2-R3
     #*sin2*PI*dal/0.90D2-0.2D1*PI*(D-sin2)+PI*DKZ/0.90D2)/(Jm*PI*DKZ/U-
     #R3*sin2*PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*log(JP*dal2*R2-P2*RO2*
     #(D-sin2)-R1*sin2*P2*dal2*R2+RSO2*P2*D2)*R1*sin2*RSO2/0.8100D4)-PI*
     #(mu/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)/(Jm*PI*DKZ
     #/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*(RO2-DDZ*RD/U)*P2*
     #(D-sin2)*R3*sin2*dal/0.45D2-0.2D1*mu/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U
     #+PI*(D-sin2)-PI*DKZ/U)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+
     #PI*DKZ/U)*(RO2-DDZ*RD/U)*P2*(D-sin2)**2*Jm+mu/(Jm*PI*DKZ/U+R3*sin2
     #*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*
     #(D-sin2)+PI*DKZ/U)*(RO2-DDZ*RD/U)*rlz**6*sin2**2*P2*dal2/0.8100D4-
     #mu/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-
     #PI*DKZ/U)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*(RO2
     #-DDZ*RD/U)*R3*sin2*P2*dal*Jm*(D-sin2)/0.90D2-mu/(Jm*PI*DKZ/U+R3*
     #sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-
     #PI*(D-sin2)+PI*DKZ/U)*(RO2-
     #DDZ*RD/U)*P2*dal2*rlz**4*sin2/0.8100D4+mu/(Jm*PI*DKZ/U+R3*sin2*PI*
     #dal/U+PI*(D-sin2)-PI*DKZ/U)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-
     #sin2)+PI*DKZ/U)*(RO2-DDZ*RD/U)*P2*DKZ*Jm*(D-sin2)/0.90D2-mu*P2*
     #dal2*(D-sin2)/(Jm*PI*DKZ/0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*PI*(D-
     #sin2)-PI*DKZ/0.90D2)/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*
     #DKZ/U)*log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-
     #DDZ*RD/U)/U+P2*(RO2-DDZ*RD/U)*(D-sin2)+R1*sin2*P2*dal2*R2-R3*sin2*
     #P2*dal*RO2/U+R3*sin2*P2*dal*(RO2-DDZ*RD/U)/U-RSO2*P2*D2+P2*DKZ*RO2
     #/U-P2*DKZ*(RO2-
     #DDZ*RD/U)/U)*J2*RSO2/0.16200D5+mu*P2*dal*(D-sin2)/(Jm*PI*DKZ/
     #0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*PI*(D-sin2)-PI*DKZ/0.90D2)/(Jm*
     #PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-
     #PI*DKZ/U)*log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-DDZ*RD/U)/U+P2*
     #(RO2-DDZ*RD/U)*(D-sin2)+R1*sin2*P2*dal2*R2-R3*sin2*P2*dal*RO2/U+R3
     #*sin2*P2*dal*(RO2-DDZ*RD/U)/U-
     #RSO2*P2*D2+P2*DKZ*RO2/U-P2*DKZ*(RO2-DDZ*RD/U)/U)*J2*rlz*RO2/0.90D2
     #+mu*P2*dal*(D-sin2)/(Jm*PI*DKZ/0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*
     #PI*(D-sin2)-PI*DKZ/0.90D2)/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*
     #(D-sin2)-
     #PI*DKZ/U)*log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-DDZ*RD/U)/U+P2*
     #(RO2-DDZ*RD/U)*(D-sin2)+R1*sin2*P2*dal2*R2-R3*sin2*P2*dal*RO2/U+R3
     #*sin2*P2*dal*(RO2-DDZ*RD/U)/U-RSO2*P2*D2+P2*DKZ*RO2/U-P2*DKZ*(RO2-
     #DDZ*RD/U)/U)*Jm*R3*sin2*RO2/0.90D2-mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/
     #0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*PI*(D-sin2)-PI*DKZ/0.90D2)/(Jm*
     #PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)*log(JP*dal2*R2-JP*
     #DKZ*RO2/U+JP*DKZ*(RO2-
     #DDZ*RD/U)/U+P2*(RO2-DDZ*RD/U)*(D-sin2)+R1*sin2*P2*dal2*R2-R3*sin2*
     #P2*dal*RO2/U+R3*sin2*P2*dal*(RO2-DDZ*RD/U)/U-RSO2*P2*D2+P2*DKZ*RO2
     #/U-P2*DKZ*(RO2-
     #DDZ*RD/U)/U)*Jm*R1*sin2*RSO2/0.16200D5-mu*P2*dal*(D-sin2)/(Jm*PI*
     #DKZ/0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*PI*(D-sin2)-PI*DKZ/0.90D2)/
     #(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)*log(JP*dal2*R2
     #-JP*DKZ*RO2/U+JP*DKZ*(RO2-
     #DDZ*RD/U)/U+P2*(RO2-DDZ*RD/U)*(D-sin2)+R1*sin2*P2*dal2*R2-R3*sin2*
     #P2*dal*RO2/U+R3*sin2*P2*dal*(RO2-DDZ*RD/U)/U-RSO2*P2*D2+P2*DKZ*RO2
     #/U-P2*DKZ*(RO2-
     #DDZ*RD/U)/U)*Jm*rlz*RO2/0.90D2+mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/
     #0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*PI*(D-sin2)-PI*DKZ/0.90D2)/(Jm*
     #PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-
     #PI*DKZ/U)*log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-DDZ*RD/U)/U+P2*
     #(RO2-DDZ*RD/U)*(D-sin2)+R1*sin2*P2*dal2*R2-R3*sin2*P2*dal*RO2/U+R3
     #*sin2*P2*dal*(RO2-DDZ*RD/U)/U-RSO2*P2*D2+P2*DKZ*RO2/U-P2*DKZ*(RO2-
     #DDZ*RD/U)/U)*Jm*RSO2/0.16200D5+mu*P2*dal*(D-sin2)/(Jm*PI*DKZ/
     #0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*PI*(D-sin2)-PI*DKZ/0.90D2)/(Jm*
     #PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)*log(JP*dal2*R2-JP*
     #DKZ*RO2/U+JP*DKZ*(RO2-
     #DDZ*RD/U)/U+P2*(RO2-DDZ*RD/U)*(D-sin2)+R1*sin2*P2*dal2*R2-R3*sin2*
     #P2*dal*RO2/U+R3*sin2*P2*dal*(RO2-DDZ*RD/U)/U-RSO2*P2*D2+P2*DKZ*RO2
     #/U-P2*DKZ*(RO2-DDZ*RD/U)/U)*R3*sin2*RO2/0.45D2-mu*P2*dal2*(D-
     #sin2)/(Jm*PI*DKZ/0.90D2+R3*sin2*PI*dal/0.90D2+0.2D1*PI*(D-sin2)-PI
     #*DKZ/0.90D2)/(Jm*PI*DKZ/U+R3*sin2*PI*dal/U+PI*(D-sin2)-PI*DKZ/U)*
     #log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-
     #DDZ*RD/U)/U+P2*(RO2-DDZ*RD/U)*(D-sin2)+R1*sin2*P2*dal2*R2-R3*sin2*
     #P2*dal*RO2/U+R3*sin2*P2*dal*(RO2-DDZ*RD/U)/U-RSO2*P2*D2+P2*DKZ*RO2
     #/U-P2*DKZ*(RO2-
     #DDZ*RD/U)/U)*R1*sin2*RSO2/0.8100D4+mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/
     #0.90D2-R3*sin2*PI*dal/0.90D2-0.2D1*PI*(D-sin2)+PI*DKZ/0.90D2)/(Jm*
     #PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*log(JP*dal2*R2-JP*
     #DKZ*RO2/U+JP*DKZ*(RO2-
     #DDZ*RD/U)/U-P2*(RO2-DDZ*RD/U)*(D-sin2)-R1*sin2*P2*dal2*R2+R3*sin2*
     #P2*dal*RO2/U-R3*sin2*P2*dal*(RO2-DDZ*RD/U)/U+RSO2*P2*D2-P2*DKZ*RO2
     #/U+P2*DKZ*(RO2-DDZ*RD/U)/U)*J2*RSO2/0.16200D5-mu*P2*dal*(D-
     #sin2)/(Jm*PI*DKZ/0.90D2-R3*sin2*PI*dal/0.90D2-0.2D1*PI*(D-sin2)+PI
     #*DKZ/0.90D2)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*
     #log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-DDZ*RD/U)/U-P2*(RO2-DDZ*RD
     #/U)*(D-sin2)-
     #R1*sin2*P2*dal2*R2+R3*sin2*P2*dal*RO2/U-R3*sin2*P2*dal*(RO2-DDZ*RD
     #/U)/U+RSO2*P2*D2-P2*DKZ*RO2/U+P2*DKZ*(RO2-DDZ*RD/U)/U)*J2*rlz*RO2/
     #0.90D2+mu*P2*dal*(D-
     #sin2)/(Jm*PI*DKZ/0.90D2-R3*sin2*PI*dal/0.90D2-0.2D1*PI*(D-sin2)+PI
     #*DKZ/0.90D2)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*
     #log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-DDZ*RD/U)/U-P2*(RO2-DDZ*RD
     #/U)*(D-sin2)-
     #R1*sin2*P2*dal2*R2+R3*sin2*P2*dal*RO2/U-R3*sin2*P2*dal*(RO2-DDZ*RD
     #/U)/U+RSO2*P2*D2-P2*DKZ*RO2/U+P2*DKZ*(RO2-DDZ*RD/U)/U)*Jm*R3*sin2*
     #RO2/0.90D2-mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/0.90D2-R3*sin2*PI*dal/
     #0.90D2-0.2D1*PI*(D-
     #sin2)+PI*DKZ/0.90D2)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*
     #DKZ/U)*log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-DDZ*RD/U)/U-P2*(RO2
     #-DDZ*RD/U)*(D-sin2)-
     #R1*sin2*P2*dal2*R2+R3*sin2*P2*dal*RO2/U-R3*sin2*P2*dal*(RO2-DDZ*RD
     #/U)/U+RSO2*P2*D2-P2*DKZ*RO2/U+P2*DKZ*(RO2-DDZ*RD/U)/U)*Jm*R1*sin2*
     #RSO2/0.16200D5-mu*P2*dal*(D-sin2)/(Jm*PI*DKZ/0.90D2-R3*sin2*PI*dal
     #/0.90D2-0.2D1*PI*(D-
     #sin2)+PI*DKZ/0.90D2)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*
     #DKZ/U)*log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-DDZ*RD/U)/U-P2*(RO2
     #-DDZ*RD/U)*(D-sin2)-
     #R1*sin2*P2*dal2*R2+R3*sin2*P2*dal*RO2/U-R3*sin2*P2*dal*(RO2-DDZ*RD
     #/U)/U+RSO2*P2*D2-P2*DKZ*RO2/U+P2*DKZ*(RO2-DDZ*RD/U)/U)*Jm*rlz*RO2/
     #0.90D2+mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/0.90D2-R3*sin2*PI*dal/0.90D2
     #-0.2D1*PI*(D-sin2)+PI*DKZ/0.90D2)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI
     #*(D-sin2)+PI*DKZ/U)*log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-
     #DDZ*RD/U)/U-P2*(RO2-DDZ*RD/U)*(D-sin2)-R1*sin2*P2*dal2*R2+R3*sin2*
     #P2*dal*RO2/U-R3*sin2*P2*dal*(RO2-DDZ*RD/U)/U+RSO2*P2*D2-P2*DKZ*RO2
     #/U+P2*DKZ*(RO2-DDZ*RD/U)/U)*Jm*RSO2/0.16200D5+mu*P2*dal*(D-
     #sin2)/(Jm*PI*DKZ/0.90D2-R3*sin2*PI*dal/0.90D2-0.2D1*PI*(D-sin2)+PI
     #*DKZ/0.90D2)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*DKZ/U)*
     #log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-DDZ*RD/U)/U-P2*(RO2-DDZ*RD
     #/U)*(D-sin2)-
     #R1*sin2*P2*dal2*R2+R3*sin2*P2*dal*RO2/U-R3*sin2*P2*dal*(RO2-DDZ*RD
     #/U)/U+RSO2*P2*D2-P2*DKZ*RO2/U+P2*DKZ*(RO2-DDZ*RD/U)/U)*R3*sin2*RO2
     #/0.45D2-mu*P2*dal2*(D-sin2)/(Jm*PI*DKZ/0.90D2-R3*sin2*PI*dal/
     #0.90D2-0.2D1*PI*(D-
     #sin2)+PI*DKZ/0.90D2)/(Jm*PI*DKZ/U-R3*sin2*PI*dal/U-PI*(D-sin2)+PI*
     #DKZ/U)*log(JP*dal2*R2-JP*DKZ*RO2/U+JP*DKZ*(RO2-DDZ*RD/U)/U-P2*(RO2
     #-DDZ*RD/U)*(D-sin2)-
     #R1*sin2*P2*dal2*R2+R3*sin2*P2*dal*RO2/U-R3*sin2*P2*dal*(RO2-DDZ*RD
     #/U)/U+RSO2*P2*D2-P2*DKZ*RO2/U+P2*DKZ*(RO2-DDZ*RD/U)/U)*R1*sin2*
     #RSO2/0.8100D4)
C pricteni neoHookovskeho clenu k axialni sile F
      F=F+ 0.3141592654D1 * (-dble((180 - alpha) * c / rlz * RO ** 2) /
     # 0.180D3 - dble((180 - alpha) ** 2) * dble(c) / dble(rlz ** 2) * l
     #og(dble(RO)) * RSO ** 2 / 0.16200D5 + dble(180 - alpha) * dble(c) 
     #/ dble(rlz) * log(dble(RO)) * dble(RO ** 2) / 0.90D2 - dble(180 / 
     #(180 - alpha) * c / rlz * RO ** 2) + dble(c) / dble(rlz ** 2) * lo
     #g(RSO ** 2 * 0.3141592654D1 * dble(180 - alpha) / 0.180D3) * RSO *
     #* 2 - 0.180D3 / dble(180 - alpha) * dble(c) / dble(rlz) * log(RSO 
     #** 2 * 0.3141592654D1 * dble(180 - alpha) / 0.180D3) * dble(RO ** 
     #2) + dble(2 * rlz ** 2 * c * RO ** 2)) - 0.3141592654D1 * (-dble(1
     #80 - alpha) * dble(c) / dble(rlz) * (dble(RO ** 2) - dble(180 - al
     #pha) / dble(rlz) * (RSO ** 2 - RSI ** 2) / 0.180D3) / 0.180D3 - db
     #le((180 - alpha) ** 2) * dble(c) / dble(rlz ** 2) * log(dble(RO **
     # 2) - dble(180 - alpha) / dble(rlz) * (RSO ** 2 - RSI ** 2) / 0.18
     #0D3) * RSO ** 2 / 0.32400D5 + dble(180 - alpha) * dble(c) / dble(r
     #lz) * log(dble(RO ** 2) - dble(180 - alpha) / dble(rlz) * (RSO ** 
     #2 - RSI ** 2) / 0.180D3) * dble(RO ** 2) / 0.180D3 - 0.180D3 / dbl
     #e(180 - alpha) * dble(c) / dble(rlz) * (dble(RO ** 2) - dble(180 -
     # alpha) / dble(rlz) * (RSO ** 2 - RSI ** 2) / 0.180D3) + dble(c) /
     # dble(rlz ** 2) * log(RSO ** 2 * 0.3141592654D1 * dble(180 - alpha
     #) / 0.180D3 - 0.3141592654D1 * dble(rlz) * dble(RO ** 2) + 0.31415
     #92654D1 * dble(rlz) * (dble(RO ** 2) - dble(180 - alpha) / dble(rl
     #z) * (RSO ** 2 - RSI ** 2) / 0.180D3)) * RSO ** 2 - 0.180D3 / dble
     #(180 - alpha) * dble(c) / dble(rlz) * log(RSO ** 2 * 0.3141592654D
     #1 * dble(180 - alpha) / 0.180D3 - 0.3141592654D1 * dble(rlz) * dbl
     #e(RO ** 2) + 0.3141592654D1 * dble(rlz) * (dble(RO ** 2) - dble(18
     #0 - alpha) / dble(rlz) * (RSO ** 2 - RSI ** 2) / 0.180D3)) * dble(
     #RO ** 2) + 0.2D1 * dble(rlz ** 2) * dble(c) * (dble(RO ** 2) - dbl
     #e(180 - alpha) / dble(rlz) * (RSO ** 2 - RSI ** 2) / 0.180D3))

      END

C GENT2 torze======================================
C 12.8.2009
      SUBROUTINE AORTAGT(RO,RSI,RSO,OMEGA,LAMBDA,DELTA,ALFA,
     /C,MU,JM,JF,SN2,RESULTP,RESULTF,RESULTM,N)
	REAL MU,JM,JF,LAMBDA
C Numericka integrace neo-Hook+GENT2 torze, dle vztahu L.Horny
C Konstitutivni rovnice Gent2 C,Jm,Jf,mju,beta
C VSTUP: polomer vnejsi RO
C        RSI,RSO - nezatizena trubice
C        OMEGA - uhel zkrouceni v radianech
C        LAMBDA - axialni stretch po zatizeni uzavrene trubice
C        DELTA - stretch po uzavreni (a bez zatizeni)
C        ALFA- uhel rozevreni (ve stupnich)
C        C1,K1,K2,SN2=(sin beta)^2
      REAL LZ,LT,LR,KAPPA,J4,J6,J1

      OPEN(77,FILE='GENT2T.TXT')
	WRITE(77,'(''GENT2: C='',E10.3,'' MU='',E10.3,'' Jm='',E10.3,'' Jf
     /='',E10.3,'' SN2='',F6.4,'' N='',I4)')C,MU,JM,JF,SN2,N
      WRITE(77,'(''ro='',E10.3,'' RI='',E10.3,'' RO='',E10.3,
     /'' ALFA[deg]='',E10.3,'' LAMBDA='',E10.3,'' OMEGA='',E10.3)')
     /RO,RSI,RSO,ALFA,LAMBDA,OMEGA 

      PI=3.14159
      SN=sqrt(SN2)
	ALPHA=ALFA*pi/180.
      R=RSI
	NINT=MAX0(5,N)
      ri = sqrt(lambda * delta * (lambda * delta * RO ** 2 - RSO ** 2 + 
     #RSI ** 2)) / lambda / delta
      DR=(RO-RI)/(NINT-1)
	R=RI
C F-axial force
	Fsum=0
	Psum=0
	Rsum=0
	DO I=1,NINT
C GENT 2 torze pomocne promenna
      lt = 0.3141592654D1 * r * ((0.3141592654D1 - alpha) * (-0.3141592
     #654D1 * lambda * delta * RO ** 2 + 0.3141592654D1 * lambda * delta
     # * r ** 2 + 0.3141592654D1 * (0.2D1 * 0.3141592654D1 * RSO - RSO *
     # alpha + RSI * alpha) ** 2 / (0.2D1 * 0.3141592654D1 - 0.2D1 * alp
     #ha) ** 2 - alpha * (0.2D1 * 0.3141592654D1 * RSO - RSO * alpha + R
     #SI * alpha) ** 2 / (0.2D1 * 0.3141592654D1 - 0.2D1 * alpha) ** 2))
     # ** (-0.1D1 / 0.2D1)
      lz = lambda * delta
      lr = sqrt((0.3141592654D1 - alpha) * (-0.3141592654D1 * lambda * 
     #delta * RO ** 2 + 0.3141592654D1 * lambda * delta * r ** 2 + 0.314
     #1592654D1 * (0.2D1 * 0.3141592654D1 * RSO - RSO * alpha + RSI * al
     #pha) ** 2 / (0.2D1 * 0.3141592654D1 - 0.2D1 * alpha) ** 2 - alpha 
     #* (0.2D1 * 0.3141592654D1 * RSO - RSO * alpha + RSI * alpha) ** 2 
     #/ (0.2D1 * 0.3141592654D1 - 0.2D1 * alpha) ** 2)) / 0.3141592654D1
     # / r / lambda / delta
      kappa = omega * r * delta
      J4 = dble(lt ** 2 * (1 - sn)) + 0.2D1 * dble(lt) * kappa * sqrt(d
     #ble(sn)) * sqrt(dble(1 - sn)) + (lz ** 2 + kappa ** 2) * dble(sn)
      J6 = dble(lt ** 2 * (1 - sn)) - 0.2D1 * dble(lt) * kappa * sqrt(d
     #ble(sn)) * sqrt(dble(1 - sn)) + (lz ** 2 + kappa ** 2) * dble(sn)
      J1 = lr ** 2 + lt ** 2 + lz ** 2 + kappa ** 2

C Gent2 torze pressure
      P= (dble(lt ** 2 * (c * Jm / (Jm - J1 + 3) + 2 * mu * (J4 - 1) 
     #* (1 - sn) * Jf / (Jf ** 2 - (J4 - 1) ** 2) + 2 * mu * (J6 - 1) * 
     #(1 - sn) * Jf / (Jf ** 2 - (J6 - 1) ** 2))) + 0.2D1 * kappa * dble
     #(lt) * (0.4D1 * dble(mu) * dble(J4 - 1) * sqrt(dble(sn)) * sqrt(db
     #le(1 - sn)) * dble(Jf) / dble(Jf ** 2 - (J4 - 1) ** 2) - 0.4D1 * d
     #ble(mu) * dble(J6 - 1) * sqrt(dble(sn)) * sqrt(dble(1 - sn)) * dbl
     #e(Jf) / dble(Jf ** 2 - (J6 - 1) ** 2)) + kappa ** 2 * dble(c * Jm 
     #/ (Jm - J1 + 3) + 2 * mu * (J4 - 1) * sn * Jf / (Jf ** 2 - (J4 - 1
     #) ** 2) + 2 * mu * (J6 - 1) * sn * Jf / (Jf ** 2 - (J6 - 1) ** 2))
     # - dble(lr ** 2 * c * Jm / (Jm - J1 + 3))) / r

C GENT2 torze Force
      F= (dble(2 * lz ** 2 * (c * Jm / (Jm - J1 + 3) + 2 * mu * (J4 -
     # 1) * sn * Jf / (Jf ** 2 - (J4 - 1) ** 2) + 2 * mu * (J6 - 1) * sn
     # * Jf / (Jf ** 2 - (J6 - 1) ** 2))) - dble(lr ** 2 * c * Jm / (Jm 
     #- J1 + 3)) - dble(lt ** 2 * (c * Jm / (Jm - J1 + 3) + 2 * mu * (J4
     # - 1) * (1 - sn) * Jf / (Jf ** 2 - (J4 - 1) ** 2) + 2 * mu * (J6 -
     # 1) * (1 - sn) * Jf / (Jf ** 2 - (J6 - 1) ** 2))) - 0.2D1 * kappa 
     #* dble(lt) * (0.4D1 * dble(mu) * dble(J4 - 1) * sqrt(dble(sn)) * s
     #qrt(dble(1 - sn)) * dble(Jf) / dble(Jf ** 2 - (J4 - 1) ** 2) - 0.4
     #D1 * dble(mu) * dble(J6 - 1) * sqrt(dble(sn)) * sqrt(dble(1 - sn))
     # * dble(Jf) / dble(Jf ** 2 - (J6 - 1) ** 2)) - kappa ** 2 * dble(c
     # * Jm / (Jm - J1 + 3) + 2 * mu * (J4 - 1) * sn * Jf / (Jf ** 2 - (
     #J4 - 1) ** 2) + 2 * mu * (J6 - 1) * sn * Jf / (Jf ** 2 - (J6 - 1) 
     #** 2))) * r

C Gent2 torze moment
      rmom= lz * (lt * (0.4D1 * mu * dble(J4 - 1) * sqrt(sn) * sqrt(0.1D
     #1 - sn) * dble(Jf) / dble(Jf ** 2 - (J4 - 1) ** 2) - 0.4D1 * mu * 
     #dble(J6 - 1) * sqrt(sn) * sqrt(0.1D1 - sn) * dble(Jf) / dble(Jf **
     # 2 - (J6 - 1) ** 2)) + kappa * (dble(c * Jm / (Jm - J1 + 3)) + 0.2
     #D1 * mu * dble(J4 - 1) * sn * dble(Jf) / dble(Jf ** 2 - (J4 - 1) *
     #* 2) + 0.2D1 * mu * dble(J6 - 1) * sn * dble(Jf) / dble(Jf ** 2 - 
     #(J6 - 1) ** 2))) * r ** 2

      if(i.eq.1.or.i.eq.nint)then
         psum=psum+p*.5
	   fsum=fsum+f*.5
	   rsum=rsum+rmom*.5
	else
         psum=psum+p
	   fsum=fsum+f
	   rsum=rsum+rmom
	endif
	r=r+dr

	WRITE(77,'(F10.6,3E11.4)')R,P,F,RMOM

      END DO

      RESULTP=psum*dr
	RESULTF=fsum*dr*pi
	RESULTM=rsum*dr*pi*2

      WRITE(77,'('' p='',E10.3,'' F='',e10.3,'' Mk='',E10.3)')
     /RESULTP,RESULTF,RESULTM

	END
C GENT2 torze end

C GENT1 torze======================================
C 12.8.2009
      SUBROUTINE AORTAG1T(RO,RSI,RSO,OMEGA,LAMBDA,DELTA,ALFA,
     /C1,MU,JF,SN2,RESULTP,RESULTF,RESULTM,N)
	REAL MU,JF,LAMBDA
C Numericka integrace neo-Hook+GENT1 torze, dle vztahu L.Horny
C Konstitutivni rovnice Gent1 (C1,Jf,mju,beta)
C VSTUP: polomer vnejsi RO
C        RSI,RSO - nezatizena trubice
C        OMEGA - uhel zkrouceni v radianech
C        LAMBDA - axialni stretch po zatizeni uzavrene trubice
C        DELTA - stretch po uzavreni (a bez zatizeni)
C        ALFA- uhel rozevreni (ve stupnich)
C        C1,K1,K2,SN2=(sin beta)^2
      REAL LZ,LT,LR,J4,J6,KAPPA

	NINT=MAX0(5,N)

      OPEN(77,FILE='GENT1T.TXT')
	WRITE(77,'(''GENT1: C='',E10.3,'' MU='',E10.3,'' Jf='',E10.3,
     /'' SN2='',F6.4,'' N='',I4)')C1,MU,JF,SN2,N
      WRITE(77,'(''ro='',E10.3,'' RI='',E10.3,'' RO='',E10.3,
     /'' ALFA[deg]='',E10.3,'' LAMBDA='',E10.3,'' OMEGA='',E10.3)')
     /RO,RSI,RSO,ALFA,LAMBDA,OMEGA 

      PI=3.14159
      SN=sqrt(SN2)
	ALPHA=ALFA*pi/180.
C Pozor od 18.8.2009 Lukas zadava uhel ve stupnich!!!
C ZT=je snad zbytecne
      ZT=1
C      ALPHA=ALFA
      ri = sqrt(lambda * delta * (lambda * delta * RO ** 2 - RSO ** 2 + 
     #RSI ** 2)) / lambda / delta
      DR=(RO-RI)/(NINT-1)
	R=RI
C F-axial force
	Fsum=0
	Psum=0
	Rsum=0

	DO I=1,NINT
C Gent1 torze pressure
C Nova verze Horny 24.8.2009
C Pomocne promenne
      lt = 0.3141592654D1 * r * ((0.3141592654D1 - alpha) * (-0.3141592
     #654D1 * lambda * delta * RO ** 2 + 0.3141592654D1 * lambda * delta
     # * r ** 2 + 0.3141592654D1 * (0.2D1 * 0.3141592654D1 * RSO - RSO *
     # alpha + RSI * alpha) ** 2 / (0.2D1 * 0.3141592654D1 - 0.2D1 * alp
     #ha) ** 2 - alpha * (0.2D1 * 0.3141592654D1 * RSO - RSO * alpha + R
     #SI * alpha) ** 2 / (0.2D1 * 0.3141592654D1 - 0.2D1 * alpha) ** 2))
     # ** (-0.1D1 / 0.2D1)
      lz = lambda * delta
      lr = sqrt((0.3141592654D1 - alpha) * (-0.3141592654D1 * lambda * 
     #delta * RO ** 2 + 0.3141592654D1 * lambda * delta * r ** 2 + 0.314
     #1592654D1 * (0.2D1 * 0.3141592654D1 * RSO - RSO * alpha + RSI * al
     #pha) ** 2 / (0.2D1 * 0.3141592654D1 - 0.2D1 * alpha) ** 2 - alpha 
     #* (0.2D1 * 0.3141592654D1 * RSO - RSO * alpha + RSI * alpha) ** 2 
     #/ (0.2D1 * 0.3141592654D1 - 0.2D1 * alpha) ** 2)) / 0.3141592654D1
     # / r / lambda / delta
      kappa = omega * r * delta
      J4 = dble(lt ** 2 * (1 - sn)) + 0.2D1 * dble(lt) * kappa * sqrt(d
     #ble(sn)) * sqrt(dble(1 - sn)) + (lz ** 2 + kappa ** 2) * dble(sn)
      J6 = dble(lt ** 2 * (1 - sn)) - 0.2D1 * dble(lt) * kappa * sqrt(d
     #ble(sn)) * sqrt(dble(1 - sn)) + (lz ** 2 + kappa ** 2) * dble(sn)
C Gent1 torze tlak
      P=(dble(lt ** 2 * (2 * c1 + 2 * mu * (J4 - 1) * (1 - sn) * Jf 
     #/ (Jf ** 2 - (J4 - 1) ** 2) + 2 * mu * (J6 - 1) * (1 - sn) * Jf / 
     #(Jf ** 2 - (J6 - 1) ** 2))) + 0.2D1 * kappa * dble(lt) * (0.4D1 * 
     #dble(mu) * dble(J4 - 1) * sqrt(dble(sn)) * sqrt(dble(1 - sn)) * db
     #le(Jf) / dble(Jf ** 2 - (J4 - 1) ** 2) - 0.4D1 * dble(mu) * dble(J
     #6 - 1) * sqrt(dble(sn)) * sqrt(dble(1 - sn)) * dble(Jf) / dble(Jf 
     #** 2 - (J6 - 1) ** 2)) + kappa ** 2 * dble(2 * c1 + 2 * mu * (J4 -
     # 1) * sn * Jf / (Jf ** 2 - (J4 - 1) ** 2) + 2 * mu * (J6 - 1) * sn
     # * Jf / (Jf ** 2 - (J6 - 1) ** 2)) - dble(2 * lr ** 2 * c1)) / r
C GENT1 torze Force
      F= (dble(2 * lz ** 2 * (2 * c1 + 2 * mu * (J4 - 1) * sn * Jf / (
     #Jf ** 2 - (J4 - 1) ** 2) + 2 * mu * (J6 - 1) * sn * Jf / (Jf ** 2 
     #- (J6 - 1) ** 2))) - dble(2 * lr ** 2 * c1) - dble(lt ** 2 * (2 * 
     #c1 + 2 * mu * (J4 - 1) * (1 - sn) * Jf / (Jf ** 2 - (J4 - 1) ** 2)
     # + 2 * mu * (J6 - 1) * (1 - sn) * Jf / (Jf ** 2 - (J6 - 1) ** 2)))
     # - 0.2D1 * kappa * dble(lt) * (0.4D1 * dble(mu) * dble(J4 - 1) * s
     #qrt(dble(sn)) * sqrt(dble(1 - sn)) * dble(Jf) / dble(Jf ** 2 - (J4
     # - 1) ** 2) - 0.4D1 * dble(mu) * dble(J6 - 1) * sqrt(dble(sn)) * s
     #qrt(dble(1 - sn)) * dble(Jf) / dble(Jf ** 2 - (J6 - 1) ** 2)) - ka
     #ppa ** 2 * dble(2 * c1 + 2 * mu * (J4 - 1) * sn * Jf / (Jf ** 2 - 
     #(J4 - 1) ** 2) + 2 * mu * (J6 - 1) * sn * Jf / (Jf ** 2 - (J6 - 1)
     # ** 2))) * r
C Gent1 torze moment
      rmom=lz * (lt * (0.4D1 * mu * dble(J4 - 1) * sqrt(sn) * sqrt(0.1D
     #1 - sn) * dble(Jf) / dble(Jf ** 2 - (J4 - 1) ** 2) - 0.4D1 * mu * 
     #dble(J6 - 1) * sqrt(sn) * sqrt(0.1D1 - sn) * dble(Jf) / dble(Jf **
     # 2 - (J6 - 1) ** 2)) + kappa * (dble(2 * c1) + 0.2D1 * mu * dble(J
     #4 - 1) * sn * dble(Jf) / dble(Jf ** 2 - (J4 - 1) ** 2) + 0.2D1 * m
     #u * dble(J6 - 1) * sn * dble(Jf) / dble(Jf ** 2 - (J6 - 1) ** 2)))
     # * r ** 2

      if(i.eq.1.or.i.eq.nint)then
         psum=psum+p*.5
	   fsum=fsum+f*.5
	   rsum=rsum+rmom*.5
	else
         psum=psum+p
	   fsum=fsum+f
	   rsum=rsum+rmom
	endif
	r=r+dr

	WRITE(77,'(F10.6,3E11.4)')R,P,F,RMOM

      END DO

      RESULTP=psum*dr
	RESULTF=fsum*dr*pi
	RESULTM=rsum*dr*pi*2

      WRITE(77,'('' p='',E10.3,'' F='',E10.3,'' Mk='',E10.3)')
     /RESULTP,RESULTF,RESULTM

	END
C GENT1 torze end

C HOLZAPFEL torze========================================================
C 12.8.2009
      SUBROUTINE AORTAHT(RO,RSI,RSO,OMEGA,LAMBDA,DELTA,ALFA,
     /C1,K1,K2,SN2,RESULTP,RESULTF,RESULTM,N)
	REAL K1,K2,LAMBDA
C Numericka integrace neo-Hook+Holzapfel, dle vztahu L.Horny
C Konstitutivni rovnice Holzapfel C1,RK1,RK2, SIN2=(sin beta)^2
C W=c1(J-1)+k1.exp[k2.(lt^2.cos beta^2+lz^2.sin beta^2-1)]
C VSTUP: polomer vnejsi RO
C        RSI,RSO - nezatizena trubice
C        OMEGA - uhel zkrouceni v radianech
C        LAMBDA - axialni stretch po zatizeni uzavrene trubice
C        DELTA - stretch po uzavreni (a bez zatizeni)
C        ALFA- uhel rozevreni (ve stupnich)
C        C1,K1,K2,SN2=(sin beta)^2
C VYSTUP: result - tlak na vnitrnim povrchu
C VYSTUP: F      - axialni sila
      REAL LZ,LT,LR,J4,J6,KAPPA

      OPEN(77,FILE='HOLZT.TXT')
	WRITE(77,'(''HOLZ: C='',E10.3,'' K1='',E10.3,'' K2='',E10.3,
     /'' SN2='',F6.4,'' N='',I4)')C1,K1,K2,SN2,N
      WRITE(77,'(''ro='',E10.3,'' RI='',E10.3,'' RO='',E10.3,
     /'' ALFA[deg]='',E10.3,'' LAMBDA='',E10.3,'' OMEGA='',E10.3)')
     /RO,RSI,RSO,ALFA,LAMBDA,OMEGA 

      PI=3.14159
	SN=sqrt(SN2)
	ALPHA=pi*alfa/180.
	NINT=MAX0(10,N)
      ri = sqrt(lambda * delta * (lambda * delta * RO ** 2 - RSO ** 2 + 
     #RSI ** 2)) / lambda / delta
      DR=(RO-RI)/(NINT-1)
	R=RI
C F-axial force
	Fsum=0
	Psum=0
	Rsum=0
	DO I=1,NINT
C Nova uprava 24.8.2009
C Pomocne promenne
	lt = 0.3141592654D1 * r * ((0.3141592654D1 - alpha) * (-0.3141592
     #654D1 * lambda * delta * RO ** 2 + 0.3141592654D1 * lambda * delta
     # * r ** 2 + 0.3141592654D1 * (0.2D1 * 0.3141592654D1 * RSO - RSO *
     # alpha + RSI * alpha) ** 2 / (0.2D1 * 0.3141592654D1 - 0.2D1 * alp
     #ha) ** 2 - alpha * (0.2D1 * 0.3141592654D1 * RSO - RSO * alpha + R
     #SI * alpha) ** 2 / (0.2D1 * 0.3141592654D1 - 0.2D1 * alpha) ** 2))
     # ** (-0.1D1 / 0.2D1)
      lz = lambda * delta
      lr = sqrt((0.3141592654D1 - alpha) * (-0.3141592654D1 * lambda * 
     #delta * RO ** 2 + 0.3141592654D1 * lambda * delta * r ** 2 + 0.314
     #1592654D1 * (0.2D1 * 0.3141592654D1 * RSO - RSO * alpha + RSI * al
     #pha) ** 2 / (0.2D1 * 0.3141592654D1 - 0.2D1 * alpha) ** 2 - alpha 
     #* (0.2D1 * 0.3141592654D1 * RSO - RSO * alpha + RSI * alpha) ** 2 
     #/ (0.2D1 * 0.3141592654D1 - 0.2D1 * alpha) ** 2)) / 0.3141592654D1
     # / r / lambda / delta
      kappa = omega * r * delta
      J4 = dble(lt ** 2 * (1 - sn)) + 0.2D1 * dble(lt) * kappa * sqrt(d
     #ble(sn)) * sqrt(dble(1 - sn)) + (lz ** 2 + kappa ** 2) * dble(sn)
      J6 = dble(lt ** 2 * (1 - sn)) - 0.2D1 * dble(lt) * kappa * sqrt(d
     #ble(sn)) * sqrt(dble(1 - sn)) + (lz ** 2 + kappa ** 2) * dble(sn)
C Holzapfel torze pressure
      P= (lt ** 2 * (dble(2 * c1) + 0.2D1 * k1 * dble(J4 - 1) * dble(1
     # - sn) * exp(dble(k2 * (J4 - 1) ** 2)) + 0.2D1 * k1 * dble(J6 - 1)
     # * dble(1 - sn) * exp(dble(k2 * (J6 - 1) ** 2))) + 0.2D1 * kappa *
     # lt * (0.4D1 * k1 * dble(J4 - 1) * sqrt(dble(sn)) * sqrt(dble(1 - 
     #sn)) * exp(dble(k2 * (J4 - 1) ** 2)) - 0.4D1 * k1 * dble(J6 - 1) *
     # sqrt(dble(sn)) * sqrt(dble(1 - sn)) * exp(dble(k2 * (J6 - 1) ** 2
     #))) + kappa ** 2 * (dble(2 * c1) + 0.2D1 * k1 * dble(J4 - 1) * dbl
     #e(sn) * exp(dble(k2 * (J4 - 1) ** 2)) + 0.2D1 * k1 * dble(J6 - 1) 
     #* dble(sn) * exp(dble(k2 * (J6 - 1) ** 2))) - dble(2 * lr ** 2 * c
     #1)) / r
C Holzapfel torze Force
      F= (0.2D1 * lz ** 2 * (dble(2 * c1) + 0.2D1 * k1 * dble(J4 - 1)
     # * sn * exp(dble(k2 * (J4 - 1) ** 2)) + 0.2D1 * k1 * dble(J6 - 1) 
     #* sn * exp(dble(k2 * (J6 - 1) ** 2))) - dble(2 * lr ** 2 * c1) - l
     #t ** 2 * (dble(2 * c1) + 0.2D1 * k1 * dble(J4 - 1) * (0.1D1 - sn) 
     #* exp(dble(k2 * (J4 - 1) ** 2)) + 0.2D1 * k1 * dble(J6 - 1) * (0.1
     #D1 - sn) * exp(dble(k2 * (J6 - 1) ** 2))) - 0.2D1 * kappa * lt * (
     #0.4D1 * k1 * dble(J4 - 1) * sqrt(sn) * sqrt(0.1D1 - sn) * exp(dble
     #(k2 * (J4 - 1) ** 2)) - 0.4D1 * k1 * dble(J6 - 1) * sqrt(sn) * sqr
     #t(0.1D1 - sn) * exp(dble(k2 * (J6 - 1) ** 2))) - kappa ** 2 * (dbl
     #e(2 * c1) + 0.2D1 * k1 * dble(J4 - 1) * sn * exp(dble(k2 * (J4 - 1
     #) ** 2)) + 0.2D1 * k1 * dble(J6 - 1) * sn * exp(dble(k2 * (J6 - 1)
     # ** 2)))) * r
C Holzapfel torze Momemnt
      RMOM=lz * (lt * (0.4D1 * k1 * dble(J4 - 1) * sqrt(sn) * sqrt(0.1D
     #1 - sn) * exp(dble(k2 * (J4 - 1) ** 2)) - 0.4D1 * k1 * dble(J6 - 1
     #) * sqrt(sn) * sqrt(0.1D1 - sn) * exp(dble(k2 * (J6 - 1) ** 2))) +
     # kappa * (dble(2 * c1) + 0.2D1 * k1 * dble(J4 - 1) * sn * exp(dble
     #(k2 * (J4 - 1) ** 2)) + 0.2D1 * k1 * dble(J6 - 1) * sn * exp(dble(
     #k2 * (J6 - 1) ** 2)))) * r ** 2

      if(i.eq.1.or.i.eq.nint)then
         psum=psum+p*.5
	   fsum=fsum+f*.5
	   rsum=rsum+rmom*.5
	else
         psum=psum+p
	   fsum=fsum+f
	   rsum=rsum+rmom
	endif

	WRITE(77,'(F10.6,3E11.4)')R,P,F,RMOM

	r=r+dr
      END DO

      RESULTP=psum*dr
	RESULTF=fsum*dr*pi
	RESULTM=rsum*dr*pi*2

      WRITE(77,'('' p='',E10.3,'' F='',E10.3,'' Mk='',E10.3)')
     /RESULTP,RESULTF,RESULTM

      END
C HOLZAPFEL torze end


C	SUBROUTINE AORTAS(RO,RSI,RSO,THETA,E,CHI,Z,WESULT)
C Zjednoduseny model aorty
C St=E.et/(1-chi.exp(-Z.et))
C Sz=E.et/(1-chi.exp(-Z.ez))
C VSTUP: polomer vnejsi RO
C        RSI,RSO - nezatizena trubice
C VYSTUP: result - tlak na vnitrnim povrchu
c	T=1-THETA/180.
C 1.faze vypocet RSSI,RSSO referencni rozevrene konfigurace
c      DRSSI=RSI*.1
c	RSSI=RSI/T
c	DO I=1,100
c	  RSSO=SQRT((RSO**2-RSI**2)/T+RSSI**2)
c	  ETI=RSI/(T*RSSI)-1
c	  ETO=RSO/(T*RSSO)-1
c	  RES=ETI*(1+CHI*EXP(-Z*ETO))+ETO*(1+CHI*EXP(-Z*ETI))
c	  IF(I.GT.1.AND.RES*RESO.LE.0.)EXIT
c	  RESO=RES
c	  RSSI=RSSI+DRSSI
c     ENDDO
C je treba provest zpresneni
c      RI=SQRT(RO**2-RSO**2+RSI**2)
c	ETI=RI/(T*RSSI)-1
c	ETO=RO/(T*RSSO)-1
c     STI=ETI/(1+CHI*EXP(-Z*ETI))
c      STO=ETO/(1+CHI*EXP(-Z*ETO))
c	WESULT=(STI+STO)*(RO/RI-1)/2
c	END

C----------------------------------TAHOVE ZKOUSKY
C Nazvy modelu odvozene od autora F-Fung, H-Holzapfel, G-Gent

C ------------------------FUNG

      SUBROUTINE ELONEXF(RL1,RL2,W1,W2,H,C1,C2,B1,B2,B3,
     /      F1,F2,s1,s2,ds1dl1,ds1dl2,ds2dl1,ds2dl2)
C FUNG
C Tensile stress experiment Fung 5 param.
C RL1,RL2 stretches
C W1xW2 area 
C H thickness
C Konstitutivni rovnice W=C1(J-3)+C2.[exp(B1.Et^2+B2.Ez^2+2B3.Et.Ex)-1]
C Results
C F1,F2 - forces [N]
C S1,S2 - Cauchys' stresses
C DS1DL1  d sigma11/ d lambda1
C DS1DL2  d sigma11/ d lambda2
C DS2DL1  d sigma22/ d lambda1
C DS2DL2  d sigma22/ d lambda2
      R1=RL1**2
	R2=RL2**2
      E=EXP((B1*(R1-1)**2+B2*(R2-1)**2+2*B3*(R1-1)*(R2-1))/4)
	RB1=B1*(R1-1)+B3*(R2-1)
	RB2=B2*(R2-1)+B3*(R1-1)
	S1=2*C1*(R1-1./(R1*R2))+C2*R1*RB1*E
	S2=2*C1*(R2-1./(R1*R2))+C2*R2*RB2*E
      DS1DL1=4*C1*(RL1+1./(R1*R2*RL1))+C2*RL1*E*(2*B2*R1+RB1*(2+R1*RB1))
      DS1DL2=4*C1/(R1*R2*RL2)+C2*RL2*R1*E*(2*B3+RB1*RB2)
      DS2DL2=4*C1*(RL2+1./(R1*R2*RL2))+C2*RL2*E*(2*B2*R2+RB2*(2+R2*RB2))
      DS2DL1=4*C1/(R1*R2*RL1)+C2*RL1*R2*E*(2*B3+RB1*RB2)
	F1=S1*H*W2/RL1
	F2=S2*H*W1/RL2
      END

      SUBROUTINE ELONEXFT(RL1,RL2,W1,W2,H,C1,C2,B1,B2,B3,
     /      F1,F2,s1,s2,ds1dl1,ds1dl2,ds2dl1,ds2dl2)
C Tensile stress experiment Fung 5 param. SAMPLE ROTATED BY 90 DEGS
C         Un fact only parameters B1 and B2 are exchanged
C RL1,RL2 stretches
C W1xW2 area 
C H thickness
C Results
C F1,F2 - forces [N]
C S1,S2 - Cauchys' stresses
C DS1DL1  d sigma11/ d lambda1
C DS1DL2  d sigma11/ d lambda2
C DS2DL1  d sigma22/ d lambda1
C DS2DL2  d sigma22/ d lambda2
      R1=RL1**2
	R2=RL2**2
      E=EXP((B2*(R1-1)**2+B1*(R2-1)**2+2*B3*(R1-1)*(R2-1))/4)
	RB1=B2*(R1-1)+B3*(R2-1)
	RB2=B1*(R2-1)+B3*(R1-1)
	S1=2*C1*(R1-1./(R1*R2))+C2*R1*RB1*E
	S2=2*C1*(R2-1./(R1*R2))+C2*R2*RB2*E
      DS1DL1=4*C1*(RL1+1./(R1*R2*RL1))+C2*RL1*E*(2*B1*R1+RB1*(2+R1*RB1))
      DS1DL2=4*C1/(R1*R2*RL2)+C2*RL2*R1*E*(2*B3+RB1*RB2)
      DS2DL2=4*C1*(RL2+1./(R1*R2*RL2))+C2*RL2*E*(2*B1*R2+RB2*(2+R2*RB2))
      DS2DL1=4*C1/(R1*R2*RL1)+C2*RL1*R2*E*(2*B3+RB1*RB2)
	F1=S1*H*W2/RL1
	F2=S2*H*W1/RL2
      END

      SUBROUTINE ELONEXF1(RL1,RL2,W1,W2,H,C1,C2,B1,B2,B3,MITER,
     /      F1,F2,s1,s2,ds1dl1,ds1dl2,ds2dl1,ds2dl2)
C Uniaxial loading in 1-direction. Fung 5-params.
C In this case stress s2 (and force F2) should be zero, and 
C RL2 is only approximation at inlet, improved by iterational process
C 
      CALL ELONEXf(RL1,RL2,W1,W2,H,C1,C2,B1,B2,B3,
     /      F1,F2,s1,s2,ds1dl1,ds1dl2,ds2dl1,ds2dl2)
	ITER=0
	DO WHILE(ITER.LE.MITER.AND.ABS(F2).GT.1E-3)
	   RL2=RL2+S2/DS2DL2
         CALL ELONEXf(RL1,RL2,W1,W2,H,C1,C2,B1,B2,B3,
     /      F1,F2,s1,s2,ds1dl1,ds1dl2,ds2dl1,ds2dl2)
	   ITER=ITER+1
	ENDDO
	END

      SUBROUTINE ELONEXFT1(RL1,RL2,W1,W2,H,C1,C2,B1,B2,B3,MITER,
     /      F1,F2,s1,s2,ds1dl1,ds1dl2,ds2dl1,ds2dl2)
C Uniaxial loading in 1-direction. Fung 5-params. 90 DEGS ROTATED SAMPLE
C In this case stress s2 (and force F2) should be zero, and 
C RL2 is only approximation at inlet, improved by iterational process
C 
      CALL ELONEXFT(RL1,RL2,W1,W2,H,C1,C2,B1,B2,B3,
     /      F1,F2,s1,s2,ds1dl1,ds1dl2,ds2dl1,ds2dl2)
	ITER=0
	DO WHILE(ITER.LE.MITER.AND.ABS(F2).GT.1E-3)
	   RL2=RL2+S2/DS2DL2
         CALL ELONEXFT(RL1,RL2,W1,W2,H,C1,C2,B1,B2,B3,
     /      F1,F2,s1,s2,ds1dl1,ds1dl2,ds2dl1,ds2dl2)
	   ITER=ITER+1
	ENDDO
	END

C-------------------------GENT, HORGAN, SACCOMANDI

      SUBROUTINE ELONEXG(L1,L2,W1,W2,H,C1,C2,JM,SINBETA2,
     /      F1,F2)
	REAL JM,L1,L2
C Tensile stress experiment Gent 4 param.
C 
C RL1,RL2 stretches
C W1xW2 area 
C H thickness
C Konstitutivni rovnice W=c1(I1-3)-c2.Jm.ln[1-(I4-1)^2/Jm^2]
C I4=RL1**2*(1-SINBETA2)+RL2**2*SINBETA2 (promenna D)
C Results
C F1,F2 - forces [N]
      R1=L1**2
	R2=L2**2
	COS2=1-SINBETA2
	SIN2=SINBETA2
	D=R1*COS2+R2*SIN2-1
	F1=(2*C1*(R1-1/(R1*R2))+4*C2*JM*D*R1*COS2/(JM**2-D**2))*H*W2/L1
     	F2=(2*C1*(R2-1/(R1*R2))+4*C2*JM*D*R2*SIN2/(JM**2-D**2))*H*W1/L2
      END

      SUBROUTINE ELONEXG1(L1,LX,W1,W2,H,C1,C2,JM,SINBETA2,MITER,
     /      F1,FX)
	REAL JM,L1,LX,LA,LB
C Uniaxial loading in 1-direction. GENT 4-params. 
C In this case force F2 should be zero, and 
C L2 is only approximation at inlet, improved by iterational process
C 
C Metoda puleni intervalu hledani parametru L2 v intervalu 0.5 az 5
      LA=0.5
	LB=5.
      CALL ELONEXG(L1,LA,W1,W2,H,C1,C2,JM,SINBETA2,F1,FA)
      CALL ELONEXG(L1,LB,W1,W2,H,C1,C2,JM,SINBETA2,F1,FB)
	IF(FA*FB.GE.0.)THEN
	      WRITE(10,*)' No root for transversal stretch'
	      RETURN
      ENDIF
      DO IT=1,MIN0(MITER,20)
        LX=(LA+LB)/2.
        CALL ELONEXG(L1,LX,W1,W2,H,C1,C2,JM,SINBETA2,F1,FX)
        IF(FX*FA.LT.0.)THEN
           LB=LX
           FB=FX
        ELSE
           LA=LX  
           FA=FX  
        ENDIF
      ENDDO
	END

C------------------------------HOLZAPFEL, OGDEN

      SUBROUTINE ELONEXH(L1,L2,W1,W2,H,C1,K1,K2,SINBETA2,
     /      F1,F2)
	REAL K1,K2,L1,L2
C Tensile stress experiment HOLZAPFELt 4 param.
C 
C RL1,RL2 stretches
C W1xW2 area 
C H thickness
C Konstitutivni rovnice W=c1(I1-3)+K1.[exp(K2.(I4-1)^2)-1]
C I4=RL1**2*(1-SINBETA2)+RL2**2*SINBETA2
C Results
C F1,F2 - forces [N]
      R1=L1**2
	R2=L2**2
	COS2=1-SINBETA2
	SIN2=SINBETA2
	D=R1*COS2+R2*SIN2-1
	F1=(2*C1*(1-1/(R1**2*R2))+4*k1*k2*D*COS2*exp(k2*d**2))*H*W2*L1
	F2=(2*C1*(1-1/(R2**2*R1))+4*k1*k2*D*SIN2*exp(k2*d**2))*H*W1*L2
      END

      SUBROUTINE ELONEXH1(L1,LX,W1,W2,H,C1,K1,K2,SINBETA2,MITER,
     /      F1,FX)
	REAL K1,K2,L1,LX,LA,LB
C Uniaxial loading in 1-direction. HOLZAPFEL 4-params. 
C In this case force F2 should be zero, and 
C L2 is only approximation at inlet, improved by iterational process
C 
C Metoda puleni intervalu hledani parametru L2 v intervalu 0.5 az 5
      LA=0.5
	LB=5.
      CALL ELONEXH(L1,LA,W1,W2,H,C1,K1,K2,SINBETA2,F1,FA)
      CALL ELONEXH(L1,LB,W1,W2,H,C1,K1,K2,SINBETA2,F1,FB)
	IF(FA*FB.GE.0.)THEN
	      WRITE(10,*)' No root for transversal stretch'
	      RETURN
      ENDIF
      DO IT=1,MIN0(MITER,20)
        LX=(LA+LB)/2.
        CALL ELONEXH(L1,LX,W1,W2,H,C1,K1,K2,SINBETA2,F1,FX)
        IF(FX*FA.LT.0.)THEN
           LB=LX
           FB=FX
        ELSE
           LA=LX  
           FA=FX  
        ENDIF
      ENDDO
	END

