C $$-COMM sdilena sekce pro DOS i WIN 
      SUBROUTINE TINE(IA,ILST,KA,TFU,RES)
C
C ͻ
C  Interpret RPN v jednoduche presnosti (logicke a relacni operatory)    
C ͼ
C
C IA - vektor RPN (posledni kod je ILST)
C KA - vektor promennych a konstant odkazovany kodem RPN
C RES - vysledek, tj. hodnota vyrazu. Skutecny parametr musi byt
C       realny!!
C
C COMMON /SCOM/IER,INDEX   - index posledne vycislovaneho vektoru 
C                            (ma vyznam pro proceduru LOVARI)
C
C Zasobnik double precision 24.9.2004
C
      INTEGER *2 ITYP,IST,IRPN,IREAL
      DOUBLE PRECISION DS1,DS2,DRES,SLIFO(20),SLIF
      DIMENSION IA(*),KA(*),SLIFO4(20)
      COMMON /SCOM/IER,INDEX,F(48)
      EQUIVALENCE (R,IR)
      IER=0
C IRPN - citac kodu 1,2,...,ILST
C IST  - ukazovatko zasobniku. Zvysuje se pri zpracovani operandu (do zasobniku)
C        snizuje se po provedeni binarni operace
      IST=0
      IRPN=0
1     IRPN=IRPN+1
      IF(IRPN.GT.ILST) GOTO 1000
      ICOD=IA(IRPN)
      IF (ICOD) 100,1000,200
C
C Operandy zaporna hodnota IA(IRPN) je vzdy dvojice -ICOD,ITYP
C ITYP
C =1 Real do zasobniku
C =2 Integer do zasobniku
C =3 vrchol zasobniku je index a prepise se prvkem vektoru Real
C =4 vrchol zasobniku je index a prepise se prvkem vektoru Intg
C =5 adresa real do zasobniku (pro prirazeni). Promenna IREAL typ promenne R=..
C =6 adresa integer do zasobniku (pro prirazeni)
C =7 adresa realneho vektoru do zasobniku A():=...
C =8 adresa integer vektoru do zasobniku M():=...
C                 
100   ICOD=-ICOD
      IRPN=IRPN+1
      ITYP=IA(IRPN)
      IF(IST.GT.19) GOTO 7000
      GO TO (101,102,103,104,105,106,107,108), ITYP
101   IST=IST+1
      IR=KA(ICOD)
      SLIFO(IST)=DBLE(R)
      GO TO 1
102   IST=IST+1
      SLIFO(IST)=FLOAT(KA(ICOD))
      GO TO 1
103   INDEX=MAX0(1,NINT(SLIFO(IST)))+ICOD-1
      IR=KA(INDEX)
      SLIFO(IST)=R
      GO TO 1
104   INDEX=MAX0(1,NINT(SLIFO(IST)))+ICOD-1
      SLIFO(IST)=FLOAT(KA(INDEX))
      GO TO 1
105   IST=IST+1
      SLIFO(IST)=ICOD
      IREAL=1
      GO TO 1
106   IST=IST+1
      SLIFO(IST)=ICOD
      IREAL=0
      GO TO 1
107   SLIFO(IST)=MAX0(1,NINT(SLIFO(IST)))+ICOD-1
      IREAL=1
      GO TO 1
108   SLIFO(IST)=MAX0(1,NINT(SLIFO(IST)))+ICOD-1
      IREAL=0
      GO TO 1
C Operace
200   IF (ICOD.LT.17) IST=IST-1
      IF (ICOD.GT.25) GO TO 500
      IF (IST) 2000,2000,201
201   GO TO (202,203,204,205,206,207,208,209,
     /       210,220,230,240,250,260,1000,1000,1000,300,310,
     /       320,330,340,350,360,370), ICOD
C 1 relace A<=B
202   IF(SLIFO(IST).LE.SLIFO(IST+1))THEN
         SLIFO(IST)=1.
      ELSE
         SLIFO(IST)=0.
      ENDIF
      GOTO 1
C 2 relace A>=B
203   IF(SLIFO(IST).GE.SLIFO(IST+1))THEN
         SLIFO(IST)=1.
      ELSE
         SLIFO(IST)=0.
      ENDIF
      GOTO 1
C 3 relace .NE.
204   IF(ABS(SLIFO(IST)-SLIFO(IST+1)).GT.ABS(SLIFO(IST))*1E-5)THEN
         SLIFO(IST)=1.
      ELSE
         SLIFO(IST)=0.
      ENDIF
      GOTO 1
C 4 relace A<B
205   IF(SLIFO(IST).LT.SLIFO(IST+1))THEN
         SLIFO(IST)=1.
      ELSE
         SLIFO(IST)=0.
      ENDIF
      GOTO 1
C 5 relace A>B
206   IF(SLIFO(IST).GT.SLIFO(IST+1))THEN
         SLIFO(IST)=1.
      ELSE
         SLIFO(IST)=0.
      ENDIF
      GOTO 1
C 6 relace .EQ.
207   IF(ABS(SLIFO(IST)-SLIFO(IST+1)).LE.ABS(SLIFO(IST))*1E-5)THEN
         SLIFO(IST)=1.
      ELSE
         SLIFO(IST)=0.
      ENDIF
      GOTO 1
C 7 operace .AND.
208   IF(ABS(SLIFO(IST)).GT.1E-5.AND.ABS(SLIFO(IST+1)).GT.1E-5)THEN
         SLIFO(IST)=1.
      ELSE
         SLIFO(IST)=0.
      ENDIF
      GOTO 1
C 8 operace .OR.
209   IF(ABS(SLIFO(IST)).GT.1E-5 .OR.ABS(SLIFO(IST+1)).GT.1E-5)THEN
         SLIFO(IST)=1.
      ELSE
         SLIFO(IST)=0.
      ENDIF
      GOTO 1
C 9 scitani
210   SLIFO(IST)=SLIFO(IST)+SLIFO(IST+1)
      GO TO 1
C 10 odcitani
220   SLIFO(IST)=SLIFO(IST)-SLIFO(IST+1)
      GO TO 1
C 11 mocnina
230   EX =SLIFO(IST+1)
      IEX=IFIX(EX+0.5)
      IF (ABS(EX-FLOAT(IEX)).LE.1E-3) GO TO 232
      IF (ABS(EX).GT.1E3)GOTO 2500
      IF (SLIFO(IST)) 2500,232,231
C realny exponent
231   SLIFO(IST)=SLIFO(IST)**EX
      GO TO 1
C celociselny exponent
232   SLIFO(IST)=SLIFO(IST)**IEX
      GO TO 1
C 12 deleni
240   DS1=SLIFO(IST)
      DS2=SLIFO(IST+1)
      IF(DABS(DS2).LE.1D-40)GOTO 5000
      DRES=DS1/DS2
      IF(DABS(DRES).GT.1D30)DRES=1D20
      SLIFO(IST)=DRES
      GO TO 1
C 13 nasobeni
250   DS1=SLIFO(IST)
      DS2=SLIFO(IST+1)
      DRES=DS1*DS2
      IF(DABS(DRES).GT.1D30)DRES=1D20
      SLIFO(IST)=DRES
      GO TO 1
C 14
260   INDEX=NINT(SLIFO(IST))
      SLIFO(IST)=SLIFO(IST+1)
      IF (IREAL) 262,262,261
261   R=SNGL(SLIFO(IST))
      KA(INDEX)=IR
      GO TO 1
262   IF(SLIFO(IST).GE.0.D0) THEN
      KA(INDEX)=SLIFO(IST)+.5
      ELSE
      KA(INDEX)=SLIFO(IST)-.5
      ENDIF
      GO TO 1
C 18 unarni minus
300   SLIFO(IST)=-SLIFO(IST)
      GO TO 1
C 19 sinus
310   SLIFO(IST)=DSIN(SLIFO(IST))
      GO TO 1
C 20 cosinus
320   SLIFO(IST)=DCOS(SLIFO(IST))
      GO TO 1
C 21 exponenciala
330   SLIF=SLIFO(IST)
      IF(SLIF.LE.-50.D0)THEN
          SLIFO(IST)=0.D0
      ELSEIF(SLIF.GT.50.D0)THEN
          SLIFO(IST)=1D15
      ELSE
          SLIFO(IST)=DEXP(SLIF)
      ENDIF
      GO TO 1
C 22 odmocnina
340   IF (SLIFO(IST)) 3000,341,341
341   SLIFO(IST)=DSQRT(SLIFO(IST))
      GO TO 1
C 23 prirozeny logaritmus
350   IF (SLIFO(IST)) 4000,4000,351
351   SLIFO(IST)=DLOG(SLIFO(IST))
      GO TO 1
C 24 dekadicky logaritmus
360   IF (SLIFO(IST)) 4000,4000,361
361   SLIFO(IST)=DLOG10(SLIFO(IST))
      GO TO 1
C 25
370   SLIFO(IST)=DABS(SLIFO(IST))
      GO TO 1
C Nestandardni funkce (jejich operandy jsou v zasobniku SLIFO)
500   IRPN=IRPN+1
      IST=IST+IA(IRPN)+1
      IF (IST) 2000,2000,501
C vektor parametru uzivatelske funkce je REAL*4
501   SLIFO4=SLIFO
      SLIFO(IST)=TFU(ICOD-25,SLIFO4(IST),-IA(IRPN))
      GO TO 1
1000  RES=SNGL(SLIFO(IST))
      IF (IST.EQ.1) RETURN
C
C NEVYCERPANY ZASOBNIK (NEUPLNY PREKLAD VYRAZU)
7000  IER=-4018
      WRITE(*,'('' TINE: Translation not completed'')')
      goto 6000
C CHYBNE OPERANDY
2000  IER=-4017
      WRITE(*,'('' TINE: wrong operands'')')
      goto 6000
C ZAPORNE CISLO NA REALNY EXPONENT
2500  IER=-4019
      WRITE(*,'('' TINE: Power of negative number'')')
      goto 6000
C ODMOCNINA ZE ZAPORNEHO CISLA
3000  IER=-4021
      WRITE(*,'('' TINE: Square root of negative number'')')
      goto 6000
C LOGARITMUS ZAPORNEHO CISLA NEBO NULY
4000  IER=-4020
      WRITE(*,'('' TINE: Log of negative number or zero'')')
      goto 6000
C DELENI NULOU
5000  IER=-4008
      WRITE(*,'('' TINE: Division by zero'')')
6000  IER=(IER-10000*irpn)
      END

      SUBROUTINE COPYREL(IFROM,ITO)
C
C Kopirovani vsech pocitanych stupnu volnosti (JDOF(NDOF)) ze zony IFROM do ITO
C s podrelaxaci danou hodnotou relaxacniho faktoru $RELFAKT (v zone fem-com).
C Soucasne se pocitaji stredni absolutni hodnoty kopirovanych DOF a
C norma jejich rozdilu - tyto vysledky se ukladaji do vektoru
C DOFRESI(MAXTDOF) a DOFMEAN(MAXTDOF), ktere jsou definovany v $FEM.
C
      INCLUDE '$FEM'
      INCLUDE '$FEM-EQU'
      DIMENSION NCOUNT(MAXTDOF)
      DO K=1,NDOF
         JDOFK=JDOF(K)
         IF(LPU(JDOFK).GE.0)THEN
           DOFRESI(JDOFK)=0.
           DOFMEAN(JDOFK)=0.
         ENDIF
      ENDDO
      DO I=1,ND
         DO K=1,NDOF
            JDOFK=JDOF(K)
            IF(LPU(JDOFK).GE.0)THEN
               LJ=LPU(JDOFK)+I
               DOFRESI(JDOFK)=DOFRESI(JDOFK)+
     /                             ABS(VAL(LJ,ITO)-VAL(LJ,IFROM))
               DOFMEAN(JDOFK)=DOFMEAN(JDOFK)+ABS(VAL(LJ,IFROM))
               NCOUNT(JDOFK)=NCOUNT(JDOFK)+1
               VAL(LJ,ITO)=$RELFAKT*VAL(LJ,IFROM)+
     /                     (1-$RELFAKT)*VAL(LJ,ITO)
            ENDIF
         ENDDO
      ENDDO
      DO K=1,NDOF
         JDOFK=JDOF(K)
         IF(NCOUNT(JDOFK).GT.0.AND.DOFMEAN(JDOFK).GT.0.)THEN
            DOFRESI(JDOFK)=DOFRESI(JDOFK)/DOFMEAN(JDOFK)
            DOFMEAN(JDOFK)=DOFMEAN(JDOFK)/NCOUNT(JDOFK)
         ENDIF
      ENDDO
      END

      SUBROUTINE COPY(IFROM,ITO)
C
C Kopirovani vsech pocitanych stupnu volnosti (JDOF(NDOF)) ze zony IFROM do ITO
C
      INCLUDE '$FEM'
      DO I=1,ND
         DO K=1,NDOF
            JDOFK=JDOF(K)
            IF(LPU(JDOFK).GE.0)THEN
               LJ=LPU(JDOFK)+I
               VAL(LJ,ITO)=VAL(LJ,IFROM)
            ENDIF
         ENDDO
      ENDDO
      END

      SUBROUTINE LOADIN
C VYNULOVANI VEKTORU X() ODPOVIDAJICI VOLNYM PARAMETRUM (ZATIZENI)
C Procedura aktualizuje pouze aktivni stupne volnosti JDOF(1..NDOF)
      INCLUDE '$FEMB'
      DO I=1,ND
        AUX(2)=XX(I)
        AUX(3)=YY(I)
        AUX(4)=ZZ(I)
        DO J=1,MDOF
C AUX(): TIME,XX,YY,ZZ,TEMP,UX,UY,UZ
           IF(LPU(J).GE.0)AUX(J+$LDOF)=VAL(LPU(J)+I,3)
        ENDDO
        DO K=1,NDOF
           IND0=LPU(JDOF(K))
           IF(IND0.GE.0)THEN
             IND=IND0+I
             IFUN=IPU(IND)
             IF(IFUN.LE.10)THEN
                VAL(IND,2)=VAL(IND,1)*CURFUN(IFUN)
             ELSEIF(IFUN.LE.20)THEN
                VAL(IND,1)=CURFUN(IFUN)
                VAL(IND,2)=0.
             ELSEIF(IFUN.LE.50)THEN
                VAL(IND,2)=0.
             ENDIF
           ENDIF
        ENDDO
      ENDDO
      END

      SUBROUTINE EDOF(IE,IOPER,NDL,INDL,MDOFL,NDOFL,IDOFL)
C Vstupni parametry IE-index elementu, IOPER-operace
C Vystupni parametry
C NDL INDL(NDL) indexy uzlu elementu (event. zaporne hodnoty)
C MDOFL celkovy pocet DOF elementu
C NDOFL(I) pocet DOF v uzlu I
C IDOFL(I,J) pozice J-teho DOF I-teho uzlu vzhledem k pocatku matice VAL
C 
      PARAMETER (MAXNDL=20,MAXNDOFL=6)
      DIMENSION INDL(MAXNDL),NDOFL(MAXNDL),IDOFL(MAXNDL,MAXNDOFL)
      INCLUDE '$FEMEQ'
C Indexy uzlu elementu 
C NDL-pocet uzlu
C NDLR-pocet uzlu na hranici (bez vnitrniho uzlu)
C MUEL-kodove cislo poctu uzlu elementu (muze byt i zaporne)
C   
C      MUEL=2          usecka
C      MUEL=-4 MINT=1  T3-stredy stran + teziste
C      MUEL=3          T3-vrcholy
C      MUEL=4          Q4-bilinearni
C      MUEL=4  MINT=1  T3-vrcholy + teziste
C      MUEL=5  MINT=1  Q4-bilinearni + teziste
C      MUEL=6          T6-kvadraticky
C      MUEL=7  MINT=1  T6-kvadraticky + bublina
C      MUEL=8          Q8-bikvadraticky
C      MUEL=9  MINT=1  Q9
C    
      LOC=LUE(IE)
      MUEL=MUE(IE)
      MINTN=MINT(IE)
      NDL=IABS(MUEL)
      NDLR=NDL-MINTN
      DO I=1,NDL
         INDL(I)=IUE(LOC+I)
      ENDDO
      IG=MAX0(1,IGROUP(IE))
      IETYP=JGROUP(IG,$ENAME)
C
C IETYP: 1-PIPE2D 2-PIPE3D 3-TRUSS2D 4-TRUSS3D 5-BEAM2D 6-BEAM3D
C        7-CSTR   8-PUMP   9-VALVE  10-SHELLAX 11-HEXCH 12-PLANE2D
C      13-FLOW2D 14-FLOW3D 15-user  16-MASS 17-SOLID 18-SPHERE 19-CYLINDER
C     
C IOPER: 1-ELEC 3-FLOW 3-THER 4-CONC 5-COND 6-CONA 7-STAT
C
      SELECT CASE(IETYP)
C Trideni dle nazvu elementu IETYP a pak dle operaci IOPER.
C Definuji se tyto promenne
C NDL       - pocet uzlu elementu
C MDOFL     - rozmer matice (celkovy pocet stupnu volnosti)
C NDOFL(i)  - pocet parametru v uzlu
C IDOFL(i,j)- pozice j-teho parametru i-teho uzlu v zone FEM
C
      CASE($USER)
C USER NDL uzlu, v kazdem uzlu jej jeden parametr (tlak, koncentrace nebo teplota)
         MDOFL=NDL
         DO I=1,NDL
            NDOFL(I)=1
            SELECT CASE(IOPER)       
            CASE($ELEC)
              IDOFL(I,1)=LPU($VOLT)+IABS(INDL(I))
            CASE($FLOW)
              IDOFL(I,1)=LPU($PRES)+IABS(INDL(I))
            CASE($THER)
              IDOFL(I,1)=LPU($TEMP)+IABS(INDL(I))
            CASE($CONC)
              IDOFL(I,1)=LPU($CN)+IABS(INDL(I))
            CASE($COND)
              IDOFL(I,1)=LPU($CD)+IABS(INDL(I))
            CASE($CONA)
              IDOFL(I,1)=LPU($CA)+IABS(INDL(I))
            CASE($STAT)
              MDOFL=2*NDL
              NDOFL(I)=2
              IDOFL(I,1)=LPU($UX)+IABS(INDL(I))
              IDOFL(I,2)=LPU($UY)+IABS(INDL(I))
            ENDSELECT
         ENDDO
      CASE($PIPE2D,$CSTR,$PUMP,$VALVE)
C PIPE2D, CSTR, PUMP, VALVE-------------------------
         NDL=2
         SELECT CASE(IOPER)
         CASE($ELEC)
C   ELEC 
           MDOFL=2
           DO I=1,2
             NDOFL(I)=1
             IDOFL(I,1)=LPU($VOLT)+IABS(INDL(I))
           ENDDO
         CASE($THER)
C   THER
           MDOFL=2
           DO I=1,2
             NDOFL(I)=1
             IDOFL(I,1)=LPU($TEMP)+IABS(INDL(I))
           ENDDO
         CASE($CONC)
C   CONC
           MDOFL=2
           DO I=1,2
             NDOFL(I)=1
             IDOFL(I,1)=LPU($CN)+IABS(INDL(I))
           ENDDO
         CASE($COND)
C   COND
           MDOFL=2
           DO I=1,2
             NDOFL(I)=1
             IDOFL(I,1)=LPU($CD)+IABS(INDL(I))
           ENDDO
         CASE($CONA)
C   CONA
           MDOFL=2
           DO I=1,2
             NDOFL(I)=1
             IDOFL(I,1)=LPU($CA)+IABS(INDL(I))
           ENDDO
         CASE($FLOW)
C   FLOW
           MDOFL=2
           DO I=1,2
             NDOFL(I)=1
             IDOFL(I,1)=LPU($PRES)+IABS(INDL(I))
           ENDDO
         CASE($STAT)
C   STAT
           MDOFL=6
           DO I=1,2
             NDOFL(I)=3
             IDOFL(I,1)=LPU($UX)+IABS(INDL(I))
             IDOFL(I,2)=LPU($UY)+IABS(INDL(I))
             IDOFL(I,3)=LPU($RZ)+IABS(INDL(I))
           ENDDO
         ENDSELECT
      CASE($PIPE3D)
C PIPE3D-------------------------
         NDL=2
         SELECT CASE(IOPER)
         CASE($ELEC)
C   ELEC 
           MDOFL=2
           DO I=1,2
             NDOFL(I)=1
             IDOFL(I,1)=LPU($VOLT)+IABS(INDL(I))
           ENDDO
         CASE($THER)
C   THER
           MDOFL=2
           DO I=1,2
             NDOFL(I)=1
             IDOFL(I,1)=LPU($TEMP)+IABS(INDL(I))
           ENDDO
         CASE($CONC)
C   CONC
           MDOFL=2
           DO I=1,2
             NDOFL(I)=1
             IDOFL(I,1)=LPU($CN)+IABS(INDL(I))
           ENDDO
         CASE($COND)
C   CONA
           MDOFL=2
           DO I=1,2
             NDOFL(I)=1
             IDOFL(I,1)=LPU($CD)+IABS(INDL(I))
           ENDDO
         CASE($CONA)
C   CONA
           MDOFL=2
           DO I=1,2
             NDOFL(I)=1
             IDOFL(I,1)=LPU($CA)+IABS(INDL(I))
           ENDDO
         CASE($FLOW)
C   FLOW
           MDOFL=2
           DO I=1,2
             NDOFL(I)=1
             IDOFL(I,1)=LPU($PRES)+IABS(INDL(I))
           ENDDO
         CASE($STAT)
C   STAT
           MDOFL=12
           DO I=1,2
             NDOFL(I)=6
             IDOFL(I,1)=LPU($UX)+IABS(INDL(I))
             IDOFL(I,2)=LPU($UY)+IABS(INDL(I))
             IDOFL(I,3)=LPU($UZ)+IABS(INDL(I))
             IDOFL(I,4)=LPU($RX)+IABS(INDL(I))
             IDOFL(I,5)=LPU($RY)+IABS(INDL(I))
             IDOFL(I,6)=LPU($RZ)+IABS(INDL(I))
           ENDDO
         ENDSELECT
      CASE($TRUSS2D)
C TRUSS2D-------------------------
         NDL=2
         SELECT CASE(IOPER)
         CASE($ELEC)
C   ELEC 
           MDOFL=2
           DO I=1,2
             NDOFL(I)=1
             IDOFL(I,1)=LPU($VOLT)+IABS(INDL(I))
           ENDDO
         CASE($THER)
C   THER
           MDOFL=2
           DO I=1,2
             NDOFL(I)=1
             IDOFL(I,1)=LPU($TEMP)+IABS(INDL(I))
           ENDDO
         CASE($CONC,$FLOW)
C   CONC,FLOW
           MDOFL=0
           NDOFL(1)=0
           NDOFL(2)=0
         CASE($STAT)
C   STAT
           MDOFL=4
           DO I=1,2
             NDOFL(I)=2
             IDOFL(I,1)=LPU($UX)+IABS(INDL(I))
             IDOFL(I,2)=LPU($UY)+IABS(INDL(I))
           ENDDO
         ENDSELECT
      CASE($TRUSS3D)
C TRUSS3D-------------------------
         NDL=2
         SELECT CASE(IOPER)
         CASE($ELEC)
C   ELEC 
           MDOFL=2
           DO I=1,2
             NDOFL(I)=1
             IDOFL(I,1)=LPU($VOLT)+IABS(INDL(I))
           ENDDO
         CASE($THER)
C   THER
           MDOFL=2
           DO I=1,2
             NDOFL(I)=1
             IDOFL(I,1)=LPU($TEMP)+IABS(INDL(I))
           ENDDO
         CASE($CONC,$FLOW)
C   CONC,FLOW
           MDOFL=0
           NDOFL(1)=0
           NDOFL(2)=0
         CASE($STAT)
C   STAT
           MDOFL=6
           DO I=1,2
             NDOFL(I)=3
             IDOFL(I,1)=LPU($UX)+IABS(INDL(I))
             IDOFL(I,2)=LPU($UY)+IABS(INDL(I))
             IDOFL(I,3)=LPU($UZ)+IABS(INDL(I))
           ENDDO
         ENDSELECT
      CASE($BEAM2D)
C BEAM2D-------------------------
         NDL=2
         SELECT CASE(IOPER)
         CASE($ELEC)
C   ELEC 
           MDOFL=2
           DO I=1,2
             NDOFL(I)=1
             IDOFL(I,1)=LPU($VOLT)+IABS(INDL(I))
           ENDDO
         CASE($THER)
C   THER
           MDOFL=2
           DO I=1,2
             NDOFL(I)=1
             IDOFL(I,1)=LPU($TEMP)+IABS(INDL(I))
           ENDDO
         CASE($CONC,$FLOW)
C   CONC,FLOW
           MDOFL=0
           NDOFL(1)=0
           NDOFL(2)=0
         CASE($STAT)
C   STAT
           MDOFL=6
           DO I=1,2
             NDOFL(I)=3
             IDOFL(I,1)=LPU($UX)+IABS(INDL(I))
             IDOFL(I,2)=LPU($UY)+IABS(INDL(I))
             IDOFL(I,3)=LPU($RZ)+IABS(INDL(I))
           ENDDO
         ENDSELECT
      CASE($BEAM3D)
C BEAM3D-------------------------
         NDL=2
         SELECT CASE(IOPER)
         CASE($ELEC)
C   ELEC 
           MDOFL=2
           DO I=1,2
             NDOFL(I)=1
             IDOFL(I,1)=LPU($VOLT)+IABS(INDL(I))
           ENDDO
         CASE($THER)
C   THER
           MDOFL=2
           DO I=1,2
             NDOFL(I)=1
             IDOFL(I,1)=LPU($TEMP)+IABS(INDL(I))
           ENDDO
         CASE($CONC,$FLOW)
C   CONC,FLOW
           MDOFL=0
           NDOFL(1)=0
           NDOFL(2)=0
         CASE($STAT)
C   STAT
           MDOFL=12
           DO I=1,2
             NDOFL(I)=6
             IDOFL(I,1)=LPU($UX)+IABS(INDL(I))
             IDOFL(I,2)=LPU($UY)+IABS(INDL(I))
             IDOFL(I,3)=LPU($UZ)+IABS(INDL(I))
             IDOFL(I,4)=LPU($RX)+IABS(INDL(I))
             IDOFL(I,5)=LPU($RY)+IABS(INDL(I))
             IDOFL(I,6)=LPU($RZ)+IABS(INDL(I))
           ENDDO
         ENDSELECT
      CASE($SHELLAX)
C SHELLAX-------------------------
         NDL=2
         SELECT CASE(IOPER)
         CASE($ELEC,$THER,$CONC,$FLOW)
C   ELEC,THER,CONC,FLOW 
           MDOFL=0
           NDOFL(1)=0
           NDOFL(2)=0
         CASE($STAT)
C   STAT
           MDOFL=6
           DO I=1,2
             NDOFL(I)=3
             IDOFL(I,1)=LPU($UX)+IABS(INDL(I))
             IDOFL(I,2)=LPU($UY)+IABS(INDL(I))
             IDOFL(I,3)=LPU($RZ)+IABS(INDL(I))
           ENDDO
         ENDSELECT
      CASE($HEXC)
C HEXC-------------------------
         NDL=4
         SELECT CASE(IOPER)
         CASE($ELEC,$STAT,$CONC)
           MDOFL=0
           NDOFL(1)=0
           NDOFL(2)=0
         CASE($FLOW)
C   pro vymeniky trubka/trubka se tlakove ztraty nepocitaji
           IF(JGROUP(IG,$METHOD).LE.10)THEN
              MDOFL=0
              NDOFL(1)=0
              NDOFL(2)=0
           ELSE
C   pro ostatni vymeniky (CHEV=11,...) je pocitan tlak
              MDOFL=4
              DO I=1,4
                NDOFL(I)=1
                IDOFL(I,1)=LPU($PRES)+IABS(INDL(I))
              ENDDO
           ENDIF         
         CASE($THER)
C   THER
           MDOFL=4
           DO I=1,4
             NDOFL(I)=1
             IDOFL(I,1)=LPU($TEMP)+IABS(INDL(I))
           ENDDO
         ENDSELECT
      CASE($PLANE2D)
C PLANE2D-------------------------ignorovani vnitrnich uzlu
         NDL=NDLR
         SELECT CASE(IOPER)
         CASE($ELEC)
C   ELEC 
           MDOFL=NDL
           DO I=1,NDL
             NDOFL(I)=1
             IDOFL(I,1)=LPU($VOLT)+IABS(INDL(I))
           ENDDO
         CASE($THER)
C   THER
           IF($IPHASE.NE.1)THEN
C $IPHASE =0 bez faz.zmen,=1 T,H formulace, =2,3,4,... fazove zmeny ale jen teploty
             MDOFL=NDL
             DO I=1,NDL
               NDOFL(I)=1
               IDOFL(I,1)=LPU($TEMP)+IABS(INDL(I))
             ENDDO
           ELSE
             MDOFL=2*NDL
             DO I=1,NDL
               NDOFL(I)=2
               IDOFL(I,1)=LPU($TEMP)+IABS(INDL(I))
               IDOFL(I,2)=LPU($HT)+IABS(INDL(I))
             ENDDO
           ENDIF
         CASE($CONC)
C   CONC
           MDOFL=NDL
           DO I=1,NDL
             NDOFL(I)=1
             IDOFL(I,1)=LPU($CN)+IABS(INDL(I))
           ENDDO
         CASE($COND)
C   COND
           MDOFL=NDL
           DO I=1,NDL
             NDOFL(I)=1
             IDOFL(I,1)=LPU($CD)+IABS(INDL(I))
           ENDDO
         CASE($CONA)
C   CONA
           MDOFL=NDL
           DO I=1,NDL
             NDOFL(I)=1
             IDOFL(I,1)=LPU($CA)+IABS(INDL(I))
           ENDDO
         CASE($FLOW)
C   FLOW
           MDOFL=0
           DO I=1,NDL
             NDOFL(I)=0
           ENDDO
         CASE($STAT)
C   STAT
           MDOFL=2*NDL
           DO I=1,NDL
             NDOFL(I)=2
             IDOFL(I,1)=LPU($UX)+IABS(INDL(I))
             IDOFL(I,2)=LPU($UY)+IABS(INDL(I))
           ENDDO
         ENDSELECT
      CASE($FLOW2D)
C FLOW2D-------------------------krome operace FLOW ignorujeme vnitrni uzly
         SELECT CASE(IOPER)
         CASE($ELEC)
C   ELEC 
           NDL=NDLR
           MDOFL=NDL
           DO I=1,NDL
             NDOFL(I)=1
             IDOFL(I,1)=LPU($VOLT)+IABS(INDL(I))
           ENDDO
         CASE($THER)
C   THER
           NDL=NDLR
           MDOFL=NDL
           DO I=1,NDL
             NDOFL(I)=1
             IDOFL(I,1)=LPU($TEMP)+IABS(INDL(I))
           ENDDO
         CASE($CONC)
C   CONC
           NDL=NDLR
           MDOFL=NDL
           DO I=1,NDL
             NDOFL(I)=1
             IDOFL(I,1)=LPU($CN)+IABS(INDL(I))
           ENDDO
         CASE($COND)
C   COND
           NDL=NDLR
           MDOFL=NDL
           DO I=1,NDL
             NDOFL(I)=1
             IDOFL(I,1)=LPU($CD)+IABS(INDL(I))
           ENDDO
         CASE($CONA)
C   CONA
           NDL=NDLR
           MDOFL=NDL
           DO I=1,NDL
             NDOFL(I)=1
             IDOFL(I,1)=LPU($CA)+IABS(INDL(I))
           ENDDO
         CASE($FLOW)
C   FLOW
           METODA=JGROUP(IG,$METHOD)
           SELECT CASE(METODA)
           CASE($UVP,$UVPP,$MIKE)
C     UVP,UVPP,MIKE
             MDOFL=0
             IF(NDLR.EQ.3)THEN
C   T3 + P0
                MDOFL=7
                DO I=1,3
                  NDOFL(I)=2
                  IDOFL(I,1)=LPU($VX)+IABS(INDL(I))
                  IDOFL(I,2)=LPU($VY)+IABS(INDL(I))
                ENDDO
                NDOFL(4)=1
                IDOFL(4,1)=LPU($PRES)+IABS(INDL(4))
             ELSEIF(NDL.EQ.5)THEN
C   Q4 + P0
                MDOFL=9
                DO I=1,4
                  NDOFL(I)=2
                  IDOFL(I,1)=LPU($VX)+IABS(INDL(I))
                  IDOFL(I,2)=LPU($VY)+IABS(INDL(I))
                ENDDO
                NDOFL(5)=1
                IDOFL(5,1)=LPU($PRES)+IABS(INDL(5))
             ELSEIF(NDL.EQ.6)THEN
C   T6 + P3  Taylor Hood
                MDOFL=15
                DO I=1,3
                  NDOFL(I)=3
                  IDOFL(I,1)=LPU($VX)+IABS(INDL(I))
                  IDOFL(I,2)=LPU($VY)+IABS(INDL(I))
                  IDOFL(I,3)=LPU($PRES)+IABS(INDL(I))
                  NDOFL(I+3)=2
                  IDOFL(I+3,1)=LPU($VX)+IABS(INDL(I+3))
                  IDOFL(I+3,2)=LPU($VY)+IABS(INDL(I+3))
                ENDDO
             ELSEIF(NDL.EQ.7)THEN
C   T7 + P3  Taylor Hood
                MDOFL=17
                DO I=1,3
                  NDOFL(I)=3
                  IDOFL(I,1)=LPU($VX)+IABS(INDL(I))
                  IDOFL(I,2)=LPU($VY)+IABS(INDL(I))
                  IDOFL(I,3)=LPU($PRES)+IABS(INDL(I))
                  NDOFL(I+3)=2
                  IDOFL(I+3,1)=LPU($VX)+IABS(INDL(I+3))
                  IDOFL(I+3,2)=LPU($VY)+IABS(INDL(I+3))
                ENDDO
                NDOFL(7)=2
                IDOFL(7,1)=LPU($VX)+IABS(INDL(7))
                IDOFL(7,2)=LPU($VY)+IABS(INDL(7))
             ELSEIF(NDL.EQ.8)THEN
C   Q8 + P4  Taylor Hood
                MDOFL=20
                DO I=1,4
                  NDOFL(I)=3
                  IDOFL(I,1)=LPU($VX)+IABS(INDL(I))
                  IDOFL(I,2)=LPU($VY)+IABS(INDL(I))
                  IDOFL(I,3)=LPU($PRES)+IABS(INDL(I))
                  NDOFL(I+4)=2
                  IDOFL(I+4,1)=LPU($VX)+IABS(INDL(I+4))
                  IDOFL(I+4,2)=LPU($VY)+IABS(INDL(I+4))
                ENDDO
       
             ELSEIF(NDL.EQ.9)THEN
C   Q9 + P4  Taylor Hood
                MDOFL=22
                DO I=1,4
                  NDOFL(I)=3
                  IDOFL(I,1)=LPU($VX)+IABS(INDL(I))
                  IDOFL(I,2)=LPU($VY)+IABS(INDL(I))
                  IDOFL(I,3)=LPU($PRES)+IABS(INDL(I))
                  NDOFL(I+4)=2
                  IDOFL(I+4,1)=LPU($VX)+IABS(INDL(I+4))
                  IDOFL(I+4,2)=LPU($VY)+IABS(INDL(I+4))
                ENDDO
                NDOFL(9)=2
                IDOFL(9,1)=LPU($VX)+IABS(INDL(9))
                IDOFL(9,2)=LPU($VY)+IABS(INDL(9))
             ENDIF
           CASE($PENS,$MIDE)
C     PENS,MIDE
             MDOFL=0
             IF(NDL.EQ.3.OR.NDL.EQ.6.OR.NDL.EQ.4.OR.NDL.EQ.8)THEN
                MDOFL=2*NDL
                DO I=1,NDL
                  NDOFL(I)=2
                  IDOFL(I,1)=LPU($VX)+IABS(INDL(I))
                  IDOFL(I,2)=LPU($VY)+IABS(INDL(I))
                ENDDO
             ENDIF
           CASE($PSIN,$CREE)
C     PSIN CREE
             MDOFL=0
             IF(NDL.EQ.3)THEN
                MDOFL=9
                DO I=1,NDL
                  NDOFL(I)=3
                  IDOFL(I,1)=LPU($PS)+IABS(INDL(I))
                  IDOFL(I,2)=LPU($PSX)+IABS(INDL(I))
                  IDOFL(I,3)=LPU($PSY)+IABS(INDL(I))
                ENDDO
             ENDIF
           CASE($PSOM,$CARE)
C     PSOM CARE uzlove parametry 1-OMG  2-PS
             MDOFL=0
             IF(NDL.EQ.3.OR.NDL.EQ.4.OR.NDL.EQ.6.OR.NDL.EQ.8)THEN
                MDOFL=2*NDL
                DO I=1,NDL
                  NDOFL(I)=2
                  IDOFL(I,1)=LPU($OMG)+IABS(INDL(I))
                  IDOFL(I,2)=LPU($PS)+IABS(INDL(I))
                ENDDO
             ENDIF
           ENDSELECT
         CASE($STAT)
C   STAT
           MDOFL=0
         ENDSELECT
      CASE($SOLID)
C SOLID-------------------------
         SELECT CASE(IOPER)
         CASE($ELEC)
C   ELEC 
           MDOFL=NDL
           DO I=1,NDL
             NDOFL(I)=1
             IDOFL(I,1)=LPU($VOLT)+IABS(INDL(I))
           ENDDO
         CASE($THER)
C   THER
           MDOFL=NDL
           DO I=1,NDL
             NDOFL(I)=1
             IDOFL(I,1)=LPU($TEMP)+IABS(INDL(I))
           ENDDO
         CASE($CONC)
C   CONC
           MDOFL=NDL
           DO I=1,NDL
             NDOFL(I)=1
             IDOFL(I,1)=LPU($CN)+IABS(INDL(I))
           ENDDO
         CASE($COND)
C   COND
           MDOFL=NDL
           DO I=1,NDL
             NDOFL(I)=1
             IDOFL(I,1)=LPU($CD)+IABS(INDL(I))
           ENDDO
         CASE($CONA)
C   CONA
           MDOFL=NDL
           DO I=1,NDL
             NDOFL(I)=1
             IDOFL(I,1)=LPU($CA)+IABS(INDL(I))
           ENDDO
         END SELECT
      CASE($FLOW3D)
C FLOW3D-------------------------
         SELECT CASE(IOPER)
         CASE($ELEC)
C   ELEC 
           MDOFL=NDL
           DO I=1,NDL
             NDOFL(I)=1
             IDOFL(I,1)=LPU($VOLT)+IABS(INDL(I))
           ENDDO
         CASE($THER)
C   THER
           MDOFL=NDL
           DO I=1,NDL
             NDOFL(I)=1
             IDOFL(I,1)=LPU($TEMP)+IABS(INDL(I))
           ENDDO
         CASE($CONC)
C   CONC
           MDOFL=NDL
           DO I=1,NDL
             NDOFL(I)=1
             IDOFL(I,1)=LPU($CN)+IABS(INDL(I))
           ENDDO
         CASE($COND)
C   COND
           MDOFL=NDL
           DO I=1,NDL
             NDOFL(I)=1
             IDOFL(I,1)=LPU($CD)+IABS(INDL(I))
           ENDDO
         CASE($CONA)
C   CONA
           MDOFL=NDL
           DO I=1,NDL
             NDOFL(I)=1
             IDOFL(I,1)=LPU($CA)+IABS(INDL(I))
           ENDDO
         CASE($FLOW)
C FLOW
           METODA=JGROUP(IG,$METHOD)
           SELECT CASE(METODA)
           CASE($PENS,$CREE)
C     PENS  T4,Q8,Q20
             MDOFL=NDL*3
             DO I=1,NDL
                NDOFL(I)=3
                IDOFL(I,1)=LPU($VX)+IABS(INDL(I))
                IDOFL(I,2)=LPU($VY)+IABS(INDL(I))
                IDOFL(I,3)=LPU($VZ)+IABS(INDL(I))
             ENDDO
           END SELECT
         END SELECT
      END SELECT
      IF(MDOFL.GT.0)ICOUNTS=ICOUNTS+1
      END

      REAL FUNCTION CURFUN(IFUN)
C
C VYPOCET FUNKCI HODNOTY BUD LINEARNI INTERPOLACI V TABULCE
C NEBO VYHODNOCENIM KODU RPN.
C -10 <= IFUN <= 50 v tomto pripade je funkce urcena hodnotou
C  I=INDFUN(IFUN)
C kdyz je I>0 a soucasne I<=MFUNCT vyhodnoti se vyraz TINQ
C kdyz je I<0 a soucasne |I|<=MTABLE vyhodnoti se tabulka.
C
C Specialni pripad je IFUN=|101|,|102|,...,|105|
C V tom pripade se vyhodnocuje interpretovany model RTD (ten, ktery je prave
C aktivni) - sekce INI. Vysledek je ve vektoru YV(1),...,YV(5) a predava se
C prave jedna z techto peti hodnot.
C
C V ostatnich pripadech je vysledek 1.
C  
      EXTERNAL TFUW
      INCLUDE '$FEM'
      EQUIVALENCE (IAUX(2),X),(IAUX(3),Y),(IAUX(4),Z),
     /            (IAUX(12),UX),(IAUX(13),UY),(IAUX(14),UZ)
      RES=1.
      IAFUN=IABS(IFUN)
      IF(IFUN.GE.MIFUN.AND.IFUN.LE.MAFUN)THEN
        IFF=INDFUN(IFUN)
        IFC=-IFF
        IF(IFF.GT.0.AND.IFF.LE.MFUNCT)THEN
C KOD RPN CISLO IFF
          CALL TINQ(IRPN(1,IFF),MRPN(IFF),IAUX,TFUW,RES,10)
        ELSEIF(IFC.LE.MTABLE.AND.IFC.GT.0)THEN
C TABULKA CISLO IFC
          SELECT CASE(KTABLE(IFC))
          CASE(0)
            T=TIME
          CASE(1)
            T=X
          CASE(2)
            T=Y
          CASE(3)
            T=Z
          CASE(4)
            T=TEMP
          CASE(5)
            T=UX
          CASE(6)
            T=UY
          CASE(7)
            T=UZ
          CASE(8)
            T=SINV
          END SELECT
          NPOINT=MTPT(IFC)
          DO I=2,NPOINT
            IF(T.LT.XTAB(I,IFC))EXIT
          ENDDO
          I=MIN0(MAXTPT,I)
          DXTAB=XTAB(I,IFC)-XTAB(I-1,IFC)
          IF(DXTAB.NE.0.) RES=YTAB(I-1,IFC)+
     /        (T-XTAB(I-1,IFC))*(YTAB(I,IFC)-YTAB(I-1,IFC))/DXTAB
        ENDIF
      ELSEIF(IAFUN.GE.101.AND.IAFUN.LE.105)THEN
C KOD RPN aktivniho modelu RTD
          CALL TINQ(MODRPN,MIRPN,IAUX,TFUW,RES,10)
          RES=YOUTPUTS(IAFUN-100)
      ENDIF
      CURFUN=RES
      END

      SUBROUTINE READBIN(IUN,IEND)
      INCLUDE '$FEMLOC'
      CHARACTER*12 PROFILE
C Cti binarni soubor /FEM/ ze zarizeni IUN
C      INQUIRE(IUN,NAME=PROFILE)
      CALL FINQUIRE(IUN,PROFILE)
      READ(IUN,ERR=51,END=51)ITDATAB,LENG
      IF(LENG.EQ.MAXEND)THEN
        IEND=0
        IF(ITDATAB.NE.0)THEN
         READ(IUN,ERR=51,END=51)INTERC
        ELSE
C cteni zuzene databaze
         READ(IUN,ERR=51,END=51)(INTERC(I),I=1,LOCIUE)
         READ(IUN,ERR=51,END=51)
     /     ((JEPAR(K,I),I=1,MAXEPAR),K=1,MAXELEM),
     /     ((KEPAR(K,I),I=1,MAXEPAR),K=1,MAXELEM),
     /     ((LEPAR(K,I),I=1,MAXTEPAR),K=1,MAXELEM),
     /     (MUE(I),MINT(I),IGROUP(I),IRCONS(I),IMPROP(I),
     /     (IEPAR(I,J),J=1,MAXEPAR),I=1,NE)
         READ(IUN,ERR=51,END=51)(LUE(I),I=1,NE+1)
         READ(IUN,ERR=51,END=51)(IUE(I),I=1,LUE(NE+1))
         READ(IUN,ERR=51,END=51)(XX(I),YY(I),ZZ(I),I=1,ND)
         READ(IUN,ERR=51,END=51)(JPU(I),I=1,MDOF),(LPU(I),I=1,MAXTDOF)
         READ(IUN,ERR=51,END=51) ((IPU((K-1)*MAXND+I),I=1,ND),K=1,MDOF)
         READ(IUN,ERR=51,END=51)
     /                 (((VAL((K-1)*MAXND+I,J),I=1,ND),K=1,MDOF),J=1,3)
C Nulovani posledniho sloupce VAL
         DO K=1,MDOF
	     DO I=1,ND
	       VAL((K-1)*MAXND+I,4)=0.
	     ENDDO
	   ENDDO
         READ(IUN,ERR=51,END=51)XBOXMI,XBOXMA,DXBOX,NXBOX,
     /                          YBOXMI,YBOXMA,DYBOX,NYBOX,
     /                          ZBOXMI,ZBOXMA,DZBOX,NZBOX
         READ(IUN,ERR=51,END=51)(PTX(I),PTY(I),PTZ(I),NEARND(I),I=1,NPT)
         READ(IUN,ERR=51,END=51)ISF,MSF,ICR,MCR,NXCR,FLAFI,IVL,MVL,
     /                          ICONTOUR,MCONTOUR
C        READ(IUN,ERR=51,END=51)(INTERC(I),I=LOCONST,MAXEND)
         READ(IUN,ERR=51,END=51)(INTERC(I),I=LOCONST,LOCNGR),
     /             (INTERC(I),I=LOCYG1,LOCYG1+NGR),
     /             (INTERC(I),I=LOCYG2,LOCYG2+NGR),
     /             (INTERC(I),I=LOCYG3,LOCYG3+NGR),
     /             (INTERC(I),I=LOCYG4,LOCYG4+NGR),
     /             (INTERC(I),I=LOCYG5,LOCYG5+NGR),
     /             (INTERC(I),I=LOCYG6,LOCYG6+NGR),
     /             (INTERC(I),I=LOCYG7,LOCYG7+NGR),
     /             (INTERC(I),I=LOCYG8,LOCYG8+NGR),
     /             (INTERC(I),I=LOCYG9,LOCYG9+NGR),
     /             (INTERC(I),I=LOCYG10,LOCYG10+NGR),
     /             (INTERC(I),I=LOCINDG,MAXEND)
    	   READ(IUN,ERR=51,END=51)IQGR,TTC
        ENDIF
      ELSE
        IEND=LENG
      ENDIF
      RETURN
51    IEND=-1
      END

      SUBROUTINE WRITEBIN(IUN,ITYP)
C
C Zapis databaze /FEM/ do jiz otevreneho souboru na jednotce IUN
C ITYP=0 zkracena, =1 uplna
C
      INCLUDE '$FEMLOC'
      IF(ITYP.NE.0)THEN
         WRITE(IUN)1,MAXEND
         WRITE(IUN)INTERC
      ELSE
C zapis redukovane databaze
         WRITE(IUN)0,MAXEND
         WRITE(IUN)(INTERC(I),I=1,LOCIUE)
         WRITE(IUN)
     /     ((JEPAR(K,I),I=1,MAXEPAR),K=1,MAXELEM),
     /     ((KEPAR(K,I),I=1,MAXEPAR),K=1,MAXELEM),
     /     ((LEPAR(K,I),I=1,MAXTEPAR),K=1,MAXELEM),
     /        (MUE(I),MINT(I),IGROUP(I),IRCONS(I),IMPROP(I),
     /        (IEPAR(I,J),J=1,MAXEPAR),I=1,NE)
         WRITE(IUN)(LUE(I),I=1,NE+1)
         WRITE(IUN)(IUE(I),I=1,LUE(NE+1))
         WRITE(IUN)(XX(I),YY(I),ZZ(I),I=1,ND)
         WRITE(IUN)(JPU(I),I=1,MDOF),(LPU(I),I=1,MAXTDOF)
         WRITE(IUN) ((IPU((K-1)*MAXND+I),I=1,ND),K=1,MDOF)
         WRITE(IUN)(((VAL((K-1)*MAXND+I,J),I=1,ND),K=1,MDOF),J=1,3)
         WRITE(IUN)XBOXMI,XBOXMA,DXBOX,NXBOX,
     /             YBOXMI,YBOXMA,DYBOX,NYBOX,
     /             ZBOXMI,ZBOXMA,DZBOX,NZBOX
         WRITE(IUN)(PTX(I),PTY(I),PTZ(I),NEARND(I),I=1,NPT)
         WRITE(IUN)ISF,MSF,ICR,MCR,NXCR,FLAFI,IVL,MVL,ICONTOUR,MCONTOUR
C starsi verze, zapis kompletni matice MOP
C        WRITE(IUN)(INTERC(I),I=LOCONST,MAXEND)
         WRITE(IUN)(INTERC(I),I=LOCONST,LOCNGR),
     /             (INTERC(I),I=LOCYG1,LOCYG1+NGR),
     /             (INTERC(I),I=LOCYG2,LOCYG2+NGR),
     /             (INTERC(I),I=LOCYG3,LOCYG3+NGR),
     /             (INTERC(I),I=LOCYG4,LOCYG4+NGR),
     /             (INTERC(I),I=LOCYG5,LOCYG5+NGR),
     /             (INTERC(I),I=LOCYG6,LOCYG6+NGR),
     /             (INTERC(I),I=LOCYG7,LOCYG7+NGR),
     /             (INTERC(I),I=LOCYG8,LOCYG8+NGR),
     /             (INTERC(I),I=LOCYG9,LOCYG9+NGR),
     /             (INTERC(I),I=LOCYG10,LOCYG10+NGR),
     /             (INTERC(I),I=LOCINDG,MAXEND)
	   WRITE(IUN)IQGR,TTC
      ENDIF
      END

      SUBROUTINE GETXYZ(IE,X,Y,Z)
      INCLUDE '$FEM'
      DIMENSION X(*),Y(*),Z(*)
      IF(IE.GT.0.AND.IE.LE.NE)THEN
        L0=LUE(IE)
        NUE=IABS(MUE(IE))
        DO I=1,NUE
           IND=IABS(IUE(L0+I))
           IF(IND.GT.0)THEN
             X(I)=XX(IND)
             Y(I)=YY(IND)
             Z(I)=ZZ(IND)
           ENDIF
        ENDDO
      ENDIF
      END

      SUBROUTINE GETDOF(IE,IDOF,DOF)
      INCLUDE '$FEM'
      DIMENSION DOF(*)
      IF(IE.GT.0.AND.IE.LE.NE)THEN
        L0=LUE(IE)
        NUE=IABS(MUE(IE))
        DO I=1,NUE
           IND=IABS(IUE(L0+I))
           LPD=LPU(IDOF)
           IF(IND.GT.0.AND.LPD.GE.0) DOF(I)=VAL(LPD+IND,3)
        ENDDO
      ENDIF
      END

      SUBROUTINE GETEPAR(IE,IST,IGAUS,IMETH,H,D,RKX,RCP,RHO,RKAPPA,VISC,
     /    RE,QFLOW,VX,VY)
      INCLUDE '$FEMB'
      IF(IE.GT.0.AND.IE.LE.NE)THEN
        LEGRP=MAX0(1,IGROUP(IE))
        LPROP=MAX0(1,IMPROP(IE))
        LRCON=MAX0(1,IRCONS(IE))
        NAMELE=JGROUP(LEGRP,$ENAME)
        IST   =JGROUP(LEGRP,$ST)
        IGAUS =JGROUP(LEGRP,$GAUSS)
        IMETH =JGROUP(LEGRP,$METHOD)
        H     =RRCONS(LRCON,$H)
        D     =RRCONS(LRCON,$D)
        RKX   =RMPROP(LPROP,$KX)
        RCP   =RMPROP(LPROP,$CP)
        RHO   =RMPROP(LPROP,$RHO)
        VISC  =RMPROP(LPROP,$VISC)
        RKAPPA=RMPROP(LPROP,$KAPPA)
        LRE=LEPAR(NAMELE,$ERE)
        LQF=LEPAR(NAMELE,$EQ)
        LVX=LEPAR(NAMELE,$VX)
        LVY=LEPAR(NAMELE,$VY)
        IF(LRE.GT.0)RE    =EPAR(IE,LEPAR(NAMELE,$ERE))
        IF(LQF.GT.0)QFLOW =EPAR(IE,LEPAR(NAMELE,$EQ))
        IF(LVX.GT.0)VX    =EPAR(IE,LEPAR(NAMELE,$EVX))
        IF(LVY.GT.0)VY    =EPAR(IE,LEPAR(NAMELE,$EVY))
      ENDIF
      END

      SUBROUTINE FINQUIRE(IUNIT,FILENAM)
C
C Zjisteni jmena souboru FILENAM, ktery je otevreny na IUNIT.
C Vstupni parametr: IUNIT - cislo zarizeni
C Vystupni parametr FILENAM z nehoz je odriznuta cesta (tedy "ciste" jmeno a pripona)
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      CHARACTER *(*) FILENAM
      CHARACTER *60 FILEPATH
      INQUIRE(IUNIT,NAME=FILEPATH)
C hledej posledni \
      IF(INDEX(FILEPATH,'\').GT.0)THEN
        IL=1
        LAST=1
        DO WHILE(IL.GT.0)
           LAST=IL+LAST
           IL=INDEX(FILEPATH(LAST:),'\')
        ENDDO
      ELSE
        LAST=1
      ENDIF
      FILENAM=FILEPATH(LAST:)
      END
    
C      INCLUDE '$$-COME.FOR'
C      INCLUDE '$$-PARF.FOR'