C $-DIAL2.FOR
C DGAS, DSOLID, DELEC, DELEMIX, DGLY, DTHERMO, DEGROUP, DMPROP (fixni pocet skupin)
C DIAPIPE, DIAPUMC, DIAPUMD
C RALFA



C --------------------------------------------------------------------

      SUBROUTINE DELEMIX(IEND)
C
C Procedura, ktera vypocte termofyzikalni vlastnosti dle Sestak J. Transportni a termodynamicka data..
C
      USE DIALOGM
      USE MSFLIB
      INCLUDE 'OPTION.FD'
      TYPE(DIALOG)DLG
      INTEGER RETINT
      LOGICAL RETLOG
      EXTERNAL WELEMIX
      IENDLOC=IEND
      IF(.NOT.DLGINIT(IDD_ELEMIX,DLG))THEN
           WRITE(*,*)' ERROR DIALOG IDD_ELEMIX NOT FOUND'
      ELSE
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEMIX,5,DLG_NUMITEMS)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEMIX,'coffee+water',1)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEMIX,'starch+water',2)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEMIX,'NaCl+water',3)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEMIX,'KCl+water',4)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEMIX,'dried milk+water',5)
         RETLOG=DLGSETSUB(DLG,IDC_COMBO_ELEMIX,WELEMIX,DLG_SELCHANGE)
	   RETLOG=DLGSET(DLG,IDC_EDIT1propELEMIX,'20.0')
	   RETLOG=DLGSET(DLG,IDC_EDIT2propELEMIX,'30.0')
         RETLOG=DLGSETSUB(DLG,IDC_EDIT1propELEMIX,WELEMIX,DLG_CHANGE)
         RETLOG=DLGSETSUB(DLG,IDC_EDIT2propELEMIX,WELEMIX,DLG_CHANGE)
         RETLOG=DLGSETSUB(DLG,IDC_BUTTON_ELEMIXGP1,WELEMIX)
C Aktivace panelu
         RETINT=DLGMODAL(DLG)
         CALL DLGUNINIT(DLG)
      ENDIF        
      END

      SUBROUTINE WELEMIX(DLG,CONTROL,CALLBACKTYPE)
 
C zobrazeni vypoctenych termodynamickych dat

      USE DIALOGM
      INCLUDE 'OPTION.FD'
      INCLUDE '$FEM'
	INCLUDE '$GMF'
      TYPE(DIALOG)DLG
      INTEGER CONTROL,CALLBACKTYPE,LOCALLBACK
      CHARACTER*60 TEXT
	CHARACTER*100 LABKAPPA
	CHARACTER*16 QLABEL
      LOGICAL RETLOG,DEFINED
	INTEGER*4,SAVE:: LM
	REAL ,SAVE:: E
	DIMENSION QTEMP(50),QVAL(50)
      LOCALLBACK=CALLBACKTYPE
         RETLOG=DLGGET(DLG,IDC_COMBO_ELEMIX,TEXT)
         SELECT CASE(TEXT)
         CASE('coffee+water')
	IL=1
         CASE('starch+water')
	IL=2
         CASE('NaCl+water')
	IL=3
         CASE('KCl+water')
	IL=4
         CASE('dried milk+water')
	IL=5
         CASE DEFAULT
	IL=0
         ENDSELECT
C
	IF(IL.GT.0)THEN
         RETLOG=DLGGET(DLG,IDC_EDIT1propELEMIX,TEXT)
         CALL TAKERD(TEXT,24,0,TC,K)
         RETLOG=DLGGET(DLG,IDC_EDIT2propELEMIX,TEXT)
         CALL TAKERD(TEXT,24,0,WC,K)

	   CALL TELEMIX(IL,TC,WC,RKAPPA,TMIN,TMAX,WM1,WM2,LABKAPPA,
     /                DEFINED)
         IF(DEFINED)THEN
           WRITE(TEXT,'(F6.1,'' , '',F6.1)')TMIN,TMAX
           RETLOG=DLGSET(DLG,IDC_STATIC_TRANGEELEMIX,TEXT)
           WRITE(TEXT,'(F6.1,'' , '',F6.1)')WM1,WM2
           RETLOG=DLGSET(DLG,IDC_STATIC_WRANGEELEMIX,TEXT)
           WRITE(TEXT,'(e11.4)')rkappa
           RETLOG=DLGSET(DLG,IDC_STATIC_ELEMIXa,TEXT)
	     IF(CONTROL.EQ.IDC_BUTTON_ELEMIXGP1)THEN
             QLABEL='Kappa S/m'
 	       DT=(TMAX-TMIN)/50.
	       QMIN=1E10
             QMAX=-QMIN
	       DO I=1,50
	         QTEMP(I)=TMIN+DT*(I-1)
	         T=QTEMP(I)
	         CALL TELEMIX(IL,T,WC,Rkappa,TMIN,TMAX,W1,W2,LABKAPPA,
     /                      DEFINED)
	         QVAL(I)=RKAPPA
	         QMIN=AMIN1(QMIN,QVAL(I))
	         QMAX=AMAX1(QMAX,QVAL(I))
	       ENDDO 
		   IF(QMAX.GT.1.001*QMIN)THEN	         
               II=FOCUSQQ(21)
               CALL GMFSTW(2,1,21,2,14,'T [C]',QLABEL,
     /0.,1.,0.,1.,TMIN,TMAX,QMIN,QMAX)
               CALL GMFAXE(2,3,15)
 	         AXMI=FXMI
	         AXMA=FXMA
	         AYMI=FYMI
	         AYMA=FYMA
	         DQ=(AYMA-AYMI)*.05
	         CALL GMFREC(AXMI,AXMA,AYMA-DQ,AYMA,8)
	         CALL GMFILL((AXMI+AXMA)*.5,AYMA-DQ*.5,15,8)
	         CALL GMFREC(AXMI,AXMA,AYMA-DQ,AYMA,15)
	         CALL GMFTEXT(AXMI,AYMA,12,100,LABKAPPA)
               CALL GMFPL(50,QTEMP,QVAL,12)
               CALL GMFSW(1)
               II=FOCUSQQ(10)
	       ENDIF
	     ENDIF
	   ELSE
           RETLOG=DLGSET(DLG,IDC_STATIC_TRANGEELEMIX,
     /'PROPERTIES NOT DEFINED')
	   ENDIF
	ENDIF
      END

	SUBROUTINE TELEMIX(IL,T,W,RKAPPA,TMIN,TMAX,WMIN,WMAX,LABKAPPA,
     /                   DEFINED)

C Databaze ELEKTRICKE VODIVOSTI pro teploty T v kelvinech
      LOGICAL DEFINED
	CHARACTER*100 LABKAPPA
	DEFINED=.FALSE.
	IF(T.LE.1.OR.T.GT.1300.)RETURN
	DEFINED=.TRUE.
      SELECT CASE(IL)
C         ('coffe')
	CASE(1)
	DEFINED=.FALSE.
	TMIN=0.
	TMAX=374
C         ('starch') VLASTMI KORELACE DLE SESTAKOVYCH DAT
	CASE(2)
	TMIN=20
	TMAX=90
	WMIN=0
	WMAX=45
	WW=W/100
	RKAPPA=0.0870/((1+((T-92.8427)/63.8425)**2)*
     /(1+((WW-.0783)/.4122)**2))
	LABKAPPA=' KAPPA=0.0870/((1+((T-92.8427)/63.8425)^2)*(1+((W-.0783)
     //.4122)^2))'
C NaCl
	CASE(3)
	DEFINED=.FALSE.
c KCl
      CASE(4)
	DEFINED=.FALSE.
	ENDSELECT
	END



C --------------------------------------------------------------------

      SUBROUTINE DELEC(IEND)
C
C Procedura, ktera vypocte termofyzikalni vlastnosti dle Sestak J. Transportni a termodynamicka data..
C
      USE DIALOGM
      USE MSFLIB
      INCLUDE 'OPTION.FD'
      TYPE(DIALOG)DLG
      INTEGER RETINT
      LOGICAL RETLOG
      EXTERNAL WELEC
      IENDLOC=IEND
      IF(.NOT.DLGINIT(IDD_ELEC,DLG))THEN
           WRITE(*,*)' ERROR DIALOG IDD_ELEC NOT FOUND'
      ELSE
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,29,DLG_NUMITEMS)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'water',1)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'gravy',2)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'mustard',3)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'ketchup',4)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'soup gulasch',5)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'sirloin sauce',6)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'soup peas',7)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'soup potato',8)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'soup mushrooms',9)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'joghurt white',10)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'smashed potatoes+milk',11)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'condensed milk 9% fat',12)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'hamulsion 0.5% thickener',13)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'hamulsion 0.1% thickener',14)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'milk 1.5% fat',15)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'lemone',16)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'orange juice',17)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'red vine',18)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'beer Pilsen 12',19)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'beer Gambrinus',20)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'beer Pilsen 10',21)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'beer Ahoj',22)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'beer regent',23)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'beer Radegast',24)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'sugar solution saturated',25)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'synthetic alcohol',26)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'methylalcohol',27)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'yolk eggs',28)
         RETLOG=DLGSET(DLG,IDC_COMBO_ELEC,'gumbo eggs',29)
         RETLOG=DLGSETSUB(DLG,IDC_COMBO_ELEC,WELEC,DLG_SELCHANGE)
	   RETLOG=DLGSET(DLG,IDC_EDIT1propELEC,'20.0')
         RETLOG=DLGSETSUB(DLG,IDC_EDIT1propELEC,WELEC,DLG_CHANGE)
         RETLOG=DLGSETSUB(DLG,IDC_BUTTON_ELECGP1,WELEC)
C Aktivace panelu
         RETINT=DLGMODAL(DLG)
         CALL DLGUNINIT(DLG)
      ENDIF        
      END

      SUBROUTINE WELEC(DLG,CONTROL,CALLBACKTYPE)
 
C zobrazeni vypoctenych termodynamickych dat

      USE DIALOGM
      INCLUDE 'OPTION.FD'
      INCLUDE '$FEM'
	INCLUDE '$GMF'
      TYPE(DIALOG)DLG
      INTEGER CONTROL,CALLBACKTYPE,LOCALLBACK
      CHARACTER*60 TEXT
	CHARACTER*16 QLABEL
	CHARACTER*100 LABKAPPA
      LOGICAL RETLOG
	INTEGER*4,SAVE:: LM
	REAL ,SAVE:: E
	DIMENSION QTEMP(50),QVAL(50)
      LOCALLBACK=CALLBACKTYPE
         RETLOG=DLGGET(DLG,IDC_COMBO_ELEC,TEXT)
         SELECT CASE(TEXT)
         CASE('water')
	   IL=1
         CASE('gravy')
	   IL=2
         CASE('mustard')
	   IL=3
         CASE('ketchup')
	   IL=4
         CASE('soup gulasch')
	   IL=5
         CASE('sirloin sauce')
	   IL=6
         CASE('soup peas')
	   IL=7
         CASE('soup potato')
	   IL=8
         CASE('soup mushrooms')
	   IL=9
         CASE('joghurt white')
	   IL=10
         CASE('smashed potatoes+milk')
	   IL=11
         CASE('condensed milk 9% fat')
	   IL=12
         CASE('hamulsion 0.5% thickener')
	   IL=13
         CASE('hamulsion 0.1% thickener')
	   IL=14
         CASE('milk 1.5% fat')
	   IL=15
         CASE('lemone')
	   IL=16
         CASE('orange juice')
	   IL=17
         CASE('red vine')
	   IL=18
         CASE('beer Pilsen 12')
	   IL=19
         CASE('beer Gambrinus')
	   IL=20
         CASE('beer Pilsen 10')
	   IL=21
         CASE('beer Ahoj')
	   IL=22
         CASE('beer regent')
	   IL=23
         CASE('beer Radegast')
	   IL=24
         CASE('sugar solution saturated')
	   IL=25
         CASE('synthetic alcohol')
	   IL=26
         CASE('methylalcohol')
	   IL=27
         CASE('yolk eggs')
	   IL=28
         CASE('gumbo eggs')
	   IL=29
         CASE DEFAULT
	IL=0
         ENDSELECT
C
	IF(IL.GT.0)THEN
         RETLOG=DLGGET(DLG,IDC_EDIT1propELEC,TEXT)
         CALL TAKERD(TEXT,24,0,TC,K)
         t=tc+273.15

	   CALL TELEC(IL,T,RKAPPA,TMIN,TMAX,LABKAPPA)

         WRITE(TEXT,'(F6.1,'' , '',F6.1)')TMIN,TMAX
         RETLOG=DLGSET(DLG,IDC_STATIC_TRANGEELEC,TEXT)
         WRITE(TEXT,'(e11.4)')rkappa
         RETLOG=DLGSET(DLG,IDC_STATIC_ELECa,TEXT)
	   IF(CONTROL.EQ.IDC_BUTTON_ELECGP1)THEN
            QLABEL='Kappa S/m'
 	      DT=(TMAX-TMIN)/50.
	      QMIN=1E10
            QMAX=-QMIN
	      DO I=1,50
	         QTEMP(I)=TMIN+DT*(I-1)
	         T=QTEMP(I)+273.15
	         CALL TELEC(IL,T,Rkappa,TMIN,TMAX,LABKAPPA)
	         QVAL(I)=RKAPPA
	         QMIN=AMIN1(QMIN,QVAL(I))
	         QMAX=AMAX1(QMAX,QVAL(I))
	      ENDDO 
		  IF(QMAX.GT.1.001*QMIN)THEN	         
              II=FOCUSQQ(21)
              CALL GMFSTW(2,1,21,2,14,'T [C]',QLABEL,
     /0.,1.,0.,1.,TMIN,TMAX,QMIN,QMAX)
              CALL GMFAXE(2,3,15)
	        AXMI=FXMI
	        AXMA=FXMA
	        AYMI=FYMI
	        AYMA=FYMA
	        DQ=(AYMA-AYMI)*.05
	        CALL GMFREC(AXMI,AXMA,AYMA-DQ,AYMA,8)
	        CALL GMFILL((AXMI+AXMA)*.5,AYMA-DQ*.5,15,8)
	        CALL GMFREC(AXMI,AXMA,AYMA-DQ,AYMA,15)
	        CALL GMFTEXT(AXMI,AYMA,12,100,LABKAPPA)
              CALL GMFPL(50,QTEMP,QVAL,12)
              CALL GMFSW(1)
              II=FOCUSQQ(10)
	      ENDIF
	   ENDIF
	ENDIF
      END

	SUBROUTINE TELEC(IL,Tkelvin,RKAPPA,TMIN,TMAX,LABKAPPA)

C Databaze ELEKTRICKE VODIVOSTI pro teploty T v kelvinech
	CHARACTER*100 LABKAPPA
      T=tkelvin-273.15
	IF(T.LE.1.OR.T.GT.1300.)RETURN
	TMIN=5
	TMAX=90
      SELECT CASE(IL)
c         CASE('water')
	   CASE(1)
	rkappa=0.0223+t*.0009
	LABkappa=' KAPPA= 0.0223+t*.0009'
c         CASE('gravy')
	   CASE(2)
	rkappa=.0447*t+1.1888
	LABkappa=' KAPPA=.0447*t+1.1888'
c         CASE('mustard')
	   CASE(3)
	rkappa=.0465*t+.9935
	LABkappa=' KAPPA=.0465*t+.9935'
c         CASE('ketchup')
	   CASE(4)
	rkappa=.0493*t+.5448
	LABkappa=' KAPPA=.0493*t+.5448'
c         CASE('soup gulasch')
	   CASE(5)
	rkappa=.0334*t+.7456
	LABkappa=' KAPPA=.0334*t+.7456'
c         CASE('sirloin sauce')
	   CASE(6)
	rkappa=.0297*t+.6648
	LABkappa=' KAPPA=.0297*t+.6648'
c         CASE('soup peas')
	   CASE(7)
	rkappa=.0286*t+.6643
	LABkappa=' KAPPA=.0286*t+.6643'
c         CASE('soup potato')
	   CASE(8)
	rkappa=.7052+.0251*t
	LABkappa=' kappa=.7052+.0251*t'
c         CASE('soup mushrooms')
	   CASE(9)
	rkappa=.0266*t+.5126
	LABkappa=' kappa=.0266*t+.5126'
c         CASE('joghurt white')
	   CASE(10)
	rkappa=.0234*t+.462
	LABkappa=' kappa=.0234*t+.462'
c         CASE('smashed potatoes+milk')
	   CASE(11)
	rkappa=.0306*t+.286
	LABkappa=' kappa=.0306*t+.286'
c         CASE('condensed milk 9% fat')
	   CASE(12)
	rkappa=.0172*t+.2944
	LABkappa=' kappa=.0172*t+.2944'
c         CASE('hamulsion 0.5% thickener')
	   CASE(13)
	rkappa=.0244*t+.0756
	LABkappa=' kappa=.0244*t+.0756'
c         CASE('hamulsion 0.1% thickener')
	   CASE(14)
	rkappa=.013*t+.2195
	LABkappa=' kappa=.013*t+.2195'
c         CASE('milk 1.5% fat')
	   CASE(15)
	rkappa=.0107*t+.2134
	LABkappa=' kappa=.0107*t+.2134'
c         CASE('lemone')
	   CASE(16)
	rkappa=.0001*t*t+.0033*t+.2955
	LABkappa=' kappa=.0001*t*t+.0033*t+.2955'
c         CASE('orange juice')
	   CASE(17)
	rkappa=9E-5*T*T+.0003*T+.2693
	LABkappa=' kappa=9E-5*T*T+.0003*T+.2693'
c         CASE('red vine')
	   CASE(18)
	rkappa=.006*T+.046
	LABkappa=' kappa=.006*T+.046'
c         CASE('beer Pilsen 12')
	   CASE(19)
	rkappa=.0038*T+.0873
	LABkappa=' kappa=.0038*T+.0873'
c         CASE('beer Gambrinus')
	   CASE(20)
	rkappa=.0042*T+.0671
	LABkappa=' kappa=.0042*T+.0671'
c         CASE('beer Pilsen 10')
	   CASE(21)
	rkappa=.0036*T+.0763
	LABkappa=' kappa=.0036*T+.0763'
c         CASE('beer Ahoj')
	   CASE(22)
	rkappa=.0031*T+.0847
	LABkappa=' kappa=.0031*T+.0847'
c         CASE('beer regent')
	   CASE(23)
	rkappa=.0036*T+.0621
	LABkappa=' kappa=.0036*T+.0621'
c         CASE('beer Radegast')
	   CASE(24)
	rkappa=.0036*T+.0569
	LABkappa=' kappa=.0036*T+.0569'
c         CASE('sugar solution saturated')
	   CASE(25)
	rkappa=.0008*T+.0142
	LABkappa=' kappa=.0008*T+.0142'
c         CASE('synthetic alcohol')
	   CASE(26)
	rkappa=0
c         CASE('methylalcohol')
	   CASE(27)
	rkappa=0
c         CASE('yolk eggs')
	   CASE(28)
	rkappa=.24
c         CASE('gumbo eggs')
	   CASE(29)
	rkappa=.0187*T+.2125
	LABkappa=' kappa=.0187*T+.2125'
	ENDSELECT
	END


C --------------------------------------------------------------------

      SUBROUTINE DSOLID(IEND)
C
C Procedura, ktera vypocte termofyzikalni vlastnosti dle Sestak J. Transportni a termodynamicka data..
C
      USE DIALOGM
      USE MSFLIB
      INCLUDE 'OPTION.FD'
      TYPE(DIALOG)DLG
      INTEGER RETINT
      LOGICAL RETLOG
      EXTERNAL WSOLID
      IENDLOC=IEND
      IF(.NOT.DLGINIT(IDD_SOLID,DLG))THEN
           WRITE(*,*)' ERROR DIALOG IDD_SOLID NOT FOUND'
      ELSE
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,48,DLG_NUMITEMS)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'steel 0.5% C',1)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'steel 1% C',2)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'steel 1.5% C',3)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'cast iron 3% C',4)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'chromium steel 5% Cr',5)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'chromium steel 13% Cr',6)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'chromium steel 17% Cr',7)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'chromium steel 26% Cr',8)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'NiCr steel 19% Cr 10% Ni',9)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'Ni steel 1% Ni',10)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'Ni steel 3.5% Ni',11)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'Ni steel 25% Ni',12)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'Ni steel 44% Ni',13)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'Mn steel 12.5% Mn 3% Ni',14)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'W steel 5% Wi',15)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'aluminium pure',16)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'dural 96% Al, 4% Cu',17)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'silumin 87% Al 13% Si',18)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'berylium',19)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'Cu pure',20)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'Albronze 90% Cu, 10% Al',21)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'bronze 89% Cu 11% Sn',22)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'brass 70% Cu, 30% Zn',23)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'lead Pb',24)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'Ni',25)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'Ag',26)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'Pt',27)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'Sn',28)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'Ti',29)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'W',30)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'U',31)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'Zn',32)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'Zr',33)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'Au',34)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'asbest',35)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'soil',36)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'concrete',37)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'sand',38)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'sandstone',39)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'glass',40)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'glass wool',41)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'SiC',42)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'butter',43)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'cheese',44)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'beef meat',45)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'pork meat',46)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'chocolade',47)
         RETLOG=DLGSET(DLG,IDC_COMBO_SOLID,'sugar',48)
         RETLOG=DLGSETSUB(DLG,IDC_COMBO_SOLID,WSOLID,DLG_SELCHANGE)
	   RETLOG=DLGSET(DLG,IDC_EDIT1propSOLID,'20.0')
         RETLOG=DLGSETSUB(DLG,IDC_EDIT1propSOLID,WSOLID,DLG_CHANGE)
         RETLOG=DLGSETSUB(DLG,IDC_BUTTON_SOLIDGP1,WSOLID)
         RETLOG=DLGSETSUB(DLG,IDC_BUTTON_SOLIDGP2,WSOLID)
         RETLOG=DLGSETSUB(DLG,IDC_BUTTON_SOLIDGP3,WSOLID)
         RETLOG=DLGSETSUB(DLG,IDC_BUTTON_SOLIDGP4,WSOLID)
         RETLOG=DLGSETSUB(DLG,IDC_BUTTON_SOLIDGP5,WSOLID)
         RETLOG=DLGSETSUB(DLG,IDC_BUTTON_SOLIDGP6,WSOLID)
         RETLOG=DLGSETSUB(DLG,IDC_BUTTON_SOLIDGP7,WSOLID)
         RETLOG=DLGSETSUB(DLG,IDC_BUTTON_SOLIDGP8,WSOLID)
C Aktivace panelu
         RETINT=DLGMODAL(DLG)
         CALL DLGUNINIT(DLG)
      ENDIF        
      END

      SUBROUTINE WSOLID(DLG,CONTROL,CALLBACKTYPE)
 
C zobrazeni vypoctenych termodynamickych dat

      USE DIALOGM
      INCLUDE 'OPTION.FD'
      INCLUDE '$FEM'
      TYPE(DIALOG)DLG
      INTEGER CONTROL,CALLBACKTYPE,LOCALLBACK
      CHARACTER*60 TEXT
	CHARACTER*16 QLABEL
      LOGICAL RETLOG,DEFINED
	INTEGER*4,SAVE:: LM
	REAL ,SAVE:: E
	DIMENSION QTEMP(50),QVAL(50)
      LOCALLBACK=CALLBACKTYPE
         RETLOG=DLGGET(DLG,IDC_COMBO_SOLID,TEXT)
         SELECT CASE(TEXT)
         CASE('steel 0.5% C')
	   IL=1
         CASE('steel 1% C')
	   IL=2
         CASE('steel 1.5% C')
	   IL=3
         CASE('cast iron 3% C')
	   IL=4
         CASE('chromium steel 5% Cr')
	   IL=5
         CASE('chromium steel 13% Cr')
	   IL=6
         CASE('chromium steel 17% Cr')
	   IL=7
         CASE('chromium steel 26% Cr')
	   IL=8
         CASE('NiCr steel 19% Cr 10% Ni')
	   IL=9
         CASE('Ni steel 1% Ni')
	   IL=10
         CASE('Ni steel 3.5% Ni')
	   IL=11
         CASE('Ni steel 25% Ni')
	   IL=12
         CASE('Ni steel 44% Ni')
	   IL=13
         CASE('Mn steel 12.5% Mn 3% Ni')
	   IL=14
         CASE('W steel 5% Wi')
	   IL=15
         CASE('aluminium pure')
	   IL=16
         CASE('dural 96% Al, 4% Cu')
	   IL=17
         CASE('silumin 87% Al 13% Si')
	   IL=18
         CASE('berylium')
	   IL=19
         CASE('Cu pure')
	   IL=20
         CASE('Albronze 90% Cu, 10% Al')
	   IL=21
         CASE('bronze 89% Cu 11% Sn')
	   IL=22
         CASE('brass 70% Cu, 30% Zn')
	   IL=23
         CASE('lead Pb')
	   IL=24
         CASE('Ni')
	   IL=25
         CASE('Ag')
	   IL=26
         CASE('Pt')
	   IL=27
         CASE('Sn')
	   IL=28
         CASE('Ti')
	   IL=29
         CASE('W')
	   IL=30
         CASE('U')
	   IL=31
         CASE('Zn')
	   IL=32
         CASE('Zr')
	   IL=33
         CASE('Au')
	   IL=34
         CASE('asbest')
	   IL=35
         CASE('soil')
	   IL=36
         CASE('concrete')
	   IL=37
         CASE('sand')
	   IL=38
         CASE('sandstone')
	   IL=39
         CASE('glass')
	   IL=40
         CASE('glass wool')
	   IL=41
         CASE('SiC')
	   IL=42
         CASE('butter')
	   IL=43
         CASE('cheese')
	   IL=44
         CASE('beef meat')
	   IL=45
         CASE('pork meat')
	   IL=46
         CASE('chocolade')
	   IL=47
         CASE('sugar')
	   IL=48
         CASE DEFAULT
	IL=0
         ENDSELECT
C
	IF(IL.GT.0)THEN
         RETLOG=DLGGET(DLG,IDC_EDIT1propSOLID,TEXT)
         CALL TAKERD(TEXT,24,0,TC,K)
         t=tc+273.15

	   CALL TSOLID(IL,T,RHO,CP,RLAM,YOUNG,POIS,ALFA,BETA,RKAPPA,
     /TM,DH,TMIN,TMAX,DEFINED)
         IF(DEFINED)THEN
           WRITE(TEXT,'(F6.1,'' , '',F6.1)')TMIN,TMAX
           RETLOG=DLGSET(DLG,IDC_STATIC_TRANGESOLID,TEXT)
           WRITE(TEXT,'(e11.4)')rho
           RETLOG=DLGSET(DLG,IDC_STATIC_SOLIDa,TEXT)
           WRITE(TEXT,'(e11.4)')cp
           RETLOG=DLGSET(DLG,IDC_STATIC_SOLIDb,TEXT)
           WRITE(TEXT,'(e11.4)')rlam
           RETLOG=DLGSET(DLG,IDC_STATIC_SOLIDc,TEXT)
           WRITE(TEXT,'(e11.4)')YOUNG
           RETLOG=DLGSET(DLG,IDC_STATIC_SOLIDd,TEXT)
           WRITE(TEXT,'(F11.4)')POIS
           RETLOG=DLGSET(DLG,IDC_STATIC_SOLIDe,TEXT)
           WRITE(TEXT,'(E11.4)')ALFA
           RETLOG=DLGSET(DLG,IDC_STATIC_SOLIDf,TEXT)
           WRITE(TEXT,'(E11.4)')BETA
           RETLOG=DLGSET(DLG,IDC_STATIC_SOLIDg,TEXT)
           WRITE(TEXT,'(F11.4)')RKAPPA
           RETLOG=DLGSET(DLG,IDC_STATIC_SOLIDh,TEXT)
           WRITE(TEXT,'(F11.1)')TM
           RETLOG=DLGSET(DLG,IDC_STATIC_SOLIDi,TEXT)
           WRITE(TEXT,'(E11.4)')DH
           RETLOG=DLGSET(DLG,IDC_STATIC_SOLIDj,TEXT)
           IGP=0
           SELECT CASE(CONTROL)
	     CASE (IDC_BUTTON_SOLIDGP1)
	       IGP=1
	       QLABEL='Density kg/m^3'
	     CASE (IDC_BUTTON_SOLIDGP2)
	       IGP=2
	       QLABEL='Cp J/kg/K'
	     CASE (IDC_BUTTON_SOLIDGP3)
	       IGP=3
	       QLABEL='lambda W/m/K'
	     CASE (IDC_BUTTON_SOLIDGP4)
	       IGP=4
	       QLABEL='E Pa'
	     CASE (IDC_BUTTON_SOLIDGP5)
	       IGP=5
	       QLABEL='mju [-]'
	     CASE (IDC_BUTTON_SOLIDGP6)
	       IGP=6
	       QLABEL='alfa [1/K]'
	     CASE (IDC_BUTTON_SOLIDGP7)
	       IGP=7
	       QLABEL='beta [1/K]'
	     CASE (IDC_BUTTON_SOLIDGP8)
	       IGP=8
	       QLABEL='kappa [S/m]'
	     ENDSELECT
	     IF(IGP.GT.0)THEN
	       DT=(TMAX-TMIN)/50.
	       QMIN=1E10
             QMAX=-QMIN
             DO I=1,50
	         QTEMP(I)=TMIN+DT*(I-1)
	         T=QTEMP(I)+273.15
	         CALL TSOLID(IL,T,RHO,CP,RLAM,YOUNG,POIS,ALFA,BETA,
     /RKAPPA,TM,DH,TMIN,TMAX,DEFINED)
	         SELECT CASE(IGP)
	         CASE(1)
	            QVAL(I)=RHO
	         CASE(2)
	            QVAL(I)=CP
	         CASE(3)
	            QVAL(I)=RLAM
	         CASE(4)
	            QVAL(I)=YOUNG
	         CASE(5)
	            QVAL(I)=POIS
	         CASE(6)
	            QVAL(I)=ALFA
	         CASE(7)
	            QVAL(I)=BETA
	         CASE(8)
	            QVAL(I)=RKAPPA
	         ENDSELECT
	         QMIN=AMIN1(QMIN,QVAL(I))
	         QMAX=AMAX1(QMAX,QVAL(I))
	       ENDDO 
		   IF(QMAX.GT.1.001*QMIN)THEN	         
               II=FOCUSQQ(21)
               CALL GMFSTW(2,1,21,2,14,'T [C]',QLABEL,
     /0.,1.,0.,1.,TMIN,TMAX,QMIN,QMAX)
               CALL GMFAXE(2,3,15)
               CALL GMFPL(50,QTEMP,QVAL,12)
               CALL GMFSW(1)
               II=FOCUSQQ(10)
	       ENDIF
	     ENDIF
	   ELSE
           RETLOG=DLGSET(DLG,IDC_STATIC_TRANGESOLID,
     /'PROPERTIES NOT DEFINED YET')
	   ENDIF
	ENDIF
      END

	SUBROUTINE TSOLID(IL,TK,RHO,CP,RLAM,EYOUNG,EMI,ALEX,BETA,RKAPPA,
     /                  TM,REVAP,TMIN,TMAX,DEFINED)
	LOGICAL DEFINED

C Databaze termofyzikalnich vlastnosti pro teploty T v kelvinech
      DEFINED=.FALSE.
	IF(TK.LE.1.OR.TK.GT.3000.)RETURN
	DEFINED=.TRUE.
	T=TK-273.15
      SELECT CASE(IL)
c         CASE('steel 0.5% C')
	   CASE(1)
           REVAP=2400000
           BETA=0.00065
           EYOUNG=200E9
           EMI=0.29
           ALEX=12E-6
           RKAPPA=1100
	RHO=7840
	CP=465.
	RLAM=50.23-0.02682*T
	TMIN=0
	TMAX=800
c         CASE('steel 1% C')
	   CASE(2)
           REVAP=2400000
           BETA=0.00065
           EYOUNG=200E9
           EMI=0.29
           ALEX=17E-6
           RKAPPA=990
	RHO=7790
	CP=470.
	RLAM=42.96+0.0003283*T-0.1733E-4*T*T
	TMIN=0
	TMAX=800
c         CASE('steel 1.5% C')
	   CASE(3)
           REVAP=2400000
           BETA=0.00065
           EYOUNG=200E9
           EMI=0.29
           ALEX=17E-6
           RKAPPA=990
	RHO=7750
	CP=470.
	RLAM=36.75+0.00061*T-0.1479E-4*T*T
	TMIN=0
	TMAX=800
c         CASE('cast iron 3% C')
	   CASE(4)
           REVAP=2400000
           BETA=0.00065
           EYOUNG=200E9
           EMI=0.29
           ALEX=17E-6
           RKAPPA=990
	RHO=7570
	CP=470
	RLAM=35.7-.01541*T-7.331*SIN(0.008593*T+1.913)
	TMIN=0
	TMAX=800
c         CASE('chromium steel 5% Cr')
	   CASE(5)
           REVAP=2400000
           BETA=0.00065
           EYOUNG=200E9
           EMI=0.29
           ALEX=17E-6
           RKAPPA=990
	RHO=7830
	CP=460
	RLAM=26.89+9.131*EXP(-((T-32.5)/428.9)**2)
	TMIN=0
	TMAX=1000
c         CASE('chromium steel 13% Cr')
	   CASE(6)
	RLAM=26.41+.00299*T-.2536*SIN(.009803*T-1.986)
	RHO=7740
	CP=460
	TMIN=0
	TMAX=1000
c         CASE('chromium steel 17% Cr')
	   CASE(7)
	RLAM=21.93+.00291*T+.7255E-6*T*T
	RHO=7710
	CP=460
	TMIN=0
	TMAX=1000
c         CASE('chromium steel 26% Cr')
	   CASE(8)
	RLAM=22.41+.01566*T
	RHO=7650
	CP=460
	TMIN=0
	TMAX=1000
c         CASE('NiCr steel 19% Cr 10% Ni')
	   CASE(9)
           REVAP=2400000
           BETA=0.00065
           EYOUNG=200E9
           EMI=0.29
           ALEX=17E-6
           RKAPPA=990
c         CASE('Ni steel 1% Ni')
	   CASE(10)
	DEFINED=.FALSE.
c         CASE('Ni steel 3.5% Ni')
	   CASE(11)
	DEFINED=.FALSE.
c         CASE('Ni steel 25% Ni')
	   CASE(12)
	DEFINED=.FALSE.
c         CASE('Ni steel 44% Ni')
	   CASE(13)
	DEFINED=.FALSE.
c         CASE('Mn steel 12.5% Mn 3% Ni')
	   CASE(14)
	DEFINED=.FALSE.
c         CASE('W steel 5% Wi')
	   CASE(15)
	DEFINED=.FALSE.
c         CASE('aluminium pure')
	   CASE(16)
           REVAP=2400000
           BETA=0.00065
           EYOUNG=70E9
           EMI=0.33
           ALEX=23E-6
           RKAPPA=3450
	RLAM=242.2-0.03826*T-4.641*SIN(0.01046*T+8.306)
	RHO=2710
	CP=902
	TMIN=-100
	TMAX=600
c         CASE('dural 96% Al, 4% Cu')
	   CASE(17)
	RLAM=196.8-32.93*EXP(-0.008025*T)
	RHO=2790
	CP=881
	TMIN=-100
	TMAX=300
c         CASE('silumin 87% Al 13% Si')
	   CASE(18)
	RLAM=184-24.43*EXP(-0.006175*T)
	RHO=2660
	CP=871
	TMIN=-100
	TMAX=300
c         CASE('berylium')
	   CASE(19)
	RLAM=94.21+16.3*EXP(-.02085*T)+107.5*EXP(-0.003768*T)
	RHO=1850
	CP=1758
	TMIN=-100
	TMAX=400
c         CASE('Cu pure')
	   CASE(20)
           REVAP=2400000
           BETA=0.00065
           EYOUNG=110E9
           EMI=0.35
           ALEX=17E-6
           RKAPPA=5800
	RLAM=386.3+2517/(174.7+T)-.01386*T-.4072E-4*T*T
	CP=386
	RHO=8930
	TMIN=-100
	TMAX=800
c         CASE('Albronze 90% Cu, 10% Al')
	   CASE(21)
	RLAM=48.83+.085*T
	RHO=8360
	CP=420
	TMIN=0
	TMAX=200
c         CASE('bronze 89% Cu 11% Sn')
	   CASE(22)
	RLAM=23.93+.046*T
	RHO=8800
	CP=343
	TMIN=0
	TMAX=200
c         CASE('brass 70% Cu, 30% Zn')
	   CASE(23)
	RLAM=111.4+.1169*T+10.13*SIN(.01282*T-.5067)
	RHO=8440
	CP=377
	TMIN=-100
	TMAX=400
c         CASE('lead Pb')
	   CASE(24)
	DEFINED=.FALSE.
c         CASE('Ni')
	   CASE(25)
	DEFINED=.FALSE.
c         CASE('Ag')
	   CASE(26)
	DEFINED=.FALSE.
c         CASE('Pt')
	   CASE(27)
	DEFINED=.FALSE.
c         CASE('Sn')
	   CASE(28)
	DEFINED=.FALSE.
c         CASE('Ti')
	   CASE(29)
	DEFINED=.FALSE.
c         CASE('W')
	   CASE(30)
	DEFINED=.FALSE.
c         CASE('U')
	   CASE(31)
	DEFINED=.FALSE.
c         CASE('Zn')
	   CASE(32)
	DEFINED=.FALSE.
c         CASE('Zr')
	   CASE(33)
	DEFINED=.FALSE.
c         CASE('Au')
	   CASE(34)
	RLAM=321.-.05598*T-2.823*SIN(.01438*T+.4251)
	RHO=19300
	CP=127
	TMIN=-100
	TMAX=600
c         CASE('asbest')
	   CASE(35)
           DENS=576
           CP=840
           RLAM=0.15
           VISC=1000
           REVAP=2400000
           BETA=0.00065
           EYOUNG=200E9
           EMI=0.29
           ALEX=17E-6
           RKAPPA=0
c         CASE('soil')
	   CASE(36)
	DEFINED=.FALSE.
c         CASE('concrete')
	   CASE(37)
	DEFINED=.FALSE.
c         CASE('sand')
	   CASE(38)
	DEFINED=.FALSE.
c         CASE('sandstone')
	   CASE(39)
	DEFINED=.FALSE.
c         CASE('glass')
	   CASE(40)
           EYOUNG=60E9
           EMI=0.23
           ALEX=12E-6
           RKAPPA=0
c         CASE('glass wool')
	   CASE(41)
           DENS=200
           CP=670
           RLAM=0.04
           BETA=0.00065
           EYOUNG=200E9
           EMI=0.29
           ALEX=10E-6
           RKAPPA=0
c         CASE('SiC')
	   CASE(42)
	DEFINED=.FALSE.
c         CASE('butter')
	   CASE(43)
	DEFINED=.FALSE.
c         CASE('cheese')
	   CASE(44)
	DEFINED=.FALSE.
c         CASE('beef meat')
	   CASE(45)
	DEFINED=.FALSE.
c         CASE('pork meat')
	   CASE(46)
	DEFINED=.FALSE.
c         CASE('chocolade')
	   CASE(47)
	DEFINED=.FALSE.
c         CASE('sugar')
	   CASE(48)
	DEFINED=.FALSE.

	ENDSELECT
	END


C --------------------------------------------------------------------

      SUBROUTINE DGAS(IEND)
C
C Procedura, ktera vypocte termofyzikalni vlastnosti dle Sestak J. Transportni a termodynamicka data..
C
      USE DIALOGM
      USE MSFLIB
      INCLUDE 'OPTION.FD'
      TYPE(DIALOG)DLG
      INTEGER RETINT
      LOGICAL RETLOG
      EXTERNAL WGAS
      IENDLOC=IEND
      IF(.NOT.DLGINIT(IDD_GAS,DLG))THEN
           WRITE(*,*)' ERROR DIALOG IDD_GAS NOT FOUND'
      ELSE
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,44,DLG_NUMITEMS)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'air',1)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'H2',2)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'CO',3)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'CO2',4)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'N2',5)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'N2O',6)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'NO',7)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'NO2',8)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'NH3',9)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'O2',10)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'SO2',11)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'SO3',12)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'F2',13)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'Cl2',14)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'Br2',15)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'J2',16)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'HF',17)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'HCl',18)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'HBr',19)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'He',20)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'Ne',21)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'Ar',22)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'CH4',23)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'C2H6',24)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'C3H8',25)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'C3H6 cyclopropane',26)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'C4H8 cyclobutane',27)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'C5H10 cyclopentane',28)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'C6H12 cyclohexane',29)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'C2H4 ethylene',30)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'C3H6 propylene',31)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'C4H8 butylene',32)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'C6H6 benzene',33)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'C7H8 toluene',34)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'C8H8 styrene',35)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'C8H10 xylene',36)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'C2H6O ethylalcohol',37)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'C3H8O propylalcohol',38)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'C4H10O butanol',39)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'C2H4O ethyloxide',40)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'C3H6O propyloxide',41)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'C4H8O butyloxide',42)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'C6H7N anilin',43)
         RETLOG=DLGSET(DLG,IDC_COMBO_GAS,'C6H6O fenol',44)
         RETLOG=DLGSETSUB(DLG,IDC_COMBO_GAS,WGAS,DLG_SELCHANGE)
	   RETLOG=DLGSET(DLG,IDC_EDIT1propGAS,'20.0')
         RETLOG=DLGSETSUB(DLG,IDC_EDIT1propGAS,WGAS,DLG_CHANGE)
         RETLOG=DLGSETSUB(DLG,IDC_BUTTON_GASGP1,WGAS)
         RETLOG=DLGSETSUB(DLG,IDC_BUTTON_GASGP2,WGAS)
         RETLOG=DLGSETSUB(DLG,IDC_BUTTON_GASGP3,WGAS)
         RETLOG=DLGSETSUB(DLG,IDC_BUTTON_GASGP4,WGAS)
C Aktivace panelu
         RETINT=DLGMODAL(DLG)
         CALL DLGUNINIT(DLG)
      ENDIF        
      END

      SUBROUTINE WGAS(DLG,CONTROL,CALLBACKTYPE)
 
C zobrazeni vypoctenych termodynamickych dat

      USE DIALOGM
      INCLUDE 'OPTION.FD'
      INCLUDE '$FEM'
	INCLUDE '$GMF'
      TYPE(DIALOG)DLG
      INTEGER CONTROL,CALLBACKTYPE,LOCALLBACK
      CHARACTER*60 TEXT
	CHARACTER*16 QLABEL
	CHARACTER*100 LABRHO,LABCP,LABLAM,LABVISC,QLAB
      LOGICAL RETLOG
	INTEGER*4,SAVE:: LM
	REAL ,SAVE:: E
	DIMENSION QTEMP(50),QVAL(50)
      LOCALLBACK=CALLBACKTYPE
         RETLOG=DLGGET(DLG,IDC_COMBO_GAS,TEXT)
         SELECT CASE(TEXT)
         CASE('air')
	IL=1
         CASE('H2')
	   IL=2
         CASE('CO')
	   IL=3
         CASE('CO2')
	   IL=4
         CASE('N2')
	   IL=5
         CASE('N2O')
	   IL=6
         CASE('NO')
	   IL=7
         CASE('NO2')
	   IL=8
         CASE('NH3')
	   IL=9
         CASE('O2')
	   IL=10
         CASE('SO2')
	   IL=11
         CASE('SO3')
	   IL=12
         CASE('F2')
	   IL=13
         CASE('Cl2')
	   IL=14
         CASE('Br2')
	   IL=15
         CASE('J2')
	   IL=16
         CASE('HF')
	   IL=17
         CASE('HCl')
	   IL=18
         CASE('HBr')
	   IL=19
         CASE('He')
	   IL=20
         CASE('Ne')
	   IL=21
         CASE('Ar')
	   IL=22
         CASE('CH4')
	   IL=23
         CASE('C2H6')
	   IL=24
         CASE('C3H8')
	   IL=25
         CASE('C3H6 cyclopropane')
	   IL=26
         CASE('C4H8 cyclobutane')
	   IL=27
         CASE('C5H10 cyclopentane')
	   IL=28
         CASE('C6H12 cyclohexane')
	   IL=29
         CASE('C2H4 ethylene')
	   IL=30
         CASE('C3H6 propylene')
	   IL=31
         CASE('C4H8 butylene')
	   IL=32
         CASE('C6H6 benzene')
	   IL=33
         CASE('C7H8 toluene')
	   IL=34
         CASE('C8H8 styrene')
	   IL=35
         CASE('C8H10 xylene')
	   IL=36
         CASE('C2H6O ethylalcohol')
	   IL=37
         CASE('C3H8O propylalcohol')
	   IL=38
         CASE('C4H10O butanol')
	   IL=39
         CASE('C2H4O ethyloxide')
	   IL=40
         CASE('C3H6O propyloxide')
	   IL=41
         CASE('C4H8O butyloxide')
	   IL=42
         CASE('C6H7N anilin')
	   IL=43
         CASE('C6H6O fenol')
	   IL=44
         CASE DEFAULT
	IL=0
         ENDSELECT
C
	IF(IL.GT.0)THEN
         RETLOG=DLGGET(DLG,IDC_EDIT1propGAS,TEXT)
         CALL TAKERD(TEXT,24,0,TC,K)
         t=tc+273.15

	   CALL TGAS(IL,T,RHO,CP,RLAM,VISC,TMIN,TMAX,
     /LABRHO,LABCP,LABLAM,LABVISC)

         WRITE(TEXT,'(F6.1,'' , '',F6.1)')TMIN,TMAX
         RETLOG=DLGSET(DLG,IDC_STATIC_TRANGEGAS,TEXT)
         WRITE(TEXT,'(e11.4)')rho
         RETLOG=DLGSET(DLG,IDC_STATIC_GASa,TEXT)
         WRITE(TEXT,'(e11.4)')cp
         RETLOG=DLGSET(DLG,IDC_STATIC_GASb,TEXT)
         WRITE(TEXT,'(e11.4)')rlam
         RETLOG=DLGSET(DLG,IDC_STATIC_GASc,TEXT)
         WRITE(TEXT,'(e11.4)')visc
         RETLOG=DLGSET(DLG,IDC_STATIC_GASd,TEXT)
	   IGP=0
	   SELECT CASE(CONTROL)
	   CASE (IDC_BUTTON_GASGP1)
	IGP=1
	QLABEL='Density kg/m^3'
	   CASE (IDC_BUTTON_GASGP2)
	IGP=2
	QLABEL='Cp J/kg/K'
	   CASE (IDC_BUTTON_GASGP3)
	IGP=3
	QLABEL='lambda W/m/K'
	   CASE (IDC_BUTTON_GASGP4)
	IGP=4
	QLABEL='viscosity Pa.s'
	   ENDSELECT
	   IF(IGP.GT.0)THEN
	      DT=(TMAX-TMIN)/50.
	      QMIN=1E10
            QMAX=-QMIN
	      DO I=1,50
	         QTEMP(I)=TMIN+DT*(I-1)
	         T=QTEMP(I)+273.15
	         CALL TGAS(IL,T,RHO,CP,RLAM,VISC,TMIN,TMAX,LABRHO,LABCP,LA
     /BLAM,LABVISC)
	         SELECT CASE(IGP)
	         CASE(1)
	            QVAL(I)=RHO
	            QLAB=LABRHO
	         CASE(2)
	            QVAL(I)=CP
	            QLAB=LABCP
	         CASE(3)
	            QVAL(I)=RLAM
	            QLAB=LABLAM
	         CASE(4)
	            QVAL(I)=VISC
	            QLAB=LABVISC
	         ENDSELECT
	         QMIN=AMIN1(QMIN,QVAL(I))
	         QMAX=AMAX1(QMAX,QVAL(I))
	      ENDDO 
		  IF(QMAX.GT.1.001*QMIN)THEN	         
              II=FOCUSQQ(21)
              CALL GMFSTW(2,1,21,2,14,'T [C]',QLABEL,
     /0.,1.,0.,1.,TMIN,TMAX,QMIN,QMAX)
              CALL GMFAXE(2,3,15)
	        AXMI=FXMI
	        AXMA=FXMA
	        AYMI=FYMI
	        AYMA=FYMA
	        DQ=(AYMA-AYMI)*.05
	        CALL GMFREC(AXMI,AXMA,AYMA-DQ,AYMA,8)
	        CALL GMFILL((AXMI+AXMA)*.5,AYMA-DQ*.5,15,8)
	        CALL GMFREC(AXMI,AXMA,AYMA-DQ,AYMA,15)
	        CALL GMFTEXT(AXMI,AYMA,12,100,QLAB)
              CALL GMFPL(50,QTEMP,QVAL,12)
              CALL GMFSW(1)
              II=FOCUSQQ(10)
	      ENDIF
	   ENDIF
	ENDIF
      END

	SUBROUTINE TGAS(IL,T,RHO,CP,RLAM,VISC,TMIN,TMAX,
     /LABRHO,LABCP,LABLAM,LABVISC)

C Databaze termofyzikalnich vlastnosti pro teploty T v kelvinech

      CHARACTER*100 LABRHO,LABCP,LABLAM,LABVISC
	DIMENSION AC(4),AV(3),AL(4)
	T1=T-273.15
	IF(T.LE.1.OR.T.GT.1800.)RETURN
	RM=1
      SELECT CASE(IL)
C         ('air') VLASTMI KORELACE DLE SESTAKOVYCH DAT
	CASE(1)
	T2=T1*T1
	T3=T2*T1
	RHO=0.108+.522*EXP(-.654E-2*T1)+.638*EXP(-.136E-2*T1)
	CP=1000.*(1.01+.681E-6*T1+.47E-6*T2-.289E-9*T3)
	RLAM=.0244+.718E-4*T1-.175E-7*T2
	VISC=(17.4+.0442*T1-.14E-4*T2)/1E6
	WRITE(LABRHO,'('' RHO=0.108+.522*EXP(-.654E-2*T)+.638*EXP(-.136E-2
     /*T)'')')
	WRITE(LABCP,'('' CP=1000.*(1.01+.681E-6*T+.47E-6*T^2-.289E-9*T^3)'
     /')')
	WRITE(LABLAM,'('' RLAM=.0244+.718E-4*T-.175E-7*T^2'')')
	WRITE(LABVISC,'('' VISC=(17.4+.0442*T-.14E-4*T^2)/1E6'')')
	TMIN=-50
	TMAX=1000
	RETURN
C         CASE('H2')
	   CASE(2)
	RM=2.016
	AC=(/6.88,-.022,.21,.13/)
	AV=(/21.87,22.2,-37.51/)
	AL=(/19.34,159.74,-9.93,37.29/)
	TMIN=-160
	TMAX=1200
C         CASE('CO')
	   CASE(3)
	RM=28.01
	AC=(/6.92,-.65,2.8,-1.14/)
	AV=(/32.28,47.47,-96.48/)
	AL=(/1.21,21.79,-.8416,1.958/)
	TMIN=-200
	TMAX=1400
C         CASE('CO2')
	   CASE(4)
	RM=44.01
	AC=(/5.14,15.4,-9.94,2.42/)
	AV=(/25.45,45.49,-86.49/)
	AL=(/-17.23,19.14,.1308,-2.514/)
	TMIN=-100
	TMAX=1400
C         CASE('N2')
	   CASE(5)
	RM=28.013
	AC=(/7.07,-1.32,3.31,-1.26/)
	AV=(/30.43,49.89,-109.3/)
	AL=(/.9359,23.44,-1.21,3.591/)
	TMIN=-160
	TMAX=1200
C         CASE('N2O')
	   CASE(6)
	RM=44.013
	AC=(/5.64,14.8,-9.68,2.33/)
	AV=(/32.28,44.54,-77.08/)
	AL=(/-18.71,21.26,-.2142,-.6371/)
	TMIN=-150
	TMAX=1400
C         CASE('NO')
	   CASE(7)
	RM=33.006
	AC=(/6.93,-.065,2.23,-.98/)
	AV=(/56.77,48.14,-84.34/)
	AL=(/11.99,17.18,-.02,-.85/)
	TMIN=-150
	TMAX=1400
C         CASE('NO2')
	   CASE(8)
	RM=46.006
	AC=(/5.53,13.2,-7.96,1.71/)
	AV=(/0.,0.,0./)
	AL=(/-33.52,26.46,-.755,1.071/)
	TMIN=25
	TMAX=1400
C         CASE('NH3')
	   CASE(9)
	RM=17.031
	AC=(/6.07,8.23,-.16,-.66/)
	AV=(/-9.372,38.99,-44.05/)
	AL=(/.91,12.87,2.93,-8.68/)
	TMIN=0
	TMAX=1200
C         CASE('O2')
	   CASE(10)
	RM=31.999
	AC=(/6.22,2.71,-.37,-.22/)
	AV=(/18.11,66.32,-187.9/)
	AL=(/-.7816,23.8,-.8939,2.324/)
	TMIN=-160
	TMAX=1200
C         CASE('SO2')
	   CASE(11)
	RM=64.063
	AC=(/5.85,15.4,-11.1,2.91/)
	AV=(/-3.793,46.45,-72.76/)
	AL=(/-19.31,15.15,-.33,.55/)
	TMIN=0
	TMAX=1400
C         CASE('SO3')
	   CASE(12)
	RM=80.058
	AC=(/3.96,34.6,-26.8,6.96/)
	AV=(/4.207,47.12,-68.34/)
	AL=(/-15.96,16.9,-.47,3./)
	TMIN=-100
	TMAX=1400
C         CASE('F2')
	   CASE(13)
	RM=37.997
	AC=(/5.89,6.94,-5.48,1.52/)
	AV=(/22.09,76.9,-211.6/)
	AL=(/1.8654,19.79,1.24,-17.77/)
	TMIN=-200
	TMAX=1000
C         CASE('Cl2')
	   CASE(14)
	RM=70.906
	AC=(/7.,5.05,-4.39,1.3/)
	AV=(/5.175,45.69,-88.54/)
	AL=(/3.25,5.8,.21,-1.25/)
	TMIN=-150
	TMAX=1200
C         CASE('Br2')
	   CASE(15)
	RM=159.808
	AC=(/8.11,2.32,-2.04,.62/)
	AV=(/2.153,54.5,-122.2/)
	AL=(/-.16,4.13,-.03,-.09/)
	TMIN=-150
	TMAX=1200
C         CASE('J2')
	   CASE(16)
	RM=253.808
	AC=(/8.57,1.13,-.91,.27/)
	AV=(/-17.75,54.71,-99.7/)
	AL=(/.63,2.73,-.03,.15/)
	TMIN=-150
	TMAX=1200
C         CASE('HF')
	   CASE(17)
	RM=20.006
	AC=(/7.16,-1.01,1.34,-.28/)
	AV=(/-19.21,45.98,-79.96/)
	AL=(/9.21,12.6,.54,-2.35/)
	TMIN=-100
	TMAX=1400
C         CASE('HCl')
	   CASE(18)
	RM=36.461
	AC=(/7.24,-1.76,3.07,-1./)
	AV=(/-9.554,54.45,-96.56/)
	AL=(/-.26,12.67,-.25,.16/)
	TMIN=-150
	TMAX=1400
C         CASE('HBr')
	   CASE(19)
	RM=80.912
	AC=(/7.15,-1.52,3.21,-1.13/)
	AV=(/-23.37,74.03,-144.8/)
	AL=(/-1.89,9.16,-.26,.53/)
	TMIN=-150
	TMAX=1200
C         CASE('He')
	   CASE(20)
	RM=4.003
	AC=(/4.97,0.,0.,0./)
	AV=(/54.16,50.14,-89.47/)
	AL=(/88.89,93.04,-1.79,3.09/)
	TMIN=-160
	TMAX=1200
C         CASE('Ne')
	   CASE(21)
	RM=20.183
	AC=(/4.97,0.,0.,0./)
	AV=(/87.79,78.6,-176.2/)
	AL=(/21.75,36.81,-2.005,6.042/)
	TMIN=-160
	TMAX=1200
C         CASE('Ar')
	   CASE(22)
	RM=39.948
	AC=(/4.97,0.,0.,0./)
	AV=(/43.87,63.99,-128./)
	AL=(/6.48,13.23,-.52,1.32/)
	TMIN=-150
	TMAX=1200
C         CASE('CH4')
	   CASE(23)
	RM=16.043
	AC=(/5.04,9.32,8.87,-5.37/)
	AV=(/15.96,34.39,-81.4/)
	AL=(/-4.463,20.84,2.815,-8.631/)
	TMIN=0
	TMAX=1000
C         CASE('C2H6')
	   CASE(24)
	RM=30.07
	AC=(/2.46,36.1,-7.,-.46/)
	AV=(/5.576,30.64,-53.07/)
	AL=(/-75.8,52.57,-4.593,39.74/)
	TMIN=0
	TMAX=1000
C         CASE('C3H8')
	   CASE(25)
	RM=44.097
	AC=(/-.58,69.9,-32.9,6.54/)
	AV=(/4.912,27.12,-38.06/)
	AL=(/4.438,-1.122,5.198,-20.08/)
	TMIN=0
	TMAX=1000
C         CASE('C3H6 cyclopropane')
	   CASE(26)
	RM=42.081
	AC=(/-6.28,79.8,-50.05,12.2/)
	AV=(/-7.787,34.78,-81.3/)
	AL=(/-20.46,9.74,3.77,-16.28/)
	TMIN=0
	TMAX=1000
C         CASE('C4H8 cyclobutane')
	   CASE(27)
	RM=56.108
	AC=(/-9.,105.,-62.9,14.5/)
	AV=(/-7.558,31.22,-65.69/)
	AL=(/-23.39,9.15,3.52,-14.81/)
	TMIN=-150
	TMAX=1400
C         CASE('C5H10 cyclopentane')
	   CASE(28)
	RM=70.135
	AC=(/-13.4,132.5,-76.09,16.8/)
	AV=(/-7.935,28.88,-52.38/)
	AL=(/-20.35,5.91,3.87,-16.51/)
	TMIN=0
	TMAX=1000
C         CASE('C6H12 cyclohexane')
	   CASE(29)
	RM=84.162
	AC=(/-16.2,165.,-91.3,18.8/)
	AV=(/-4.705,26.32,-44.1/)
	AL=(/-20.57,4.45,4.07,-17.31/)
	TMIN=0
	TMAX=1000
C         CASE('C2H4 ethylene')
	   CASE(30)
	RM=28.054
	AC=(/.934,36.9,-19.3,4.01/)
	AV=(/3.586,35.13,-80.55/)
	AL=(/-42.04,38.65,.7963,-3.262/)
	TMIN=-100
	TMAX=1000
C         CASE('C3H6 propylene')
	   CASE(31)
	RM=42.081
	AC=(/.68,56.8,-28.6,5.6/)
	AV=(/-5.601,31.88,-62.91/)
	AL=(/-18.11,14.57,2.38,-9.17/)
	TMIN=-100
	TMAX=1000
C         CASE('C4H8 butylene')
	   CASE(32)
	RM=56.108
	AC=(/-.515,83.1,-45.5,9.8/)
	AV=(/-8.884,29.59,-57.24/)
	AL=(/-25.12,13.78,2.43,-10.2/)
	TMIN=-100
	TMAX=1000
C         CASE('C6H6 benzene')
	   CASE(33)
	RM=78.114
	AC=(/-8.79,116.,-76.1,18.9/)
	AV=(/-15.76,32.45,-72.32/)
	AL=(/-20.19,8.64,2.34,-9.69/)
	TMIN=0
	TMAX=1000
C         CASE('C7H8 toluene')
	   CASE(34)
	RM=92.141
	AC=(/-9.34,138.5,-87.2,20.6/)
	AV=(/-8.421,27.11,-40.18/)
	AL=(/18.14,-9.57,5.66,-22.22/)
	TMIN=0
	TMAX=1000
C         CASE('C8H8 styrene')
	   CASE(35)
	RM=104.152
	AC=(/-7.22,150.,-99.9,25.2/)
	AV=(/-5.683,23.68,-32.68/)
	AL=(/2.09,-.46,2.97,-12.11/)
	TMIN=0
	TMAX=1000
C         CASE('C8H10 xylene')
	   CASE(36)
	RM=106.168
	AC=(/-3.68,142.,-82.1,18.2/)
	AV=(/1.176,21.74,-20.57/)
	AL=(/-13.66,8.53,1.78,-6.26/)
	TMIN=0
	TMAX=1000
C         CASE('C2H6O ethylalcohol')
	   CASE(37)
	RM=46.069
	AC=(/.239,62.3,-38.06,9.47/)
	AV=(/1.396,28.48,12.41/)
	AL=(/-18.62,9.95,2.9,-12.38/)
	TMIN=0
	TMAX=1000
C         CASE('C3H8O propylalcohol')
	   CASE(38)
	RM=60.096
	AC=(/2.71,68.6,-27.,1.51/)
	AV=(/-20.7,31.44,-14.35/)
	AL=(/-18.94,9.52,2.85,-11.99/)
	TMIN=0
	TMAX=1000
C         CASE('C4H10O butanol')
	   CASE(39)
	RM=74.123
	AC=(/2.51,91.1,-39.6,4.09/)
	AV=(/-18.43,28.67,-10.48/)
	AL=(/-18.56,8.51,2.88,-11.92/)
	TMIN=0
	TMAX=1000
C         CASE('C2H4O ethyloxide')
	   CASE(40)
	RM=44.054
	AC=(/-2.06,54.4,-32.1,7.31/)
	AV=(/-7.614,36.27,-66.32/)
	AL=(/-34.84,12.96,3.63,-18.26/)
	TMIN=0
	TMAX=1000
C         CASE('C3H6O propyloxide')
	   CASE(41)
	RM=58.08
	AC=(/-3.57,86.4,-61.6,18.5/)
	AV=(/-7.72,33.89,-55.94/)
	AL=(/-19.59,8.75,2.56,-10.91/)
	TMIN=0
	TMAX=1000
C         CASE('C4H8O butyloxide')
	   CASE(42)
	RM=92.53
	AC=(/-2.81,97.9,-48.6,6.1/)
	AV=(/-2.54,28.25,-35.24/)
	AL=(/-21.85,7.75,2.36,-10.66/)
	TMIN=0
	TMAX=1000
C         CASE('C6H7N anilin')
	   CASE(43)
	RM=93.129
	AC=(/-8.11,143.4,-107.,30.7/)
	AV=(/-14.98,29.03,-1.116/)
	AL=(/-26.39,11.89,1.55,-4.3/)
	TMIN=0
	TMAX=1000
C         CASE('C6H6O fenol')
	   CASE(44)
	RM=94.113
	AC=(/-5.68,126.,-85.4,20.5/)
	AV=(/-16.41,32.,0./)
	AL=(/-31.87,15.26,1.74,-4.4/)
	TMIN=0
	TMAX=1000
	ENDSELECT
c Yaws Liang correlations, perfect gas for density
	T2=T*T
	T3=T2*T
      WRITE(LABRHO,'('' RHO=1.013E5*'',F6.2,''/(T*8.314)'')')RM
	RHO=1.013E5*RM/(T*8.314)
	WRITE(LABCP,'('' CP=4186.8*('',F8.2,''+'',F8.2,''E-3*T+'',F8.2,''E
     /-6*T^2+'',F8.2,''E-9*T^3)/'',F6.1)')AC,RM
	CP=4186.8*(AC(1)+AC(2)*1E-3*T+AC(3)*1E-6*T2+AC(4)*1E-9*T3)/RM
	WRITE(LABVISC,'('' VISC=1E-7*('',F8.2,''+'',F8.2,''E-2*T+'',F8.2,'
     /'E-6*T^2)'')')AV
	VISC=1E-7*(AV(1)+AV(2)*1E-2*T+AV(3)*1E-6*T2)
	WRITE(LABLAM,'('' LAM=4.1868E-4*('',F8.2,''+'',F8.2,''E-2*T+'',F8.
     /2,''E-4*T^2+'',F8.2,''E-8*T^3)'')')AL
	RLAM=4.1868E-4*(AL(1)+AL(2)*1E-2*T+AL(3)*1E-4*T2+AL(4)*1E-8*T3)
	END

C --------------------------------------------------------------------

      SUBROUTINE DGLY(IEND)
C
C Procedura, ktera vypocte VISKOZITU A HUSTOTU JAKO FUNKCI KONCENTRACE  a teploty
C
      USE DIALOGM
      USE MSFLIB
      INCLUDE 'OPTION.FD'
      TYPE(DIALOG)DLG
      INTEGER RETINT
      LOGICAL RETLOG,DEFINED
      EXTERNAL WGLY
      IENDLOC=IEND
      IF(.NOT.DLGINIT(IDD_GLY,DLG))THEN
           WRITE(*,*)' ERROR DIALOG IDD_GLY NOT FOUND'
      ELSE
         RETLOG=DLGSET(DLG,IDC_COMBO_GLY,7,DLG_NUMITEMS)
         RETLOG=DLGSET(DLG,IDC_COMBO_GLY,'GLYCERIN+WATER',1)
         RETLOG=DLGSET(DLG,IDC_COMBO_GLY,'ETHYLEN GLYCOL+WATER',2)
         RETLOG=DLGSET(DLG,IDC_COMBO_GLY,'OLEUM H2SO4+WATER',3)
         RETLOG=DLGSET(DLG,IDC_COMBO_GLY,'NaCl+WATER',4)
         RETLOG=DLGSET(DLG,IDC_COMBO_GLY,'CaCl2+WATER',5)
         RETLOG=DLGSET(DLG,IDC_COMBO_GLY,'NaOH+WATER',6)
         RETLOG=DLGSET(DLG,IDC_COMBO_GLY,'KOH+WATER',7)
         RETLOG=DLGSETSUB(DLG,IDC_COMBO_GLY,WGLY,DLG_SELCHANGE)
	   RETLOG=DLGSET(DLG,IDC_EDIT_GLY1,'90')
	   RETLOG=DLGSET(DLG,IDC_EDIT_GLY2,'20.0')
         RETLOG=DLGSETSUB(DLG,IDC_EDIT_GLY1,WGLY,DLG_CHANGE)
         RETLOG=DLGSETSUB(DLG,IDC_EDIT_GLY2,WGLY,DLG_CHANGE)
         RETLOG=DLGSETSUB(DLG,IDC_BUTTON_GLY1,WGLY)
         RETLOG=DLGSETSUB(DLG,IDC_BUTTON_GLY2,WGLY)
C Aktivace panelu
         RETINT=DLGMODAL(DLG)
         CALL DLGUNINIT(DLG)
      ENDIF        
      END

      SUBROUTINE WGLY(DLG,CONTROL,CALLBACKTYPE)
 
C zobrazeni vypoctenych termodynamickych dat

      USE DIALOGM
      INCLUDE 'OPTION.FD'
      INCLUDE '$FEM'
      TYPE(DIALOG)DLG
      INTEGER CONTROL,CALLBACKTYPE,LOCALLBACK
      CHARACTER*60 TEXT
	CHARACTER*16 QLABEL
      LOGICAL RETLOG,DEFINED
	INTEGER*4,SAVE:: LM
	REAL ,SAVE:: E
	DIMENSION QW(50),QVAL(50)
      LOCALLBACK=CALLBACKTYPE
         RETLOG=DLGGET(DLG,IDC_COMBO_GLY,TEXT)
         SELECT CASE(TEXT)
         CASE('GLYCERIN+WATER')
	IL=1
         CASE('ETHYLEN GLYCOL+WATER')
	IL=2
         CASE('OLEUM H2SO4+WATER')
	IL=3
         CASE('NaCl+WATER')
	IL=4
         CASE('CaCl2+WATER')
	IL=5
         CASE('NaOH+WATER')
	IL=6
         CASE('KOH+WATER')
	IL=7
         CASE DEFAULT
	IL=0
         ENDSELECT
C
	IF(IL.GT.0)THEN
         RETLOG=DLGGET(DLG,IDC_EDIT_GLY2,TEXT)
         CALL TAKERD(TEXT,24,0,TC,K)
         RETLOG=DLGGET(DLG,IDC_EDIT_GLY1,TEXT)
         CALL TAKERD(TEXT,24,0,W,K)        

	   CALL VGLY(IL,TC,W,VISC,RHO,TMIN,TMAX,WM1,WM2,DEFINED)
         IF(DEFINED)THEN
           WRITE(TEXT,'(''T-range:'',F6.1,'' , '',F6.1)')TMIN,TMAX
           RETLOG=DLGSET(DLG,IDC_STATIC_GLY_TRANGE,TEXT)
           WRITE(TEXT,'(''W-range:'',F6.1,'' , '',F6.1)')WM1,WM2
           RETLOG=DLGSET(DLG,IDC_STATIC_GLY_WRANGE,TEXT)
           WRITE(TEXT,'(e11.4)')rho
           RETLOG=DLGSET(DLG,IDC_STATIC_GLY1,TEXT)
           WRITE(TEXT,'(e11.4)')visc
           RETLOG=DLGSET(DLG,IDC_STATIC_GLY2,TEXT)
           IGP=0
	     SELECT CASE(CONTROL)
	     CASE (IDC_BUTTON_GLY2)
	       IGP=2
	       QLABEL='Density kg/m^3'
	     CASE (IDC_BUTTON_GLY1)
	       IGP=1
	       QLABEL='viscosity Pa.s'
	     ENDSELECT
	     IF(IGP.GT.0)THEN
	       DW=(WM2-WM1)/50.
	       QMIN=1E10
             QMAX=-QMIN
	       DO I=1,50
	         QW(I)=WM1+DW*(I-1)
               CALL VGLY(IL,TC,QW(I),VISC,RHO,TMIN,TMAX,WM1,WM2,DEFINED)
	         SELECT CASE(IGP)
	         CASE(1)
	            QVAL(I)=RHO
	         CASE(2)
	            QVAL(I)=VISC
	         ENDSELECT
	         QMIN=AMIN1(QMIN,QVAL(I))
	         QMAX=AMAX1(QMAX,QVAL(I))
	       ENDDO 
		   IF(QMAX.GT.1.001*QMIN)THEN	         
               II=FOCUSQQ(21)
               CALL GMFSTW(2,1,21,2,14,'w [%]',QLABEL,
     /0.,1.,0.,1.,WM1,WM2,QMIN,QMAX)
               CALL GMFAXE(2,3,15)
               CALL GMFPL(50,QW,QVAL,12)
               CALL GMFSW(1)
               II=FOCUSQQ(10)
	       ENDIF
	     ENDIF
	   ELSE
           RETLOG=DLGSET(DLG,IDC_STATIC_GLY_TRANGE,
     /'PROPERTIES NOT DEFINED YET')
	   ENDIF
	ENDIF
      END

	SUBROUTINE VGLY(IL,T,W,RHO,VISC,TMIN,TMAX,WM1,WM2,DEFINED)
C Databaze termofyzikalnich vlastnosti pro teploty T v kelvinech
	PARAMETER (MAXT=10)
	LOGICAL DEFINED
      DIMENSION ET(MAXT),MET(MAXT),AWL(3,MAXT),AWH(4,MAXT),WR(MAXT),
     /QVISC(MAXT),QRHO(MAXT),AR(2,MAXT)
	DEFINED=.FALSE.
	IF(T.LE.1.OR.T.GT.1300.)RETURN
	DEFINED=.TRUE.
      SELECT CASE(IL)

	CASE(1)
C         ('GLYCERIN')
	TMIN=0.
	TMAX=80.
	WM1=0
	WM2=100.
	NT=8
C ET-teploty WE-mezni koncentrace pro korelace LOW,HIGH, MET-typ korelace
	ET(1:NT)=(/20.,25.,30.,40.,50.,60.,70.,80./)
	WR(1:NT)=(/90.,90.,90.,0.,0.,0.,0.,0./)
	MET(1:NT)=(/1,1,1,1,1,1,1,1/)
	AWL(1:3,1)=(/.008285,.01017,-.006769/)
	AWH(1:4,1)=(/6.546,-.1618,.001287,1.999/)
	AWL(1:3,2)=(/-.03927,.01002,-.006778/)
	AWH(1:4,2)=(/6.284,-.1558,.001228,2./)
	AWL(1:3,3)=(/-.08721,.01006,-.006709/)
	AWH(1:4,3)=(/6.841,-.1682,.00129,1.998/)
	AWH(1:4,4)=(/-.1012,.009695,.2468E-7,3.899/)
	AWH(1:4,5)=(/-.2061,.009851,.142E-7,3.989/)
	AWH(1:4,6)=(/-.3301,.01076,.4004E-8,4.227/)
	AWH(1:4,7)=(/-.4072,.01085,.2207E-8,4.328/)
	AWH(1:4,8)=(/.2406,-.01209,.4873E-4,2.35/)
	AR(1,1:NT)=(/.9944,.997,.9957,.9923,.988,.983,.9777,.9716/)
	AR(2,1:NT)=(/.002672,.00263,.00262,.00259,.00257,.00255,.00253,
     /.00252/)

	CASE(2)
C        ('ETYLENGLYKOL')
	TMIN=0
	TMAX=50
	WM1=4
	WM2=47
	NT=3
	ET(1:NT)=(/0.,20.,50./)
	WR(1:NT)=(/0.,0.,0./)
	MET(1:NT)=(/1,1,1/)
	AWH(1:4,3)=(/-.2386,.006754,.1086E-7,4.23/)
	AWH(1:4,2)=(/-.0147,.01132,.2069E-13,7.254/)
	AWH(1:4,1)=(/0.232,.01632,-.001769,1.159/)
	AR(1,1:NT)=(/.9975,.997,.99/)
	AR(2,1:NT)=(/1.371E-3,1.371E-3,1.371E-3/)

	CASE(3)
C OLEUM
      DEFINED=.FALSE.
      CASE(4)
C NaCl
      DEFINED=.FALSE.

	CASE(5)
C CaCl2
      DEFINED=.FALSE.

	CASE(6)
C NaOH
      DEFINED=.FALSE.

	CASE(7)
C KOH
      DEFINED=.FALSE.

	CASE DEFAULT
	   RHO=0.
	   VISC=0.
	   RETURN
	ENDSELECT
C Vyhodnoceni hustot a viskozit pro NT teplot
	IF(T.LT.TMIN.OR.T.GT.TMAX.OR.W.LT.WM1.OR.W.GT.WM2)THEN
	   RHO=0
	   VISC=0
	ELSE
	DO IT=1,NT
	SELECT CASE(MET(IT))
	CASE(1)
	TT=ET(IT)
	IF(W.GE.WR(IT))THEN
	 QVISC(IT)=10.**(AWH(1,IT)+AWH(2,IT)*W+AWH(3,IT)*W**AWH(4,IT)-3.)
	ELSE
	 QVISC(IT)=10.**((AWL(1,IT)+AWL(2,IT)*W)/(1+AWL(3,IT)*W)-3.)
	ENDIF
	QRHO(IT)=(AR(1,IT)+AR(2,IT)*W)*1000.
	ENDSELECT
	ENDDO
C Interpolace ve vektoru QVISC pro teplotu T
      DO I=2,NT
	IF(ET(I).GE.T)THEN
	VISC=QVISC(I-1)+(T-ET(I-1))*(QVISC(I)-QVISC(I-1))/(ET(I)-ET(I-1))
	RHO=QRHO(I-1)+(T-ET(I-1))*(QRHO(I)-QRHO(I-1))/(ET(I)-ET(I-1))
	EXIT
	ENDIF
	ENDDO
	ENDIF
	END

C --------------------------------------------------------------------

      SUBROUTINE DTHERMO(IEND)
C
C Procedura, ktera vypocte termofyzikalni vlastnosti dle Sestak J. Transportni a termodynamicka data..
C
      USE DIALOGM
      USE MSFLIB
      INCLUDE 'OPTION.FD'
      TYPE(DIALOG)DLG
      INTEGER RETINT
      LOGICAL RETLOG
      EXTERNAL WTHERMO
      IENDLOC=IEND
      IF(.NOT.DLGINIT(IDD_PROPERTIES,DLG))THEN
           WRITE(*,*)' ERROR DIALOG IDD_PROPERTIES NOT FOUND'
      ELSE
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,56,DLG_NUMITEMS)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'water',1)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'petrol',2)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'hydrogen H2',3)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'carbon monoxide CO',4)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'carbon dioxide CO2',5)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'nitride dioxide NO2',6)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'nitride monoxide NO',7)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'ammonia NH3',8)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'nitrogen N2',9)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'oxygen O2',10)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'sulphur dioxide SO2',11)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'chlorine Cl2',12)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'Bromine Br2',13)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'hydrogenchlorine HCl',14)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'hydrogenbromine HBr',15)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'sulphuric acid H2SO4',16)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'methane CH4',17)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'ethane C2H6',18)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'propane C3H8',19)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'butane C4H10',20)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'pentane C5H12',21)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'hexane C6H14',22)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'cyclobutane C4H8',23)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'cyclopentane C5H10',24)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'cyclohexane C6H12',25)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'ethylene C2H4',26)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'propylene C3H6',27)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'acethylene C2H2',28)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'benzene C6H6',29)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'toluene C7H8',30)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'styrene C8H8',31)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'xylene C8H10',32)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'napthalene C10H8',33)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'tetrachlomethane CCl4',34)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'chloroform ChCl3',35)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'methylenchloride CH2Cl2',36)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'methylchloride CH3Cl',37)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'methanol CH3OH',38)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'ethanol C2H5OH',39)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'propanol C3H7OH',40)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'butanol C4H9OH',41)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'ethylenglycol C2H6O2',42)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'glycerine C3H8O3',43)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'aceton C3H6O',44)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'diethylether C4H10O',45)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'ethyleneoxid C2H4O',46)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'vinegar acid C2H4O2',47)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'fenylamin (anilin) C6H7N',48)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'nitrobenzene C6H5NO2',49)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'fenol C6H6O',50)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'polyethylene',51)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'polypropylene',52)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'polyvinilchloride',53)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'polystyrene',54)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'polyamide',55)
         RETLOG=DLGSET(DLG,IDC_COMBO1prop,'oil',56)
         RETLOG=DLGSETSUB(DLG,IDC_COMBO1prop,WTHERMO,DLG_SELCHANGE)
	   RETLOG=DLGSET(DLG,IDC_EDIT1prop,'20.0')
         RETLOG=DLGSETSUB(DLG,IDC_EDIT1prop,WTHERMO,DLG_CHANGE)
         RETLOG=DLGSETSUB(DLG,IDC_BUTTON_GP1,WTHERMO)
         RETLOG=DLGSETSUB(DLG,IDC_BUTTON_GP2,WTHERMO)
         RETLOG=DLGSETSUB(DLG,IDC_BUTTON_GP3,WTHERMO)
         RETLOG=DLGSETSUB(DLG,IDC_BUTTON_GP4,WTHERMO)
         RETLOG=DLGSETSUB(DLG,IDC_BUTTON_GP5,WTHERMO)
         RETLOG=DLGSETSUB(DLG,IDC_BUTTON_GP6,WTHERMO)
C Aktivace panelu
         RETINT=DLGMODAL(DLG)
         CALL DLGUNINIT(DLG)
      ENDIF        
      END

      SUBROUTINE WTHERMO(DLG,CONTROL,CALLBACKTYPE)
 
C zobrazeni vypoctenych termodynamickych dat

      USE DIALOGM
      INCLUDE 'OPTION.FD'
      INCLUDE '$FEM'
	INCLUDE '$GMF'
      TYPE(DIALOG)DLG
      INTEGER CONTROL,CALLBACKTYPE,LOCALLBACK
      CHARACTER*60 TEXT
	CHARACTER*16 QLABEL
      CHARACTER*100 LABP,LABR,LABCP,LABRHO,LABLAM,LABVISC,QLAB
      LOGICAL RETLOG,DEFINED
	INTEGER*4,SAVE:: LM
	REAL ,SAVE:: E
	DIMENSION QTEMP(50),QVAL(50)
      LOCALLBACK=CALLBACKTYPE
         RETLOG=DLGGET(DLG,IDC_COMBO1prop,TEXT)
         SELECT CASE(TEXT)
         CASE('water')
	IL=1
         CASE('petrol')
	IL=2
         CASE('hydrogen H2')
	IL=3
         CASE('carbon monoxide CO')
	IL=4
         CASE('carbon dioxide CO2')
	IL=5
         CASE('nitride dioxide NO2')
	IL=6
         CASE('nitride monoxide NO')
	IL=7
         CASE('ammonia NH3')
	IL=8
         CASE('nitrogen N2')
	IL=9
         CASE('oxygen O2')
	IL=10
         CASE('sulphur dioxide SO2')
	IL=11
         CASE('chlorine Cl2')
	IL=12
         CASE('Bromine Br2')
	IL=13
         CASE('hydrogenchlorine HCl')
	IL=14
         CASE('hydrogenbromine HBr')
	IL=15
         CASE('sulphuric acid H2SO4')
	IL=16
         CASE('methane CH4')
	IL=17
         CASE('ethane C2H6')
	IL=18
         CASE('propane C3H8')
	IL=19
         CASE('butane C4H10')
	IL=20
         CASE('pentane C5H12')
	IL=21
         CASE('hexane C6H14')
	IL=22
         CASE('cyclobutane C4H8')
	IL=23
         CASE('cyclopentane C5H10')
	IL=24
         CASE('cyclohexane C6H12')
	IL=25
         CASE('ethylene C2H4')
	IL=26
         CASE('propylene C3H6')
	IL=27
         CASE('acethylene C2H2')
	IL=28
         CASE('benzene C6H6')
	IL=29
         CASE('toluene C7H8')
	IL=30
         CASE('styrene C8H8')
	IL=31
         CASE('xylene C8H10')
	IL=32
         CASE('napthalene C10H8')
	IL=33
         CASE('tetrachlomethane CCl4')
	IL=34
         CASE('chloroform ChCl3')
	IL=35
         CASE('methylenchloride CH2Cl2')
	IL=36
         CASE('methylchloride CH3Cl')
	IL=37
         CASE('methanol CH3OH')
	IL=38
         CASE('ethanol C2H5OH')
	IL=39
         CASE('propanol C3H7OH')
	IL=40
         CASE('butanol C4H9OH')
	IL=41
         CASE('ethylenglycol C2H6O2')
	IL=42
         CASE('glycerine C3H8O3')
	IL=43
         CASE('aceton C3H6O')
	IL=44
         CASE('diethylether C4H10O')
	IL=45
         CASE('ethyleneoxid C2H4O')
	IL=46
         CASE('vinegar acid C2H4O2')
	IL=47
         CASE('fenylamin (anilin) C6H7N')
	IL=48
         CASE('nitrobenzene C6H5NO2')
	IL=49
         CASE('fenol C6H6O')
	IL=50
         CASE('polyethylene')
	IL=51
         CASE('polypropylene')
	IL=52
         CASE('polyvinilchloride')
	IL=53
         CASE('polystyrene')
	IL=54
         CASE('polyamide')
	IL=55
         CASE('oil')
	IL=56
         CASE DEFAULT
	IL=0
         ENDSELECT
C
	IF(IL.GT.0)THEN
         RETLOG=DLGGET(DLG,IDC_EDIT1prop,TEXT)
         CALL TAKERD(TEXT,24,0,TC,K)
         t=tc+273.15

	   CALL THERMO(IL,T,RHO,CP,RLAM,VISC,P,R,TMIN,TMAX,
     /LABP,LABR,LABCP,LABRHO,LABLAM,LABVISC,DEFINED)
         IF(DEFINED)THEN
           WRITE(TEXT,'(F6.1,'' , '',F6.1)')TMIN,TMAX
           RETLOG=DLGSET(DLG,IDC_STATIC_TRANGE,TEXT)
           WRITE(TEXT,'(e11.4)')rho
           RETLOG=DLGSET(DLG,IDC_STATIC_a,TEXT)
           WRITE(TEXT,'(e11.4)')cp
           RETLOG=DLGSET(DLG,IDC_STATIC_b,TEXT)
           WRITE(TEXT,'(e11.4)')rlam
           RETLOG=DLGSET(DLG,IDC_STATIC_c,TEXT)
           WRITE(TEXT,'(e11.4)')visc
           RETLOG=DLGSET(DLG,IDC_STATIC_d,TEXT)
           WRITE(TEXT,'(e11.4)')p
           RETLOG=DLGSET(DLG,IDC_STATIC_e,TEXT)
           WRITE(TEXT,'(e11.4)')r
           RETLOG=DLGSET(DLG,IDC_STATIC_f,TEXT)
	     IF(IL.GE.51.AND.IL.LE.52)THEN
            RETLOG=DLGSET(DLG,IDC_STATIC_PK,'K-consistency coef. [Pa.s^n
     /]     =')
            RETLOG=DLGSET(DLG,IDC_STATIC_PN,'n-flow behavior index [-]  
     /      =')
	     ELSE
            RETLOG=DLGSET(DLG,IDC_STATIC_PK,'viscosity [Pa.s]      =')
            RETLOG=DLGSET(DLG,IDC_STATIC_PN,'pressure of saturated vapou
     /r [Pa]=')
	     ENDIF
	     IGP=0
	     SELECT CASE(CONTROL)
           CASE (IDC_BUTTON_GP1)
	       IGP=1
	       QLABEL='Density kg/m^3'
	       QLAB=LABRHO
	     CASE (IDC_BUTTON_GP2)
	       IGP=2
	       QLABEL='Cp J/kg/K'
	       QLAB=LABCP
	     CASE (IDC_BUTTON_GP3)
	       IGP=3
	       QLABEL='lambda W/m/K'
	       QLAB=LABLAM
	     CASE (IDC_BUTTON_GP4)
	       IGP=4
	       IF(IL.GE.51.AND.IL.LE.52)THEN
	          QLABEL='K [Pa.s^n]'
	       ELSE
	          QLABEL='viscosity Pa.s'
	          QLAB=LABVISC
	       ENDIF
	     CASE (IDC_BUTTON_GP5)
	       IGP=5
	       IF(IL.GE.51.AND.IL.LE.52)THEN
	          QLABEL='n [-]'
	       ELSE
	          QLABEL='p sat [Pa]'
	          QLAB=LABP
	       ENDIF
	     CASE (IDC_BUTTON_GP6)
	       IGP=6
	       QLABEL='r-evaporat.J/kg'
	       QLAB=LABR
	     ENDSELECT
	     IF(IGP.GT.0)THEN
	       DT=(TMAX-TMIN)/50.
	       QMIN=1E10
             QMAX=-QMIN
             DO I=1,50
	         QTEMP(I)=TMIN+DT*(I-1)
	         T=QTEMP(I)+273.15
	         CALL THERMO(IL,T,RHO,CP,RLAM,VISC,P,R,TMIN,TMAX,
     /LABP,LABR,LABCP,LABRHO,LABLAM,LABVISC,DEFINED)
	         SELECT CASE(IGP)
	         CASE(1)
	            QVAL(I)=RHO
	         CASE(2)
	            QVAL(I)=CP
	         CASE(3)
	            QVAL(I)=RLAM
	         CASE(4)
	            QVAL(I)=VISC
	         CASE(5)
	            QVAL(I)=P
	         CASE(6)
	            QVAL(I)=R
	         ENDSELECT
	         QMIN=AMIN1(QMIN,QVAL(I))
	         QMAX=AMAX1(QMAX,QVAL(I))
	       ENDDO 
		   IF(QMAX.GT.1.001*QMIN)THEN	         
               II=FOCUSQQ(21)
               CALL GMFSTW(2,1,21,2,14,'T [C]',QLABEL,
     /0.,1.,0.,1.,TMIN,TMAX,QMIN,QMAX)
               CALL GMFAXE(2,3,15)
               AXMI=FXMI
	         AXMA=FXMA
	         AYMI=FYMI
	         AYMA=FYMA
	         DQ=(AYMA-AYMI)*.05
	         CALL GMFREC(AXMI,AXMA,AYMA-DQ,AYMA,8)
	         CALL GMFILL((AXMI+AXMA)*.5,AYMA-DQ*.5,15,8)
	         CALL GMFREC(AXMI,AXMA,AYMA-DQ,AYMA,15)
	         CALL GMFTEXT(AXMI,AYMA,12,100,QLAB)
               CALL GMFPL(50,QTEMP,QVAL,12)
               CALL GMFSW(1)
               II=FOCUSQQ(10)
	       ENDIF
	     ENDIF
	   ELSE
           RETLOG=DLGSET(DLG,IDC_STATIC_TRANGE,'PROPERTIES NOT DEFINED')
	   ENDIF
	ENDIF
      END

	SUBROUTINE THERMO(IL,T,RHO,CP,RLAM,VISC,P,R,TMIN,TMAX,
     /LABP,LABR,LABCP,LABRHO,LABLAM,LABVISC,DEFINED)

C Databaze termofyzikalnich vlastnosti pro teploty T v kelvinech

      LOGICAL DEFINED
      CHARACTER*100 LABP,LABR,LABCP,LABRHO,LABLAM,LABVISC
      DIMENSION AP(5),ARHO(3),AR(3),ACP(4),AMI(4),AL(3)
	EQUIVALENCE (ARHO(3),TK),(AR(2),T1),(AR(1),R1),(AR(3),RN)
	DEFINED=.FALSE.
	IF(T.LE.1.OR.T.GT.1300.)RETURN
	DEFINED=.TRUE.
	T1=T-273.15
      SELECT CASE(IL)
C         ('water')
	CASE(1)
	AP=(/16.373,-2818.6,-1.6908,-5.7546,4.0073/)
	ARHO=(/.3471,.274,374.2/)
	AR=(/538.7,100.,.38/)
	ACP=(/.6741,2.825,-8.371,8.601/)
	AMI=(/-10.73,1828.,1.966,-14.66/)
	AL=(/-916.62,1254.73,-152.12/)
	TMIN=0.
	TMAX=374
	MET=1
C         ('petrol') - LETECKY PETROLEJ bOLGARSKIJ 1972
	CASE(2)
	RHO=825-.748*T1
	VISC=0.08625+2.911*EXP(-0.02114*T1)
	RLAM=.156-.000234*T1
	CP=1840.-3.8*T1
	TMIN=0.
	TMAX=200
	MET=0
C         ('hydrogen H2')
	CASE(3)
	AP=(/5.2366,-46.28,-0.44809,25.29,0./)
	ARHO=(/.315,0.3473,-240.2/)
	AR=(/107.,-252.8,0.237/)
	ACP=(/3.79,-329.8,12170.9,-2434.8/)
	AMI=(/-4.857,25.13,14.09,-2773./)
	AL=(/-20.41,2473.7,-5347.26/)
	TMIN=-259.4
	TMAX=-241
	MET=1
C         ('carbon monoxide CO')
	CASE(4)
	AP=(/32.863,-606.91,-12.969,27.551,0./)
	ARHO=(/0.2931,0.2706,-140.1/)
	AR=(/51.6,-191.5,0.38/)
	ACP=(/0.5645,4.798,-143.7,911.95/)
	AMI=(/-2.346,105.2,0.4613,-19.64/)
	AL=(/475.48,3.31,-214.26/)
	TMIN=-205
	TMAX=-140
	MET=1
C         ('carbon dioxide CO2')
	CASE(5)
	AP=(/47.544,-1792.2,-16.559,13.833,0./)
	ARHO=(/0.4576,0.259,31.1/)
	AR=(/56.1,0.,0.38/)
	ACP=(/-19.3,254.6,-1095.5,1573.3/)
	AMI=(/-1.345,21.22,1.034,-34.05/)
	AL=(/972.06,-201.53,-22.99/)
	TMIN=-56.5
	TMAX=31.
	MET=1
C         ('nitride dioxide NO2')
	CASE(6)
	AP=(/33.024,-2276.7,-10.143,8.951,0./)
	ARHO=(/.5859,.283,158./)
	AR=(/99.,21.2,.38/)
	ACP=(/-1.625,18.99,-61.72,68.77/)
	AMI=(/-8.431,932.6,2.759,-37.54/)
	AL=(/519.74,6.22,-25.73/)
	TMIN=-11.3
	TMAX=158
	MET=1
C         ('nitride monoxide NO')
	CASE(7)
	AP=(/258.32,-4361.,-115.06,167.15,0./)
	ARHO=(/0.5201,0.2953,-93.1/)
	AR=(/110.,-151.8,0.38/)
	ACP=(/-19.06,523.6,-4704.5,14217./)
	AMI=(/-4.995,238.3,3.669,-134.3/)
	AL=(/423.34,253.19,-212.35/)
	TMIN=-163.8
	TMAX=-93
	MET=1
C         ('ammonia NH3')
	CASE(8)
	AP=(/38.44,-2066.2,-12.105,7.7768,0./)
	ARHO=(/.2312,.2471,132.4/)
	AR=(/327.4,-33.43,0.38/)
	ACP=(/-1.923,31.1,-110.9,137.6/)
	AMI=(/-8.591,876.4,2.681,-36.12/)
	AL=(/2551.3,-376.62,-29.35/)
	TMIN=-77.7
	TMAX=132.4
	MET=1
C         ('nitrogen N2')
	CASE(9)
	AP=(/21.623,-455.57,-7.5107,17.214,0./)
	ARHO=(/.3026,.2763,-146.8/)
	AR=(/47.5,-195.8,.38/)
	ACP=(/-1.064,59.47,-768.7,3357.3/)
	AMI=(/-12.14,376.1,12.,-470.9/)
	AL=(/627.99,-368.91,-22.57/)
	TMIN=-210.
	TMAX=-146.8
	MET=1
C         ('oxygen O2')
	CASE(10)
	AP=(/5.6486,-411.3,1.8118,-25.042,62.612/)
	ARHO=(/.4227,.2797,-118.5/)
	AR=(/50.9,-183.,0.38/)
	ACP=(/-.4587,32.34,-395.1,1575.7/)
	AMI=(/-2.072,93.22,.6031,-27.21/)
	AL=(/583.79,-210.49,-48.31/)
	TMIN=-219
	TMAX=-118.4
	MET=1
C         ('sulphur dioxide SO2')
	CASE(11)
	AP=(/46.554,-2456.3,-15.169,9.0026,0./)
	ARHO=(/.5164,.2554,157.6/)
	AR=(/93.,-10.,0.38/)
	ACP=(/-.5737,10.34,-40.28,52.85/)
	AMI=(/-2.67,406.7,0.6141,-12.54/)
	AL=(/2140.81,-783.66,71.43/)
	TMIN=-72
	TMAX=157
	MET=1
C         ('chlorine Cl2')
	CASE(12)
	AP=(/42.262,-2009.8,-13.963,9.3705,0./)
	ARHO=(/.5615,.2720,144./)
	AR=(/69.6,-34.06,0.38/)
	ACP=(/-.1322,4.72,-20.37,28.94/)
	AMI=(/-.7681,151.4,-.08065,.4075/)
	AL=(/599.01,-48.3,-15.24/)
	TMIN=-101
	TMAX=144
	MET=1
C         ('Bromine Br2')
	CASE(13)
	AP=(/32.102,-2454.8,-9.2176,4.2584,0./)
	ARHO=(/1.2267,.3225,315./)
	AR=(/44.8,58.78,.38/)
	ACP=(/-.3986,4.452,-13.36,13.22/)
	AMI=(/-1.4,387.5,.04157,-.5214/)
	AL=(/384.05,-3.07,-8.04/)
	TMIN=-7
	TMAX=315
	MET=1
C         ('hydrochloride HCl')
	CASE(14)
	AP=(/136.05,-3047.3,-58.416,95.496,-58.507/)
	ARHO=(/.4183,.2619,51.5/)
	AR=(/105.8,-85.03,.38/)
	ACP=(/-.1121,7.048,-35.31,66.21/)
	AMI=(/-1.515,194.6,.3067,-13.76/)
	AL=(/1071.7,-18.44,-65.81/)
	TMIN=-114
	TMAX=51
	MET=1
C         ('hydrogenbromine HBr')
	CASE(15)
	AP=(/-351.11,5375.2,161.89,-259.04,157.16/)
	ARHO=(/.7358,.2560,90./)
	AR=(/52.,-66.8,0.38/)
	ACP=(/-0.6353,10.02,-41.47,58.95/)
	AMI=(/-9.238,866.7,3.432,-51.72/)
	AL=(/579.89,38.34,-41.11/)
	TMIN=-87
	TMAX=90
	MET=1
C         ('sulphuric acid H2SO4') KONCENTROVANA 100%
	CASE(16)
	T1=T-273.15
	T2=T1*T1
	CP=1420.
	RLAM=0.3171+0.4393e-7*t1-0.8929e-6*t2
	RHO=1857-t1
c	VISC=0.0622-0.2048e-2*t1+0.2027e-4*t2
      VISC=0.007664+0.07892*EXP(-0.0664*T1)
	R=109E3
	P=0
	WRITE(LABCP,'(''CP=1420.'')')
	WRITE(LABLAM,'(''RLAM=0.3171+0.4393e-7*t1-0.8929e-6*t2'')')
	WRITE(LABRHO,'(''RHO=1857-t1'')')
	WRITE(LABVISC,'(''VISC=0.007664+0.07892*EXP(-0.0664*T1)'')')
	WRITE(LABP,'(''P=0'')')
	WRITE(LABR,'(''R=109E3'')')
	TMIN=0
	TMAX=75
	MET=0
C         ('methane CH4')
	CASE(17)
	AP=(/22.573,-656.24,-7.3942,11.896,0./)
	ARHO=(/.1611,.2877,-82.6/)
	AR=(/121.7,-161.5,.38/)
	ACP=(/1.23,-10.33,72.0,-107.3/)
	AMI=(/-11.67,499.3,8.125,-226.3/)
	AL=(/722.72,-144.42,-76.36/)
	TMIN=-182
	TMAX=-82
	MET=1
C         ('ethane C2H6')
	CASE(18)
	AP=(/16.316,-1074.8,-3.1434,-4.5534,10.373/)
	ARHO=(/.2202,.3041,32.3/)
	AR=(/116.7,-88.2,.38/)
	ACP=(/.1388,8.481,-56.54,126.1/)
	AMI=(/-4.444,290.1,1.905,-41.64/)
	AL=(/699.31,-165.88,-4.87/)
	TMIN=-183
	TMAX=32.3
	MET=1
C         ('propane C3H8')
	CASE(19)
	AP=(/36.007,-1737.2,-11.666,8.5187,0./)
	ARHO=(/.2204,.2753,96.7/)
	AR=(/101.8,-42.1,.38/)
	ACP=(/.3326,2.332,-13.36,30.16/)
	AMI=(/-3.372,313.5,1.034,-20.26/)
	AL=(/623.51,-126.79,-2.12/)
	TMIN=-187
	TMAX=97
	MET=1
C         ('butane C4H10')
	CASE(20)
	P=EXP(20.571-2154.9/(T-34.42))
	RHO=-10.73-28.41*EXP(.01398*T1)+644.2*EXP(-.8948E-3*T1)
	R=(316.1-1.71*T1+105.6*SIN(.009257*T1+.8092))*1000
	CP=(2.888+.01459*T1-1.136*SIN(.01028*T1+.4497))*1000
	VISC=(0.08268+.002641*EXP(-.04816*T1)+.1196*EXP(-.01224*T1))*1E-3
	RLAM=.06857+.1031E-6*EXP(-.1612*T1)+.05105*EXP(-.009754*T1)
	TMIN=-75
	TMAX=125
	MET=0
C         ('pentane C5H12')
	CASE(21)
	RHO=649-.8395*T1-.002686*T1*T1
	R=(384.6-.5874*T1-.003381*T1*T1)*1000
	CP=(2.214+.003805*T1+.1581E-4*T1*T1)*1000
	VISC=(-.4896+.1322*EXP(-.01714*T1)+.6429*EXP(-.9176E-3*T1))*1E-3
	RLAM=.03697-.007756*EXP(-.02*T1)+.09273*EXP(-.006409*T1)
	P=EXP(20.7261-2477.07/(T-39.94))
	TMIN=-25
	TMAX=150
	MET=0
C         ('hexane C6H14')
	CASE(22)
	P=EXP(20.7294-2697.55/(T-48.78))
	RHO=672.8-.841*T1-.001373*T1*T1
	R=(383.9-.503*T1-.002143*T1*T1)*1000
	CP=(2.161+.003064*T1+.125E-4*T1*T1)*1000
	VISC=(.3847-.8244E-3*T1)/(1+.008446*T1)*1E-3
	RLAM=.1263-.39E-3*T1+.369E-6*T1*T1
	TMIN=-40
	TMAX=160
	MET=0
C         ('cyclobutane C4H8')
	CASE(23)
	AP=(/211.96,-5392.8,-89.626,123.13,-64.646/)
	ARHO=(/.2575,.2711,190.4/)
	AR=(/103.,12.51,.38/)
	ACP=(/-.346,7.745,-27.,33.42/)
	AMI=(/-1.972,292.,.142,-1.706/)
	AL=(/346.67,-29.07,-3.62/)
	tmin=-90
	tmax=190
	MET=1
C         ('cyclopentane C5H10')
	CASE(24)
	AP=(/45.484,-2726.5,-14.599,7.67,0./)
	ARHO=(/.2701,.2737,238.5/)
	AR=(/93.,49.26,.38/)
	ACP=(/-.08117,4.146,-13.16,15.95/)
	AMI=(/-2.615,485.7,.3162,-3.762/)
	AL=(/511.73,-61.8,-1.39/)
	TMIN=-94
	TMAX=238
	MET=1
C         ('cyclohexane C6H12')
	CASE(25)
	AP=(/64.753,-3619.2,-21.753,10.742,0./)
	ARHO=(/.2729,.2727,280.3/)
	AR=(/85.1,80.74,.38/)
	ACP=(/-1.284,13.39,-35.1,32.27/)
	AMI=(/-1.91,599.2,-0.06749,.5026/)
	AL=(/388.26,-22.72,-3.3/)
	TMIN=6.5
	TMAX=280.3
	MET=1
C         ('ethylene C2H4')
	CASE(26)
	AP=(/30.895,-1196.8,-10.153,9.9351,0./)
	ARHO=(/.2118,.2784,9.9/)
	AR=(/115.4,-103.7,.38/)
	ACP=(/.3402,6.218,-50.12,126.3/)
	AMI=(/-7.706,461.8,3.725,-76.33/)
	AL=(/851.45,-228.94,-4.71/)
	TMIN=-169
	TMAX=9.9
	MET=1
C         ('propylene C3H6')
	CASE(27)
	AP=(/36.877,-1725.5,-12.057,8.9948,0./)
	ARHO=(/.2252,.2686,91.9/)
	AR=(/104.6,-47.7,.38/)
	ACP=(/.4706,1.683,-16.82,44.07/)
	AMI=(/-5.009,413.2,1.771,-30.92/)
	AL=(/694.04,-144.57,0.3/)
	TMIN=-185
	TMAX=92
	MET=1
C         ('acethylene C2H2')
	CASE(28)
	T1=T-273.15
	T2=T1*T1
	CP=3300+19.8*t1+0.1156*t2
	RLAM=0.098-0.65e-3*t1
	RHO=458.2-2.891*t1-0.01196*t2
	VISC=0.000106-0.389e-6*t1+0.8036e-8*t2
	P=0
	R=(396.3-5.5554*T1-0.03326*T2)*1000
	WRITE(LABCP,'(''CP=3300+19.8*t1+0.1156*t2'')')
	WRITE(LABLAM,'(''RLAM=0.098-0.65e-3*t1'')')
	WRITE(LABRHO,'(''RHO=458.2-2.891*t1-0.01196*t2'')')
	WRITE(LABVISC,'(''VISC=0.000106-0.389e-6*t1+0.8036e-8*t2'')')
	WRITE(LABP,'(''P=0'')')
	WRITE(LABR,'(''R=(396.3-5.5554*T1-0.03326*T2)*1000'')')
	TMIN=-80
	TMAX=20
	MET=0
C         ('benzene C6H6')
	CASE(29)
	AP=(/51.204,-3245.7,-16.403,7.54,0./)
	ARHO=(/.3051,.2714,288.94/)
	AR=(/94.1,80.1,.38/)
	ACP=(/-1.481,15.46,-43.7,44.09/)
	AMI=(/2.003,64.66,-1.105,9.648/)
	AL=(/424.26,1.14,-9.03/)
	TMIN=5.5
	TMAX=289
	MET=1
C         ('toluene C7H8')
	CASE(30)
	AP=(/115.21,-4918.1,-43.467,38.548,-13.496/)
	ARHO=(/.2883,.2624,318.8/)
	AR=(/86.1,110.6,.38/)
	ACP=(/-.1461,4.584,-13.46,14.25/)
	AMI=(/-2.553,559.1,.1987,-1.954/)
	AL=(/485.1,-53.84,-.59/)
	TMIN=-95
	TMAX=318
	MET=1
C         ('styrene C8H8')
	CASE(31)
	AP=(/768.68,-20562.6,-318.53,340.22,-136.67/)
	ARHO=(/.2829,.2498,369./)
	AR=(/84.69,145.,.38/)
	ACP=(/-.3154,5.465,-14.3,14.34/)
	AMI=(/-1.181,410.9,-.1378,.731/)
	AL=(/643.97,-80.82,.4/)
	TMIN=-30.6
	TMAX=369
	MET=1
C         ('xylene C8H10')
	CASE(32)
	AP=(/56.025,-3955.6,-17.831,7.3259,0./)
	ARHO=(/.287,.2619,357.8/)
	AR=(/82.9,144.4,.38/)
	ACP=(/-.4498,6.892,-18.6,17.86/)
	AMI=(/-1.447,451.1,-0.07678,.4675/)
	AL=(/393.83,-17.77,-3.38/)
	TMIN=-25
	TMAX=358
	MET=1
C         ('napthalene C10H8')
	CASE(33)
	AP=(/192.16,-8336.3,-72.834,56.768,-17.319/)
	ARHO=(/.3241,.2653,475.02/)
	AR=(/80.7,218.0,.38/)
	ACP=(/-1.412,11.61,-25.26,19.63/)
	AMI=(/-4.46,1093.,.4767,-2.548/)
	AL=(/317.24,14.22,-4.04/)
	TMIN=80.5
	TMAX=475
	MET=1
C         ('tetrachlomethane CCl4')
	CASE(34)
	AP=(/50.612,-3135.7,-16.313,7.8036,0./)
	ARHO=(/.5591,.2736,283.2/)
	AR=(/46.55,76.7,.38/)
	ACP=(/-.01228,2.058,-7.04,8.61/)
	AMI=(/-5.658,994.5,1.016,-8.733/)
	AL=(/383.95,-45.45,-.24/)
	TMIN=-23
	TMAX=283
	MET=1
C         ('chloroform ChCl3')
	CASE(35)
	AP=(/26.828,-2292.6,-7.186,3.1365,0./)
	ARHO=(/.5165,.2666,263.4/)
	AR=(/58.9,61.3,.38/)
	ACP=(/-.09154,3.149,-10.64,12.4/)
	AMI=(/-1.812,397.5,.1174,-1.784/)
	AL=(/390.25,-20.58,-5.06/)
	TMIN=-63
	TMAX=263
	MET=1
C         ('methylenchloride CH2Cl2')
	CASE(36)
	AP=(/65.845,-2732.3,-25.385,35.167,-19.359/)
	ARHO=(/.3933,.2141,241./)
	AR=(/78.7,39.8,.38/)
	ACP=(/.01117,3.009,-11.43,14.97/)
	AMI=(/-3.501,514.8,.7038,-7.985/)
	AL=(/537.74,-60.47,-2.69/)
	TMIN=-96
	TMAX=240
	MET=1
C         ('methylchloride CH3Cl')
	CASE(37)
	AP=(/42.827,-2100.9,-14.14,9.5055,0./)
	ARHO=(/.3542,.2573,143.1/)
	AR=(/102.2,-23.8,.38/)
	ACP=(/.04123,4.188,-19.11,29.73/)
	AMI=(/-1.311,157.7,0.1394,-2.899/)
	AL=(/902.96,-158.57,-4.21/)
	TMIN=-97
	TMAX=143
	MET=1
C         ('methanol CH3OH')
	CASE(38)
	AP=(/-42.629,-1186.2,23.279,-35.082,17.578/)
	ARHO=(/.2928,.276,239.4/)
	AR=(/260.1,64.7,.4/)
	ACP=(/.8382,-3.231,8.296,-.1689/)
	AMI=(/-17.09,2096.,4.738,-48.93/)
	AL=(/770.13,-114.28,2.79/)
	TMIN=-97
	TMAX=240
	MET=1
C         ('ethanol C2H5OH')
	CASE(39)
	AP=(/-10.967,-2212.6,10.298,-21.061,10.748/)
	ARHO=(/.2903,.2765,243.1/)
	AR=(/202.6,78.3,.4/)
	ACP=(/-.3499,9.559,-37.86,54.59/)
	AMI=(/-2.697,700.9,.2682,-4.917/)
	AL=(/628.,-91.88,5.28/)
	TMIN=-114
	TMAX=243
	MET=1
C         ('propanol C3H7OH')
	CASE(40)
	AP=(/-338.31,5127.5,148.8,-175.79,74.666/)
	ARHO=(/.2915,.2758,263.6/)
	AR=(/162.3,97.2,.4/)
	ACP=(/-.2761,8.573,-34.2,49.85/)
	AMI=(/-5.333,1158.,.8722,-9.699/)
	AL=(/442.74,-8.04,-5.29/)
	TMIN=-126
	TMAX=263
	MET=1
C         ('butanol C4H9OH')
	CASE(41)
	AP=(/-458.03,7760.4,199.14,-229.44,95.289/)
	ARHO=(/.2633,.2477,289.8/)
	AR=(/140.5,117.7,.4/)
	ACP=(/-.7587,12.97,-46.12,58.59/)
	AMI=(/-4.222,1130.,.4137,-4.328/)
	AL=(/546.51,-64.42,.316/)
	TMIN=-89
	TMAX=289
	MET=1
C         ('ethylenglycol C2H6O2')
	CASE(42)
	DEFINED=.FALSE.
C         ('glycerine C3H8O3')
	CASE(43)
	T1=T-273.15
	T2=T1*T1
	CP=2240+5.484*t1
	RLAM=0.2828+0.00014*t1
	RHO=1277-0.64*t1-0.2546e-5*t1**3.2
	VISC=0.00013+10.23*exp(-0.125*t1)+1.71*exp(-0.04853*t1)
	P=1000*(-0.01357+231.2*exp(-((t1-373.6)/91.21)**2))
	R=200500
	WRITE(LABCP,'(''CP=2240+5.484*t1'')')
	WRITE(LABLAM,'(''RLAM=0.2828+0.00014*t1'')')
	WRITE(LABRHO,'(''RHO=458.2-2.891*t1-0.01196*t2'')')
	WRITE(LABVISC,'(''VISC=0.00013+10.23*exp(-0.125*t1)+1.71*exp(-0.04
     /853*t1)'')')
	WRITE(LABP,'(''P=1000*(-0.01357+231.2*exp(-((t1-373.6)/91.21)**2))
     /'')')
	WRITE(LABR,'(''R=200500'')')
	TMIN=0
	TMAX=200
	MET=0
C         ('aceton C3H6O')
	CASE(44)
	DEFINED=.FALSE.
C         ('diethylether C4H10O')
	CASE(45)
	T1=T-273.15
	T2=T1*T1
	CP=2237+3.827*t1+0.0451*t2
	RLAM=0.1322-0.0002772*t1
	RHO=744.8-0.9623*t1-0.00409*t2
	VISC=(-0.0107+0.01265*exp(-0.046*t1)+0.2786*exp(-0.0084*t1))*1e-3
	P=0.1139e5+177.6*t1+16.48*t1**2.307
	R=1000*(378-1.89*t1)/(1-0.00352*t1)
	WRITE(LABCP,'(''CP=2237+3.827*t1+0.0451*t2'')')
	WRITE(LABLAM,'(''RLAM=0.1322-0.0002772*t1'')')
	WRITE(LABRHO,'(''RHO=744.8-0.9623*t1-0.00409*t2'')')
	WRITE(LABVISC,'(''VISC=(-0.0107+0.01265*exp(-0.046*t1)+0.2786*exp(
     /-0.0084*t1))*1e-3'')')
	WRITE(LABP,'(''P=0.1139e5+177.6*t1+16.48*t1**2.307'')')
	WRITE(LABR,'(''R=1000*(378-1.89*t1)/(1-0.00352*t1)'')')
	TMIN=-60
	TMAX=180
	MET=0
C         ('ethyleneoxid C2H4O')
	CASE(46)
	AP=(/40.723,-2372.4,-12.865,7.3243,0./)
	ARHO=(/.3172,.2608,195.8/)
	AR=(/138.5,10.55,.466/)
	ACP=(/.2839,2.347,-11.66,20.04/)
	AMI=(/-1.678,312.4,0.03232,-0.7838/)
	AL=(/626.62,-79.51,-2.85/)
	TMIN=-112
	TMAX=195
	MET=1
C         ('vinegar acid C2H4O2')
	CASE(47)
	DEFINED=.FALSE.
C         ('fenylamin (anilin) C6H7N')
	CASE(48)
	AP=(/18.893,-3104.,-3.4714,0.02743,0./)
	ARHO=(/.3392,.2761,426./)
	AR=(/112.4,184.4,.38/)
	ACP=(/.1407,2.467,-6.085,5.927/)
	AMI=(/-2.454,886.6,-0.02522,.5411/)
	AL=(/537.55,-30.42,-1.49/)
	TMIN=-6
	TMAX=426
	MET=1
C         ('nitrobenzene C6H5NO2')
	CASE(49)
	DEFINED=.FALSE.
C         ('fenol C6H6O')
	CASE(50)
	AP=(/672.71,-22197.3,-266.67,226.43,-73.731/)
	ARHO=(/.4094,.3246,420./)
	AR=(/116.4,181.8,.38/)
	ACP=(/-.6896,8.218,-18.42,14.47/)
	AMI=(/-8.039,1889.,1.055,-6.718/)
	AL=(/440.93,26.7,-7.01/)
	TMIN=40.7
	TMAX=420
	MET=1
C         ('polyethylene')
	CASE(51)
	T1=T-273.15
	T2=T1*T1
	CP=(2.56+4.98*EXP(-((T1-114)/11.2)**2))*1000.
	RLAM=.133+1.32*EXP(-.0296*T1)+.0421*EXP(-.643E-4*T1)
	RHO=938-.728*T1-13.4*SIN(.0331*T1+2.75)
	VISC=(0.168-0.00119*T1+0.219E-5*T2)*1E6
	P=0.106+.00193*T1-.178E-5*T2
	WRITE(LABCP,'(''CP=(2.56+4.98*EXP(-((T1-114)/11.2)**2))*1000'')')
	WRITE(LABLAM,'(''LAM=.133+1.32*EXP(-.0296*T1)+.0421*EXP(-.643E-4*T
     /1)'')')
	WRITE(LABRHO,'(''RHO=938-.728*T1-13.4*SIN(.0331*T1+2.75)'')')
	WRITE(LABVISC,'(''VISC=(0.168-0.00119*T1+0.219E-5*T2)*1E6'')')
	WRITE(LABP,'(''P=0.106+.00193*T1-.178E-5*T2'')')
	TMIN=50
	TMAX=260
	MET=0
C         ('polypropylene')
	CASE(52)
	T1=T-273.15
	T2=T1*T1
	RHO=558-235*SIN(.0181*T1+3.92)+18.3*SIN(.0746*T1+4.93)
	IF(T1.LE.160.)THEN
	CP=(1.28+.228E-3*T1)/(1.-.00443*T1)*1000.
	RLAM=.737-.942E-2*T1+.376E-4*T2
	ELSE
	CP=(-1.25+4.12*EXP(-.554E-3*T1))*1000.
	RLAM=.119-.125E-3*T1+.124E-6*T2
	ENDIF
	VISC=.245E6-.173E4*T1+3.37*T2
	P=.221+0.0002*T1
	WRITE(LABRHO,'(''RHO=558-235*SIN(.0181*T1+3.92)+18.3*SIN(.0746*T1+
     /4.93)'')')
	WRITE(LABVISC,'(''VISC=.245E6-.173E4*T1+3.37*T2'')')
	WRITE(LABP,'(''P=.221+0.0002*T1'')')
	TMIN=50
	TMAX=240
	MET=0
C         ('polyvinilchloride')
	CASE(53)
	T1=T-273.15
	RLAM=0.0921
	IF(T1.LE.180.)THEN
	CP=1420
	ELSE
	CP=700
	ENDIF
	RHO=1170.+.926*T1-0.00903*T1**2
	TMIN=50
	TMAX=200
	MET=0
C         ('polystyrene')
	CASE(54)
	T1=T-273.15
	IF(T1.LE.100.)THEN
	RLAM=0.2
	CP=1400
	RHO=1035
	ELSE
	RLAM=0.22
	CP=1740
	RHO=990
	ENDIF
	TMIN=50
	TMAX=240
	MET=0
C         ('polyamide')
	CASE(55)
	T1=T-273.15
	IF(T1.LE.160.)THEN
	CP=-7520+269*T1-2.55*T1**2+.829E-2*T1**3
	ELSE
	CP=2900
	ENDIF
	RLAM=0.21
	CP=1840+4*T1
	RHO=1000
	VISC=1420-(T1-160.)*28.8
	TMIN=50
	TMAX=240
	MET=0
C         ('oil')
	CASE(56)
	DEFINED=.FALSE.

	CASE DEFAULT
	   RHO=0.
	   VISC=0.
	   CP=0.
	   RLAM=0.
	   R=0.
	   P=0.
	   RETURN
	ENDSELECT
	SELECT CASE(MET)
	CASE(1)
C YAWS
	T2=T*T
	T3=T2*T
	P=10.**(AP(1)+AP(2)/T+AP(3)*ALOG10(T)+AP(4)*1E-3*T+AP(5)*1E-6*T2
     /+2.1249)
	RHO=10.**(3.+ALOG10(ARHO(1))-(1.-T/(TK+273.))**(2./7.)*
     /ALOG10(ARHO(2)))
      R=4186.8*R1*((TK+273.15-T)/(TK-T1))**RN
	CP=4186.8*(ACP(1)+ACP(2)*1E-3*T+ACP(3)*1E-6*T2+ACP(4)*1E-9*T3)
	VISC=10.**(AMI(1)+AMI(2)/T+AMI(3)*1E-2*T+AMI(4)*1E-6*T2-3.)
	RLAM=4.1868E-4*(AL(1)+AL(2)*1E-2*T+AL(3)*1E-4*T2)

	WRITE(LABP,'('' P=10^('',F7.1,''+'',F8.1,''/T+'',F7.2,''*LOG(T)+''
     /,F7.2,''E-3*T+'',F7.2,''E-6*T^2+2.125)'')')AP
	WRITE(LABRHO,'('' RHO=10^(3+LOG('',F8.2,'')-(1.-T/('',F8.1,''+273.
     /))^(2/7)*LOG('',F8.2,''))'')')ARHO(1),TK,ARHO(2)
      WRITE(LABR,'('' R=4186*'',F8.2,''*(('',F6.0,''+273-T)/('',F6.0,''-
     /'',F6.1,''))^'',F6.2)')AR(1),ARHO(3),ARHO(3),AR(2),AR(3)
	WRITE(LABCP,'('' CP=4186*('',F8.2,''+'',F8.2,''E-3*T+'',F8.2,''E-6
     /*T^2+'',F8.2,''E-9*T^3)'')')ACP
	WRITE(LABVISC,'('' VISC=10^('',F8.2,''+'',F8.2,''/T+'',F8.2,''E-2*
     /T+'',F8.2,''E-6*T^2-3)'')')AMI
	WRITE(LABLAM,'('' LAM=4.1868E-4*('',F8.2,''+'',F8.2,''E-2*T+'',F8.
     /2,''E-4*T^2)'')')AL
	ENDSELECT
	END


C ----------------------------------------------------------

      SUBROUTINE DIAPUMC(IEND,JMI,IG,IR,IM,I1,I2,AA,BB,CC,EE,FF,
     /    DPMIN,DPMAX,QFLOW,P1,P2,TMEAN,DENS,VISC,CP,RLAM)
C EID  - PUMP centrifugal
C aktivace dialogu. Nepouziva zadne CALLBACK procedury
      USE DIALOGM
      INCLUDE 'OPTION.FD'
      INCLUDE '$FEM'
      INTEGER RETINT
      TYPE(DIALOG)DLG
      CHARACTER*(LENLIN) TEXT
      IF(.NOT.DLGINIT(IDD_EIDPUMC,DLG))THEN
           WRITE(*,*)' ERROR DIALOG IDD_EIDPUMC NOT FOUND'
      ELSE
         WRITE(TEXT,'(I4)')JMI
         RETLOG=DLGSET(DLG,IDC_IPUMP,TEXT)
         WRITE(TEXT,'(I4)')IG
         RETLOG=DLGSET(DLG,IDC_EGROUP,TEXT)
         WRITE(TEXT,'(I4)')IR
         RETLOG=DLGSET(DLG,IDC_RCONST,TEXT)
         WRITE(TEXT,'(I4)')IM
         RETLOG=DLGSET(DLG,IDC_MPROP,TEXT)
         WRITE(TEXT,'(I4)')I1
         RETLOG=DLGSET(DLG,IDC_NODE1,TEXT)
         WRITE(TEXT,'(I4)')I2
         RETLOG=DLGSET(DLG,IDC_NODE2,TEXT)
         WRITE(TEXT,'(F8.0)')DENS
         RETLOG=DLGSET(DLG,IDC_DENS,TEXT)
         WRITE(TEXT,'(F8.4)')VISC
         RETLOG=DLGSET(DLG,IDC_VISC,TEXT)
         WRITE(TEXT,'(F8.0)')CP
         RETLOG=DLGSET(DLG,IDC_CP,TEXT)
         WRITE(TEXT,'(F8.1)')RLAM
         RETLOG=DLGSET(DLG,IDC_LAM,TEXT)
         WRITE(TEXT,'(E10.3)')AA
         RETLOG=DLGSET(DLG,IDC_EDITA,TEXT)
         WRITE(TEXT,'(E10.3)')BB
         RETLOG=DLGSET(DLG,IDC_EDITB,TEXT)
         WRITE(TEXT,'(E10.3)')CC
         RETLOG=DLGSET(DLG,IDC_EDITC,TEXT)
         WRITE(TEXT,'(E10.3)')EE
         RETLOG=DLGSET(DLG,IDC_EDITE,TEXT)
         WRITE(TEXT,'(E10.3)')FF
         RETLOG=DLGSET(DLG,IDC_EDITF,TEXT)
         WRITE(TEXT,'(E10.3)')DPMIN
         RETLOG=DLGSET(DLG,IDC_EPMIN,TEXT)
         WRITE(TEXT,'(E10.3)')DPMAX
         RETLOG=DLGSET(DLG,IDC_EPMAX,TEXT)
         WRITE(TEXT,'('' Q[m^3/s]='',E10.3,10X,''T[C]='',F5.0)')
     /QFLOW,TMEAN
         RETLOG=DLGSET(DLG,IDC_STATICRESULT1,TEXT)
         WRITE(TEXT,'('' p1[Pa]='',E10.3,10X,''p2[Pa]='',e10.3)')P1,P2
         RETLOG=DLGSET(DLG,IDC_STATICRESULT2,TEXT)
      RETINT=DLGMODAL(DLG)
         IF(RETINT.EQ.IDOK)THEN
           IEND=0
           RETLOG=DLGGET(DLG,IDC_DENS,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,DENS,K)
           RETLOG=DLGGET(DLG,IDC_VISC,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,VISC,K)
           RETLOG=DLGGET(DLG,IDC_CP,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,CP,K)
           RETLOG=DLGGET(DLG,IDC_LAM,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,RLAM,K)
           RETLOG=DLGGET(DLG,IDC_EDITA,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,AA,K)
           RETLOG=DLGGET(DLG,IDC_EDITB,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,BB,K)
           RETLOG=DLGGET(DLG,IDC_EDITC,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,CC,K)
           RETLOG=DLGGET(DLG,IDC_EDITE,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,EE,K)
           RETLOG=DLGGET(DLG,IDC_EDITF,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,FF,K)
           RETLOG=DLGGET(DLG,IDC_EPMIN,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,DPMIN,K)
           RETLOG=DLGGET(DLG,IDC_EPMAX,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,DPMAX,K)
         ELSE
           IEND=-1
         ENDIF
         CALL DLGUNINIT(DLG)
      ENDIF
      END

      SUBROUTINE DIAPUMD(IEND,JMI,IG,IR,IM,I1,I2,IFUN,
     /    DE,VOL,QFLOW,P1,P2,TMEAN,DENS,VISC,CP,RLAM)
C EID  - PUMP positive displacement
C aktivace dialogu. Nepouziva zadne CALLBACK procedury
      USE DIALOGM
      INCLUDE 'OPTION.FD'
      INCLUDE '$FEM'
      INTEGER RETINT
      TYPE(DIALOG)DLG
      CHARACTER*(LENLIN) TEXT
      IF(.NOT.DLGINIT(IDD_EIDPUMD,DLG))THEN
           WRITE(*,*)' ERROR DIALOG IDD_EIDPUMD NOT FOUND'
      ELSE
         WRITE(TEXT,'(I4)')JMI
         RETLOG=DLGSET(DLG,IDC_IPUMP,TEXT)
         WRITE(TEXT,'(I4)')IG
         RETLOG=DLGSET(DLG,IDC_EGROUP,TEXT)
         WRITE(TEXT,'(I4)')IR
         RETLOG=DLGSET(DLG,IDC_RCONST,TEXT)
         WRITE(TEXT,'(I4)')IM
         RETLOG=DLGSET(DLG,IDC_MPROP,TEXT)
         WRITE(TEXT,'(I4)')I1
         RETLOG=DLGSET(DLG,IDC_NODE1,TEXT)
         WRITE(TEXT,'(I4)')I2
         RETLOG=DLGSET(DLG,IDC_NODE2,TEXT)
         WRITE(TEXT,'(F8.0)')DENS
         RETLOG=DLGSET(DLG,IDC_DENS,TEXT)
         WRITE(TEXT,'(F8.4)')VISC
         RETLOG=DLGSET(DLG,IDC_VISC,TEXT)
         WRITE(TEXT,'(F8.0)')CP
         RETLOG=DLGSET(DLG,IDC_CP,TEXT)
         WRITE(TEXT,'(F8.1)')RLAM
         RETLOG=DLGSET(DLG,IDC_LAM,TEXT)
         WRITE(TEXT,'(E10.3)')VOL
         RETLOG=DLGSET(DLG,IDC_EVOL,TEXT)
         WRITE(TEXT,'(E10.3)')DE
         RETLOG=DLGSET(DLG,IDC_EDIM,TEXT)
         WRITE(TEXT,'('' T[C]='',F5.0)')TMEAN
         RETLOG=DLGSET(DLG,IDC_STATICR1,TEXT)
         WRITE(TEXT,'('' Q[m^3/S]='',E10.3)')QFLOW
         RETLOG=DLGSET(DLG,IDC_STATICR2,TEXT)
         WRITE(TEXT,'('' p1[Pa]='',E10.3,10x,''p2[Pa]='',E10.3)')P1,P2
         RETLOG=DLGSET(DLG,IDC_STATICR3,TEXT)
         WRITE(TEXT,'(I6)')IFUN
         RETLOG=DLGSET(DLG,IDC_EFUN,TEXT)
         IF(IFUN.GE.MIFUN.AND.IFUN.LE.MAFUN)THEN
            IFF=INDFUN(IFUN)
            IF(IFF.GT.0)THEN
              RETLOG=DLGSET(DLG,IDC_STATICFUNTEXT,FUNTXT(IFF))
            ELSE
              RETLOG=DLGSET(DLG,IDC_STATICFUNTEXT,'Defined by a table')
            ENDIF
         ELSE
            RETLOG=DLGSET(DLG,IDC_STATICFUNTEXT,'Defined by extended RT
     /D model')
         ENDIF
      RETINT=DLGMODAL(DLG)
         IF(RETINT.EQ.IDOK)THEN
           IEND=0
           RETLOG=DLGGET(DLG,IDC_DENS,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,DENS,K)
           RETLOG=DLGGET(DLG,IDC_VISC,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,VISC,K)
           RETLOG=DLGGET(DLG,IDC_CP,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,CP,K)
           RETLOG=DLGGET(DLG,IDC_LAM,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,RLAM,K)
           RETLOG=DLGGET(DLG,IDC_EVOL,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,VOL,K)
           RETLOG=DLGGET(DLG,IDC_EDIM,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,DE,K)
           RETLOG=DLGGET(DLG,IDC_EFUN,TEXT)
           CALL TAKISD(TEXT,LENLIN,0,IFUN,K)
         ELSE
           IEND=-1
         ENDIF
         CALL DLGUNINIT(DLG)
      ENDIF
      END

      SUBROUTINE WALFA(DLG,CONTROL,CALLBACKTYPE)
C 
C vyhodnoceni panelu vyberu materialu (COMBO1) a vypocet ALFA
      USE DIALOGM
      INCLUDE 'OPTION.FD'
      INCLUDE '$FEM'
      TYPE(DIALOG)DLG
      INTEGER CONTROL,CALLBACKTYPE,LOCALLBACK
      CHARACTER*22 TEXT
      LOGICAL RETLOG
C -----------------------------------------------------------
      COMMON /$DIA/ISMAT,IALFA,DENS,VISC,CP,RLAM,BETA,ALFA,ZZETA,
     /             EENA,EEMA,EENB,EEPRESS,EED,EEH
C -----------------------------------------------------------
      DATA ISW/0/
      LOCALLBACK=CALLBACKTYPE
      SELECT CASE(CONTROL)
      CASE(IDC_COMBO1)
         RETLOG=DLGGET(DLG,IDC_COMBO1,TEXT)
         SELECT CASE(TEXT)
         CASE('AIR')
           DENS=1.1
           CP=1006
           RLAM=0.027
           VISC=0.000019
           REVAP=2400000
           BETA=0.003
         CASE('FLUE GAS')
           DENS=0.75
           CP=1100
           RLAM=0.05
           VISC=0.00004
           REVAP=2400000
           BETA=0.003
         CASE('STEAM')
           DENS=1
           CP=1960
           RLAM=0.033
           VISC=0.000016
           REVAP=2400000
           BETA=0.003
         CASE('Crude OIL')
           DENS=900
           CP=2000
           RLAM=0.13
           VISC=0.128
           REVAP=2400000
           BETA=0.00065
         CASE('PETROL')
           DENS=800
           CP=2000
           RLAM=0.144
           VISC=0.128
           REVAP=2400000
           BETA=0.00084
         CASE('ETHYLGLYCOL')
           DENS=1117
           CP=2400
           RLAM=0.25
           VISC=1
           REVAP=2400000
           BETA=0.00065
         CASE('GLASS')
           DENS=2710
           CP=840
           RLAM=0.76
           VISC=1000
           REVAP=2400000
           BETA=0.00065
         CASE('WOOL GLASS')
           DENS=200
           CP=670
           RLAM=0.04
           VISC=1000
           REVAP=2400000
           BETA=0.00065
         CASE('ASBEST')
           DENS=576
           CP=840
           RLAM=0.15
           VISC=1000
           REVAP=2400000
           BETA=0.00065
         CASE('CARBON STEEL')
           DENS=7790
           CP=470
           RLAM=43
           VISC=1000
           REVAP=2400000
           BETA=0.00065
         CASE('STAINLESS STEEL')
           DENS=7820
           CP=460
           RLAM=15
           VISC=1000
           REVAP=2400000
           BETA=0.00065
         CASE('COPPER')
           DENS=8930
           CP=386
           RLAM=398
           VISC=1000
           REVAP=2400000
           BETA=0.00065
         CASE('ALUMINIUM')
           DENS=2710
           CP=902
           RLAM=236
           VISC=1000
           REVAP=2400000
           BETA=0.00065
         CASE DEFAULT
           RLAM=0.69
           VISC=0.001
           DENS=1000
           CP=4200
           REVAP=2400000
           BETA=0.0005
         ENDSELECT
         WRITE(TEXT,'(F7.0)')DENS
         RETLOG=DLGSET(DLG,IDC_DENS,TEXT)
         WRITE(TEXT,'(F7.0)')CP
         RETLOG=DLGSET(DLG,IDC_CP,TEXT)
         WRITE(TEXT,'(F8.3)')RLAM
         RETLOG=DLGSET(DLG,IDC_LAM,TEXT)
         ISMAT=1
         IF(ISW.GT.0)THEN
            RETLOG=DLGGET(DLG,IDC_EDIT1,TEXT)
            CALL TAKERD(TEXT,22,0,A1,K)
            RETLOG=DLGGET(DLG,IDC_EDIT2,TEXT)
            CALL TAKERD(TEXT,22,0,A2,K)
            RETLOG=DLGGET(DLG,IDC_EDIT3,TEXT)
            CALL TAKERD(TEXT,22,0,A3,K)
            SELECT CASE(ISW)
            CASE(1)
C FORCED CONV.CYLINDER
              IF(A1.GT.0..AND.A2.GT.0.)THEN
                RE=A1*A2*DENS/VISC
                PR=VISC*CP/RLAM
                RNU=(0.4*SQRT(RE)+0.06*RE**0.66666)*PR**0.4
                ALFA=RNU*RLAM/A1
                IALFA=1
              ELSE
                IALFA=0
              ENDIF
            CASE(2)
C FORCED CONV.ANNULUS
              IF(A1.GT.0..AND.A2.GT.0..AND.A3.GT.0.)THEN
                DE=ABS(A2-A1)
                RE=A3*DE*DENS/VISC
                PR=VISC*CP/RLAM
                RNU=0.023*RE**0.8*PR**0.4
                ALFA=RNU*RLAM/A1
                IALFA=2
              ELSE
                IALFA=0
              ENDIF
            CASE(3)
C NATURAL CONV. VERTICAL
              IF(A1.GT.0..AND.A2.NE.A3)THEN
                RA=DENS**2*CP*9.81*BETA*A1**3*ABS(A3-A2)/RLAM/VISC
                PR=VISC*CP/RLAM
                IF(RA.LE.1E4)THEN
                 RNU=0.68+0.67*RA**.25/(1+(0.492/PR)**(9./16.))**(4./9.)
                ELSEIF(RA.LE.1E9)THEN
                 RNU=0.59*RA**0.25
                ELSE
                 RNU=0.1*RA**0.33333
                ENDIF
                ALFA=RNU*RLAM/A1
                IALFA=3
              ELSE
                IALFA=0
              ENDIF
            CASE(4)
C NATURAL CONV. CYLINDER
              IF(A1.GT.0..AND.A2.NE.A3)THEN
                RA=DENS**2*CP*9.81*BETA*A1**3*ABS(A3-A2)/RLAM/VISC
                PR=VISC*CP/RLAM
                RNU=(SQRT(0.36)+0.387*(RA/(1+(0.56/PR)**(9./16.))
     /**(16./9.))**(1./6.))**2
                ALFA=RNU*RLAM/A1
                IALFA=4
              ELSE
                IALFA=0
              ENDIF
            CASE(5)
C CONDENSATION
              IF(A1.GT.0..AND.A2.NE.A3)THEN
                DENS=AMAX1(DENS,900.)
                ALFA=1.13*(RLAM**3*DENS**2*9.81*REVAP/
     /(VISC*A1*ABS(A2-A3)))**.25
                IALFA=5
              ELSE
                IALFA=0
              ENDIF
            CASE(6)
C INSULATION
              IF(A1.GT.0.)THEN
                ALFA=RLAM/A1
                IALFA=6
              ELSE
                IALFA=0
              ENDIF
            CASE(7)
C RADIATION
              IF(A1.NE.A2)THEN
                T1=A1+273
                T2=A2+273
                ALFA=5.67E-8*(T1+T2)*(T1**2+T2**2)
                IALFA=7
              ELSE
                IALFA=0
              ENDIF
            END SELECT
            IF(IALFA.GT.0)THEN
              SELECT CASE(IALFA)
              CASE(1,2)
                 WRITE(TEXT,'(''Re='',E10.3,'' Pr='',F5.1)')RE,PR
                 RETLOG=DLGSET(DLG,IDC_STATICTYPE,TEXT)
              CASE(3,4)
                 WRITE(TEXT,'(''Ra='',E10.3,'' Pr='',F5.1)')RA,PR
                 RETLOG=DLGSET(DLG,IDC_STATICTYPE,TEXT)
              CASE(5)
                 RETLOG=DLGSET(DLG,IDC_STATICTYPE,'Condensation steam   
     / ')
              CASE(6)
                 RETLOG=DLGSET(DLG,IDC_STATICTYPE,'Only conduction      
     / ')
              CASE(7)   
                 RETLOG=DLGSET(DLG,IDC_STATICTYPE,'Radiation            
     / ')
              END SELECT
              WRITE(TEXT,'(E10.3)')ALFA
              RETLOG=DLGSET(DLG,IDC_STATICRESULT,TEXT)
            ELSE
              RETLOG=DLGSET(DLG,IDC_STATICRESULT,'ALPHA cannot be comput
     /ed')
            ENDIF
         ENDIF
      CASE(IDC_BUTTON11)
         RETLOG=DLGSET(DLG,IDC_STATIC1,'D [m]=')
         RETLOG=DLGSET(DLG,IDC_STATIC2,'v [m/s]=')
         RETLOG=DLGSET(DLG,IDC_STATIC3,'         ')
         RETLOG=DLGSET(DLG,IDC_EDIT2,.TRUE.)
         RETLOG=DLGSET(DLG,IDC_EDIT3,.FALSE.)
         RETLOG=DLGSET(DLG,IDC_STATIC_PARAM,'Forced conv.-cylinder')
         ISW=1
      CASE(IDC_BUTTON22)
         RETLOG=DLGSET(DLG,IDC_STATIC1,'Dinner [m]=')
         RETLOG=DLGSET(DLG,IDC_STATIC2,'Douter [m]=')
         RETLOG=DLGSET(DLG,IDC_STATIC3,'v [m/s]=')
         RETLOG=DLGSET(DLG,IDC_EDIT2,.TRUE.)
         RETLOG=DLGSET(DLG,IDC_EDIT3,.TRUE.)
         RETLOG=DLGSET(DLG,IDC_STATIC_PARAM,'Forced conv.-annulus')
         ISW=2
      CASE(IDC_BUTTON33)
         RETLOG=DLGSET(DLG,IDC_STATIC1,'Height [m]=')
         RETLOG=DLGSET(DLG,IDC_STATIC2,'Twall  [C]=')
         RETLOG=DLGSET(DLG,IDC_STATIC3,'Tfluid [C]=')
         RETLOG=DLGSET(DLG,IDC_EDIT2,.TRUE.)
         RETLOG=DLGSET(DLG,IDC_EDIT3,.TRUE.)
         RETLOG=DLGSET(DLG,IDC_STATIC_PARAM,'Natural conv.wall')
         ISW=3
      CASE(IDC_BUTTON44)
         RETLOG=DLGSET(DLG,IDC_STATIC1,'Diameter[m]=')
         RETLOG=DLGSET(DLG,IDC_STATIC2,'Twall  [C]=')
         RETLOG=DLGSET(DLG,IDC_STATIC3,'Tfluid [C]=')
         RETLOG=DLGSET(DLG,IDC_EDIT2,.TRUE.)
         RETLOG=DLGSET(DLG,IDC_EDIT3,.TRUE.)
         RETLOG=DLGSET(DLG,IDC_STATIC_PARAM,'Natural conv.cyl.')
         ISW=4
      CASE(IDC_BUTTON55)
         RETLOG=DLGSET(DLG,IDC_STATIC1,'Height [m]=')
         RETLOG=DLGSET(DLG,IDC_STATIC2,'Tsteam [C]=')
         RETLOG=DLGSET(DLG,IDC_STATIC3,'Twall [C]=')
         RETLOG=DLGSET(DLG,IDC_EDIT2,.TRUE.)
         RETLOG=DLGSET(DLG,IDC_EDIT3,.TRUE.)
         RETLOG=DLGSET(DLG,IDC_STATIC_PARAM,'Condensing steam')
         ISW=5
      CASE(IDC_BUTTON66)
         RETLOG=DLGSET(DLG,IDC_STATIC1,'Thickness [m]=')
         RETLOG=DLGSET(DLG,IDC_STATIC2,'              ')
         RETLOG=DLGSET(DLG,IDC_STATIC3,'              ')
         RETLOG=DLGSET(DLG,IDC_EDIT2,.FALSE.)
         RETLOG=DLGSET(DLG,IDC_EDIT3,.FALSE.)
         RETLOG=DLGSET(DLG,IDC_STATIC_PARAM,'Insullation')
         ISW=6
      CASE(IDC_BUTTON77)
         RETLOG=DLGSET(DLG,IDC_STATIC1,'T1 [C]=')
         RETLOG=DLGSET(DLG,IDC_STATIC2,'T2 [C]=')
         RETLOG=DLGSET(DLG,IDC_STATIC3,'              ')
         RETLOG=DLGSET(DLG,IDC_EDIT2,.TRUE.)
         RETLOG=DLGSET(DLG,IDC_EDIT3,.FALSE.)
         RETLOG=DLGSET(DLG,IDC_STATIC_PARAM,'Radiation')
         ISW=7
      END SELECT
      END

      SUBROUTINE RALFA(IEND)
C
C Procedura, ktera zobrazi panel vyberu materialu a soucinitele prenosu tepla.
C Jeji vysledek je v bloku COMMON /$DIA/.
C ISMAT>0 platne hodnoty DENS,VISC,...
C IALFA>0 platne hodnoty ALFA
C
      USE DIALOGM
      USE MSFLIB
      INCLUDE 'OPTION.FD'
      TYPE(DIALOG)DALFA
      INTEGER RETINT
      LOGICAL RETLOG
      EXTERNAL WALFA
C -----------------------------------------------------------
      COMMON /$DIA/ISMAT,IALFA,DENS,VISC,CP,RLAM,BETA,ALFA,ZZETA,
     /             EENA,EEMA,EENB,EEPRESS,EED,EEH
C -----------------------------------------------------------
      ISMAT=0
      IALFA=0
      IF(.NOT.DLGINIT(IDD_DALPHA,DALFA))THEN
           WRITE(*,*)' ERROR DIALOG IDD_DALPHA NOT FOUND'
      ELSE
         RETLOG=DLGSET(DALFA,IDC_COMBO1,14,DLG_NUMITEMS)
         RETLOG=DLGSET(DALFA,IDC_COMBO1,'AIR',1)
         RETLOG=DLGSET(DALFA,IDC_COMBO1,'FLUE GAS',2)
         RETLOG=DLGSET(DALFA,IDC_COMBO1,'STEAM',3)
         RETLOG=DLGSET(DALFA,IDC_COMBO1,'WATER',4)
         RETLOG=DLGSET(DALFA,IDC_COMBO1,'Crude OIL',5)
         RETLOG=DLGSET(DALFA,IDC_COMBO1,'PETROL',6)
         RETLOG=DLGSET(DALFA,IDC_COMBO1,'ETHYLGLYCOL',7)
         RETLOG=DLGSET(DALFA,IDC_COMBO1,'GLASS',8)
         RETLOG=DLGSET(DALFA,IDC_COMBO1,'WOOL GLASS',9)
         RETLOG=DLGSET(DALFA,IDC_COMBO1,'ASBEST',10)
         RETLOG=DLGSET(DALFA,IDC_COMBO1,'CARBON STEEL',11)
         RETLOG=DLGSET(DALFA,IDC_COMBO1,'STAINLESS STEEL',12)
         RETLOG=DLGSET(DALFA,IDC_COMBO1,'COPPER',13)
         RETLOG=DLGSET(DALFA,IDC_COMBO1,'ALUMINIUM',14)
C button1 - CYLINDER
C button2 - ANNULAR
         RETLOG=DLGSETSUB(DALFA,IDC_BUTTON11,WALFA)
         RETLOG=DLGSETSUB(DALFA,IDC_BUTTON22,WALFA)
         RETLOG=DLGSETSUB(DALFA,IDC_BUTTON33,WALFA)
         RETLOG=DLGSETSUB(DALFA,IDC_BUTTON44,WALFA)
         RETLOG=DLGSETSUB(DALFA,IDC_BUTTON55,WALFA)
         RETLOG=DLGSETSUB(DALFA,IDC_BUTTON66,WALFA)
         RETLOG=DLGSETSUB(DALFA,IDC_BUTTON77,WALFA)
         RETLOG=DLGSETSUB(DALFA,IDC_COMBO1,WALFA,DLG_SELCHANGE)
C Aktivace panelu
         RETINT=DLGMODAL(DALFA)
         IF(RETINT.NE.IDOK)THEN
            ISMAT=0
            IALFA=0
            IEND=-1
         ELSE
            IEND=0
         ENDIF
         CALL DLGUNINIT(DALFA)
      ENDIF        
      END

      SUBROUTINE PIPALFA(DLG,CONTROL,CALLBACKTYPE)
C 
      USE DIALOGM
      INCLUDE 'OPTION.FD'
      TYPE(DIALOG)DLG
      INTEGER CONTROL,CALLBACKTYPE,LOCALLBACK
      CHARACTER*20 TEXT
      LOGICAL RETLOG
C -----------------------------------------------------------
      COMMON /$DIA/ISMAT,IALFA,DENS,VISC,CP,RLAM,BETA,ALFA,ZETA,
     /             EENA,EEMA,EENB,EEPRESS,EED,EEH
C -----------------------------------------------------------
      LOCALLBACK=CALLBACKTYPE
      SELECT CASE(CONTROL)
      CASE(IDC_BALPHA)
        CALL RALFA(IEND)
        IF(IEND.EQ.0.AND.IALFA.GT.0)THEN
           WRITE(TEXT,'(E10.3)')ALFA
           RETLOG=DLGSET(DLG,IDC_ALPHA,TEXT)
        ENDIF
      CASE(IDC_BZETA)
        CALL RZETA(IEND)
        IF(IEND.EQ.0)THEN
           WRITE(TEXT,'(E10.3)')ZETA
           RETLOG=DLGSET(DLG,IDC_ZETA,TEXT)
        ENDIF
      CASE(IDC_BSTRESS)
        CALL RSTRESS(IEND)
      ENDSELECT
      END

      SUBROUTINE DIAPIPE(IEND,JMI,IG,IR,IM,I1,I2,ISOURC,MULTI,
     /DE,QFLOW,BL,ALFA,ZETA,PRESS,
     /TMEAN,TWALL,TE,VEL,RE,TAU,FOUL,DUDY,AREA,PERIM,H,ROUGH,
     /DENS,VISC,CP,RLAM,ALEX,EYOUNG,EMJU,PERM,
     /ENA,ENB,EMA,EMB,ESIGMA,EMISE,EPOROSITY,EDBALLS,NAMELE)
C EID  - pipe2d nebo PIPE3D
C aktivace dialogu. Nepouziva zadne CALLBACK procedury
      USE DIALOGM
      INCLUDE 'OPTION.FD'
C -----------------------------------------------------------
      COMMON /$DIA/ISMAT,IALFA,DDENS,VVISC,CCP,RRLAM,BBETA,AALFA,ZZETA,
     /             EENA,EEMA,EENB,EEPRESS,EED,EEH
C -----------------------------------------------------------
      INCLUDE '$FEMB'
      INTEGER RETINT
      TYPE(DIALOG)DLG
      EXTERNAL PIPALFA
      CHARACTER*(LENLIN) TEXT
      IF(.NOT.DLGINIT(IDD_PIPE3D,DLG))THEN
           WRITE(*,*)' ERROR DIALOG IDD_PIPE3D NOT FOUND'
      ELSE
         WRITE(TEXT,'(I4)')JMI
         RETLOG=DLGSET(DLG,IDC_IPIPE,TEXT)
         WRITE(TEXT,'(I4)')IG
         RETLOG=DLGSET(DLG,IDC_EGROUP,TEXT)
         WRITE(TEXT,'(I4)')IR
         RETLOG=DLGSET(DLG,IDC_RCONST,TEXT)
         WRITE(TEXT,'(I4)')IM
         RETLOG=DLGSET(DLG,IDC_MPROP,TEXT)
         WRITE(TEXT,'(I4)')I1
         RETLOG=DLGSET(DLG,IDC_NODE1,TEXT)
         WRITE(TEXT,'(I4)')I2
         RETLOG=DLGSET(DLG,IDC_NODE2,TEXT)
         WRITE(TEXT,'(F9.3)')ZETA
         RETLOG=DLGSET(DLG,IDC_ZETA,TEXT)
         WRITE(TEXT,'(F9.1)')ALFA
         RETLOG=DLGSET(DLG,IDC_ALPHA,TEXT)
         WRITE(TEXT,'(F8.0)')DENS
         RETLOG=DLGSET(DLG,IDC_DENS,TEXT)
         WRITE(TEXT,'(F8.4)')VISC
         RETLOG=DLGSET(DLG,IDC_VISC,TEXT)
         WRITE(TEXT,'(F8.0)')CP
         RETLOG=DLGSET(DLG,IDC_CP,TEXT)
         WRITE(TEXT,'(F8.1)')RLAM
         RETLOG=DLGSET(DLG,IDC_LAM,TEXT)
         WRITE(TEXT,'(F8.5)')DE
         RETLOG=DLGSET(DLG,IDC_DE,TEXT)
         WRITE(TEXT,'(F8.5)')H
         RETLOG=DLGSET(DLG,IDC_EH,TEXT)
         WRITE(TEXT,'(F8.5)')AREA
         RETLOG=DLGSET(DLG,IDC_AREA,TEXT)
         WRITE(TEXT,'(F9.4)')PERIM
         RETLOG=DLGSET(DLG,IDC_PERIM,TEXT)
         WRITE(TEXT,'(I3)')ISOURC
         RETLOG=DLGSET(DLG,IDC_SOURC,TEXT)
         WRITE(TEXT,'(I6)')MULTI
         RETLOG=DLGSET(DLG,IDC_MULTI,TEXT)
         WRITE(TEXT,'(F9.2)')TAU
         RETLOG=DLGSET(DLG,IDC_TAU,TEXT)
         WRITE(TEXT,'(F9.2)')EPOROSITY
         RETLOG=DLGSET(DLG,IDC_POROSITY,TEXT)
         WRITE(TEXT,'(F9.6)')EDBALLS
         RETLOG=DLGSET(DLG,IDC_DBALLS,TEXT)
         WRITE(TEXT,'(F8.5)')FOUL
         RETLOG=DLGSET(DLG,IDC_FOUL,TEXT)
         WRITE(TEXT,'(F8.5)')BL
         RETLOG=DLGSET(DLG,IDC_BL,TEXT)
         WRITE(TEXT,'(E10.3)')EYOUNG
         RETLOG=DLGSET(DLG,IDC_EYOUNG,TEXT)
         WRITE(TEXT,'(F6.2)')EMJU
         RETLOG=DLGSET(DLG,IDC_EMJU,TEXT)
         WRITE(TEXT,'(E10.3)')ALEX
         RETLOG=DLGSET(DLG,IDC_ALEX,TEXT)
         WRITE(TEXT,'(E10.3)')PERM
         RETLOG=DLGSET(DLG,IDC_EPERM,TEXT)
         WRITE(TEXT,'(F8.5)')ROUGH
         RETLOG=DLGSET(DLG,IDC_ROUGH,TEXT)
         WRITE(TEXT,'(F6.1)')TE
         RETLOG=DLGSET(DLG,IDC_ETE,TEXT)
         WRITE(TEXT,'(F6.1)')TWALL
         RETLOG=DLGSET(DLG,IDC_TWALL,TEXT)
         WRITE(TEXT,'(F6.1)')TMEAN
         RETLOG=DLGSET(DLG,IDC_TMEAN,TEXT)
         WRITE(TEXT,'(E10.3)')DUDY
         RETLOG=DLGSET(DLG,IDC_DUDY,TEXT)
         WRITE(TEXT,'(E10.3)')PRESS
         RETLOG=DLGSET(DLG,IDC_PRESS,TEXT)
         WRITE(TEXT,'(F7.3)')VEL
         RETLOG=DLGSET(DLG,IDC_VEL,TEXT)
         WRITE(TEXT,'(E10.3)')QFLOW
         RETLOG=DLGSET(DLG,IDC_EQ,TEXT)
         WRITE(TEXT,'(E10.3)')RE
         RETLOG=DLGSET(DLG,IDC_ERE,TEXT)
         WRITE(TEXT,'(E10.3)')EMA
         RETLOG=DLGSET(DLG,IDC_EMA,TEXT)
         WRITE(TEXT,'(E10.3)')EMB
         RETLOG=DLGSET(DLG,IDC_EMB,TEXT)
         WRITE(TEXT,'(E10.3)')ENA
         RETLOG=DLGSET(DLG,IDC_ENA,TEXT)
         WRITE(TEXT,'(E10.3)')ENB
         RETLOG=DLGSET(DLG,IDC_ENB,TEXT)
         WRITE(TEXT,'(E10.3)')ESIGMA
         RETLOG=DLGSET(DLG,IDC_ESIGMA,TEXT)
         WRITE(TEXT,'(E10.3)')EMISE
         RETLOG=DLGSET(DLG,IDC_EMISE,TEXT)
         EENA=ENA
         EEMA=EMA
         EENB=ENB
         EEPRESS=PRESS
         EED=DE
         EEH=H
C Nastaveni procedur
         RETLOG=DLGSETSUB(DLG,IDC_BALPHA,PIPALFA)
         RETLOG=DLGSETSUB(DLG,IDC_BZETA,PIPALFA)
         RETLOG=DLGSETSUB(DLG,IDC_BSTRESS,PIPALFA)
      RETINT=DLGMODAL(DLG)
         IF(RETINT.EQ.IDOK)THEN
           IEND=0
           RETLOG=DLGGET(DLG,IDC_RCONST,TEXT)
           CALL TAKISD(TEXT,LENLIN,0,IRR,K)
           IF(IRR.GT.0.AND.IRR.LE.MAXMRCONS)IR=IRR
           RETLOG=DLGGET(DLG,IDC_ALPHA,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,ALFA,K)
           RETLOG=DLGGET(DLG,IDC_AREA,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,AREA,K)
           RETLOG=DLGGET(DLG,IDC_DENS,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,DENS,K)
           RETLOG=DLGGET(DLG,IDC_VISC,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,VISC,K)
           RETLOG=DLGGET(DLG,IDC_CP,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,CP,K)
           RETLOG=DLGGET(DLG,IDC_LAM,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,RLAM,K)
           RETLOG=DLGGET(DLG,IDC_DE,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,DE,K)
           RETLOG=DLGGET(DLG,IDC_EH,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,H,K)
           RETLOG=DLGGET(DLG,IDC_ROUGH,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,ROUGH,K)
           RETLOG=DLGGET(DLG,IDC_PERIM,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,PERIM,K)
           RETLOG=DLGGET(DLG,IDC_SOURC,TEXT)
           CALL TAKISD(TEXT,LENLIN,0,ISOURC,K)
           RETLOG=DLGGET(DLG,IDC_MULTI,TEXT)
           CALL TAKISD(TEXT,LENLIN,0,MULTI,K)
           RETLOG=DLGGET(DLG,IDC_DUDY,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,DUDY,K)
           RETLOG=DLGGET(DLG,IDC_ETE,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,TE,K)
           RETLOG=DLGGET(DLG,IDC_EPERM,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,PERM,K)
           RETLOG=DLGGET(DLG,IDC_POROSITY,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,EPOROSITY,K)
           RETLOG=DLGGET(DLG,IDC_DBALLS,TEXT)
           CALL TAKERD(TEXT,LENLIN,0,EDBALLS,K)
         ELSE
           IEND=-1
         ENDIF
         CALL DLGUNINIT(DLG)
      ENDIF
      END

      SUBROUTINE DEGROUP(DUMMY)
C Egroup - pro 8 skupin (jen vybrane polozky)
      USE DIALOGM
      INCLUDE 'OPTION.FD'
      INCLUDE '$FEM'
      INTEGER RETINT,IDCETYPE(8),IDCETRAN(8),IDCEGAUSS(8),IDCECSYS(8),
     /        IDCESTRAIN(8),IDCEFLOW(8),IDCEMETHOD(8),IDCESOURCE(8),
     /        IDCESINK(8),IDCCNSOURCE(8),IDCCNSINK(8),IDCMUL(8),IDCEN(8)
      LOGICAL RETLOG,DUMMY,LOCDUMMY
      TYPE(DIALOG)DLG
	EXTERNAL WEGROUP,WEGNAME
      CHARACTER*(LENLIN) TEXT
      DATA IDCETYPE,IDCETRAN,IDCEGAUSS,IDCECSYS,IDCESTRAIN,IDCEFLOW,
     /IDCEMETHOD,IDCESOURCE,IDCESINK,IDCCNSOURCE,IDCCNSINK,IDCMUL,IDCEN/
     /IDC_ETYPE1,IDC_ETYPE2,IDC_ETYPE3,IDC_ETYPE4,IDC_ETYPE5,IDC_ETYPE6,
     /IDC_ETYPE7,IDC_ETYPE8,
     /IDC_ETRAN1,IDC_ETRAN2,IDC_ETRAN3,IDC_ETRAN4,IDC_ETRAN5,IDC_ETRAN6,
     /IDC_ETRAN7,IDC_ETRAN8,
     /IDC_EGAUSS1,IDC_EGAUSS2,IDC_EGAUSS3,IDC_EGAUSS4,IDC_EGAUSS5,
     /IDC_EGAUSS6,IDC_EGAUSS7,IDC_EGAUSS8,
     /IDC_ECSYS1,IDC_ECSYS2,IDC_ECSYS3,IDC_ECSYS4,IDC_ECSYS5,IDC_ECSYS6,
     /IDC_ECSYS7,IDC_ECSYS8,
     /IDC_ESTRAIN1,IDC_ESTRAIN2,IDC_ESTRAIN3,IDC_ESTRAIN4,IDC_ESTRAIN5,
     /IDC_ESTRAIN6,IDC_ESTRAIN7,IDC_ESTRAIN8,
     /IDC_EFLOW1,IDC_EFLOW2,IDC_EFLOW3,IDC_EFLOW4,IDC_EFLOW5,IDC_EFLOW6,
     /IDC_EFLOW7,IDC_EFLOW8,
     /IDC_EMETHOD1,IDC_EMETHOD2,IDC_EMETHOD3,IDC_EMETHOD4,IDC_EMETHOD5,
     /IDC_EMETHOD6,IDC_EMETHOD7,IDC_EMETHOD8,
     /IDC_ESOURCE1,IDC_ESOURCE2,IDC_ESOURCE3,IDC_ESOURCE4,IDC_ESOURCE5,
     /IDC_ESOURCE6,IDC_ESOURCE7,IDC_ESOURCE8,
     /IDC_ESINK1,IDC_ESINK2,IDC_ESINK3,IDC_ESINK4,IDC_ESINK5,
     /IDC_ESINK6,IDC_ESINK7,IDC_ESINK8,
     /IDC_ECNSOURCE1,IDC_ECNSOURCE2,IDC_ECNSOURCE3,IDC_ECNSOURCE4,
     /IDC_ECNSOURCE5,IDC_ECNSOURCE6,IDC_ECNSOURCE7,IDC_ECNSOURCE8,
     /IDC_ECNSINK1,IDC_ECNSINK2,IDC_ECNSINK3,IDC_ECNSINK4,
     /IDC_ECNSINK5,IDC_ECNSINK6,IDC_ECNSINK7,IDC_ECNSINK8,
     /IDC_EMULP1,IDC_EMULP2,IDC_EMULP3,IDC_EMULP4,
     /IDC_EMULP5,IDC_EMULP6,IDC_EMULP7,IDC_EMULP8,
     /IDC_ENAME1,IDC_ENAME2,IDC_ENAME3,IDC_ENAME4,
     /IDC_ENAME5,IDC_ENAME6,IDC_ENAME7,IDC_ENAME8/
      LOCDUMMY=DUMMY
      IF(.NOT.DLGINIT(IDD_EGROUP,DLG))THEN
           WRITE(*,*)' ERROR DIALOG NOT FOUND'
      ELSE
          WRITE(TEXT,1)MGROUP
1         FORMAT(I3)
            RETLOG=DLGSET(DLG,IDC_EMGROUP,TEXT)
        DO J=1,MIN0(8,MGROUP)
          JNAME=JGROUP(J,1)
          IF(JNAME.GT.0.AND.JNAME.LE.9)THEN
	        WRITE(TEXT,'(I1,6X,A8)')JNAME,TELEM(JNAME)
		ELSEIF(JNAME.GT.0.AND.JNAME.LE.MAXELEM)THEN
	        WRITE(TEXT,'(I2,5X,A8)')JNAME,TELEM(JNAME)
          ELSE
              WRITE(TEXT,'(I2,''   undef'')')JGROUP(J,6)
	    ENDIF
          RETLOG=DLGSET(DLG,IDCETYPE(J),TEXT)
          WRITE(TEXT,*)JGROUP(J,2)
          RETLOG=DLGSET(DLG,IDCETRAN(J),TEXT)
          WRITE(TEXT,*)JGROUP(J,3)
          RETLOG=DLGSET(DLG,IDCEGAUSS(J),TEXT)
          WRITE(TEXT,*)JGROUP(J,4)
          RETLOG=DLGSET(DLG,IDCECSYS(J),TEXT)
          WRITE(TEXT,*)JGROUP(J,5)
          RETLOG=DLGSET(DLG,IDCESTRAIN(J),TEXT)
          JG=JGROUP(J,6)
	    IF(JG.GT.0.AND.JG.LE.9)THEN
	        WRITE(TEXT,'(I1,6X,A4)')JG,TMETHOD(JG)
          ELSEIF(JG.GT.0.AND.JG.LE.MAXMET)THEN
	        WRITE(TEXT,'(I2,5X,A4)')JG,TMETHOD(JG)
          ELSE
              WRITE(TEXT,'(I2,''    undef'')')JGROUP(J,6)
	    ENDIF
          RETLOG=DLGSET(DLG,IDCEMETHOD(J),TEXT)
          WRITE(TEXT,*)JGROUP(J,7)
          RETLOG=DLGSET(DLG,IDCEFLOW(J),TEXT)
          WRITE(TEXT,*)JGROUP(J,8)
          RETLOG=DLGSET(DLG,IDCESOURCE(J),TEXT)
          WRITE(TEXT,*)JGROUP(J,9)
          RETLOG=DLGSET(DLG,IDCESINK(J),TEXT)
          WRITE(TEXT,*)JGROUP(J,10)
          RETLOG=DLGSET(DLG,IDCCNSOURCE(J),TEXT)
          WRITE(TEXT,*)JGROUP(J,11)
          RETLOG=DLGSET(DLG,IDCCNSINK(J),TEXT)
          WRITE(TEXT,*)JGROUP(J,16)
          RETLOG=DLGSET(DLG,IDCMUL(J),TEXT)
          RETLOG=DLGSETSUB(DLG,IDCEMETHOD(J),WEGROUP,DLG_CHANGE)
          RETLOG=DLGSETSUB(DLG,IDCETYPE(J),WEGNAME,DLG_CHANGE)
        ENDDO
        RETINT=DLGMODAL(DLG)
        IF(RETINT.EQ.IDOK)THEN
            RETLOG=DLGGET(DLG,IDC_EMGROUP,TEXT)
            CALL TAKISD(TEXT,LENLIN,0,MGROUP,K)
        DO J=1,MIN0(8,MGROUP)
            RETLOG=DLGGET(DLG,IDCETYPE(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JGROUP(J,1),K)
            RETLOG=DLGGET(DLG,IDCETRAN(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JGROUP(J,2),K)
            RETLOG=DLGGET(DLG,IDCEGAUSS(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JGROUP(J,3),K)
            RETLOG=DLGGET(DLG,IDCECSYS(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JGROUP(J,4),K)
            RETLOG=DLGGET(DLG,IDCESTRAIN(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JGROUP(J,5),K)
            RETLOG=DLGGET(DLG,IDCEMETHOD(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JGROUP(J,6),K)
            RETLOG=DLGGET(DLG,IDCEFLOW(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JGROUP(J,7),K)
            RETLOG=DLGGET(DLG,IDCESOURCE(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JGROUP(J,8),K)
            RETLOG=DLGGET(DLG,IDCESINK(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JGROUP(J,9),K)
            RETLOG=DLGGET(DLG,IDCCNSOURCE(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JGROUP(J,10),K)
            RETLOG=DLGGET(DLG,IDCCNSINK(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JGROUP(J,11),K)
            RETLOG=DLGGET(DLG,IDCMUL(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JGROUP(J,16),K)
        ENDDO
        ENDIF
        CALL DLGUNINIT(DLG)
      ENDIF
      END

      SUBROUTINE WEGROUP(DLG,CONTROL,CALLBACKTYPE)
C 
C dynamicka modifikace polozky METHOD (CONTROL)
C
      USE DIALOGM
      INCLUDE 'OPTION.FD'
      INCLUDE '$FEM'
      TYPE(DIALOG)DLG
      INTEGER CONTROL,CALLBACKTYPE,LOCALLBACK
      CHARACTER*60 TEXT
      LOGICAL RETLOG
      LOCALLBACK=CALLBACKTYPE
      RETLOG=DLGGET(DLG,CONTROL,TEXT)
      CALL TAKISD(TEXT,15,0,MMM,K)
      IF(MMM.GT.0.AND.MMM.LE.9)THEN
        WRITE(TEXT,'(I1,6X,A4)')MMM,TMETHOD(MMM)
        RETLOG=DLGSET(DLG,CONTROL,TEXT)
      ELSEIF(MMM.GT.0.AND.MMM.LE.MAXMET)THEN
        WRITE(TEXT,'(I2,5X,A4)')MMM,TMETHOD(MMM)
        RETLOG=DLGSET(DLG,CONTROL,TEXT)
	ELSE
	  RETLOG=DLGSET(DLG,CONTROL,TEXT(1:6)//' undef')
	ENDIF
	END

      SUBROUTINE WEGNAME(DLG,CONTROL,CALLBACKTYPE)
C 
C dynamicka modifikace polozky ENAME (CONTROL)
C
      USE DIALOGM
      INCLUDE 'OPTION.FD'
      INCLUDE '$FEM'
      TYPE(DIALOG)DLG
      INTEGER CONTROL,CALLBACKTYPE,LOCALLBACK
      CHARACTER*60 TEXT
      LOGICAL RETLOG
      LOCALLBACK=CALLBACKTYPE
      RETLOG=DLGGET(DLG,CONTROL,TEXT)
      CALL TAKISD(TEXT,15,0,MMM,K)
      IF(MMM.GT.0.AND.MMM.LE.9)THEN
        WRITE(TEXT,'(I1,6X,A8)')MMM,TELEM(MMM)
        RETLOG=DLGSET(DLG,CONTROL,TEXT)
	ELSEIF(MMM.GT.0.AND.MMM.LE.MAXELEM)THEN
        WRITE(TEXT,'(I2,5X,A8)')MMM,TELEM(MMM)
        RETLOG=DLGSET(DLG,CONTROL,TEXT)
	ELSE
	  RETLOG=DLGSET(DLG,CONTROL,TEXT(1:6)//' undef')
	ENDIF
	END

      SUBROUTINE DMPROP(DUMMY)
      USE DIALOGM
      INCLUDE 'OPTION.FD'
      INCLUDE '$FEM'
      INTEGER RETINT,IDCK(4),IDCKF(4),IDCC(4),IDCCF(4),
     /   IDCRHO(4),IDCRHOF(4),IDCKAPPA(4),IDCKAPPAF(4),
     /   IDCVISC(4),IDCVISCF(4),IDCM(4),IDCMF(4),IDCE(4),IDCEF(4),
     /   IDCBETA(4),IDCBETAF(4),IDCDN(4),IDCDNF(4),IDCAN(4),IDCANF(4),
     /   IDCTM(4),IDCTMF(4),IDCHM(4),IDCHMF(4),
     /   IDCHN(4),IDCHNF(4)
      LOGICAL RETLOG,DUMMY,LOCDUMMY
      TYPE(DIALOG)DLG
      CHARACTER*(LENLIN) TEXT
      DATA IDCK,IDCKF,IDCC,IDCCF,IDCRHO,IDCRHOF,IDCKAPPA,IDCKAPPAF,
     /     IDCVISC,IDCVISCF,IDCM,IDCMF,IDCE,IDCEF,
     /     IDCBETA,IDCBETAF,IDCDN,IDCDNF,IDCAN,IDCANF,
     /     IDCTM,IDCTMF,IDCHM,IDCHMF,IDCHN,IDCHNF/
     / IDC_K1,IDC_K2,IDC_K3,IDC_K4,IDC_KF1,IDC_KF2,IDC_KF3,IDC_KF4,
     / IDC_C1,IDC_C2,IDC_C3,IDC_C4,IDC_CF1,IDC_CF2,IDC_CF3,IDC_CF4,
     / IDC_RHO1,IDC_RHO2,IDC_RHO3,IDC_RHO4,IDC_RHOF1,IDC_RHOF2,
     / IDC_RHOF3,IDC_RHOF4,
     / IDC_KAPPA1,IDC_KAPPA2,IDC_KAPPA3,IDC_KAPPA4,IDC_KAPPAF1,
     / IDC_KAPPAF2,IDC_KAPPAF3,IDC_KAPPAF4,
     / IDC_VISC1,IDC_VISC2,IDC_VISC3,IDC_VISC4,IDC_VISCF1,IDC_VISCF2,
     / IDC_VISCF3,IDC_VISCF4,
     / IDC_M1,IDC_M2,IDC_M3,IDC_M4,IDC_MF1,IDC_MF2,IDC_MF3,IDC_MF4,
     / IDC_E1,IDC_E2,IDC_E3,IDC_E4,IDC_EF1,IDC_EF2,IDC_EF3,IDC_EF4,
     / IDC_BETA1,IDC_BETA2,IDC_BETA3,IDC_BETA4,IDC_BETAF1,IDC_BETAF2,
     / IDC_BETAF3,IDC_BETAF4,
     / IDC_DN1,IDC_DN2,IDC_DN3,IDC_DN4,IDC_DNF1,IDC_DNF2,
     / IDC_DNF3,IDC_DNF4,
     / IDC_AN1,IDC_AN2,IDC_AN3,IDC_AN4,IDC_ANF1,IDC_ANF2,
     / IDC_ANF3,IDC_ANF4,
     / IDC_TM1,IDC_TM2,IDC_TM3,IDC_TM4,IDC_TMF1,IDC_TMF2,
     / IDC_TMF3,IDC_TMF4,
     / IDC_HM1,IDC_HM2,IDC_HM3,IDC_HM4,IDC_HMF1,IDC_HMF2,
     / IDC_HMF3,IDC_HMF4,
     / IDC_HN1,IDC_HN2,IDC_HN3,IDC_HN4,IDC_HNF1,IDC_HNF2,
     / IDC_HNF3,IDC_HNF4/

      LOCDUMMY=DUMMY
      IF(.NOT.DLGINIT(IDD_MPROP,DLG))THEN
           WRITE(*,*)' ERROR DIALOG NOT FOUND'
      ELSE
          WRITE(TEXT,2)MMPROP
          RETLOG=DLGSET(DLG,IDC_EMMPROP,TEXT)
1         FORMAT(E10.3)
2         FORMAT(I3)
        DO J=1,MIN0(4,MMPROP)
          WRITE(TEXT,1)RMPROP(J,1)
          RETLOG=DLGSET(DLG,IDCK(J),TEXT)
          WRITE(TEXT,2)JMPROP(J,1)
          RETLOG=DLGSET(DLG,IDCKF(J),TEXT)
          WRITE(TEXT,1)RMPROP(J,2)
          RETLOG=DLGSET(DLG,IDCC(J),TEXT)
          WRITE(TEXT,2)JMPROP(J,2)
          RETLOG=DLGSET(DLG,IDCCF(J),TEXT)
          WRITE(TEXT,1)RMPROP(J,3)
          RETLOG=DLGSET(DLG,IDCRHO(J),TEXT)
          WRITE(TEXT,2)JMPROP(J,3)
          RETLOG=DLGSET(DLG,IDCRHOF(J),TEXT)
          WRITE(TEXT,1)RMPROP(J,4)
          RETLOG=DLGSET(DLG,IDCKAPPA(J),TEXT)
          WRITE(TEXT,2)JMPROP(J,4)
          RETLOG=DLGSET(DLG,IDCKAPPAF(J),TEXT)
          WRITE(TEXT,1)RMPROP(J,5)
          RETLOG=DLGSET(DLG,IDCE(J),TEXT)
          WRITE(TEXT,2)JMPROP(J,5)
          RETLOG=DLGSET(DLG,IDCEF(J),TEXT)
          WRITE(TEXT,1)RMPROP(J,6)
          RETLOG=DLGSET(DLG,IDCM(J),TEXT)
          WRITE(TEXT,2)JMPROP(J,6)
          RETLOG=DLGSET(DLG,IDCMF(J),TEXT)
          WRITE(TEXT,1)RMPROP(J,7)
          RETLOG=DLGSET(DLG,IDCVISC(J),TEXT)
          WRITE(TEXT,2)JMPROP(J,7)
          RETLOG=DLGSET(DLG,IDCVISCF(J),TEXT)
          WRITE(TEXT,1)RMPROP(J,8)
          RETLOG=DLGSET(DLG,IDCBETA(J),TEXT)
          WRITE(TEXT,2)JMPROP(J,8)
          RETLOG=DLGSET(DLG,IDCBETAF(J),TEXT)
          WRITE(TEXT,1)RMPROP(J,9)
          RETLOG=DLGSET(DLG,IDCDN(J),TEXT)
          WRITE(TEXT,2)JMPROP(J,9)
          RETLOG=DLGSET(DLG,IDCDNF(J),TEXT)
          WRITE(TEXT,1)RMPROP(J,10)
          RETLOG=DLGSET(DLG,IDCHN(J),TEXT)
          WRITE(TEXT,2)JMPROP(J,10)
          RETLOG=DLGSET(DLG,IDCHNF(J),TEXT)
          WRITE(TEXT,1)RMPROP(J,11)
          RETLOG=DLGSET(DLG,IDCAN(J),TEXT)
          WRITE(TEXT,2)JMPROP(J,11)
          RETLOG=DLGSET(DLG,IDCANF(J),TEXT)
          WRITE(TEXT,1)RMPROP(J,19)
          RETLOG=DLGSET(DLG,IDCTM(J),TEXT)
          WRITE(TEXT,2)JMPROP(J,19)
          RETLOG=DLGSET(DLG,IDCTMF(J),TEXT)
          WRITE(TEXT,1)RMPROP(J,20)
          RETLOG=DLGSET(DLG,IDCHM(J),TEXT)
          WRITE(TEXT,2)JMPROP(J,20)
          RETLOG=DLGSET(DLG,IDCHMF(J),TEXT)
        ENDDO
        RETINT=DLGMODAL(DLG)
        IF(RETINT.EQ.IDOK)THEN
            RETLOG=DLGGET(DLG,IDC_EMMPROP,TEXT)
            CALL TAKISD(TEXT,LENLIN,0,MMPROP,K)
        DO J=1,MIN0(4,MMPROP)
            RETLOG=DLGGET(DLG,IDCK(J),TEXT)
            CALL TAKERD(TEXT,LENLIN,0,RMPROP(J,1),K)
            RETLOG=DLGGET(DLG,IDCKF(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JMPROP(J,1),K)
            RETLOG=DLGGET(DLG,IDCC(J),TEXT)
            CALL TAKERD(TEXT,LENLIN,0,RMPROP(J,2),K)
            RETLOG=DLGGET(DLG,IDCCF(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JMPROP(J,2),K)
            RETLOG=DLGGET(DLG,IDCRHO(J),TEXT)
            CALL TAKERD(TEXT,LENLIN,0,RMPROP(J,3),K)
            RETLOG=DLGGET(DLG,IDCRHOF(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JMPROP(J,3),K)
            RETLOG=DLGGET(DLG,IDCKAPPA(J),TEXT)
            CALL TAKERD(TEXT,LENLIN,0,RMPROP(J,4),K)
            RETLOG=DLGGET(DLG,IDCKAPPAF(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JMPROP(J,4),K)
            RETLOG=DLGGET(DLG,IDCE(J),TEXT)
            CALL TAKERD(TEXT,LENLIN,0,RMPROP(J,5),K)
            RETLOG=DLGGET(DLG,IDCEF(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JMPROP(J,5),K)
            RETLOG=DLGGET(DLG,IDCM(J),TEXT)
            CALL TAKERD(TEXT,LENLIN,0,RMPROP(J,6),K)
            RETLOG=DLGGET(DLG,IDCMF(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JMPROP(J,6),K)
            RETLOG=DLGGET(DLG,IDCVISC(J),TEXT)
            CALL TAKERD(TEXT,LENLIN,0,RMPROP(J,7),K)
            RETLOG=DLGGET(DLG,IDCVISCF(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JMPROP(J,7),K)
            RETLOG=DLGGET(DLG,IDCBETA(J),TEXT)
            CALL TAKERD(TEXT,LENLIN,0,RMPROP(J,8),K)
            RETLOG=DLGGET(DLG,IDCBETAF(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JMPROP(J,8),K)
            RETLOG=DLGGET(DLG,IDCDN(J),TEXT)
            CALL TAKERD(TEXT,LENLIN,0,RMPROP(J,9),K)
            RETLOG=DLGGET(DLG,IDCDNF(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JMPROP(J,9),K)
            RETLOG=DLGGET(DLG,IDCHN(J),TEXT)
            CALL TAKERD(TEXT,LENLIN,0,RMPROP(J,10),K)
            RETLOG=DLGGET(DLG,IDCHNF(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JMPROP(J,10),K)
            RETLOG=DLGGET(DLG,IDCAN(J),TEXT)
            CALL TAKERD(TEXT,LENLIN,0,RMPROP(J,11),K)
            RETLOG=DLGGET(DLG,IDCANF(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JMPROP(J,11),K)
            RETLOG=DLGGET(DLG,IDCTM(J),TEXT)
            CALL TAKERD(TEXT,LENLIN,0,RMPROP(J,19),K)
            RETLOG=DLGGET(DLG,IDCTMF(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JMPROP(J,19),K)
            RETLOG=DLGGET(DLG,IDCHM(J),TEXT)
            CALL TAKERD(TEXT,LENLIN,0,RMPROP(J,20),K)
            RETLOG=DLGGET(DLG,IDCHMF(J),TEXT)
            CALL TAKISD(TEXT,LENLIN,0,JMPROP(J,20),K)
        ENDDO
        ENDIF
        CALL DLGUNINIT(DLG)
      ENDIF
      END

