      SUBROUTINE COMHELP(TXKEYW,TXCOM,IEND)
C
C TXKEYW - nazev prikazu, napr. ,EGROUP,EG,
C TXCOM  - nalezeny komentar k prikazu
C IEND   =0 komentar neni,
C        >0 delka komentare
C
      PARAMETER (NKW=167)
      CHARACTER*(*) TXKEYW,TXCOM
      CHARACTER*6 KW(NKW),KWTRIM
      CHARACTER*35 TKW(NKW)
      DATA (KW(I),TKW(I),I=1,NKW) /
     /   'ANALYS','set generated DOF structure',
     /   'ACTSET','activate groups EG,RC,MP',
     /   'SFEXTR','volume by surface extrusion',
     /   'VARLIS','list system variables',
     /   'MODLIS','active model listing',
     /   'EGROUP','element group properties',
     /   'RCONST','real constants of elements',
     /   'RCPUMP','pump from a database',
     /   'RCSTUB','RC for shell and tube HE',
     /   'RCEHEV','RC change of existing CHEVRON',
     /   'RCEPUM','RC change of existing PUMP',
     /   'RCROSS','Diam.of rectangular cross-sect',
     /   'FUNDEF','dependent properties or B.C.',
     /   'CURDEF','define a table (properties)',
     /   'INITIA','initial conditions for FEM',
     /   'INIFEM','zeroing FEM database',
     /   'OPTION','set switches for SOLVE',
     /   'RMODEL','read RTD model definition',
     /   'CRITER','criterion of TC matching',
     /   'COMPAR','calculate differences of TCs',
     /   'WMODIF','modify weights for optimisation',
     /   'LINREG','linear polynomial regression',
     /   'NELREG','nonlinear regression y=f(x,A)',
     /   'PARDEF','definition of model params',
     /   'PARLIM','model parameters bounds',
     /   'PARSET','model parameters setting', 
     /   'PARFIT','parameter optimisation setting',
     /   'IDMSER','series of ideal mixers',
     /   'PASERI','two parallel series of mixers',
     /   'METHOD','solution of dif.eq. by Euler/RK',
     /   'STIMUL','stimulus functions of a model',
     /   'OUTPUT','recorded responses of a model',
     /   'FUNVAL','assign value of function to variab.',
     /   'IMPULS','run solver of model',
     /   'CONVOL','response of model to X(t)',
     /   'MOMENT','moments of a time curve',
     /   'TCZERI','fill initial zeroes to a TC',
     /   'TCLEAR','zeroing selected columns of MOP',
     /   'SMOOTH','local smoothing of a time curve',
     /   'COPYTO','copy a time curve',
     /   'NEWPRO','close old, open new problem',
     /   'ACTNUM','activate numbering of entities',
     /   'INACTN','Inactivate numbering of entities',
     /   'STATUS','set type of status window',
     /   'RECORD','start recording macro',
     /   'ENDREC','close macro recording file',
     /   'GRAFUN','graph of function (properties)',
     /   'BOXING','Cartesian boxing',
     /   'SEARCH','string. Look at source program',
     /   'INTGSF','integrate a function on surface',
     /   'INTGCR','integrate a function on curve',
     /   'INTGEL','integrate DOF over elements',
     /   'ELEMEN','define an element from nodes',
     /   'CRSPOL','polyline with arcs using mouse',
     /   'FLUENT','script file for tracer injection',
     /   'FLUENF','script file for FLUENT flow solut.',
     /   'READTS','results from FLUENT (CN,VX,...)',
     /   'UNIFIL','compose FLUENT-res file into OUT-f',
     /   'DETDEF','define collimated detector',
     /   'DETPLO','redraw collimated detectors',
     /   'DETLIS','list detectors X,Y,Z,aperture,...',
     /   'DETFUN','detector response (in view angle)',
     /   'DETDOF','detector response (all elements)',
     /   'DEFPLO','plot deformed construction',
     /   'LOADTN','read time step from OUT-file',
     /   'LOADTE','read time step from TEP-file',
     /   'TRANSE','information about command interpret',
     /   'TRUSS ','structural analysis of trusses (MC)',
     /   'TIMES ','set time step and number of steps',
     /   'TCINP ','input TC point from keyboard',
     /   'TCINT ','Integrate a time curve',
     /   'TCYSH ','shift a time curve',
     /   'TCXSH ','time shift',
     /   'TCPXY ','graph x,y (any columns for x)',
     /   'TCBGR ','background raise correction',
     /   'TCRND ','randomise a time curve',
     /   'TCLIP ','suppress negative values',
     /   'TCEND ','specify maximum time',
     /   'TCSET ','type of time curve',
     /   'TCDEV ','deviation of TC pairs',
     /   'TCFUN ','ci=f(c1,c2,...,c10)',
     /   'TCREG ','regression a part of TC',
     /   'TCJOIN','join two time curves',
     /   'TCSUB ','subtract two time curves',
     /   'WHILE ','WHILE relation DO [block]',
     /   'MACRO ','run macro file',
     /   '#LOOP ','#LOOP label n-times',
     /   '#GOTO ','#GOTO label',
     /   '#LABEL','addres for LOOP,GOTO',
     /   '#IF   ','#IF relace #ELSEIF #ENDIF',
     /   'GRAPH ','2D contours of a DOF',
     /   'GTIME ','time history of a DOF',
     /   'CLOSE ','close an opened file',
     /   'IDENT ','entity picking by mouse',
     /   'CR2PT ','curve defined by two points',
     /   'PTCR2 ','points as intersection of 2 CR',
     /   'GROUP ','activate a group EG,RC,MP',
     /   'MPROP ','material properties',
     /   'RCHEV ','RC for a plate HE (chevron)',
     /   'RCHEX ','RC for heat exchanger',
     /   'ERMSF ','Change EG,RC,MP on a surface',
     /   'ERMOD ','Change EG,RC,MP inside a box',
     /   'METER ','display DOF values in points',
     /   'MERGE ','nodes merging',
     /   'SOLVE ','run ELEC,FLOW,THER,CONC,STRESS',
     /   'WRITE ','write data into a file',
     /   'PALIS ','list model parameters',
     /   'OPTIM ','optimisation of a model',
     /   'INLET ','velocities and PS at inlet',
     /   'ERMEL ','change Eg,Rc,Mp of element',
     /   'ERMSF ','change Eg,Rc,Mp on a surface',
     /   'ERMOD ','change Eg,Rc,Mp in a region',
     /   'WALL  ','velocities and PS at wall',
     /   'READ  ','read data from a file',
     /   'PLOT  ','plot a selected entity',
     /   'IMOD  ','run RTD model initialization',
     /   'MOFE  ','move DOF into element parameters',
     /   'SFCR  ','surface created from 2 curves',
     /   'UNDO  ','repeat shortened Session file',
     /   'SAVE  ','save Session file',
     /   'VIEW  ','rotate view point',
     /   'VLSF  ','volume from 2 opposite surfaces',
     /   'MCR2  ','mesh curves by PIPE+Heat Exhanger',
     /   'MCR4  ','mesh Heat Exchangers on 2 curves',
     /   'NFCR  ','DOF or force on a curve',
     /   'NFSF  ','DOF or force on a surface',
     /   'LIST  ','list selected entity',
     /   'SOMA  ','memetic optimisation',
     /   'NLR2  ','nonlinear regression y=f(x1,x2,A)',
     /   'NORM  ','normalize a time curve',
     /   'TCDT  ','transform to a const.step DT',
     /   'TCOS  ','new origin of a time curve',
     /   'NODE  ','define a new node',
     /   'FILE  ','run session file',
     /   'OPEN  ','open file for a model',
     /   'EXIT  ','quit FEMINA',
     /   'HELP  ','string. Look for SECTION in source',
     /   'GFCR  ','Graph of Function along a curve',
     /   'GFSF  ','Contours of function on a surface',
     /   'GVEL  ','Velocities Vx,Vy by arrows',
     /   'TAIL  ','tail extrapolation',
     /   'DISP  ','display values (error in argument?)',
     /   'PGUP  ','Page Up in window LIST',
     /   'PGDN  ','Page Down in window LIST',
     /   'FFT   ','Fourier filter,convol.,corel.',
     /   'NDF   ','force or DOF in a node',
     /   'PTF   ','force or DOF in a point',
     /   'RUN   ','execute an external program',
     /   'ROM   ','read observation points data',
     /   'MSF   ','mesh surface',
     /   'MCR   ','mesh curve',
     /   'MVL   ','mesh volume',
     /   'ARC   ','define curve as a circular arc',
     /   'TCE   ','edit time a curve using mouse',
     /   'LOC   ','information about system variables',
     /   'GTC   ','graph of multiple time curves',
     /   'GTD   ','logarithmic graphs of time curves',
     /   'GTE   ','time history of element parameter',
     /   'GD1   ','1D graph of a DOF using colours',
     /   'GE2   ','2D contours of element parameter',
     /   'GE1   ','1D plot of element parameter',
     /   'GCR   ','Graph of a DOF along selected CR',
     /   'DEL   ','Delete specified entity',
     /   'LTE   ','Load element parameters for time t',
     /   'EPS   ','Prescribed accuracy PRES,TEMP,...',
     /   'FOR   ','FOR i=i1,i2 DO [block]',
     /   'IF    ','IF relation THEN [block]'/

C zjistujeme, zda se nektere klicove slovo neobjevuje v textu

      IEND=0
      DO I=1,NKW
        KWTRIM=KW(I)
        LL=LEN(TRIM(KWTRIM))
        IF(INDEX(TXKEYW,KWTRIM(1:LL)).GT.0)THEN
            TXCOM=TKW(I)
            IEND=LEN(TKW(I))
            EXIT
        ENDIF
      ENDDO
      END


      SUBROUTINE VARHELP(I,TXTV,LOC)
C
C Informace o interpretovanych promennych.
C I    - index atributu (poradi preddefinovanych promennych v BLOCK DATA)
C TXTV - vystupni retezec (informace o promenne)
C LOC  - POZICE PROMENNE V /FEM (1 az MAXEND)
C
      INCLUDE '$FEM-PAB'
      INCLUDE '$FEM-PAR'
      INCLUDE '$FEM-LOC'
      CHARACTER *(*) TXTV
	INCLUDE '$TRANDAT'
      LOC=0
      IF(I.LE.0.OR.I.GT.NVARTOT)RETURN
      SELECT CASE(IATTR(2,I))
         CASE(1)
            TXTV=NAME(I)//' real    '
         CASE(2)
            TXTV=NAME(I)//' int     '
         CASE(3)
            TXTV=NAME(I)//'(i) real '
         CASE(4)
            TXTV=NAME(I)//'(i) int  '
         CASE(5)
            TXTV=NAME(I)//' funct.  '
      END SELECT
      IF(IATTR(2,I).LE.4)LOC=IATTR(1,I)
      END

      SUBROUTINE FEMHELP(LOC,TXTH,IENDH)
C
C Informace o promennych v zone COMMON /FEM/
C LOC  - pozice promenne v COMMON/FEM (1 az MAXEND)
C TXTH - vystupni retezec (informace o promenne pokud je na pozici LOC definovana)
C IENDH- =0 nebyla nalezena polozka HELP
C
      INCLUDE '$FEM-PAB'
      INCLUDE '$FEM-PAR'
      INCLUDE '$FEM-LOC'
      CHARACTER *(*) TXTH
      IENDH=1
      SELECT CASE(LOC)
                CASE(1)
      TXTH='current time (transient analysis)'
                CASE(2)
      TXTH='current coordinate (set before funct.evaluation)'
                CASE(5)
      TXTH='second invariant of rate od deformation'
                CASE(11)
      TXTH='DOF identification as temperature (value 1)'
                CASE(12)
      TXTH='DOF identification as UX displacement (value 2)'
                CASE(13)
      TXTH='DOF identification as UY displacement (value 3)'
                CASE(14)
      TXTH='DOF identification as UZ displacement (value 4)'
                CASE(15)
      TXTH='DOF identification as RX rotation (value 5)'
                CASE(16)
      TXTH='DOF identification as RY rotation (value 6)'
                CASE(17)
      TXTH='DOF identification as RZ rotation (value 7)'
                CASE(18)
      TXTH='DOF identification as voltage (value 8)'
                CASE(19)
      TXTH='DOF identification as VX velocity (value 9)'
                CASE(20)
      TXTH='DOF identification as VY velocity (value 10)'
                CASE(21)
      TXTH='DOF identification as VZ velocity (value 11)'
                CASE(22)
      TXTH='DOF identification as pressure (value 12)'
                CASE(23)
      TXTH='DOF identification as vorticity omega (value 13)'
                CASE(24)
      TXTH='DOF identification as stream function (value 14)'
                CASE(25)
      TXTH='DOF stream function derivative PSX (value 15)'
                CASE(26)
      TXTH='DOF stream function derivative PSY (value 16)'
                CASE(27)
      TXTH='DOF stream function derivative PSZ (value 17)'
                CASE(28)
      TXTH='DOF vorticity derivative OMGX (value 18)'
                CASE(29)
      TXTH='DOF vorticity derivative OMGY (value 19)'
                CASE(30)
      TXTH='DOF vorticity derivative OMGZ (value 20)'
                CASE(31)
      TXTH='DOF identification as concentration CN (value 21)'
                CASE(32)
      TXTH='DOF identification as concentration CD (value 22)'
                CASE(33)
      TXTH='DOF identification as concentration CA (value 23)'
                CASE(34)
      TXTH='DOF identification as enthalpy HT (value 24)'
                CASE(41)
      TXTH='user variables A,B,...H-real, I,J,...N-integer'
                CASE(42)
      TXTH='user variable B-real (can be used for anything)'
                CASE(43)
      TXTH='user variable C-real (can be used for anything)'
                CASE(44)
      TXTH='user variable D-real (can be used for anything)'
                CASE(45)
      TXTH='user variable E-real (can be used for anything)'
                CASE(46)
      TXTH='user variable F-real (can be used for anything)'
                CASE(47)
      TXTH='user variable G-real (can be used for anything)'
                CASE(48)
      TXTH='user variable H-real (can be used for anything)'
                CASE(49)
      TXTH='user variable I-integer (can be used for anything)'
                CASE(50)
      TXTH='user variable J-integer (can be used for anything)'
                CASE(51)
      TXTH='user variable K-integer (can be used for anything)'
                CASE(52)
      TXTH='user variable L-integer (can be used for anything)'
                CASE(53)
      TXTH='user variable M-integer (can be used for anything)'
                CASE(54)
      TXTH='user variable N-integer (can be used for anything)'
                CASE(55)
      TXTH='user variable O-real (can be used for anything)'
                CASE(56)
      TXTH='user variable P-real (can be used for anything)'
                CASE(57)
      TXTH='user variable Q-real (can be used for anything)'
                CASE(58)
      TXTH='user variable R-real (can be used for anything)'
                CASE(59)
      TXTH='user variable S-real (can be used for anything)'
                CASE(60)
      TXTH='user variable T-real (can be used for anything)'
                CASE(61)
      TXTH='user variable U-real (can be used for anything)'
                CASE(62)
      TXTH='user variable V-real (can be used for anything)'
                CASE(63)
      TXTH='user variable W-real (can be used for anything)'
                CASE(64)
      TXTH='user variable X-real (can be used for anything)'
                CASE(65)
      TXTH='user variable Y-real (can be used for anything)'
                CASE(66)
      TXTH='user variable Z-real (can be used for anything)'
                CASE(71)
      TXTH='Element identification by name (PIPE2D)'
                CASE(72)
      TXTH='Element identification (not used)'
                CASE(73)
      TXTH='Element identification by name (TRUSS2D)'
                CASE(74)
      TXTH='Element identification (not used)'
                CASE(75)
      TXTH='Element identification by name (BEAM2D)'
                CASE(76)
      TXTH='Element identification (not used)'
                CASE(77)
      TXTH='Element identification (CSTR - mixed tank)'
                CASE(78)
      TXTH='Element identification (PUMP)'
                CASE(79)
      TXTH='Element identification (VALVE)'
                CASE(80)
      TXTH='Element identification by name (SHELLAX)'
                CASE(81)
      TXTH='Element identification (HEXC heat exchanger)'
                CASE(82)
      TXTH='Element identification (PLANE2D plate-membrane)'
                CASE(83)
      TXTH='Element identification (FLOW2D -laminar flow)'
                CASE(84)
      TXTH='Element identification (FLOW3D -laminar flow)'
                CASE(85)
      TXTH='Element identification by name (USER defined)'
                CASE(86)
      TXTH='Element identification (not used)'
                CASE(87)
      TXTH='Element identification (SOLID- 3D brick)'
                CASE(88,89)
      TXTH='Element identification (not used)'
                CASE(91)
      TXTH='E-par.identification (Nalpha normal stress)'
                CASE(92)
      TXTH='E-par.identification (Nbeta circumf.stress)'
                CASE(93)
      TXTH='E-par.identification (Malpha meridian moment)'
                CASE(94)
      TXTH='E-par.identification (Mbeta circumf.moment)'
                CASE(95)
      TXTH='E-par.identification (trans.force)'
                CASE(96)
      TXTH='E-par.identification (flowrate)'
                CASE(97)
      TXTH='E-par.identification (Reynolds number)'
                CASE(98)
      TXTH='E-par.identification (wall shear stress)'
                CASE(99)
      TXTH='E-par.identification (fouling layer)'
                CASE(100)
      TXTH='E-par.identification (dissip.power)'
                CASE(101)
      TXTH='E-par.identification (Length-Area-Volume)'
                CASE(102)
      TXTH='E-par.identification (second invariant)'
                CASE(103)
      TXTH='E-par.identification (dT/dx)'
                CASE(104)
      TXTH='E-par.identification (dT/dy)'
                CASE(105)
      TXTH='E-par.identification (dT/dz)'
                CASE(106)
      TXTH='E-par.identification (Sigma xx)'
                CASE(107)
      TXTH='E-par.identification (Sigma yy)'
                CASE(108)
      TXTH='E-par.identification (Sigma xy)'
                CASE(109)
      TXTH='E-par.identification (Sigma Mises)'
                CASE(110)
      TXTH='E-par.identification (EPOWER)'
                CASE(111)
      TXTH='E-par.identification (mean temperature)'
                CASE(114)
      TXTH='E-par.identification (Vx velocity)'
                CASE(115)
      TXTH='E-par.identification (Vy velocity)'
                CASE(116)
      TXTH='E-par.identification (Vz velocity)'
                CASE(117)
      TXTH='E-par.identification (Ealpha)'
                CASE(121)
      TXTH='flow solution identif.(velocity-pressure)'
                CASE(122)
      TXTH='flow solution identif.(pseudo-compressibility)'
                CASE(123)
      TXTH='flow solution identif.(minimum kinetic energy)'
                CASE(124)
      TXTH='flow solution identif.(penalty method)'
                CASE(125)
      TXTH='flow solution identif.(minimum dissip.energy)'
                CASE(126)
      TXTH='flow solution identif.(stream function PSI)'
                CASE(127)
      TXTH='flow solution identif.(stream function cubic)'
                CASE(128)
      TXTH='flow solution identif.(stream function creep)'
                CASE(129)
      TXTH='flow solution identif.(PSI-OMEGA)'
                CASE(130)
      TXTH='flow solution identif.(PSI-OMEGA Campion Rens.)'
                CASE(131)
      TXTH='heat exchanger identification (plate-chevron)'
                CASE(132)
      TXTH='heat exchanger identification (shell and tube)'
                CASE(133)
      TXTH='heat exchanger identification (hair)'
               CASE(LOCAUX1)
      TXTH='number of points created by PT command (geometry)'
                CASE(LOCAUX2)
      TXTH='number of curves created by using CR2PT,CR3PT'
                CASE(LOCAUX3)
      TXTH='number of surfaces created from points or curves'
                CASE(LOCAUX4)
      TXTH='number of volumes (volumes are not supported yet)'
                CASE(LOCAUX5)
      TXTH='number of finite elements (created by MCR,MSF,...)'
                CASE(LOCAUX6)
      TXTH='number of nodes (created by MCR,MSF,... or by ND)'
                CASE(LOCMGROUP)
      TXTH='number of E-groups (defined by EG command)'
                CASE(LOCMRCONS)
      TXTH='number of RC-groups (defined by RC command)'
                CASE(LOCMMPROP)
      TXTH='number of MPROP-groups (defined by MP command)'
                CASE(MAXAUX+11)
      TXTH='1-PIPE,2-UVP,3-PSI'
                CASE(LOCNTSTEP)
      TXTH='number of time steps'
                CASE(LOCDTIME)
      TXTH='time step [s]'
                CASE(LOCIALG1)
      TXTH='switches (MASS-matrix,CONVECTion,BUOYANCY,SOURCe)'
                CASE(LOCIRT)
      TXTH='Fouling model'
                CASE(LOCIELEC)
      TXTH='max.iterations ELEC (2D voltage)'
                CASE(LOCIELEC+1)
      TXTH='max.iterations THER (2D thermal)'
                CASE(LOCIELEC+2)
      TXTH='max.iterations CONC (2D concentration)'
                CASE(LOCIELEC+3)
      TXTH='max.iterations FLOW (Navier Stokes)'
                CASE(LOCIELEC+4)
      TXTH='max.iterations STAT (stress analysis)'
                CASE(LOCICONV)
      TXTH='convective terms respected'
                CASE(LOCIBUOY)
      TXTH='buoyancy (1-density, 2-Boussinesque'
                CASE(LOCIOHMI)
      TXTH='source terms respected'
                CASE(LOCIUPW)
      TXTH='upwind enabled'
                CASE(LOCIHEPI)
      TXTH='=0 MWR, =1 enthalpy balance, >1 characteristics'
                CASE(LOCINTG)
      TXTH='number of integration points along curve'
                CASE(LOCIRTD)
      TXTH='executing RTD model in main program'
                CASE(LOCRALG1)
      TXTH='GX-gravity acceleration (effects natural convec.)'
                CASE(LOCRUPW)
      TXTH='upwind correction (a value between 0 and 1)'
                CASE(LOCPIVT)
      TXTH='minimum of pivot (frontal method); default 1e-6'
                CASE(LOCRTOL)
      TXTH='minimum distance of points or nodes for merging'
                CASE(LOCRSCL)
      TXTH='scale factor for displacement (graphics)'
                CASE(LOCRLAMB)
      TXTH='LAMBDA-penalty factor (should be 10**7 or so)'
                CASE(LOCRELAX)
      TXTH='Underrelaxation factor (iterations loops)'
                CASE(LOCTHETA)
      TXTH='0-explicit,0.5-Crank Nicholson,1-implicit'
                CASE(LOCSUMDEV)
      TXTH='sum od deviations'
                CASE(LOCRINTG)
      TXTH='result of integration'
                CASE(LOCTAUDISP)
      TXTH='characteristic time (axial dispersion)'
                CASE(LOCPSWALL)
      TXTH='value of stream function at wall (for WALL)'
                CASE(LOCRLEVEQ)
      TXTH='thermal boundary layer rediction coef.'
                CASE(LOCRTREF)
      TXTH='reference temperature'
                CASE(LOCVHYDR)
      TXTH='hydraulic characteristic function'
                CASE(LOCVHEAT)
      TXTH='heat source function'
                CASE(LOCVHSINK)
      TXTH='heat sink function'
                CASE(LOCVCNSRC)
      TXTH='Cn source function'
                CASE(LOCVCNSINK)
      TXTH='Cn sink function'
                CASE(LOCVCDSRC)
      TXTH='Cd source function'
                CASE(LOCVCDSINK)
      TXTH='Cd sink function'
                CASE(LOCVCASRC)
      TXTH='Ca source function'
                CASE(LOCVCASINK)
      TXTH='Ca sink function'
                CASE(LOCRALG1+10)
      TXTH='Residuals ELEC,THER,CONC,...'
                CASE(LOCVST)
      TXTH='EGROUP   Static/Transient algorithms'
                CASE(LOCVGSS)
      TXTH='EGROUP   number of Gauss Points'
                CASE(LOCVPAX)
      TXTH='EGROUP   Cartesian/Cylindrical coord.syst. assumed'
                CASE(LOCVH)
      TXTH='RCONST   H [m]  thickness of a plate'
                CASE(LOCVD)
      TXTH='RCONST   D [m] diameter of a pipe'
                CASE(LOCVPRS)
      TXTH='RCONST   Inner pressure [Pa] applied to a shell'
                CASE(LOCVALF)
      TXTH='RCONST   [W/m^2/K] heat transfer coeffient'
                CASE(LOCVTE)
      TXTH='RCONST   Te [C] ambient temperature'
                CASE(LOCVARE)
      TXTH='RCONST   [m^2] -usually heat transfer surface'
                CASE(LOCVPER)
      TXTH='RCONST   Perimeter [m] of a cross section'
                CASE(LOCVVOL)
      TXTH='RCONST   Volume'
                CASE(LOCVRA)
      TXTH='RCONST   wall rougness'
                CASE(LOCVDUDY)
      TXTH='RCONST   transversal intensity of el.field'
                CASE(LOCVZETA)
      TXTH='RCONST   local loss coefficient'
                CASE(LOCVPERM)
      TXTH='RCONST   permeability of wall'
                CASE(LOCVALFE)
      TXTH='RCONST   electric conductivity of wall'
                CASE(LOCVUE)
      TXTH='RCONST   external voltage'
                CASE(LOCVKX)
      TXTH='MPROP    Kx [W/m/K] heat conductivity'
                CASE(LOCVCP)
      TXTH='MPROP    Cp [J/kg/K] heat capacity'
                CASE(LOCVDEN)
      TXTH='MPROP    Rho [kg/m^3] density'
                CASE(LOCVKAP)
      TXTH='MPROP    Kappa [S/m] electrical conductivity'
                CASE(LOCVEX)
      TXTH='MPROP    E [Pa] (Young modulus)'
                CASE(LOCVMI)
      TXTH='MPROP    Mi (Poisson constant)'
                CASE(LOCVISC)
      TXTH='MPROP    Viscosity [Pa.s]'
                CASE(LOCVBET)
      TXTH='MPROP    Beta [1/K] thermal expansion'
                CASE(LOCVDN)
      TXTH='MPROP    Dn [m^2/s] diffusion coeffient'
                CASE(LOCVEN)
      TXTH='MPROP    En activation energy (Arrhenius)'
                CASE(LOCVAN)
      TXTH='MPROP    An frequency factor dc/dt=An*exp(En/RT)*c'
                CASE(LOCVKXF)
      TXTH='MPROP    Kx -index of function multiplying Kx'
                CASE(LOCVTM)
      TXTH='MPROP    Tm [C] melting point temperature'
                CASE(LOCVHM)
      TXTH='MPROP    Hm [J/kg] enthalpy of melting'
                CASE(LOCVKAPF)
      TXTH='MPROP    [S/m] conduct.of fouling layer'
                CASE(LOCVKF)
      TXTH='MPROP    [W/m/K] therm.cond.of fouling layer'
                CASE(LOCIUE)
      TXTH='Connect: IUE(lue(i)+j) j-th node of i-th element'
                CASE(LOCLUE)
      TXTH='LUE(i)  pointer to i-th element connectivity'
                CASE(LOCMUE)
      TXTH='MUE(i)  number of i-th element nodes'
                CASE(LOCEPAR)
      TXTH='first parameter of i-th element (postproc.result)'
                CASE(LOCEPA2)
      TXTH='second parameter of i-th element (postproc.result)'
                CASE(LOCEPA3)
      TXTH='third parameter of i-th element (postproc.result)'
                CASE(LOCEPA4)
      TXTH='fourth parameter of i-th element (postproc.result)'
                CASE(LOCEPA5)
      TXTH='fifth parameter of i-th element (postproc.result)'
                CASE(LOCIGROUP)
      TXTH='E-GROUP index of an element'
                CASE(LOCIRCONS)
      TXTH='RC-GROUP index of an element '
                CASE(LOCIMPROP)
      TXTH='MPROP-GROUP index of an element'
                CASE(LOCXX)
      TXTH='nodal coordinates X'
                CASE(LOCYY)
      TXTH='nodal coordinates Y'
                CASE(LOCIPU)
      TXTH='IPU(lpu(i)+j) status of DOF (<0 fixed, >0 load)'
                CASE(LOCJPU)
      TXTH='JPU(i) type of DOF (1-TEMP,2-UX,...)'
                CASE(LOCVAL)
      TXTH='V1(lpu(j)+i) DOF -j- of i-th node (input values)'
                CASE(LOCV2)
      TXTH='V2(lpu(j)+i) DOF -j- of i-th node (results)'
                CASE(LOCV3)
      TXTH='V1(lpu(j)+i) DOF -j- of i-th node (initial cond.)'
                CASE(LOCPTX)
      TXTH='point coordinate x'
                CASE(LOCPTY)
      TXTH='point coordinate y'
                CASE(LOCNEAR)
      TXTH='nearest NODE to a point'
                CASE(LOCRANGE)
      TXTH='DOF-Minimum values of all DOFs (command RANGE)'
                CASE(LOCRESI)
      TXTH='Abs.values of DOF differences (iterat.termination)'
                CASE(LOCMEAN)
      TXTH='Mean values of DOF''s (calculated by RANGE)'
                CASE(LOCMFUN)
      TXTH='number of functions (var.propert.,bound.cond...)'
                CASE(LOCMTAB)
      TXTH='number of tables (var.properties.,bound.cond...)'
                CASE(LOCMVAL)
      TXTH='C(i) concentration in i-th vessel (lump.par.model)'
                CASE(LOCMDER)
      TXTH='DC(i) time derivative of C(i) '
                CASE(LOCMETHOD)
      TXTH='solution of eqs. by 0-Euler,1-Runge Kutta'
                CASE(LOCNEQUAT)
      TXTH='number of equations and unknowns cm(1),...cm(neq)'
                CASE(LOCPMOD)
      TXTH='lumped model parameters'
                CASE(LOCNUMODP)
      TXTH='number of lumped model parameters PM(1),...'
                CASE(LOCRMOD)
      TXTH='lumped model parameters relaxation factor WM(1),..'
                CASE(LOCZMINP)
      TXTH='lumped model parameters lower bounds'
                CASE(LOCZMAXP)
      TXTH='lumped model parameters upper bounds'
                CASE(LOCLMOD)
      TXTH='association of parameter PM to a variable in FEM'
                CASE(LOCKMOD)
      TXTH='regression parameter identification (=1)'
                CASE(LOCNINPUTS)
      TXTH='number of stimulus functions xvt(i,t) for a model'
                CASE(LOCMINPUTS)
      TXTH='index of curve describing i-th stimulus xvt(i,t)'
                CASE(LOCXINPUTS)
      TXTH='actual value of i-th stimulus functions xv(i)'
                CASE(LOCNOUTPUTS)
      TXTH='number of recorded responses yvt(i,t) of model'
                CASE(LOCMOUTPUTS)
      TXTH='index of curve describing i-th response yvt(i,t)'
                CASE(LOCYOUTPUTS)
      TXTH='actual value of i-th response functions yv(i)'
                CASE(LOCYG1)
      TXTH='time values of curve (nodal history,experiment...)'
                CASE(LOCYG2)
      TXTH='values of curve (nodal history, experiment,...)'
                CASE(LOCNGR)
      TXTH='number of points of a curve (no.of time steps)'
                CASE(LOCINDG)
      TXTH='correponding node(1),exper.(2),inlet(3),outlet(4)'
                CASE(LOCIQGR)
      TXTH='time course: 1-FEM,2-experiment,3-inlet,4-outlet'
                CASE(LOCNMODELS)
      TXTH='number of interpreted models defined in ext.files'
                CASE(LOCKCOMPAR)
      TXTH='criterion for TC comparison 0-sum,...4-integral...'
                CASE(LOCSCOMPAR)
      TXTH='norm of TC differences'
                CASE(LOCNCOMPAR)
      TXTH='number of pairs of compared TC curves'
                CASE(LOCICOMPAR)
      TXTH='indices of compared curves...'
                CASE DEFAULT
                  IENDH=0
                  TXTH=' '
      END SELECT
      END

      SUBROUTINE OBR(IOBR)
      SELECT CASE(IOBR)
      CASE(1)
          CALL DIAGRA('$SOLHEX.BMP')
      CASE(2)
          CALL DIAGRA('$SOLPIPE.BMP')
      CASE(3)
          CALL DIAGRA('$PCHAR1.BMP')
      CASE(4)
          CALL DIAGRA('$SOLPLAN.BMP')
      CASE(5)
          CALL DIAGRA('$PCHAR2.BMP')
      CASE(6)
          CALL DIAGRA('$SOLFLOW.BMP')
      END SELECT
      END
