C $s1-plot

      SUBROUTINE CLEARPLOT
      INCLUDE '$PLT-COM'
      IF(IST20.EQ.1)THEN
        ND$=0
        EL$=0
        PT$=0
        CR$=0
        SF$=0
        DT$=0
      ELSE
        TC$=0
        ITCPLOT=0
      ENDIF
      END

      SUBROUTINE CRPTS(X1,X2,X3,Y1,Y2,Y3,XG,YG)
C Parabolicka krivka XG,YG prolozena body 1,2,3
      DIMENSION XG(*),YG(*),RG(11)
      DATA RG/-1.,-.8,-.6,-.4,-.2,0.,.2,.4,.6,.8,1./
      DO I=1,11
         R=RG(I)
         XG(I)=X1*R*(R-1)/2.+X2*R*(R+1)/2.+X3*(1-R**2)
         YG(I)=Y1*R*(R-1)/2.+Y2*R*(R+1)/2.+Y3*(1-R**2)
      ENDDO
      END

      SUBROUTINE PLOTVL(K,ICOL,KVLL)
      INCLUDE '$FEM'
      INCLUDE '$GMF'
      INCLUDE '$PLT-COM'
      DIMENSION X20(20),Y20(20),XG(31),YG(31),ICQ(31)
      IF(K.LE.0.OR.K.GT.NVL)RETURN
      NPTVL=MVL(K)
      XA=0
      YA=0
      DO J=1,NPTVL
        IU=MAX0(1,IVL(J,K))
        CALL ROT(PTX(IU),PTY(IU),PTZ(IU),X20(J),Y20(J),DUMMY)
        XA=XA+X20(J)/NPTVL
        YA=YA+Y20(J)/NPTVL
      ENDDO
      IF(XA.GT.FXMI.AND.XA.LE.FXMA.AND.YA.GE.FYMI.AND.YA.LE.FYMA)THEN
        IF(KVLL.NE.0)CALL GMFTXC(XA,YA,ICOL,K)
        IF(NPTVL.EQ.8)THEN
          ICQ(1:16)=(/1,2,3,4,1,5,6,7,8,5,6,2,3,7,8,4/)
          NCQ=16
        ELSEIF(NPTVL.EQ.20)THEN
          ICQ(1:31)=(/1,9,2,10,3,11,4,12,1,17,5,13,6,14,7,
     /               15,8,16,5,13,6,18,2,10,3,19,7,15,8,20,4/)
          NCQ=31
        ELSEIF(NPTVL.EQ.4)THEN
          ICQ(1:8)=(/1,2,3,4,1,3,2,4/)
          NCQ=8
        ENDIF
        DO I=1,NCQ
           XG(I)  =X20(ICQ(I))
           YG(I)  =Y20(ICQ(I))
        ENDDO
        CALL GMFPL(NCQ,XG,YG,ICOL)
      ENDIF
      END

      SUBROUTINE PLOTSF(K,ICOL,KSFF)
      INCLUDE '$FEM'
      INCLUDE '$GMF'
      INCLUDE '$PLT-COM'
      DIMENSION X8(8),Y8(8),XG(11),YG(11)
      IF(K.LE.0.OR.K.GT.NSF)RETURN
      NPTSF=MSF(K)
      XA=0
      YA=0
      DO J=1,NPTSF
        IU=MAX0(1,ISF(J,K))
        CALL ROT(PTX(IU),PTY(IU),PTZ(IU),X8(J),Y8(J),DUMMY)
        XA=XA+X8(J)/NPTSF
        YA=YA+Y8(J)/NPTSF
      ENDDO
      IF(XA.GT.FXMI.AND.XA.LE.FXMA.AND.YA.GE.FYMI.AND.YA.LE.FYMA)THEN
        IF(KSFF.NE.0)CALL GMFTXC(XA,YA,ICOL,K)
        IF(NPTSF.EQ.8.OR.NPTSF.EQ.6)THEN
          NP1=NPTSF/2
          DO J=1,NP1
            J1=MOD(J,NP1)+1        
            X1=X8(J)
            X2=X8(J1)
            X3=X8(J+NP1)
            Y1=Y8(J)
            Y2=Y8(J1)
            Y3=Y8(J+NP1)
            CALL CRPTS(X1,X2,X3,Y1,Y2,Y3,XG,YG)
            CALL GMFPL(11,XG,YG,ICOL)
          ENDDO
        ELSE
          CALL GMFPLC(NPTSF,X8,Y8,ICOL)
        ENDIF
        SF$=1
      ENDIF
      END

      SUBROUTINE PLDSF(K)
C Vykresleni plochy cislo K pro dialog zadavani site
      INCLUDE '$FEM'
      INCLUDE '$GMF'
      CHARACTER *2 LABEL(4),PT
      DIMENSION X8(8),Y8(8),XG(11),YG(11)
      DATA LABEL /'Nx','Ny','Nx','Ny'/
      IF(K.LE.0.OR.K.GT.NSF)RETURN
      NPTSF=MSF(K)
      XA=0
      YA=0
      XMI=1E10
      YMI=1E10
      XMA=-1E10
      YMA=-1E10
      DO J=1,NPTSF
        IU=MAX0(1,ISF(J,K))
        CALL ROT(PTX(IU),PTY(IU),PTZ(IU),X8(J),Y8(J),DUMMY)
        XA=XA+X8(J)/NPTSF
        YA=YA+Y8(J)/NPTSF
        XMI=AMIN1(XMI,X8(J))
        YMI=AMIN1(YMI,Y8(J))
        XMA=AMAX1(XMA,X8(J))
        YMA=AMAX1(YMA,Y8(J))
      ENDDO
      DX=(XMA-XMI)*.1
      DY=(YMA-YMI)*.1
      CALL GMFSTW(3,1,21,5,12,'X','Y',0.,1.,0.,1.,
     /            XMI-DX,XMA+DX,YMI-DY,YMA+DY)
      CALL GMFAXE(3,7,15)
      CALL GMFFONT(1,16)
      CALL GMFTXC(XA,YA,1,K)
      DO J=1,NPTSF
          CALL GMFMRK(X8(J),Y8(J),40)
          WRITE(PT,'(''P'',I1)')J
          CALL GMFTEXT(X8(J),Y8(J),0,2,PT)
      ENDDO
      IF(NPTSF.EQ.8.OR.NPTSF.EQ.6)THEN
          NP1=NPTSF/2
          DO J=1,NP1
            J1=MOD(J,NP1)+1        
            X1=X8(J)
            X2=X8(J1)
            X3=X8(J+NP1)
            Y1=Y8(J)
            Y2=Y8(J1)
            Y3=Y8(J+NP1)
            CALL CRPTS(X1,X2,X3,Y1,Y2,Y3,XG,YG)
            CALL GMFPL(11,XG,YG,J)
            IF(J.LE.2)THEN
               CALL GMFMRK(XG(3),YG(3),25)
               CALL GMFTEXT(XG(3),YG(3),J,2,LABEL(J))
            ENDIF
          ENDDO
      ELSE
          CALL GMFPLC(NPTSF,X8,Y8,0)
          DO J=1,2
            CALL GMFPL(2,X8(J),Y8(J),J)
            CALL GMFTEXT((X8(J)+X8(J+1))/2,(Y8(J)+Y8(J+1))/2,
     /                   J,2,LABEL(J))
            CALL GMFMRK(X8(J)+(X8(J+1)-X8(J))*.2,
     /                  Y8(J)+(Y8(J+1)-Y8(J))*.2,25)
          ENDDO
      ENDIF
      CALL GMFSW(1)
      END

      SUBROUTINE PLOTCR(K,ICOL,KCRR)
      INCLUDE '$FEM'
      INCLUDE '$GMF'
      INCLUDE '$PLT-COM'
      DIMENSION X3(3),Y3(3),XG(11),YG(11)
      IF(K.LE.0.OR.K.GT.NCR)RETURN
      NPTCR=MCR(K)
      XA=0
      YA=0
      DO J=1,NPTCR
        IU=MAX0(1,ICR(J,K))
        CALL ROT(PTX(IU),PTY(IU),PTZ(IU),X3(J),Y3(J),DUMMY)
        XA=XA+X3(J)/NPTCR
        YA=YA+Y3(J)/NPTCR
      ENDDO
      IF(XA.GE.FXMI.AND.XA.LE.FXMA.AND.YA.GE.FYMI.AND.YA.LE.FYMA)THEN
        IF(NPTCR.EQ.3)THEN
           CALL CRPTS(X3(1),X3(2),X3(3),Y3(1),Y3(2),Y3(3),XG,YG)
           CALL GMFPL(11,XG,YG,ICOL)
        ELSE
           XG(2)=X3(1)+.1*(X3(2)-X3(1))
           YG(2)=Y3(1)+.1*(Y3(2)-Y3(1))
           CALL GMFPL(2,X3,Y3,ICOL)
        ENDIF
        IF(KCRR.NE.0)THEN
           CALL GMFTXC(XA,YA,ICOL,K)
           CALL GMFMRK(XG(2),YG(2),35)
        ENDIF
        CR$=1
      ENDIF
      END

      SUBROUTINE PLDCR(K)
      INCLUDE '$FEM'
      INCLUDE '$GMF'
      CHARACTER *2 PT
      DIMENSION X3(3),Y3(3),XG(11),YG(11)
      IF(K.LE.0.OR.K.GT.NCR)RETURN
      NPTCR=MCR(K)
      XA=0
      YA=0
      XMI=1E10
      YMI=1E10
      XMA=-1E10
      YMA=-1E10
      DO J=1,NPTCR
        IU=MAX0(1,ICR(J,K))
        CALL ROT(PTX(IU),PTY(IU),PTZ(IU),X3(J),Y3(J),DUMMY)
        XA=XA+X3(J)/NPTCR
        YA=YA+Y3(J)/NPTCR
        XMI=AMIN1(XMI,X3(J))
        YMI=AMIN1(YMI,Y3(J))
        XMA=AMAX1(XMA,X3(J))
        YMA=AMAX1(YMA,Y3(J))
      ENDDO
      DX=AMAX1(0.01,(XMA-XMI)*.1)
      DY=AMAX1(0.01,(YMA-YMI)*.1)
      CALL GMFSTW(3,1,21,5,12,'X','Y',0.,1.,0.,1.,
     /            XMI-DX,XMA+DX,YMI-DY,YMA+DY)
      CALL GMFAXE(3,7,15)
      CALL GMFFONT(1,16)
      CALL GMFTXC(XA,YA,1,K)
      DO J=1,NPTCR
          CALL GMFMRK(X3(J),Y3(J),40)
          WRITE(PT,'(''P'',I1)')J
          CALL GMFTEXT(X3(J),Y3(J),0,2,PT)
      ENDDO
      IF(NPTCR.EQ.3)THEN
           CALL CRPTS(X3(1),X3(2),X3(3),Y3(1),Y3(2),Y3(3),XG,YG)
           CALL GMFPL(11,XG,YG,ICOL)
           CALL GMFMRK(XG(3),YG(3),25)
      ELSE
           CALL GMFPL(2,X3,Y3,ICOL)
           CALL GMFMRK(X3(1)+.2*(X3(2)-X3(1)),Y3(1)+.2*(Y3(2)-Y3(1)),25)
      ENDIF
      CALL GMFSW(1)
      END

      SUBROUTINE DRAWE(K)
C
C Vykresleni vsech entit typu K=1 PT, K=2 CR, K=3 SF pro dialog
C
      INCLUDE '$fem'
      IF(NPT.LE.1)RETURN
      XMI=1E10
      YMI=1E10
      XMA=-1E10
      YMA=-1E10
      DO J=1,NPT
        CALL ROT(PTX(J),PTY(J),PTZ(J),PTXJ,PTYJ,DUMMY)        
        XMI=AMIN1(XMI,PTXJ)
        YMI=AMIN1(YMI,PTYJ)
        XMA=AMAX1(XMA,PTXJ)
        YMA=AMAX1(YMA,PTYJ)
      ENDDO
      DX=(XMA-XMI)*.05
      DY=(YMA-YMI)*.05
      CALL GMFSTW(3,1,21,5,10,'X','Y',0.,1.,0.,1.,
     /            XMI-DX,XMA+DX,YMI-DY,YMA+DY)
      CALL GMFAXE(3,7,15)
      CALL GMFFONT(5,12)
      SELECT CASE(K)
      CASE(1)
         DO I=1,NPT
           CALL ROT(PTX(I),PTY(I),PTZ(I),PTXI,PTYI,DUMMY)        
           CALL GMFMRKL(PTXI,PTYI,37,I,2)
         ENDDO
         DO I=1,NCR
           CALL PLOTCR(I,2,0)
         ENDDO
      CASE(2)
         DO I=1,NCR
           CALL PLOTCR(I,2,1)
         ENDDO
      CASE(3)
         DO I=1,NSF
           CALL PLOTSF(I,2,1)
         ENDDO
      END SELECT
      CALL GMFSW(1)
      END

      SUBROUTINE DEFPLOT(IPX,IPY,ICOL)
C
C Vykresleni deformovane konstrukce. 
C 1. Pricteni prirustku uzlovych parametru IPX,IPY k souradnicim uzlu 
C    Meritko je promenna vektoru RALGOR(8).
C 2. Vykresleni vsech elementu
C 3. Regenerace puvodnich souradnic
C
C Pokud je RALGOR(8), meritko SCL, rovno nule, pocita se minimalni 
C a maximalni UX,UY,X,Y a meritko se dle toho nastavi
C
      INCLUDE '$FEM'
      IF(IPX.LE.0.OR.IPY.LE.0)RETURN
      SCL=RALGOR(8)
      IF(SCL.EQ.0.)THEN
         UXMIN=1E10
         UYMIN=1E10
         UXMAX=-1E10
         UYMAX=-1E10
         XMIN=1E10
         YMIN=1E10
         XMAX=-1E10
         YMAX=-1E10
         DO IU=1,ND
            XMIN=AMIN1(XMIN,XX(IU))
            YMIN=AMIN1(YMIN,YY(IU))
            XMAX=AMAX1(XMAX,XX(IU))
            YMAX=AMAX1(YMAX,YY(IU))
            DX=VAL(LPU(IPX)+IU,2)
            DY=VAL(LPU(IPY)+IU,2)
            UXMIN=AMIN1(UXMIN,DX)
            UYMIN=AMIN1(UYMIN,DY)
            UXMAX=AMAX1(UXMAX,DX)
            UYMAX=AMAX1(UYMAX,DY)
         ENDDO
         DUX=UXMAX-UXMIN
         DUY=UYMAX-UYMIN
         IF(DUX.LE.0.)THEN
            SCLX=0
         ELSE
            SCLX=0.03*(XMAX-XMIN)/DUX
         ENDIF
         IF(DUY.LE.0.)THEN
            SCLY=0
         ELSE
            SCLY=0.03*(YMAX-YMIN)/DUY
         ENDIF
         SCL=AMAX1(SCLX,SCLY)
      ENDIF
      DO IU=1,ND
C         XX(IU)=XX(IU)+VAL(LPU(IPX)+IU,2)*SCLX
C         YY(IU)=YY(IU)+VAL(LPU(IPY)+IU,2)*SCLY
         XX(IU)=XX(IU)+VAL(LPU(IPX)+IU,2)*SCL
         YY(IU)=YY(IU)+VAL(LPU(IPY)+IU,2)*SCL
      ENDDO
      DO IE=1,NE
         CALL PLOTEL(IE,ICOL,0)
      ENDDO
      DO IU=1,ND
C         XX(IU)=XX(IU)-VAL(LPU(IPX)+IU,2)*SCLX
C         YY(IU)=YY(IU)-VAL(LPU(IPY)+IU,2)*SCLY
         XX(IU)=XX(IU)-VAL(LPU(IPX)+IU,2)*SCL
         YY(IU)=YY(IU)-VAL(LPU(IPY)+IU,2)*SCL
      ENDDO
      END

      SUBROUTINE PLOTEL(IE,ICOL,IFILL)
C Vykresleni elementu IE barvou ICOL.
C IFILL=0  bez barevne vyplne
C IFILL=1  barevna vypln dle EGROUP
C IFILL=2  barevna vypln dle RCONST
C IFILL=3  barevna vypln dle MPROP
C
      INCLUDE '$FEMB'
      INCLUDE '$FEM-EQU'
      INCLUDE '$PLT-COM'
      DIMENSION X20(20),Y20(20)
      IF(IE.LE.0.OR.IE.GT.NE+NPART)RETURN
      IG   =MAX0(1,IGROUP(IE))
      LRCON=MAX0(1,IRCONS(IE))
      D    =RRCONS(LRCON,$D)
      AREA =RRCONS(LRCON,$AREA)
      NAMEL=JGROUP(IG,$ENAME)
      JMET =JGROUP(IG,$METHOD)
      JAXIS=JGROUP(IG,$AXIS)
      NUG  =IABS(MUE(IE))-MINT(IE)
      NUOLINE=NUG
      L0=LUE(IE)

C ------- 1.faze bez kresleni jen se pocitaji transformovane souradnice X20...

      IF(MUE(IE).LT.0)THEN
C Vyjimka. Trojuhelnik s uzly ve stredech stran a teziste
         DO J=1,4
           IU=IABS(IUE(L0+J))
           IF(IU.LE.0.OR.IU.GT.MAXND)RETURN
           CALL ROT(XX(IU),YY(IU),ZZ(IU),X20(J+3),Y20(J+3),DUMMY)
         ENDDO
         NUOLINE=3
         NUG=3
         CALL TEXP(X20(4),Y20(4),X20,Y20)
      ELSEIF(NAMEL.EQ.$SOLID.OR.NAMEL.EQ.$FLOW3D)THEN
C 3D ELEMENTY
         IF(NUG.EQ.4)THEN
C Ctyrsten
           NUOLINE=8
           DO J=1,4
             IU=IABS(IUE(L0+J))  
             IF(IU.LE.0.OR.IU.GT.MAXND)RETURN
             CALL ROT(XX(IU),YY(IU),ZZ(IU),X20(J),Y20(J),DUMMY)
           ENDDO
           X20(5)=X20(1)
           X20(6)=X20(3)
           X20(7)=X20(2)
           X20(8)=X20(4)
           Y20(5)=Y20(1)
           Y20(6)=Y20(3)
           Y20(7)=Y20(2)
           Y20(8)=Y20(4)
         ELSEIF(NUG.EQ.5)THEN
C Petisten (pyramida)
           NUOLINE=10
           DO J=1,5
             IU=IABS(IUE(L0+J))  
             IF(IU.LE.0.OR.IU.GT.MAXND)RETURN
             CALL ROT(XX(IU),YY(IU),ZZ(IU),X20(J),Y20(J),DUMMY)
           ENDDO
           X20(6)=X20(1)
           X20(7)=X20(4)
           X20(8)=X20(3)
           X20(9)=X20(5)
           X20(10)=X20(2)
           Y20(6)=Y20(1)
           Y20(7)=Y20(4)
           Y20(8)=Y20(3)
           Y20(9)=Y20(5)
           Y20(10)=Y20(2)
         ELSEIF(NUG.EQ.6)THEN
C Petisten (Acko) dle konvenci Fluentu (prvni tri uzly jeden bok, druha trojice druhy bok)
           NUOLINE=12
           DO J=1,6
             IU=IABS(IUE(L0+J))  
             IF(IU.LE.0.OR.IU.GT.MAXND)RETURN
             CALL ROT(XX(IU),YY(IU),ZZ(IU),X20(J),Y20(J),DUMMY)
           ENDDO
C pro kresleni jednou carou je treba prohodit uzly 4 a 6
           DD=X20(6)
           X20(6)=X20(4)
           X20(4)=DD
           DD=Y20(6)
           Y20(6)=Y20(4)
           Y20(4)=DD
C
           X20(7)=X20(1)
           X20(8)=X20(3)
           X20(9)=X20(2)
           X20(10)=X20(5)
           X20(11)=X20(4)
           X20(12)=X20(6)
           Y20(7)=Y20(1)
           Y20(8)=Y20(3)
           Y20(9)=Y20(2)
           Y20(10)=Y20(5)
           Y20(11)=Y20(4)
           Y20(12)=Y20(6)
         ELSE
C Sestisten (cihla)
           NUOLINE=18
           DO J=1,4
             IU=IABS(IUE(L0+J))  
             IF(IU.LE.0.OR.IU.GT.MAXND)RETURN
             CALL ROT(XX(IU),YY(IU),ZZ(IU),X20(J),Y20(J),DUMMY)
             IU=IABS(IUE(L0+J+4))  
             IF(IU.LE.0.OR.IU.GT.MAXND)RETURN
             CALL ROT(XX(IU),YY(IU),ZZ(IU),X20(J+5),Y20(J+5),DUMMY)
           ENDDO
           X20(5)=X20(1)
           X20(10)=X20(6)
           X20(11)=X20(7)
           X20(12)=X20(2)
           X20(13)=X20(3)
           X20(14)=X20(8)
           X20(15)=X20(9)
           X20(16)=X20(4)
           X20(17)=X20(1)
           X20(18)=X20(6)
           Y20(5)=Y20(1)
           Y20(10)=Y20(6)
           Y20(11)=Y20(7)
           Y20(12)=Y20(2)
           Y20(13)=Y20(3)
           Y20(14)=Y20(8)
           Y20(15)=Y20(9)
           Y20(16)=Y20(4)
           Y20(17)=Y20(1)
           Y20(18)=Y20(6)
         ENDIF
      ELSEIF(NAMEL.EQ.$SPHERE)THEN
C Particle
         IU=IABS(IUE(L0+1))
         FI=0
         DFI=0.3141
         DO J=1,20
           X=XX(IU)+D/2*COS(FI)
           Y=YY(IU)+D/2*SIN(FI)
           Z=ZZ(IU)
           CALL ROT(X,Y,Z,X20(J),Y20(J),DUMMY)
           FI=FI+DFI
         ENDDO
         NUOLINE=20
      ELSEIF(NUG.LE.4)THEN
C 2D a 1D elementy (napr. rovinny prvek bez uzlu uprostred stran)
         DO J=1,NUG
           IU=IABS(IUE(L0+J))
           IF(IU.LE.0.OR.IU.GT.MAXND)RETURN
           CALL ROT(XX(IU),YY(IU),ZZ(IU),X20(J),Y20(J),DUMMY)
         ENDDO
      ELSE
C 2D elementy rovinny prvek s uzly uprostred stran
         NUM=NUG/2
         K=0
         DO J=1,NUM
            IU=IABS(IUE(L0+J))
            IF(IU.GT.0.AND.IU.LE.MAXND)THEN
              K=K+1
              CALL ROT(XX(IU),YY(IU),ZZ(IU),X20(K),Y20(K),DUMMY)
            ENDIF
            IU=IABS(IUE(L0+J+NUM))
            IF(IU.GT.0.AND.IU.LE.MAXND)THEN
              K=K+1
              CALL ROT(XX(IU),YY(IU),ZZ(IU),X20(K),Y20(K),DUMMY)
            ENDIF
         ENDDO
      ENDIF
      IF(NUG.LE.0)RETURN
C
C ------- 2.faze kresleni dle souradnice X20...

C Vykreslujeme jen ty elementy, ktere lezi uvnitr okna?
      CALL GMFPLC(NUOLINE,X20,Y20,ICOL)
      XA=0
      YA=0
      DO J=1,NUG
         IU=IABS(IUE(L0+J))
         IF(IU.LE.0.OR.IU.GT.ND)RETURN
         CALL ROT(XX(IU),YY(IU),ZZ(IU),XXIU,YYIU,DUMMY)
         XA=XA+XXIU
         YA=YA+YYIU
      ENDDO
      XT=XA/NUG
      YT=YA/NUG
      SELECT CASE(NAMEL)
      CASE($PIPE2D,$PIPE3D,$TRUSS2D,$TRUSS3D,$BEAM2D,$BEAM3D)
C PIPE
C                IE,IHEIGHT,ICOL,IDOF,VMIN,VMAX,IVMIN,IVMAX
         IF(NPT.GE.30.OR.NE.GT.200)THEN
            IHEI=0
         ELSEIF(NPT.GE.10.OR.NE.GT.10)THEN
            IHEI=1
	   ELSE
	      IHEI=2
         ENDIF
         IF(GFIX.EQ.0..AND.GFIY.EQ.0..AND.GFIZ.EQ.0.
     /      .AND.JAXIS.EQ.0.AND.IPROJ.EQ.0)THEN
            CALL GPIPE(IE,IHEI,0,12,2,VMIN,VMAX,0,500)
         ELSEIF(JAXIS.GT.0)THEN
C PRVNI NULA BARVA, DRUHA IDENTIFIKACE NAVESTI
            CALL GPIPE3(IE,JAXIS,0,0)
         ENDIF
      CASE($SHELLAX)
         CALL GMFMRKS(X20(1),Y20(1),40)
         CALL GMFMRKS(X20(2),Y20(2),40)
         IRC=MAX0(1,IRCONS(IE))
         PRES=RRCONS(IRC,$P)
         CALL GMFARROW(1,X20,Y20,PRES,0)
      CASE($CSTR)
C CSTR
         DX=X20(2)-X20(1)
         DY=Y20(2)-Y20(1)
         H=AMAX1(DX,DY)*.35
         HX=AMAX1(H,(XMAF-XMIF)/40.)
         HY=AMAX1(H,(YMAF-YMIF)/30.)
         CALL PLOTMIX(XT,YT,HX,HY)
      CASE($PUMP)
C PUMP
         HX=(XMAF-XMIF)/60.
         HY=(YMAF-YMIF)/45.
         CALL PLOTPUMP(XT,YT,HX,HY)
      CASE($VALVE)
C VALVE
         HX=(XMAF-XMIF)/90.
         HY=(YMAF-YMIF)/60.
         CALL PLOTVALVE(XT,YT,HX,HY)
      CASE($HEXC)
C HEXC
         IF($IHEPI.EQ.0)THEN
           CALL GMFPLC(3,X20,Y20,0)
           CALL GMFPLC(3,X20(2),Y20(2),0)
         ELSEIF(JMET.EQ.$CHEV)THEN
           JM=JGROUP(IG,$FI)
           CALL PLOTCHEV(X20,Y20,JM)
         ELSEIF(JMET.EQ.$STUB)THEN
           CALL GMFPLC(NUG,X20,Y20,15)
           CALL PLOTSTUB(X20,Y20)
         ELSE
           CALL GMFPLC(3,X20,Y20,0)
         ENDIF
      END SELECT
     
      JFILL=0
      SELECT CASE(IFILL)
      CASE(1)
C FILL EGROUP
         JFILL=IGROUP(IE)
      CASE(2)
C FILL RCONST
         JFILL=IRCONS(IE)
      CASE(3)
C FILL MPROP
         JFILL=IMPROP(IE)
      ENDSELECT
      IF(JFILL.GT.0)THEN
          X20=XT
          Y20=YT
          CALL GMFPL(2,X20,Y20,15)
          CALL GMFILL(XT,YT,JFILL,ICOL)
      ENDIF
      IF(KEL.NE.0)THEN
         CALL GMFTXC(XT,YT,3,IE)
      ENDIF
      EL$=1
      END

      SUBROUTINE PLOTMIX(XT,YT,HX,HY)
C Vykresleni ikonky mixeru
      DIMENSION XG(7),YG(7)
      XG(1)=XT-HX
      XG(2)=XT+HX
      XG(3)=XT+HX
      XG(4)=XT-HX
      YG(1)=YT-HY
      YG(2)=YT-HY
      YG(3)=YT+HY
      YG(4)=YT+HY
      CALL GMFPLC(4,XG,YG,1)
      CALL GMFILL(XT,YT,11,1)
      CALL GMFPLC(4,XG,YG,0)
      XG(1)=XT
      YG(1)=YT+1.2*HY
      XG(2)=XT
      YG(2)=YT
      XG(3)=XT-0.7*HX
      YG(3)=YT+0.3*HY
      XG(4)=XG(3)
      YG(4)=YT-0.3*HY
      XG(5)=XT+0.7*HX
      YG(5)=YT+0.3*HY
      XG(6)=XG(5)
      YG(6)=YT-0.3*HY
      XG(7)=XT
      YG(7)=YT
      CALL GMFPL(7,XG,YG,0)
      CALL GMFILL(XT+.4*HX,YT,15,0)
      CALL GMFILL(XT-.4*HX,YT,15,0)
      END

      SUBROUTINE PLOTPUMP(XT,YT,HX,HY)
C Vykresleni ikonky CERPADLA
      DIMENSION XG(39),YG(39)
      PARAMETER (PI=3.14159)
      DFI=PI/19
      FI=-PI/2.
      DO I=1,38
         XG(I)=XT+HX*COS(FI)
         YG(I)=YT+HY*SIN(FI)
         FI =FI-DFI
      ENDDO
      XG(39)=XG(1)
      YG(39)=YG(1)
      CALL GMFPL(39,XG,YG,1)
      CALL GMFILL(XT,YT,11,1)
      XG(2)=XT
      YG(2)=YT+HY
      XG(3)=XT-HX
      YG(3)=YT
      XG(4)=XT
      YG(4)=YT+HY
      XG(5)=XT+HX
      YG(5)=YT
      CALL GMFPL(5,XG,YG,1)
      END

      SUBROUTINE PLOTVALVE(XT,YT,HX,HY)
C Vykresleni ikonky VENTILU
      PARAMETER (PI=3.14159)
      DIMENSION XG(8),YG(8)
      XG(1)=XT+HX
      YG(1)=YT+HY
      XG(2)=XT-HX
      YG(2)=YT-HY
      XG(3)=XT-HX
      YG(3)=YT+HY
      XG(4)=XT+HX
      YG(4)=YT-HY
      XG(5)=XG(1)
      YG(5)=YG(1)
      XG(6)=XT
      YG(6)=YT
      XG(7)=XT
      YG(7)=YT+1.3*HY
      XG(8)=XT-HX*.5
      YG(8)=YG(7)
      CALL GMFPL(8,XG,YG,1)
      CALL GMFILL(XT-HX*.3,YT,11,1)
      CALL GMFILL(XT+HX*.3,YT,11,1)
      END

      SUBROUTINE PLOTCHEV(X,Y,JM)
CHEVRON - HEAT EXCHANGER
C     JM - Pocet tahu. Pocet desek 2*JM+1
      DIMENSION X(*),Y(*),XV(9),YV(9),XS(9),YS(9)
      NPLATE=2*JM+1
      XV(1)=X(1)-.1*(X(2)-X(1))
      YV(1)=Y(1)-.1*(Y(2)-Y(1))
      XV(2)=X(1)-.1*(X(3)-X(1))
      YV(2)=Y(1)-.1*(Y(3)-Y(1))
      XV(3)=X(2)-.1*(X(4)-X(2))
      YV(3)=Y(2)-.1*(Y(4)-Y(2))
      XV(4)=X(2)-.1*(X(1)-X(2))
      YV(4)=Y(2)-.1*(Y(1)-Y(2))
      XV(5)=X(4)-.1*(X(3)-X(4))
      YV(5)=Y(4)-.1*(Y(3)-Y(4))
      XV(6)=X(4)-.1*(X(2)-X(4))
      YV(6)=Y(4)-.1*(Y(2)-Y(4))
      XV(7)=X(3)-.1*(X(1)-X(3))
      YV(7)=Y(3)-.1*(Y(1)-Y(3))
      XV(8)=X(3)-.1*(X(4)-X(3))
      YV(8)=Y(3)-.1*(Y(4)-Y(3))
      XV(9)=XV(1)
      YV(9)=YV(1)
      DX=ABS(XV(4)-XV(1))/(5.*NPLATE)
      DY=ABS(YV(2)-YV(7))/(5.*NPLATE)
      DO I=1,NPLATE
         XT=0
         YT=0
         DO J=1,9
            XS(J)=XV(J)+(NPLATE-I)*DX
            YS(J)=YV(J)+(NPLATE-I)*DY
            XT=XT+XS(J)
            YT=YT+YS(J)
         ENDDO
         CALL GMFPL(9,XS,YS,1)
         IF(I.EQ.NPLATE)THEN
            IFIL=11
         ELSE
            IFIL=15
         ENDIF
         CALL GMFILL(XT/9,YT/9,IFIL,1)
         CALL GMFPL(9,XS,YS,0)
      ENDDO
      DO I=1,6
        XV(1)=X(1)+(X(2)-X(1))*I/7.
        YV(1)=Y(1)+(Y(2)-Y(1))*I/7.
        XV(3)=X(3)+(X(4)-X(3))*I/7.
        YV(3)=Y(3)+(Y(4)-Y(3))*I/7.
        XV(2)=(X(1)+X(3))/2.+(X(2)+X(4)-X(1)-X(3))*(I+1)/14.
        YV(2)=(Y(1)+Y(3))/2.+(Y(2)+Y(4)-Y(1)-Y(3))*(I+1)/14.
        CALL GMFPL(3,XV,YV,0)
      ENDDO
      DO I=1,4
        CALL GMFMRK(X(I),Y(I),27)
      ENDDO
      END
      
      SUBROUTINE PLOTSTUB(X,Y)
C SHELL AND TUBE
      DIMENSION X(*),Y(*),XV(12),YV(12)
      XA=X(3)*.4+X(1)*.6
      YA=Y(3)*.4+Y(1)*.6
      XB=X(4)*.4+X(2)*0.6
      YB=Y(4)*.4+Y(2)*0.6
      XC=X(1)+1.6*(X(3)-X(1))
      YC=Y(1)+1.6*(Y(3)-Y(1))
      XD=X(2)+1.6*(X(4)-X(2))
      YD=Y(2)+1.6*(Y(4)-Y(2))
      XV(1)=X(3)
      YV(1)=Y(3)
      XV(2)=X(3)+(X(4)-X(3))*.1
      YV(2)=Y(3)+(Y(4)-Y(3))*.1
      XV(3)=XA+.1*(XB-XA)
      YV(3)=YA+.1*(YB-YA)
      XV(4)=XA+.2*(XB-XA)
      YV(4)=YA+.2*(YB-YA)
      XV(5)=XA+.8*(XB-XA)
      YV(5)=YA+.8*(YB-YA)
      XV(6)=XA+.9*(XB-XA)
      YV(6)=YA+.9*(YB-YA)
      XV(7)=X(3)+.9*(X(4)-X(3))
      YV(7)=Y(3)+.9*(Y(4)-Y(3))
      XV(8)=XC+.9*(XD-XC)
      YV(8)=YC+.9*(YD-YC)
      XV(9)=XC+.8*(XD-XC)
      YV(9)=YC+.8*(YD-YC)
      XV(10)=XC+.2*(XD-XC)
      YV(10)=YC+.2*(YD-YC)
      XV(11)=XC+.1*(XD-XC)
      YV(11)=YC+.1*(YD-YC)
      XV(12)=XV(2)
      YV(12)=YV(2)
      CALL GMFPL(12,XV,YV,1)
      CALL GMFILL((X(3)+X(4))*.5,(Y(3)+Y(4))*.5,15,1)
      CALL GMFPL(12,XV,YV,0)
      XV(1)=XV(4)
      YV(1)=YV(4)
      XV(2)=XV(10)
      YV(2)=YV(10)
      CALL GMFPL(2,XV,YV,0)
      XV(1)=XV(5)
      YV(1)=YV(5)
      XV(2)=XV(9)
      YV(2)=YV(9)
      CALL GMFPL(2,XV,YV,0)
      XV(1)=XV(7)
      YV(1)=YV(7)
      XV(2)=X(4)
      YV(2)=Y(4)
      CALL GMFPL(2,XV,YV,0)
      XV(1)=X(1)
      YV(1)=Y(1)
      XV(2)=X(1)+0.3*(X(2)-X(1))
      YV(2)=Y(1)+0.3*(Y(2)-Y(1))
      XV(3)=XA+.3*(XB-XA)
      YV(3)=YA+.3*(YB-YA)
      CALL GMFPL(3,XV,YV,0)
      XV(1)=X(2)
      YV(1)=Y(2)
      XV(2)=X(2)-0.3*(X(2)-X(1))
      YV(2)=Y(2)-0.3*(Y(2)-Y(1))
      XV(3)=XA+.7*(XB-XA)
      YV(3)=YA+.7*(YB-YA)
      CALL GMFPL(3,XV,YV,0)
      DO I=1,7
        XA=X(1)+(X(3)-X(1))*(I+2)/6.
        YA=Y(1)+(Y(3)-Y(1))*(I+2)/6.
        XB=X(2)+(X(4)-X(2))*(I+2)/6.
        YB=Y(2)+(Y(4)-Y(2))*(I+2)/6.
        XV(1)=XA+.2*(XB-XA)
        YV(1)=YA+.2*(YB-YA)
        XV(2)=XA+.8*(XB-XA)
        YV(2)=YA+.8*(YB-YA)
        CALL GMFPL(2,XV,YV,11)
      ENDDO
      END
   
      SUBROUTINE PLOTAL
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
C Vykresleni vsech elementu (IST20=1-FEM) a krivek (IST20=2), pokud jiz
C byly drive vykresleny (priznaky EL$,TC$,... v zone /$PLOT/).
      INCLUDE '$FEM'
      INCLUDE '$PLT-COM'
	INCLUDE '$FEM-EQU'
 
C IACT (KGROUP,KMAT,KRCONS,KND,KEL,KPT)  - priznak cislovani entit
C definovano ekvivalenci v $FEM
      II=SETACTIVEQQ(20)
      IF(IST20.EQ.1)THEN
        IF(EL$.NE.0)THEN
           DO I=1,NE
              CALL PLOTEL(I,KEL,0)
           ENDDO
        ENDIF
        IF(CR$.NE.0)THEN
           DO I=1,NCR
              CALL PLOTCR(I,2,KCR)
           ENDDO
        ENDIF
        IF(ND$.NE.0)THEN
           DO I=1,ND
              CALL ROT(XX(I),YY(I),ZZ(I),XXI,YYI,DUMMY)
              IF(ND.LE.100)THEN
                 CALL GMFMRKL(XXI,YYI,30,I,KND)
              ELSE
                 CALL GMFMRKLS(XXI,YYI,40,I,0)
              ENDIF
           ENDDO
        ENDIF
        IF(PT$.NE.0)THEN
           DO I=1,NPT
              CALL ROT(PTX(I),PTY(I),PTZ(I),PTXI,PTYI,DUMMY)
              IF(NPT.LE.20)THEN
                 CALL GMFMRKL(PTXI,PTYI,27,I,KPT)
              ELSE
                 CALL GMFMRKL(PTXI,PTYI,47,I,0)
              ENDIF
           ENDDO
        ENDIF
        IF(DT$.NE.0)THEN
           DO I=1,MAXDET
              CALL DETPLO(I,DT$)
           ENDDO
        ENDIF
        CALL AXICON
      ELSE
        IF(TC$.NE.0)THEN
           DO I=2,MAXSEL
C IQGR - typ krivky. Ale neni to informace o tom, ze je krivka 
C vykreslena na displeji. 
C             IF(IQGR(I).GT.1)CALL GMFPL(NGR,YGR(1,1),YGR(1,I),I)
              IF(ITCPLOT(I).NE.0)CALL GMFPL(NGR,YGR(1,1),YGR(1,I),I)
           ENDDO
        ENDIF
      ENDIF
      END

      SUBROUTINE GMFMRKL(X,Y,ISYM,INUM,INU)
      INCLUDE '$GMF'
	INTEGER ISYM,INUM,INU
      IF(X.GT.FXMI.AND.X.LE.FXMA.AND.Y.GE.FYMI.AND.Y.LE.FYMA)THEN
         IF(INU.NE.0)CALL GMFTXI(X,Y,0,INUM)
         CALL GMFMRK(X,Y,ISYM)
      ENDIF
      END

      SUBROUTINE GMFMRKLS(X,Y,ISYM,INUM,INU)
      INCLUDE '$GMF'
	INTEGER ISYM,INUM,INU
      IF(X.GT.FXMI.AND.X.LE.FXMA.AND.Y.GE.FYMI.AND.Y.LE.FYMA)THEN
         IF(INU.NE.0)CALL GMFTXI(X,Y,0,INUM)
         CALL GMFMRKS(X,Y,ISYM)
      ENDIF
      END

      SUBROUTINE GMFTXTT(XT,YT,ICOL,LEN,CIND)
C
C ZOBRAZENI TEXT(1:LEN) VPRAVO OD BODU XT,YT BARVOU ICOL
C
      INCLUDE '$GMF'
      CHARACTER*(LEN) CIND
C
C VELIKOST OKENKA DLE POCTU CISLIC IND
C
      DY=SNGL((WYMA-WYMI)/32)
      SELECT CASE(LEN)
      CASE(1)
         DX=SNGL((WXMA-WXMI)/75)
      CASE(2)
         DX=SNGL((WXMA-WXMI)/40)
      CASE(3)
         DX=SNGL((WXMA-WXMI)/25)
      CASE DEFAULT
         DX=SNGL((WXMA-WXMI)/10)
      END SELECT
      X=XT+SNGL((WXMA-WXMI)/100)
      Y=YT+SNGL((WYMA-WYMI)/50)
      CALL GMFREC(X,X+DX,Y,Y-DY,8)
      CALL GMFILL(X+DX/2,Y-DY/2,15,8)
      CALL GMFREC(X,X+DX,Y,Y-DY,15)
      CALL GMFTEXT(X,Y,ICOL,LEN,CIND)
      END


      SUBROUTINE GMFTXI(XT,YT,ICOL,IND)
C
C ZOBRAZENI INDEXU IND VPRAVO OD BODU XT,YT BARVOU ICOL
C
      INCLUDE '$GMF'
      CHARACTER *4 CIND
C
C VELIKOST OKENKA DLE POCTU CISLIC IND
C
      SELECT CASE(IND)
      CASE(0:9)
         DX=SNGL((WXMA-WXMI)/75)
         DY=SNGL((WYMA-WYMI)/32)
         WRITE(CIND,'(I1)')IND
         ID=1
      CASE(10:99)
         DX=SNGL((WXMA-WXMI)/40)
         DY=SNGL((WYMA-WYMI)/32)
         WRITE(CIND,'(I2)')IND
         ID=2
      CASE(100:999)
         DX=SNGL((WXMA-WXMI)/25)
         DY=SNGL((WYMA-WYMI)/32)
         WRITE(CIND,'(I3)')IND
         ID=3
      CASE DEFAULT
         DX=SNGL((WXMA-WXMI)/22)
         DY=SNGL((WYMA-WYMI)/32)
         WRITE(CIND,'(I4)')IND
         ID=4
      END SELECT
      X=XT+SNGL((WXMA-WXMI)/100)
      Y=YT+SNGL((WYMA-WYMI)/50)
      CALL GMFREC(X,X+DX,Y,Y-DY,8)
      CALL GMFILL(X+DX/2,Y-DY/2,15,8)
      CALL GMFREC(X,X+DX,Y,Y-DY,15)
      CALL GMFTEXT(X,Y,ICOL,ID,CIND)
      END

      SUBROUTINE GMFTXC(XT,YT,ICOL,IND)
C
C ZOBRAZENI INDEXU IND S CENTREM XT,YT BARVOU ICOL
C
      INCLUDE '$GMF'
      CHARACTER *4 CIND
C
C VELIKOST OKENKA DLE POCTU CISLIC IND
C
      SELECT CASE(IND)
      CASE(0:9)
         DX=SNGL((WXMA-WXMI)/75)
         DY=SNGL((WYMA-WYMI)/32)
         WRITE(CIND,'(I1)')IND
         ID=1
      CASE(10:99)
         DX=SNGL((WXMA-WXMI)/40)
         DY=SNGL((WYMA-WYMI)/32)
         WRITE(CIND,'(I2)')IND
         ID=2
      CASE(100:999)
         DX=SNGL((WXMA-WXMI)/25)
         DY=SNGL((WYMA-WYMI)/32)
         WRITE(CIND,'(I3)')IND
         ID=3
      CASE DEFAULT
         DX=SNGL((WXMA-WXMI)/22)
         DY=SNGL((WYMA-WYMI)/32)
         WRITE(CIND,'(I4)')IND
         ID=4
      END SELECT
      X=XT-DX/2.
      Y=YT+SNGL((WYMA-WYMI)/50)
      CALL GMFREC(X,X+DX,Y,Y-DY,8)
      CALL GMFILL(X+DX/2,Y-DY/2,15,8)
      CALL GMFREC(X,X+DX,Y,Y-DY,15)
      CALL GMFTEXT(X,Y,ICOL,ID,CIND)
      END

      SUBROUTINE GPIPE(IE,IHEIGH,ICOL,IDOF,IZON,VMIN,VMAX,IVMIN,IVMAX)
C
C Vykresleni obrysu elementu typu usecka barvou ICOL. Obrys je obdelnik
C se zkosenymi stranami dle navazujicich elementu, pricemz tloustka obdelniku
C je urcena parametrem IHEIGHT = 0 (mala), 1 (stredni),...
C
C       3o------------------o4
C    2o                          o5
C       1o-------------------o6
C
C Vnitrek obrysu je vytonovan barvou dle hodnoty uzlovych parametru IDOF v
C uzlech elementu ze zony IZON. VMIN,VMAX je rozsah hodnot parametru, 
C kteremu jsou prirazeny barvy IVMIN,IVMAX (povoleny rozsah 0 az 2850).
C Uprava brezen 2005: MULTIPIPE
C Uprava zari   2005: porous
C
      DIMENSION X(6),Y(6),IU(2),V(2),VG(3),XG(3),YG(3),ISX(3,4),ISV(3,4)
      INCLUDE '$FEMB'
      INCLUDE '$gmf'
C ROZKLAD NA 4 TROJUHELNIKY (KAZDY TROJUHELNIK JE SLOUPEC MATIC ISI,ISV)
C Body 2 a 5 jsou koncove uzly elementu, 1,6 jedna a 3,4 druha strana.
C Matice ISV prirazuje vrcholum barvu bud 1 nebo 2 (koncove body elementu)
C 1 2 (1) 6 (2),  2 3 (1) 4 (2),  4 5 (2) 2 (1), 5 6 (2) 2 (1)
      DATA ISX /1,2,6, 2,3,4, 4,5,2, 5,6,2/
      DATA ISV /1,1,2, 1,1,2, 2,2,1, 2,2,1/
C PREVOD DO NORMALIZOVANYCH SOURADNIC 0-1
      XXW(I)=(XX(I)-WXMI)/(WXMA-WXMI)
      YYW(I)=(YY(I)-WYMI)/(WYMA-WYMI)
C ZPETNA TRANSFORMACE
      XXR(A)=WXMI+A*(WXMA-WXMI)
      YYR(A)=WYMI+A*(WYMA-WYMI)
C POUZE 2-UZLOVE ELEMENTY
      IF(MUE(IE).NE.2)RETURN
C Tloustka obdelniku V NORMALIZOVANYCH SOURADNICICH
      H=0.01*IHEIGH
C Indexy uzlu elementu
      LOC=LUE(IE)
      DO J=1,2
         IU(J)=IABS(IUE(LOC+J))
         IF(IU(J).LE.0)RETURN
      ENDDO
      RI=SQRT((XXW(IU(2))-XXW(IU(1)))**2+(YYW(IU(2))-YYW(IU(1)))**2)
      IF(ABS(RI).LT.1E-10)RETURN
C HLEDANI NAVAZUJICI ELEMENTU
C UVAZUJEME KONFIGURACI TRI UZLU 1 - 2 (ELEMENT IE)  2 - 3 (NAVAZUJICI JE)
      DO IEND=1,2
         I1=IU(IEND)
         I2=IU(MOD(IEND,2)+1)
         COSI=(XXW(I2)-XXW(I1))/RI
         SINI=(YYW(I2)-YYW(I1))/RI
C HLEDANI NAVAZUJICI ELEMENTU V UZLU I2
C Prohledani matice konektivity: vsechny dvouuzlove elementy (s vyjimkou IE), 
C v nichz se vyskytuje uzel I2 (uzel I1 slouzi jen k urceni smeru elementu IE)
         DETMAX=-1e6
         DETMIN=1e6
         AIJMAX=-10.
         AIJMIN=10.
         DO JE=1,NE
          IF(MUE(JE).EQ.2.AND.JE.NE.IE)THEN
            LOCJ=LUE(JE)
            I3=IABS(IUE(LOCJ+1))
            I4=IABS(IUE(LOCJ+2))
            IF(I3.EQ.I2.OR.I4.EQ.I2)THEN
C Element JE navazuje v uzlu I2 na element IE. 
               IF(I3.EQ.I2)I3=I4
               RJ=SQRT((XXW(I3)-XXW(I2))**2+(YYW(I3)-YYW(I2))**2)
               IF(ABS(RJ).LT.1E-10)EXIT
               COSJ=(XXW(I3)-XXW(I2))/RJ
               SINJ=(YYW(I3)-YYW(I2))/RJ
C VYPOCET DVOU PRUSECIKU PARALELNICH PRIMEK (H +-)
C SINIJ=sin(alfaI-alfaJ)
C COSIJ=cos(alfaI-alfaJ)
               SINIJ=-COSI*SINJ+SINI*COSJ
               COSIJ=COSI*COSJ+SINI*SINJ
               AIJ=ASIN(SINIJ)
               IF(COSIJ.LT.0.)THEN
                 IF(AIJ.LE.0.)THEN
                    AIJ=-PI-AIJ
                 ELSE
                    AIJ=PI-AIJ
                 ENDIF
               ENDIF
               IF(AIJ.GT.AIJMAX)THEN
                  DETMAX=SINIJ
                  AIJMAX=AIJ
                  COSMAX=COSJ
                  SINMAX=SINJ
               ENDIF
               IF(AIJ.LE.AIJMIN)THEN
                  DETMIN=SINIJ
                  AIJMIN=AIJ
                  COSMIN=COSJ
                  SINMIN=SINJ
               ENDIF
            ENDIF
          ENDIF
         ENDDO
C
C Probehlo zpracovani vsech elementu. Pokud zadny navazujici element neni,
C je DETMIN>DETMAX, pokud je to primka plati DETMIN=DETMAX=0, 
C jinak se jedna o zmenu smeru.
C V kazdem pripade musime vygenerovat dvojici bodu: T1,T2
C
         IF(ABS(DETMAX).LT.1E-4)THEN
            T1=0
         ELSE
C + H ODPOVIDA HODNOTE DETMAX
            T1=-H*((SINMAX-SINI)*SINMAX-(COSI-COSMAX)*COSMAX)/DETMAX         
         ENDIF
         IF(ABS(DETMIN).LT.1E-4)THEN
            T2=0
         ELSE
C - H ODPOVIDA HODNOTE DETMIN
            T2= H*((SINMIN-SINI)*SINMIN-(COSI-COSMIN)*COSMIN)/DETMIN
         ENDIF
         X(3*IEND-2)=XXR(XXW(I2)+H*SINI+COSI*T1)
         Y(3*IEND-2)=YYR(YYW(I2)-H*COSI+SINI*T1)
         X(3*IEND)=XXR(XXW(I2)-H*SINI+COSI*T2)
         Y(3*IEND)=YYR(YYW(I2)+H*COSI+SINI*T2)
         X(3*IEND-1)=XX(I2)
         Y(3*IEND-1)=YY(I2)
C UZLOVE PARAMETRY ZE ZONY 2
         IF(IDOF.GT.0)THEN
           IF(IZON.LE.0.OR.IZON.GT.4)THEN
              V(IEND)=VAL(LPU(IDOF)+I2,2)
           ELSE
              V(IEND)=VAL(LPU(IDOF)+I2,IZON)
           ENDIF
         ENDIF
      ENDDO
C      CALL GMFPLC(6,X,Y,ICOL)
C VYTONOVANI HODNOTAMI UZLOVEHO PARAMETRU. V(1,2) JSOU VYBRANE UZLOVE HODNOTY.
C ROZKLAD NA 4 TROJUHELNIKY
C 1 2 (1) 6 (2),  2 3 (1) 4 (2),  4 5 (2) 2 (1), 5 6 (2) 2 (1)
      DO IT=1,4
        DO IV=1,3
           XG(IV)=X(ISX(IV,IT))
           YG(IV)=Y(ISX(IV,IT))
           VG(IV)=V(ISV(IV,IT))
        ENDDO
C VYTONOVANI
        CALL GMFCTR(VG,XG,YG,VMIN,VMAX,IVMIN,IVMAX)
      ENDDO
      CALL GMFPLC(6,X,Y,ICOL)
C Dokresleni paralelnich car pro element s paralelnimi trubkami
      IG   =MAX0(1,IGROUP(IE))
      MULTI=JGROUP(IG,$EX1)
      IF(MULTI.GT.1)THEN
         XG(1)=(X(1)+X(2))*.5
         XG(2)=(X(5)+X(6))*.5
         YG(1)=(Y(1)+Y(2))*.5
         YG(2)=(Y(5)+Y(6))*.5
         CALL GMFPL(2,XG,YG,ICOL)
         XG(1)=(X(3)+X(2))*.5
         XG(2)=(X(5)+X(4))*.5
         YG(1)=(Y(3)+Y(2))*.5
         YG(2)=(Y(5)+Y(4))*.5
         CALL GMFPL(2,XG,YG,ICOL)
      ENDIF
C porous EPS <.99
	IR =MAX0(1,IRCONS(IE))
	EPS=RRCONS(IR,$RX1)
	IF(EPS.LT..99.AND.EPS.GT..01)THEN
	  NCC=MAX0(1,IFIX(50*RI/EPS))
	  XA1=(X(2)+X(3))*.5
	  YA1=(Y(2)+Y(3))*.5
	  XB1=(X(4)+X(5))*.5
	  YB1=(Y(4)+Y(5))*.5
	  XA2=(X(2)+X(1))*.5
	  YA2=(Y(2)+Y(1))*.5
	  XB2=(X(6)+X(5))*.5
	  YB2=(Y(6)+Y(5))*.5
	  DO I=1,NCC
	    R=FLOAT(I)/(NCC+1)
          XC1=XA1+(XB1-XA1)*R
	    XC2=XA2+(XB2-XA2)*R
          YC1=YA1+(YB1-YA1)*R
	    YC2=YA2+(YB2-YA2)*R
	    RR=RND(IDUMMY)
	    XC=RR*XC1+(1-RR)*XC2
	    YC=RR*YC1+(1-RR)*YC2
	    CALL GMFMRKS(XC,YC,67)
	  ENDDO
	ENDIF
C heat source nebo DUDY
	IHEAT=JGROUP(IG,$HEAT)
	ELECT=RRCONS(IR,$DUDY)
	IF(IHEAT.NE.0.OR.ELECT.NE.0.)THEN
	  NCC=MAX0(1,IFIX(80*RI))
	  DO I=1,NCC
	    R=FLOAT(I)/(NCC+1)
          XC=X(2)+(X(5)-X(2))*R
          YC=Y(2)+(Y(5)-Y(2))*R
		IF(IHEAT.NE.0) CALL GMFMRKS(XC,YC,33)
		IF(ELECT.NE.0.)CALL GMFMRKS(XC,YC,11)
	  ENDDO
	ENDIF
C Vykresleni teplotni mezni vrstvy BL
	LEBL=MAX0(1,LEPAR($PIPE2D,$EQZ))
	BL=EPAR(IE,LEBL)
	D=RRCONS(IR,$D)/2
      IF(BL.GT.0..AND.D.GT.0..AND.BL.LE.D)THEN
	  RMAX=BL/D
	  DR=RMAX/9
	  DO K=10,1,-1
	    R=(K-1)*DR
	    IF(K.EQ.1)THEN
	      ICLB=0
	    ELSE
	      ICLB=12
	    ENDIF
          XG(1)=X(3)+(X(2)-X(3))*R
          YG(1)=Y(3)+(Y(2)-Y(3))*R
          XG(2)=X(4)+(X(5)-X(4))*R
          YG(2)=Y(4)+(Y(5)-Y(4))*R
          CALL GMFPL(2,XG,YG,ICLB)
          XG(1)=X(1)+(X(2)-X(1))*R
          YG(1)=Y(1)+(Y(2)-Y(1))*R
          XG(2)=X(6)+(X(5)-X(6))*R
          YG(2)=Y(6)+(Y(5)-Y(6))*R
          CALL GMFPL(2,XG,YG,ICLB)
	  ENDDO
	ENDIF
      END

      SUBROUTINE GPIPE3(IE,JAXIS,ICOLOR,LABEL)
C
C PIPE2D vykreslovana jako 3D objekt
C JAXIS=1  kruhova trubka o prumeru D
C JAXIS=2,3,4  obdelnikova trubka s rozmerem A x B urcenych hydraulickym prumerem
C          a plochou prurezu AREA. 
C          J=2 strana A lezi v rovine XY
C          J=3 strana A lezi v rovine YZ
C          J=4 strana A lezi v rovine XZ
C LABEL>0  Label points
C
      INCLUDE '$FEMB'
      INCLUDE '$GMF'
      PARAMETER (NSEGM=22)
      DIMENSION X(2),Y(2),Z(2),ISA(4),ISB(4),
     /          XP1(NSEGM),YP1(NSEGM),
     /          XP2(NSEGM),YP2(NSEGM)
      DATA ISA,ISB/-1,-1,1,1,1,-1,-1,1/
C
      IG   =MAX0(1,IGROUP(IE))
      LRCON=MAX0(1,IRCONS(IE))
      D    =RRCONS(LRCON,$D)
      R    =D/2.
      AREA =RRCONS(LRCON,$AREA)
      NAMEL=JGROUP(IG,$ENAME)
      L0=LUE(IE)
      DO J=1,2
         IU=IABS(IUE(L0+J))
         X(J)=XX(IU)
         Y(J)=YY(IU)
         Z(J)=ZZ(IU)
      ENDDO
      H=SQRT((X(1)-X(2))**2+(Y(1)-Y(2))**2+(Z(1)-Z(2))**2)
      CALL TKEZXYZ(JAXIS,X,Y,Z,0.,0.,0.,XC,YC,ZC)
      CALL ROT(XC,YC,ZC,XCP,YCP,ZCP)
      SELECT CASE(JAXIS)
      CASE(1)
C TRUBKA S KRUHOVYM PRUREZEM O PRUMERU D
          NSEG=NSEGM-1
          FI=0
          DFI=2*PI/(NSEG-1)
          DO I=1,NSEG
            RETA=R*COS(FI)
            RZETA=R*SIN(FI)
            CALL TKEZXYZ(JAXIS,X,Y,Z,0.,RETA,RZETA,XC1,YC1,ZC1)
            CALL TKEZXYZ(JAXIS,X,Y,Z,H ,RETA,RZETA,XC2,YC2,ZC2)
            CALL ROT(XC1,YC1,ZC1,XP1(I),YP1(I),DUMMY1)
            CALL ROT(XC2,YC2,ZC2,XP2(I),YP2(I),DUMMY2)
            XP1(I+1)=XP2(I)
            YP1(I+1)=YP2(I)
            IF(DUMMY1.GE.ZCP)CALL GMFPL(2,XP1(I),YP1(I),ICOLOR)
            FI=FI+DFI
          ENDDO
      CASE(2,3,4)
          CALL RECTAB(D,AREA,A,B)
          AH=A/2.
          BH=B/2.
          NSEG=4
          DO I=1,NSEG
              AHH=AH*ISA(I)
              BHH=BH*ISB(I)
              CALL TKEZXYZ(JAXIS,X,Y,Z,0.,AHH,BHH,XC1,YC1,ZC1)
              CALL TKEZXYZ(JAXIS,X,Y,Z,H ,AHH,BHH,XC2,YC2,ZC2)
              CALL ROT(XC1,YC1,ZC1,XP1(I),YP1(I),DUMMY1)
              CALL ROT(XC2,YC2,ZC2,XP2(I),YP2(I),DUMMY2)
              XP1(I+1)=XP2(I)
              YP1(I+1)=YP2(I)
              CALL GMFPL(2,XP1(I),YP1(I),ICOLOR)
          ENDDO
      ENDSELECT
      CALL GMFPLC(NSEG,XP1,YP1,ICOLOR)
      CALL GMFPLC(NSEG,XP2,YP2,ICOLOR)
      IF(LABEL.GT.0.AND.NSEG.GT.0)
     /        CALL WRITXYZ(XP1(NSEG),YP1(NSEG),XC1,YC1,ZC1)
      END

      SUBROUTINE WRITXYZ(XT,YT,XC,YC,ZC)
C Vypis x,y,z
      INCLUDE '$GMF'
      CHARACTER*27 TEXT
      DX=SNGL((WXMA-WXMI)/6)
      DY=SNGL((WYMA-WYMI)/52)
      X=XT+SNGL((WXMA-WXMI)/150)
      Y=YT+SNGL((WYMA-WYMI)/50)
      CALL GMFREC(X,X+DX,Y,Y-DY,8)
      CALL GMFILL(X+DX/2,Y-DY/2,15,8)
      CALL GMFREC(X,X+DX,Y,Y-DY,15)
      CALL GMFMRK(XT,YT,47)
      WRITE(TEXT,'(3E9.2)')XC,YC,ZC
      CALL GMFFONT(5,10)
      CALL GMFTEXT(X,Y,12,27,TEXT)
      CALL GMFFONT(1,16)
      END

      SUBROUTINE GFND(XC,YC,VALUE,IHEIG)
C
C Vykresleni znacky v bode Xc,Yc (teziste)
C Vykresli se kolecko se segmentem odpovidajicim VALUE
C VALUE    relativni hodnota v intervalu 0,1
C IHEIG    relativni velikost znacky =0 mala, 1-stredni
C
      DIMENSION XG(67),YG(67)
      INCLUDE '$GMF'
C
      DR=0.01*(IHEIG+1)
C Budik v normalizovanych souradnicich
      DO I=1,58
         FI=(I-1)*3.141/29
         XG(I)=DR*SIN(FI)
         YG(I)=DR*COS(FI)
      ENDDO
      XG(59)=XG(1)
      YG(59)=YG(1)
      XG(60)=0
      YG(60)=0
      FI=6.282*VALUE
C Kresleni sipky 63,64,65
      XG(63)=DR*.8*SIN(FI-.1)
	YG(63)=DR*.8*COS(FI-.1)
	XG(64)=DR*SIN(FI)
      YG(64)=DR*COS(FI)
      XG(65)=DR*.8*SIN(FI+.1)
	YG(65)=DR*.8*COS(FI+.1)
	XG(66)=DR*.9*SIN(FI)
	YG(66)=DR*.9*COS(FI)
	XG(67)=XG(63)
	YG(67)=YG(63)
      DO I=1,2
        DR=DR/I
        FI=FI/I
        XG(60+I)=DR*SIN(FI)
        YG(60+I)=DR*COS(FI)
      ENDDO
C Prevod do uzivatelskych souradnic
      DO I=1,67
        XG(I)=XC+XG(I)*(WXMA-WXMI)
        YG(I)=YC+YG(I)*(WYMA-WYMI)*1.2
      ENDDO
      CALL GMFPL(59,XG,YG,8)
      CALL GMFILL(XC,YC,15,8)
      CALL GMFPL(61,XG,YG,0)
C FILL  jen kdyz je FI>0
      IF(FI.GT.0.05)CALL GMFILL(XG(62),YG(62),11,0)
      CALL GMFMRK(XC,YC,56)
	CALL GMFPL(5,XG(63),YG(63),12)
      END

      SUBROUTINE GRAFTC(ICNTR,IGRAF1)
C Vykresleni TC krivek do maleho okna 21.
C ICNTR=0 vsechny krivky
C      =1 jen krivku cislo IGRAF1
C      =2 jen krivky typu IGRAF1 (typ je dan vektorem IQGR())
      INCLUDE '$FEM'
      INCLUDE '$PLT-COM'
      DIMENSION AREA(MAXSEL),TMEAN(MAXSEL)
      CHARACTER*20 LABEL
      IF(NGR.LE.1)RETURN
C Stanoveni meritka
      YMINI=1E10
      YMAXI=-1E10
      TMAXI=0
      DO IGRAF=2,MAXSEL
        IF(ICNTR.EQ.0.OR.(ICNTR.EQ.1.AND.IGRAF.EQ.IGRAF1)
     /               .OR.(ICNTR.EQ.2.AND.IQGR(IGRAF).EQ.IGRAF1))THEN
            AREA(IGRAF)=0
            TMEAN(IGRAF)=0
            DO I=1,NGR
                YYY=YGR(I,IGRAF)
                YMINI=AMIN1(YMINI,YYY)
                YMAXI=AMAX1(YMAXI,YYY)
                TT=YGR(I,1)
                DAREA=YYY*(YGR(MIN0(NGR,I+1),1)-YGR(I,1))
                AREA(IGRAF)=AREA(IGRAF)+DAREA
                TMEAN(IGRAF)=TMEAN(IGRAF)+DAREA*TT
            ENDDO
            IF(ABS(AREA(IGRAF)).GT.1E-5)THEN
                TMEAN(IGRAF)=TMEAN(IGRAF)/AREA(IGRAF)
            ELSE
                TMEAN(IGRAF)=0.
            ENDIF
            TMAXI=AMAX1(TMAXI,1.8*TMEAN(IGRAF))
        ENDIF
      ENDDO
C Aktivace
      YMAXI=YMAXI+0.01*(YMAXI-YMINI)
      IF(TMAXI.GT.0.0.AND.YMINI.LT.YMAXI)THEN
         CALL GMFSTW(2,1,21,4,10,'t','Y',0.,1.,0.,1.,
     /                       0.,TMAXI,YMINI,YMAXI)
         CALL GMFAXE(2,7,15)
         DYLEV=(YMAXI-YMINI)*0.05
	   YLEVEL=YMAXI-DYLEV
         CALL GMFTEXT(0.75*TMAXI,YLEVEL+DYLEV*.5,0,15,'Area      Tmean')
         DO IGRAF=2,MAXSEL
           IF(ICNTR.EQ.0.OR.(ICNTR.EQ.1.AND.IGRAF.EQ.IGRAF1)
     /                  .OR.(ICNTR.EQ.2.AND.IQGR(IGRAF).EQ.IGRAF1))THEN
                CALL GMFPL(NGR,YGR(1,1),YGR(1,IGRAF),IGRAF)
C Vyhledej maximum a oznac bod cislem krivky
                IM=1
                YM=0
                DO I=1,NGR
                  IF(YGR(I,IGRAF).GT.YM)THEN
                     IM=I
                     YM=YGR(I,IGRAF)
                  ENDIF
                ENDDO
	          IF(AREA(IGRAF).GT.0.)THEN              
                   YLEVEL=YLEVEL-DYLEV
                   CALL GMFMRKL(YGR(IM,1),YGR(IM,IGRAF),30,IGRAF,1)
                   CALL GMFMRKL(0.67*TMAXI,YLEVEL,30,IGRAF,1)
                   CALL GMFILL(0.67*TMAXI,YLEVEL,IGRAF,0)
                   WRITE(LABEL,'(2E10.2)')AREA(IGRAF),TMEAN(IGRAF)
                   CALL GMFTEXT(.7*TMAXI,YLEVEL+.5*DYLEV,0,28,LABEL//
     /' '//TTC(IQGR(IGRAF)+1))
	          ENDIF
                TC$=1
           ENDIF
         ENDDO
      ENDIF
      END

      SUBROUTINE GREGR(IYGR)
C Regresni analyza
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEM'
      INCLUDE '$PLT-COM'
      INTEGER*2 IRES,IPREV
      TYPE(RCCOORD)CURPOS
      CHARACTER*80 LINE
      IF(IYGR.LE.0.OR.IYGR.GT.MAXSEL)RETURN
      OPEN(3,FILE='RANNREG.OUT')
      READ(3,*,END=999)
      READ(3,*,END=999,ERR=999)MFIT
      READ(3,*,END=999)
      READ(3,*,END=999,ERR=999)NDATA
      DO I=1,MFIT+NDATA+3
         READ(3,*,END=999)
      ENDDO
      READ(3,*,END=999,ERR=999)XMI,XMA,YMI,YMA
      II=FOCUSQQ(20)
C      II=SETBKCOLOR(8)
      II=SETBKCOLOR(15)
      IPREV=SETTEXTCOLOR(INT2(15))
      CALL CLEARSCREEN($GCLEARSCREEN)
c      IRES=SETTEXTCOLOR(INT2(11))
      CALL GMFSTW(1,1,20,3,16,'X','Y',0.,1.,0.,.89,XMI,XMA,YMI,YMA)
      CALL GMFAXE(1,7,15)
      DO I=1,200
        READ(3,*,END=999,ERR=999)XGR(I),VGR(I)
      ENDDO
      CALL GMFPL(200,XGR,VGR,0)
      REWIND 3
      DO I=1,4
        READ(3,'(A)')LINE
        CALL SETTEXTPOSITION(INT2(I),INT2(1),CURPOS)
	  IF(I.EQ.3.OR.I.EQ.1)THEN
           IRES=SETTEXTCOLOR(INT2(0))
	  ELSE
           IRES=SETTEXTCOLOR(INT2(11))
	  ENDIF
        WRITE(20,'(A)')LINE
      ENDDO
      DO I=1,MFIT+2
        READ(3,*)
      ENDDO
      DO I=1,NDATA
         READ(3,*,ERR=999,END=999)XDUMMY,YDUMMY,YGR(I,IYGR)
         CALL GMFMRKS(XDUMMY,YDUMMY,30)
      ENDDO
999   CLOSE(3)
      IST20=3
      END 

      SUBROUTINE GMFMRGB(X,Y,XMIN,XMAX,YMIN,YMAX,SIZE,ICOLOR)
C Vykresli kolecko RGB barvou ICOLOR
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      PARAMETER (NVERT=33)
      TYPE (WXYCOORD) POLY(NVERT)
      DX=0.25*(XMAX-XMIN)*SIZE
      DY=0.50*(YMAX-YMIN)*SIZE
      FI=0
      DFI=6.2832/(NVERT-1)
      DO I=1,NVERT-1
        POLY(I).WX=X+DX*COS(FI)
        POLY(I).WY=Y+DY*SIN(FI)
        FI=FI+DFI
      ENDDO
      POLY(NVERT)=POLY(1)
      CALL GMFRGB(ICOLOR,IRGB)
      STATUS=SETCOLORRGB(IRGB)
      RESULT=POLYGON_W($GFILLINTERIOR,POLY,NVERT)
      END

      SUBROUTINE GREGR2(IYGR)
C Regresni analyza NLR2
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEM'
      INCLUDE '$PLT-COM'
      INTEGER*2 IRES,IPREV,RETINT
      TYPE(RCCOORD)CURPOS
      CHARACTER*80 LINE
	CHARACTER*1 CH
	IF(IYGR.LE.0.OR.IYGR.GT.MAXSEL)RETURN
      OPEN(3,FILE='RANNREG2.OUT')
      READ(3,*,END=999)
      READ(3,*,END=999,ERR=999)MFIT
      READ(3,*,END=999)
      READ(3,*,END=999,ERR=999)NDATA
      DO I=1,MFIT+NDATA+3
         READ(3,*,END=999)
      ENDDO
      READ(3,*,END=999,ERR=999)XMI1,XMA1,XMI2,XMA2,YMI,YMA
      II=FOCUSQQ(20)
      II=SETBKCOLOR(15)
      IPREV=SETTEXTCOLOR(INT2(15))
      IRES=SETTEXTCOLOR(INT2(11))
C Predikce modelu: 100 bodu-primarni promenna f(x1,x2-const), 10 bodu x2
C Hodnoty X1,X2 nemusime cist, jsou pevne dany rozsahy XMI1,XMI2,...
      DX1=(XMA1-XMI1)/99
      DX2=(XMA2-XMI2)/9
      DO I=1,1000
        READ(3,*,END=999,ERR=999)X1DUMMY,X2DUMMY,VGR(I)
      ENDDO
      IX2=1
	IROT=0
C smycka grafu
	DO WHILE(IX2.NE.12)
        II=SETACTIVEQQ(20)
        CALL CLEARSCREEN($GCLEARSCREEN)
        IF(IX2.GE.1.AND.IX2.LE.10)THEN
C XY graf
          CALL GMFSTW(1,1,20,3,16,'X1','Y',0.,1.,0.,.89,
     /                XMI1,XMA1,YMI,YMA)
          CALL GMFAXE(1,7,15)
          CALL GMFPLD(XMI1,DX1,100,VGR((IX2-1)*100+1),0)
          REWIND 3
          X2=XMI2+DX2*(IX2-1)
          DO I=1,4
            READ(3,'(A)')LINE
            IF(I.EQ.1)WRITE(LINE(52:64),'(''X2='',E10.3)')X2
            CALL SETTEXTPOSITION(INT2(I),INT2(1),CURPOS)
	      IF(I.EQ.3.OR.I.EQ.1)THEN
             IRES=SETTEXTCOLOR(INT2(0))
	      ELSE
             IRES=SETTEXTCOLOR(INT2(11))
	      ENDIF
            WRITE(20,'(A)')LINE
          ENDDO
          DO I=1,MFIT+2
          READ(3,*)
          ENDDO
          DO I=1,NDATA
            READ(3,*,ERR=999,END=999)X1DUMMY,X2DUMMY,YDUMMY,YGR(I,IYGR)
C DIST 0-1
            DIST=ABS((X2-X2DUMMY)/(XMA2-XMI2))
            SIZE=1./(30.+400.*DIST**2)
            ICOLOR=100+DIST*500
            CALL GMFMRGB(X1DUMMY,YDUMMY,XMI1,XMA1,YMI,YMA,SIZE,ICOLOR)
            IF(DIST.LT.0.05)CALL GMFMRK(X1DUMMY,YDUMMY,40)
          ENDDO
        ELSE
C 3D PLOT transformace s natacenim osy x2 kolem vertikalni souradne osy y (osa x1 je vzdy horizontala)
C
C X = x1-alfa x2
C Y = y -beta x2
	    IROT=IROT+1
          YMII=AMIN1(0.,YMI)
	    XMII1=AMIN1(0.,XMI1)            
	    XMII2=AMIN1(0.,XMI2)            
          ALFA=0.5*SIN(IROT*.1+1)*(XMA1-XMII1)/(XMA2-XMII2)
	    BETA=0.5*COS(IROT*.1)*(YMA-YMII)/(XMA2-XMII2)
          XMIW=AMIN1(0.,-ALFA*XMA2)
	    XMAW=XMA1-ALFA*XMI2
		YMIW=AMIN1(0.,YMII-BETA*XMA2)
		YMAW=AMAX1(YMA,YMA-BETA*XMI2)
	    DXW=(XMAW-XMIW)*.15
	    DYW=(YMAW-YMIW)*.15
          CALL GMFSTW(1,1,20,3,16,'X1','Y',0.,1.,0.,1.,
     /                 XMIW-DXW,XMAW+DXW,YMIW-DYW,YMAW+DYW)
	    CALL GMFSW(1)
C Vykresleni souradnicoveho krize X1,X2,Y
          CALL GMFLINE(0.,0.,XMA1,0.,12)
	    CALL GMFTEXT(XMA1,0.,12,2,'X1')
	    CALL GMFLINE(0.,0.,0.,YMA,12)
	    XRMA=-ALFA*XMA2
	    YRMA=-BETA*XMA2
	    CALL GMFLINE(0.,0.,XRMA,YRMA,12)
	    CALL GMFTEXT(XRMA,YRMA,12,2,'X2')
          CALL GMFLINEA(.9*XMA1,0.,XMA1,0.,12)
	    CALL GMFLINEA(0.,.9*YMA,0.,YMA,12)
	    CALL GMFLINEA(.8*XRMA,.8*YRMA,XRMA,YRMA,12)
	    CALL GMFTEXT(0.05*DXW,YMA,12,1,'Y')
C Skutecny rozsah VYKRESLENI OBDELNIKU pro Y=0, 
          X1=XMI1-ALFA*XMI2
	    Y1=-BETA*XMI2
	    X2=XMA1-ALFA*XMI2
	    Y2=Y1
          CALL GMFLINE(X1,Y1,X2,Y1,11)     
          X3=XMA1-ALFA*XMA2
	    Y3=-BETA*XMA2
	    CALL GMFLINE(X2,Y2,X3,Y3,11)  
          X4=XMI1-ALFA*XMA2
	    Y4=Y3
	    CALL GMFLINE(X3,Y3,X4,Y4,11)
          CALL GMFLINE(X4,Y4,X1,Y1,11)
C Vykresleni predikce modelu sit car X2=konst (10) a X1=konst (100 car)
	    DO I2=1,10
            X2=XMI2+(I2-1)*DX2
	      DO I1=1,99
              X1=XMI1+(I1-1)*DX1
              XN1=X1+DX1
              Y=VGR((I2-1)*100+I1)
              YN=VGR((I2-1)*100+I1+1)
             CALL GMFLINE(X1-ALFA*X2,Y-BETA*X2,XN1-ALFA*X2,YN-BETA*X2,0)
            ENDDO
	    ENDDO
	    DO I1=1,100,3
            X1=XMI1+(I1-1)*DX1
	      DO I2=1,9
              X2=XMI2+(I2-1)*DX2
              XN2=X2+DX2
              Y=VGR((I2-1)*100+I1)
              YN=VGR(I2*100+I1)
            CALL GMFLINE(X1-ALFA*X2,Y-BETA*X2,X1-ALFA*XN2,YN-BETA*XN2,0)
            ENDDO
	    ENDDO
C Vykresleni bodu
          REWIND 3
          DO I=1,MFIT+6
            READ(3,*)
          ENDDO
          DO I=1,NDATA
            READ(3,*,ERR=999,END=999)X1,X2,Y,Ymodel
	      X1B=X1-ALFA*X2
	      Y1B=-BETA*X2
	      Y1D=Y-BETA*X2
	      Y1M=YMODEL-BETA*X2
	      CALL GMFLINE(X1B,Y1B,X1B,Y1M,11)
	      CALL GMFLINE(X1B,Y1B,X1B,Y1D,11)
	      CALL GMFMRKS(X1B,Y1D,27)
	      CALL GMFMRKS(X1B,Y1M,37)
	      CALL GMFMRKS(X1B,Y1B,40)
          ENDDO
        ENDIF

        WRITE(10,'('' Select index of X2 (1,...9,A), 3D graph (B,C,...),
     / or quit (Q)'')')
c        READ(10,*,ERR=999)IX2
        CALL GCU(CH,III)
	  IX2=11
	  SELECT CASE(CH)
	  CASE('1')
	     IX2=1
        CASE('2')
	     IX2=2
	  CASE('3')
	     IX2=3
        CASE('4')
	     IX2=4
	  CASE('5')
	     IX2=5
        CASE('6')
	     IX2=6
	  CASE('7')
	     IX2=7
        CASE('8')
	     IX2=8
	  CASE('9')
	     IX2=9
        CASE('A','a')
	     IX2=10
        CASE('B','b')
	     IROT=IROT-2
        CASE('C','c')
	     IROT=IROT+1
        CASE('D','d')
	     IROT=IROT+2
        CASE('F','f')
	     IROT=IROT+3
        CASE('Q','q')
	     IX2=12
        ENDSELECT
      ENDDO
999   CLOSE(3)
      IST20=3
      END 

      SUBROUTINE DETPLO(IDET,ICOL)
C Vykresleni detektoru IDET
      INCLUDE '$FEM'
      INCLUDE '$PLT-COM'
      PARAMETER (NN=20,NNN=21)
      DIMENSION XF(NNN),YF(NNN),XB(NN),YB(NN),XR(NN),YR(NN),
     /          XO(NN),YO(NN),X2(2),Y2(2),Z2(2),XGG(2),YGG(2)
      IF(IDET.GE.1.AND.IDET.LE.MAXDET)THEN
        DO I=1,2
          X2(I)=DETECT(IDET,3*I-2)
          Y2(I)=DETECT(IDET,3*I-1)
          Z2(I)=DETECT(IDET,3*I)
        ENDDO
        R=DETECT(IDET,7)/2
        ANGLE=DETECT(IDET,8)*3.141/180.
        RANGE=DETECT(IDET,9)
        H=SQRT((X2(2)-X2(1))**2+(Y2(2)-Y2(1))**2+(Z2(2)-Z2(1))**2)
        IF(H.EQ.0..OR.R.LE.0.)RETURN
        PSI=0
        DPSI=2.*PI/NN
C Vykresleni krouzku (XF,YF -front, XB,YB-back  XR,YR-kuzel
        DO I=1,NN
          CALL TRZFXYZ(X2,Y2,Z2,R,0.,PSI,X,Y,Z)
          CALL ROT(X,Y,Z,XF(I),YF(I),DUMMY)
          CALL TRZFXYZ(X2,Y2,Z2,R,-H,PSI,X,Y,Z)
          CALL ROT(X,Y,Z,XB(I),YB(I),DUMMY)
          XF(I+1)=XB(I)
          YF(I+1)=YB(I)
          CALL GMFPL(2,XF(I),YF(I),ICOL)
C View angle
          CALL TRZFXYZ(X2,Y2,Z2,RANGE*TAN(ANGLE)+R,RANGE,PSI,X,Y,Z)
          CALL ROT(X,Y,Z,XR(I),YR(I),DUMMY)
C View factor angle
          CALL TRZFXYZ(X2,Y2,Z2,RANGE*2*R/H+R,RANGE,PSI,X,Y,Z)
          CALL ROT(X,Y,Z,XO(I),YO(I),DUMMY)
          PSI=PSI+DPSI
        ENDDO
C spojnice jedne hrany kuzele
        DO I=1,NN,5
          XGG(1)=XF(I)
          YGG(1)=YF(I)
          XGG(2)=XR(I)
          YGG(2)=YR(I)
          CALL GMFPL(2,XGG,YGG,ICOL)
        ENDDO
        XGG(1)=XF(1)
        YGG(1)=YF(1)
        XGG(2)=XO(1)
        YGG(2)=YO(1)
        CALL GMFPL(2,XGG,YGG,13)
C Vykresleni 3 krouzku
        CALL GMFPLC(NN,XF,YF,ICOL)
        CALL GMFPLC(NN,XB,YB,ICOL)
        CALL GMFPLC(NN,XR,YR,ICOL)
        CALL GMFPLC(NN,XO,YO,13)
        CALL ROT(X2(2),Y2(2),Z2(2),XF(1),YF(1),DUMMY)
        CALL GMFMRK(XF(1),YF(1),37)
        DX=X2(1)-X2(2)
        DY=Y2(1)-Y2(2)
        DZ=Z2(1)-Z2(2)
        X2(2)=X2(1)+DX*RANGE/H
        Y2(2)=Y2(1)+DY*RANGE/H
        Z2(2)=Z2(1)+DZ*RANGE/H
C Znacka krouzek na celech detektoru
        DO I=1,2
          CALL ROT(X2(I),Y2(I),Z2(I),XF(I),YF(I),DUMMY)
          CALL GMFMRK(XF(I),YF(I),37)
        ENDDO
        CALL GMFARROW(0,XF,YF,.1,0)
        CALL GMFPL(2,XF,YF,ICOL)
        DT$=ICOL
      ENDIF
      END

      SUBROUTINE DIAGRA(FILE)
C Obrazek ze souboru do napovedneho okna 21
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      CHARACTER*(*) FILE
      II=SETACTIVEQQ(22)
      II=FOCUSQQ(22)
      II=SETBKCOLOR(15)
      CALL CLEARSCREEN($GCLEARSCREEN)
      II=LOADIMAGE('.\FILES\'//FILE,50,10)
      CALL GMFSW(1)
      END

C      SUBROUTINE GPOINT(XMI,XMA,YMI,YMA)
C Vykresleni Gaussovych bodu v trojuhelniku
C      USE MSFLIB
C      DIMENSION X(4),Y(4),F(3),FX(3),FY(3),G1(16),G2(16),WT(16)
C      DIMENSION NG(6)
C      DATA NG/3,4,6,7,12,16/
C      II=FOCUSQQ(20)
C      DX=(XMA-XMI)/6.
C      DY=(YMA-YMI)/2.
C      Y(1)=YMI+DY
C      Y(2)=Y(1)
C      Y(3)=Y(1)+DY*.6
C      DO IT=1,6
C        X(1)=XMI+DX*(IT-.8)
C        X(2)=X(1)+DX*.9
C        X(3)=X(1)*.4+X(2)*.6
C        CALL GMFPLC(3,X,Y,0)
C        CALL TGAUS(NG(IT),NGSS,G1,G2,WT)
C        WS=0
C        DO I=1,NGSS
C          CALL FDFT(3,X,Y,G1(I),G2(I),F,FX,FY,DET)
C          XX=X(1)*F(1)+X(2)*F(2)+X(3)*F(3)
C          YY=Y(1)*F(1)+Y(2)*F(2)+Y(3)*F(3)
C          CALL GMFMRK(XX,YY,40)
C          WS=WS+WT(I)
C        ENDDO
C      ENDDO
C      Y(1)=YMI+DY*.1
C      Y(2)=Y(1)
C      Y(3)=Y(1)+DY*.7
C      Y(4)=Y(3)
C      DX=(XMA-XMI)/4.
C      DO IT=1,4
C        X(1)=XMI+DX*(IT-.8)
C        X(2)=X(1)+DX*.8
C        X(3)=X(2)
C        X(4)=X(1)
C        CALL GMFPLC(4,X,Y,0)
C        CALL QGAUS(IT,NGSS,G1,G2,WT)
C        DO I=1,NGSS
C          XX=(X(1)+X(2))*.5+(X(2)-X(1))*G1(I)*.5
C          YY=(Y(1)+Y(4))*.5+(Y(4)-Y(1))*G2(I)*.5
C          CALL GMFMRK(XX,YY,40)
C        ENDDO
C      ENDDO
C      END
