C $s2-init
      SUBROUTINE INIT
      INCLUDE '$FEMLOC'
C Vynulovani priznaku kresleni entit
      CALL CLEARPLOT
C Ulozeni aktualniho typu analyzy
      KANALSAVE=KANAL
C Kompletni vymazani ciselne casti databaze
c posledni mazana polozka je aktualni natoceni souradneho systemu
      DO I=1,LOCNEXCOM-1
         INTERC(I)=0
      ENDDO
      DO I=1,MAXSEL
         FILEXPERI(I)='            '
      ENDDO
C Default RTD analysis
	ISTATUS=3
      JEPA=1
C Egroup RCgroup MPgroup
      IACT(1:3)=1
C Pt,Cr,Sf numbering
      IACT(6:8)=1
C All elements are groups 1 (EL,RC,MP)
      IGROUP=1
      IRCONS=1
      IMPROP=1
      MGROUP=1
      MMPROP=1
      MRCONS=1
	DO I=1,3
      RRCONS(I,$H)=1.
      RRCONS(I,$D)=0.05
      RRCONS(I,$RA)=1E-4
      RRCONS(I,$RX1)=1.
      RRCONS(I,$RX2)=0.0001
      RRCONS(I,$TE)=200.
      RMPROP(I,$KX)=0.6
      RMPROP(I,$KY)=0.
      RMPROP(I,$KZ)=0.
      RMPROP(I,$CP)=4200.
      RMPROP(I,$RHO)=998.
      RMPROP(I,$KAPPA)=0.04
      RMPROP(I,$E)=2.1E11
      RMPROP(I,$EY)=0
      RMPROP(I,$EZ)=0
      RMPROP(I,$MI)=0.28
      RMPROP(I,$VISC)=0.001
      RMPROP(I,$BETA)=0.5E-3
      RMPROP(I,$DN)=1E-9
      RMPROP(I,$DD)=1E-9
      RMPROP(I,$DA)=1E-9
      RMPROP(I,$ALEX)=12E-6
      RMPROP(I,$HM)=2.4E6
      RMPROP(I,$TM)=100.
	ENDDO
C IALGOR: 
      $IMASS=1
      $IBUOY=0
      $ICONV=1
      $IUPW=1
      $FAST=1
C        7-N-eliminace, 8-N-integrace, 22-iter flow, 23-iter therm
      IALGOR(7)=15
      IALGOR(8)=200
      IALGOR(20+$FLOW)=1
      IALGOR(20+$THER)=1
      IALGOR(17)=1
      $IVIEW=21
C RALGOR:
      $RUPW=1
      $RPENFAKT=1E7
      $REPSPIV=1E-12
      $RTOL=0.0002
      $RBOXRATIO=.3
      $RELFAKT=1.
      $RTHETA=1.
      $RTAUDISP=1.
C Pozadovana presnost
      DO I=11,20
        RALGOR(I)=1E-5
      ENDDO
C 36-lambda up, 37-lambda down, 38-Leveque
      RALGOR(36)=10.
      RALGOR(37)=0.5
      $BL=1.
C kriterium nejmensich ctvercu
      KCOMPAR=2
      CALL SETCOM
      CALL ANASET(KANALSAVE)
      JGROUP(1,$ENAME)=KELEM
      JGROUP(1,$METHOD)=$UVP
      END

      SUBROUTINE SET3D
C Vypocet smerovych sinu a kosinu 3D transformace
C XVIEW,.. souradnice bodu 0,0,1

$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEM'
C NATOCENI
      FIX=GFIX*0.0174533
      FIY=GFIY*0.0174533
      FIZ=GFIZ*0.0174533
      CFIX=COS(FIX)
      CFIY=COS(FIY)
      CFIZ=COS(FIZ)
      SFIX=SIN(FIX)
      SFIY=SIN(FIY)
      SFIZ=SIN(FIZ)
      XVIEW=-CFIX*SFIY*CFIZ+SFIX*SFIZ
      YVIEW=SFIX*CFIZ+CFIX*SFIY*SFIZ
      ZVIEW=CFIY*CFIX
C AXONOMETRIE
      IF(ZEYE.EQ.0..AND.XEYE.EQ.0.)ZEYE=1000.
      REYE=SQRT(XEYE**2+ZEYE**2)
      AEYE=ZEYE/REYE
      BEYE=XEYE/REYE
C NASTAVENI
      CALL GRANGE(1,10,10,XMI,XMA,YMI,YMA)
      CALL GMFSTW(1,1,20,1,16,'X','Y',0.,1.,0.,1.,
     /                 XMI,XMA,YMI,YMA)
C GRAPUT nastavi rozsahy v COMMONu pro aktualni typ grafu (0)
      CALL GRAPUT(1,XMI,XMA,YMI,YMA)
      CALL GMFAXE(1,7,15)
      CALL PLOTAL
      END

      SUBROUTINE AXICON
C Vykresleni souradneho krize
      INCLUDE '$FEM'
      INCLUDE '$PLT-COM'
      DIMENSION X(6),Y(6)
      SC=AMAX1(XMAF-XMIF,YMAF-YMIF,1E-3)*0.15
      CALL ROT(0.,0.,0.,X(1),Y(1),DUMMY)
      CALL ROT(SC,0.,0.,X(2),Y(2),DUMMY)
      X(3)=X(1)
      Y(3)=Y(1)
      CALL ROT(0.,SC,0.,X(4),Y(4),DUMMY)
      X(5)=X(1)
      Y(5)=Y(1)
      CALL ROT(0.,0.,SC,X(6),Y(6),DUMMY)
C Zjisteni zda se kriz vejde do rozsahu os
      SHX=0.
      SHY=0.
      DO I=1,6
         IF(X(I).LT.XMIF)SHX=AMAX1(SHX,XMIF-X(I))
         IF(X(I).GT.XMAF)SHX=AMIN1(SHX,XMAF-X(I))
         IF(Y(I).LT.YMIF)SHY=AMAX1(SHY,YMIF-Y(I))
         IF(Y(I).GT.YMAF)SHY=AMIN1(SHY,YMAF-Y(I))
      ENDDO
      DO I=1,6
         X(I)=X(I)+SHX
         Y(I)=Y(I)+SHY
      ENDDO
      CALL GMFTEXT(X(2),Y(2),13,1,'X')
      CALL GMFTEXT(X(4),Y(4),13,1,'Y')
      CALL GMFTEXT(X(6),Y(6),13,1,'Z')
      CALL GMFPL(6,X,Y,13)
      END

      SUBROUTINE ANASET(KANA)
C
C Tato procedura definuje vyznam sloupcu matic 
C VAL,IPU (pocet sloupcu MDOF, jsou jim prirazeny DOF vektorem JPU)
C KELEM je index typu posledniho definovaneho elementu (1-PIPE2D, 13-FLOW2d)
      INCLUDE '$FEMB'
      KANAL=MIN0(4,KANA)
      SELECT CASE(KANAL)
      CASE(1)
C PIPE
         KELEM=1
         MDOF=15
         JPU(1:MDOF)=(/$TEMP,$PRES,$VOLT,$CN,$CD,$CA,
     /         $UX,$UY,$UZ,$RX,$RY,$RZ,$VX,$VY,$VZ/)
      CASE(2)
C UVP
         KELEM=13
         MDOF=18
         JPU(1:MDOF)=(/$TEMP,$PRES,$VOLT,$CN,$CD,$CA,$VX,$VY,$VZ,
     /          $UX,$UY,$RZ,$PS,$PSX,$PSY,$PSZ,$OMG,$HT/)
      CASE(3)
C PSI
         KELEM=13
         MDOF=17
         JPU(1:MDOF)=(/$TEMP,$OMG,$VOLT,$CN,$CD,$CA,$VX,$VY,$VZ,
     /              $PS,$PSX,$PSY,$PSZ,$OMGX,$OMGY,$OMGZ,$HT/)
      CASE(4)
C FLUENT
         KELEM=1
         MDOF=1
         JPU(1)=$CN
      END SELECT
C Mapovaci funkce parametru uzlu
      DO I=1,MAXTDOF
         LPU(I)=-1
         DO J=1,MDOF
            IF(I.EQ.JPU(J))LPU(I)=(J-1)*MAXND
         ENDDO
      ENDDO
      END

      SUBROUTINE SETCOM
      INCLUDE '$FEMB'
C
C Definice nazvu 
C TDOF   (*8,  MAXTDOF stupne volnosti), 
C TMPROP (*32, MAXNMPROP materialove parametry)
C TRCONS (*32, MAXNRCONS realne konstanty)
C TGROUP (*32, MAXNGROUP Egroup)
C TELEM  (*8,  MAXELEM mazvy elementu)
C TANAL  (*4,  PIPE,UVP,PSI typ analyzy)
C
C Pro jednotlive typy elementu (PIPE2D,...) jsou definovany seznamy 
C relevantnich parametru EGROUP,RCONS,MPROP,EPAR pro dialog a vystupni sestavy:
C NGROUP(ename)  LGROUP(ename,parameter)
C NRCONS(ename)  LRCONS(ename,parameter)
C NMPROP(ename)  LMPROP(ename,parameter)
C NEPAR (ename)  LEPAR (ename,parameter)
C 
      TDOF=(/
     /  'TEMP','UX  ','UY  ','UZ  ','RX  ','RY  ','RZ  ','VOLT',
     /  'VX  ','VY  ','VZ  ','PRES',
     /  'OMG ','PS  ','PSX ','PSY ','PSZ ','OMGX','OMGY','OMGZ',
     /  'CN  ','CD  ','CA  ','HT  ','d25 ','d26 ',
     /  'd27 ','d28 ','d29 ','d30 '/)

      TMPROP=( /'KX-heat conductivity [W/m/K] ',
     /          'CP-heat capacity [J/kg/K]',
     /          'DENSity [kg/m^3]',
     /          'KAPPA-electr. conductivity [S/m]',
     /          'EX-Young''s elast. modulus [Pa]',
     /          'MI-Poisson''s constant [-]',
     /          'VISCosity [Pa.s]',
     /          'BETA-thermal vol.expansion [1/K]',
     /          'DN-diffusion coef. [m^2/s]',
     /          'HN-reaction enthalpy CN [J/kg]',
     /          'AN-frequency factor',
     /          'DD-diffusion coef. [m^2/s]',
     /          'HD-reaction enthalpy CD [J/kg]',
     /          'AD-frequency factor',
     /          'DA-diffusion coef. [m^2/s]',
     /          'HA-reaction enthalpy CA [J/kg]',
     /          'AA-frequency factor',
     /          'Alfa-therm.expansion wall [1/K]',
     /          'TM-melting point [C]',
     /          'HM-enthalpy of melting [J/kg]',
     /          'KAPPAF-el.conduct.of fouling',
     /          'KXF-heat conductiv.of fouling',
     /          'KY-anizotropic heat cond.[W/m/K]',
     /          'KZ-anizotropic heat cond.[W/m/K]',
     /          'EY-anizotrop. elast. modulus [Pa]',
     /          'EZ-anizotrop. elast. modulus [Pa]'/)

      TRCONS =(/'HH[m] -wall thickness',
     /          'DD[m] -diameter',
     /          'PE pressure external [Pa]',
     /          'ALPHA [W/m^2/K]-heat trans.coef.',
     /          'TE   -external temperature [C]',
     /          'AREA [m^2]',
     /          'PERIMeter [m]',
     /          'VOLume internal [m^3]',
     /          'RA   -surface roughness [m]',
     /          'DUDY -intensity of el.field',
     /          'JZ   -moment of inertia',
     /          'ZETA -local resistance',
     /          'PERM -wall permeability',
     /          'KN   -mass transf.coef. CN',
     /          'CEN  -external conc. CN',
     /          'KD   -mass transf.coef. CD',
     /          'CED  -external conc. CD',
     /          'KA   -mass transf.coef. CA',
     /          'CEA  -external conc. CA',
     /          'KE   -external el.conduct',
     /          'UE   -external voltage [V]',
     /          'EPS  -porosity of packed bed',
     /          'Db[m]-diameter of packing particles',
     /          'R3 -aux for PUMP and HEXC',
     /          'R4 -aux.for PUMP and HEXC',
     /          'R5 -aux.for PUMP and HEXC',
     /          'R6 -aux.for PUMP and HEXC',
     /          'R7 -aux.for PUMP and HEXC',
     /          'R8 -aux.for PUMP and HEXC',
     /          'R9 -aux.for PUMP and HEXC'/)

      TGROUP =(/'Element NAME',
     /          'TRANS-static(0) / transient(1)',
     /          'GAUSS-number of Gauss-points',
     /          'AXIS -Cart.(0)/Cylindr.(1)/pipe(2)',
     /          'STRESS-Plane stress(0),strain(1)',
     /          'TYPE or algorithm used',
     /          'HYDRaulic.character.function',
     /          'H-source function',
     /          'H-sink function',
     /          'Cn-source function',
     /          'Cn-sink function',
     /          'Cd-source function',
     /          'Cd-sink function',
     /          'Ca-source function',
     /          'Ca-sink function',
     /          'No.of parallel pipes','aux2','aux3','aux4','aux5'
     /         /)

      TELEM  =(/'PIPE2D  ','PIPE3D  ','TRUSS2D ','TRUSS3D ','BEAM2D  ',
     /          'BEAM3D  ','CSTR    ','PUMP    ','VALVE   ','SHELLAX ',
     /          'HEXC    ','PLANE2D ','FLOW2D  ','FLOW3D  ','USER    ',
     /          'MASS    ','SOLID   ','SPHERE  ','CYLINDER'/)
 
      NGROUP(1:19)=(/13,13,3,3,3,3,12,5,4,2,3,13,13,13,13,13,13,2,2/)
C 1-PIPE2D 2-PIPE3D 3-TRUSS2D 4-TRUSS3D 5-BEAM2D 6-BEAM3D
      LGROUP($PIPE2D,1:13)=(/$ENAME,$ST,$AXIS,$FI,$HEAT,$HSINK,$NSOURCE,
     /       $NSINK,$DSOURCE,$DSINK,$ASOURCE,$ASINK,$EX1/)
      LGROUP($PIPE3D,1:13)=(/$ENAME,$ST,$AXIS,$FI,$HEAT,$HSINK,$NSOURCE,
     /       $NSINK,$DSOURCE,$DSINK,$ASOURCE,$ASINK,$EX1/)
      LGROUP($TRUSS2D,1:3)=(/$ENAME,$ST,$HEAT/)
      LGROUP($TRUSS3D,1:3)=(/$ENAME,$ST,$HEAT/)
      LGROUP($BEAM2D,1:3)=(/$ENAME,$ST,$HEAT/)
      LGROUP($BEAM3D,1:3)=(/$ENAME,$ST,$HEAT/)
C 7-CSTR 8-PUMP 9-VALVE
      LGROUP($CSTR,1:12)=(/$ENAME,$ST,$AXIS,$FI,$HEAT,$HSINK,
     /       $NSOURCE,$NSINK,$DSOURCE,$DSINK,$ASOURCE,$ASINK/)
      LGROUP($PUMP,1:5)=(/$ENAME,$ST,$METHOD,$FI,$HEAT/)
      LGROUP($VALVE,1:4)=(/$ENAME,$ST,$FI,$HEAT/)
C 10-SHELLAX 11-HEXC
      LGROUP($SHELLAX,1:2)=(/$ENAME,$ST/)
      LGROUP($HEXC,1:3)=(/$ENAME,$ST,$METHOD/)
C 12-PLANE2D 13-FLOW2D ... 16-MASS,17-SOLID
      LGROUP($PLANE2D,1:13)=(/$ENAME,$ST,$GAUSS,$AXIS,$STRESS,$HEAT,
     /     $HSINK,$NSOURCE,$NSINK,$DSOURCE,$DSINK,$ASOURCE,$ASINK/)
      DO I=13,17
        LGROUP(I,1:13)=(/$ENAME,$ST,$GAUSS,$AXIS,$METHOD,$HEAT,
     /     $HSINK,$NSOURCE,$NSINK,$DSOURCE,$DSINK,$ASOURCE,$ASINK/)
      ENDDO
C 18-SPHERE 19-CYLINDER
      LGROUP($SPHERE,1:2)=(/$ENAME,$ST/)
      LGROUP($CYLINDER,1:2)=(/$ENAME,$ST/)
C                    1  2  3 4 5 6 7 8 9 10  12...  16
      NRCONS(1:19)=(/19,10,4,4,5,5,8,7,4,2,2,6,6,6,6,6,3,1,2/)
C 1-PIPE2D 2-PIPE3D 3-TRUSS2D 4-TRUSS3D 5-BEAM2D 6-BEAM3D
      LRCONS($PIPE2D,1:19)=(/$D,$RA,$ZETA,$H,$ALFA,$TE,$AREA,$PERIM,
     /    $DUDY,$P,$PERMEAB,$KN,$CEN,$KD,$CED,$KA,$CEA,$RX1,$RX2/)
      LRCONS($PIPE3D,1:10)=(/$D,$RA,$ZETA,$H,$ALFA,$TE,$AREA,$PERIM,
     /                       $DUDY,$P/)
      LRCONS($TRUSS2D,1:4)=(/$ALFA,$TE,$AREA,$PERIM/)
      LRCONS($TRUSS3D,1:4)=(/$ALFA,$TE,$AREA,$PERIM/)
      LRCONS($BEAM2D,1:5)=(/$ALFA,$TE,$AREA,$PERIM,$JZ/)
      LRCONS($BEAM3D,1:5)=(/$ALFA,$TE,$AREA,$PERIM,$JZ/)
C 7-CSTR 8-PUMP 9-VALVE
      LRCONS($CSTR,1:8)=(/$D,$ZETA,$ALFA,$TE,$VOL,$AREA,$PERIM,$P/)
      LRCONS($PUMP,1:7)=(/$P,$ALFA,$TE,$VOL,$AREA,$PERIM,$D/)
      LRCONS($VALVE,1:4)=(/$ZETA,$D,$H,$P/)
C 10-SHELLAX 11-HEXC
      LRCONS($SHELLAX,1:2)=(/$H,$P/)
      LRCONS($HEXC,1:2)=(/$ALFA,$AREA/)
C 12-PLANE2D 13-FLOW2D ... 17-SOLID
      DO I=12,16
        LRCONS(I,1:6)=(/$H,$ALFA,$TE,$DUDY,$KE,$UE/)
      ENDDO
      LRCONS(17,1:3)=(/$ALFA,$TE,$DUDY/)
C 18-SPHERE 19-CYLINDER
      LRCONS($SPHERE,1:1)=(/$D/)
      LRCONS($CYLINDER,1:2)=(/$D,$H/)

      NMPROP(1:19)=(/15,15,6,6,6,6,15,15,15,2,1,21,18,8,8,8,13,6,6/)
      LMPROP($PIPE2D,1:15)=(/$KX,$CP,$RHO,$KAPPA,$E,$MI,$VISC,$BETA,
     /                       $DN,$DD,$DA,$AN,$AD,$AA,$ALEX/)
      LMPROP($PIPE3D,1:15) =(/$KX,$CP,$RHO,$KAPPA,$E,$MI,$VISC,$BETA,
     /                       $DN,$DD,$DA,$AN,$AD,$AA,$ALEX/)
      LMPROP($TRUSS2D,1:6)=(/$KX,$CP,$RHO,$KAPPA,$E,$ALEX/)
      LMPROP($TRUSS3D,1:6)=(/$KX,$CP,$RHO,$KAPPA,$E,$ALEX/)
      LMPROP($BEAM2D,1:6) =(/$KX,$CP,$RHO,$KAPPA,$E,$ALEX/)
      LMPROP($BEAM3D,1:6) =(/$KX,$CP,$RHO,$KAPPA,$E,$ALEX/)
      LMPROP($CSTR,1:15) =(/$KX,$CP,$RHO,$KAPPA,$E,$MI,$VISC,$BETA,
     /                       $DN,$DD,$DA,$AN,$AD,$AA,$ALEX/)
      LMPROP($PUMP,1:15) =(/$KX,$CP,$RHO,$KAPPA,$E,$MI,$VISC,$BETA,
     /                       $DN,$DD,$DA,$AN,$AD,$AA,$ALEX/)
      LMPROP($VALVE,1:15) =(/$KX,$CP,$RHO,$KAPPA,$E,$MI,$VISC,$BETA,
     /                       $DN,$DD,$DA,$AN,$AD,$AA,$ALEX/)
      LMPROP($SHELLAX,1:2)=(/$E,$MI/)
      LMPROP($HEXC,1:1)=(/$KX/)
      LMPROP($PLANE2D,1:21) =(/$KX,$CP,$RHO,$KAPPA,$E,$MI,$ALEX,$TM,$HM,
     /             $DN,$DD,$DA,$AN,$AD,$AA,$KAPPE,$KXE,$KY,$KZ,$EY,$EZ/)
      LMPROP($FLOW2D,1:18)=(/$KX,$CP,$RHO,$KAPPA,$VISC,$BETA,$TM,$HM,
     /                     $DN,$DD,$DA,$AN,$AD,$AA,$KAPPE,$KXE,$KY,$KZ/)
      DO I=14,16
         LMPROP(I,1:8)= (/$KX,$CP,$RHO,$KAPPA,$VISC,$BETA,$DN,$AN/)
      ENDDO
      LMPROP($SOLID,1:13)= (/$KX,$CP,$RHO,$KAPPA,$E,$MI,$ALEX,$DN,$AN,
     /                     $KY,$KZ,$EY,$EZ/)
      LMPROP($SPHERE,1:6)= (/$KX,$CP,$RHO,$KAPPA,$E,$VISC/)
      LMPROP($CYLINDER,1:6)= (/$KX,$CP,$RHO,$KAPPA,$E,$VISC/)

      TANAL=(/'PIPE','UVP ','PSI ','FLUE'/)

      IMARK=(/6,9,8,8,9,8,8,5,9,8,8,3,2,1,19,18,29,28,28,4,4,4,0,
     /           0,0,0,0,0,0,0/)

      TTC =(/'Empty   ','Time    ','FEM     ','Experim.','Xinput  ',
     /       'Youtput ','Regress.','Sigma   ','E-impuls','Rxy     ',
     /       'data    ','data    ','data    ','data    ','data    ',
     /       'data    ','data    ','data    ','data    ','data    '/)

      TEPAR=(/
     /'ENAlpha ','ENBeta  ','EMAlpha ','EMBeta  ','EQZ     ',
     /'EQflow  ','EREynold','ETAUwall','EFOULing','EDISSip ',
     /'ELAVolum','EIIinvar','ETXderiv','ETYderiv','ETZderiv',
     /'ESXX    ','ESYY    ','ESXY-tau','EMISEs  ','EPOWER  ',
     /'ETMEAN  ','E1 pipe ','E2 pipe ','EVXveloc','EVYveloc',
     /'EVZveloc','EALPHA  ','ENUsselt'/)

      TOPER=(/'ELEC','FLOW','THER','CONC','COND','CONA','STAT'/)
      TMETHOD=(/'UVP ','UVPP','MIKE','PENS','MIDE','PSIN','PSBL',
     /          'CREE','PSOM','CARE','CHEV','STUB','HAIR'/)

      VARTXT='_'
      MODPARTXT='_'
C
C -----NOVA SEKCE PARAMETRU ELEMENTU
C                   1  2  3  4  5  6  7  8  9  10 11
      NEPAR(1:19)=(/15,15,15,15,15,15,15,15,15,15,15,
     /              15,15,15,15,15,15,15,15/)
C 1-PIPE2D 2-PIPE3D 3-TRUSS2D 4-TRUSS3D 5-BEAM2D 6-BEAM3D
C 7-CSTR   8-PUMP   9-VALVE  10-SHELLAX 
      DO I=1,10
         JEPAR(I,1:15)=(/$ENALFA,$ENBETA,$EMALFA,$EMBETA,$EQZ,$EMISE,
     /   $EQ,$ERE,$ETAU,$EVX,$EFOUL,$EALPHA,$ETMEAN,$EPOWER,$ENU/)
      ENDDO
C 11-HEXC
      JEPAR(11,1:15)=(/$ENALFA,$ENBETA,$EMALFA,$EMBETA,$EQZ,$EMISE,
     /  $EQ,$ERE,$ETAU,$EALPHA,$EFOUL,$ETMEAN,$EPOWER,$EE1,$EE2/)
C 12-PLANE2D 13-FLOW2D ... 17-SOLID 18-SPHERE 19-CYLINDER
      DO I=12,MAXELEM
         JEPAR(I,1:15)=(/$EDISS,$ELAV,$EII,$EGTX,$EGTY,$EGTZ,
     /          $EVX,$EVY,$EVZ,$ESXX,$ESYY,$ESXY,$EMISE,$EFOUL,$EPOWER/)
      ENDDO
C Mapovaci funkce parametru elementu
      DO K=1,MAXELEM
        DO I=1,MAXTEPAR
           LEPAR(K,I)=-1
           DO J=1,NEPAR(K)
              IF(I.EQ.JEPAR(K,J))LEPAR(K,I)=J
           ENDDO
        ENDDO
      ENDDO
      END

      SUBROUTINE CMD
      INCLUDE '$FEM'
      LOGICAL WESULT
      CHARACTER*(LENLIN) LINE,TXTV
C 
C-----Data pro volani vnejsich programu a interpretovanych modelu
      INQUIRE(FILE='$FEMINA.CMD',EXIST=WESULT)
      IF(WESULT)THEN
         OPEN(91,FILE='$FEMINA.CMD')
         WRITE(*,*)'Setup file $FEMINA.CMD from the current directory'
      ELSE       
         INQUIRE(FILE='.\FILES\$FEMINA.CMD',EXIST=WESULT)
         IF(WESULT)THEN
           OPEN(91,FILE='.\FILES\$FEMINA.CMD')
           WRITE(*,*)'Setup file $FEMINA.CMD from the directory FILES'
         ELSE
           WRITE(*,*)'Unable to find setup file $FEMINA.CMD. Default set
     /tings are used.'
           GOTO 2001
         ENDIF
      ENDIF
      NEXCOM=0
      NMODELS=0
2000  READ(91,'(A)',END=2001)LINE
2003  CALL TUPC(LENLIN,LINE,LINE)
      IF(LINE(1:7).EQ.'\\EXTER')THEN
         READ(91,'(A)',END=2001)LINE
         CALL TUPC(LENLIN,LINE,LINE)
	   WRITE(*,'(5x,''External program called as: '',A)')line(1:90)
         NEXCOM=NEXCOM+1
         CALL SELITE(LINE,0,TXTV,K)
         NEXKWD(NEXCOM)=TRIM(TXTV)
         CALL SELITE(LINE,K,TXTV,K)
         NEXFILE(NEXCOM)=TRIM(ADJUSTL(TXTV))
         NPP=0
2002     READ(91,'(A)',END=2001)LINE
         NPP=NPP+1
         IND=INDEX(LINE,':')
         IF(IND.GT.1)THEN
            NEXPARTXT(NPP,NEXCOM)=LINE(1:IND-1)
            CALL TAKERD(LINE,LENLIN,IND,DEXPAR(NPP,NEXCOM),K)
            NEXPAR(NEXCOM)=NPP
            GOTO 2002
         ELSE
            GOTO 2003
         ENDIF
      ELSEIF(LINE(1:7).EQ.'\\MODEL')THEN
         READ(91,'(A)',END=2001)LINE
         CALL TUPC(LENLIN,LINE,LINE)
         NMODELS=NMODELS+1
         CALL SELITE(LINE,0,TXTV,K)
         MODKWD(NMODELS)=TRIM(TXTV)
         CALL SELITE(LINE,K,TXTV,K)
         MODFILE(NMODELS)=TRIM(ADJUSTL(TXTV))
      ENDIF
      GOTO 2000
2001  CLOSE(91)
      WRITE(*,'(5x,''Number of RTD models:'',I3)')NMODELS
      END
