C FEMINA.for V3.8
C UNITS
C   1  session file *.SES
C   2  session file interpret, UNDO files
C   3  OUT files, binary files, nacteni textu programu MODEL
C   4  MACRO files
C   5  PUMPS.TXT
C   6  RUNBOX.BIN
C   8  record
C   9  *.dbg
C  10  window console
C  11  window status
C  20  window MODEL
C  21  window GRAPH
C  30  window LIST
C  40  window HELP
C     

$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      USE DIALOGM
      USE PEEKAPPMODULE
      INCLUDE '$FEMLOC'
C $GRID je common komunikace s menu callback procedurami
      INCLUDE '$GRID'
	INCLUDE '$WIN'
      INCLUDE '$PLT-COM'
      INCLUDE '$TRANDAT'
	INCLUDE '$RPN'
C NAVIG - jen logicka promenna blokovani CALL HELP kdyz je spustena navigace
	INCLUDE '$NAVIG'
C MAXLIST vypis definovanych funkci a DOF ve stavovem radku
C MAXOPER max.pocet operaci (ELEC,THER,...)
      PARAMETER (MAXLIST=10)
      CHARACTER*1 TLISFUN(MAXLIST),CH
      CHARACTER*8 CLOCKDATE
      CHARACTER*10 CLOCKTIME

	INTEGER(2) NCHPROBLEM,NCHFILE
C CHARACTER*12 STATUS,FILESES
      CHARACTER*20 STATUS,FILESES,LITEM
C LISTFUN - pouziva se pro vytvoreni a zobrazeni indexu definovanych funkci
C TLISFUN   bud T nebo F oznaceni tabulky nebo funkce v seznamu funkci
      DIMENSION LISTFUN(MAXLIST)
      TYPE(XYCOORD)POS
      TYPE(WINDOWCONFIG)SCREEN
      INTEGER*2 IRP,C2
      LOGICAL EXPROG,WESULT,MENUACT

C DOPORUCENI FORA PRO DVOUJADROVE PROCESORY - CAS PRO INICIALIZACI FONTU
      CALL SLEEPQQ(500)
C===================================================================================
C     --nacitani souboru s cestami k pracovnim adresarum--
C     --soubor ma dva radky 1.cesta k uzivatelskym souborum
C     --2.cesta k instalacnim souborum
C      open(110,file='ladeni.txt')
      INQUIRE(FILE='PATH.CFG',EXIST=WESULT)
	IF(WESULT)THEN
	  open(66,file='path.cfg')
C	femina path == executable dir directory
	  read(66,'(a)')filepath
	  close(66)
	ELSE
	  FILEPATH=file$curdrive
	ENDIF

C===================================================================================
      IENDCHECK=99999
      IF(INTERC(MAXEND).NE.99999)THEN
          WRITE(*,'('' Inconsistent databaze.'')')
          STOP
      ELSE
      WRITE(*,'('' COMMON BLOCK IN MEMORY LENGTH='',f10.3,'' Mbytes'')')
     /     MAXEND*4./1E6
      ENDIF
C Vyber souboru dle rozliseni obrazovky
      WESULT=GETWINDOWCONFIG(SCREEN)
	WRITE(*,'('' SCREEN RESOLUTION'',I8,''x'',i8)')
     /SCREEN.NUMXPIXELS,SCREEN.NUMYPIXELS
	SELECT CASE(SCREEN.NUMYPIXELS)
	CASE(1200)
	I=SYSTEM('COPY FILES\$W1200.CFG FILES\$FEMWIN.CFG')
	CASE(1024)
	I=SYSTEM('COPY FILES\$W1024.CFG FILES\$FEMWIN.CFG')
	CASE(960)
	I=SYSTEM('COPY FILES\$W960.CFG FILES\$FEMWIN.CFG')
	CASE(864)
	I=SYSTEM('COPY FILES\$W864.CFG FILES\$FEMWIN.CFG')
	CASE(768)
	I=SYSTEM('COPY FILES\$W768.CFG FILES\$FEMWIN.CFG')
	CASE(600)
	I=SYSTEM('COPY FILES\$W600.CFG FILES\$FEMWIN.CFG')
	ENDSELECT
C Zruseni pracovnich souboru
      ICOUNT=DELFILESQQ('$RUNFEM.OUT')
C Rozsireni nabidky zakladnich menu. 0-inicializace (default RTD menu) PRESUNUTO ZA PROBLEM
C      CALL FEMENU(0)
      
      IDUMMY=ABOUTBOXQQ('FEMINA 3.8 @Zitny 2007\r\rUpdate 16.4.2009 \rCo
     /mpaq Fortran'C)


      NUMFONTS=INITIALIZEFONTS()
	CALL SLEEPQQ(200)
C hodnoty IND,... maji vyznam jen jako default hodnoty pro interaktivni
C zadavani parametru. KANAL=1 vychozi typ analyzy PIPE
      IND=1
      INDC=0
      INDS=0
      IP1=1
      KANAL=1
      ITYP=6
      IDEFILE=7
      IFORMAT=1
      GRIDON=.FALSE.
      LIST=.TRUE.
      IZONE=2
      FILEDAT='*.*'
      STATUS=' '
      ISTATUS=3
C-----Data pro volani vnejsich programu a interpretovanych modelu $FEMINA.CMD
      CALL CMD


C-----Uzivagel muze zakazat cteni souboru nastaveni oken DEFAULT
      write(*,*)
	write(*,*)
     /'You can select several options as soon as there are problems with 
     / compatibility'
      write(*,*)'The option is selected by pressing a [Key]:'
	write(*,*)
	write(*,*)'[ENTER]      full capabilities (adjustable windows, fon
     /ts, keyboard interrupts)'
	write(*,*)'[F] or [f]   standard fonts, fixed windows'
	write(*,*)'[K] or [k]   standard keyboard utilities (you cannot in
     /terrupt running batches)'
	write(*,*)'[M] or [m]   menu suppressed (only console commands ava
     /ilable)'
	write(*,*)'[S] or [s]   simplest, reduced version (menu suppressed
     / and standard fonts)'
	write(*,*)
	write(*,*)'Press a [key]...'
	ikey=INCHARQQ()
	CH=CHAR(IKEY)
	IF(IKEY.EQ.13)THEN
C  ENTER
C-----Open $FEMWIN.CFG for femina windows data
	   nothread=.false.
	   menuact=.true.
         CALL READWIN(1)
	ELSEIF(CH.EQ.'F'.OR.CH.EQ.'f')THEN
	   nothread=.false.
	   menuact=.true.
	   IOLDWOPEN=1   
	ELSEIF(CH.EQ.'M'.OR.CH.EQ.'m')THEN
	   nothread=.TRUE.
	   menuact=.false.
         CALL READWIN(1)
	ELSEIF(CH.EQ.'K'.OR.CH.EQ.'k')THEN
	   nothread=.TRUE.
	   menuact=.true.
         CALL READWIN(1)
	ELSEIF(CH.EQ.'S'.OR.CH.EQ.'s')THEN
	   nothread=.true.
	   menuact=.false.
	   IOLDWOPEN=1   
      ELSE
	   nothread=.false.
	   menuact=.true.
	   IOLDWOPEN=1
      ENDIF

C  
      IF(IOLDWOPEN.EQ.1)THEN       
C Stanoveni velikosti okna
        WESULT=GETWINDOWCONFIG(SCREEN)
        NPX=SCREEN.NUMXPIXELS
        NPY=SCREEN.NUMYPIXELS
        NCOLA=SCREEN.NUMTEXTCOLS
        NROWA=SCREEN.NUMTEXTROWS
        nrow(10)=0.2*NROWA
        nrow(11)=3
        nrow(20)=int2(0.65*NROWA)
        nrow(30)=0.32*NROWA
        nrow(21)=0.42*NROWA
        nrow(22)=0.42*NROWA
        nrow(40)=0.21*NROWA
        MAXTROWS=nrow(22)
        ncol(10)=0.75*NCOLA
        ncol(11)=ncol(10)
        ncol(20)=ncol(10)
        ncol(30)=0.34*NCOLA
        ncol(21)=ncol(30)
        ncol(22)=ncol(30)
        ncol(40)=ncol(30)-1
        ixpos(10)=0
        ixpos(11)=0
        ixpos(20)=0
        ixpos(21)=0.66*NCOLA
        ixpos(22)=IXPOS(21)
        ixpos(30)=IXPOS(21)
        ixpos(40)=IXPOS(21)
        iypos(10)=0.74*NROWA
        iypos(11)=0.68*NROWA
        iypos(20)=0
        iypos(21)=0.305*NROWA
        iypos(22)=iypos(21)
        iypos(30)=0
        iypos(40)=0.68*NROWA
        ixpix(10)=0.65*NPX
        ixpix(11)=IXPIX(10)
        ixpix(20)=IXPIX(10)
        ixpix(21)=0.34*NPX
        ixpix(22)=ixpix(21)
        ixpix(30)=ixpix(21)
        ixpix(40)=NPX
        iypix(10)=0.158*NPY
        iypix(11)=0.050*NPY
        iypix(20)=0.65*NPY
        iypix(21)=0.35*NPY
        iypix(22)=iypix(21)
        iypix(30)=0.28*NPY
        iypix(40)=NPY
	  labela(20)='Model or MOP'C
	  labela(10)='Console F2-variables, F3-session, F4-help'C
	  labela(30)='List active DBG file'C
	  ifontph(20)=2
	  ihfontph(20)=16
	  ifontph(10)=2
	  ihfontph(10)=16
	  icursor(10)=0
      ENDIF
c       
C-----------------------------
C Aktivace WIN
      CALL WFULL
C Nastaveni pole indexu oteviranychj oken
      unitas(1:7) = (/10,11,20,30,22,21,40/)
      DO I=1,7
         UNITA=unitas(i)
         CALL WOPENH(unita,labela(unita),ixpos(unita),iypos(unita),
     / ixpix(unita),iypix(unita),nrow(unita),ncol(unita),
     / ifontph(unita),ihfontph(unita),icursor(unita),
     / fontphattr(unita),
     / icfR(unita),icfG(unita),icfB(unita),
     / icbR(unita),icbG(unita),icbB(unita),ioldwopen)
         IF(unita.EQ.30)THEN 
            MAXTROWS=nrow(unita)
            NBCK=MAXTROWS+1
         ENDIF
         CALL CLEARSCREEN($GCLEARSCREEN)
      ENDDO

      WRITE(11,'(''   This window serves for actuall info. Use S to sele
     /ct required kind of information'')')
      II=FOCUSQQ(40)
      CALL HELP
C
C Pripad volani FEMINY z jineho programu, napr. FEMINA.EXE PROGRAM THOLE3GEO
C Argumenty zjistuje procedura call GETARG(1,problem,nchprog)
      CALL GETARG(INT2(1),PROBLEM,NCHPROBLEM)
	CALL GETARG(INT2(2),FILENAM,NCHFILE)
	IF(NCHFILE.LE.0)FILENAM='DEFAULT'                             
C
      IF(NCHPROBLEM.LE.0)THEN
C Initialise default analysis, open session file and draw axis
      II=FOCUSQQ(10)
      II=SETTEXTCOLOR(int2(11))
	WRITE(10,'('' FEMINA requires 1280x1024 screen resolution. Use SET
     /WIN to change position of windows.''/'' Default menu bar is for RT
     /D processing. Use STATUS to add the FEM analysis menu.'')')
      WRITE(10,'('' PROBLEM (MAX.8 CHARACTERS)>            ''\)')
      II=SETTEXTCOLOR(int2(15))
      READ(10,'(A)')PROBLEM
	ENDIF
	IF(LEN(TRIM(PROBLEM)).EQ.0)PROBLEM='TEST'

C Rozsireni nabidky zakladnich menu. 0-inicializace (default RTD menu)
      IF(.NOT.NOTHREAD)THEN
C-----START GETCHAR THREAD
	  CALL PEEKSTART(10)
      ENDIF
	IF(MENUACT)  CALL FEMENU(0)

C ----------------------------

1000  CALL INIT
C nulovani poctu uzivatelskych promennych a konstant funkci
      NCONST=0
      NVARTOT=NVARSYS
      CALL HELP
      CLOSE(1)
      CLOSE(2)
      CLOSE(3)
	CLOSE(4)
C	CLOSE(5)
	CLOSE(6)
	CLOSE(7)
      CLOSE(8)
      CLOSE(9)
	CLOSE(29)
	CLOSE(35)
	CLOSE(36)
	CLOSE(39)
	CLOSE(66)
	CLOSE(88)
	CLOSE(99)
      RECORW=.FALSE.
      READFI=.FALSE.
      READMA=.FALSE.
C Vypis informaci o elementech v okne 21
      CALL INFO21(MAXTROWS)
C
      II=SETACTIVEQQ(20)
C This file 9 is only for debugging and LIST window
      OPEN(9,FILE=TRIM(PROBLEM)//'.DBG',BLOCKSIZE=15000)
      CALL DATE_AND_TIME(CLOCKDATE,CLOCKTIME)
      WRITE(9,'('' Opening '',A,'' date:'',A,''.'',A,''.'',A,'' at '',A,
     /'':'',A)')TRIM(PROBLEM),
     /          CLOCKDATE(7:8),CLOCKDATE(5:6),CLOCKDATE(3:4),
     /          CLOCKTIME(1:2),CLOCKTIME(3:4)
      CALL GMFSTW(2,0,21,5,8,'X (or symmetry)','Y (or radius)',
     /0.,1.,0.,1.,0.,1.,0.,1.)
      CALL GMFSTW(1,1,20,1,16,'X (or axis)','Y (or radius)',
     /.0,1.,0.,1.,-0.05,1.05,-0.05,1.05)
C SET SCALE  I=1 FEM, =2 RTD
      DO I=1,2
        CALL GRAPUT(I,-0.05,1.05,-0.05,1.05)
      ENDDO
C STATUS WINDOW 20 1-FEM
      IST20=ISTATUS
      CALL GMFAXE(1,7,15)
      CALL SET3D
      ISTOLD=0
C Session file
      FILESES=TRIM(PROBLEM)//'.SES'
      INQUIRE(FILE=FILESES,EXIST=WESULT)
      OPEN(1,FILE=FILESES)
      IF(WESULT)THEN
         WRITE(10,'('' Session file '',A,'' exists. If you want to OPEN 
     /it as an old problem press [Y].'')')TRIM(FILESES)
         CALL GCU(CH,IEND)
         IF(CH.EQ.'Y'.OR.CH.EQ.'y')CALL COMFIL(1,1,.FALSE.)
      ENDIF
      WRITE(1,'(''C* Opening '',A,'' date:'',A,''.'',A,''.'',A, 
     /'' at '',A,'':'',A)')TRIM(PROBLEM),
     /                  CLOCKDATE(7:8),CLOCKDATE(5:6),CLOCKDATE(3:4),
     /                  CLOCKTIME(1:2),CLOCKTIME(3:4)

C--------------- Nekonecna smycka zpracovani PRIKAZU
C  Navesti 51 je zacatek sekce, kam se skace pri zjisteni chyby, nebo po ukonceni makra.
C  

51    READMA=.FALSE.
	MENU=.FALSE.
	IFISTEP=0
      CLOSE(4)


C DO WHILE je smycka opakovani prikazu az do EXIT nebo preruseni rezimu macro.
C Provadi se tyto akce:
C 1. aktualizuje se okno stavoveho radku 11.
C 2. aktualizuje se okno LIST (vypis poslednich radku souboru DBG)
C       Vyjimecny pripad NCHFILE>0 znamena, ze FEMINA se spoustela jako davka s urcenym jmenem souboru prikazu.
C       Pak se provede zpracovani tohoto souboru procedurou COMFIL a vypocet konci (STOP).
C 3. precte se text prikazu LINE. Bud ze souboru (READM=.TRUE.) nebo editaci z konzole.
C 4. Text LINE se analyzuje procedurou PROCOM. Ta zjisti KEYW a dekoduje LAST parametru.

52    DO WHILE(KEYW(1:4).NE.'EXIT')
C Zobrazeni aktualnich informaci ve stavovem radku (UNIT=11)
C        INQUIRE(UNIT=1,NAME=FILESES)
c      write(110,*)' label 52 menu=',menu,' keyw=',keyw(1:4)
        CALL FINQUIRE(1,FILESES)
        IF(FILESES.NE.STATUS)THEN
           STATUS=FILESES
C           CLOSE(11)
       unita =11
       CALL WOPENH(unita,'Session file ['//STATUS//']'C,
     /     ixpos(unita),iypos(unita),
     /     ixpix(unita),iypix(unita),nrow(unita),ncol(unita),
     /     ifontph(unita),ihfontph(unita),icursor(unita),
     /     fontphattr(unita),
     /     icfR(unita),icfG(unita),icfB(unita),
     /     icbR(unita),icbG(unita),icbB(unita),ioldwopen)
           ISTOLD=0
        ENDIF
        IF(ISTOLD.NE.ISTATUS)THEN
           II=FOCUSQQ(11)
           IF(ISTATUS.EQ.1)THEN
              II=SETBKCOLOR(3)
           ELSEIF(ISTATUS.EQ.2)THEN
              II=SETBKCOLOR(12)
           ELSE
              II=SETBKCOLOR(1)
	        ISTATUS=3
           ENDIF
           CALL CLEARSCREEN($GCLEARSCREEN)
C ISTATUS=1,2,3 V ZONE COMMON
	     ISTATC=ISTATUS
	     IF(MENUACT)CALL FEMENU(ISTATC)
	     IF(ISTOLD.EQ.1.AND.ISTATUS.GE.2. OR. 
     /        ISTOLD.GE.2.AND.ISTATUS.EQ.1)CALL INFO21(MAXTROWS)
           ISTOLD=ISTATUS
        ENDIF
C Obsah okna 11 zavisi na ISTATUS (=1 FEM, =2 MODEL, =3 RTD)
      SELECT CASE(ISTATUS)
      CASE(1)
CSTATUS FEM Seznam definovanych funkci
        NDEFUN=0
        DO I=MIFUN,MAFUN
          IF(INDFUN(I).NE.0)THEN
            NDEFUN=MIN0(7,NDEFUN+1)
            LISTFUN(NDEFUN)=I
            IF(INDFUN(I).GT.0)THEN
               TLISFUN(NDEFUN)='F'
            ELSE
               TLISFUN(NDEFUN)='T'
            ENDIF
          ENDIF
        ENDDO
        IF(NDEFUN.GT.3)THEN
          WRITE(11,48)NE,ND,KGROUP,KRCONS,KMPROP,TIME,
     /             (LISTFUN(I),TLISFUN(I),I=1,NDEFUN)
48        FORMAT(' NE=',I4,' ND=',I4,' EG=',I2,' RC=',I2,' MP=',I2,
     /           ' time=',E8.2,' Funct:',7(I3,A1))
        ELSE
          WRITE(11,448)NE,ND,KGROUP,KRCONS,KMPROP,TIME,
     /             (LISTFUN(I),TLISFUN(I),I=1,NDEFUN)
448       FORMAT(' NE=',I4,' ND=',I4,' Active groups: EG=',I2,' RC=',I2,
     /           ' MP=',I2,' time=',E8.2,' Funct:',3(I3,A1))
        ENDIF
        IF(KANAL.GT.0)WRITE(11,47)TANAL(KANAL),
     /          (TRIM(TDOF(JPU(I))),I=1,MDOF)
47      FORMAT(1X,A4,': ',17(A,','),A)
      CASE(2)
CSTATUS MODEL
        LL=MIN0(LINESRPN(2),LEN(MODTXT))
        IF(LL.GT.0)THEN
            WRITE(11,46)NEQUAT,METHOD,NTSTEP,DTIME,NINPUTS,NOUTPUTS,
     /                  NUMODP,SCOMPAR
46          FORMAT(' Neq=',I3,' Meth[',I2,']  Step=',i4,' Dt=',E9.2,
     /             ' Ninp=',i2,' Nout=',i2,' Np=',i2,' Scompar=',E9.3)
            WRITE(11,49)MODTXT(1:LL)
49          FORMAT(1X,A)
        ELSE
            WRITE(11,45)NTSTEP,DTIME
45          FORMAT(' No. of steps=',i4,' Dt=',E10.3,' [s]'/' model is no
     /t defined')
        ENDIF
      CASE(3)
CSTATUS RTD
        WRITE(11,44)NTSTEP,DTIME,NGR
44      FORMAT(' No. of steps=',i4,'  Dt=',E10.3, '[s]'/' MOP-number of 
     /rows (variable NT)=',i4)
        CALL SHOWTC(11)
      END SELECT

C WINDOW 30-LIST vypis poslednich 10 radku ze souboru 9 (*.dbg)

        II=FOCUSQQ(30)
        CALL CLEARSCREEN($GCLEARSCREEN)
        INDX=SETFONT('t''Courier''h14f')
        IF(LIST)THEN
           REWIND 9
           NDBG=0
61         READ(9,*,END=62,ERR=62)
           NDBG=NDBG+1
           GOTO 61
62         BACKSPACE 9
           NFIRST=NDBG-NBCK
        ENDIF
        LIST=.TRUE.
        REWIND 9
        NWRIT=0
        DO I=1,NDBG
           READ(9,'(A)',END=63)LINE
           IF(I.GE.NFIRST.AND.NWRIT.LE.NBCK)THEN
              NWRIT=NWRIT+1
              IRP=NWRIT*11
              CALL MOVETO(0,IRP,POS)
              C2=SETCOLOR(INT2(11))
              IF(I.LE.999)THEN
                 WRITE(LABEL,'(I3)')I
                 CALL OUTGTEXT(LABEL(1:3))
              ELSE
                 WRITE(LABEL,'(I4)')I
                 CALL OUTGTEXT(LABEL(1:4))
              ENDIF
              CALL MOVETO(INT2(20),IRP,POS)
              C2=SETCOLOR(INT2(15))
              CALL OUTGTEXT(LINE)
           ENDIF
        ENDDO
63      CALL MOVETO(0,0,POS)
        WRITE(LABEL,'(I4)')NDBG
        C2=SETCOLOR(INT2(11))
        CALL OUTGTEXT('There are '//LABEL(1:4)//' lines in DBG file')

	  
C Editace nebo precteni prikazoveho radku
C Okna 21 - VIEW (results), 22 - DIALOG se fyzicky prekryvaji. Normalne
C zobrazime v popredi okno 21, pouze vyjimecne (kdyz je IAUX(10)>0 zobrazime
C okno cislo 22.
        MENU=.FALSE.
        IF(IAUX(10).EQ.0)THEN
           II=FOCUSQQ(21)
        ELSE
           II=FOCUSQQ(22)
           IAUX(10)=0
        ENDIF
        IF(READMA)THEN
c	     write(110,*)' readma before readline. menu=',menu
409        READ(4,'(A)',END=51,ERR=51)LINE
           IF(LEN(TRIM(LINE)).EQ.0)GOTO 409
c	     write(110,*)' readma after. menu=',menu,' line=',line(1:9)
           CALL TUPC(1,LINE,LINE)
           II=FOCUSQQ(10)
           II=SETTEXTCOLOR(int2(11))
           WRITE(10,'('' MACRO>''\)')
           II=SETTEXTCOLOR(int2(15))
           IF(LINE(1:2).NE.'R*')WRITE(10,'(A)')TRIM(LINE)
C Step by step
	     IF(IFISTEP.NE.0)THEN
              II=SETTEXTCOLOR(int2(12))
              WRITE(10,'('' Enter(step),Space(run),I(insert),N(next),R(r
     /epeat previous),Esc(quit macro)'')')
              CALL GCU(CH,IEND)
	        IF(IEND.EQ.227)THEN
	           GOTO 51
              ELSEIF(CH.EQ.' ')THEN
	           IFISTEP=0
              ELSEIF(CH.EQ.'I'.OR.CH.EQ.'i')THEN
	           LINE(1:30)='I*  write a command           '
			   BACKSPACE 4
              ELSEIF(CH.EQ.'R'.OR.CH.EQ.'r')THEN
                 BACKSPACE 4
                 BACKSPACE 4
                 GOTO 409
              ELSEIF(CH.EQ.'N'.OR.CH.EQ.'n')THEN
	           GOTO 409
              ENDIF
	     ENDIF
           SELECT CASE(LINE(1:2))
           CASE ('C*')
              GOTO 409
           CASE ('Q*')
              GOTO 51
           CASE ('I*')
              II=SETTEXTCOLOR(int2(12))
              WRITE(10,'('' INPUT from keyboard ['',A,''] (use [Tab])'')
     /')TRIM(LINE)
              II=SETTEXTCOLOR(int2(11))
              WRITE(10,'('' >''\)')
              II=SETTEXTCOLOR(int2(15))
C GMFEDLC(0,..   nic se needituje, ale radek se ulozi do seznamu poslednich prikazu
              CALL GMFEDLC(0,TRIM(LINE),IEND)
              CALL GMFEDLC(10,LINE,IEND)
              IF(IEND.NE.0)GOTO 51
           CASE ('R*')
              II=SETTEXTCOLOR(int2(12))
              WRITE(10,'('' [Enter]-next, [Esc]-quit macro, [F1]-repeat 
     /'',A)')LINE(4:47)
              II=SETTEXTCOLOR(int2(15))
              CALL GCU(CH,IEND)
              IF(IEND.GE.259.AND.IEND.LE.266)THEN
C  Repeat 
                 BACKSPACE 4
                 BACKSPACE 4
                 GOTO 409
              ELSEIF(IEND.EQ.227)THEN
C  Enter
                 GOTO 51
              ENDIF
           END SELECT
        ELSEIF(NCHFILE.GT.0)THEN
C
C BATCH spousteny primo z prikazove radky FEMINY. Pak FEMINA konci
C
            IFISTEP=0
            CALL FOPEN(2,FILENAM)
C Interpretace prikazu na UNIT=2. Treti parametr (.TRUE.) znamena, ze se
C budou identifikovat navesti, soucasne kopirovat radky do souboru 1 (druhy
C parametr) a pak teprve probehne zpracovani vsech prikazu
C (vcetne cyklu). Soubor zustava otevreny a je mozne ho doplnovat.
            CALL COMFIL(2,1,.TRUE.)
	      STOP
	  ELSE
           II=FOCUSQQ(10)
           II=SETTEXTCOLOR(int2(11))
           WRITE(10,'('' >''\)')
           II=SETTEXTCOLOR(int2(15))
	     IF(MENUACT)CALL FEMENA
	     CALL GMFEDLC(10,LINE,IEND)
C Aktivace/deaktivace polozek menu
	     IF(MENUACT)CALL FEMENA
	     DO WHILE(MENU)
	        II=FOCUSQQ(10)
              II=SETTEXTCOLOR(int2(13))
              WRITE(10,'('' commands resumed>''\)')
              II=SETTEXTCOLOR(int2(15))
	        MENU=.FALSE.
C	        CALL USERPUTCHAR(CHAR(27))
	        IF(.NOT.READMA)THEN
			     CALL GMFEDLC(10,line,iend)
	        ELSE
	             GOTO 52
	        ENDIF
	     ENDDO
           IF(IEND.NE.0)THEN
	        IF(READMA)THEN
	           GOTO 52
	        ELSE
		       GOTO 51
	        ENDIF
	     ENDIF
        ENDIF
	
        CALL PROCOM(LINE)
        IF(.NOT.NAVIG)CALL HELP
C
C Zpracovani prikazu probiha nasledovne: 
C 1. byla prectena radka LINE a ta se zpracuje procedurou PROCOM	
C    ktera vygeneruje KEYW a vektory parametru IP,RP,TP (prvnich LAST parametru).
C    Vysledkem jsou promenne LAST,ISEMI index posledniho parametru radky a pozice stredniku
C 2. pak obvykle nasleduje DIAP, ktera doplnuje dalsi parametry IP,RP,TP bud interaktivne
C    nebo z dialogu (polozkou LAST+1 pocinaje a NPAR konce).
C 3. Pak jsou dve moznosti: bud se primo pouziji parametry IP,RP,TP (grafika),
C    nebo jsou parametry IP,RP ignorovany a z polozek TP se vytvori jediny uplny prikazovy
C    radek (WRITEL), ktery se zapise do session filu a predevsim preda procedure OPERAT, 
C    ktera si pak znovu tento text analyzuje (rekonstruuje IP,RP,TP).
C V pripade, ze KEYW='FILE' provede se davkove zpracovani procedurou COMFIL, neaktivuje se
C DIAP a neexistuji tudiz default hodnoty parametru!!! Tzn., ze napr. EGROUP 1,PIPE2D; je v tomto tvaru
C predlozen procedure OPERAT, ktera priradi hodnoty IP(1)=1, IP(2)=kod PIPE2D , IP(3)=...=0
C tj. vsechny ostatni EGROUP parametry skupiny 1 typu PIPE2D se vynuluji. Strednik tedy neznamena, ze 
C budou puvodni parametry zachovany. Totez plati i pro prikazy interpretovane jako makro! Je treba si
C uvedomit, jakym zpusobem prirazuje DIAG defaultni parametry - jen tehdy, kdyz od pocatku
C je vse zadavano interaktivne (tj.LAST=0), pri druhem nebo tretim kroku (ISELSTEP) se provede prirazeni
C celeho bloku promennych, ktere se budou v nasledujicich krocich zadavat. 
C
C======================================================================================
C COMMANDS
	
        SELECT CASE(KEYW)

CASES CONTROL-------------------------------------
        CASE('N     ','NEWPRO','NEW   ','RESET ','START ')
           WRITE(10,'('' Close old '',A,''.SES and open a new session fi
     /le'')')TRIM(PROBLEM)
           CALL DIAP(1,'FILE',IEND)
           IF(IEND.EQ.0)THEN
              PROBLEM=TRIM(TP(1))
              CALL DIAP(1,'ANALYS',IEND)
              CALL WRITEL('ANALYS')
              GOTO 1000
           ENDIF
        CASE('SETWIN')
	     CALL RSETWIN(WESULT)
        CASE('CMD   ')
	     CALL RCMD(WESULT)
        CASE('INIFEM')
	     CALL RINIFEM(WESULT)
        CASE('TRANSE')
	     CALL RTRANSE(WESULT)
        CASE('DISPC')
	     CALL RDISPC(WESULT)
        CASE('F     ')
	     CALL RFI (WESULT)
        CASE('FILE  ','FDLG  ')
           CALL RFILE(WESULT)
        CASE('OPEN  ')
           CALL DIAP(4,'OPEN',IEND)
           IF(IEND.EQ.0)THEN
              CALL WRITEL('OPEN')
              IAUX(10)=1
           ENDIF
        CASE('MOP   ','MOPEN ')
	     CALL ROPEN(WESULT)
	  CASE('MOR   ','MORUN ')
	     CALL RMOR(WESULT)
        CASE('CLOSE ')
	     CALL RCLOSE(WESULT)
        CASE( 'UNDO  ','BACK  ','ZPET  ')
	     CALL RUNDO(WESULT)
        CASE('SAVE  ')
           CALL RSAVE(WESULT)
        CASE('M     ')
	     CALL RMAC(WESULT)
        CASE('MACRO ')
	     CALL RMACRO(WESULT)
        CASE('RECORD','REC   ')
	     CALL RRECORD(WESULT)
        CASE('ENDREC')
	     CALL RENDREC(WESULT)
        CASE('#GOTO ')
           CALL WRITEL('#GOTO')
        CASE('#LABEL')
           CALL WRITEL('#LABEL')
        CASE('#LOOP ')
           CALL WRITEL('#LOOP')
        CASE('#IF   ')
           CALL WRITEL('#IF')
        CASE('#ELSE ')
           CALL WRITEL('#ELSE')
        CASE('#ENDIF')
           CALL WRITEL('#ENDIF')
        CASE('U     ')
CONTROL UP n-lines
           CALL DIAP(1,'LINE',IEND)
           IF(IEND.EQ.0)THEN
              LIST=.FALSE.
              NFIRST=MAX0(1,NFIRST-IP(1))
           ENDIF
        CASE('PU    ','PGUP  ')
CONTROL PAGE UP
           LIST=.FALSE.
           NFIRST=MAX0(1,NFIRST-15)
        CASE('D     ')
CONTROL DOWN n-lines
           CALL DIAP(1,'LINE',IEND)
           IF(IEND.EQ.0)THEN
              LIST=.FALSE.
              NFIRST=MIN0(NDBG,NFIRST+IP(1))
           ENDIF
        CASE('PD    ','PGDN  ')
CONTROL PAGE DOWN
           LIST=.FALSE.
           NFIRST=MIN0(NDBG,NFIRST+15)
        CASE('REM   ')
           WRITE(9,'(10(1X,A))')(TRIM(TP(I)),I=1,LAST)
        CASE('H     ','HELP  ','?     ')
           CALL HELPC(2,TP(1))
        CASE('SEARCH')
           CALL HELPC(3,TP(1))
        CASE('S     ','STATUS','SHOW  ')
	     CALL RSTATUS(WESULT)
        CASE('L     ','LOC   ','WHERE ','VAR   ','VARIAB')
CONTROL LLL - pozice promenne TP(1), JJJ - typ (1-real, 2-integer)
           CALL LOVARI(ICRPN,NRPN,LLL,JJJ)
           IF(JJJ.EQ.1)THEN
              WRITE(9,'(1X,A,'' position='',i10,'' value='',e10.3)')
     /              TRIM(TP(1)),LLL,REALRC(LLL)
           ELSEIF(JJJ.EQ.2)THEN
              WRITE(9,'(1X,A,'' position='',i10,'' value='',I10)')
     /              TRIM(TP(1)),LLL,INTERC(LLL)
           ELSE
              WRITE(9,'(1X,A,'' is not a correct expression'')')
     /              TRIM(TP(1))
           ENDIF
           IF(JJJ.GT.0)THEN
              CALL FEMHELP(LLL,TXTV,IENDH)
              IF(IENDH.GT.0)WRITE(9,'('' :'',A)')TRIM(TXTV)
           ENDIF
        CASE('VALUE ','ASSIGN')
C VALUE TEXT VYRAZ             ..... PREVAZNE PRO ZPRACOVANI MAKREM
           WRITE(10,'('' Specify value '',A,''=      ''\)')TRIM(TP(1))
           WRITE(1,'(''VALUE '',A)')TRIM(TP(1))
           CALL LOVARI(ICRPN,NRPN,LLL,JJJ)
           IF(LLL.GT.0.AND.LLL.LE.MAXEND.AND.JJJ.GT.0)THEN
	        CALL GMFEDLC(10,LITEM,IENDC)
              IF(JJJ.EQ.1)THEN
C                 READ(10,*,ERR=51)REALRC(LLL)
                 READ(LITEM,*,ERR=51,END=51)REALRC(LLL)
               ELSE
C                 READ(10,*,ERR=51)INTERC(LLL)
                 READ(LITEM,*,ERR=51,END=51)INTERC(LLL)
               ENDIF
           ENDIF
        CASE('FUNVAL','FV    ','VALFUN')
	     CALL RFUNVAL(WESULT)
        CASE('BKCOLO')
           CALL DIAP(0,'ANALYS',IEND)
           IF(IEND.EQ.0)II=SETBKCOLOR(IP(1))
        CASE('K     ','ANALYS','ANAL  ','AN    ')
	     CALL RANALYS(WESULT)
        CASE('A     ','ACTNUM','NUMIN ','NUM   ')
	     CALL RACTNUM(WESULT)
        CASE('B     ','INACTN','NUMOUT')
	     CALL RINACTNUM(WESULT)
        CASE('G     ','ACTSET','SETGRP','ACTGRP','GROUP ')
	     CALL RACTSET(WESULT)

C DELETE --------------------

        CASE('NDEL  ','NDDEL ')
	     CALL RNDEL(WESULT)
        CASE('EDEL  ')
	     CALL REDEL(WESULT)
        CASE('CRDEL ')
	     CALL RCRDEL(WESULT)
        CASE('SFDEL ')
	     CALL RSFDEL(WESULT)
        CASE('PTDEL ')
	     CALL RPTDEL(WESULT)

CGEOM   --------------------definice krivek a ploch
C       DEFAULT Z-SOURADNICE
        CASE('Z     ','ZD    ','ZDEF  ')
	     CALL RZDEF(WESULT)
        CASE('P     ','PT    ','POINT ','BOD   ')
           CALL RPT(WESULT)
	  CASE('PXYZ  ','PTXYZ ')
	     CALL RPTXYZ(WESULT)
        CASE('CRSPOL','CRS   ','POLYLI','CRPOLY','CARA  ')
           CALL RCRS(WESULT)
        CASE('ND    ','NODE  ','UZEL  ')
           CALL RNODE(WESULT)
        CASE('C     ','CR2PT ','C2P   ','CRLINE','CURVE ','KRIVKA')
	     CALL RCR2PT(WESULT)
        CASE('CR3PT ','C3P   ')
	     CALL RCR3PT(WESULT)
        CASE('CRNPT ','CNP   ')
	     CALL RCRNPT(WESULT)
        CASE('CIRCLE','CIR   ','KRUH  ')
	     CALL RCIRCLE(WESULT)
        CASE('ARC   ')
	     CALL RARC(WESULT)
        CASE('SF4PT ','S4P   ','SURFAC','PLOCHA')
	     CALL RSF4PT(WESULT)
        CASE('SF8PT ','S8P   ')
	     CALL RSF8PT(WESULT)
        CASE('SF3PT ','S3P   ')
	     CALL RSF3PT(WESULT)
        CASE('SF6PT ','S6P   ')
	     CALL RSF6PT(WESULT)
        CASE('SFCR  ')
	     CALL RSFCR(WESULT)
        CASE('PTCRIN','PTCR2 ','PCI  ')
	     CALL RPTCR2(WESULT)
        CASE('VL8PT ','V8P   ','OBJEM ')
	     CALL RVL8PT(WESULT)
        CASE('SFEXTR','SFEX  ')
	     CALL RSFEXTR(WESULT)
        CASE('VLSF  ')
	     CALL RVLSF(WESULT)
        CASE('CTR   ','CT    ')
	     CALL RCTR(WESULT)
        CASE('CRN   ')
	     CALL RCRN(WESULT)
	  CASE('DIST  ')
	     CALL RDIST(WESULT)
CASES GROUP -------------------------------------

        CASE('MPROP ','MP    ','MATERI')
	     CALL RMP(WESULT)
        CASE('EGROUP','EG    ')
	     CALL REG(WESULT)
        CASE('RCONST','RC    ')
	     CALL RRC(WESULT)
        CASE('RCPUMP','RCP   ')
	     CALL RRCPUMP(WESULT)
        CASE('RCEPUM','RCEP  ')
	     CALL RRCEPUM(WESULT)
        CASE('RCHEX ','RCHE  ')
	     CALL RRCHEX(WESULT)
        CASE('RCHEV ','RCHEVR')
	     CALL RRCHEV(WESULT)
        CASE('RCEHEV')
	     CALL RRCEHEV(WESULT)
        CASE('RCSTUB','RCST  ')
	     CALL RRCSTUB(WESULT)
        CASE('RCSTH ','RCSTHEL')
	     CALL RRCSTH(WESULT)
        CASE('RCESTU','RCEST ')
	     CALL RRCESTU(WESULT)
        CASE('RCESTH')
	     CALL RRCESTH(WESULT)
        CASE('RCROSS','RCR   ')
	     CALL RRCROSS(WESULT)
        CASE('FUNDEF','FDEF  ','FD    ','DF    ','FUNKCE')
	     CALL RFUNDEF(WESULT)
        CASE('CURDEF','CDEF  ','CD    ','DC    ','TABLE ','TAB   ')
	     CALL RCURDEF(WESULT)
        CASE('INTGCR','ICR   ','IC    ')
	     CALL RINTGCR(WESULT)
        CASE('INTGSF','ISF   ','IS    ')
	     CALL RINTGSF(WESULT)
        CASE('INTGEL','INTEL ','IE    ')
	     CALL RINTGEL(WESULT)

CASES MESH --------------------------------------

        CASE('E     ','ELEMEN')
	     CALL RELEMENT(WESULT)
        CASE('MVL   ','M_VL  ','MESHVL','SITV  ')
	     CALL RMVL(WESULT)
        CASE('MSF   ','M_SF  ','MESHSF','SITS  ')
	     CALL RMSF(WESULT)
        CASE('MCT   ','M_CT  ')
	     CALL RMCT(WESULT)
        CASE('MRG   ','M_RG  ')
	     CALL RMRG(WESULT)
        CASE('MPT   ')
	     CALL RMPT(WESULT)
        CASE('MND   ')
	     CALL RMND(WESULT)
        CASE('MCR   ','MCRC  ','M_CR  ','MESHCR','SITC  ')
	     CALL RMCR(WESULT)
        CASE('MCR2  ','MCRPH ','MCR24 ')
	     CALL RMCR24(WESULT)
        CASE('MCR4  ','MCRHEX','MCH   ')
	     CALL RMCR4(WESULT)
        CASE('PPT   ','PARTIC')
	     CALL RPARTIC(WESULT)
        CASE('PDEL  ','PARDEL')
	     CALL RPARDEL(WESULT)
        CASE('NMERGE','NM    ','SLOUCI')
	     CALL RNMERGE(WESULT)
        CASE('NMERGS','SMERGE')
	     CALL RNMERGS(WESULT)
        CASE('PMERGE','PM    ')
	     CALL RPMERGE(WESULT)
        CASE('ERMSF ')
	     CALL RERMSF(WESULT)
        CASE('ERMOD ')
	     CALL RERMOD(WESULT)
        CASE('ERMEL ')
	     CALL RERMEL(WESULT)
     

CASES FORCES, INITIAL----------------------------

        CASE('NFCR  ','FCR   ','BOUND ','PODMIN')
	     CALL RNFCR(WESULT)
        CASE('NFCT  ','FCT   ')
	     CALL RNFCT(WESULT)
        CASE('NFSF  ','FSF   ','SOURCE')
	     CALL RNFSF(WESULT)
        CASE('NF    ','FN    ','NDF   ','FND   ')
	     CALL RNF(WESULT)
        CASE('NFPT  ','FPT   ','FP    ','PF    ','PTF   ')
	     CALL RNFPT(WESULT)
        CASE('INLET ','VSTUP ')
	     CALL RINLET(WESULT)
        CASE('WALL  ','STENA ')
	     CALL RWALL(WESULT)
        CASE('I     ','INITIA','INI   ','NULUJ ')
	     CALL RINITIA(WESULT)
        CASE('MOFE  ')
	     CALL RMOFE(WESULT)
	  CASE('NDTOCR','ATTACH')
	     CALL RATTACH(WESULT)

CASES FEM analyzy--------------------------------

        CASE('OPTION','ATRANE','APIPE')
           CALL DIAP(1,'OPTION',IEND)
           IF(IEND.EQ.0) CALL WRITEL('OPTION')
        CASE('ACCURA','EPS   ')
	     CALL RACCURA(WESULT)
        CASE('SOLVE ','THERMA','CREEP ','PIPE  ','HEXC  ','CONC  ',
     /'SHELLA','TRANEQ','TRANEC','CONTHE','POCITE','RESENI')
	     CALL RSOLVE(WESULT)
        CASE('DSOLVE','SOLVED')
	     CALL RSOLVED(WESULT)
        CASE('PSOLVE','SOLVEP')
	     CALL RPSOLVE(WESULT)
        CASE('TRUSS ','TRUS  ')
	     CALL RTRUSS(WESULT)
        CASE('BOX   ','BOXING')
           CALL RBOX(WESULT)


CASES RTD MODEL--------------------------------------
        CASE('MOPED ','NOTEPA')
		   CALL RUNMOPED(WESULT)
        CASE('EXCEL ')
		   CALL RUNEXCEL(WESULT)
        CASE('T     ','TIMES ','TSTEP ','DT    ','CAS   ')
             CALL RTSTEP(WESULT)
        CASE('TMAX  ')
	       CALL RTMAX(WESULT)
        CASE('RMODEL','RM    ','MODEL ')
		   CALL RRMODEL(WESULT)
        CASE('PARDEF','PARD  ','PADEF ','PAD   ','PDEF  ')
		   CALL RPARDEF(WESULT)
        CASE('PARLAB','PARHED')
		   CALL RPARLAB(WESULT)
        CASE('PARLIM','PARL  ','PALIM ','PLIM  ')
		   CALL RPARLIM(WESULT)
        CASE('PARFIT','PARREG','PARF  ','PAF   ')
		   CALL RPARFIT(WESULT)
        CASE('PARSET','PARS  ','PASET ','PAS   ','PSET  ')
		   CALL RPARSET(WESULT)
        CASE('METHOD','MET   ','RUNGE ')
		   CALL RMETHOD(WESULT)
        CASE('INPUT ','INP   ','STIMUL','VZRUCH')
		   CALL RINPUT(WESULT)
        CASE('O     ','OUTPUT','OUT   ','OUTLET','RESPON','ODEZVA')
		   CALL ROUTPUT(WESULT)
        CASE('INIMOD','IMOD  ','IM    ')
           CALL WRITEL('INIMOD')
        CASE('CONVOL','CON   ')
		   CALL RCONVOL(WESULT)
        CASE('IMPULS','IMP   ')
		   CALL RIMPULS(WESULT) 
        CASE('INTEGR')
		   CALL RINTEGR(WESULT)
        CASE('EPIPE ','AORTA ')
		   CALL RAORTA(WESULT)
	  CASE('EPIPER')
	       CALL RAORTAR(WESULT)
        CASE('ELONEX')
		   CALL RELONEX(WESULT)
	  CASE('GMOD  ')
	       CALL RGMOD(WESULT)
	  CASE('FOAM  ')
	       CALL RFOAM(WESULT)
	  CASE('FOAMS ')
	       CALL RFOAMS(WESULT)
	  CASE('FOAMSE')
	       CALL RFOAMSE(WESULT)
	  CASE('FOAMV ')
	       CALL RFOAMV(WESULT)

CASES REG----------------------------------------
        CASE('LINREG','LR    ')
		   CALL RLINREG(WESULT)
        CASE('LAGREG','LGRR  ')
		   CALL RLAGREG(WESULT)
        CASE('NELREG','NLR   ','NLRG  ')
		   CALL RNELREG(WESULT)
        CASE('NLR2  ')
		   CALL RNLR2(WESULT)
        CASE('OPTIMA','OPT   ','MINSSQ','MARQUA')
		   CALL ROPTIMA(WESULT)
        CASE('SOMA  ','GENETI')
		   CALL RSOMA(WESULT)
	  CASE('RANDOM')
	       CALL RANDOP(WESULT)
	  CASE('NELDER','SIMPLE')
	       CALL RNELDER(WESULT)

CASE RTD-----------------------------------------
        CASE('COMPAR','TCOMP ','TCOM  ','POROVN')
		   CALL RCOMPAR(WESULT)
        CASE('CRITER','TCRIT ','TCRI  ')
		   CALL RCRITER(WESULT)
        CASE('WMODIF','WMOD')
		   CALL RWMODIF(WESULT)
        CASE('TCDEV ','TCDELT','ODCHYL')
		   CALL RTCDEV(WESULT)
        CASE('COPYTO','COTO  ','TCO   ')
		   CALL RCOPYTO(WESULT)
        CASE('TCSUB ','SUBTRA','SUB   ')
		   CALL RTCSUB(WESULT)
        CASE('MOMENT','MOM')
		   CALL RMOMENT(WESULT)
        CASE('FMOM')
             CALL RFMOMENT(WESULT)
        CASE('J     ','TCL   ','TCLIST')
             CALL RTCLIST(WESULT)
        CASE('TCLEAR')
		   CALL RTCLEAR(WESULT)
        CASE('NORM  ','NOR   ')
		   CALL RRNORM(WESULT)
        CASE('TCDT  ','TCT   ')
             CALL RTCDT(WESULT)
        CASE('TCNT  ','TCN   ')
             CALL RTCNT(WESULT)
        CASE('TCINT ','TCINTG')
             CALL RTCINT(WESULT)
        CASE('IDMSER','IDM   ','SERIE ')
		   CALL RIDMSER(WESULT)
        CASE('PASERI','PASER ','SERIE2')
		   CALL RPASERI(WESULT)
        CASE('TCEDIT','TED   ','TCE    ')
		   CALL RTCEDIT(WESULT)
        CASE('TCSET ','SETC  ','STC   ','TCTYPE','TCS   ')
		   CALL RTCSET(WESULT)
        CASE('TCINP ','TCI   ','INTC  ','INPUTC')
             CALL RTCINPUT(WESULT)
        CASE('TCFUN ','TCF   ','FUNTC ')
		   CALL RTCFUN(WESULT)
        CASE('TCFR  ')
		   CALL RTCFUNR(WESULT)
        CASE('SMOOTH','SM    ','TCSMOO','TCSM  ','SPLINE')
             CALL RSMOOTH(WESULT)
        CASE('TCJOIN','TCJ   ','UNION ','COMPOS')
		   CALL RJOIN(WESULT)
        CASE('TAIL  ','CHVOST')
		   CALL RTAIL(WESULT)
        CASE('TCREG  ','TCR   ')
		   CALL RTCREG(WESULT)
        CASE('TCBGR  ','BGR   ','POZADI')
		   CALL RBGR(WESULT)
        CASE('TRCOR ')
		   CALL RRCOR(WESULT)
        CASE('TCRND ','RND   ','RAND  ','SUM   ')
	  	   CALL RRND(WESULT)
	  CASE('TCDEC ')
	       CALL RTCDEC(WESULT)
        CASE('TCLIP ','CLIP  ')
		   CALL RCLIP(WESULT)
        CASE('TCEND ','TCRANG')
		   CALL RTCRANGE(WESULT)
        CASE('TCYSHF','SHIFT ','CS    ')
		   CALL RTCSHIFT(WESULT)
        CASE('TCXSHF','TSHIFT','TS    ')
		   CALL RTSHIFT(WESULT)
        CASE('TCOSHF','TCOS  ','OS    ')
		   CALL RTCOSHF(WESULT)
        CASE('TCZERI','TCZ   ','TCZERO','TCZER ')
		   CALL RTCZERI(WESULT)
        CASE('TCFFT ','FFT   ','FT    ')
		   CALL RFFT(WESULT)
        CASE('DETLIS','DETL  ')
		   CALL RDETLIS(WESULT)
        CASE('MODLIS','MODL  ','ML    ')
		   CALL RMODLIS(WESULT)
        CASE('PALIS ','PL    ')
		   CALL RPALIST(WESULT)
        CASE('BOXTES','INTERP')
		   CALL RBOXTES(WESULT)
        CASE('GTD   ')
		   CALL RDAXIS(WESULT)
        CASE('GTC   ','GXY   ')
		   CALL RGTC(WESULT)
        CASE('GTF  ')
		   CALL RGTF(WESULT)
        CASE('GTL  ')
		   CALL RGTL(WESULT)
        CASE('TCPLOT','TCP   ')
		   CALL RTCPLOT(WESULT)
        CASE('TCPXY ','XY    ')
	       WESULT=0
		   CALL RTCPXY(WESULT)
        CASE('TCPXYM','XYM   ')
	       WESULT=1
		   CALL RTCPXY(WESULT)

        
CASES WRITE/READ---------------------------------

        CASE('LOADTN','LTN   ','LT    ','LOADT ','CTICAS')
	     CALL RLOADTN(WESULT)
        CASE('LOADTE','LTE   ')
	     CALL RLOADTE(WESULT)
        CASE('NAMEPR','NAME  ')
	     CALL RNAME(WESULT)
        CASE('UNIFIL','IMPORT')
	     CALL RUNIFIL(WESULT)
        CASE('WRITE ','W     ')
	     CALL RWRITE(WESULT)
        CASE('WRITEB','WB    ')
	     CALL RWRITEB(WESULT)
        CASE('READBI','READB ','RB    ')
	     CALL RREADBI(WESULT)
        CASE('REOMAT','ROM   ')
	     CALL RREOMAT(WESULT)
        CASE('READ  ','R     ','RTC   ','RNOD  ','READTC','READCO')
	     CALL RREAD(WESULT)
        CASE('READTS','RTS   ')
	     CALL RREADTS(WESULT)
        CASE('FLUENF')
	     CALL RFLUENF(WESULT)
        CASE('FLUENT')
	     CALL RFLUENT(WESULT)

CASES GRAF VYSLEDKY a LISTS------

        CASE('WINDOW','OKNO  ')
		 CALL RWINDOW(WESULT)
        CASE('VIEW  ','V3D   ','POHLED')
		 CALL RVIEW(WESULT)
        CASE('GRAPH ','GD2   ','G2    ','D2    ','GRAF2 ','VRSTEV')
           CALL RGD2(WESULT)
        CASE('GVEL  ','GV    ')
		 CALL RGVEL(WESULT)
        CASE('STREAM','GS    ')
		 CALL RSTREAM(WESULT)
        CASE('GSN   ')
		 CALL RSTREAMN(WESULT)
        CASE('GD1   ','G1    ','D1    ','GRAF1 ')
           CALL RGD1(WESULT)
        CASE('GRAPS ','GE1   ','E1    ')
           CALL RGE1(WESULT)
        CASE('GE2     ','E2    ')
           CALL RGE2(WESULT)
        CASE('GCR   ','GC    ','GDCR  ','GDC   ')
           CALL RGCR(WESULT)
        CASE('GD3   ','GFSF  ')
           CALL RGFSF(WESULT)
        CASE('GFCR  ','GCF   ','GFC   ')
           CALL RGFCR(WESULT)
        CASE('GTE   ')
	     CALL RGRATE(WESULT)
        CASE('GRATIM','GT    ','GTIM  ','GTIME ','GTN   ')
	     CALL RGRATN(WESULT)
        CASE('CTE   ')
	     CALL RGRACTE(WESULT)
        CASE('CTN   ')
	     CALL RGRACTN(WESULT)
        CASE('CTTN  ')
	     CALL RGRACTTN(WESULT)
        CASE('GRAFUN','GF    ')
		 CALL RGRAFUN(WESULT)
	  CASE('TGRID ')
	     CALL RTGRID(WESULT)
	  CASE('AGRID ')
	     CALL RAGRID(WESULT)

CASES PLOT

        CASE('PTPLOT','PTP   ')
		   CALL RPTPLOT(WESULT)
        CASE('PTPG  ')
		   CALL RPTPG(WESULT)
        CASE('NDPLOT','NDP   ')
           CALL RNDPLOT(WESULT)
        CASE('SFPLOT','SFP   ')
		   CALL RSFPLOT(WESULT)
        CASE('VLPLOT','VLP   ')
		   CALL RVLPLOT(WESULT)
        CASE('CRPLOT','CRP   ')
		   CALL RCRPLOT(WESULT)
        CASE('CRPG  ')
		   CALL RCRPG(WESULT)
        CASE('CTPLOT','CTP   ')
		   CALL RCTPLOT(WESULT)
        CASE('DETPLO','DPL   ','DETPL ')
		   CALL RDETPLOT(WESULT)
        CASE('EPLOT ','EP    ')
		   CALL REPLOT(WESULT)
        CASE('DEFPLO')
		   CALL RDEFPLOT(WESULT)
        CASE('NFPLOT','NFP   ')
		   CALL RNFPLOT(WESULT)
        CASE('PFPLOT','PFP   ','DIAL  ','METER ')
		   CALL RPFPLOT(WESULT)
      
CASES IDENTifikace lokatorem

        CASE('PIDENT','PID   ','PICKP ','PTPICK')
		   CALL RPID(WESULT)
        CASE('NIDENT','NID   ','PICKN ','NDPICK')
		   CALL RNID(WESULT)
        CASE('EIDENT','EID   ','PICKE ','EPICK ')
		   CALL REID(WESULT)
        CASE('CIDENT','CID   ','PICKC ','CRPICK')
		   CALL RCID(WESULT)
        CASE('TIDENT','TID   ','PICKT ','TCPICK')
		   CALL RTID(WESULT)

CASES GSCREEN----

        CASE('CLS   ','MAZ   ')
		   CALL RCLS(WESULT)
        CASE('X     ','SCALE ','MERITK')
		   CALL RSCALE(WESULT)
        CASE('LA   ')
		   CALL RLABEL(WESULT)
        CASE('WS    ')
		   CALL RWINSET(WESULT)
        CASE('ZOOMI ','ZI    ','DETAIL','LUPA  ')
		   CALL RZOOMI(WESULT)
        CASE('ZOOMOU','ZOOMO ','ZO    ')
		   CALL RZOOMOUT(WESULT)
        CASE('MAGNIF','MA    ','MG    ')
		   CALL RMAGNIF(WESULT)
        CASE('GRIDON','GRID  ','GON   ','MRIZKA')
		   CALL RGRIDON(WESULT)
        CASE('GRIDOF','GOF   ')
		   CALL RGRIDOF(WESULT)

CASES PLISTS---

        CASE('MPLIST','MPL   ')
		   CALL RMPLIST(WESULT)
        CASE('RCLIST','RCL   ')
		   CALL RRCLIST(WESULT)
        CASE('EGLIST','EGL   ')
		   CALL REGLIST(WESULT)
        CASE('ELIST ','EL    ')
		   CALL RELIST(WESULT)
        CASE('EPLIST','EPL   ')
		   CALL REPLIST(WESULT)
        CASE('NDLIST','NDL   ','NLIST ','Y     ')
		   CALL RNDLIST(WESULT)
        CASE('PTLIST','PTL   ','PLIST ')
		   CALL RPTLIST(WESULT)
        CASE('SFLIST','SFL   ','SLIST ')
		   CALL RSFLIST(WESULT)
        CASE('VLLIST','VLL   ','VLIST ')
		   CALL RVLLIST(WESULT)
        CASE('CRLIST','CRL   ')
		   CALL RCRLIST(WESULT)
        CASE('CTLIST','CTL   ')
		   CALL RCTLIST(WESULT)
        CASE('NCONTO','NC    ')
		   CALL RNCT(WESULT)
        CASE('PTIN  ')
		   CALL RPTIN(WESULT)
        CASE('NFLIST','NFL   ','FLIST ')
		   CALL RNFLIST(WESULT)
        CASE('DOFLIS','DOFL  ','RANGE ')
		   CALL RDOFLIST(WESULT)
        CASE('CURLIS','CURL  ')
		   CALL RCURLIST(WESULT)
        CASE('FUNLIS','FUNL  ')
		   CALL RFUNLIST(WESULT)
        CASE('CLIST ','CL    ','SETTIN','ENABLE')
		   CALL RCHECK(WESULT)
        CASE('V     ','VARLIS','VARL  ')
		   CALL RVARLIST(WESULT)
        CASE('DETDEF','DD    ')
		   CALL RDETDEF(WESULT)
        CASE('DETDOF','DETD  ')
		   CALL RDETDOF(WESULT)
        CASE('DETFUN','DETF  ')
		   CALL RDETFUN(WESULT)

C EXIT ---------------------------------------

        CASE('Q     ','EXIT  ','QUIT  ','KONEC ')
          WRITE(10,'('' If you really want to quit press [Y] or [Q]'')')
           CALL GCU(CH,IEND)
           IF(CH.EQ.'Y'.OR.CH.EQ.'y'.OR.CH.EQ.'Q'.OR.CH.EQ.'q')THEN
           WRITE(10,'(1X,''Thank you for using FEMINA :=)''/'' Protocol  
     /of this session is in '',A,''.SES and results are in OUT and TEP f
     /iles.''/'' If you had problems with solution try to execute RUNFEM
     /.EXE as a stand alone program.'')')TRIM(PROBLEM)
           KEYW='EXIT  '
           ENDIF
        CASE DEFAULT
C Neznamy prikaz je automaticky zapsan do session filu
C nejprve zjisteni zda nejde o jmeno vnejsiho programu
           EXPROG=.FALSE.
           DO I=1,NEXCOM
              IF(KEYW(1:4).EQ.NEXKWD(I))THEN
                 CALL DIAP(1,NEXKWD(I),IEND)
                 IF(IEND.EQ.0)THEN
                    CALL WRITEL(NEXKWD(I))
                    EXPROG=.TRUE.
                    EXIT
                 ENDIF
              ENDIF
           ENDDO
           IF(.NOT.EXPROG)THEN
              CALL PROITE(1,LINE,IEND)
              IF(IEND.LT.0.AND.
     /               LINE(1:2).NE.'C*'.AND.
     /               LINE(1:2).NE.'Q*'.AND.
     /               LINE(1:2).NE.'I*'.AND.
     /               LINE(1:2).NE.'R*')THEN
                  WRITE(10,'('' Wrong syntax in script ['',a,'']'')')
     /               TRIM(LINE)
C DOSOVSKY prikaz
                  WESULT=.FALSE.
                  IF(LINE(1:1).EQ.':'.OR.
     /               LINE(1:1).EQ.'/'.OR.LINE(1:1).EQ.'\')THEN
                     WRITE(10,'('' Trying to execute DOS command'',a40)'
     /)LINE(1:40)
                     WESULT=SYSTEMQQ(LINE(2:))
                  ENDIF
                  IF(.NOT.WESULT.AND.KEYW.NE.'NUL'.AND.KEYW.NE.'LINE')
     /THEN
                     INQUIRE(FILE=KEYW,EXIST=WESULT)
                     IF(WESULT)THEN
                        CALL FOPEN(4,KEYW)
                        CALL SHOWBEG(4)
                        READMA=.TRUE.
                     ELSE
                        WRITE(10,'(1X,A,'' unrecognized command'')')KEYW
                        CALL HELPC(1,KEYW)
                     ENDIF
                  ENDIF
              ELSE
                  WRITE(1,'(A)')TRIM(LINE)
                  IF(RECORW)THEN
                     WRITE(8,'(A)')TRIM(LINE)
C                     INQUIRE(UNIT=8,NAME=FILENAM)
                     CALL FINQUIRE(8,FILENAM)
                     WRITE(10,'('' Recording ['',A,''] into file '',A)')
     /                        TRIM(LINE),FILENAM
                  ENDIF
              ENDIF
           ENDIF
        ENDSELECT ! CASE klicovych slow
      ENDDO ! while opakovani prikazu
      END

