      MODULE PEEKAPPMODULE
C Vytvoreni noveho vlakna CALL PEEKSTART(unit) v nemz se provadi GETCHARQQ 
C 
C 
      USE DFLIB
      USE DFMT
      IMPLICIT NONE
      INTEGER*4 BUFGET, BUFPUT
      CHARACTER*1 BUFFER(0:255)
      INTEGER THREADHANDLE
      TYPE(RTL_CRITICAL_SECTION) DRAWLOCK
	LOGICAL THREADEF
	SAVE THREADEF
      CONTAINS

      SUBROUTINE PEEKSTART(UNIT)
      INTEGER UNIT,J,M
      INTEGER*4, STATIC :: SAVEUNIT
      SAVEUNIT = UNIT
C BUFPUT je index znaku v zasobniku BUFFER - zvysuje se po kazdem stisku klavesy
C BUFGET je index znaku v zasobniku BUFFER - zvysuje se pi kazdem USERGETCH
      BUFPUT = 0
      BUFGET = 0
      CALL INITIALIZECRITICALSECTION( LOC(DRAWLOCK) )
      THREADHANDLE = CREATETHREAD( 0, 0, GETCHARPROC, %LOC(SAVEUNIT), 
     /CREATE_SUSPENDED, J )
      M = SETTHREADPRIORITY(THREADHANDLE, THREAD_PRIORITY_ABOVE_NORMAL )
c      M = SETTHREADPRIORITY(THREADHANDLE, THREAD_PRIORITY_highest )
      M = RESUMETHREAD(THREADHANDLE)
	THREADEF=.TRUE.
      RETURN
      END SUBROUTINE PEEKSTART

      INTEGER*4 FUNCTION GETCHARPROC( UNIT )
      USE DFLIB
      INTEGER*4 J,K, UNIT
      CHARACTER*1 CH 
      GETCHARPROC = 1
      DO WHILE(.TRUE.)
C      DO WHILE(THREADEF)
        J = FOCUSQQ(UNIT)    
        CH = GETCHARQQ() ! THIS WILL BLOCK UNTIL A CHARACTER IS TYPED
        CALL ENTERCRITICALSECTION( LOC(DRAWLOCK) )
        BUFPUT = IAND(BUFPUT + 1,16#000000FF)
        IF(BUFPUT .EQ. BUFGET) THEN
           CALL BEEPQQ(4000,500)
           BUFPUT = IAND(BUFPUT - 1,16#000000FF)
        ELSE
           BUFFER(BUFPUT) = CH
        ENDIF
        CALL LEAVECRITICALSECTION( LOC(DRAWLOCK) )
      END DO
      END FUNCTION GETCHARPROC

	SUBROUTINE USERPUTCHAR(CH)
	CHARACTER*1 CH
        BUFPUT = IAND(BUFPUT + 1,16#000000FF)
        IF(BUFPUT .EQ. BUFGET) THEN
           CALL BEEPQQ(4000,500)
           BUFPUT = IAND(BUFPUT - 1,16#000000FF)
        ELSE
           BUFFER(BUFPUT) = CH
        ENDIF
	END SUBROUTINE USERPUTCHAR
	
      LOGICAL*4 FUNCTION USERPEEKCHAR()
	IF(THREADEF)THEN
		CALL ENTERCRITICALSECTION( LOC(DRAWLOCK) )
		IF(BUFGET .EQ. BUFPUT) THEN
			USERPEEKCHAR = .FALSE.
		ELSE
			USERPEEKCHAR = .TRUE.
		ENDIF
		CALL LEAVECRITICALSECTION( LOC(DRAWLOCK) )
	ELSE
		USERPEEKCHAR=.FALSE.
	ENDIF
      END FUNCTION USERPEEKCHAR

      CHARACTER*1 FUNCTION USERGETCHAR()
	IF(THREADEF)THEN
		CALL ENTERCRITICALSECTION( LOC(DRAWLOCK) )
		IF(BUFGET .EQ. BUFPUT) THEN
			CALL BEEPQQ(4000,500)
			USERGETCHAR = ' '
		ELSE
			BUFGET = IAND(BUFGET + 1,16#000000FF)
			USERGETCHAR = BUFFER(BUFGET)
		ENDIF
		CALL LEAVECRITICALSECTION( LOC(DRAWLOCK) )
	ELSE
		USERGETCHAR=' '
	ENDIF
      END FUNCTION USERGETCHAR

      END MODULE PEEKAPPMODULE
