c Nelinearni regrese Marquardt dle Numerical recipes 
c Modifikace pro dve nezavisle promenne
      PARAMETER (NCVM=10,NDM=5096)
C SIG -
      DIMENSION X1(NDM),X2(NDM),Y(NDM),SIG(NDM),
     /COVAR(NCVM,NCVM),DYDA(NCVM),ASTART(NCVM,9)
      DIMENSION LISTA(NCVM),ALPHA(NCVM,NCVM),AA(3,3),BB(3)
      COMMON /$REGRES/MODEL,A(NCVM)
      EXTERNAL FUN2,FUNLIN2
      LOGICAL DEFSIG

      OPEN(1,FILE='RANNREG2.DAT')
      READ(1,*,END=1000,ERR=1000)MODELI,NDATA
      DEFSIG=.TRUE.
      DO I=1,NDATA
         READ(1,*,END=1000,ERR=1000)IDUMMY,X1(I),X2(I),Y(I),SIG(I)
         IF(SIG(I).GT.0.)DEFSIG=.FALSE.
      ENDDO
      IF(DEFSIG)SIG=1.
      CLOSE(1)
C MODEL=1  A1+A2*x1+A3*x2
C MODEL=2  A1+A2*x1+A3*x2+A4*x1*x2
C MODEL=3  A1+A2*x1+A3*x2+A4*x1*x2+A5*X1^2+A6*X2^2
C MODEL=4  A1+(A2+A3*X1+A4*X2)*EXP(A5*X1+A6*X2)
C MODEL=5  A1*x1^A2*x2^A3
C MODEL=6  A1+A2*x1^A3*x2^A4
C MODEL=7  A1+A2*X1^A3*X2^A4/(1+A5*X1^A6*X2^A7)
C MODEL=8  A1*EXP(-A2*X1)*X2^A3
C MODEL=9  A1+A2*EXP(-A3*X1)*X2^A4
C MODEL=10 A1*EPX(-((X1-A2)/A3)^2-((X2-A4)/A5)^2)
C MODEL=11 A1+A2*EPX(-((X1-A3)/A4)^2-((X2-A5)/A6)^2)
C MODEL=12 (A1+A2*X1)*X2*(1-X2)^(A4+A5*X2+A6*X1)+A3*(1-X2)
      X1RANGE=ABS(X1(NDATA)-X1(1))
      IF(X1RANGE.LE.1E-10)STOP
      YMA=-1E10
      YMI=1E10
      YMEAN=0
      X1MI=1E10
      X2MI=1E10
      X1MA=-1E10
      X2MA=-1E10
      DO I=1,NDATA
        IF(ABS(Y(I)).GT.YMA)THEN
           YMA=ABS(Y(I))
           XMAX1=X1(I)
           XMAX2=X2(I)
        ENDIF
        YMEAN=YMEAN+Y(I)
        YMI=AMIN1(YMI,Y(I))
        X1MI=AMIN1(X1MI,X1(I))
        X2MI=AMIN1(X2MI,X2(I))
        X1MA=AMAX1(X1MA,X1(I))
        X2MA=AMAX1(X2MA,X2(I))
      ENDDO
      YMEAN=YMEAN/NDATA
C
      IF(MODELI.LE.0)THEN
         MODEL1=1
         MODEL2=12
      ELSE
         MODEL1=MODELI
         MODEL2=MODELI
      ENDIF
      BEST=1E8
      DO MODEL=MODEL1,MODEL2
	  NREP=1
        SELECT CASE(MODEL)
         CASE(1)
           MFIT=3
           MLIN=3
         CASE(2)
           MFIT=4
           MLIN=4
         CASE(3)
           MFIT=6
           MLIN=6
         CASE(4)
           MFIT=6
           MLIN=4
           A(5)=1/AMAX1(1E-6,XMAX1)
           A(6)=1/AMAX1(1E-6,XMAX2)
         CASE(5,6,7)
           IF(MODEL.NE.5)THEN
C Odhad koeficientu A1 linearni regresi
             AA=0
             BB=0
             DO I=1,NDATA
               XX1=X1(I)
               XX2=X2(I)
               YY=Y(I)
               AA(1,2)=AA(1,2)+XX1
               AA(1,3)=AA(1,3)+XX2
               AA(2,2)=AA(2,2)+XX1*XX1
               AA(3,3)=AA(3,3)+XX2*XX2
               AA(2,3)=AA(2,3)+XX1*XX2
               BB(1)=BB(1)+YY
               BB(2)=BB(2)+YY*XX1
               BB(3)=BB(3)+YY*XX2
             ENDDO
             AA(3,2)=AA(2,3)
             AA(2,1)=AA(1,2)
             AA(3,1)=AA(1,3)
             AA(1,1)=NDATA
             CALL GAUSSJ(AA,3,3,BB,1,1,ier)
             A(1)=BB(1)*.2
             WRITE(*,*)' LINEARNI ODHAD A1=',A(1)
           ENDIF
C Odhad koeficientu racionalni funkce
           IF(MODEL.EQ.7)THEN
             A(6)=.2
             A(7)=.2
             A(5)=.000001/(X1MA**A(6)*X2MA**A(7))
           ENDIF
           NPOS=0
           AA=0
           BB=0
           DO I=1,NDATA
             XX1=X1(I)
             XX2=X2(I)
             IF(XX1.GT.0..AND.XX2.GT.0.)THEN
               IF(MODEL.EQ.5)THEN
                 YY=Y(I)
               ELSEIF(MODEL.EQ.6)THEN
                 YY=Y(I)-A(1)
               ELSE
                 YY=(Y(I)-A(1))*(1.+A(5)*XX1**A(6)*XX2**A(7))
               ENDIF
               IF(YY.GT.0.)THEN
                 NPOS=NPOS+1
                 X1L=ALOG(XX1)
                 X2L=ALOG(XX2)
                 YL=ALOG(YY)
                 AA(1,2)=AA(1,2)+X1L
                 AA(1,3)=AA(1,3)+X2L
                 AA(2,2)=AA(2,2)+X1L*X1L
                 AA(3,3)=AA(3,3)+X2L*X2L
                 AA(2,3)=AA(2,3)+X1L*X2L
                 BB(1)=BB(1)+YL
                 BB(2)=BB(2)+YL*X1L
                 BB(3)=BB(3)+YL*X2L
               ENDIF
             ENDIF
           ENDDO
           AA(3,2)=AA(2,3)
           AA(2,1)=AA(1,2)
           AA(3,1)=AA(1,3)
           AA(1,1)=NPOS
           CALL GAUSSJ(AA,3,3,BB,1,1,ier)
           IF(MODEL.EQ.5)THEN
              MFIT=3
              MLIN=1
              A(2)=BB(2)
              A(3)=BB(3)
           ELSEIF(MODEL.EQ.6)THEN
              MFIT=4
              MLIN=2
              A(3)=BB(2)
              A(4)=BB(3)
           ELSE
              MFIT=7
              MLIN=2
              A(3)=BB(2)
              A(4)=BB(3)
           ENDIF
         CASE(8)
C MODEL=8  A1*EXP(-A2*X1)*X2^A3
           MFIT=3
           MLIN=1
           NPOS=0
           AA=0
           BB=0
           DO I=1,NDATA
             XX1=X1(I)
             XX2=X2(I)
	       YY=Y(I)
             IF(XX2.GT.0..AND.YY.GT.0.)THEN
                 NPOS=NPOS+1
                 X2L=ALOG(XX2)
                 YL=ALOG(YY)
                 AA(1,2)=AA(1,2)-XX1
                 AA(1,3)=AA(1,3)+X2L
                 AA(2,2)=AA(2,2)+XX1*XX1
                 AA(3,3)=AA(3,3)+X2L*X2L
                 AA(2,3)=AA(2,3)-XX1*X2L
                 BB(1)=BB(1)+YL
                 BB(2)=BB(2)-YL*XX1
                 BB(3)=BB(3)+YL*X2L
             ENDIF
           ENDDO
           AA(3,2)=AA(2,3)
           AA(2,1)=AA(1,2)
           AA(3,1)=AA(1,3)
           AA(1,1)=NPOS
           CALL GAUSSJ(AA,3,3,BB,1,1,ier)
           A(1)=EXP(BB(1))
	     A(2)=BB(2)
	     A(3)=BB(3)
         CASE(9)
C MODEL=9  A1+A2*EXP(-A3*X1)*X2^A4
           MFIT=4
           MLIN=2
	     NREP=8
	     ASTART(3,1:NREP)=(/2.,2.,2.,2.,3.,4.,4.,4./)
	     ASTART(4,1:NREP)=(/.3,.5,1.,2.,2.,.5,1.,2./)
	     DO I=1,NREP
             ASTART(3,I)=ASTART(3,I)/AMAX1(1E-6,X1MA)
	     ENDDO
         CASE(10)
C MODEL=10 A1*EPX(-((X1-A2)/A3)^2-((X2-A4)/A5)^2)
           MFIT=5
           MLIN=1
	     NREP=9
	     ASTART(2,1:NREP)=(/.1,.5,.7,.1,.5,.7,.1,.5,.7/)
	     ASTART(3,1:NREP)=(/.1,.1,.1,.3,.3,.3,.7,.7,.7/)
	     ASTART(4,1:NREP)=(/.1,.5,.7,.1,.5,.7,.1,.5,.7/)
	     ASTART(5,1:NREP)=(/.1,.1,.1,.3,.3,.3,.7,.7,.7/)
	     DO I=1,NREP
	       OMG=ASTART(2,I)
	       ASTART(2,I)=X1MI*OMG+X1MA*(1-OMG)
	       ASTART(3,I)=(X1MA-X1MI)/ASTART(3,I)
	       OMG=ASTART(4,I)
	       ASTART(4,I)=X2MI*OMG+X2MA*(1-OMG)
	       ASTART(5,I)=(X2MA-X2MI)/ASTART(5,I)
           ENDDO
         CASE(11)
C MODEL=11 A1+A2*EPX(-((X1-A3)/A4)^2-((X2-A5)/A6)^2)
           MFIT=6
           MLIN=2
	     NREP=9
	     ASTART(3,1:NREP)=(/.1,.5,.7,.1,.5,.7,.1,.5,.7/)
	     ASTART(4,1:NREP)=(/.1,.1,.1,.3,.3,.3,.7,.7,.7/)
	     ASTART(5,1:NREP)=(/.1,.5,.7,.1,.5,.7,.1,.5,.7/)
	     ASTART(6,1:NREP)=(/.1,.1,.1,.3,.3,.3,.7,.7,.7/)
	     DO I=1,NREP
	       OMG=ASTART(3,I)
	       ASTART(3,I)=X1MI*OMG+X1MA*(1-OMG)
	       ASTART(4,I)=(X1MA-X1MI)/ASTART(4,I)
	       OMG=ASTART(5,I)
	       ASTART(5,I)=X2MI*OMG+X2MA*(1-OMG)
	       ASTART(6,I)=(X2MA-X2MI)/ASTART(6,I)
           ENDDO
	  CASE(12)
C MODEL=12 (A1+A2*X1)*X2*(1-X2)^(A4+A5*X2+A6*X1)+A3*(1-X2)
           MFIT=6
           MLIN=3
	     NREP=6
	     ASTART(4,1:NREP)=(/.5,.5,1.,1.,2.,2./)
	     ASTART(5,1:NREP)=(/2.,3.,2.,3.,2.,3./)
	     DO I=1,NREP
	       ASTART(6,I)=.1/X1MA
	     ENDDO
        END SELECT

        IF(NDATA.LE.MFIT.OR.MFIT.GT.NCVM)STOP

	  DO IREP=1,NREP
C Opakovani reseni pro tentyz model, ale s jinym nastrelem A(i)
        IF(NREP.GT.1)THEN
	     DO I=MLIN+1,MFIT
	        A(I)=ASTART(I,IREP)
	     ENDDO
	  ENDIF

        DO I=1,MLIN
          LISTA(I)=I
        ENDDO
        CALL LFIT2(X1,X2,Y,SIG,NDATA,A,MLIN,LISTA,MLIN,COVAR,NCVM,CHISQ,
     /                                                   FUNLIN2,IERROR)
	  IF(IERROR.LT.0)THEN
	     WRITE(*,*)' LINEARISATION FAILED IN MODEL',MODEL
           CHISQ=1E10
	     GOTO 888
        ENDIF
        WRITE(*,'('' Linearisation. Estimated parameters''/1X,7E10.3)')
     /(A(I),I=1,MFIT)
        DO I=1,MFIT
          LISTA(I)=I
        ENDDO
        ALAMDA=-1.
        CALL MRQMIN2(X1,X2,Y,SIG,NDATA,A,MFIT,LISTA,MFIT,COVAR,ALPHA,
     /NCVM,CHISQ,FUN2,ALAMDA,IER)
        WRITE(*,*)' MRQMIN (-1) IER=',IER
        IF(IER.NE.0)THEN
           CHISQ=1E10
           GOTO 888
        ENDIF
        DO ITER=1,50
           CALL MRQMIN2(X1,X2,Y,SIG,NDATA,A,MFIT,LISTA,MFIT,COVAR,ALPHA,
     /NCVM,CHISQ,FUN2,ALAMDA,IER)
           IF(IER.NE.0)THEN
              CHISQ=1E10
              GOTO 888
           ENDIF
           WRITE(*,'('' Model'',i2,'' Iter'',i2,'' chisq='',e12.5,'' Lam
     /='',e9.2)')MODEL,ITER,CHISQ,ALAMDA
           IF(ALAMDA.GT.1E5)EXIT
        ENDDO
        WRITE(*,'('' MODEL'',I3)')MODEL
        WRITE(*,'('' Final values of parameters''/1X,7E12.4)')
     /(A(I),I=1,MFIT)
        ALAMDA=0
        CALL MRQMIN2(X1,X2,Y,SIG,NDATA,A,MFIT,LISTA,MFIT,COVAR,ALPHA,
     /NCVM,CHISQ,FUN2,ALAMDA,IER)
        Q=GAMMQ(0.5*(NDATA-MFIT),0.5*CHISQ)
C
888     CONTINUE
        IF(CHISQ.LT.BEST)THEN
          BEST=CHISQ
          OPEN(1,FILE='RANNREG2.OUT')
          SELECT CASE(MODEL)
C MODEL=1  A1+A2*x1+A3*x2
C MODEL=2  A1+A2*x1+A3*x2+A4*x1*x2
C MODEL=3  A1+A2*x1+A3*x2+A4*x1*x2+A5*X1^2+A6*X2^2
C MODEL=4  A1+(A2+A3*X1+A4*X2)*EXP(A5*X1+A6*X2)
C MODEL=5  A1*x1^A2*x2^A3
C MODEL=6  A1+A2*x1^A3*x2^A4
C MODEL=7  A1+A2*X1^A3*X2^A4/(1+A5*X1^A6*X2^A7)
C MODEL=8  A1*EXP(-A2*X1)*X2^A3
C MODEL=9  A1+A2*EXP(-A3*X1)*X2^A4
C MODEL=10 A1*EPX(-((X1-A2)/A3)^2-((X2-A4)/A5)^2)
C MODEL=11 A1+A2*EPX(-((X1-A3)/A4)^2-((X2-A5)/A6)^2)
C MODEL=12 (A1+A2*X1)*X2*(1-X2)^(A4+A5*X2+A6*X1)+A3*(1-X2)
          CASE(1)
      WRITE(1,'('' Y= A1+A2.x1+A3.x2                               '')')
          CASE(2)
      WRITE(1,'('' Y= A1+A2.x1+A3.x2+A4.x1.x2                      '')')
          CASE(3)
      WRITE(1,'('' Y= A1+A2.x1+A3.x2+A4.x1.x2+A5.x1^2+A6.x2^2      '')')
          CASE(4)
      WRITE(1,'('' Y= A1+(A2+A3.x1+A4.x2).EXP(A5.x1+A6.x2)         '')')
          CASE(5)
      WRITE(1,'('' Y= A1.x1^A2.x2^A3                               '')')
          CASE(6)
      WRITE(1,'('' Y= A1+A2.x1^A3.x2^A4                            '')')
          CASE(7)
      WRITE(1,'('' Y= A1+A2.x1^A3.x2^A4/(1+A5.x1^A6.x2^A7)         '')')
          CASE(8)
      WRITE(1,'('' Y= A1*EXP(-A2*x1)*x2^A3                         '')')
          CASE(9)
      WRITE(1,'('' Y= A1+A2*EXP(-A3*X1)*X2^A4                      '')')
          CASE(10)
      WRITE(1,'('' Y= A1*EPX(-((X1-A2)/A3)^2-((X2-A4)/A5)^2)       '')')
          CASE(11)
      WRITE(1,'('' Y= A1+A2*EPX(-((X1-A3)/A4)^2-((X2-A5)/A6)^2)    '')')
	    CASE(12)
      WRITE(1,'('' Y=(A1+A2*X1)X2(1-X2)^(A4+A5*X2+A6*X1)+A3(1-X2)  '')')
          END SELECT
          SUMD=0
          SUMM=0
          YMI=1E10
          YMA=-1E10
          DO I=1,NDATA
            CALL FUN2(X1(I),X2(I),A,S,DYDA,MFIT)
            SUMD=SUMD+(Y(I)-S)**2
            SUMM=SUMM+(Y(I)-YMEAN)**2
            YMI=AMIN1(YMI,Y(I))
            YMA=AMAX1(YMA,Y(I))
          ENDDO
          IF(SUMM.GT.0.)R=SQRT(AMAX1(0.,1.-SUMD/SUMM))
          STDEV=SQRT(SUMD/(NDATA-MFIT))
          WRITE(1,1)MFIT,(A(LISTA(I)),I=1,MFIT)
1         FORMAT(I3,' -parameters:'/10E12.4)
          WRITE(1,2)NDATA,STDEV,R,CHISQ,Q
2         FORMAT(I5,' points Stdev=',E10.4,' R=',F6.4,' CHISQ=',E10.4,
     /' Probability=',E9.3/' Covariance matrix')
          DO I=1,MFIT
            WRITE(1,'(10E11.3)')(COVAR(I,J),J=1,MFIT)
          ENDDO
          WRITE(1,3)
3         FORMAT(' PREDICTION (X1,X2,Ydata,Ymodel)')
          DO I=1,NDATA
            CALL FUN2(X1(I),X2(I),A,S,DYDA,MFIT)
            WRITE(1,'(4E12.4)')X1(I),X2(I),Y(I),S
          ENDDO
          WRITE(1,4)X1MI,X1MA,X2MI,X2MA,YMI,YMA
4         FORMAT(' Range X1MIN,X1MAX, X2MIN,X2MAX, YMIN,YMAX'/6e11.3)
          DX1=(X1MA-X1MI)/99.
          DX2=(X2MA-X2MI)/9.
          DO I2=1,10
            XX2=X2MI+(I2-1)*DX2
            DO I1=1,100
               XX1=X1MI+(I1-1)*DX1
               CALL FUN2(XX1,XX2,A,S,DYDA,MFIT)
               WRITE(1,'(3E12.4)')XX1,XX2,S
            ENDDO
          ENDDO
          CLOSE(1)
        ENDIF
	ENDDO
      ENDDO
1000  CLOSE(1)
C      PAUSE
      END

      SUBROUTINE FUNLIN2(X1,X2,B,M)
C MODEL=1  A1+A2*x1+A3*x2
C MODEL=2  A1+A2*x1+A3*x2+A4*x1*x2
C MODEL=3  A1+A2*x1+A3*x2+A4*x1*x2+A5*X1^2+A6*X2^2
C MODEL=4  A1+(A2+A3*X1+A4*X2)*EXP(A5*X1+A6*X2)
C MODEL=5  A1*x1^A2*x2^A3
C MODEL=6  A1+A2*x1^A3*x2^A4
C MODEL=7  A1+A2*X1^A3*X2^A4/(1+A5*X1^A6*X2^A7)
C MODEL=8  A1*EXP(-A2*X1)*X2^A3
C MODEL=9  A1+A2*EXP(-A3*X1)*X2^A4
C MODEL=10 A1*EPX(-((X1-A2)/A3)^2-((X2-A4)/A5)^2)
C MODEL=11 A1+A2*EPX(-((X1-A3)/A4)^2-((X2-A5)/A6)^2)
C MODEL=12 (A1+A2*X1)*X2*(1-X2)^(A4+A5*X2+A6*X1)+A3*(1-X2)
      PARAMETER (NCVM=10)
      COMMON /$REGRES/MODEL,A(NCVM)
      DIMENSION B(*)
      MDUM=M
      B(1)=1
      SELECT CASE(MODEL)
      CASE(1)
        B(2)=X1
        B(3)=X2
      CASE(2)
        B(2)=X1
        B(3)=X2
        B(4)=X1*X2
      CASE(3)
        B(2)=X1
        B(3)=X2
        B(4)=X1*X2
        B(5)=X1**2
        B(6)=X2**2
      CASE(4)
        E=EXP(A(5)*X1+A(6)*X2)
        B(2)=E
        B(3)=E*X1
        B(4)=E*X2
      CASE(5)
        IF(X1.GT.0..AND.X2.GT.0.)B(1)=X1**A(2)*X2**A(3)
      CASE(6)
        IF(X1.GT.0..AND.X2.GT.0.)B(2)=X1**A(3)*X2**A(4)
      CASE(7)
        IF(X1.GT.0..AND.X2.GT.0.)B(2)=X1**A(3)*X2**A(4)/
     /                                (1+A(5)*X1**A(6)*X2**A(7))
	CASE(8)
	  IF(X2.GT.0.)B(1)=EXP(-A(2)*X1)*X2**A(3)
	CASE(9)
	  IF(X2.GT.0.)B(2)=EXP(-A(3)*X1)*X2**A(4)
	CASE(10)
	  B(1)=EXP(-((X1-A(2))/A(3))**2-((X2-A(4))/A(5))**2)
	CASE(11)
	  B(2)=EXP(-((X1-A(3))/A(4))**2-((X2-A(5))/A(6))**2)
      CASE(12)
	  E=X2*(1.-X2)**(A(4)+A(5)*X2+A(6)*X1)
	  B(1)=E
	  B(2)=X1*E
	  B(3)=1-X2
      ENDSELECT
      END      

      SUBROUTINE FUN2(X1,X2,A,Y,DYDA,M)
C MODEL=1  A1+A2*x1+A3*x2+A4*x1*x2
C MODEL=2  A1+(A2+A3*X1+A4*X2)*EXP(A5*X1+A6*X2)
C MODEL=3  A1*x1^A2*x2^A3
C MODEL=4  A1+A2*x1^A3*x2^A4
C MODEL=5  A1+A2*X1^A3*X2^A4/(1+A5*X1^A6*X2^A7)
C MODEL=6  A1+A2*x1^A3*x2^A4
C MODEL=7  A1+A2*X1^A3*X2^A4/(1+A5*X1^A6*X2^A7)
C MODEL=8  A1*EXP(-A2*X1)*X2^A3
C MODEL=9  A1+A2*EXP(-A3*X1)*X2^A4
C MODEL=10 A1*EPX(-((X1-A2)/A3)^2-((X2-A4)/A5)^2)
C MODEL=11 A1+A2*EPX(-((X1-A3)/A4)^2-((X2-A5)/A6)^2)
C MODEL=12 (A1+A2*X1)*X2*(1-X2)^(A4+A5*X2+A6*X1)+A3*(1-X2)
      PARAMETER (NCVM=10)
      COMMON /$REGRES/MODEL,AAA(NCVM)
      DIMENSION A(NCVM),DYDA(NCVM)
      MDUM=M
      DYDA(1)=1.
      SELECT CASE(MODEL)
      CASE(1)
        Y=A(1)+A(2)*X1+A(3)*X2
        DYDA(2)=X1
        DYDA(3)=X2
      CASE(2)
        Y=A(1)+A(2)*X1+A(3)*X2+A(4)*X1*X2
        DYDA(2)=X1
        DYDA(3)=X2
        DYDA(4)=X1*X2
      CASE(3)
        Y=A(1)+A(2)*X1+A(3)*X2+A(4)*X1*X2+A(5)*X1**2+A(6)*X2**2
        DYDA(2)=X1
        DYDA(3)=X2
        DYDA(4)=X1*X2
        DYDA(5)=X1**2
        DYDA(6)=X2**2
      CASE(4)
        E=EXP(A(5)*X1+A(6)*X2)
        S=A(2)+A(3)*X1+A(4)*X2
        Y=A(1)+S*E
        DYDA(2)=E
        DYDA(3)=X1*E
        DYDA(4)=X2*E
        DYDA(5)=S*E*X1
        DYDA(6)=S*E*X2
      CASE(5)
        X1A=AMAX1(1E-10,X1)
        E1=X1A**A(2)
        X2A=AMAX1(1E-10,X2)
        E2=X2A**A(3)
        Y=A(1)*E1*E2
        DYDA(1)=E1*E2
        DYDA(2)=A(1)*E1*ALOG(X1A)*E2
        DYDA(3)=A(1)*E2*ALOG(X2A)*E1
      CASE(6)
        X1A=AMAX1(1E-10,X1)
        E1=X1A**A(3)
        X2A=AMAX1(1E-10,X2)
        E2=X2A**A(4)
        Y=A(1)+A(2)*E1*E2
        DYDA(2)=E1*E2
        DYDA(3)=A(2)*E1*ALOG(X1A)*E2
        DYDA(4)=A(2)*E2*ALOG(X2A)*E1
      CASE(7)
        X1A=AMAX1(1E-10,X1)
        X2A=AMAX1(1E-10,X2)
        A(3)=AMIN1(3.,AMAX1(-3.,A(3)))
        A(4)=AMIN1(3.,AMAX1(-3.,A(4)))
        A(6)=AMIN1(3.,AMAX1(-3.,A(6)))
        A(7)=AMIN1(3.,AMAX1(-3.,A(7)))
        E3=X1A**A(3)
        E4=X2A**A(4)
        E6=X1A**A(6)
        E7=X2A**A(7)
        Q=A(2)*E3*E4
        B=1+A(5)*E6*E7
        AL1=ALOG(X1A)
        AL2=ALOG(X2A)
        IF(B.NE.0.)THEN
          Q=Q/B
          Y=A(1)+Q
          DYDA(2)=E3*E4/B
          DYDA(3)=Q*AL1
          DYDA(4)=Q*AL2
          DYDA(5)=-Q*E6*E7/B
          DYDA(6)=-Q*A(5)*E6*E7*AL1/B
          DYDA(7)=-Q*A(5)*E6*E7*AL2/B
        ENDIF
	CASE(8)
        X2A=AMAX1(1E-10,X2)
        A(3)=AMIN1(3.,AMAX1(-3.,A(3)))
        AL2=ALOG(X2A)
        E=EXP(-A(2)*X1)*X2A**A(3)
	  Y=A(1)*E
	  DYDA(1)=E
        DYDA(2)=-X1*Y
	  DYDA(3)=AL2*Y
	CASE(9)
        X2A=AMAX1(1E-10,X2)
        A(4)=AMIN1(3.,AMAX1(-3.,A(4)))
        AL2=ALOG(X2A)
        E=EXP(-A(3)*X1)*X2A**A(4)
	  Y=A(1)+A(2)*E
	  DYDA(2)=E
        DYDA(3)=-X1*Y
	  DYDA(4)=AL2*Y
      CASE(10)
	  A3=A(3)
	  A5=A(5)
	  IF(ABS(A3).LE.1E-10)A3=1
	  IF(ABS(A5).LE.1E-10)A5=1
	  E1=((X1-A(2))/A3)**2
	  E2=((X2-A(4))/A5)**2
	  E1=AMAX1(-20.,AMIN1(20.,E1))
	  E2=AMAX1(-20.,AMIN1(20.,E2))
	  E=EXP(-E1-E2)
	  Y=E*A(1)
	  DYDA(1)=E
	  DYDA(2)=2*Y*(X1-A(2))/A3**2
	  DYDA(3)=2*Y*(X1-A(2))**2/A3**3
	  DYDA(4)=2*Y*(X2-A(4))/A5**2
	  DYDA(5)=2*Y*(X2-A(4))**2/A5**3
      CASE(11)
	  A4=A(3)
	  A6=A(6)
	  IF(ABS(A4).LE.1E-10)A4=1
	  IF(ABS(A6).LE.1E-10)A6=1
	  E1=((X1-A(3))/A4)**2
	  E2=((X2-A(5))/A6)**2
	  E1=AMAX1(-20.,AMIN1(20.,E1))
	  E2=AMAX1(-20.,AMIN1(20.,E2))
	  E=EXP(-E1-E2)
	  Y=A(1)+E*A(2)
	  DYDA(2)=E
	  DYDA(3)=2*Y*(X1-A(3))/A4**2
	  DYDA(4)=2*Y*(X1-A(3))**2/A4**3
	  DYDA(5)=2*Y*(X2-A(5))/A6**2
	  DYDA(6)=2*Y*(X2-A(5))**2/A6**3
	CASE(12)
	  X12=AMAX1(1E-10,AMIN1(1.,1.-X2))
	  E=X2*X12**(A(4)+A(5)*X2+A(6)*X1)
	  DYDA(1)=E
	  DYDA(2)=E*X1
	  DYDA(3)=X12
        EE=(A(1)+A(2)*X1)*ALOG(X12)*E
	  DYDA(4)=EE
	  DYDA(5)=EE*X2
	  DYDA(6)=EE*X1	  
      END SELECT
      END

      SUBROUTINE COVSRT(COVAR,NCVM,MA,LISTA,MFIT)
      DIMENSION COVAR(NCVM,NCVM),LISTA(NCVM)
      DO J=1,MA-1
        DO I=J+1,MA
           COVAR(I,J)=0
        ENDDO
      ENDDO
      DO I=1,MFIT-1
         DO J=I+1,MFIT
            IF(LISTA(J).GT.LISTA(I))THEN
                COVAR(LISTA(J),LISTA(I))=COVAR(I,J)
            ELSE
                COVAR(LISTA(I),LISTA(J))=COVAR(I,J)
            ENDIF
         ENDDO
      ENDDO
      SWAP=COVAR(1,1)
      DO J=1,MA
         COVAR(1,J)=COVAR(J,J)
         COVAR(J,J)=0.
      ENDDO
      COVAR(LISTA(1),LISTA(1))=SWAP
      DO J=2,MFIT
         COVAR(LISTA(J),LISTA(J))=COVAR(1,J)
      ENDDO
      DO J=2,MA
         DO I=1,J-1
             COVAR(I,J)=COVAR(J,I)
         ENDDO
      ENDDO
      END

      SUBROUTINE GAUSSJ(A,N,NP,B,M,MP,ier)
C
C RESENI SOUSTAVY LINEARNICH ALGEBRAICKYCH ROVNIC GAUSS-JORDANOVOU ELIMINACI
C VSTUPNI PARAMETRY:
C N         - POCET RESENYCH ROVNIC
C M         - POCET RESENYCH PRAVYCH STRAN
C NP,MP     - DEKLARACNI ROZMERY A(NP,NP),B(NP,MP)
C VSTUPNI A VYSTUPNI PARAMETRY
C A(NP,NP)  - MATICE SOUSTAVY
C B(NP,MP)  - PRAVA STRANA A RESENI
C MAXIMALNI POCET ROVNIC = 100
C
C Numerical Recipes p. 28
C
      parameter (nmax=100)
      dimension a(np,np),b(np,mp),ipiv(nmax),indxr(nmax),indxc(nmax)
      ier=0
      do i=1,n
         ipiv(i)=0
      enddo
      do i=1,n
         big=0
         do j=1,n
             if(ipiv(j).ne.1)then
                   do k=1,n
                         if(ipiv(k).eq.0)then
                               if(abs(a(j,k)).ge.big)then
                                    big=abs(a(j,k))
                                    irow=j
				    icol=k
                               endif
                         elseif(ipiv(k).gt.1)then
                               IER=1
                               return
                         endif
                    enddo
               endif
          enddo
          ipiv(icol)=ipiv(icol)+1
          if(irow.ne.icol)then
              do l=1,n
                 dum=a(irow,l)
                 a(irow,l)=a(icol,l)
                 a(icol,l)=dum
              enddo
              do l=1,m
                 dum=b(irow,l)
                 b(irow,l)=b(icol,l)
                 b(icol,l)=dum
              enddo
          endif
          indxr(i)=irow
          indxc(i)=icol
          if(a(icol,icol).eq.0.)THEN
              IER=2
              return
          endif
          pivinv=1/a(icol,icol)
          a(icol,icol)=1
          do l=1,n
             a(icol,l)=a(icol,l)*pivinv
          enddo
          do l=1,m
             b(icol,l)=b(icol,l)*pivinv
          enddo
          do ll=1,n
              if(ll.ne.icol)then
                  dum=a(ll,icol)
                  a(ll,icol)=0
                  do l=1,n
                     a(ll,l)=a(ll,l)-a(icol,l)*dum
                  enddo
                  do l=1,m
                     b(ll,l)=b(ll,l)-b(icol,l)*dum
                  enddo
               endif
           enddo
      enddo
      do l=n,1,-1
         if(indxr(l).ne.indxc(l))then
            do k=1,n
               dum=a(k,indxr(l))
               a(k,indxr(l))=a(k,indxc(l))
               a(k,indxc(l))=dum
            enddo
         endif
      enddo
      end

      SUBROUTINE MRQMIN2(X1,X2,Y,SIG,NDATA,A,MA,LISTA,MFIT,COVAR,ALPHA,
     /                         NCA,CHISQ,FUNCS,ALAMDA,IER)
C Numerical recipes p.513
      PARAMETER (MMAX=10)
      DIMENSION X1(NDATA),X2(NDATA),Y(NDATA),SIG(NDATA),
     /          A(MA),LISTA(NCA),
     /          COVAR(NCA,NCA),ALPHA(NCA,NCA),
     /          ATRY(MMAX),BETA(MMAX), DA(MMAX)
      EXTERNAL FUNCS
      IER=0
      IF(ALAMDA.LT.0.)THEN
        KK=MFIT+1
        DO J=1,MA
           IHIT=0
           DO K=1,MFIT
              IF(LISTA(K).EQ.J)IHIT=IHIT+1
           ENDDO
           IF(IHIT.EQ.0)THEN
              LISTA(KK)=J
              KK=KK+1
           ELSEIF(IHIT.GT.1)THEN
              PAUSE 'Improper set in LISTA'
           ENDIF
        ENDDO
        IF(KK.NE.(MA+1))PAUSE' Improper set in LISTA'
        ALAMDA=0.001
        CALL MRQCOF2(X1,X2,Y,SIG,NDATA,A,MA,LISTA,MFIT,ALPHA,BETA,
     /              NCA,CHISQ,FUNCS)
        OCHISQ=CHISQ
        DO J=1,MA
           ATRY(J)=A(J)
        ENDDO
      ENDIF
      DO J=1,MFIT
         DO K=1,MFIT
            COVAR(J,K)=ALPHA(J,K)
         ENDDO
         COVAR(J,J)=ALPHA(J,J)*(1.+ALAMDA)
         DA(J)=BETA(J)
      ENDDO
      CALL GAUSSJ(COVAR,MFIT,NCA,DA,1,1,IER)
      IF(IER.NE.0)RETURN
      IF(ALAMDA.EQ.0.)THEN
         CALL COVSRT(COVAR,NCA,MA,LISTA,MFIT)
         RETURN
      ENDIF
      DO J=1,MFIT
        ATRY(LISTA(J))=A(LISTA(J))+DA(J)
      ENDDO
      CALL MRQCOF2(X1,X2,Y,SIG,NDATA,ATRY,MA,LISTA,MFIT,COVAR,DA,NCA,
     /            CHISQ,FUNCS)
      IF(CHISQ.LT.OCHISQ)THEN
         ALAMDA=ALAMDA*.1
         OCHISQ=CHISQ
         DO J=1,MFIT
            DO K=1,MFIT
              ALPHA(J,K)=COVAR(J,K)
            ENDDO
            BETA(J)=DA(J)
            A(LISTA(J))=ATRY(LISTA(J))
         ENDDO
      ELSE
         ALAMDA=10.*ALAMDA
         CHISQ=OCHISQ
      ENDIF
      END

      SUBROUTINE MRQCOF2(X1,X2,Y,SIG,NDATA,A,MA,LISTA,MFIT,
     /                 ALPHA,BETA,NALP,CHISQ,FUNCS)
      PARAMETER (MMAX=10)
      DIMENSION X1(NDATA),X2(NDATA),Y(NDATA),SIG(NDATA),
     /          ALPHA(NALP,NALP),BETA(MA),
     /          DYDA(MMAX),LISTA(MFIT),A(MA)
      DO J=1,MFIT
         DO K=1,J
            ALPHA(J,K)=0
         ENDDO
         BETA(J)=0.
      ENDDO
      CHISQ=0.
      DO I=1,NDATA
         CALL FUNCS(X1(I),X2(I),A,YMOD,DYDA,MA)
         IF(SIG(I).LE.0.)THEN
            SIG2I=0.
         ELSE
            SIG2I=1./(SIG(I)*SIG(I))
         ENDIF
         DY=Y(I)-YMOD
         DO J=1,MFIT
             WT=DYDA(LISTA(J))*SIG2I
             DO K=1,J
                ALPHA(J,K)=ALPHA(J,K)+WT*DYDA(LISTA(K))
             ENDDO
             BETA(J)=BETA(J)+DY*WT
         ENDDO
         CHISQ=CHISQ+DY*DY*SIG2I
      ENDDO
      DO J=2,MFIT
         DO K=1,J-1
            ALPHA(K,J)=ALPHA(J,K)
         ENDDO
      ENDDO
      END

      SUBROUTINE LFIT2(X1,X2,Y,SIG,NDATA,A,MA,LISTA,MFIT,COVAR,NCVM,
     /                CHISQ,FUNCS,IERROR)
C Numerical recipes p.513
      PARAMETER (MMAX=10)
      DIMENSION X1(NDATA),X2(NDATA),Y(NDATA),SIG(NDATA),
     /          A(MA),LISTA(NCVM),
     /          COVAR(NCVM,NCVM),BETA(MMAX), AFUNC(MMAX)
	IERROR=0
      KK=MFIT+1
      DO J=1,MA
         IHIT=0
         DO K=1,MFIT
            IF(LISTA(K).EQ.J)IHIT=IHIT+1
         ENDDO
         IF(IHIT.EQ.0)THEN
            LISTA(KK)=J
            KK=KK+1
         ELSEIF(IHIT.GT.1)THEN
            WRITE(*,*)'Improper set in LISTA'
	      IERROR=-1
	      RETURN
         ENDIF
      ENDDO
      IF(KK.NE.(MA+1))THEN
	   WRITE(*,*)' Improper set in LISTA'
	   IERROR=-2
	   RETURN
	ENDIF
      DO J=1,MFIT
         DO K=1,MFIT
            COVAR(J,K)=0.
         ENDDO
         BETA(J)=0.
      ENDDO
      DO I=1,NDATA
         CALL FUNCS(X1(I),X2(I),AFUNC,MA)
         YM=Y(I)
         IF(MFIT.LT.MA)THEN
             DO J=MFIT+1,MA
                YM=YM-A(LISTA(J))*AFUNC(LISTA(J))
             ENDDO
         ENDIF
         IF(SIG(I).LE.0.)THEN
            SIG2I=0.
         ELSE
            SIG2I=1./SIG(I)**2
         ENDIF
         DO J=1,MFIT
            WT=AFUNC(LISTA(J))*SIG2I
            DO K=1,J
               COVAR(J,K)=COVAR(J,K)+WT*AFUNC(LISTA(K))
            ENDDO
            BETA(J)=BETA(J)+YM*WT
         ENDDO
      ENDDO
      IF(MFIT.GT.1)THEN
         DO J=2,MFIT
            DO K=1,J-1
               COVAR(K,J)=COVAR(J,K)
            ENDDO
         ENDDO
      ENDIF
      CALL GAUSSJ(COVAR,MFIT,NCVM,BETA,1,1,IER)
      IF(IER.NE.0)THEN
         WRITE(*,*)'SINGULAR'
	   IERROR=-3
         RETURN
      ENDIF
      DO J=1,MFIT
          A(LISTA(J))=BETA(J)
      ENDDO
      CHISQ=0
      DO I=1,NDATA
          CALL FUNCS(X1(I),X2(I),AFUNC,MA)
          SUM=0
          DO J=1,MA
             SUM=SUM+A(J)*AFUNC(J)
          ENDDO
          IF(SIG(I).GT.0.)CHISQ=CHISQ+((Y(I)-SUM)/SIG(I))**2
      ENDDO
      CALL COVSRT(COVAR,NCVM,MA,LISTA,MFIT)
      END
