C  RUNDET.for  
C pocita celou odezvu na zaklade dat .OUT (na rozdil od RUNDET1, ktery
C pocita jen jeden bod odezvy pro data v pameti).
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEMLOC'
      DIMENSION IDET(MAXDET),IDCOL(MAXDET)
C
C IENDCHECK - signalizace vysledku =0 O.K. bez preruseni
C                                  =-1 chyba pri cteni dat
C                                  kod klavesy (Esc-27, Enter-13, ...)
      IENDCHECK=-1
      OPEN(1,FILE='$RUNFEM.BIN',FORM='BINARY',ERR=1000)
      CALL READBIN(1,IEND)
      IENDCHECK=0
      WRITE(*,'('' RUNDET read RUNFEM.BIN successfully'')')
      WRITE(*,'('' You can quit computation by pressing any key...'')')
C Binarni soubor pro zapis indexu elementu, ktere odpovidaji boxu x,y,z
      OPEN(6,FILE='$RUNBOX.BIN',ACCESS='DIRECT',RECL=4)
C Soubor uzlovych parametru historie
      OPEN(3,FILE=TRIM(PROBLEM)//'.OUT')
C Protokol vysledku
      OPEN(4,FILE='$RUNDET.OUT')
C
      IDOF=IP(1)
      ATTENUAT=RP(2)
      IATTENUAT=IP(3)
      IVIEW=IP(4)
      NDET=IP(5)
      IF(IVIEW.LE.0.OR.IVIEW.GT.6)THEN
         WRITE(4,*)' Incorrect method selected (1-6)'
         STOP
      ELSEIF(NDET.LE.0)THEN
         WRITE(4,*)' Incorrect number of detectors',NDET
         STOP
      ENDIF
      DO I=1,NDET
         IDET(I)=IP(2*I+4)
         IDCOL(I)=IP(2*I+5)
      ENDDO
      IF(KEYW.EQ.'DETDOF')THEN
        IAL=1
      ELSE
        IAL=2
      ENDIF
      CALL DETREC(IAL,IDOF,ATTENUAT,IATTENUAT,IVIEW,NDET,IDET,IDCOL)
      REWIND 1
      CALL WRITEBIN(1,0)
1000  CONTINUE
      END

      SUBROUTINE DETREC(IAL,IDOF,ATTENUAT,IATTENUAT,IVIEW,NDET,IDET,
     /                  IDCOL)
C IAL=1 Concentration defined as DOF IDOF
C IAL=2 Concentration defined as FUNCTION IDOF
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEMLOC'
      LOGICAL PRESSED
      CHARACTER*1 C
      DIMENSION  IDET(MAXDET),IDCOL(MAXDET),DET(MAXDET)
      WRITE(4,'('' Responses from results ['',A,''] calculated for'',i2,
     /''-detectors.''/'' Media attenuation'',e10.2,'' multiplied by func
     /tion'',i3/'' Algorithm used'',i2,'' (1-view factor, 2-with correct
     /ion to near points, 3,4-single ray, 5,6-triple ray)''/'' Detector 
     /  Column''/(2i9))')TRIM(PROBLEM),NDET,ATTENUAT,IATTENUAT,IVIEW,
     /(IDET(I),IDCOL(I),I=1,NDET)
      WRITE(4,'(/'' Processing'',i5,'' time steps, DT='',e10.3)')
     /NTSTEP,DTIME
C
      TIME=0.
      REWIND(3)
C cteni prvnich dvou casovych kroku do zony 2 a 4. 
      READ(3,*,END=53)
      READ(3,*,END=53,ERR=53)T1
      READ(3,*,END=53)
      DO I=1,ND
         READ(3,*,END=53,ERR=53)IDUM,(VAL(MAXND*(J-1)+I,2),J=1,MDOF)
      ENDDO
      READ(3,*,END=53,ERR=53)T2,DTTT,(RALGOR(I),I=39,45)
      READ(3,*,END=53)
      DO I=1,ND
         READ(3,*,END=53,ERR=53)IDUM,(VAL(MAXND*(J-1)+I,4),J=1,MDOF)
      ENDDO
      NGR=MIN0(NTSTEP,MAXNTS)
C Vynulovani 
      DO ITIME=1,NTSTEP
        DO WHILE(TIME.GT.T2)
C Pokud je interpolovana hodnota TIME vyssi nez horni hranice precteneho
C intervalu T2, cti novy casovy krok
           T1=T2
           DO I=1,ND
              DO J=1,MDOF
                IJ=MAXND*(J-1)+I
                VAL(IJ,2)=VAL(IJ,4)
              ENDDO
           ENDDO
           READ(3,*,END=52,ERR=52)T2,DTTT,(RALGOR(I),I=39,45)
           READ(3,*,END=52)
           DO I=1,ND
              READ(3,*,END=52,ERR=52)IDUM,(VAL(MAXND*(J-1)+I,4),
     /                                        J=1,MDOF)
           ENDDO
           WRITE(4,*)' LOADED DOF TIME=',T2
        ENDDO
C Linearni interpolace
        DT=T2-T1
        DO I=1,ND    
           DO J=1,MDOF
              IJ=MAXND*(J-1)+I
              IF(DT.GT.0.)THEN
                 DTR=(TIME-T1)/DT
                 VAL(IJ,3)=DTR*VAL(IJ,4)+(1.-DTR)*VAL(IJ,2)
              ELSE
                 VAL(IJ,3)=VAL(IJ,4)
              ENDIF
           ENDDO
        ENDDO
C
C TIME - aktualizovany pocatecni podminky (vsechny uzlove parametry)
C
        CALL DETEL(IAL,IDOF,ATTENUAT,IATTENUAT,
     /             IVIEW,NDET,IDET,ITIME,DET)
C
C Prenos vypoctenych odezev do specifikovanych sloupcu MOP
        IF(ITIME.GT.0.AND.ITIME.LE.MAXNTS)THEN
          YGR(ITIME,1)=TIME
          DO I=1,NDET
            IC=IDCOL(I)
            IF(IC.GT.1.AND.IC.LE.MAXSEL)THEN
		     YGR(ITIME,IC)=DET(I)
	         WRITE(4,'('' MOP('',I3,'','',I2,'')='',E10.3)')
     /               ITIME,IC,DET(I)
	      ENDIF
          ENDDO
        ENDIF
        TIME=TIME+DTIME
        PRESSED=PEEKCHARQQ()
        IF(PRESSED)THEN
            C=GETCHARQQ()
            IENDCHECK=ICHAR(C)
            GOTO 52
        ENDIF
      ENDDO
52    CLOSE(3)
      WRITE(*,'(1X,''Exit from RUNDET'')')
      RETURN
53    CLOSE(3)
      WRITE(*,'(1X,''Not enough data points-processing terminated'')')
      END

C      INCLUDE '$RUN-DET.FOR'
C      INCLUDE '$$-COME.FOR'
C      INCLUDE '$RUN-COL.FOR'