C RUNMND.for
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      PARAMETER (MAXT=10000)
      INCLUDE '$FEMLOC'
      DIMENSION IUET(3,MAXT),IUES(3,MAXT),INB(MAXT),XP(MAXT),YP(MAXT),
     /          IAUXC(MAXT),INDP(MAXT)
C
C IENDCHECK - signalizace vysledku =0 O.K. bez preruseni
C                                  =-1 chyba pri cteni dat
C                                  kod klavesy (Esc-27, Enter-13, ...)
      IENDCHECK=-1
      OPEN(1,FILE='$RUNFEM.BIN',FORM='BINARY',ERR=1000)
      CALL READBIN(1,IEND)
      IENDCHECK=0
      WRITE(*,'('' RUNND read RUNFEM.BIN successfully'')')
      WRITE(*,'('' You can quit computation by Ctrl C...'')')
      WRITE(*,*)
C Protokol vysledku
      OPEN(4,FILE='$RUNMND.OUT')
C parametry prikazoveho radku
      NFIRST=IP(1)
      NLAST=IP(2)
      NSTEP=IP(3)
      NU1=IABS(IP(4))
      NU2=IABS(IP(5))
      NEX=NU1-NU2
      CONTROL=RP(6)
      KGROUP=MAX0(1,KGROUP)
      KRCONS=MAX0(1,KRCONS)
      KMPROP=MAX0(1,KMPROP)
      N=0
      DO I=NFIRST,NLAST,NSTEP
        N=N+1
        XP(N)=XX(I)
        YP(N)=YY(I)
        INDP(N)=I
      ENDDO
C
C generovani trojuhelnikove site
C ======================================================
C
      WRITE(*,100)N,CONTROL
      WRITE(4,100)N,CONTROL
100   FORMAT(' FEMPT starts with',i6,' points. CONTROL=',f5.2)
      CALL FEMPT(XP,YP,N,CONTROL,IUET,NET,INB,NB,IAUXC)
      WRITE(*,101)NET
      WRITE(4,101)NET
101   FORMAT(' FEMPT ends giving',i6,' triangles.')
C
C ======================================================
C
C generuj uzly uprostred stran a elementy FEMINA
C
      NBAS=N
      DO IE=1,NET
        DO I1=1,3
           I2=MOD(I1,3)+1
           J1=IUET(I1,IE)
           J2=IUET(I2,IE)
           XT=(XP(J1)+XP(J2))*.5
           YT=(YP(J1)+YP(J2))*.5
           INEW=N+1
           DO J=NBAS+1,N
              DIST=(XT-XP(J))**2+(YT-YP(J))**2
              IF(DIST.LE.1E-6)THEN
                 INEW=J
                 EXIT
              ENDIF
           ENDDO
           N=MAX0(N,INEW)
           IUES(I1,IE)=INEW
           XP(INEW)=XT
           YP(INEW)=YT
           INDP(INEW)=ND+INEW-NBAS
        ENDDO
      ENDDO
C
C prenos vygenerovane site trojuhelniku do databaze
C
      DO I=NBAS+1,N
        XX(INDP(I))=XP(I)
        YY(INDP(I))=YP(I)
        ZZ(INDP(I))=0.
      ENDDO
      DO IET=1,NET
        IF(NEX.EQ.6)THEN
          NE=NE+1
          MUE(NE)=NU1
          MINT(NE)=NU2
          IGROUP(NE)=KGROUP
          IRCONS(NE)=KRCONS
          IMPROP(NE)=KMPROP
          L0=LUE(NE)
          DO I=1,3
            IUE(L0+I)=INDP(IUET(I,IET))
            IUE(L0+I+3)=INDP(IUES(I,IET))
          ENDDO
          LUE(NE+1)=LUE(NE)+NU1
        ELSEIF(NEX.EQ.3)THEN
          DO I=1,3
            NE=NE+1
            MUE(NE)=NU1
            MINT(NE)=NU2
            IGROUP(NE)=KGROUP
            IRCONS(NE)=KRCONS
            IMPROP(NE)=KMPROP
            L0=LUE(NE)
            IUE(L0+1)=INDP(IUET(I,IET))
            IUE(L0+2)=INDP(IUES(I,IET))
            K=MOD(I+1,3)+1
            IUE(L0+3)=INDP(IUES(K,IET))
            LUE(NE+1)=LUE(NE)+NU1
          ENDDO   
          NE=NE+1
          MUE(NE)=NU1
          MINT(NE)=NU2
          IGROUP(NE)=KGROUP
          IRCONS(NE)=KRCONS
          IMPROP(NE)=KMPROP
          L0=LUE(NE)
          DO I=1,3
            IUE(L0+I)=INDP(IUES(I,IET))
          ENDDO
          LUE(NE+1)=LUE(NE)+NU1
        ENDIF
      ENDDO
      ND=ND+N-NBAS
      REWIND 1
      CALL WRITEBIN(1,0)
1000  CONTINUE
      END

C     INCLUDE '$$-COMM.FOR'
C	INCLUDE '$$-COME.FOR'
C	INCLUDE '$RUN-COL.FOR'
	