C RUNMRG.for Algoritmus vroubeni uzavreneho obrysu CT
C
c$IF DEFINED (compaq)
      USE DFLIB
c$ELSE
c      USE MSFLIB
c$ENDIF
      PARAMETER (MAXQ=80000,MAXDIV=1000)
      INCLUDE '$FEMLOC'
C IC-cyklicky seznam, IUET-matice konektivity zakl.trojuhelniku, 
C IUES-stredy stran
      DIMENSION IUET(3,MAXQ),IUES(3,MAXQ),IEES(3,MAXQ),
     /          IC(MAXQ),IB(MAXQ),IQ(MAXQ),TCENTER(MAXQ),
     /          XP(MAXQ),YP(MAXQ),RX(3),XA(MAXDIV)
      LOGICAL REVERT
      DATA RX /-1.,1.,0./
C
C IENDCHECK - signalizace vysledku =0 O.K. bez preruseni
C                                  =-1 chyba pri cteni dat
C                                  kod klavesy (Esc-27, Enter-13, ...)
      IENDCHECK=-1
      OPEN(1,FILE='$RUNFEM.BIN',FORM='BINARY',ERR=1000)
      CALL READBIN(1,IEND)
      IENDCHECK=0
      WRITE(*,'('' RUNMRG read RUNFEM.BIN successfully'')')
      WRITE(*,*)
C Protokol vysledku
      OPEN(4,FILE='$RUNMRG.OUT')
C parametry prikazoveho radku
      ICON=MAX0(1,IP(1))
      NU1=IABS(IP(2))
      NU2=IABS(IP(3))
      NDIV=MAX0(3,IP(4))
      NITERS=IP(5)
      NITER=IABS(NITERS)
      NREFINE=IP(6)
      BWEIGHT=AMAX1(1.,RP(7))
      CONTROL=AMAX1(.8,AMIN1(1.5,RP(8)))
      NEX=NU1-NU2
      KGROUP=MAX0(1,KGROUP)
      KRCONS=MAX0(1,KRCONS)
      KMPROP=MAX0(1,KMPROP)
C N-pocet vygenerovanych uzlu
C NC-pocet uzlu cyklickeho seznamu
      NC=1
C Generovani hranicnich bodu  JCR-citac krivek obrysu ICONT

      DO JCR=1,MCONTOUR(ICON)
        ICURVE=ICONTOUR(JCR,ICON)
        NPCURVE=MCR(ICURVE)
C Doplneni bodu krivky ICURVE dle NXCR a FLAFI
C NPCURVE =2 nebo 3 pocet definicnich bodu krivky
C NNCURVE pocet uzlu na krivce (pocet useku NNCURVE-1)
        NNCURVE=NXCR(ICURVE)
        IF(NNCURVE.LE.2)NNCURVE=NDIV
        AX=FLAFI(ICURVE)
        IF(AX.EQ.0.)AX=1.
        NSEG=NNCURVE-1
        CALL FEMDIV(-1.,1.,XA,NSEG,AX)
C je treba zjistit spravnou orientaci krivky, ktera musi navazovat
C na predchozi krivku obrysu
        IF(JCR.EQ.1)THEN
C Vychozi krivka a prvni uzel cyklickeho seznamu
          KEND=ICR(2,ICURVE)
          REVERT=.FALSE.
          I1=ICR(1,ICURVE)
          XP(1)=PTX(I1)
          YP(1)=PTY(I1)
          IB(1)=1
          N=2
        ELSE
C Navazujici krivka
          IF(ICR(1,ICURVE).EQ.KEND)THEN
             REVERT=.FALSE.
             KEND=ICR(2,ICURVE)
          ELSEIF(ICR(2,ICURVE).EQ.KEND)THEN
             REVERT=.TRUE.
             KEND=ICR(1,ICURVE)
          ELSE
             WRITE(4,*)' RUNMRG-specified Contour is not closed. Stop.'
             STOP
          ENDIF
        ENDIF
C Generovani uzlu na krivce a doplnovat je do cyklickeho seznamu.
C Prvni uzel negenerujeme, protoze jiz musel byt vytvoren na predchozi
C krivce
        DO IX=2,NNCURVE
          XP(N)=0
          YP(N)=0
          DO I=1,NPCURVE
C RX= -1,1,0
C XA= -1,-.9, ..., .9,1 bezrozmerne delici body intervalu  (-1,1)
             ZX=XA(IX)*RX(I)
             IF(NPCURVE.EQ.2)THEN
                BI=(1+ZX)/2.
             ELSEIF(I.LE.2)THEN
                BI=(1+ZX)*ZX/2.
             ELSE
                BI=1-XA(IX)**2
             ENDIF
             IND=ICR(I,ICURVE)
             IF(REVERT)THEN
                IF(I.EQ.1)THEN
                   IND=ICR(2,ICURVE)
                ELSEIF(I.EQ.2)THEN
                   IND=ICR(1,ICURVE)
                ENDIF
             ENDIF
             XP(N)=XP(N)+PTX(IND)*BI
             YP(N)=YP(N)+PTY(IND)*BI
          ENDDO
C 
          IND=N
          N=N+1
C DOPLNIME index uzlu IND do seznamu hranicnich uzlu
          IC(NC)=NC+1
          NC=NC+1
	    IF(NC.GT.MAXQ)THEN
	        WRITE(4,*)' NC exceeds limits'
	        STOP
          ENDIF
          IB(NC)=IND
        ENDDO
      ENDDO
C uzavreme cyklicky seznam 
      N=N-1
      NC=NC-1
      IF(NC.GT.MAXQ.OR.NC.LE.0)THEN
        WRITE(4,*)' NC exceeds limits or zero'
        STOP
      ENDIF
      IC(NC)=1
      WRITE(4,44)NC
      WRITE(*,44)NC
44    FORMAT(' RUNMRG-Boundary points form cyclic list NC=',I4)
      DO I=1,NC
        WRITE(4,'('' IC('',I3,'')='',I3,'' IB('',i3,'')='',I3,
     /'' XP('',I3,'')='',F8.3,'' YP('',I3,'')='',F8.3)')I,IC(I),I,IB(I),
     /I,XP(I),I,YP(I)
      ENDDO

C
C generovani trojuhelnikove site
C ======================================================
C
      WRITE(*,100)N
      WRITE(4,100)N
      NBND=N
100   FORMAT(' Meshing starts with',i6,' boundary points.')
CTMESH zakladni trojuhelnikova sit
      CALL CTMESH(XP,YP,N,IC,IB,IQ,NC,IUET,NET,control)
CTSORT setrideni elementu dle souradnic teziste
	CALL CTSORT(XP,YP,IUET,NET,TCENTER)
CTMESM vyhlazeni prumerovanim souradnic sousedu IUES,IEES,IB jen jako pomocny vektor. Eliminace vitrnich elementu.
      CALL CTMESM(XP,YP,NBND,N,NDNEW,IUET,NET,IUES,IEES,IB,IQ,IC,
     /            BWEIGHT,NITER)
      WRITE(4,'('' Correction using boundary weight'',f6.1)')BWEIGHT
      N=NDNEW

      WRITE(*,101)NET
      WRITE(4,101)NET
101   FORMAT(' CTMESH ends giving',i6,' triangles.')
C
C ======================================================
C
C generuj uzly uprostred stran a elementy FEMINA
C
      DO I=1,NREFINE
        CALL MIDNOD(IUET,IUES,NET,XP,YP,N,MAXQ,NBND)
C Nove elementy 1:4
        NENEW=0
        DO IE=1,NET
          I1=IUET(1,IE)
          I2=IUET(2,IE)
          I3=IUET(3,IE)
          I4=IUES(1,IE)
          I5=IUES(2,IE)
          I6=IUES(3,IE)
          NENEW=NENEW+1
          IEES(1,NENEW)=I4
          IEES(2,NENEW)=I5
          IEES(3,NENEW)=I6
          NENEW=NENEW+1
          IEES(1,NENEW)=I1
          IEES(2,NENEW)=I4
          IEES(3,NENEW)=I6
          NENEW=NENEW+1
          IEES(1,NENEW)=I2
          IEES(2,NENEW)=I5
          IEES(3,NENEW)=I4
          NENEW=NENEW+1
          IEES(1,NENEW)=I3
          IEES(2,NENEW)=I6
          IEES(3,NENEW)=I5
        ENDDO
        NET=NENEW
        DO J=1,NET
          DO K=1,3
            IUET(K,J)=IEES(K,J)
          ENDDO
        ENDDO
      ENDDO

C Zaverecne vyhlazeni site jen kdyz je zadan zaporny pocet iteraci
C      IF(NREFINE.GT.0.AND.NITERS.LT.0)CALL CTSMOOT(XP,YP,NBND,N,
C     /                                IUET,NET,IUES,IB,BWEIGHT,NITER,N)
      IF(NITERS.LT.0)CALL CTSMOOT(XP,YP,NBND,N,
     /                                IUET,NET,IUES,IB,BWEIGHT,NITER,N)
      CALL MIDNOD(IUET,IUES,NET,XP,YP,N,MAXQ,NBND)
C
C prenos vygenerovane site trojuhelniku do databaze
C
      DO I=1,N
        XX(ND+I)=XP(I)
        YY(ND+I)=YP(I)
        ZZ(ND+I)=0.
      ENDDO
      DO IET=1,NET
        IF(NEX.EQ.6)THEN
          NE=NE+1
          MUE(NE)=NU1
          MINT(NE)=NU2
          IGROUP(NE)=KGROUP
          IRCONS(NE)=KRCONS
          IMPROP(NE)=KMPROP
          L0=LUE(NE)
          DO I=1,3
            IUE(L0+I)=IUET(I,IET)+ND
            IUE(L0+I+3)=IUES(I,IET)+ND
          ENDDO
          LUE(NE+1)=LUE(NE)+NU1
        ELSEIF(NEX.EQ.3)THEN
          DO I=1,3
            NE=NE+1
            MUE(NE)=NU1
            MINT(NE)=NU2
            IGROUP(NE)=KGROUP
            IRCONS(NE)=KRCONS
            IMPROP(NE)=KMPROP
            L0=LUE(NE)
            IUE(L0+1)=IUET(I,IET)+ND
            IUE(L0+2)=IUES(I,IET)+ND
            K=MOD(I+1,3)+1
            IUE(L0+3)=IUES(K,IET)+ND
            LUE(NE+1)=LUE(NE)+NU1
          ENDDO   
          NE=NE+1
          MUE(NE)=NU1
          MINT(NE)=NU2
          IGROUP(NE)=KGROUP
          IRCONS(NE)=KRCONS
          IMPROP(NE)=KMPROP
          L0=LUE(NE)
          DO I=1,3
            IUE(L0+I)=IUES(I,IET)+ND
          ENDDO
          LUE(NE+1)=LUE(NE)+NU1
        ENDIF
      ENDDO
      ND=ND+N
      REWIND 1
      CALL WRITEBIN(1,0)
1000  CONTINUE
      END

      SUBROUTINE MIDNOD(IUET,IUES,NET,XP,YP,N,MAXQ,NBND)
      DIMENSION IUET(3,*),IUES(3,*),XP(*),YP(*)
      NBAS=N
      DO IE=1,NET
        DO I1=1,3
           I2=MOD(I1,3)+1
           J1=IUET(I1,IE)
           J2=IUET(I2,IE)
           XT=(XP(J1)+XP(J2))*.5
           YT=(YP(J1)+YP(J2))*.5
           INEW=N+1
C U teto verze neztotoznujeme uzly, lezici na hranici oblasti
	     IF(J1.GT.NBND.AND.J2.GT.NBND)THEN
             DO J=NBAS+1,N
              DIST=(XT-XP(J))**2+(YT-YP(J))**2
              IF(DIST.LE.1E-6)THEN
                 INEW=J
                 EXIT
              ENDIF
             ENDDO
	     ENDIF
           N=MAX0(N,INEW)
           IF(N.GT.MAXQ)THEN
              WRITE(4,*)' Number of nodes exeeds',maxq
              STOP
           ENDIF
           IUES(I1,IE)=INEW
           XP(INEW)=XT
           YP(INEW)=YT
        ENDDO
      ENDDO
      END

      SUBROUTINE CTSMOOT(XP,YP,NB,NDNEW,IUE,NENEW,
     /    ISU,IB,BWEIGHT,NITER,NDIM)
C
C Modifikace souradnic uzlu elementu. 
C ISU(N,*) -indexy sousednich uzlu,
C ISE(N,*) -indexy sousednich elementu, IB-pocet sousedu, 
C Attractivity hranicnich bodu jsou definovany vahou BWEIGHT
C
      DIMENSION XP(*),YP(*),IUE(3,*),ISU(NDIM,*),IB(*)
C 
C MODIFIKACE SOURADNIC UZLU
C
      CALL NEIGHU(IUE,ISU,IB,NDNEW,NENEW,NDIM)
      ALFA=.4
      DO ITER=1,NITER
        DO I=NB+1,NDNEW
          XA=0
          YA=0
          NS=IB(I)
          IF(NS.GT.4)THEN
            W=0.
            DO J=1,NS
              IS=ISU(I,J)
              IF(IS.LE.NB)THEN
                 B=BWEIGHT
              ELSE
                 B=1.
              ENDIF
              XA=XA+XP(IS)*B
              YA=YA+YP(IS)*B
              W=W+B
            ENDDO
            XP(I)=XP(I)*ALFA+XA/W*(1-ALFA)
            YP(I)=YP(I)*ALFA+YA/W*(1-ALFA)
          ENDIF
        ENDDO
      ENDDO
      END

      SUBROUTINE NEIGHU(IUE,ISU,IB,N,NE,NDIM)
C Vyhledani sousedu
      DIMENSION IUE(3,*),ISU(NDIM,*),IB(*)
      LOGICAL NEW
      DO I=1,N
         IB(I)=0
      ENDDO
      DO I=1,N
         DO IE=1,NE
            DO K=1,3
               IF(I.EQ.IUE(K,IE))THEN
C Dva potencialni sousede K1,K2 uzlu I
                  K1=K
                  DO J=1,2
                     K1=MOD(K1,3)+1
                     IS=IUE(K1,IE)
                     NEW=.TRUE.
                     DO L=1,IB(I)
                        IF(ISU(I,L).EQ.IS)THEN
                           NEW=.FALSE.
                           EXIT
                        ENDIF
                     ENDDO
                     IF(NEW)THEN
                        IB(I)=IB(I)+1
                        ISU(I,IB(I))=IS
                     ENDIF
                  ENDDO
               ENDIF
            ENDDO
         ENDDO
      ENDDO
      END

      SUBROUTINE CTMESM(XP,YP,NB,NDOLD,NDNEW,IUE,NE,
     /    ISU,ISE,IB,IDE,IDU,BWEIGHT,NITER)
C
C Nahrazeni elementu slozenych ze 3 vnitrnich trojuhelniku jedinym elementem,
C a elementu ze 4 trojuhelniku dvema elementy
C Modifikace souradnic uzlu elementu. 
C ISU(N,*) -indexy sousednich uzlu,
C ISE(N,*) -indexy sousednich elementu, IB-pocet sousedu, 
C IDE-priznak zruseneho elementu, IDU-priznak zruseneho uzlu
C Attractivity hranicnich bodu jsou definovany vahou BWEIGHT
C
      DIMENSION XP(*),YP(*),IUE(3,*),ISU(NDOLD,*),ISE(NDOLD,*),IB(*),
     /          IDE(*),IDU(*)
      LOGICAL NEW
C DO WHILE existuje trojuhelnik s vnitrnim uzlem
      NDNEW=NDOLD
      NENEW=NE
      ICOUNT=0
      NEW=.TRUE.
      DO WHILE(NEW)
        ICOUNT=ICOUNT+1
        WRITE(4,'('' CTMESM-Loop'',I2,'' ND='',I4,'' NE='',I4,'' NB='',
     /I4)')ICOUNT,NDNEW,NENEW,NB
        CALL NEIGHB(IUE,ISU,ISE,IB,NDNEW,NENEW,NDOLD)
C
C VYHLEDANI UZLU, KTERE MAJI PRAVE 3 SOUSEDY (s vyjimkou hranicnich uzlu)
C
        DO I=1,NDNEW
           IDU(I)=0
        ENDDO
        DO I=1,NENEW
           IDE(I)=0
        ENDDO
        NEW=.FALSE.
        DO I=NB+1,NDNEW
           IF(IB(I).EQ.3)THEN
              WRITE(4,'('' CTMESM-node'',I4,'' and connected elements'',
     /3I4)')I,(ISE(I,J),J=1,3)
              NEW=.TRUE.
              DO J=1,3
                INDE=ISE(I,J)
                IF(INDE.LE.0)THEN
                   WRITE(4,'('' ERROR zero index of neighbour el.'')')
                   RETURN
                ENDIF
                IDE(INDE)=1
              ENDDO
              IDU(I)=1
C Novy element
              DO J=1,3
                IUE(J,INDE)=ISU(I,J)
              ENDDO
              IDE(INDE)=0
           ENDIF
        ENDDO
C
C Vynechani predznackovanych elementu a uzlu (zmena matice konektivity)
C
        CALL DELEN(IUE,NENEW,XP,YP,NDNEW,IDE,IDU)
        WRITE(4,'('' CTMESM-purge, NODES ND='',I4,'' NE='',I4)')
     /        NDNEW,NENEW

      ENDDO
C
C vsechny vnitrni trojuhelniky jsou eliminovany
C podobna procedura pro 4-uhelniky
C
      ICOUNT=0
      NEW=.TRUE.
      DO WHILE(NEW)
        ICOUNT=ICOUNT+1
        WRITE(4,'('' CTMESM-4Loop'',I2,'' ND='',I4,'' NE='',I4,'' NB='',
     /I4)')ICOUNT,NDNEW,NENEW,NB
        CALL NEIGHB(IUE,ISU,ISE,IB,NDNEW,NENEW,NDOLD)
C
C VYHLEDANI UZLU, KTERE MAJI PRAVE 4 SOUSEDY (s vyjimkou hranicnich uzlu)
C
        DO I=1,NDNEW
           IDU(I)=0
        ENDDO
        DO I=1,NENEW
           IDE(I)=0
        ENDDO
        NEW=.FALSE.
        DO I=NB+1,NDNEW
           IF(IB(I).EQ.4)THEN
              WRITE(4,'('' CTMESM-node'',I4,'' and connected elements'',
     /4I4)')I,(ISE(I,J),J=1,4)
              NEW=.TRUE.
C Vyhledani souseda ISMAX s nejvetsim poctem sousedu NSMAX
              NSMAX=0
              ISMAX=0
              DO J=1,4
                INDE=ISE(I,J)
                IF(INDE.LE.0)THEN
                   WRITE(4,'('' ERROR zero index of neighbour el.'')')
                   RETURN
                ENDIF
                IDE(INDE)=1
                INDU=ISU(I,J)
                IF(IB(INDU).GT.NSMAX)THEN
                   ISMAX=INDU
                   NSMAX=IB(INDU)
                ENDIF
              ENDDO
              IDU(I)=1
C Dva nove elementy IE1,IE2
              IE1=ISE(I,1)
              IE2=ISE(I,2)
              IDE(IE1)=0
              IDE(IE2)=0
              IUE(1,IE1)=ISMAX
              IC1=1
              IC2=0
              DO J=1,4
                INDS=ISU(I,J)
                IF(INDS.NE.ISMAX)THEN
                  DO K=1,IB(INDS)
                     IF(ISU(INDS,K).EQ.ISMAX)THEN
                       IC1=IC1+1
                       IUE(IC1,IE1)=INDS
                     ENDIF
                  ENDDO
                  IC2=IC2+1
                  IUE(IC2,IE2)=INDS
                ENDIF
              ENDDO
           ENDIF
        ENDDO
C
C Vynechani predznackovanych elementu a uzlu (zmena matice konektivity)
C
        CALL DELEN(IUE,NENEW,XP,YP,NDNEW,IDE,IDU)
        WRITE(4,'('' CTMESM-purge, NODES ND='',I4,'' NE='',I4)')
     /        NDNEW,NENEW
      ENDDO
      NE=NENEW
C 
C MODIFIKACE SOURADNIC UZLU
C
      ALFA=.6
      DO ITER=1,NITER
        DO I=NB+1,NDNEW
          XA=0
          YA=0
          NS=IB(I)
          IF(NS.GT.0)THEN
            W=0.
            DO J=1,NS
              IS=ISU(I,J)
              IF(IS.LE.NB)THEN
                 B=BWEIGHT
              ELSE
                 B=1.
              ENDIF
              XA=XA+XP(IS)*B
              YA=YA+YP(IS)*B
              W=W+B
            ENDDO
            XP(I)=XP(I)*ALFA+XA/W*(1-ALFA)
            YP(I)=YP(I)*ALFA+YA/W*(1-ALFA)
          ENDIF
        ENDDO
      ENDDO
	WRITE(4,'('' CTMESM-'',i6,''-iterations using relfact'',f5.2,
     /'' boundary weight='',f6.2)')NITER,ALFA,BWEIGHT
      END

      SUBROUTINE NEIGHB(IUE,ISU,ISE,IB,N,NE,NDIM)
C Vyhledani sousedu
      DIMENSION IUE(3,*),ISU(NDIM,*),ISE(NDIM,*),IB(*)
      LOGICAL NEW
      DO I=1,N
         IB(I)=0
         DO J=1,4
           ISE(I,J)=0
         ENDDO
      ENDDO
      DO I=1,N
         DO IE=1,NE
            DO K=1,3
               IF(I.EQ.IUE(K,IE))THEN
C Dva potencialni sousede K1,K2 uzlu I
                  K1=K
                  DO J=1,2
                     K1=MOD(K1,3)+1
                     IS=IUE(K1,IE)
                     NEW=.TRUE.
                     DO L=1,IB(I)
                        IF(ISU(I,L).EQ.IS)THEN
                           NEW=.FALSE.
                           EXIT
                        ENDIF
                     ENDDO
                     IF(NEW)THEN
                        IB(I)=IB(I)+1
                        ISU(I,IB(I))=IS
                     ENDIF
                  ENDDO
                  DO J=1,4
                     IF(ISE(I,J).EQ.0)THEN
                        ISE(I,J)=IE
                        EXIT
                     ENDIF
                  ENDDO
               ENDIF
            ENDDO
         ENDDO
      ENDDO
      END

      SUBROUTINE DELEN(IUE,NENEW,XP,YP,NDNEW,IDE,IDU)
C
C Vynechani zrusenych elementu (ide=1) a uzlu (idu=1)
C
      DIMENSION IUE(3,*),XP(*),YP(*),IDE(*),IDU(*)
C Nejprve elementy
      NE=NENEW
      IE=1
      DO WHILE(IE.LE.NE)
         IF(IDE(IE).NE.0)THEN
            DO J=IE,NE-1
               DO K=1,3
                  IUE(K,J)=IUE(K,J+1)
               ENDDO
               IDE(J)=IDE(J+1)
            ENDDO
            IDE(NE)=0
            NENEW=NENEW-1
         ELSE
            IE=IE+1
         ENDIF
      ENDDO
C
C Vynechani zrusenych uzlu a jejich precislovani ve vsech elementech
C
      ND=NDNEW
      IU=1
      DO WHILE(IU.LE.ND)
         IF(IDU(IU).NE.0)THEN
           DO J=IU,ND-1
              XP(J)=XP(J+1)
              YP(J)=YP(J+1)
              IDU(J)=IDU(J+1)
           ENDDO
           IDU(ND)=0
           NDNEW=NDNEW-1
           DO J=1,NENEW
              DO K=1,3
                 IF(IUE(K,J).GE.IU)IUE(K,J)=IUE(K,J)-1
              ENDDO
           ENDDO
         ELSE
           IU=IU+1
         ENDIF
      ENDDO
      END

	SUBROUTINE CTSORT(XP,YP,IUET,NE,TCENTER)
C SETRIDENI ELEMENTU
	DIMENSION XP(*),YP(*),IUET(3,*),TCENTER(*)
	LOGICAL SORTED
	DO I=1,NE
	  XT=0
	  YT=0
	  DO J=1,3
	    K=IUET(J,I)
	    XT=XT+XP(K)
	    YT=YT+YP(K)
	  ENDDO
	  TCENTER(I)=XT+YT
	ENDDO
      SORTED=.FALSE.
	DO WHILE(.NOT.SORTED)
        SORTED=.TRUE.
	  DO I=1,NE-1
	    IF(TCENTER(I).GT.TCENTER(I+1))THEN
	       SORTED=.FALSE.
	       A=TCENTER(I)
	       TCENTER(I)=TCENTER(I+1)
	       TCENTER(I+1)=A
	       DO K=1,3
	          IA=IUET(K,I)
	          IUET(K,I)=IUET(K,I+1)
	          IUET(K,I+1)=IA
	       ENDDO
	    ENDIF
	  ENDDO
	ENDDO
	END

	SUBROUTINE BACK(J0,IC,IQ,NC)
C
C Zpetny seznam IQ z dopredneho cyklickeho seznamu IC
C
	DIMENSION IC(*),IQ(*)
	J1=J0
	NC=0
	DO WHILE(.TRUE.)
	  NC=NC+1
	  J2=IC(J1)
	  IQ(J2)=J1
	  IF(J2.EQ.J0)THEN
	     IQ(J0)=J1
	     EXIT
	  ENDIF
	  J1=J2
	ENDDO
	END

	SUBROUTINE ANGLES(J0,IC,IQ,IB,XP,YP,ANGMIN,JMIN)
C
C Vypocet vnitrnich uhlu cyklickeho seznamu IC,IQ (IQ-zpetny cyklicky seznam)
C Hlava seznamu J0
C ic(I),iq(I) naslednik predchudce
C ib(i) index souradnic XP,YP
C angles  MINIMALNI UHEL uhel
C
	DIMENSION XP(*),YP(*),IC(*),IQ(*),IB(*)
	J2=J0
	JMIN=0
	ANGMIN=100.
	DO WHILE(.TRUE.)
	  J3=IC(J2)
	  J1=IQ(J2)
	  I3=IB(J3)
	  I2=IB(J2)
	  I1=IB(J1)
	  ANG=PTANGLE(XP(I1),YP(I1),XP(I2),YP(I2),XP(I3),YP(I3),IER)
        IF(ANG.LT.ANGMIN)THEN
	     ANGMIN=ANG
	     JMIN=J2
	  ENDIF
	  IF(J3.EQ.J0)EXIT
	  J2=J3
	ENDDO
	END

      SUBROUTINE CTMESH(XP,YP,N,IC,IB,IQ,NC,IUE,NE,CONTROL)
      DIMENSION XP(*),YP(*),IC(*),IB(*),IQ(*),IUE(3,*)
C XP(N),YP(N) - uzlove body (na vstupu pouze N-hranicnich bodu obrysu)
C IC(NC),IQ(NC) - cyklicky seznam nasledniku, predchudcu
C IB(NC)      - index uzlu XP,YP
C N - vstupni i vystupni parametr
C CONTROL - urcuje miru vysky generovanych elementu
C CONEAR  - relativni vzdalenost prohledavani
      PARAMETER (PI=3.141)
      NE=0
      J0=1
      DO WHILE(NC.GT.3)
        WRITE(4,'(/'' CTMESH NE='',I5,'' Nod='',I5,'' NC='',I4)')NE,N,NC
	  CALL BACK(J0,IC,IQ,NC)            
	  CALL ANGLES(J0,IC,IQ,IB,XP,YP,ANGMIN,JMIN)
	  IF(ANGMIN.LE.0.)THEN
	    WRITE(4,*)' ZERO ANGLE. QUIT'
	    STOP
	  ELSE
	    CALL TRIGEN(ANGMIN,JMIN,IC,IQ,IB,XP,YP,N,IUE,NE,CONTROL)
	    J0=JMIN
	  ENDIF
	ENDDO
	END

      SUBROUTINE TRIGEN(ANGLE,J2,IC,IQ,IB,XP,YP,N,IUE,NE,CONTROL)
	DIMENSION IC(*),IQ(*),IB(*),XP(*),YP(*),IUE(3,*)
	J3=IC(J2)
	J1=IQ(J2)
	I1=IB(J1)
	I2=IB(J2)
	I3=IB(J3)
	IF(ANGLE.LE.1.6)THEN
C 1T
        NE=NE+1
	  IUE(1,NE)=I1
	  IUE(2,NE)=I2
	  IUE(3,NE)=I3
	  IC(J1)=J3
	  J2=J1
      ELSE
C 2T  N-index noveho uzlu
        N=N+1
        X1=XP(I1)
	  Y1=YP(I1)
        X2=XP(I2)
	  Y2=YP(I2)
        X3=XP(I3)
	  Y3=YP(I3)
	  XT=(X1+X3)/2
	  YT=(Y1+Y3)/2
        REL=1.88*CONTROL
        XP(N)=X2+REL*(XT-X2)        
        YP(N)=Y2+REL*(YT-Y2)        
	  IB(J2)=N
	  NE=NE+1
	  IUE(1,NE)=I1
	  IUE(2,NE)=I2
	  IUE(3,NE)=N
	  NE=NE+1
	  IUE(1,NE)=I2
	  IUE(2,NE)=I3
	  IUE(3,NE)=N
      ENDIF
	END
