      SUBROUTINE TINE(IA,ILST,KA,TFU,RES)
C
C ͻ
C  Interpret RPN v jednoduche presnosti (logicke a relacni operatory)    
C ͼ
C
C IA - vektor RPN (posledni kod je ILST)
C KA - vektor promennych a konstant odkazovany kodem RPN
C RES - vysledek, tj. hodnota vyrazu. Skutecny parametr musi byt
C       realny!!
C
C COMMON /SCOM/IER,INDEX   - index posledne vycislovaneho vektoru 
C                            (ma vyznam pro proceduru LOVARI)
C
C Zasobnik double precision 24.9.2004
C
      INTEGER *2 ITYP,IST,IRPN,IREAL
      DOUBLE PRECISION DS1,DS2,DRES,SLIFO(20),SLIF
      DIMENSION IA(*),KA(*),SLIFO4(20)
      COMMON /SCOM/IER,INDEX,F(48)
      EQUIVALENCE (R,IR)
      IER=0
C IRPN - citac kodu 1,2,...,ILST
C IST  - ukazovatko zasobniku. Zvysuje se pri zpracovani operandu (do zasobniku)
C        snizuje se po provedeni binarni operace
      IST=0
      IRPN=0
1     IRPN=IRPN+1
      IF(IRPN.GT.ILST) GOTO 1000
      ICOD=IA(IRPN)
      IF (ICOD) 100,1000,200
C
C Operandy zaporna hodnota IA(IRPN) je vzdy dvojice -ICOD,ITYP
C ITYP
C =1 Real do zasobniku
C =2 Integer do zasobniku
C =3 vrchol zasobniku je index a prepise se prvkem vektoru Real
C =4 vrchol zasobniku je index a prepise se prvkem vektoru Intg
C =5 adresa real do zasobniku (pro prirazeni). Promenna IREAL typ promenne R=..
C =6 adresa integer do zasobniku (pro prirazeni)
C =7 adresa realneho vektoru do zasobniku A():=...
C =8 adresa integer vektoru do zasobniku M():=...
C                 
100   ICOD=-ICOD
      IRPN=IRPN+1
      ITYP=IA(IRPN)
      IF(IST.GT.19) GOTO 7000
      GO TO (101,102,103,104,105,106,107,108), ITYP
101   IST=IST+1
      IR=KA(ICOD)
      SLIFO(IST)=DBLE(R)
      GO TO 1
102   IST=IST+1
      SLIFO(IST)=FLOAT(KA(ICOD))
      GO TO 1
103   INDEX=MAX0(1,NINT(SLIFO(IST)))+ICOD-1
      IR=KA(INDEX)
      SLIFO(IST)=R
      GO TO 1
104   INDEX=MAX0(1,NINT(SLIFO(IST)))+ICOD-1
      SLIFO(IST)=FLOAT(KA(INDEX))
      GO TO 1
105   IST=IST+1
      SLIFO(IST)=ICOD
      IREAL=1
      GO TO 1
106   IST=IST+1
      SLIFO(IST)=ICOD
      IREAL=0
      GO TO 1
107   SLIFO(IST)=MAX0(1,NINT(SLIFO(IST)))+ICOD-1
      IREAL=1
      GO TO 1
108   SLIFO(IST)=MAX0(1,NINT(SLIFO(IST)))+ICOD-1
      IREAL=0
      GO TO 1
C Operace
200   IF (ICOD.LT.17) IST=IST-1
      IF (ICOD.GT.25) GO TO 500
      IF (IST) 2000,2000,201
201   GO TO (202,203,204,205,206,207,208,209,
     /       210,220,230,240,250,260,1000,1000,1000,300,310,
     /       320,330,340,350,360,370), ICOD
C 1 relace A<=B
202   IF(SLIFO(IST).LE.SLIFO(IST+1))THEN
         SLIFO(IST)=1.
      ELSE
         SLIFO(IST)=0.
      ENDIF
      GOTO 1
C 2 relace A>=B
203   IF(SLIFO(IST).GE.SLIFO(IST+1))THEN
         SLIFO(IST)=1.
      ELSE
         SLIFO(IST)=0.
      ENDIF
      GOTO 1
C 3 relace .NE.
204   IF(ABS(SLIFO(IST)-SLIFO(IST+1)).GT.ABS(SLIFO(IST))*1E-5)THEN
         SLIFO(IST)=1.
      ELSE
         SLIFO(IST)=0.
      ENDIF
      GOTO 1
C 4 relace A<B
205   IF(SLIFO(IST).LT.SLIFO(IST+1))THEN
         SLIFO(IST)=1.
      ELSE
         SLIFO(IST)=0.
      ENDIF
      GOTO 1
C 5 relace A>B
206   IF(SLIFO(IST).GT.SLIFO(IST+1))THEN
         SLIFO(IST)=1.
      ELSE
         SLIFO(IST)=0.
      ENDIF
      GOTO 1
C 6 relace .EQ.
207   IF(ABS(SLIFO(IST)-SLIFO(IST+1)).LE.ABS(SLIFO(IST))*1E-5)THEN
         SLIFO(IST)=1.
      ELSE
         SLIFO(IST)=0.
      ENDIF
      GOTO 1
C 7 operace .AND.
208   IF(ABS(SLIFO(IST)).GT.1E-5.AND.ABS(SLIFO(IST+1)).GT.1E-5)THEN
         SLIFO(IST)=1.
      ELSE
         SLIFO(IST)=0.
      ENDIF
      GOTO 1
C 8 operace .OR.
209   IF(ABS(SLIFO(IST)).GT.1E-5 .OR.ABS(SLIFO(IST+1)).GT.1E-5)THEN
         SLIFO(IST)=1.
      ELSE
         SLIFO(IST)=0.
      ENDIF
      GOTO 1
C 9 scitani
210   SLIFO(IST)=SLIFO(IST)+SLIFO(IST+1)
      GO TO 1
C 10 odcitani
220   SLIFO(IST)=SLIFO(IST)-SLIFO(IST+1)
      GO TO 1
C 11 mocnina
230   EX =SLIFO(IST+1)
      IEX=IFIX(EX+0.5)
      IF (ABS(EX-FLOAT(IEX)).LE.1E-3) GO TO 232
      IF (ABS(EX).GT.1E3)GOTO 2500
      IF (SLIFO(IST)) 2500,232,231
C realny exponent
231   SLIFO(IST)=SLIFO(IST)**EX
      GO TO 1
C celociselny exponent
232   SLIFO(IST)=SLIFO(IST)**IEX
      GO TO 1
C 12 deleni
240   DS1=SLIFO(IST)
      DS2=SLIFO(IST+1)
      IF(DABS(DS2).LE.1D-40)GOTO 5000
      DRES=DS1/DS2
      IF(DABS(DRES).GT.1D30)DRES=1D20
      SLIFO(IST)=DRES
      GO TO 1
C 13 nasobeni
250   DS1=SLIFO(IST)
      DS2=SLIFO(IST+1)
      DRES=DS1*DS2
      IF(DABS(DRES).GT.1D30)DRES=1D20
      SLIFO(IST)=DRES
      GO TO 1
C 14
260   INDEX=NINT(SLIFO(IST))
      SLIFO(IST)=SLIFO(IST+1)
      IF (IREAL) 262,262,261
261   R=SNGL(SLIFO(IST))
      KA(INDEX)=IR
      GO TO 1
262   IF(SLIFO(IST).GE.0.D0) THEN
      KA(INDEX)=SLIFO(IST)+.5
      ELSE
      KA(INDEX)=SLIFO(IST)-.5
      ENDIF
      GO TO 1
C 18 unarni minus
300   SLIFO(IST)=-SLIFO(IST)
      GO TO 1
C 19 sinus
310   SLIFO(IST)=DSIN(SLIFO(IST))
      GO TO 1
C 20 cosinus
320   SLIFO(IST)=DCOS(SLIFO(IST))
      GO TO 1
C 21 exponenciala
330   SLIF=SLIFO(IST)
      IF(SLIF.LE.-50.D0)THEN
          SLIFO(IST)=0.D0
      ELSEIF(SLIF.GT.50.D0)THEN
          SLIFO(IST)=1D15
      ELSE
          SLIFO(IST)=DEXP(SLIF)
      ENDIF
      GO TO 1
C 22 odmocnina
340   IF (SLIFO(IST)) 3000,341,341
341   SLIFO(IST)=DSQRT(SLIFO(IST))
      GO TO 1
C 23 prirozeny logaritmus
350   IF (SLIFO(IST)) 4000,4000,351
351   SLIFO(IST)=DLOG(SLIFO(IST))
      GO TO 1
C 24 dekadicky logaritmus
360   IF (SLIFO(IST)) 4000,4000,361
361   SLIFO(IST)=DLOG10(SLIFO(IST))
      GO TO 1
C 25
370   SLIFO(IST)=DABS(SLIFO(IST))
      GO TO 1
C Nestandardni funkce (jejich operandy jsou v zasobniku SLIFO)
500   IRPN=IRPN+1
      IST=IST+IA(IRPN)+1
      IF (IST) 2000,2000,501
C vektor parametru uzivatelske funkce je REAL*4
501   SLIFO4=SLIFO
      SLIFO(IST)=TFU(ICOD-25,SLIFO4(IST),-IA(IRPN))
      GO TO 1
1000  RES=SNGL(SLIFO(IST))
      IF (IST.EQ.1) RETURN
C
C NEVYCERPANY ZASOBNIK (NEUPLNY PREKLAD VYRAZU)
7000  IER=-4018
      WRITE(*,'('' TINE: Translation not completed'')')
      goto 6000
C CHYBNE OPERANDY
2000  IER=-4017
      WRITE(*,'('' TINE: wrong operands'')')
      goto 6000
C ZAPORNE CISLO NA REALNY EXPONENT
2500  IER=-4019
      WRITE(*,'('' TINE: Power of negative number'')')
      goto 6000
C ODMOCNINA ZE ZAPORNEHO CISLA
3000  IER=-4021
      WRITE(*,'('' TINE: Square root of negative number'')')
      goto 6000
C LOGARITMUS ZAPORNEHO CISLA NEBO NULY
4000  IER=-4020
      WRITE(*,'('' TINE: Log of negative number or zero'')')
      goto 6000
C DELENI NULOU
5000  IER=-4008
      WRITE(*,'('' TINE: Division by zero'')')
6000  IER=(IER-10000*irpn)
      END

      REAL FUNCTION CURFUN(IFUN)
C
C VYPOCET FUNKCI HODNOTY BUD LINEARNI INTERPOLACI V TABULCE
C NEBO VYHODNOCENIM KODU RPN.
C -10 <= IFUN <= 50 v tomto pripade je funkce urcena hodnotou
C  I=INDFUN(IFUN)
C kdyz je I>0 a soucasne I<=MFUNCT vyhodnoti se vyraz TINQ
C kdyz je I<0 a soucasne |I|<=MTABLE vyhodnoti se tabulka.
C
C Specialni pripad je IFUN=|101|,|102|,...,|105|
C V tom pripade se vyhodnocuje interpretovany model RTD (ten, ktery je prave
C aktivni) - sekce INI. Vysledek je ve vektoru YV(1),...,YV(5) a predava se
C prave jedna z techto peti hodnot.
C
C V ostatnich pripadech je vysledek 1.
C  
      EXTERNAL TFUS
      INCLUDE '$FEM'
      EQUIVALENCE (IAUX(2),X),(IAUX(3),Y),(IAUX(4),Z),
     /            (IAUX(12),UX),(IAUX(13),UY),(IAUX(14),UZ)
      RES=1.
      IAFUN=IABS(IFUN)
      IF(IFUN.GE.MIFUN.AND.IFUN.LE.MAFUN)THEN
        IFF=INDFUN(IFUN)
        IFC=-IFF
        IF(IFF.GT.0.AND.IFF.LE.MFUNCT)THEN
C KOD RPN CISLO IFF
          CALL TINQ(IRPN(1,IFF),MRPN(IFF),IAUX,TFUS,RES,10)
        ELSEIF(IFC.LE.MTABLE.AND.IFC.GT.0)THEN
C TABULKA CISLO IFC
          SELECT CASE(KTABLE(IFC))
          CASE(0)
            T=TIME
          CASE(1)
            T=X
          CASE(2)
            T=Y
          CASE(3)
            T=Z
          CASE(4)
            T=TEMP
          CASE(5)
            T=UX
          CASE(6)
            T=UY
          CASE(7)
            T=UZ
          CASE(8)
            T=SINV
          END SELECT
          NPOINT=MTPT(IFC)
          DO I=2,NPOINT
            IF(T.LT.XTAB(I,IFC))EXIT
          ENDDO
          I=MIN0(MAXTPT,I)
          DXTAB=XTAB(I,IFC)-XTAB(I-1,IFC)
          IF(DXTAB.NE.0.) RES=YTAB(I-1,IFC)+
     /        (T-XTAB(I-1,IFC))*(YTAB(I,IFC)-YTAB(I-1,IFC))/DXTAB
        ENDIF
      ELSEIF(IAFUN.GE.101.AND.IAFUN.LE.105)THEN
C KOD RPN aktivniho modelu RTD
          CALL TINQ(MODRPN,MIRPN,IAUX,TFUS,RES,10)
          RES=YOUTPUTS(IAFUN-100)
      ENDIF
      CURFUN=RES
      END

      SUBROUTINE READBIN(IUN,IEND)
      INCLUDE '$FEMLOC'
      CHARACTER*12 PROFILE
C Cti binarni soubor /FEM/ ze zarizeni IUN
C      INQUIRE(IUN,NAME=PROFILE)
      CALL FINQUIRE(IUN,PROFILE)
      READ(IUN,ERR=51,END=51)ITDATAB,LENG
      IF(LENG.EQ.MAXEND)THEN
        IEND=0
        IF(ITDATAB.NE.0)THEN
         READ(IUN,ERR=51,END=51)INTERC
        ELSE
C cteni zuzene databaze
         READ(IUN,ERR=51,END=51)(INTERC(I),I=1,LOCIUE)
         READ(IUN,ERR=51,END=51)
     /     ((JEPAR(K,I),I=1,MAXEPAR),K=1,MAXELEM),
     /     ((KEPAR(K,I),I=1,MAXEPAR),K=1,MAXELEM),
     /     ((LEPAR(K,I),I=1,MAXTEPAR),K=1,MAXELEM),
     /     (MUE(I),MINT(I),IGROUP(I),IRCONS(I),IMPROP(I),
     /     (IEPAR(I,J),J=1,MAXEPAR),I=1,NE)
         READ(IUN,ERR=51,END=51)(LUE(I),I=1,NE+1)
         READ(IUN,ERR=51,END=51)(IUE(I),I=1,LUE(NE+1))
         READ(IUN,ERR=51,END=51)(XX(I),YY(I),ZZ(I),I=1,ND)
         READ(IUN,ERR=51,END=51)(JPU(I),I=1,MDOF),(LPU(I),I=1,MAXTDOF)
         READ(IUN,ERR=51,END=51) ((IPU((K-1)*MAXND+I),I=1,ND),K=1,MDOF)
         READ(IUN,ERR=51,END=51)
     /                 (((VAL((K-1)*MAXND+I,J),I=1,ND),K=1,MDOF),J=1,3)
C Nulovani posledniho sloupce VAL
         DO K=1,MDOF
	     DO I=1,ND
	       VAL((K-1)*MAXND+I,4)=0.
	     ENDDO
	   ENDDO
         READ(IUN,ERR=51,END=51)XBOXMI,XBOXMA,DXBOX,NXBOX,
     /                          YBOXMI,YBOXMA,DYBOX,NYBOX,
     /                          ZBOXMI,ZBOXMA,DZBOX,NZBOX
         READ(IUN,ERR=51,END=51)(PTX(I),PTY(I),PTZ(I),NEARND(I),I=1,NPT)
         READ(IUN,ERR=51,END=51)ISF,MSF,ICR,MCR,NXCR,FLAFI,IVL,MVL,
     /                          ICONTOUR,MCONTOUR
C        READ(IUN,ERR=51,END=51)(INTERC(I),I=LOCONST,MAXEND)
         READ(IUN,ERR=51,END=51)(INTERC(I),I=LOCONST,LOCNGR),
     /             (INTERC(I),I=LOCYG1,LOCYG1+NGR),
     /             (INTERC(I),I=LOCYG2,LOCYG2+NGR),
     /             (INTERC(I),I=LOCYG3,LOCYG3+NGR),
     /             (INTERC(I),I=LOCYG4,LOCYG4+NGR),
     /             (INTERC(I),I=LOCYG5,LOCYG5+NGR),
     /             (INTERC(I),I=LOCYG6,LOCYG6+NGR),
     /             (INTERC(I),I=LOCYG7,LOCYG7+NGR),
     /             (INTERC(I),I=LOCYG8,LOCYG8+NGR),
     /             (INTERC(I),I=LOCYG9,LOCYG9+NGR),
     /             (INTERC(I),I=LOCYG10,LOCYG10+NGR),
     /             (INTERC(I),I=LOCINDG,MAXEND)
	   READ(IUN,ERR=51,END=51)IQGR,TTC
        ENDIF
      ELSE
        IEND=LENG
      ENDIF
      RETURN
51    IEND=-1
      END

      SUBROUTINE WRITEBIN(IUN,ITYP)
C
C Zapis databaze /FEM/ do jiz otevreneho souboru na jednotce IUN
C ITYP=0 zkracena, =1 uplna
C
      INCLUDE '$FEMLOC'
      IF(ITYP.NE.0)THEN
         WRITE(IUN)1,MAXEND
         WRITE(IUN)INTERC
      ELSE
C zapis redukovane databaze
         WRITE(IUN)0,MAXEND
         WRITE(IUN)(INTERC(I),I=1,LOCIUE)
         WRITE(IUN)
     /     ((JEPAR(K,I),I=1,MAXEPAR),K=1,MAXELEM),
     /     ((KEPAR(K,I),I=1,MAXEPAR),K=1,MAXELEM),
     /     ((LEPAR(K,I),I=1,MAXTEPAR),K=1,MAXELEM),
     /        (MUE(I),MINT(I),IGROUP(I),IRCONS(I),IMPROP(I),
     /        (IEPAR(I,J),J=1,MAXEPAR),I=1,NE)
         WRITE(IUN)(LUE(I),I=1,NE+1)
         WRITE(IUN)(IUE(I),I=1,LUE(NE+1))
         WRITE(IUN)(XX(I),YY(I),ZZ(I),I=1,ND)
         WRITE(IUN)(JPU(I),I=1,MDOF),(LPU(I),I=1,MAXTDOF)
         WRITE(IUN) ((IPU((K-1)*MAXND+I),I=1,ND),K=1,MDOF)
         WRITE(IUN)(((VAL((K-1)*MAXND+I,J),I=1,ND),K=1,MDOF),J=1,3)
         WRITE(IUN)XBOXMI,XBOXMA,DXBOX,NXBOX,
     /             YBOXMI,YBOXMA,DYBOX,NYBOX,
     /             ZBOXMI,ZBOXMA,DZBOX,NZBOX
         WRITE(IUN)(PTX(I),PTY(I),PTZ(I),NEARND(I),I=1,NPT)
         WRITE(IUN)ISF,MSF,ICR,MCR,NXCR,FLAFI,IVL,MVL,ICONTOUR,MCONTOUR
C starsi verze, zapis kompletni matice MOP
C        WRITE(IUN)(INTERC(I),I=LOCONST,MAXEND)
         WRITE(IUN)(INTERC(I),I=LOCONST,LOCNGR),
     /             (INTERC(I),I=LOCYG1,LOCYG1+NGR),
     /             (INTERC(I),I=LOCYG2,LOCYG2+NGR),
     /             (INTERC(I),I=LOCYG3,LOCYG3+NGR),
     /             (INTERC(I),I=LOCYG4,LOCYG4+NGR),
     /             (INTERC(I),I=LOCYG5,LOCYG5+NGR),
     /             (INTERC(I),I=LOCYG6,LOCYG6+NGR),
     /             (INTERC(I),I=LOCYG7,LOCYG7+NGR),
     /             (INTERC(I),I=LOCYG8,LOCYG8+NGR),
     /             (INTERC(I),I=LOCYG9,LOCYG9+NGR),
     /             (INTERC(I),I=LOCYG10,LOCYG10+NGR),
     /             (INTERC(I),I=LOCINDG,MAXEND)
	   WRITE(IUN)IQGR,TTC
      ENDIF
      END


      SUBROUTINE FINQUIRE(IUNIT,FILENAM)
C
C Zjisteni jmena souboru FILENAM, ktery otevreny na IUNIT.
C Vstupni parametr: IUNIT - cislo zarizeni
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      CHARACTER *(*) FILENAM
      CHARACTER *60 FILEPATH
      INQUIRE(IUNIT,NAME=FILEPATH)
C hledej posledni \
      IF(INDEX(FILEPATH,'\').GT.0)THEN
        IL=1
        LAST=1
        DO WHILE(IL.GT.0)
           LAST=IL+LAST
           IL=INDEX(FILEPATH(LAST:),'\')
        ENDDO
      ELSE
        LAST=1
      ENDIF
      FILENAM=FILEPATH(LAST:)
      END