      SUBROUTINE FDFQ3(NU,XU,YU,ZU,RKSI,RETA,X,Y,Z,F,FX,FY,FZ,DET)
C
C Bazove funkce na zakrivene plose definovane 4 nebo 8 body.
C Vstup
C NU, XU(NU),YU(NU),ZU(NU), RKSI, RETA
C Vystup
C F,FX,FY,FZ,DET
C
      DIMENSION XU(*),YU(*),ZU(*),F(*),FX(*),FY(*),FZ(*)
      DIMENSION DFKSI(8),DFETA(8)
      CALL FDQ(NU,RKSI,RETA,F,DFKSI,DFETA)
      DXDKSI=0.
      DXDETA=0.
      DYDKSI=0.
      DYDETA=0.
      DZDKSI=0.
      DZDETA=0.
      X=0.
      Y=0.
      Z=0.
      DO I=1,NU
        DXDKSI=DXDKSI+XU(I)*DFKSI(I)
        DXDETA=DXDETA+XU(I)*DFETA(I)
        DYDKSI=DYDKSI+YU(I)*DFKSI(I)
        DYDETA=DYDETA+YU(I)*DFETA(I)
        DZDKSI=DZDKSI+ZU(I)*DFKSI(I)
        DZDETA=DZDETA+ZU(I)*DFETA(I)
        X=X+XU(I)*F(I)
        Y=Y+YU(I)*F(I)
        Z=Z+ZU(I)*F(I)
      ENDDO
      DWX=DYDKSI*DZDETA-DZDKSI*DYDETA
      DWY=DZDKSI*DXDETA-DXDKSI*DZDETA
      DWZ=DXDKSI*DYDETA-DXDETA*DYDKSI
      DET=SQRT(DWX**2+DWY**2+DWZ**2)
c Vypocet fx,fy,fz
      DXY=DXDKSI*DYDETA-DXDETA*DYDKSI
      IF(DXY.EQ.0.)DXY=1E10
      DKSIDX=DYDETA/DXY
      DETADX=-DYDKSI/DXY
      DYX=DYDKSI*DXDETA-DYDETA*DXDKSI
      IF(DYX.EQ.0.)DYX=1E10
      DKSIDY=DXDETA/DYX
      DETADY=-DXDKSI/DYX
      DXZ=DZDKSI*DXDETA-DZDETA*DXDKSI
      IF(DXZ.EQ.0.)DXZ=1E10
      DKSIDZ=DXDETA/DXZ
      DETADZ=-DXDKSI/DXZ
      DO I=1,NU
        FX(I)=DFKSI(I)*DKSIDX+DFETA(I)*DETADX
        FY(I)=DFKSI(I)*DKSIDY+DFETA(I)*DETADY
        FZ(I)=DFKSI(I)*DKSIDZ+DFETA(I)*DETADZ
      ENDDO
      END
