      SUBROUTINE FDQ(NOD,RKSI,RETA,F,DFKSI,DFETA)
C
C ISOPARAMETRICKE BAZOVE FUNKCE A JEJICH PRVNI DERIVACE
C VE CTYRUHELNIKU SE 4/8 UZLY.
C
C VSTUPNI PARAMETRY:
C NOD = 4/8   POCET UZLU
C RKSI,RETA    BEZROZMERNE SOURADNICE (-1,1) BODU UVNITR ELEMENTU
C
C VYSTUP:
C F(),DFKSI(),DFETA() HODNOTY A PRVNI DERIVACE VSECH 4/8 BAZOVYCH FUNKCI V BODE RKSI,RNY
C
      DIMENSION F(*),DFKSI(*),DFETA(*),GX(8),GY(8)
      DATA GX,GY/-1.,1.,1.,-1.,0.,1.,0.,-1.,-1.,-1.,1.,1.,-1.,0.,1.,0./
      DO I=1,NOD
         XX=GX(I)*RKSI
         YY=GY(I)*RETA
         IF(NOD.EQ.4)THEN
            F(I)=(1+YY)*(1+XX)/4
            DFKSI(I)=GX(I)/4*(1+YY)
            DFETA (I)=GY(I)/4*(1+XX)
         ELSEIF(I.LE.4)THEN
            F(I)=(1+YY)*(1+XX)*(XX+YY-1)/4
            DFKSI(I)=GX(I)/4*(1+YY)*(2*XX+YY)
            DFETA (I)=GY(I)/4*(1+XX)*(2*YY+XX)
         ELSEIF(I.EQ.5.OR.I.EQ.7)THEN
            F(I)=(1-RKSI**2)*(1+YY)/2
            DFKSI(I)=-RKSI*(1+YY)
            DFETA(I)=GY(I)*(1-RKSI**2)/2
         ELSE
            F(I)=(1-RETA**2)*(1+XX)/2
            DFKSI(I)=GX(I)*(1-RETA**2)/2
            DFETA(I)=-RETA*(1+XX)
         ENDIF
      ENDDO
      END
