      SUBROUTINE FEMERGE(X,Y,N,IUE,LUE,NE,TOL,NEW)
C
C MERGE UZLU, VZDALENYCH O MENE NEZ -TOL- A UPRAVA MATICE KONEKTIVITY
C VEKTORY SOURADNIC SE ZKRATI.
C
C VSTUPNI PARAMETRY:
C X(N),Y(N)   SOURADNICE UZLU
C IUE(*)      VEKTOR KONEKTIVITY
C LUE(*)      INDEXY PRVNICH UZLU ELEMENTU
C TOL         MINIMALNI VZDALENOST ODLISNYCH UZLU
C
C VYSTUPNI PARAMETRY:
C NEW         NOVA DELKA VEKTORU X,Y
C
      DIMENSION X(*),Y(*),IUE(*),LUE(*)
      TOL2=TOL*TOL
      NEW=N
      I=1
      DO WHILE(I.LT.NEW)
C TESTUJEME VYSKYT TOTOZNYCH UZLU I+1,...,NEW
        XI=X(I)
        YI=Y(I)
        J=I+1
        DO WHILE(J.LT.NEW)
          IF((XI-X(J))**2+(YI-Y(J))**2.LT.TOL2)THEN
C VYRAD UZEL J (V MATICI KONEKTIVITY MISTO NEHO DOSAD I)
            NEW=NEW-1
            DO K=J,NEW
              X(K)=X(K+1)
              Y(K)=Y(K+1)
            ENDDO
            DO IE=1,NE
              NUE=LUE(IE+1)-LUE(IE)
              L0=IUE(IE)
              DO IU=1,NUE
                INDU=IUE(L0+IU)
                IF(INDU.EQ.J)THEN
                    IUE(L0+IU)=I
                ELSEIF(INDU.GT.J)THEN
                    IUE(L0+IU)=INDU-1
                ENDIF
              ENDDO
            ENDDO
          ENDIF
          J=J+1
        ENDDO
        I=I+1
      ENDDO
      END
 
