      SUBROUTINE FFMERGE(X,Y,Z,N,IUE,LUE,MUE,NE,TOL)
C Zrychlena verze
C MERGE UZLU, VZDALENYCH O MENE NEZ -TOL- A UPRAVA MATICE KONEKTIVITY
C VEKTORY SOURADNIC SE NEZKRACUJI (i sloucene uzly zustavaji jako dvojice).
C
C VSTUPNI PARAMETRY:
C X(N),Y(N),Z(n)   SOURADNICE UZLU
C IUE(*)      VEKTOR KONEKTIVITY
C LUE(*)      INDEXY PRVNICH UZLU ELEMENTU
C MUE(*)      POCET UZLU ELEMENTU (ZAPORNA HODNOTA MY VYZNAM JEN PRO GRAFIKU)
C TOL         MINIMALNI VZDALENOST ODLISNYCH UZLU
C
      PARAMETER (NDBIN=3000)
      DIMENSION X(*),Y(*),Z(*),IUE(*),LUE(*),MUE(*),IND(NDBIN)
C Roztrideni uzlu do NBIN skupin
C      TOL2=TOL*TOL
      XMIN=1e10
      XMAX=-1E10
      YMIN=1e10
      YMAX=-1E10
      ZMIN=1e10
      ZMAX=-1E10
      DO I=1,N
        XMIN=AMIN1(XMIN,X(I))
        XMAX=AMAX1(XMAX,X(I))
        YMIN=AMIN1(YMIN,Y(I))
        YMAX=AMAX1(YMAX,Y(I))
        ZMIN=AMIN1(ZMIN,Z(I))
        ZMAX=AMAX1(ZMAX,Z(I))
      ENDDO
	DXT=AMAX1(1E-7,(XMAX-XMIN)*TOL)
	DYT=AMAX1(1E-7,(YMAX-YMIN)*TOL)
	DZT=AMAX1(1E-7,(ZMAX-ZMIN)*TOL)
      NBIN=(12*N)/NDBIN+1
      DX=(XMAX-XMIN)/NBIN
      DXSMAL=DX*1E-5
      DO IBIN=1,NBIN
        XB1=XMIN+(IBIN-1)*DX
        XB2=XB1+DX
        XB1=XB1-DXSMAL
        XB2=XB2+DXSMAL
        NDB=0
        DO I=1,N
          IF(X(I).GE.XB1.AND.X(I).LE.XB2)THEN
             IF(NDB.LT.NDBIN)THEN
                NDB=NDB+1
                IND(NDB)=I
             ELSE
                WRITE(*,*)' Too many nodes in bin',xb1,xb2
             ENDIF
          ENDIF
        ENDDO
        DO IB=1,NDB-1
          I=IND(IB)  
C TESTUJEME VYSKYT TOTOZNYCH UZLU I+1,...,NEW
          XI=X(I)
          YI=Y(I)
          ZI=Z(I)
          DO JB=IB+1,NDB
            J=IND(JB)
C            IF((XI-X(J))**2+(YI-Y(J))**2+(ZI-Z(J))**2.LT.TOL2)THEN
            IF(ABS(XI-X(J)).LT.DXT.AND.
     /         ABS(YI-Y(J)).LT.DYT.AND.
     /         ABS(ZI-Z(J)).LT.DZT)THEN
C VYRAD UZEL J (V MATICI KONEKTIVITY MISTO NEHO DOSAD I)
              DO IE=1,NE
                NUE=IABS(MUE(IE))
                L0=LUE(IE)
                DO IU=1,NUE
                  INDU=IABS(IUE(L0+IU))
                  IF(INDU.EQ.J)IUE(L0+IU)=I
                ENDDO
              ENDDO
            ENDIF
          ENDDO
        ENDDO
      ENDDO
      END
 
