      SUBROUTINE GMFCTS(V3,X3,Y3,V,IVC,N,ICOL)
C
C KRESLENI IZOCAR V TRUJUHELNIKU A VYPLNOVANI PROUZKU
C BARVAMI IVC(N)
C VSTUPNI PARAMETRY:
C V3(3),X3(3),Y3(3) - FUNKCI HODNOTY A SOURADNICE VRCHOLU
C V(N)   - POZADOVANE HODNOTY IZOCAR
C IVC(N) - BARVA PROUZKU ODPOVIDAJICI IZOCARE V(N)
C N      - POCET HODNOT IZOCAR
C ICOL   - BARVA IZOCAR
C
      PARAMETER (MAXCON=12)
      DIMENSION V3(*),X3(*),Y3(*),V(*),IVC(*),
     /          VM(3),XM(3),YM(3),IB(3),X(2),Y(2),
     /          XX(MAXCON),YY(MAXCON),IVAL(MAXCON),
     /          X1(MAXCON),X2(MAXCON),Y1(MAXCON),Y2(MAXCON)
      DOI=1,3
      IB(I)=I
      ENDDO
      DOJ=1,2
         DOI=1,2
         I1=IB(I)
         I2=IB(I+1)
         IF(V3(I1).GT.V3(I2))THEN
            IB(I)=I2
            IB(I+1)=I1
         ENDIF
         ENDDO
      ENDDO
      DOI=1,3
      IBI=IB(I)
      VM(I)=V3(IBI)
      XM(I)=X3(IBI)
      YM(I)=Y3(IBI)
      ENDDO
C XM,YM,VM - TROJUHELNIK S USPORADANIM VRCHOLU TAK, ZE VM(1)<VM(2)<VM(3)
      ICONT=1
      X1(1)=XM(1)
      X2(1)=XM(1)
      Y1(1)=YM(1)
      Y2(1)=YM(1)
      ICIMP=0
C CYKLUS PRES POZADOVANE HODNOTY IZOCAR V(1),...,V(N)
      DO  I=1,N
      VAL=V(I)
      IF(VAL.LE.VM(1)) ICIMP=I
      IF(VAL.GE.VM(1).AND.VAL.LE.VM(3))THEN
         IVAL(ICONT)=I
         IF(VM(3).GT.VM(1))THEN
            REL=(VAL-VM(1))/(VM(3)-VM(1))
         ELSE
            REL=0.5
         ENDIF
         X(1)=XM(1)+REL*(XM(3)-XM(1))
         Y(1)=YM(1)+REL*(YM(3)-YM(1))
         IF(VAL.LE.VM(2))THEN
            IF(VM(2).GT.VM(1))THEN
               REL=(VAL-VM(1))/(VM(2)-VM(1))
            ELSE
               REL=0.5
            ENDIF
            X(2)=XM(1)+REL*(XM(2)-XM(1))
            Y(2)=YM(1)+REL*(YM(2)-YM(1))
         ELSE
            IF(VM(3).GT.VM(2))THEN
               REL=(VAL-VM(2))/(VM(3)-VM(2))
            ELSE
               REL=0.5
            ENDIF
            X(2)=XM(2)+REL*(XM(3)-XM(2))
            Y(2)=YM(2)+REL*(YM(3)-YM(2))
         ENDIF
C VYKSLENI USECKY ISOCARY
         CALL GMFPL(2,X,Y,ICOL)
         IF(ICONT.LT.MAXCON)ICONT=ICONT+1
         X1(ICONT)=X(1)
         X2(ICONT)=X(2)
         Y1(ICONT)=Y(1)
         Y2(ICONT)=Y(2)
         ENDIF
      ENDDO
C KONEC CYKLU PRES IZOCARY.
C SOURADNICE ISOCAR JSOU VE VEKTORECH X1,X2,Y1,Y2
C A INDEXY ISOCAR VE VEKTORU IVAL
C
      IF(ICONT.GT.1)THEN
C PRIPAD DVOU A VICE ISOCAR
         ICONT=MIN0(MAXCON-1,ICONT)
         IVAL(ICONT)=IVAL(ICONT-1)+1
         X1(ICONT+1)=XM(3)
         X2(ICONT+1)=XM(3)
         Y1(ICONT+1)=YM(3)
         Y2(ICONT+1)=YM(3)
         DO3J=1,ICONT
         XX(J)=(X1(J)+X2(J)+X1(J+1)+X2(J+1))*.25
3        YY(J)=(Y1(J)+Y2(J)+Y1(J+1)+Y2(J+1))*.25
      ELSE
C JEN JEDINA ISOCARA
         XX(1)=(XM(1)+XM(2)+XM(3))*.3333
         YY(1)=(YM(1)+YM(2)+YM(3))*.3333
         IVAL(1)=MIN0(ICIMP+1,N)
      ENDIF
C VYKRESLENI TROJUHELNIKU
      CALL GMFPLC(3,X3,Y3,ICOL)
C VYPLNOVANI PROUZKU
      DO J=1,ICONT
         INTERC=IVC(IVAL(J))
         IF(INTERC.NE.ICOL) CALL GMFILL(XX(J),YY(J),INTERC,ICOL)
      ENDDO
      END
