      SUBROUTINE GMFECTE(IND,LABEL,NLAB,X,Y,VAL,IUE,LUE,MUE,NE,
     /  B1MI,B1MA,B2MI,B2MA,V,IVC,NC,ICOL)
C
C CONTOURS ON MESH OF ELEMENTS (TRIANGLES OR QUADRILATERALS).
C Zobrazuji se parametry ELEMENTU a ne UZLU (to je rozdil proti GMFECTS).
C NESPOJITE spektrum barev.
C
C IND      - INDEX OKNA, LABEL (TEXT NLAB ZNAKU)
C X(*),Y(*)- SOURADNICE UZLU
C VAL(*)   - FUNKCNI HODNOTY V ELEMENTECH (tezistich elementu)
C IUE(*)   - VEKTOR KONEKTIVITY (INDEXY UZLU ELEMENTU 1...NE)
C LUE(NE+1)- INDEX I-TEHO UZLU ELEMENTU IE JE LUE(IE)+I
C MUE(*)   - IABS(MUE)=POCET UZLU ELEMENTU. MUE<0 POSLEDNI UZEL NEKRESLIT.
C B1MI,... - OBDELNIK (X,Y), OHRANICENY BARVOU ICOL
C V(NC)    - HODNOTY ISOCAR
C IVC(NC)  - BARVY IZOCAR A VYPLNOVYCH PROUZKU
C NC       - POCET ISOCAR
C ICOL     - BARVA RAMECKU
C
      INCLUDE 'GMF$'
      DIMENSION X(*),Y(*),VAL(*),IUE(*),LUE(*),MUE(*),V(*),IVC(*),
     /          XG(5),YG(5)
      CHARACTER *12 LAB, LABEL*(*)
      IF(NE.LT.1) GOTO9999
      CALL GMFAXE(IND,7,15)
      CALL GMFREC(B1MI,B1MA,B2MI,B2MA,ICOL)
      D2=(B2MA-B2MI)/20.
      D1=(B1MA-B1MI)/20.
      DO IE=1,NE
         NUE=IABS(MUE(IE))
C MUE<0 - POSLEDNI UZEL JE V TEZISTI ELEMENTU - NEKRESLIT
C vykresluji se bud troj nebo ctyruhelniky s primymi stranami
         IF(MUE(IE).LT.0)NUE=NUE-1
         IF(MUE(IE).EQ.6)NUE=3
         NUE=MIN0(4,NUE)
C Pokud se jako element vyskytne usecka, nic se nekresli
         IF(NUE.LT.3)THEN
             CALL GMFTEXT(B1MI,B2MA,ICOL,25,'Line elements not allowed')
             RETURN
         ENDIF
         L0=LUE(IE)
         XC=0
         YC=0
         DO I=1,NUE
            IU=IABS(IUE(L0+I))
            XG(I)=X(IU)
            YG(I)=Y(IU)
            XC=XC+X(IU)
            YC=YC+Y(IU)
         ENDDO
         XC=XC/NUE
         YC=YC/NUE
         XG(NUE+1)=XG(1)
         YG(NUE+1)=YG(1)
         CALL GMFPL(NUE+1,XG,YG,ICOL)
C Vypln barvou dle hodnoty VAL(IE)
         ISOC=1
         DO I=1,NC
           IF(VAL(IE).GE.V(I))ISOC=I
         ENDDO
         CALL GMFILL(XC,YC,IVC(ISOC),ICOL)
         CALL GMFPL(NUE+1,XG,YG,IVC(ISOC))
      ENDDO
C SET CHART
      B2=B2MI
      D1TINY=D1/20.
      D2TINY=D2/20.
C CHART
      B1L=B1MA
      B1R=FXMA
      B1LT=B1L+(B1R-B1L)*.1
      B2L=FYMI
      B2R=FYMA
      D2=(B2MA-B2MI)/NC
      D2S=D2*.5
      B1S=(B1L+B1R)*.5
      B2=B2MI
      XG(1)=B1R
      XG(2)=B1R
      XG(3)=B1S
      DO J=1,NC
         CALL GMFREC(B1L,B1R,B2,B2+D2,ICOL)
C VALUES
         ICTEXT=ICOL
         YG(1)=B2
         YG(2)=B2+D2
         YG(3)=B2+D2/2
         CALL GMFPLC(3,XG,YG,ICOL)
         CALL GMFILL((B1R+B1S)/2.,YG(3),IVC(J),ICOL)
         WRITE(LAB,50)V(J)
50       FORMAT(E12.5)
         CALL GMFTEXT(B1LT,B2+D2,ICTEXT,8,LAB(1:8))
         IF(D2.GE.WYT)CALL GMFTEXT(B1LT,B2+D2S,ICTEXT,4,LAB(9:12))
         B2=B2+D2
      ENDDO
      IF(NLAB.GT.0)THEN
         DYF=(FYMA-FYMI)/11
         DTI=DYF/5
         TOP=FYMA-DTI
         BOT=TOP-DYF
         CALL GMFREC(B1MI,B1MA,BOT,TOP,ICOL)
         CALL GMFILL(B1MI+D1,TOP-DTI,14,ICOL)
         CALL GMFILL(B1MI+D1,BOT+DTI,14,ICOL)
         CALL GMFTEXT(B1MI,TOP,ICOL,NLAB,LABEL)
      ENDIF
9999  RETURN
      END
 
