      SUBROUTINE GMFRCTR(IND,LABEL,NLAB,VAL,M,N,
     /  B1MI,B1MA,B2MI,B2MA,VMIN,VMAX,IVMIN,IVMAX,ICOL)
C
C CONTOURS RECTANGULARS NET. Spojite spektrum barev, ale
C navic se barvou ICOL kresli i cary - vrstevnice. Vyuzivaji se procedury
C pro vykreslovani vrstevnic v trojuhelnicich.
C
C IND      - INDEX OKNA, LABEL (TEXT NLAB ZNAKU)
C VAL(M,N) - FUNKCNI HODNOTY V OBDELNIKOVE MATICI
C B1MI,... - OBDELNIK (X,Y), OHRANICENY BARVOU ICOL
C VMIN,VMAX- ROZSAH VAL, IVMIN,IVMAX ODPOVIDAJICI KODY BAREV (0-2850)
C ICOL     - BARVA VRSTEVNIC A RAMECKU
C
C Fortran PowerStation 16-Jul-02
C
      INCLUDE 'GMF$'
      PARAMETER (NC=10)
      DIMENSION VAL(M,N),X3(3),Y3(3),V3(3),V(NC)
      CHARACTER *12 LAB, LABEL*(*)
      IF(M.LE.1.OR.N.LE.1) GOTO9999
      DO J=1,NC
         V(J)=VMIN+J*(VMAX-VMIN)/NC
      ENDDO
      CALL GMFAXE(IND,7,15)
      D2=(B2MA-B2MI)/(N-1)
      D1=(B1MA-B1MI)/(M-1)

C SET CHART
      B2=B2MI
      D1TINY=D1/M
      D2TINY=D2/N
C CHART
      B1L=B1MA
      B1R=FXMA
      B1LT=B1L+(B1R-B1L)*.1
      B2L=FYMI
      B2R=FYMA
      D2C=(B2MA-B2MI)/NC
      D2S=D2C*.5
      B1S=(B1L+B1R)*.5
      B2=B2MI
      X3(1)=B1R
      X3(2)=B1R
      X3(3)=B1S
      DOJ=1,NC
         CALL GMFREC(B1L,B1R,B2,B2+D2C,ICOL)
C VALUES
         ICTEXT=ICOL
         VC=V(J)
         Y3(1)=B2
         Y3(2)=B2+D2C
         Y3(3)=B2+D2C/2
         V3(1)=VC
         V3(2)=VC
         V3(3)=VC
         CALL GMFCTR(V3,X3,Y3,VMIN,VMAX,IVMIN,IVMAX)
         WRITE(LAB,50)VC
50       FORMAT(E12.5)
         CALL GMFTEXT(B1LT,B2+D2C,ICTEXT,6,LAB(3:8))
         IF(D2C.GE.WYT)CALL GMFTEXT(B1LT,B2+D2S,ICTEXT,4,LAB(9:12))
         B2=B2+D2C
      ENDDO
      IF(NLAB.GT.0)THEN
         DYF=(FYMA-FYMI)/11
         DTI=DYF/5
         TOP=FYMA-DTI
         BOT=TOP-DYF
         CALL GMFREC(B1MI,B1MA,BOT,TOP,ICOL)
         CALL GMFILL(B1MI+D1,TOP-DTI,14,ICOL)
         CALL GMFILL(B1MI+D1,BOT+DTI,14,ICOL)
         CALL GMFTEXT(B1MI,TOP,ICOL,NLAB,LABEL)
      ENDIF

      B2=B2MI
      DOJ=1,N-1
         B1=B1MI
         DOI=1,M-1
         X3(3)=B1
         X3(1)=B1+D1
         X3(2)=B1
         Y3(3)=B2
         Y3(1)=B2
         Y3(2)=B2+D2
         V3(3)=VAL(I,J)
         V3(1)=VAL(I+1,J)
         V3(2)=VAL(I,J+1)
         CALL GMFCTR(V3,X3,Y3,VMIN,VMAX,IVMIN,IVMAX)
         X3(3)=B1+D1
         Y3(3)=B2+D2
         V3(3)=VAL(I+1,J+1)
         CALL GMFCTR(V3,X3,Y3,VMIN,VMAX,IVMIN,IVMAX)
         B1=B1+D1
         ENDDO
      B2=B2+D2
      ENDDO
      B2=B2MI
      DOJ=1,N-1
         B1=B1MI
         DOI=1,M-1
         X3(3)=B1
         X3(1)=B1+D1
         X3(2)=B1
         Y3(3)=B2
         Y3(1)=B2
         Y3(2)=B2+D2
         V3(3)=VAL(I,J)
         V3(1)=VAL(I+1,J)
         V3(2)=VAL(I,J+1)
         CALL GMFCTI(V3,X3,Y3,V,NC,ICOL)
         X3(3)=B1+D1
         Y3(3)=B2+D2
         V3(3)=VAL(I+1,J+1)
         CALL GMFCTI(V3,X3,Y3,V,NC,ICOL)
         B1=B1+D1
         ENDDO
      B2=B2+D2
      ENDDO
C      CALL GMFREC(B1MI,B1MA,B2MI,B2MA,ICOL)
      CALL GMFREC(B1MI,B1MA,B2MI,B2MA,0)
9999  END
 
