      SUBROUTINE GMFRCTS(IND,LABEL,NLAB,VAL,M,N,
     /                  B1MI,B1MA,B2MI,B2MA,VC,IVC,NC,ICOL)
C
C CONTOURS RECTANGULARS NET. Vykresli se carou (barva ICOL) NC-vrstevnic
C VC(1),...VC(NC) a plochy mezi nimi se vyplnuji barvami IVC(1),...IVC(NC).
C Vyuziva se algoritmus kresleni vrstevnic v trojuhelnicich GMFCTS.
C
C IND     - INDEX OKNA, LABEL (TEXT NLAB ZNAKU)
C VAL(M,N) - FUNKCNI HODNOTY V OBDELNIKOVE MATICI
C B1MI,... - OBDELNIK (X,Y), OHRANICENY BARVOU ICOL
C VC(NC)   - VEKTOR HODNOT VRSTEVNIC
C IVC(NC)  - BAREVNE KODY VRSTEVNIC
C
      INCLUDE 'GMF$'
      DIMENSION VAL(M,N),X3(3),Y3(3),V3(3),VC(*),IVC(*)
      CHARACTER *12 LAB, LABEL*(*)
      IF(NC.LE.1.OR.M.LE.1.OR.N.LE.1) GOTO9999
      CALL GMFAXE(IND,7,15)
      CALL GMFREC(B1MI,B1MA,B2MI,B2MA,ICOL)
      B2=B2MI
      D2=(B2MA-B2MI)/(N-1)
      D1=(B1MA-B1MI)/(M-1)
      DOJ=1,N-1
         B1=B1MI
         DOI=1,M-1
         X3(3)=B1
         X3(1)=B1+D1
         X3(2)=B1
         Y3(3)=B2
         Y3(1)=B2
         Y3(2)=B2+D2
         V3(3)=VAL(I,J)
         V3(1)=VAL(I+1,J)
         V3(2)=VAL(I,J+1)
         CALL GMFCTI(V3,X3,Y3,VC,NC,ICOL)
         X3(3)=B1+D1
         Y3(3)=B2+D2
         V3(3)=VAL(I+1,J+1)
         CALL GMFCTI(V3,X3,Y3,VC,NC,ICOL)
         B1=B1+D1
         ENDDO
      B2=B2+D2
      ENDDO
C FILL
      B2=B2MI
      D1TINY=D1/M
      D2TINY=D2/N
      DO J=1,N
         B1=B1MI
         DO I=1,M
           VV=VAL(I,J)
           DOK=1,NC
             IF(VC(K).GE.VV)THEN
               BB1=B1
               BB2=B2
               IF(B1.LE.B1MI)BB1=BB1+D1TINY
               IF(B1.GE.B1MA)BB1=BB1-D1TINY
               IF(B2.LE.B2MI)BB2=BB2+D2TINY
               IF(B2.GE.B2MA)BB2=BB2-D2TINY
               CALLGMFILL(BB1,BB2,IVC(K),ICOL)
               EXIT
             ENDIF
           ENDDO
         B1=B1+D1
         ENDDO
         B2=B2+D2
         CALL GMFREC(B1MI-D1,B1MI-D1TINY,B2MI,B2MI+D2*(J-1),0)
      ENDDO
C CHART
      B1L=B1MA
      B1R=FXMA
      B1LT=B1L+(B1R-B1L)*.1
      B2L=FYMI
      B2R=FYMA
      D2=(B2MA-B2MI)/NC
      D2S=D2*.5
      B1S=(B1L+B1R)*.5
      B2=B2MI
      DOJ=1,NC
         CALL GMFREC(B1L,B1R,B2,B2+D2,ICOL)
         CALL GMFILL(B1S,B2+D2S,IVC(J),ICOL)
C VALUES
         IF(IVC(J).EQ.ICOL)THEN
            ICTEXT=0
         ELSE
            ICTEXT=ICOL
         ENDIF
         WRITE(LAB,50)VC(J)
50       FORMAT(E12.5)
         CALL GMFTEXT(B1LT,B2+D2,ICTEXT,6,LAB(3:8))
         IF(D2.GE.WYT)CALL GMFTEXT(B1LT,B2+D2S,ICTEXT,4,LAB(9:12))
         B2=B2+D2
      ENDDO
      IF(NLAB.GT.0)THEN
         DYF=(FYMA-FYMI)/11
         DTI=DYF/5
         TOP=FYMA-DTI
         BOT=TOP-DYF
         CALL GMFREC(B1MI,B1MA,BOT,TOP,ICOL)
         CALL GMFILL(B1MI+D1,TOP-DTI,14,ICOL)
         CALL GMFILL(B1MI+D1,BOT+DTI,14,ICOL)
         CALL GMFTEXT(B1MI,TOP,ICOL,NLAB,LABEL)
      ENDIF
9999  END
