      SUBROUTINE GMFSTE(INDS,CXMI,CXMA,CYMI,CYMA,XMI,XMA,YMI,YMA)
C
C NASTAVENI SOUR. SYSTEMU :
C   INDS= 1,2,3,4,5,6        ARITMETICKE OSY (MALA MEZERA VLEVO)
C   INDS=11,12,13,14,15,16   ARITMETICKE OSY (FIXOVANY UZIV. ROZSAH)
C   INDS <0                  LOG-LOG OSY (VETSI MEZERA VLEVO).
C FIXOVANY UZIVATELSKY ROZSAH JE URCEN PRO VYKRESLOVANI VRSTEVNIC.
C POCITAJI SE ROZSAHY VNITRNIHO A VNEJSIHO OKNA, DELKY TEXTU DLE
C AKTUALNIHO FONTU.
C NASTAVENI ODPOVIDA PROCEDURE GMFAXE (TO JE JEDINY ROZDIL PROTI GMFST).
C
C Fortran PowerStation 16-Jul-02
C
C$IF DEFINED (compaq)
      USE DFLIB
C$ELSE
C      USE MSFLIB
C$ENDIF
C
      INCLUDE 'GMFB$'
      INCLUDE 'GMF$'
      INTEGER *2 DUMMY,NEWX,NEWY,LXMI,LXMA,LYMI,LYMA,LENTEX
      DOUBLE PRECISION WPIX
      TYPE (FONTINFO)F
      NEWX(XCOORD)=MAXX*XCOORD+.5
      NEWY(YCOORD)=MAXY*(1.-YCOORD)+.5
      IND=IABS(INDS)
      IF(IND.GT.6) IND=MAX0(1,IND-10)
C
C VNEJSI OKENKO VIEWPORT   [I]
C
      IBXMI(IND)=NEWX(CXMI)
      IBXMA(IND)=NEWX(CXMA)
      IBYMI(IND)=NEWY(CYMI)
      IBYMA(IND)=NEWY(CYMA)
C
C PROCEDURA GSCL DOSTANE INFORMACI O UZIVATELSKYCH SOURADNICICH XMIN,XMAX
C A VYGENERUJE
C RXMI,RXMA ZAOKROUHLENY INTERVAL
C NBX       POCET DELICICH INTERVALU,
C DBNX      MERITKO (RAD)
C DBX       VZDALENOST TIKU JE DBX*10**DBNX
C
      CALL GSCL(XMI,XMA,RXMI,RXMA,NBX(IND),DBNX(IND),DBX(IND))
      CALL GSCL(YMI,YMA,RYMI,RYMA,NBY(IND),DBNY(IND),DBY(IND))
C OD TOHOTO OKAMZIKU SE JIZ XMI,... NAHRAZUJE RXMI,...
C HODNOTY QXMI,... URCUJI VYKRESLOVANE SOURADNICOVE OSY
      QBXMI(IND)=RXMI
      QBXMA(IND)=RXMA
      QBYMI(IND)=RYMI
      QBYMA(IND)=RYMA
C
C VNITRNI OKENKO WINDOW    [F]
C
      IF(INDS.GT.6)THEN
C FIXED (VNITRNI OKENKO JE VETSI NEZ ZADAVANY ROZSAH XMI-XMA,YMI-YMA,
C ZVLASTE VPRAVO, PROTOZE SE TAM MA JESTE VEJIT SKALA VRSTEVNIC)
         DXIN=RXMA-RXMI
         DYIN=RYMA-RYMI
         FBXMI(IND)=RXMI-DXIN*.05
         FBXMA(IND)=RXMA+DXIN*.2
         FBYMI(IND)=RYMI-DYIN*.05
         FBYMA(IND)=RYMA+DYIN*.18
      ELSE
C VNITRNI OKENKO V ZAOKROUHLENYCH ROZSAZICH.
C OSY JSOU TOTOZNE S HRANICI VNITRNIHO OKNA [F]
         FBXMI(IND)=RXMI
         FBXMA(IND)=RXMA
         FBYMI(IND)=RYMI
         FBYMA(IND)=RYMA
      ENDIF
C
C VELIKOST POUZITEHO PISMA URCUJICI VZDALENOST VNITRNIHO A VNEJSIHO RAMECKU
C
C SET FONTS
C
      IF(IBFON(IND).LE.0.OR.IBHEI(IND).LE.0)THEN
         IDIFY=IABS(IBYMI(IND)-IBYMA(IND))
         IF(IDIFY.LE.350)THEN
             IBFON(IND)=5
             IBHEI(IND)=MAX0(8,IDIFY/20)
         ELSE
             IBFON(IND)=3
             IBHEI(IND)=MAX0(10,IDIFY/30)
         ENDIF
      ENDIF
      CALL GMFFONT(IBFON(IND),IBHEI(IND))
      DUMMY=GETFONTINFO(F)
      LYMI=(F.PIXHEIGHT+5)*2
      LYMA=F.PIXHEIGHT+5
C
      IF(INDS.LT.0)THEN
C LOG-LOG
         LENTEX=GETGTEXTEXTENT('1.E+02')
         LXMI=LENTEX+(IBXMA(IND)-IBXMI(IND))/40
         LXMA=LENTEX/2
      ELSE
C ARITMETICKE
         LENTEX=GETGTEXTEXTENT('1234')
         LXMI=LENTEX+(IBXMA(IND)-IBXMI(IND))/100
         LXMA=20
      ENDIF
C
C VNITRNI OKENKO VIEWPORT  [J]
C
      JBXMI(IND)=IBXMI(IND)+LXMI
      JBXMA(IND)=IBXMA(IND)-LXMA
      JBYMI(IND)=IBYMI(IND)-LYMI
      JBYMA(IND)=IBYMA(IND)+LYMA
C
C VNEJSI OKENKO WINDOW     [W]
C
      WPIX=(FBXMA(IND)-FBXMI(IND))/(JBXMA(IND)-JBXMI(IND))
      WBXMI(IND)=FBXMI(IND)-WPIX*LXMI
      WBXMA(IND)=FBXMA(IND)+WPIX*LXMA
      WBXT(IND)=WPIX*LENTEX
      WPIX=(FBYMA(IND)-FBYMI(IND))/(JBYMI(IND)-JBYMA(IND))
      WBYMI(IND)=FBYMI(IND)-WPIX*LYMI
      WBYMA(IND)=FBYMA(IND)+WPIX*LYMA
      WBYT(IND)=WPIX*F.PIXHEIGHT
      END
