      SUBROUTINE PTCTX(X,XPT,YPT,NPT,IPCR,NPCR,NCR,
     /                  ICRCT,NCRCT,NCT,Y,NY)
C
C Hledani pruseciku obrysu CT s vertikalou X=const. 
C
C Vstupni parametry:
C X            souradnice X
C XPT(),YPT()  souradnice bodu definujicich krivky
C NPT          pocet bodu
C IPCR(3,ic)   kazdy sloupec definuje jednu krivku 2 nebo 3 body
C NPCR(ic)     pocet bodu definujicich krivku
C NCR          pocet krivek
C ICRCT(50,ic) kazdy sloupec definuje jeden obrys (1.vnejsi, dalsi vnitrni)
C NCRCT(ic)    pocet krivek definujicich obrys
C NCT          pocet obrysu
C
C Vystupni parametr
C Y(ny)        souradnice vypoctenych pruseciku 
C NY           pocet pruseciku
C
      DIMENSION XPT(*),YPT(*),IPCR(3,*),NPCR(*),ICRCT(50,*),NCRCT(*)
      DIMENSION Y(*),XX(3),YY(3),TT(2)
      NY=0
      DO ICT=1,NCT
        DO IC=1,NCRCT(ICT)
          ICR=ICRCT(IC,ICT)
          IF(ICR.GT.0.AND.ICR.LE.NCR)THEN
C
C Hledame pruseciky krivky ICR s vertikalou X=const
C
            NP=NPCR(ICR)
            DO I=1,NP
              IP=IPCR(I,ICR)
              IF(IP.GT.0.AND.IP.LE.NPT)THEN
                XX(I)=XPT(IP)
                YY(I)=YPT(IP)
              ENDIF
            ENDDO
            SELECT CASE(NP)
            CASE(2)
C
C Prusecik s useckou
C
               IF(XX(1).NE.XX(2))THEN
                 T=(X-XX(1))/(XX(2)-XX(1))
                 IF(T.GE.0..AND.T.LE.1.)THEN
                   NY=NY+1
                   Y(NY)=YY(1)+(YY(2)-YY(1))*T
                 ENDIF
               ENDIF
            CASE(3)
C
C prusecik s parabolou
C
               A=(XX(2)-XX(1))/2.
               B=(XX(1)+XX(2))/2.-XX(3)
               DET=A**2-4*B*(XX(3)-X)
               IF(DET.GE.0.)THEN
                 S=SQRT(DET)
                 IF(B.NE.0.)THEN
                   TT(1)=(-A+S)/(2*B)
                   TT(2)=(-A-S)/(2*B)
                 ELSEIF(A.NE.0.)THEN
                   TT(1)=(X-XX(3))/A
                   TT(2)=100
                 ENDIF
                 DO I=1,2
                   IF(ABS(TT(I)).LE.1.)THEN
                     NY=NY+1
                     Y(NY)=YY(3)+(YY(2)-YY(1))/2.*TT(I)+
     /                  ((YY(1)+YY(2))/2.-YY(3))*TT(I)**2
                   ENDIF
                 ENDDO
               ENDIF
             END SELECT
          ENDIF
        ENDDO
      ENDDO
C
      END
