      SUBROUTINE TRANSL(ITX,ICTS,J,IDENT,IATTR,NOID,LENG,KFR,KMAX,
     / IMAX,ICON,IRPN,A,IA,K,LIM,NLIM)
C
C Preklad aritmetickeho nebo logickeho vyrazu
C dle stejnych konvenci jako TRANSE, ale text je vymezen omezovaci.
C Je to podobne jako procedura TRANSD, kde je ale pevne definovan jediny omezovac,
C mezera. Ta muze byt pouzita i u TRANSL. Omezovacem muze byt i carka, ale
C je treba osetrit pripad, kdy je carka vyznamova, tj. kdyz se vyskytuje jako
C oddelovac parametru funkce. Omezeni carkou se potlaci tehdy, kdyz ji predchazi
C alespon jedna nevybalancovana leva zavorka).
C
C Nove parametry:
C K >0 pozice posledniho znaku (pred omezovacem)
C LIM  textovy retezec seznam omezovacich znaku
C NLIM pocet omezovacu (delka retezce LIM)
C
      COMMON /SCOM/IER,IW(49)
      CHARACTER *(*) ITX,IDENT,LIM
      INTEGER A(*)
      DIMENSION IATTR(2,*),IA(*)
      CHARACTER *1 KZ,CLIM
      ICT=IABS(ICTS)
C
C Vynechani uvodnich mezer
C
      J1=J
      CALL TAKCH$(ITX,ICT,J1,KZ,K)
      IF(K.LE.0)RETURN
      K1=K
C NZAV-pocet nevybalancovanych levych zavorek
      NZAV=0
      LOOP: DO  K=K1,ICT
        KZ=ITX(K:K)
        IF(KZ.EQ.'(')THEN
           NZAV=NZAV+1
        ELSEIF(KZ.EQ.')')THEN
           NZAV=NZAV-1
C NEVYBALANCOVANA PRAVA ZAVORKA / KONEC
           IF(NZAV.LT.0)EXIT LOOP
        ENDIF
C TEST OMEZOVACU V SEZNAMU LIM
        DO I=1,NLIM
           CLIM=LIM(I:I)
           IF(KZ.EQ.CLIM)THEN
              IF(CLIM.NE.','.OR.NZAV.LE.0)EXIT LOOP
           ENDIF
        ENDDO
      END DO LOOP
      K=K-1
C
C K-POZICE posledniho platneho znaku
C
      IF(ICTS.LT.0)THEN
         KS=-K
      ELSE
         KS=K
      ENDIF
      CALL TRANSE(ITX,KS,J1,IDENT,IATTR,NOID,LENG,KFR,KMAX,IMAX,ICON,
     /            IRPN,A,IA)
      IF(IER.LT.0) K=-K
      END
