      SUBROUTINE WOPEN(UNIT,LABEL,NROW,NCOL,IX,IY,MAXXP,MAXYP)
C
C Otevri CHILD - window okenko na jednotce UNIT
C NROW,NCOL    - velikost okna (radky a sloupce)
C IX,IY        - umisteni okna (ix-offset X, iy-offset Y vzhledem k
C                levemu hornimu rohu FRAME)
C
C Vytvorenemu oknu je prirazen Focus (FOCUSQQ)
C a je aktivni pro grafiku (SETACTIVEQQ)
C
C$IF DEFINED (compaq)
      USE DFLIB
C$ELSE
C      USE MSFLIB
C$ENDIF
C
C GPWIN$ PARAMETRY CHILD-WINDOW (MUSI BYT OZ OTEVRENE)
C
      PARAMETER (MAXW=40)
      INTEGER *2 MAXWX,MAXWY,ROWS,COLS,ROWSHF,COLSHF
      COMMON /GPFWIN$/
     /   MAXWX(MAXW),MAXWY(MAXW),ROWS(MAXW),COLS(MAXW),
     /   ROWSHF(MAXW),COLSHF(MAXW)
      integer unit
      character *(*)label
      logical *4 result,STATUS
      type (qwinfo) winfo
      TYPE (WINDOWCONFIG)WC
      IF(UNIT.GT.MAXW)RETURN
      open(unit,file='user',title=label)
      winfo.h=nrow
      winfo.w=ncol
      winfo.x=ix
      winfo.y=iy
      winfo.type=qwin$set
      result=setwsizeqq(unit,winfo)
      result=setactiveqq(unit)
      status=focusqq(unit)
      STATUS=GETWINDOWCONFIG(WC)
      IF(MAXXP.LE.0)THEN
         MAXWX(UNIT)=WC.NUMXPIXELs
      ELSE
         MAXWX(UNIT)=MAXXP
         WC.NUMXPIXELS=MAXXP
      ENDIF
      IF(MAXYP.LE.0)THEN
         MAXWY(UNIT)=WC.NUMYPIXELs
      ELSE
         MAXWY(UNIT)=MAXYP
         WC.NUMYPIXELS=MAXYP
      ENDIF
      STATUS=SETWINDOWCONFIG(WC)
      IF(.NOT.STATUS)STATUS=SETWINDOWCONFIG(WC)
      ROWS(UNIT)=WC.NUMTEXTROWS
      COLS(UNIT)=WC.NUMTEXTCOLS
      ROWSHF(UNIT)=IX
      COLSHF(UNIT)=IY
      NUMFONTS=INITIALIZEFONTS()
      end
