C* Parallel series 5-CSTR, 2-CSTR $PCSTRP.BMP
C*
C* Chapter 2.2.10 page 82, user manual 
C*
C* Flowrates and Impulse response CN(t) 
C* calculated by weighted residual method.
C* --------------------------------------
C* Pipes D-0.05m
C* Upper branch 5-CSTR, volume 2m^3
C* Lower branch 2-CSTR, colume 1m^3
C* Turbulent flow, mean time 1888 s
C* --------------------------------------
C*
C* Tested by Zitny 5.9.2004
C*
PT 1,.000E+00,.500E+00; define points
PT 2,.100E+00,.500E+00;
PT 3,.100E+00,.200E+00;
PT 4,.200E+00,.200E+00;
PT 5,.800E+00,.200E+00;
PT 6,.900E+00,.200E+00;
PT 7,.900E+00,.500E+00;
PT 8,.100E+01,.500E+00;
PT 9,.900E+00,.700E+00;
PT 10,.800E+00,.700E+00;
PT 11,.200E+00,.700E+00;
PT 12,.100E+00,.700E+00;
CR2PT 1,1,2; define line segments 
CR2PT 2,2,3;
CR2PT 3,3,4;
CR2PT 4,5,6;
CR2PT 5,6,7;
CR2PT 6,7,8;
CR2PT 7,7,9;
CR2PT 8,2,12;
CR2PT 9,12,11;
CR2PT 10,10,9;
CR2PT 7,9,7;
CR2PT 11,4,5;
CR2PT 12,11,10;
EGROUP 1,PIPE2D,1,0,0; define PIPE type
RCONST 1,PIPE2D,.500E-01,.100E-03,0,1,0,0,0,0,0,0;
MCR 1,2,1,2,0,10,1; mesh PIPEs
EGROUP 2,CSTR,1,0,0; define CSTR for branch 1
RCONST 2,CSTR,0.05,1,0,0,1,0,0,0;
MCR 11,2,1,2,0,0,1; mesh CSTR in branch 1
RCONST 3,CSTR,0.05,1,0,0,2,0,0,0; define parameters CSTR in branch 2
MCR 12,5,1,2,0,0,1; mesh CSTR in branch 2
NMERGE ; merge identical nodes
NFPT 1,PRES,-1,5000; pressure 5000 Pa at inlet
NFPT 8,PRES,-1,0; zero pressure at outlet
CURDEF -2,0,5,0,0,1,1,10,1,11,0,100,0;
NFPT 1,CN,-2,1; impulse concentration (function -2) at inlet
INITIA CN,0; zero initial concentration
RELFAKT=0.5
SOLVE 0,1,1,0,0,70,0,0,0; one step calculates flowrates
INITIA CN,0; 
RELFAKT=1
SOLVE 0,600,10,1,0,0,0,1,0; tracer dispersion at 600 time steps
NORM 2,2,0;
