C* $ZTOMEL0.BMP
C* Macro file Electrotomography is
C* based upon evaluation of electric field
C* when 7 electrodes attached to the wall 
C* of a rectangular tank are switched.
C*
C* Optimised function is distribution of
C* electrical conductivity kappa=a+bx+cy+dxy,
C* with parameters a,b,c,d identified by
C* comparison of electric power. This power
C* is located in the 2nd column of MOP and
C* rows correspond to different combination
C* of electrodes (Voltage 0 or 1). FEM solution
C* is performed by batch ZTOMELS1.GEO.
C*
C* 21-ROWS are used for dif.combinations of
C*    electroded on curves 5,6,7,8,9,10,11
C*
C* Tested by Zitny 20.9.2004
C*
PT 1,.000E+00,.000E+00;
PT 2,.100E+01,.000E+00;
PT 3,.100E+01,.100E+01;
PT 4,.000E+00,.100E+01;
SF4PT 1,1,2,3,4;
EGROUP 1,PLANE2D,0,1,0,0,0;
MSF 1,30,30,1,1,3;
PT 5,.100E+00,.000E+00;
PT 6,.200E+00,.000E+00;
PT 7,.400E+00,.000E+00;
PT 8,.600E+00,.000E+00;
PT 9,.800E+00,.000E+00;
PT 10,.900E+00,.000E+00;
PT 11,.000E+00,.200E+00;
PT 12,.000E+00,.300E+00;
PT 13,.000E+00,.600E+00;
PT 14,.000E+00,.700E+00;
PT 15,.100E+01,.200E+00;
PT 16,.100E+01,.300E+00;
PT 17,.100E+01,.600E+00;
PT 18,.100E+01,.700E+00;
CR2PT 5,5,6;
CR2PT 6,7,8;
CR2PT 7,9,10;
CR2PT 8,11,12;
CR2PT 9,13,14;
CR2PT 10,15,16;
CR2PT 11,17,18;
FUNDEF 1,A+B*XX+C*YY+D*XX*YY;
A=1
B=.5
C=.3
D=-.5
MPROP 1,PLANE2D,.600E+00,0,4200,0,998,0,.400E-01,1,.210E+12,0,.280E+00,0,.120E-04,0;
TSTEP 21,1
F ZTOMELS1.GEO
TCF C3=C2
PARDEF 4,a,b,c,d;
PARFIT .7,2,1,.7,2,1,.5,2,1,-0.3,2,1;
PARLIM 0,2,0,1,0,1,-2,2;
COMPAR 1,1,9,2,3,0;
OPEN 7,ZTOMELS1.GEO
OPTIMA 7,3
INITIA CN,1;
GD2 CN,3;
