C* $ZTOMTB0.BMP
C* Transmission tomography MACRO
C* The same problem as in ZTOMTRA0.GEO
C* this time using only 12 rays, but
C* a more complicated model (6-params).
C* Calculation of integrals along
C* gamma rays is done in ZTOMTRB1.GEO.
C*
C* Tested by Zitny 20.9.2004
C*
ANALYS 2;
PT 1,.5,.5;
PT 2,.7,.5;
CIRCLE 1,1,2,4;
R=0.25
F=0
DISP NP
DISP NPT
I=10
PT I,R*COS(F),R*SIN(F);
F=F+45/180*3.141
I=I+1
PT I,R*COS(F),R*SIN(F),0;
F=F+45/180*3.141
I=I+1
PT I,R*COS(F),R*SIN(F),0;
F=F+45/180*3.141
I=I+1
I=10
F=0
PT I,0.5+R*COS(F),0.5+R*SIN(F),0;
F=F+45/180*3.141
I=I+1
PT I,0.5+R*COS(F),0.5+R*SIN(F),0;
F=F+45/180*3.141
I=I+1
PT I,0.5+R*COS(F),0.5+R*SIN(F),0;
F=F+45/180*3.141
I=I+1
PT I,0.5+R*COS(F),0.5+R*SIN(F),0;
F=F+45/180*3.141
I=I+1
PT I,0.5+R*COS(F),0.5+R*SIN(F),0;
F=F+45/180*3.141
I=I+1
PT I,0.5+R*COS(F),0.5+R*SIN(F),0;
F=F+45/180*3.141
I=I+1
PT I,0.5+R*COS(F),0.5+R*SIN(F),0;
F=F+45/180*3.141
I=I+1
PT I,0.5+R*COS(F),0.5+R*SIN(F),0;
F=F+45/180*3.141
I=I+1
CR2PT 5,12,15;
CR2PT 6,12,16;
CR2PT 7,12,17;
CR2PT 8,11,14;
CR2PT 9,11,15;
CR2PT 10,11,16;
CR2PT 11,13,16;
CR2PT 12,13,17;
CR2PT 13,13,10;
SCALE .248E+00,.755E+00,.248E+00,.755E+00;
PTCR2 5,2;
PTCR2 5,3;
PTCR2 6,1;
PTCR2 6,4;
PTCR2 6,3;
PTCR2 7,1;
PTCR2 7,4;
PTCR2 12,2;
PTCR2 12,4;
PTCR2 11,2;
PTCR2 11,3;
PTCR2 13,2;
PTCR2 13,1;
PTCR2 8,1;
PTCR2 8,2;
PTCR2 9,1;
PTCR2 9,3;
PTCR2 10,1;
PTCR2 10,4;
CRDEL 5,13;
CR2PT 5,18,19;
CR2PT 6,4,8;
CR2PT 7,22,23;
CR2PT 8,30,31;
CR2PT 9,32,33;
CR2PT 10,34,35;
CR2PT 11,26,27;
CR2PT 12,5,9;
CR2PT 13,28,29;
FUNDEF 1,A+B*XX+C*YY+D*XX**2+E*YY**2+f*xx*yy+G*sin(9*xx);
FUNDEF 2,1;
TSTEP 9,1;
A=1
B=.5
C=.5
D=-.1
E=.1
F=.5
F=.8
F ./FILES/ZTOMTRB1.GEO
TCFUN C3=C2;
PARDEF 6,A,B,C,D,E,F;
PARFIT .2,1,1,.45,1,1,.6,1,1,0.,1,1,0.,1,1,0.5,1,1;
PARLIM 0,2,0,1,0,1,-1,1,-1,1,-1,1,-1,1;
MOP ./FILES/ZTOMTRB1.GEO;
COMPAR 1,1,9,2,3,0;
OPTIMA 7,5
DISP A,B,C
SFCR 1,1,2;
MSF 1,30,30,1,1,4;
EGROUP 1,PLANE2D,0,0,0,0,0;
INITIA TEMP,1;
GD2 TEMP,3;