C* $RCMPIP2.BMP
C* Batch for optimisation pipeline+pump
C* Parameters F-flowrate (kg/s), R-pump flowrate
C* F-defined as boundary condition at inlet, 
C* R-defined as function (2) pump characteristic
C*
C* model is separated into 2 files: 
C*    RCMPIPE1.GEO - geometry, mesh and boundary conditions
C*    RCMPIPE2.GEO - steady solution of low, and transient solution
C* Result: CN recorded into second column of MOP
C*
C* This is only the second part (optimised)
C*
NFPT 1,PRES,1,F; prescribe flowrate at inlet
RELFAKT=.7
SOLVE 0,1,1,0,0,80,0,0,0,0,0; solve flow
INITIA CN,0; initial zero concentration of tracer CN
SOLVE 0,200,T,1,0,0,0,1,0,0,0; 200 time steps for tracer distribution
CTN CN,1,13,2;
NORM 2,2,0;
