C* FQUAD.GEO !! attention this is a MACRO file !!
C*
C* Planar channel uniform velocity at inlet 
C* Upper side of channel is wall, 
C* Lower side is symmetry axis.
C* UVP method, transient
C* ----------------------------------------------
C* Use macro (M FQUAD.GEO) to process this file.
C* I* command enables to check the method for
C* different elements and different meshes.
C* Tested T2T1,T1T0, Q1Q0  acceptable
C*    Q2(8)Q1 does not work well,
C*    Q2(9)Q1 is better, but T2T1 is the best.
C* ----------------------------------------------
C* Re = 0.2 * 1000/4 =50,  L/D=0.05*Re=2.5, L=0.5
C* ----------------------------------------------
C*
C* Macro tested by Zitny 5.9.2004
C*
ANALYS 2;
EGROUP 1,FLOW2D,1,3,0,UVP,0;
MPROP 1,FLOW2D,.600E+00,0,4200,0,998,0,.400E-01,0,4,0,.500E-03,0,.100E-08,0,0,0,0,0;
FUNDEF -2,1.5*(1-100*YY**2);
PT 1,.000E+00,.000E+00;
PT 2,.100E+01,.000E+00;
PT 3,.100E+01,.100E+00;
PT 4,.000E+00,.100E+00;
SF4PT 1,1,2,3,4;
I* MSF 1,20,10,1,1,5,1;
NFCR 4,VX,-1,1,1;
NFCR 1,VY,-1,0,0;
NFCR 3,VY,-1,0,0;
NFCR 3,VX,-1,0,0;
NFCR 2,PRES,-1,0,0;
C* 5 time steps
SOLVE 0,5,100,0,0,5,0,0,0;
R* repeat solve command
I* new
