C* Straight pipe constant wall temperature
C* Laminar regime, variable thermal layer 
C* thickness.
C* --------------------------------------
C* Length=1m, R=0.01m, u=0.1 m/s
C* Te=100 C, alpha=1e7 (almost Tw=100)
C* Tinlet=0 C, Toutlet=15 C (Leveque)
C* --------------------------------------
C*
C* Tested by Zitny 14.9.2004
C*
H=1
R=0.01
U=0.1
W=3*H/U
L=120
PT 1,0,0;
PT 2,H,0;
CR2PT 1,1,2;
UPW=1
RUPW=1
INIFEM
EGROUP 1,PIPE2D,0,0,0;
RCONST 1,PIPE2D,0.02;
MCR 1,200,1,2,1,0,1;
NFPT 2,PRES,-1,0;
FUNDEF -2,A;
NFPT 1,PRES,-2,1;
A=8
TE(1)=100
ALPHA(1)=1E7
NFPT 1,TEMP,-3,0;
TAUD=1E-7
SOLVE 0,1,.750E-01,0,0,4,1,0,0;
I* GC TEMP