C* Series of CSTR (without pipes)
C* Impulse response calculated and
C* compared with exact impulse response
C* This example demonstrates that the
C* weighted residual methods does not
C* work properly when using CSTR elements
C* and the only way is to select method
C* of nodal balancing of transported
C* quantity (in this case CN). It is
C* interesting that the MWR can be used
C* in a similar case (see PISERIE.GEO)
C* if a PIPE element is conected behind
C* the last CSTR elements.
C* ---------------------------------
C* series of 5 CSTR, volume 1m^3
C* flowrate 0.005 m^3/s, mean residence
C* time 1000 s.
C* ---------------------------------
C*
C* Tested by Zitny 12.9.2004
C*
C* Enthalpy balancing method (HEPI=1),
C* Volumetric balancing (VOLFLOW=1)
C*
C* Remark: When using balancing method
C*    the outlet nodes must have status
C*    of balanced quantity (CN) greater 
C*    than 20 (e.g.21) and zero value of 
C*    nodal parameter CN=0 !!
C* 
HEPI=1
VOLFLOW=1
PT 1,0,0;
PT 2,1,0;
CR2PT 1,1,2;
EGROUP 1,CSTR,1,0,0;
RCONST 1,CSTR,0.05,0,0,0,1,0,0,0;
MCR 1,5,1,2,1,1,1;
NFPT 1,PRES,1,0.005;
NFPT 2,PRES,-1,0;
SOLVE 0,2,1,0,0,30,0,0,0;
CURDEF -2,0,5,0,0,10,1,50,1,60,0,100,0;
NFPT 1,CN,-2,1;
NFPT 2,CN,21,0;
SOLVE 0,500,5,1,0,0,0,1,0;
SERIE 3,5,1000
C* Use GT to plot impulse response
C*
