C* Heat transfer in a plain pipe
C* Constant wall temperature. 
C* L=1m, d=0.02m, water, T0=0, Te=Tw=100 C.
C* This is batch used for testing solution accuracy
C* with gradually increasing mass flowrate (repeated
C* solution in a loop inserting mass flowrate into
C* first column of MOP, following columns are
C* second column HEPI=0 (MWR),          TAUD=0
C* third  column HEPI=1 (enth.balance), TAUD=0
C* fourth column HEPI=0 (MWR),          TAUD=1e4
C* fifth  column HEPI=1 (enth.balance), TAUD=1e4
C*
PT 1,.000E+00,.000E+00;
PT 2,.100E+01,.000E+00;
CR2PT 1,1,2;
RCONST 1,PIPE2D,.200E-01,0,0,.100E-02,1E8,100,0,0,0,0,0,0,0,0,0,0,0;
EGROUP 1,PIPE2D,0,0,0,0,0,0,0,0,0,0,0;
MPROP 1,PIPE2D,.600E+00,0,4200,0,998,0,.400E-01,0,.210E+12,0,.280E+00,0,.100E-02,0,.500E-03,0,.100E-08,0,.100E-08,0,.100E-08,0,0,0,0,0,0,0,.120E-04,0;
C* specify number of elements to be meshed
VALUE N
MCR 1,N,1,2,0,0,1;
NMERGE ;
NF ND,PRES,-1,0;
NF 1,TEMP,-1,0;
C* A-mass flowrate
A=0.0005
J=0
NT=15
#LOOP L,NT
J=J+1
C1(J)=A
NF 1,PRES,1,A
NF ND,TEMP,0,0
TAUD=0
HEPI=0
NF ND,TEMP,0,0
SOLVE 0,1,1,0,0,10,1,0,0,0,0;
C2(J)=V2(LPU(TEMP)+ND)
HEPI=1
NF ND,TEMP,21,0
SOLVE 0,1,1,0,0,10,1,0,0,0,0;
C3(J)=V2(LPU(TEMP)+ND)
TAUD=1E6
HEPI=0
NF ND,TEMP,0,0
SOLVE 0,1,1,0,0,10,1,0,0,0,0;
C4(J)=V2(LPU(TEMP)+ND)
HEPI=1
NF ND,TEMP,21,0
SOLVE 0,1,1,0,0,10,1,0,0,0,0;
C5(J)=V2(LPU(TEMP)+ND)
A=A*1.5
#LABEL L
