C* deJong milk fouling in a closed loop.
C* Loop of pipes with prescribed flowrate.
C* Concentrations of CN-netive proteins,
C* CD-denaturated proteins and CA-agglomerates
C* are calculated as a function of time.
C* Weighted residual method is used.
C* --------------------------------------
C* Constant temperature T=70 C, Q=1 l/s
C* CN=4 kg/m^3 initially.
C* --------------------------------------
C*
C* Tested by Zitny 14.9.2004
C*
PT 1,.000E+00,.000E+00;
PT 2,.100E+01,.000E+00;
CR2PT 1,1,2;
PT 3,.100E+01,.500E+00;
CR2PT 2,2,3;
PT 4,.000E+00,.500E+00;
CR2PT 3,3,4;
PT 5,.000E+00,.000E+00;
CR2PT 4,4,5;
PMERGE ;
EGROUP 1,PIPE2D,1,0,0,0,0,0,1,2,3,4,0;
FUNDEF 1,0.00601;
FUNDEF 2,0.00601*CN;
FUNDEF 3,0.000041502*CD;
FUNDEF 4,0.000041502*CD**2;
MCR 1,3,1,2,0,0,1;
MCR 2,2,1,2,0,0,1;
MCR 3,3,1,2,0,0,1;
MCR 4,2,1,2,0,0,1;
NMERGE ;
FOR I=1,10 DO E6(I)=0.001
RCONST 1,PIPE2D,.500E-01,.100E-03,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0;
FUNDEF 5,4;
INITIA CN,5;
INITIA CD,0;
INITIA CA,0;
OHMI=1
SOLVE 0,50,10,1,0,0,0,1,3,1,0;
INITIA CN,5;
SOLVE 0,500,.5,1,0,0,0,1,3,1,0;
