C* Pump with specified characteristics
C* (linear relationship flowrate-pressure)
C*
C* Be careful about convergency-for
C* example in this case it was necessary
C* to set RELFAKT=0.2.
C* -----------------------------------
C* Fixed pressures 1000 and 2000 Pa at
C* the end of pipeline (it means that
C* the pump should deliver at least
C* dp>1000 Pa). The characteristic is
C* defined in such a way, that the
C* maximum flowrate is .2e-6 m^3/s.
C* -----------------------------------
C*
C* Tested by Zitny 15.9.2004
C*
FUNDEF 1,.2E-5*(1-MIN(.9,ABS(DP)/2000));
PT 1,0,0.5;
PT 2,.4,.5;
PT 3,.6,.5;
PT 4,1,.5;
CR2PT 1,1,2;
CR2PT 2,3,4;
CR2PT 3,2,3;
CR2PT 4,1,4;
RCONST 1,PIPE2D,0.005,0,0,1,0,0,0,0,0,0;
MCR 1,3,1,2,0;
MCR 2,3,1,2,0;
EGROUP 2,PUMP,0,0,1,0;
MCR 3,1,1,2,0;
NMERGE ;
NFPT 1,PRES,-1,1000;
NFPT 4,PRES,-1,2000;
VISC(1)=1
RELFAKT=0.2
SOLVE 0,1,1,0,0,30,0,0,0;
