C* TRUSS - internal heat source (transient)
C* example for NAZ
C* ----------------------------------------
C* L=1 m, material water
C* Fixed end temperatures 20 and 10 C
C* Internal volumetric heat source Q=100*y
C* ----------------------------------------
C*
C* Tested by Zitny 5.9.2004
C*
PT 1,.000E+00,.000E+00;
PT 2,.000E+00,.100E+01;
CR2PT 1,1,2;
EGROUP 1,TRUSS2D,0,1;
RCONST 1,TRUSS2D,0,0,1,0;
MPROP 1,TRUSS2D,.600E+00,0,4200,0,998,0,.400E-01,0,.210E+12,0,.120E-04,0;
FUNDEF 1,100*YY;
MCR 1,10,1,2,0,0,1;
NFPT 1,TEMP,-1,20;
NFPT 2,TEMP,-1,10;
OPTION 0,0,0,1,1,0,0,15,.1E-11,1,.1E+08,1,.1E+01,1,0,0,.1E-04,.1E-04,0,0,0,0,0,0,0,
SOLVE 0,1,1,0,0,0,1,0,0,0,0;
