C* deJong model - fouling in a pipe
C* continuous delivery of a fresh milk
C* having concentration CN=4kg/m^2.
C*
C* Tested by Zitny 14.9.2004
C*
PT 1,.000E+00,.500E+00;
PT 2,.100E+01,.500E+00;
CR2PT 1,1,2;
REAL KN,EN,KD,ED
R=8.314
KN=86.4106
EN=216000
KD=99.3186
ED=312000
EGROUP 1,PIPE2D,1,1,0,0,0,0,2,3,4,5,0,
RCONST 1,PIPE2D,.008,.1E-03,.0,.1E+01,.0,.0,.0,.0,.0,.0,.0,.0,.0,.0,.0,.0,.0,
FUNDEF 2,EXP(KN-EN/(R*(TEMP+273)));
FUNDEF 3,EXP(KN-EN/(R*(TEMP+273)))*CN;
FUNDEF 4,CD*EXP(KD-ED/(R*(TEMP+273)));
FUNDEF 5,CD**2*EXP(KD-ED/(R*(TEMP+273)));
FUNDEF 6,A*CA;
FUNDEF 7,4;
MCR 1,10,1,2,0,0,1;
NF 1,PRES,1,.100E-02;
NF 11,PRES,-1,0;
INITIA CN,7;
INITIA CD,0;
INITIA CA,0;
NF 1,CA,-1,0;
NF 1,CD,-1,0;
NF 1,CN,-1,4;
NF 1,TEMP,-1,20;
A=0.0001
OHMI=1
RT=6
SOLVE 0,100,2,0,0,5,1,1,3,1,0;
