C* Macro
C* RTD models identification using OPTIMA
C* Several predefined models are tested,
C* each testing consists in the following steps:
C*
C* Example where optimisation fails
C* 1. RM read model
C* 2. impulse response for a given parameters
C* 3. copy responses and randomisation
C* 4. compar-which responses are to be compared
C* 5. parfit-regression method applied fo individial parameters
C* 6. optima-parameter identification
C*
C* Tested models
C* A0a   - parallel series
C* 
C* Tested by Zitny 23.9.2005
C*
TSTEP 100,.05;

C* 4
TCFUN C2=0
TCFUN C3=0
TCFUN C4=0
TCFUN C5=0
TCFUN C6=0
TCFUN C7=0
TCFUN C8=0
RMODEL A0A;
PARSET .5,.2,2,3,3,1;
IMPULS -2,5,100,.500E-01;
TCFUN C4=C3;
TCRND 4,4,1,.05;
COMPAR 1,1,100,3,4,0;
PARFIT .2,2,1,.45,2,1,2.5,2,1,8,3,1,2,3,1,1,1,1;
IMPULS -2,5,100,.500E-01;
TCFUN C5=C3;
OPTIMA 0,20;
GTC;
modlis
I* TID parallel series model. C5=initial, C3=final
PARFIT 0.200E+00,2,1,0.450E+00,2,1,0.250E+01,2,1,1,8,1,2,3,1,0.106E+01,1,1;
PARLIM 0.100E-01,0.990E+00,0.100E-02,10,0.100E-01,50,1,10,1,10,0.100E-01,100;
IMPULS -2,5,100,.500E-01;
TCFUN C5=C3;
OPTIMA 0,20;
GTC;
I* TID parallel series model. C5=initial, C3=final
PARFIT 0.2,2,1,0.45,2,1,0.250E+01,2,1,1,8,1,2,3,1,0.106E+01,1,1;
PARLIM 0.1,0.4,0.1,1,0.5,5,1,10,1,10,0.5,2;
IMPULS -2,5,100,.500E-01;
TCFUN C5=C3;
SOMA 0,20;
GTC;
I* SOMA


