C* TMELT.GEO melting a frozen box
C* Lemmon's method for phase change modelling.
C* -------------------------------------------
C* Left side at -5 deg, right side at 20 degs. 
C* Melting point T=0 deg.
C* Upper and bottom side are insulated.
C* -------------------------------------------
C* Remark: This file can be processed as a batch
C*         or as a macro.
C*
C* Tested by Zitny 18.9.2004
C*
ANALYS 2;
PT 1,.000E+00,.000E+00;
PT 2,.100E+01,.000E+00;
PT 3,.100E+01,.100E+01;
PT 4,.000E+00,.100E+01;
SF4PT 1,1,2,3,4;
EGROUP 1,PLANE2D,1,3,0,0,0;
RCONST 1,PLANE2D,1,0,0,0;
MPROP 1,PLANE2D,.600E+00,1,4200,2,1000,3,.400E-01,0,.210E+12,0,.280E+00,0,.120E-04,0,0,0,340000,0;
CURDEF 1,4,4,-10,2.2/0.6,0,2.2/0.6,0.001,1,10,1;
CURDEF 2,4,4,-10,2/4.2,0,2/4.2,.100E-02,1,10,1;
CURDEF 3,4,4,-10,917/1000,0,917/1000,.100E-02,1,10,1;
MSF 1,20,5,1,1,3;
NFCR 4,TEMP,-1,-5,-5;
NFCR 2,TEMP,-1,20,20;
FUNDEF 4,-5;
INITIA TEMP,4;
C* OPTION specifies calculation with phase changes
OPTION 0,0,0,0,1,0,0,15,.1E-11,1,.1E+08,1,.1E+01,1,0,2,.1E-04,.1E-04,0,0,0,0,0,0,0,
SOLVE 0,50,1000,0,0,0,3,0,0,0,0;
GT temp 